#ifndef _mach_avm_h_
#define _mach_avm_h_

#include <avm/enh/reboot_status.h>

/*------------------------------------------------------------------------------------------*\
 * 240-254 char	LOCAL/EXPERIMENTAL USE
 * 240-254 block	LOCAL/EXPERIMENTAL USE
 *         Allocated for local/experimental use.  For devices not
 *         assigned official numbers, these ranges should be
 *         used in order to avoid conflicting with future assignments.
\*------------------------------------------------------------------------------------------*/
#define AVM_DECT_IO_MAJOR	    227
#define AVM_USERMAN_MAJOR	    228
#define KDSLD_USERMAN_MAJOR	    229
#define AVM_TIATM_MAJOR         230
#define TFFS_MAJOR              262
#define AVM_EVENT_MAJOR         261
#define AVM_DEBUG_MAJOR         263
#define WATCHDOG_MAJOR          260
#define KDSLD_MAJOR             243
#define KDSLDPTRACE_MAJOR       244
#define UBIK_MAJOR              245
#define DEBUG_TRACE_MAJOR       246
#define AVM_LED_MAJOR           264
#define AVM_I2C_MAJOR           248
#define YAFFS                   249
#define AVM_AUDIO_MAJOR         250
#define AVM_NEW_LED_MAJOR       251
#define AVM_POWER_MAJOR         252
#define AVM_VINAX_MAJOR		    253
#define AVM_HSK_MAJOR		    254
#define AVM_NET_TRACE_MAJOR     255
#define AVM_ATH_EEPROM              239

/*------------------------------------------------------------------------------------------*\
 * zusaetzlich folgende:
 *
 * 207 char	Compaq ProLiant health feature indicate
 * 220 char	Myricom Myrinet "GM" board
 * 224 char	A2232 serial card
 * 225 char	A2232 serial card (alternate devices)
 * 227 char	IBM 3270 terminal Unix tty access
 * 228 char	IBM 3270 terminal block-mode access
 * 229 char	IBM iSeries virtual console
 * 230 char	IBM iSeries virtual tape
 *
\*------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
#define MAX_ENV_ENTRY               256

#ifdef CONFIG_ARM

#if defined(CONFIG_MACH_BCM963138)

#include <linux/init.h>
#include <plat/bcm63xx_timer.h>
#include <asm/arch_timer.h>
#include <asm/io.h>

/* Der Timer hat nur 30Bit Aufloesung. Die obersten beiden Bits sind immer 0.
 * Da der Profiler im Sammeltreiber nicht damit klar kommt werden die Werte des
 * Timers um 2 Bit nach oben geshiftet. */
#define avm_get_cycles()             (bcm63xx_read_timer_count2() << 2)
#define avm_get_cyclefreq()          (50000000 << 2)

#elif defined(CONFIG_BCM963178)

#include <linux/init.h>
#include <asm/io.h>

unsigned int avm_get_cycles(void);
unsigned int avm_get_cyclefreq(void);
#endif
#define avm_cycles_cpuclock_depend() (0)

#include <mach/avm_gpio.h>

#define avm_gpio_init               brcm_gpio_init
#define avm_gpio_ctrl               brcm_gpio_ctrl
#define avm_gpio_request_irq        brcm_button_request_callback
#define avm_gpio_disable_irq        brcm_button_disable_callback
#define avm_gpio_out_bit            brcm_gpio_out_bit
#define avm_gpio_out_bit_no_sched   brcm_gpio_out_bit_no_sched
#define avm_gpio_in_bit             brcm_gpio_in_bit
#define avm_gpio_set_bitmask        brcm_gpio_set_bitmask

void dma_cache_inv(unsigned long start_virt_addr, size_t len);
void dma_cache_wback_inv(unsigned long page_address, ssize_t size);

void avm_dma_pool_init(unsigned char *base, unsigned int size);
void *avm_dma_pool_alloc(unsigned int size, dma_addr_t *physaddr);
void avm_dma_pool_free(void *vaddr);

char *avm_urlader_env_get_variable(int idx);
char *avm_urlader_env_get_value_by_id(unsigned int id);
char *avm_urlader_env_get_value(char *var);
int avm_urlader_env_set_variable(char *var, char *val);
int avm_urlader_env_unset_variable(char *var);
int avm_urlader_env_defrag(void);

#endif /*--- #ifdef CONFIG_ARM ---*/

//Only used as fallback, if location is not stored in device-tree under reserved-memory with name 'avm_reboot_string'
#define AVM_REBOOT_STRING_LOCATION  (0xa0001000)
#define AVM_REBOOT_STRING_SIZE      512

#endif /*--- #ifndef _mach_avm_h_ ---*/
