/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _DRV_EPON_NCO_ADDR_AG_H_
#define _DRV_EPON_NCO_ADDR_AG_H_

#include "access_macros.h"
#if !defined(_CFE_)
#include "bdmf_interface.h"
#else
#include "bdmf_data_types.h"
#include "bdmf_errno.h"
#endif
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif
typedef struct
{
    bdmf_boolean cfgbypass;
    uint8_t cfgsrcout10mhz;
    uint8_t cfgsrcout;
    uint8_t cfgsrcin;
    bdmf_boolean cfgncoclr;
} nco_addr_nco_cfg;

bdmf_error_t ag_drv_nco_addr_nco_cfg_set(const nco_addr_nco_cfg *nco_cfg);
bdmf_error_t ag_drv_nco_addr_nco_cfg_get(nco_addr_nco_cfg *nco_cfg);
bdmf_error_t ag_drv_nco_addr_nco_int_set(bdmf_boolean intnoncosync, bdmf_boolean intnoxifpps, bdmf_boolean intnolifpps);
bdmf_error_t ag_drv_nco_addr_nco_int_get(bdmf_boolean *intnoncosync, bdmf_boolean *intnoxifpps, bdmf_boolean *intnolifpps);
bdmf_error_t ag_drv_nco_addr_nco_msk_set(bdmf_boolean intnoncosyncmask, bdmf_boolean intnoxifppsmask, bdmf_boolean intnolifppsmask);
bdmf_error_t ag_drv_nco_addr_nco_msk_get(bdmf_boolean *intnoncosyncmask, bdmf_boolean *intnoxifppsmask, bdmf_boolean *intnolifppsmask);
bdmf_error_t ag_drv_nco_addr_nco_1pps_period_set(uint32_t cfg1ppsperiod);
bdmf_error_t ag_drv_nco_addr_nco_1pps_period_get(uint32_t *cfg1ppsperiod);
bdmf_error_t ag_drv_nco_addr_nco_8khz_period_set(uint32_t cfg8khzperiod);
bdmf_error_t ag_drv_nco_addr_nco_8khz_period_get(uint32_t *cfg8khzperiod);
bdmf_error_t ag_drv_nco_addr_nco_center_frequency_set(uint32_t cfgncodefault);
bdmf_error_t ag_drv_nco_addr_nco_center_frequency_get(uint32_t *cfgncodefault);
bdmf_error_t ag_drv_nco_addr_nco_int_gain_set(uint16_t cfgncogain);
bdmf_error_t ag_drv_nco_addr_nco_int_gain_get(uint16_t *cfgncogain);
bdmf_error_t ag_drv_nco_addr_nco_pro_gain_set(uint16_t cfgncopropgain);
bdmf_error_t ag_drv_nco_addr_nco_pro_gain_get(uint16_t *cfgncopropgain);
bdmf_error_t ag_drv_nco_addr_nco_cnt_get(uint32_t *ncocnt);
bdmf_error_t ag_drv_nco_addr_nco_1pps_half_set(uint32_t cfg1ppshalfperiod);
bdmf_error_t ag_drv_nco_addr_nco_1pps_half_get(uint32_t *cfg1ppshalfperiod);
bdmf_error_t ag_drv_nco_addr_nco_8khz_half_set(uint32_t cfg8khzhalfperiod);
bdmf_error_t ag_drv_nco_addr_nco_8khz_half_get(uint32_t *cfg8khzhalfperiod);
bdmf_error_t ag_drv_nco_addr_nco_period_cnt_get(uint32_t *periodcnt);
bdmf_error_t ag_drv_nco_addr_nco_phs_err_cnt_get(uint16_t *ncophserr);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_nco_addr_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

