/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _BCM6858_TEN_G_GEARBOX_AG_H_
#define _BCM6858_TEN_G_GEARBOX_AG_H_

#include "access_macros.h"
#include "bdmf_interface.h"
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif

/**************************************************************************************************/
/* cfg_sgb_pon_10g_epon_tx_fifo_off:  - TX FIFO offset value.                                     */
/* cfg_sgb_pon_10g_epon_tx_fifo_off_ld:  - 0: Normal operation. 1: Load new TX FIFO offset.       */
/* cfg_sgb_pon_10g_epon_tx2rx_loop_en:  - 0: Normal operation. 1: Enable TX to RX loopback.       */
/* cfg_sgb_pon_10g_epon_rx_data_end:  - 0: Normal operation. 1: Enable endian flip.               */
/* cfg_sgb_pon_10g_epon_clk_en:  - 0: Disable clock. 1: Enable clock.                             */
/* cfg_sgb_pon_10g_epon_tx_gbox_rstn:  - 0: Reset TX gearbox logic. 1: Enable TX gearbox logic.   */
/* cfg_sgb_pon_10g_epon_rx_gbox_rstn:  - 0: Reset RX gearbox logic. 1: Enable RX gearbox logic.   */
/* cfg_sgb_pon_10g_epon_tx_cgen_rstn:  - 0: Reset TX clock generator. 1: Enable TX clock generato */
/*                                    r.                                                          */
/* cfg_sgb_pon_10g_epon_rx_cgen_rstn:  - 0: Reset RX clock generator. 1: Enable RX clock generato */
/*                                    r.                                                          */
/**************************************************************************************************/
typedef struct
{
    uint8_t cfg_sgb_pon_10g_epon_tx_fifo_off;
    bdmf_boolean cfg_sgb_pon_10g_epon_tx_fifo_off_ld;
    bdmf_boolean cfg_sgb_pon_10g_epon_tx2rx_loop_en;
    bdmf_boolean cfg_sgb_pon_10g_epon_rx_data_end;
    bdmf_boolean cfg_sgb_pon_10g_epon_clk_en;
    bdmf_boolean cfg_sgb_pon_10g_epon_tx_gbox_rstn;
    bdmf_boolean cfg_sgb_pon_10g_epon_rx_gbox_rstn;
    bdmf_boolean cfg_sgb_pon_10g_epon_tx_cgen_rstn;
    bdmf_boolean cfg_sgb_pon_10g_epon_rx_cgen_rstn;
} ten_g_gearbox_gearbox;

bdmf_error_t ag_drv_ten_g_gearbox_gearbox_set(const ten_g_gearbox_gearbox *gearbox);
bdmf_error_t ag_drv_ten_g_gearbox_gearbox_get(ten_g_gearbox_gearbox *gearbox);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_ten_g_gearbox_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

