/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _BCM6858_WAN_SERDES_AG_H_
#define _BCM6858_WAN_SERDES_AG_H_

#include "access_macros.h"
#include "bdmf_interface.h"
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif

/**************************************************************************************************/
/* cfg_pll1_lcref_sel:  -                                                                         */
/* cfg_pll1_refout_en:  -                                                                         */
/* cfg_pll1_refin_en:  -                                                                          */
/* cfg_pll0_lcref_sel:  -                                                                         */
/* cfg_pll0_refout_en:  -                                                                         */
/* cfg_pll0_refin_en:  -                                                                          */
/**************************************************************************************************/
typedef struct
{
    bdmf_boolean cfg_pll1_lcref_sel;
    bdmf_boolean cfg_pll1_refout_en;
    bdmf_boolean cfg_pll1_refin_en;
    bdmf_boolean cfg_pll0_lcref_sel;
    bdmf_boolean cfg_pll0_refout_en;
    bdmf_boolean cfg_pll0_refin_en;
} wan_serdes_pll_ctl;


/**************************************************************************************************/
/* cfg_pram_we:  -                                                                                */
/* cfg_pram_cs:  -                                                                                */
/* cfg_pram_ability:  -                                                                           */
/* cfg_pram_datain:  -                                                                            */
/* cfg_pram_addr:  -                                                                              */
/**************************************************************************************************/
typedef struct
{
    bdmf_boolean cfg_pram_we;
    bdmf_boolean cfg_pram_cs;
    bdmf_boolean cfg_pram_ability;
    uint8_t cfg_pram_datain;
    uint16_t cfg_pram_addr;
} wan_serdes_pram_ctl;

bdmf_error_t ag_drv_wan_serdes_pll_ctl_set(const wan_serdes_pll_ctl *pll_ctl);
bdmf_error_t ag_drv_wan_serdes_pll_ctl_get(wan_serdes_pll_ctl *pll_ctl);
bdmf_error_t ag_drv_wan_serdes_temp_ctl_get(uint16_t *wan_temperature_data);
bdmf_error_t ag_drv_wan_serdes_pram_ctl_set(const wan_serdes_pram_ctl *pram_ctl);
bdmf_error_t ag_drv_wan_serdes_pram_ctl_get(wan_serdes_pram_ctl *pram_ctl);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_wan_serdes_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

