/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _NGPON_GEARBOX_AG_H_
#define _NGPON_GEARBOX_AG_H_

#include "access_macros.h"
#include "bdmf_interface.h"
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif
#include "rdp_common.h"

typedef struct
{
    uint8_t cfngpongboxrxfifordptr;
    uint8_t cfngpongboxrxptrautolddis;
    uint8_t cfngpongboxrxmaxbadk;
    uint8_t cfngpongboxrxfrmk28only;
    uint8_t cfngpongboxrxmaxgoodk;
    uint8_t cfngpongboxrxfrchunt;
    uint8_t cfngpongboxrxoutdataflip;
    uint8_t cfngpongboxrxfrcmuxsel;
    uint8_t cfngpongboxrxfrcmuxval;
    uint8_t cfngpongboxrx20bdataflip;
    uint8_t cfngpongboxrxserdataflip;
    uint8_t cfngpongboxrxserdatainv;
    uint8_t cfngpongboxrxfifoptrld;
    uint8_t cfngpongboxrxswsynchold;
    uint8_t cfngpongboxrxmode;
    uint8_t cfngpongboxrxen;
    uint8_t cfngpongboxrstn;
} ngpon_gearbox_rx_ctl_0;

typedef struct
{
    uint8_t cfngpongboxtxfifodatardptr;
    uint8_t cfngpongboxtxfifovldoff;
    uint8_t cfngpongboxtxservldflip;
    uint8_t cfngpongboxtxserdataflip;
    uint8_t cfngpongboxtxservldinv;
    uint8_t cfngpongboxtxserdatainv;
    uint8_t cfngpongboxtxfifovldptrld;
    uint8_t cfngpongboxtxfifoptrld;
    uint8_t cfngpongboxtxen;
} ngpon_gearbox_tx_ctl;

typedef struct
{
    uint8_t ngpontxgboxfifovldptrcol;
    uint8_t ngponrxgboxstate;
    uint8_t ngpontxgboxfifodataptrcol;
    uint8_t ngponrxgboxkcnt;
    uint8_t ngponrxgboxfifoptrdelta;
    uint8_t ngponrxgboxsyncacq;
    uint8_t ngponrxgboxfifoptrcol;
    uint16_t ngponrxgboxcodeerrcntstat;
} ngpon_gearbox_status;

int ag_drv_ngpon_gearbox_rx_ctl_0_set(const ngpon_gearbox_rx_ctl_0 *rx_ctl_0);
int ag_drv_ngpon_gearbox_rx_ctl_0_get(ngpon_gearbox_rx_ctl_0 *rx_ctl_0);
int ag_drv_ngpon_gearbox_rx_ctl_1_set(uint32_t cfngpongboxrxmaxtimercnt);
int ag_drv_ngpon_gearbox_rx_ctl_1_get(uint32_t *cfngpongboxrxmaxtimercnt);
int ag_drv_ngpon_gearbox_rx_ctl_2_set(uint16_t cfngpongboxrxk28d5rdp, uint16_t cfngpongboxrxk28d5rdn);
int ag_drv_ngpon_gearbox_rx_ctl_2_get(uint16_t *cfngpongboxrxk28d5rdp, uint16_t *cfngpongboxrxk28d5rdn);
int ag_drv_ngpon_gearbox_rx_ctl_3_set(uint16_t cfngpongboxrxd5d7rdp, uint16_t cfngpongboxrxd5d7rdn);
int ag_drv_ngpon_gearbox_rx_ctl_3_get(uint16_t *cfngpongboxrxd5d7rdp, uint16_t *cfngpongboxrxd5d7rdn);
int ag_drv_ngpon_gearbox_tx_ctl_set(const ngpon_gearbox_tx_ctl *tx_ctl);
int ag_drv_ngpon_gearbox_tx_ctl_get(ngpon_gearbox_tx_ctl *tx_ctl);
int ag_drv_ngpon_gearbox_status_set(const ngpon_gearbox_status *status);
int ag_drv_ngpon_gearbox_status_get(ngpon_gearbox_status *status);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_ngpon_gearbox_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

