/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "drivers_common_ag.h"
#include "ten_g_gearbox_ag.h"
int ag_drv_ten_g_gearbox_gearbox_set(const ten_g_gearbox_gearbox *gearbox)
{
    uint32_t reg_gearbox=0;

#ifdef VALIDATE_PARMS
    if(!gearbox)
    {
        pr_err("ERROR driver %s:%u|(%d)\n", __FILE__, __LINE__, 1);
        return 1;
    }
    if((gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off >= _3BITS_MAX_VAL_) ||
       (gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off_ld >= _1BITS_MAX_VAL_) ||
       (gearbox->cfg_sgb_pon_10g_epon_tx2rx_loop_en >= _1BITS_MAX_VAL_) ||
       (gearbox->cfg_sgb_pon_10g_epon_rx_data_end >= _1BITS_MAX_VAL_) ||
       (gearbox->cfg_sgb_pon_10g_epon_clk_en >= _1BITS_MAX_VAL_) ||
       (gearbox->cfg_sgb_pon_10g_epon_tx_gbox_rstn >= _1BITS_MAX_VAL_) ||
       (gearbox->cfg_sgb_pon_10g_epon_rx_gbox_rstn >= _1BITS_MAX_VAL_) ||
       (gearbox->cfg_sgb_pon_10g_epon_tx_cgen_rstn >= _1BITS_MAX_VAL_) ||
       (gearbox->cfg_sgb_pon_10g_epon_rx_cgen_rstn >= _1BITS_MAX_VAL_))
    {
        pr_err("ERROR driver %s:%u|(%d)\n", __FILE__, __LINE__, 0);
        return 0;
    }
#endif

    reg_gearbox = RU_FIELD_SET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_TX_FIFO_OFF, reg_gearbox, gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off);
    reg_gearbox = RU_FIELD_SET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_TX_FIFO_OFF_LD, reg_gearbox, gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off_ld);
    reg_gearbox = RU_FIELD_SET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_TX2RX_LOOP_EN, reg_gearbox, gearbox->cfg_sgb_pon_10g_epon_tx2rx_loop_en);
    reg_gearbox = RU_FIELD_SET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_RX_DATA_END, reg_gearbox, gearbox->cfg_sgb_pon_10g_epon_rx_data_end);
    reg_gearbox = RU_FIELD_SET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_CLK_EN, reg_gearbox, gearbox->cfg_sgb_pon_10g_epon_clk_en);
    reg_gearbox = RU_FIELD_SET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_TX_GBOX_RSTN, reg_gearbox, gearbox->cfg_sgb_pon_10g_epon_tx_gbox_rstn);
    reg_gearbox = RU_FIELD_SET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_RX_GBOX_RSTN, reg_gearbox, gearbox->cfg_sgb_pon_10g_epon_rx_gbox_rstn);
    reg_gearbox = RU_FIELD_SET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_TX_CGEN_RSTN, reg_gearbox, gearbox->cfg_sgb_pon_10g_epon_tx_cgen_rstn);
    reg_gearbox = RU_FIELD_SET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_RX_CGEN_RSTN, reg_gearbox, gearbox->cfg_sgb_pon_10g_epon_rx_cgen_rstn);

    RU_REG_WRITE(0, TEN_G_GEARBOX, GEARBOX, reg_gearbox);

    return 0;
}

int ag_drv_ten_g_gearbox_gearbox_get(ten_g_gearbox_gearbox *gearbox)
{
    uint32_t reg_gearbox=0;

#ifdef VALIDATE_PARMS
    if(!gearbox)
    {
        pr_err("ERROR driver %s:%u|(%d)\n", __FILE__, __LINE__, 2);
        return 2;
    }
#endif

    RU_REG_READ(0, TEN_G_GEARBOX, GEARBOX, reg_gearbox);

    gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off = RU_FIELD_GET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_TX_FIFO_OFF, reg_gearbox);
    gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off_ld = RU_FIELD_GET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_TX_FIFO_OFF_LD, reg_gearbox);
    gearbox->cfg_sgb_pon_10g_epon_tx2rx_loop_en = RU_FIELD_GET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_TX2RX_LOOP_EN, reg_gearbox);
    gearbox->cfg_sgb_pon_10g_epon_rx_data_end = RU_FIELD_GET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_RX_DATA_END, reg_gearbox);
    gearbox->cfg_sgb_pon_10g_epon_clk_en = RU_FIELD_GET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_CLK_EN, reg_gearbox);
    gearbox->cfg_sgb_pon_10g_epon_tx_gbox_rstn = RU_FIELD_GET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_TX_GBOX_RSTN, reg_gearbox);
    gearbox->cfg_sgb_pon_10g_epon_rx_gbox_rstn = RU_FIELD_GET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_RX_GBOX_RSTN, reg_gearbox);
    gearbox->cfg_sgb_pon_10g_epon_tx_cgen_rstn = RU_FIELD_GET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_TX_CGEN_RSTN, reg_gearbox);
    gearbox->cfg_sgb_pon_10g_epon_rx_cgen_rstn = RU_FIELD_GET(0, TEN_G_GEARBOX, GEARBOX, CFG_SGB_PON_10G_EPON_RX_CGEN_RSTN, reg_gearbox);

    return 0;
}

