/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: TOP_STATUS_US_RESERVED0
 ******************************************************************************/
const ru_field_rec TOP_STATUS_US_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    TOP_STATUS_US_RESERVED0_FIELD_MASK,
    0,
    TOP_STATUS_US_RESERVED0_FIELD_WIDTH,
    TOP_STATUS_US_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: TOP_STATUS_US_CLK_8KHZ_ALIGNED
 ******************************************************************************/
const ru_field_rec TOP_STATUS_US_CLK_8KHZ_ALIGNED_FIELD =
{
    "CLK_8KHZ_ALIGNED",
#if RU_INCLUDE_DESC
    "",
    "Status indication whether clk_8khz is aligned to the incoming frames"
    "or being adjusted.",
#endif
    TOP_STATUS_US_CLK_8KHZ_ALIGNED_FIELD_MASK,
    0,
    TOP_STATUS_US_CLK_8KHZ_ALIGNED_FIELD_WIDTH,
    TOP_STATUS_US_CLK_8KHZ_ALIGNED_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: TOP_STATUS_US
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *TOP_STATUS_US_FIELDS[] =
{
    &TOP_STATUS_US_RESERVED0_FIELD,
    &TOP_STATUS_US_CLK_8KHZ_ALIGNED_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec TOP_STATUS_US_REG = 
{
    "US",
#if RU_INCLUDE_DESC
    "WAN_TOP_STATUS Register",
    "Register used for various WAN status bits.",
#endif
    TOP_STATUS_US_REG_OFFSET,
    0,
    0,
    24,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    TOP_STATUS_US_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: TOP_STATUS
 ******************************************************************************/
static const ru_reg_rec *TOP_STATUS_REGS[] =
{
    &TOP_STATUS_US_REG,
};

unsigned long TOP_STATUS_ADDRS[] =
{
    0x80144090,
};

const ru_block_rec TOP_STATUS_BLOCK = 
{
    "TOP_STATUS",
    TOP_STATUS_ADDRS,
    1,
    1,
    TOP_STATUS_REGS
};

/* End of file TOP_STATUS.c */
