/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: TS48_EPON_EPON_MSB_RESERVED0
 ******************************************************************************/
const ru_field_rec TS48_EPON_EPON_MSB_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    TS48_EPON_EPON_MSB_RESERVED0_FIELD_MASK,
    0,
    TS48_EPON_EPON_MSB_RESERVED0_FIELD_WIDTH,
    TS48_EPON_EPON_MSB_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: TS48_EPON_EPON_MSB_TS48_EPON_READ_MSB
 ******************************************************************************/
const ru_field_rec TS48_EPON_EPON_MSB_TS48_EPON_READ_MSB_FIELD =
{
    "TS48_EPON_READ_MSB",
#if RU_INCLUDE_DESC
    "",
    "Upper 16-bits of TS48.",
#endif
    TS48_EPON_EPON_MSB_TS48_EPON_READ_MSB_FIELD_MASK,
    0,
    TS48_EPON_EPON_MSB_TS48_EPON_READ_MSB_FIELD_WIDTH,
    TS48_EPON_EPON_MSB_TS48_EPON_READ_MSB_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: TS48_EPON_EPON_LSB_TS48_EPON_READ_LSB
 ******************************************************************************/
const ru_field_rec TS48_EPON_EPON_LSB_TS48_EPON_READ_LSB_FIELD =
{
    "TS48_EPON_READ_LSB",
#if RU_INCLUDE_DESC
    "",
    "Lower 32-bits of TS48.",
#endif
    TS48_EPON_EPON_LSB_TS48_EPON_READ_LSB_FIELD_MASK,
    0,
    TS48_EPON_EPON_LSB_TS48_EPON_READ_LSB_FIELD_WIDTH,
    TS48_EPON_EPON_LSB_TS48_EPON_READ_LSB_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: TS48_EPON_EPON_MSB
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *TS48_EPON_EPON_MSB_FIELDS[] =
{
    &TS48_EPON_EPON_MSB_RESERVED0_FIELD,
    &TS48_EPON_EPON_MSB_TS48_EPON_READ_MSB_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec TS48_EPON_EPON_MSB_REG = 
{
    "EPON_MSB",
#if RU_INCLUDE_DESC
    "WAN_TOP_TS48_EPON_MSB Register",
    "Register used for 48-bit timestamp Time Of Day (TOD) read back from"
    "EPON/AE block.",
#endif
    TS48_EPON_EPON_MSB_REG_OFFSET,
    0,
    0,
    27,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    TS48_EPON_EPON_MSB_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: TS48_EPON_EPON_LSB
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *TS48_EPON_EPON_LSB_FIELDS[] =
{
    &TS48_EPON_EPON_LSB_TS48_EPON_READ_LSB_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec TS48_EPON_EPON_LSB_REG = 
{
    "EPON_LSB",
#if RU_INCLUDE_DESC
    "WAN_TOP_TS48_EPON_LSB Register",
    "Register used for 48-bit timestamp Time Of Day (TOD) read back from"
    "EPON/AE block.",
#endif
    TS48_EPON_EPON_LSB_REG_OFFSET,
    0,
    0,
    28,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    TS48_EPON_EPON_LSB_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: TS48_EPON
 ******************************************************************************/
static const ru_reg_rec *TS48_EPON_REGS[] =
{
    &TS48_EPON_EPON_MSB_REG,
    &TS48_EPON_EPON_LSB_REG,
};

unsigned long TS48_EPON_ADDRS[] =
{
    0x801440a0,
};

const ru_block_rec TS48_EPON_BLOCK = 
{
    "TS48_EPON",
    TS48_EPON_ADDRS,
    1,
    2,
    TS48_EPON_REGS
};

/* End of file TS48_EPON.c */
