/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: TSEC_EPON_EPON_RESERVED0
 ******************************************************************************/
const ru_field_rec TSEC_EPON_EPON_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    TSEC_EPON_EPON_RESERVED0_FIELD_MASK,
    0,
    TSEC_EPON_EPON_RESERVED0_FIELD_WIDTH,
    TSEC_EPON_EPON_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: TSEC_EPON_EPON_TSEC_EPON_READ
 ******************************************************************************/
const ru_field_rec TSEC_EPON_EPON_TSEC_EPON_READ_FIELD =
{
    "TSEC_EPON_READ",
#if RU_INCLUDE_DESC
    "",
    "Seconds[18:0].",
#endif
    TSEC_EPON_EPON_TSEC_EPON_READ_FIELD_MASK,
    0,
    TSEC_EPON_EPON_TSEC_EPON_READ_FIELD_WIDTH,
    TSEC_EPON_EPON_TSEC_EPON_READ_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: TSEC_EPON_EPON
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *TSEC_EPON_EPON_FIELDS[] =
{
    &TSEC_EPON_EPON_RESERVED0_FIELD,
    &TSEC_EPON_EPON_TSEC_EPON_READ_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec TSEC_EPON_EPON_REG = 
{
    "EPON",
#if RU_INCLUDE_DESC
    "WAN_TOP_TSEC_EPON Register",
    "Register used for seconds read back from EPON/AE block.",
#endif
    TSEC_EPON_EPON_REG_OFFSET,
    0,
    0,
    29,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    TSEC_EPON_EPON_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: TSEC_EPON
 ******************************************************************************/
static const ru_reg_rec *TSEC_EPON_REGS[] =
{
    &TSEC_EPON_EPON_REG,
};

unsigned long TSEC_EPON_ADDRS[] =
{
    0x801440a8,
};

const ru_block_rec TSEC_EPON_BLOCK = 
{
    "TSEC_EPON",
    TSEC_EPON_ADDRS,
    1,
    1,
    TSEC_EPON_REGS
};

/* End of file TSEC_EPON.c */
