/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _GPON_AG_H_
#define _GPON_AG_H_

#include "access_macros.h"
#include "bdmf_interface.h"
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif
#include "rdp_common.h"

typedef struct
{
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_ptg_status2_sel;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_ptg_status1_sel;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_status_sel;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_txlbe_bit_order;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_rx_16bit_order;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_tx_8bit_order;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_tx_16bit_order;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_tx_pointer_distance_min;
    uint8_t cr_wan_top_wan_misc_gpon_gearbox_0_fifo_cfg_0_asym_loopback;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_tx_pointer_distance_max;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_tx_bit_inv;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_tx_wr_ptr_dly;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_tx_wr_ptr_adv;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_clear_txfifo_collision;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_loopback_rx;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_0_clear_txfifo_drifted;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_sw_reset_txfifo_reset;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_sw_reset_txpg_reset;
} gpon_gearbox_0;

typedef struct
{
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_pattern_cfg1_filler;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_pattern_cfg1_payload;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_pattern_cfg1_header;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_pattern_cfg1_pg_mode;
} gpon_pattern_cfg1;

typedef struct
{
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_config_burst_delay_cyc;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_tx_vld_delay_cyc;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_1_tx_wr_pointer;
    uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_fifo_cfg_1_tx_rd_pointer;
} gpon_gearbox_2;

int ag_drv_gpon_gearbox_0_set(const gpon_gearbox_0 *gearbox_0);
int ag_drv_gpon_gearbox_0_get(gpon_gearbox_0 *gearbox_0);
int ag_drv_gpon_pattern_cfg1_set(const gpon_pattern_cfg1 *pattern_cfg1);
int ag_drv_gpon_pattern_cfg1_get(gpon_pattern_cfg1 *pattern_cfg1);
int ag_drv_gpon_pattern_cfg2_set(uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_pattern_cfg2_gap_size, uint8_t cr_xgwan_top_wan_misc_gpon_gearbox_pattern_cfg2_burst_size);
int ag_drv_gpon_pattern_cfg2_get(uint8_t *cr_xgwan_top_wan_misc_gpon_gearbox_pattern_cfg2_gap_size, uint8_t *cr_xgwan_top_wan_misc_gpon_gearbox_pattern_cfg2_burst_size);
int ag_drv_gpon_gearbox_2_set(const gpon_gearbox_2 *gearbox_2);
int ag_drv_gpon_gearbox_2_get(gpon_gearbox_2 *gearbox_2);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_gpon_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

