/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: GPON_GEARBOX_STATUS_GEARBOX_STATUS_CR_RD_DATA_CLX
 ******************************************************************************/
const ru_field_rec GPON_GEARBOX_STATUS_GEARBOX_STATUS_CR_RD_DATA_CLX_FIELD =
{
    "CR_RD_DATA_CLX",
#if RU_INCLUDE_DESC
    "",
    "Status indication based on status_sel signals.  If"
    "gpon_gearbox_fifo_status_sel is high, this status will be"
    "gpon_gearbox_fifo_status.  If gpon_gearbox_ptg_status1_sel is high,"
    "this status will be gpon_gearbox_ptg_status1.  If"
    "gpon_gearbox_ptg_status2_sel is high, this status will be"
    "gpon_gearbox_ptg_status2.",
#endif
    GPON_GEARBOX_STATUS_GEARBOX_STATUS_CR_RD_DATA_CLX_FIELD_MASK,
    0,
    GPON_GEARBOX_STATUS_GEARBOX_STATUS_CR_RD_DATA_CLX_FIELD_WIDTH,
    GPON_GEARBOX_STATUS_GEARBOX_STATUS_CR_RD_DATA_CLX_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: GPON_GEARBOX_STATUS_GEARBOX_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *GPON_GEARBOX_STATUS_GEARBOX_STATUS_FIELDS[] =
{
    &GPON_GEARBOX_STATUS_GEARBOX_STATUS_CR_RD_DATA_CLX_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec GPON_GEARBOX_STATUS_GEARBOX_STATUS_REG = 
{
    "GEARBOX_STATUS",
#if RU_INCLUDE_DESC
    "WAN_TOP_GPON_GEARBOX_STATUS Register",
    "Register used for various WAN status bits.",
#endif
    GPON_GEARBOX_STATUS_GEARBOX_STATUS_REG_OFFSET,
    0,
    0,
    26,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    GPON_GEARBOX_STATUS_GEARBOX_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: GPON_GEARBOX_STATUS
 ******************************************************************************/
static const ru_reg_rec *GPON_GEARBOX_STATUS_REGS[] =
{
    &GPON_GEARBOX_STATUS_GEARBOX_STATUS_REG,
};

unsigned long GPON_GEARBOX_STATUS_ADDRS[] =
{
#if defined(CONFIG_BCM963158)
    0x80144094,
#else
    #error "GPON_GEARBOX_STATUS base address not defined"
#endif
};

const ru_block_rec GPON_GEARBOX_STATUS_BLOCK = 
{
    "GPON_GEARBOX_STATUS",
    GPON_GEARBOX_STATUS_ADDRS,
    1,
    1,
    GPON_GEARBOX_STATUS_REGS
};

/* End of file GPON_GEARBOX_STATUS.c */
