/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: TOP_SCRATCH_ATCH_SCRATCH
 ******************************************************************************/
const ru_field_rec TOP_SCRATCH_ATCH_SCRATCH_FIELD =
{
    "SCRATCH",
#if RU_INCLUDE_DESC
    "",
    "Scratch pad.",
#endif
    TOP_SCRATCH_ATCH_SCRATCH_FIELD_MASK,
    0,
    TOP_SCRATCH_ATCH_SCRATCH_FIELD_WIDTH,
    TOP_SCRATCH_ATCH_SCRATCH_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: TOP_SCRATCH_ATCH
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *TOP_SCRATCH_ATCH_FIELDS[] =
{
    &TOP_SCRATCH_ATCH_SCRATCH_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec TOP_SCRATCH_ATCH_REG = 
{
    "ATCH",
#if RU_INCLUDE_DESC
    "WAN_TOP_SCRATCH Register",
    "Register used for testing read and write access into wan_top block.",
#endif
    TOP_SCRATCH_ATCH_REG_OFFSET,
    0,
    0,
    0,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    TOP_SCRATCH_ATCH_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: TOP_SCRATCH
 ******************************************************************************/
static const ru_reg_rec *TOP_SCRATCH_REGS[] =
{
    &TOP_SCRATCH_ATCH_REG,
};

unsigned long TOP_SCRATCH_ADDRS[] =
{
#if defined(CONFIG_BCM963158)
    0x80144000,
#else
    #error "TOP_SCRATCH base address not defined"
#endif
};

const ru_block_rec TOP_SCRATCH_BLOCK = 
{
    "TOP_SCRATCH",
    TOP_SCRATCH_ADDRS,
    1,
    1,
    TOP_SCRATCH_REGS
};

/* End of file TOP_SCRATCH.c */
