/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: AEPCS_IEEE_REGID_ID_CFG_AEPCS_IEEE_REGID
 ******************************************************************************/
const ru_field_rec AEPCS_IEEE_REGID_ID_CFG_AEPCS_IEEE_REGID_FIELD =
{
    "CFG_AEPCS_IEEE_REGID",
#if RU_INCLUDE_DESC
    "",
    "The AE PCS IEEE device ID.",
#endif
    AEPCS_IEEE_REGID_ID_CFG_AEPCS_IEEE_REGID_FIELD_MASK,
    0,
    AEPCS_IEEE_REGID_ID_CFG_AEPCS_IEEE_REGID_FIELD_WIDTH,
    AEPCS_IEEE_REGID_ID_CFG_AEPCS_IEEE_REGID_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: AEPCS_IEEE_REGID_ID
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *AEPCS_IEEE_REGID_ID_FIELDS[] =
{
    &AEPCS_IEEE_REGID_ID_CFG_AEPCS_IEEE_REGID_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec AEPCS_IEEE_REGID_ID_REG = 
{
    "ID",
#if RU_INCLUDE_DESC
    "WAN_AEPCS_IEEE_REGID Register",
    "Provides the configuration for AE PCS IEEE device ID register.",
#endif
    AEPCS_IEEE_REGID_ID_REG_OFFSET,
    0,
    0,
    52,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    AEPCS_IEEE_REGID_ID_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: AEPCS_IEEE_REGID
 ******************************************************************************/
static const ru_reg_rec *AEPCS_IEEE_REGID_REGS[] =
{
    &AEPCS_IEEE_REGID_ID_REG,
};

unsigned long AEPCS_IEEE_REGID_ADDRS[] =
{
    0x801440d0,
};

const ru_block_rec AEPCS_IEEE_REGID_BLOCK = 
{
    "AEPCS_IEEE_REGID",
    AEPCS_IEEE_REGID_ADDRS,
    1,
    1,
    AEPCS_IEEE_REGID_REGS
};

/* End of file AEPCS_IEEE_REGID.c */
