/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: TOP_RESET_T_RESERVED0
 ******************************************************************************/
const ru_field_rec TOP_RESET_T_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    TOP_RESET_T_RESERVED0_FIELD_MASK,
    0,
    TOP_RESET_T_RESERVED0_FIELD_WIDTH,
    TOP_RESET_T_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: TOP_RESET_T_CFG_PCS_RESET_N
 ******************************************************************************/
const ru_field_rec TOP_RESET_T_CFG_PCS_RESET_N_FIELD =
{
    "CFG_PCS_RESET_N",
#if RU_INCLUDE_DESC
    "",
    "Active low PCS reset. Set to 1 for normal operation",
#endif
    TOP_RESET_T_CFG_PCS_RESET_N_FIELD_MASK,
    0,
    TOP_RESET_T_CFG_PCS_RESET_N_FIELD_WIDTH,
    TOP_RESET_T_CFG_PCS_RESET_N_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: TOP_RESET_T
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *TOP_RESET_T_FIELDS[] =
{
    &TOP_RESET_T_RESERVED0_FIELD,
    &TOP_RESET_T_CFG_PCS_RESET_N_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec TOP_RESET_T_REG = 
{
    "T",
#if RU_INCLUDE_DESC
    "WAN_TOP_RESET Register",
    "Various resets to be applied within wan_top.",
#endif
    TOP_RESET_T_REG_OFFSET,
    0,
    0,
    1,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    TOP_RESET_T_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: TOP_RESET
 ******************************************************************************/
static const ru_reg_rec *TOP_RESET_REGS[] =
{
    &TOP_RESET_T_REG,
};

unsigned long TOP_RESET_ADDRS[] =
{
    0x80144004,
};

const ru_block_rec TOP_RESET_BLOCK = 
{
    "TOP_RESET",
    TOP_RESET_ADDRS,
    1,
    1,
    TOP_RESET_REGS
};

/* End of file TOP_RESET.c */
