/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: VOLTAGE_REGULATOR_DIVIDER_IDER_RESERVED0
 ******************************************************************************/
const ru_field_rec VOLTAGE_REGULATOR_DIVIDER_IDER_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    VOLTAGE_REGULATOR_DIVIDER_IDER_RESERVED0_FIELD_MASK,
    0,
    VOLTAGE_REGULATOR_DIVIDER_IDER_RESERVED0_FIELD_WIDTH,
    VOLTAGE_REGULATOR_DIVIDER_IDER_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_BYPASS
 ******************************************************************************/
const ru_field_rec VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_BYPASS_FIELD =
{
    "CFG_VREG_CLK_BYPASS",
#if RU_INCLUDE_DESC
    "",
    "Allows the bypassing of the N divider.",
#endif
    VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_BYPASS_FIELD_MASK,
    0,
    VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_BYPASS_FIELD_WIDTH,
    VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_BYPASS_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_SRC
 ******************************************************************************/
const ru_field_rec VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_SRC_FIELD =
{
    "CFG_VREG_CLK_SRC",
#if RU_INCLUDE_DESC
    "",
    "Specifies the clock source of the voltage regulator sync output : 1"
    "- VDSL PHY; 0 - 50 MHz XTAL clock.",
#endif
    VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_SRC_FIELD_MASK,
    0,
    VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_SRC_FIELD_WIDTH,
    VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_SRC_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_DIV
 ******************************************************************************/
const ru_field_rec VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_DIV_FIELD =
{
    "CFG_VREG_DIV",
#if RU_INCLUDE_DESC
    "",
    "N divider value of voltage regulator sync output.  Assertive 1 value"
    "will be INT((N/2); and assertive 0, N - INT(N/2).",
#endif
    VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_DIV_FIELD_MASK,
    0,
    VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_DIV_FIELD_WIDTH,
    VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_DIV_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: VOLTAGE_REGULATOR_DIVIDER_IDER
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *VOLTAGE_REGULATOR_DIVIDER_IDER_FIELDS[] =
{
    &VOLTAGE_REGULATOR_DIVIDER_IDER_RESERVED0_FIELD,
    &VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_BYPASS_FIELD,
    &VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_CLK_SRC_FIELD,
    &VOLTAGE_REGULATOR_DIVIDER_IDER_CFG_VREG_DIV_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec VOLTAGE_REGULATOR_DIVIDER_IDER_REG = 
{
    "IDER",
#if RU_INCLUDE_DESC
    "WAN_VOLTAGE_REGULATOR_DIVIDER Register",
    "Provides the divider for the voltage regulator sync output.",
#endif
    VOLTAGE_REGULATOR_DIVIDER_IDER_REG_OFFSET,
    0,
    0,
    50,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    VOLTAGE_REGULATOR_DIVIDER_IDER_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: VOLTAGE_REGULATOR_DIVIDER
 ******************************************************************************/
static const ru_reg_rec *VOLTAGE_REGULATOR_DIVIDER_REGS[] =
{
    &VOLTAGE_REGULATOR_DIVIDER_IDER_REG,
};

unsigned long VOLTAGE_REGULATOR_DIVIDER_ADDRS[] =
{
    0x801440c8,
};

const ru_block_rec VOLTAGE_REGULATOR_DIVIDER_BLOCK = 
{
    "VOLTAGE_REGULATOR_DIVIDER",
    VOLTAGE_REGULATOR_DIVIDER_ADDRS,
    1,
    1,
    VOLTAGE_REGULATOR_DIVIDER_REGS
};

/* End of file VOLTAGE_REGULATOR_DIVIDER.c */
