/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _RESCAL_AG_H_
#define _RESCAL_AG_H_

#include "access_macros.h"
#include "bdmf_interface.h"
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif
#include "rdp_common.h"

typedef struct
{
    uint16_t ctrl;
    uint8_t pwrdn;
    uint8_t diag_on;
    uint8_t rstb;
} rescal_cfg;

typedef struct
{
    uint8_t valid;
    uint8_t comp;
    uint8_t state;
    uint16_t ctrl_dfs;
    uint8_t prev_comp_cnt;
    uint8_t pon;
    uint8_t done;
} rescal_status0;

int ag_drv_rescal_cfg_set(const rescal_cfg *cfg);
int ag_drv_rescal_cfg_get(rescal_cfg *cfg);
int ag_drv_rescal_status_0_get(rescal_status0 *status0);
int ag_drv_rescal_status_1_get(uint8_t *curr_comp_cnt);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_rescal_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

