/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _TOD_AG_H_
#define _TOD_AG_H_

#include "access_macros.h"
#include "bdmf_interface.h"
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif
#include "rdp_common.h"

typedef struct
{
    uint8_t cfg_ts48_mac_select;
    uint8_t cfg_ts48_enable;
    uint16_t cfg_ts48_offset;
    uint8_t cfg_ts48_read;
} tod_config_0;

int ag_drv_tod_config_0_set(const tod_config_0 *config_0);
int ag_drv_tod_config_0_get(tod_config_0 *config_0);
int ag_drv_tod_msb_get(uint16_t *ts48_wan_read_msb);
int ag_drv_tod_lsb_get(uint32_t *ts48_wan_read_lsb);
int ag_drv_tod_config_2_set(uint16_t tx_offset, uint16_t rx_offset);
int ag_drv_tod_config_2_get(uint16_t *tx_offset, uint16_t *rx_offset);
int ag_drv_tod_config_3_set(uint8_t ts48_fifo_dis, uint8_t ts48_fifo_ld_rate, uint16_t ref_offset);
int ag_drv_tod_config_3_get(uint8_t *ts48_fifo_dis, uint8_t *ts48_fifo_ld_rate, uint16_t *ref_offset);
int ag_drv_tod_status_0_get(uint16_t *ts16_tx_read, uint16_t *ts16_rx_read);
int ag_drv_tod_status_1_get(uint16_t *ts16_rx_synce_read, uint16_t *ts16_ref_synce_read);
int ag_drv_tod_status_2_get(uint16_t *ts16_mac_tx_read, uint16_t *ts16_mac_rx_read);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_tod_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

