/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: PMI_LP_0_PMI_LP_WRITE
 ******************************************************************************/
const ru_field_rec PMI_LP_0_PMI_LP_WRITE_FIELD =
{
    "PMI_LP_WRITE",
#if RU_INCLUDE_DESC
    "PMI_LP_WRITE",
    "Read/Write control from master. 1-write, 0-read. This should be"
    "asserted before or with the pmi_lp_en and should be driven until the"
    "next transaction."
    "Reset value is 0x0.",
#endif
    PMI_LP_0_PMI_LP_WRITE_FIELD_MASK,
    0,
    PMI_LP_0_PMI_LP_WRITE_FIELD_WIDTH,
    PMI_LP_0_PMI_LP_WRITE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: PMI_LP_0_PMI_LP_EN
 ******************************************************************************/
const ru_field_rec PMI_LP_0_PMI_LP_EN_FIELD =
{
    "PMI_LP_EN",
#if RU_INCLUDE_DESC
    "PMI_LP_EN",
    "Transaction enable control from master. This is treated as"
    "asynchronous to the rmic. The bus master should wait for pmi_lp_ack"
    "to be deasserted before pmi_lp_en is asserted. The bus master should"
    "then wait for pmi_lp_ack to be asserted indicating that the"
    "transaction is complete before it deasserts pmi_lp_en."
    "Reset value is 0x0.",
#endif
    PMI_LP_0_PMI_LP_EN_FIELD_MASK,
    0,
    PMI_LP_0_PMI_LP_EN_FIELD_WIDTH,
    PMI_LP_0_PMI_LP_EN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: PMI_LP_0_RESERVED0
 ******************************************************************************/
const ru_field_rec PMI_LP_0_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    PMI_LP_0_RESERVED0_FIELD_MASK,
    0,
    PMI_LP_0_RESERVED0_FIELD_WIDTH,
    PMI_LP_0_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: PMI_LP_1_PMI_LP_ADDR
 ******************************************************************************/
const ru_field_rec PMI_LP_1_PMI_LP_ADDR_FIELD =
{
    "PMI_LP_ADDR",
#if RU_INCLUDE_DESC
    "PMI_LP_ADDR",
    "32-bit address driven by master for read or write transaction. This"
    "should be asserted before or with the pmi_lp_en and should be driven"
    "until the next transaction"
    "Reset value is 0x0.",
#endif
    PMI_LP_1_PMI_LP_ADDR_FIELD_MASK,
    0,
    PMI_LP_1_PMI_LP_ADDR_FIELD_WIDTH,
    PMI_LP_1_PMI_LP_ADDR_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: PMI_LP_2_PMI_LP_MASKDATA
 ******************************************************************************/
const ru_field_rec PMI_LP_2_PMI_LP_MASKDATA_FIELD =
{
    "PMI_LP_MASKDATA",
#if RU_INCLUDE_DESC
    "PMI_LP_MASKDATA",
    "16-bit mask bus driven by master for write transaction. 0 means no"
    "mask (wrdata bit is written to register), 1 means mask (wrdata bit"
    "is ignored). This bus has no affect during a read operation. This"
    "should be asserted before or with the pmi_lp_en and should be driven"
    "until the next transaction."
    "Reset value is 0x0.",
#endif
    PMI_LP_2_PMI_LP_MASKDATA_FIELD_MASK,
    0,
    PMI_LP_2_PMI_LP_MASKDATA_FIELD_WIDTH,
    PMI_LP_2_PMI_LP_MASKDATA_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: PMI_LP_2_PMI_LP_WRDATA
 ******************************************************************************/
const ru_field_rec PMI_LP_2_PMI_LP_WRDATA_FIELD =
{
    "PMI_LP_WRDATA",
#if RU_INCLUDE_DESC
    "PMI_LP_WRDATA",
    "16-bit data bus driven by master for write transaction. This should"
    "be driven before or with the pmi_lp_en and should be driven until"
    "the next transaction."
    "Reset value is 0x0.",
#endif
    PMI_LP_2_PMI_LP_WRDATA_FIELD_MASK,
    0,
    PMI_LP_2_PMI_LP_WRDATA_FIELD_WIDTH,
    PMI_LP_2_PMI_LP_WRDATA_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: PMI_LP_3_PMI_LP_RDDATA
 ******************************************************************************/
const ru_field_rec PMI_LP_3_PMI_LP_RDDATA_FIELD =
{
    "PMI_LP_RDDATA",
#if RU_INCLUDE_DESC
    "PMI_LP_RDDATA",
    "16-bit data bus driven RMIC slave during a read transaction. This"
    "data is latched in the register clock domain but this data is"
    "guaranteed to be stable by the end of the read transaction so this"
    "does not have to metastabilized."
    "Reset value is 0x0.",
#endif
    PMI_LP_3_PMI_LP_RDDATA_FIELD_MASK,
    0,
    PMI_LP_3_PMI_LP_RDDATA_FIELD_WIDTH,
    PMI_LP_3_PMI_LP_RDDATA_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: PMI_LP_3_PMI_LP_ACK
 ******************************************************************************/
const ru_field_rec PMI_LP_3_PMI_LP_ACK_FIELD =
{
    "PMI_LP_ACK",
#if RU_INCLUDE_DESC
    "PMI_LP_ACK",
    "Ack response back from the RMIC slave indicating that the write or"
    "read transaction is complete. This signal is driven in the registers"
    "blocks clock domain and should be treated as an asynchronous input"
    "by the master."
    "Reset value is 0x0.",
#endif
    PMI_LP_3_PMI_LP_ACK_FIELD_MASK,
    0,
    PMI_LP_3_PMI_LP_ACK_FIELD_WIDTH,
    PMI_LP_3_PMI_LP_ACK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: PMI_LP_3_PMI_LP_ERR
 ******************************************************************************/
const ru_field_rec PMI_LP_3_PMI_LP_ERR_FIELD =
{
    "PMI_LP_ERR",
#if RU_INCLUDE_DESC
    "PMI_LP_ERR",
    "Error response from RMIC slave indicating an address error which"
    "means that either the block address does not exist or that the devid"
    "did not match the strap value. The ack signal indicates that the"
    "transaction is complete and the error signal indicates that there"
    "was an address error with this transaction. This signal is asserted"
    "along with the ack signal and should be treated an asynchronous"
    "signal the same way as the ack signal."
    "Reset value is 0x0.",
#endif
    PMI_LP_3_PMI_LP_ERR_FIELD_MASK,
    0,
    PMI_LP_3_PMI_LP_ERR_FIELD_WIDTH,
    PMI_LP_3_PMI_LP_ERR_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: PMI_LP_3_RESERVED0
 ******************************************************************************/
const ru_field_rec PMI_LP_3_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    PMI_LP_3_RESERVED0_FIELD_MASK,
    0,
    PMI_LP_3_RESERVED0_FIELD_WIDTH,
    PMI_LP_3_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: PMI_LP_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *PMI_LP_0_FIELDS[] =
{
    &PMI_LP_0_PMI_LP_WRITE_FIELD,
    &PMI_LP_0_PMI_LP_EN_FIELD,
    &PMI_LP_0_RESERVED0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec PMI_LP_0_REG = 
{
    "LP_0",
#if RU_INCLUDE_DESC
    "PMI_LP_0 Register",
    "Register used for low priority configuration.",
#endif
    PMI_LP_0_REG_OFFSET,
    0,
    0,
    9,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    3,
    PMI_LP_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: PMI_LP_1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *PMI_LP_1_FIELDS[] =
{
    &PMI_LP_1_PMI_LP_ADDR_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec PMI_LP_1_REG = 
{
    "LP_1",
#if RU_INCLUDE_DESC
    "PMI_LP_1 Register",
    "Register used for low priority configuration.",
#endif
    PMI_LP_1_REG_OFFSET,
    0,
    0,
    10,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    PMI_LP_1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: PMI_LP_2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *PMI_LP_2_FIELDS[] =
{
    &PMI_LP_2_PMI_LP_MASKDATA_FIELD,
    &PMI_LP_2_PMI_LP_WRDATA_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec PMI_LP_2_REG = 
{
    "LP_2",
#if RU_INCLUDE_DESC
    "PMI_LP_2 Register",
    "Register used for low priority configuration.",
#endif
    PMI_LP_2_REG_OFFSET,
    0,
    0,
    11,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    PMI_LP_2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: PMI_LP_3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *PMI_LP_3_FIELDS[] =
{
    &PMI_LP_3_PMI_LP_RDDATA_FIELD,
    &PMI_LP_3_PMI_LP_ACK_FIELD,
    &PMI_LP_3_PMI_LP_ERR_FIELD,
    &PMI_LP_3_RESERVED0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec PMI_LP_3_REG = 
{
    "LP_3",
#if RU_INCLUDE_DESC
    "PMI_LP_3 Register",
    "Register used for low priority configuration.",
#endif
    PMI_LP_3_REG_OFFSET,
    0,
    0,
    12,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    PMI_LP_3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: PMI
 ******************************************************************************/
static const ru_reg_rec *PMI_REGS[] =
{
    &PMI_LP_0_REG,
    &PMI_LP_1_REG,
    &PMI_LP_2_REG,
    &PMI_LP_3_REG,
};

unsigned long PMI_ADDRS[] =
{
    0x82db205c,
};

const ru_block_rec PMI_BLOCK = 
{
    "PMI",
    PMI_ADDRS,
    1,
    4,
    PMI_REGS
};

/* End of file PMI.c */
