/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef __AG_H_
#define __AG_H_

#include "ru.h"

/******************************************************************************
 *  Fields
 ******************************************************************************/
extern const ru_field_rec TOP_SCRATCH_ATCH_DATA_FIELD;
#define TOP_SCRATCH_ATCH_DATA_FIELD_MASK  0x00000000ffffffff
#define TOP_SCRATCH_ATCH_DATA_FIELD_WIDTH 32
#define TOP_SCRATCH_ATCH_DATA_FIELD_SHIFT 0

extern const ru_field_rec EARLY_TXEN_TXEN_CFG_HOLD_TIME_FIELD;
#define EARLY_TXEN_TXEN_CFG_HOLD_TIME_FIELD_MASK  0x00000000000000ff
#define EARLY_TXEN_TXEN_CFG_HOLD_TIME_FIELD_WIDTH 8
#define EARLY_TXEN_TXEN_CFG_HOLD_TIME_FIELD_SHIFT 0

extern const ru_field_rec EARLY_TXEN_TXEN_CFG_SETUP_TIME_FIELD;
#define EARLY_TXEN_TXEN_CFG_SETUP_TIME_FIELD_MASK  0x000000000000ff00
#define EARLY_TXEN_TXEN_CFG_SETUP_TIME_FIELD_WIDTH 8
#define EARLY_TXEN_TXEN_CFG_SETUP_TIME_FIELD_SHIFT 8

extern const ru_field_rec EARLY_TXEN_TXEN_CFG_TOFF_TIME_FIELD;
#define EARLY_TXEN_TXEN_CFG_TOFF_TIME_FIELD_MASK  0x0000000000ff0000
#define EARLY_TXEN_TXEN_CFG_TOFF_TIME_FIELD_WIDTH 8
#define EARLY_TXEN_TXEN_CFG_TOFF_TIME_FIELD_SHIFT 16

extern const ru_field_rec EARLY_TXEN_TXEN_CFG_OUTPUT_TXEN_POLARITY_FIELD;
#define EARLY_TXEN_TXEN_CFG_OUTPUT_TXEN_POLARITY_FIELD_MASK  0x0000000001000000
#define EARLY_TXEN_TXEN_CFG_OUTPUT_TXEN_POLARITY_FIELD_WIDTH 1
#define EARLY_TXEN_TXEN_CFG_OUTPUT_TXEN_POLARITY_FIELD_SHIFT 24

extern const ru_field_rec EARLY_TXEN_TXEN_CFG_INPUT_TXEN_POLARITY_FIELD;
#define EARLY_TXEN_TXEN_CFG_INPUT_TXEN_POLARITY_FIELD_MASK  0x0000000002000000
#define EARLY_TXEN_TXEN_CFG_INPUT_TXEN_POLARITY_FIELD_WIDTH 1
#define EARLY_TXEN_TXEN_CFG_INPUT_TXEN_POLARITY_FIELD_SHIFT 25

extern const ru_field_rec EARLY_TXEN_TXEN_CFG_EARLY_TXEN_BYPASS_FIELD;
#define EARLY_TXEN_TXEN_CFG_EARLY_TXEN_BYPASS_FIELD_MASK  0x0000000004000000
#define EARLY_TXEN_TXEN_CFG_EARLY_TXEN_BYPASS_FIELD_WIDTH 1
#define EARLY_TXEN_TXEN_CFG_EARLY_TXEN_BYPASS_FIELD_SHIFT 26

extern const ru_field_rec EARLY_TXEN_TXEN_CFG_RESERVED0_FIELD;
#define EARLY_TXEN_TXEN_CFG_RESERVED0_FIELD_MASK  0x00000000f8000000
#define EARLY_TXEN_TXEN_CFG_RESERVED0_FIELD_WIDTH 5
#define EARLY_TXEN_TXEN_CFG_RESERVED0_FIELD_SHIFT 27

extern const ru_field_rec RESCAL_CFG_CTRL_FIELD;
#define RESCAL_CFG_CTRL_FIELD_MASK  0x0000000000001fff
#define RESCAL_CFG_CTRL_FIELD_WIDTH 13
#define RESCAL_CFG_CTRL_FIELD_SHIFT 0

extern const ru_field_rec RESCAL_CFG_PWRDN_FIELD;
#define RESCAL_CFG_PWRDN_FIELD_MASK  0x0000000000002000
#define RESCAL_CFG_PWRDN_FIELD_WIDTH 1
#define RESCAL_CFG_PWRDN_FIELD_SHIFT 13

extern const ru_field_rec RESCAL_CFG_DIAG_ON_FIELD;
#define RESCAL_CFG_DIAG_ON_FIELD_MASK  0x0000000000004000
#define RESCAL_CFG_DIAG_ON_FIELD_WIDTH 1
#define RESCAL_CFG_DIAG_ON_FIELD_SHIFT 14

extern const ru_field_rec RESCAL_CFG_RSTB_FIELD;
#define RESCAL_CFG_RSTB_FIELD_MASK  0x0000000000008000
#define RESCAL_CFG_RSTB_FIELD_WIDTH 1
#define RESCAL_CFG_RSTB_FIELD_SHIFT 15

extern const ru_field_rec RESCAL_CFG_RESERVED0_FIELD;
#define RESCAL_CFG_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define RESCAL_CFG_RESERVED0_FIELD_WIDTH 16
#define RESCAL_CFG_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec RESCAL_STATUS0_VALID_FIELD;
#define RESCAL_STATUS0_VALID_FIELD_MASK  0x0000000000000001
#define RESCAL_STATUS0_VALID_FIELD_WIDTH 1
#define RESCAL_STATUS0_VALID_FIELD_SHIFT 0

extern const ru_field_rec RESCAL_STATUS0_COMP_FIELD;
#define RESCAL_STATUS0_COMP_FIELD_MASK  0x0000000000000002
#define RESCAL_STATUS0_COMP_FIELD_WIDTH 1
#define RESCAL_STATUS0_COMP_FIELD_SHIFT 1

extern const ru_field_rec RESCAL_STATUS0_STATE_FIELD;
#define RESCAL_STATUS0_STATE_FIELD_MASK  0x000000000000001c
#define RESCAL_STATUS0_STATE_FIELD_WIDTH 3
#define RESCAL_STATUS0_STATE_FIELD_SHIFT 2

extern const ru_field_rec RESCAL_STATUS0_CTRL_DFS_FIELD;
#define RESCAL_STATUS0_CTRL_DFS_FIELD_MASK  0x000000000003ffe0
#define RESCAL_STATUS0_CTRL_DFS_FIELD_WIDTH 13
#define RESCAL_STATUS0_CTRL_DFS_FIELD_SHIFT 5

extern const ru_field_rec RESCAL_STATUS0_PREV_COMP_CNT_FIELD;
#define RESCAL_STATUS0_PREV_COMP_CNT_FIELD_MASK  0x00000000003c0000
#define RESCAL_STATUS0_PREV_COMP_CNT_FIELD_WIDTH 4
#define RESCAL_STATUS0_PREV_COMP_CNT_FIELD_SHIFT 18

extern const ru_field_rec RESCAL_STATUS0_PON_FIELD;
#define RESCAL_STATUS0_PON_FIELD_MASK  0x0000000003c00000
#define RESCAL_STATUS0_PON_FIELD_WIDTH 4
#define RESCAL_STATUS0_PON_FIELD_SHIFT 22

extern const ru_field_rec RESCAL_STATUS0_DONE_FIELD;
#define RESCAL_STATUS0_DONE_FIELD_MASK  0x0000000004000000
#define RESCAL_STATUS0_DONE_FIELD_WIDTH 1
#define RESCAL_STATUS0_DONE_FIELD_SHIFT 26

extern const ru_field_rec RESCAL_STATUS0_RESERVED0_FIELD;
#define RESCAL_STATUS0_RESERVED0_FIELD_MASK  0x00000000f8000000
#define RESCAL_STATUS0_RESERVED0_FIELD_WIDTH 5
#define RESCAL_STATUS0_RESERVED0_FIELD_SHIFT 27

extern const ru_field_rec RESCAL_STATUS1_CURR_COMP_CNT_FIELD;
#define RESCAL_STATUS1_CURR_COMP_CNT_FIELD_MASK  0x000000000000003f
#define RESCAL_STATUS1_CURR_COMP_CNT_FIELD_WIDTH 6
#define RESCAL_STATUS1_CURR_COMP_CNT_FIELD_SHIFT 0

extern const ru_field_rec RESCAL_STATUS1_RESERVED0_FIELD;
#define RESCAL_STATUS1_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define RESCAL_STATUS1_RESERVED0_FIELD_WIDTH 26
#define RESCAL_STATUS1_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec MISC_0_ONU2G_PMD_STATUS_SEL_FIELD;
#define MISC_0_ONU2G_PMD_STATUS_SEL_FIELD_MASK  0x0000000000000001
#define MISC_0_ONU2G_PMD_STATUS_SEL_FIELD_WIDTH 1
#define MISC_0_ONU2G_PMD_STATUS_SEL_FIELD_SHIFT 0

extern const ru_field_rec MISC_0_REFIN_EN_FIELD;
#define MISC_0_REFIN_EN_FIELD_MASK  0x0000000000000002
#define MISC_0_REFIN_EN_FIELD_WIDTH 1
#define MISC_0_REFIN_EN_FIELD_SHIFT 1

extern const ru_field_rec MISC_0_REFOUT_EN_FIELD;
#define MISC_0_REFOUT_EN_FIELD_MASK  0x0000000000000004
#define MISC_0_REFOUT_EN_FIELD_WIDTH 1
#define MISC_0_REFOUT_EN_FIELD_SHIFT 2

extern const ru_field_rec MISC_0_MDIO_MODE_FIELD;
#define MISC_0_MDIO_MODE_FIELD_MASK  0x0000000000000008
#define MISC_0_MDIO_MODE_FIELD_WIDTH 1
#define MISC_0_MDIO_MODE_FIELD_SHIFT 3

extern const ru_field_rec MISC_0_MDIO_FAST_MODE_FIELD;
#define MISC_0_MDIO_FAST_MODE_FIELD_MASK  0x0000000000000010
#define MISC_0_MDIO_FAST_MODE_FIELD_WIDTH 1
#define MISC_0_MDIO_FAST_MODE_FIELD_SHIFT 4

extern const ru_field_rec MISC_0_EPON_TX_FIFO_OFF_LD_FIELD;
#define MISC_0_EPON_TX_FIFO_OFF_LD_FIELD_MASK  0x0000000000000020
#define MISC_0_EPON_TX_FIFO_OFF_LD_FIELD_WIDTH 1
#define MISC_0_EPON_TX_FIFO_OFF_LD_FIELD_SHIFT 5

extern const ru_field_rec MISC_0_ONU2G_PHYA_FIELD;
#define MISC_0_ONU2G_PHYA_FIELD_MASK  0x00000000000007c0
#define MISC_0_ONU2G_PHYA_FIELD_WIDTH 5
#define MISC_0_ONU2G_PHYA_FIELD_SHIFT 6

extern const ru_field_rec MISC_0_EPON_GBOX_RX_WIDTH_MODE_FIELD;
#define MISC_0_EPON_GBOX_RX_WIDTH_MODE_FIELD_MASK  0x0000000000000800
#define MISC_0_EPON_GBOX_RX_WIDTH_MODE_FIELD_WIDTH 1
#define MISC_0_EPON_GBOX_RX_WIDTH_MODE_FIELD_SHIFT 11

extern const ru_field_rec MISC_0_EPON_AE_2P5_FULL_RATE_MODE_FIELD;
#define MISC_0_EPON_AE_2P5_FULL_RATE_MODE_FIELD_MASK  0x0000000000001000
#define MISC_0_EPON_AE_2P5_FULL_RATE_MODE_FIELD_WIDTH 1
#define MISC_0_EPON_AE_2P5_FULL_RATE_MODE_FIELD_SHIFT 12

extern const ru_field_rec MISC_0_RESERVED0_FIELD;
#define MISC_0_RESERVED0_FIELD_MASK  0x000000000000e000
#define MISC_0_RESERVED0_FIELD_WIDTH 3
#define MISC_0_RESERVED0_FIELD_SHIFT 13

extern const ru_field_rec MISC_0_PMD_LANE_MODE_FIELD;
#define MISC_0_PMD_LANE_MODE_FIELD_MASK  0x00000000ffff0000
#define MISC_0_PMD_LANE_MODE_FIELD_WIDTH 16
#define MISC_0_PMD_LANE_MODE_FIELD_SHIFT 16

extern const ru_field_rec MISC_1_PMD_CORE_0_MODE_FIELD;
#define MISC_1_PMD_CORE_0_MODE_FIELD_MASK  0x000000000000ffff
#define MISC_1_PMD_CORE_0_MODE_FIELD_WIDTH 16
#define MISC_1_PMD_CORE_0_MODE_FIELD_SHIFT 0

extern const ru_field_rec MISC_1_PMD_CORE_1_MODE_FIELD;
#define MISC_1_PMD_CORE_1_MODE_FIELD_MASK  0x00000000ffff0000
#define MISC_1_PMD_CORE_1_MODE_FIELD_WIDTH 16
#define MISC_1_PMD_CORE_1_MODE_FIELD_SHIFT 16

extern const ru_field_rec MISC_2_PMD_RX_MODE_FIELD;
#define MISC_2_PMD_RX_MODE_FIELD_MASK  0x0000000000000001
#define MISC_2_PMD_RX_MODE_FIELD_WIDTH 1
#define MISC_2_PMD_RX_MODE_FIELD_SHIFT 0

extern const ru_field_rec MISC_2_PMD_LN_DP_H_RSTB_FIELD;
#define MISC_2_PMD_LN_DP_H_RSTB_FIELD_MASK  0x0000000000000002
#define MISC_2_PMD_LN_DP_H_RSTB_FIELD_WIDTH 1
#define MISC_2_PMD_LN_DP_H_RSTB_FIELD_SHIFT 1

extern const ru_field_rec MISC_2_PMD_LN_H_RSTB_FIELD;
#define MISC_2_PMD_LN_H_RSTB_FIELD_MASK  0x0000000000000004
#define MISC_2_PMD_LN_H_RSTB_FIELD_WIDTH 1
#define MISC_2_PMD_LN_H_RSTB_FIELD_SHIFT 2

extern const ru_field_rec MISC_2_PMD_CORE_0_DP_H_RSTB_FIELD;
#define MISC_2_PMD_CORE_0_DP_H_RSTB_FIELD_MASK  0x0000000000000008
#define MISC_2_PMD_CORE_0_DP_H_RSTB_FIELD_WIDTH 1
#define MISC_2_PMD_CORE_0_DP_H_RSTB_FIELD_SHIFT 3

extern const ru_field_rec MISC_2_PMD_CORE_1_DP_H_RSTB_FIELD;
#define MISC_2_PMD_CORE_1_DP_H_RSTB_FIELD_MASK  0x0000000000000010
#define MISC_2_PMD_CORE_1_DP_H_RSTB_FIELD_WIDTH 1
#define MISC_2_PMD_CORE_1_DP_H_RSTB_FIELD_SHIFT 4

extern const ru_field_rec MISC_2_PMD_POR_H_RSTB_FIELD;
#define MISC_2_PMD_POR_H_RSTB_FIELD_MASK  0x0000000000000020
#define MISC_2_PMD_POR_H_RSTB_FIELD_WIDTH 1
#define MISC_2_PMD_POR_H_RSTB_FIELD_SHIFT 5

extern const ru_field_rec MISC_2_PMD_EXT_LOS_FIELD;
#define MISC_2_PMD_EXT_LOS_FIELD_MASK  0x0000000000000040
#define MISC_2_PMD_EXT_LOS_FIELD_WIDTH 1
#define MISC_2_PMD_EXT_LOS_FIELD_SHIFT 6

extern const ru_field_rec MISC_2_PMD_LN_TX_H_PWRDN_FIELD;
#define MISC_2_PMD_LN_TX_H_PWRDN_FIELD_MASK  0x0000000000000080
#define MISC_2_PMD_LN_TX_H_PWRDN_FIELD_WIDTH 1
#define MISC_2_PMD_LN_TX_H_PWRDN_FIELD_SHIFT 7

extern const ru_field_rec MISC_2_PMD_LN_RX_H_PWRDN_FIELD;
#define MISC_2_PMD_LN_RX_H_PWRDN_FIELD_MASK  0x0000000000000100
#define MISC_2_PMD_LN_RX_H_PWRDN_FIELD_WIDTH 1
#define MISC_2_PMD_LN_RX_H_PWRDN_FIELD_SHIFT 8

extern const ru_field_rec MISC_2_PMD_TX_DISABLE_FIELD;
#define MISC_2_PMD_TX_DISABLE_FIELD_MASK  0x0000000000000200
#define MISC_2_PMD_TX_DISABLE_FIELD_WIDTH 1
#define MISC_2_PMD_TX_DISABLE_FIELD_SHIFT 9

extern const ru_field_rec MISC_2_RESERVED0_FIELD;
#define MISC_2_RESERVED0_FIELD_MASK  0x0000000000000c00
#define MISC_2_RESERVED0_FIELD_WIDTH 2
#define MISC_2_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec MISC_2_PMD_TX_OSR_MODE_FIELD;
#define MISC_2_PMD_TX_OSR_MODE_FIELD_MASK  0x000000000000f000
#define MISC_2_PMD_TX_OSR_MODE_FIELD_WIDTH 4
#define MISC_2_PMD_TX_OSR_MODE_FIELD_SHIFT 12

extern const ru_field_rec MISC_2_PMD_TX_MODE_FIELD;
#define MISC_2_PMD_TX_MODE_FIELD_MASK  0x0000000000030000
#define MISC_2_PMD_TX_MODE_FIELD_WIDTH 2
#define MISC_2_PMD_TX_MODE_FIELD_SHIFT 16

extern const ru_field_rec MISC_2_RESERVED1_FIELD;
#define MISC_2_RESERVED1_FIELD_MASK  0x00000000000c0000
#define MISC_2_RESERVED1_FIELD_WIDTH 2
#define MISC_2_RESERVED1_FIELD_SHIFT 18

extern const ru_field_rec MISC_2_PMD_RX_OSR_MODE_FIELD;
#define MISC_2_PMD_RX_OSR_MODE_FIELD_MASK  0x0000000000f00000
#define MISC_2_PMD_RX_OSR_MODE_FIELD_WIDTH 4
#define MISC_2_PMD_RX_OSR_MODE_FIELD_SHIFT 20

extern const ru_field_rec MISC_2_CFGACTIVEETHERNET2P5_FIELD;
#define MISC_2_CFGACTIVEETHERNET2P5_FIELD_MASK  0x0000000001000000
#define MISC_2_CFGACTIVEETHERNET2P5_FIELD_WIDTH 1
#define MISC_2_CFGACTIVEETHERNET2P5_FIELD_SHIFT 24

extern const ru_field_rec MISC_2_CFGNGPONTXCLK_FIELD;
#define MISC_2_CFGNGPONTXCLK_FIELD_MASK  0x0000000006000000
#define MISC_2_CFGNGPONTXCLK_FIELD_WIDTH 2
#define MISC_2_CFGNGPONTXCLK_FIELD_SHIFT 25

extern const ru_field_rec MISC_2_CFGNGPONRXCLK_FIELD;
#define MISC_2_CFGNGPONRXCLK_FIELD_MASK  0x0000000018000000
#define MISC_2_CFGNGPONRXCLK_FIELD_WIDTH 2
#define MISC_2_CFGNGPONRXCLK_FIELD_SHIFT 27

extern const ru_field_rec MISC_2_CFG_APM_MUX_SEL_0_FIELD;
#define MISC_2_CFG_APM_MUX_SEL_0_FIELD_MASK  0x0000000020000000
#define MISC_2_CFG_APM_MUX_SEL_0_FIELD_WIDTH 1
#define MISC_2_CFG_APM_MUX_SEL_0_FIELD_SHIFT 29

extern const ru_field_rec MISC_2_CFG_APM_MUX_SEL_1_FIELD;
#define MISC_2_CFG_APM_MUX_SEL_1_FIELD_MASK  0x0000000040000000
#define MISC_2_CFG_APM_MUX_SEL_1_FIELD_WIDTH 1
#define MISC_2_CFG_APM_MUX_SEL_1_FIELD_SHIFT 30

extern const ru_field_rec MISC_2_RESERVED2_FIELD;
#define MISC_2_RESERVED2_FIELD_MASK  0x0000000080000000
#define MISC_2_RESERVED2_FIELD_WIDTH 1
#define MISC_2_RESERVED2_FIELD_SHIFT 31

extern const ru_field_rec MISC_3_MEM_REB_FIELD;
#define MISC_3_MEM_REB_FIELD_MASK  0x0000000000000001
#define MISC_3_MEM_REB_FIELD_WIDTH 1
#define MISC_3_MEM_REB_FIELD_SHIFT 0

extern const ru_field_rec MISC_3_LASER_INVERT_FIELD;
#define MISC_3_LASER_INVERT_FIELD_MASK  0x0000000000000002
#define MISC_3_LASER_INVERT_FIELD_WIDTH 1
#define MISC_3_LASER_INVERT_FIELD_SHIFT 1

extern const ru_field_rec MISC_3_LASER_MODE_FIELD;
#define MISC_3_LASER_MODE_FIELD_MASK  0x000000000000001c
#define MISC_3_LASER_MODE_FIELD_WIDTH 3
#define MISC_3_LASER_MODE_FIELD_SHIFT 2

extern const ru_field_rec MISC_3_RESERVED0_FIELD;
#define MISC_3_RESERVED0_FIELD_MASK  0x0000000000000020
#define MISC_3_RESERVED0_FIELD_WIDTH 1
#define MISC_3_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec MISC_3_WAN_INTERFACE_SELECT_FIELD;
#define MISC_3_WAN_INTERFACE_SELECT_FIELD_MASK  0x0000000000000040
#define MISC_3_WAN_INTERFACE_SELECT_FIELD_WIDTH 1
#define MISC_3_WAN_INTERFACE_SELECT_FIELD_SHIFT 6

extern const ru_field_rec MISC_3_LASER_OE_FIELD;
#define MISC_3_LASER_OE_FIELD_MASK  0x0000000000000080
#define MISC_3_LASER_OE_FIELD_WIDTH 1
#define MISC_3_LASER_OE_FIELD_SHIFT 7

extern const ru_field_rec MISC_3_NTR_SYNC_PERIOD_SEL_FIELD;
#define MISC_3_NTR_SYNC_PERIOD_SEL_FIELD_MASK  0x0000000000000f00
#define MISC_3_NTR_SYNC_PERIOD_SEL_FIELD_WIDTH 4
#define MISC_3_NTR_SYNC_PERIOD_SEL_FIELD_SHIFT 8

extern const ru_field_rec MISC_3_WAN_DEBUG_SEL_FIELD;
#define MISC_3_WAN_DEBUG_SEL_FIELD_MASK  0x000000000000f000
#define MISC_3_WAN_DEBUG_SEL_FIELD_WIDTH 4
#define MISC_3_WAN_DEBUG_SEL_FIELD_SHIFT 12

extern const ru_field_rec MISC_3_EPON_DEBUG_SEL_FIELD;
#define MISC_3_EPON_DEBUG_SEL_FIELD_MASK  0x0000000000ff0000
#define MISC_3_EPON_DEBUG_SEL_FIELD_WIDTH 8
#define MISC_3_EPON_DEBUG_SEL_FIELD_SHIFT 16

extern const ru_field_rec MISC_3_EPON_TX_FIFO_OFF_FIELD;
#define MISC_3_EPON_TX_FIFO_OFF_FIELD_MASK  0x000000003f000000
#define MISC_3_EPON_TX_FIFO_OFF_FIELD_WIDTH 6
#define MISC_3_EPON_TX_FIFO_OFF_FIELD_SHIFT 24

extern const ru_field_rec MISC_3_RESERVED1_FIELD;
#define MISC_3_RESERVED1_FIELD_MASK  0x00000000c0000000
#define MISC_3_RESERVED1_FIELD_WIDTH 2
#define MISC_3_RESERVED1_FIELD_SHIFT 30

extern const ru_field_rec PMI_LP_0_PMI_LP_WRITE_FIELD;
#define PMI_LP_0_PMI_LP_WRITE_FIELD_MASK  0x0000000000000001
#define PMI_LP_0_PMI_LP_WRITE_FIELD_WIDTH 1
#define PMI_LP_0_PMI_LP_WRITE_FIELD_SHIFT 0

extern const ru_field_rec PMI_LP_0_PMI_LP_EN_FIELD;
#define PMI_LP_0_PMI_LP_EN_FIELD_MASK  0x0000000000000002
#define PMI_LP_0_PMI_LP_EN_FIELD_WIDTH 1
#define PMI_LP_0_PMI_LP_EN_FIELD_SHIFT 1

extern const ru_field_rec PMI_LP_0_RESERVED0_FIELD;
#define PMI_LP_0_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define PMI_LP_0_RESERVED0_FIELD_WIDTH 30
#define PMI_LP_0_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec PMI_LP_1_PMI_LP_ADDR_FIELD;
#define PMI_LP_1_PMI_LP_ADDR_FIELD_MASK  0x00000000ffffffff
#define PMI_LP_1_PMI_LP_ADDR_FIELD_WIDTH 32
#define PMI_LP_1_PMI_LP_ADDR_FIELD_SHIFT 0

extern const ru_field_rec PMI_LP_2_PMI_LP_MASKDATA_FIELD;
#define PMI_LP_2_PMI_LP_MASKDATA_FIELD_MASK  0x000000000000ffff
#define PMI_LP_2_PMI_LP_MASKDATA_FIELD_WIDTH 16
#define PMI_LP_2_PMI_LP_MASKDATA_FIELD_SHIFT 0

extern const ru_field_rec PMI_LP_2_PMI_LP_WRDATA_FIELD;
#define PMI_LP_2_PMI_LP_WRDATA_FIELD_MASK  0x00000000ffff0000
#define PMI_LP_2_PMI_LP_WRDATA_FIELD_WIDTH 16
#define PMI_LP_2_PMI_LP_WRDATA_FIELD_SHIFT 16

extern const ru_field_rec PMI_LP_3_PMI_LP_RDDATA_FIELD;
#define PMI_LP_3_PMI_LP_RDDATA_FIELD_MASK  0x000000000000ffff
#define PMI_LP_3_PMI_LP_RDDATA_FIELD_WIDTH 16
#define PMI_LP_3_PMI_LP_RDDATA_FIELD_SHIFT 0

extern const ru_field_rec PMI_LP_3_PMI_LP_ACK_FIELD;
#define PMI_LP_3_PMI_LP_ACK_FIELD_MASK  0x0000000000010000
#define PMI_LP_3_PMI_LP_ACK_FIELD_WIDTH 1
#define PMI_LP_3_PMI_LP_ACK_FIELD_SHIFT 16

extern const ru_field_rec PMI_LP_3_PMI_LP_ERR_FIELD;
#define PMI_LP_3_PMI_LP_ERR_FIELD_MASK  0x0000000000020000
#define PMI_LP_3_PMI_LP_ERR_FIELD_WIDTH 1
#define PMI_LP_3_PMI_LP_ERR_FIELD_SHIFT 17

extern const ru_field_rec PMI_LP_3_RESERVED0_FIELD;
#define PMI_LP_3_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define PMI_LP_3_RESERVED0_FIELD_WIDTH 14
#define PMI_LP_3_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec TOD_CONFIG_0_TS48_MAC_SELECT_FIELD;
#define TOD_CONFIG_0_TS48_MAC_SELECT_FIELD_MASK  0x0000000000000007
#define TOD_CONFIG_0_TS48_MAC_SELECT_FIELD_WIDTH 3
#define TOD_CONFIG_0_TS48_MAC_SELECT_FIELD_SHIFT 0

extern const ru_field_rec TOD_CONFIG_0_TS48_ENABLE_FIELD;
#define TOD_CONFIG_0_TS48_ENABLE_FIELD_MASK  0x0000000000000008
#define TOD_CONFIG_0_TS48_ENABLE_FIELD_WIDTH 1
#define TOD_CONFIG_0_TS48_ENABLE_FIELD_SHIFT 3

extern const ru_field_rec TOD_CONFIG_0_TS48_OFFSET_FIELD;
#define TOD_CONFIG_0_TS48_OFFSET_FIELD_MASK  0x0000000000003ff0
#define TOD_CONFIG_0_TS48_OFFSET_FIELD_WIDTH 10
#define TOD_CONFIG_0_TS48_OFFSET_FIELD_SHIFT 4

extern const ru_field_rec TOD_CONFIG_0_TS48_READ_FIELD;
#define TOD_CONFIG_0_TS48_READ_FIELD_MASK  0x0000000000004000
#define TOD_CONFIG_0_TS48_READ_FIELD_WIDTH 1
#define TOD_CONFIG_0_TS48_READ_FIELD_SHIFT 14

extern const ru_field_rec TOD_CONFIG_0_RESERVED0_FIELD;
#define TOD_CONFIG_0_RESERVED0_FIELD_MASK  0x00000000ffff8000
#define TOD_CONFIG_0_RESERVED0_FIELD_WIDTH 17
#define TOD_CONFIG_0_RESERVED0_FIELD_SHIFT 15

extern const ru_field_rec TOD_MSB_TS48_WAN_READ_MSB_FIELD;
#define TOD_MSB_TS48_WAN_READ_MSB_FIELD_MASK  0x000000000000ffff
#define TOD_MSB_TS48_WAN_READ_MSB_FIELD_WIDTH 16
#define TOD_MSB_TS48_WAN_READ_MSB_FIELD_SHIFT 0

extern const ru_field_rec TOD_MSB_RESERVED0_FIELD;
#define TOD_MSB_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define TOD_MSB_RESERVED0_FIELD_WIDTH 16
#define TOD_MSB_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec TOD_LSB_TS48_WAN_READ_LSB_FIELD;
#define TOD_LSB_TS48_WAN_READ_LSB_FIELD_MASK  0x00000000ffffffff
#define TOD_LSB_TS48_WAN_READ_LSB_FIELD_WIDTH 32
#define TOD_LSB_TS48_WAN_READ_LSB_FIELD_SHIFT 0

extern const ru_field_rec TOD_CONFIG_2_RX_OFFSET_FIELD;
#define TOD_CONFIG_2_RX_OFFSET_FIELD_MASK  0x00000000000003ff
#define TOD_CONFIG_2_RX_OFFSET_FIELD_WIDTH 10
#define TOD_CONFIG_2_RX_OFFSET_FIELD_SHIFT 0

extern const ru_field_rec TOD_CONFIG_2_RESERVED0_FIELD;
#define TOD_CONFIG_2_RESERVED0_FIELD_MASK  0x000000000000fc00
#define TOD_CONFIG_2_RESERVED0_FIELD_WIDTH 6
#define TOD_CONFIG_2_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec TOD_CONFIG_2_TX_OFFSET_FIELD;
#define TOD_CONFIG_2_TX_OFFSET_FIELD_MASK  0x0000000003ff0000
#define TOD_CONFIG_2_TX_OFFSET_FIELD_WIDTH 10
#define TOD_CONFIG_2_TX_OFFSET_FIELD_SHIFT 16

extern const ru_field_rec TOD_CONFIG_2_RESERVED1_FIELD;
#define TOD_CONFIG_2_RESERVED1_FIELD_MASK  0x00000000fc000000
#define TOD_CONFIG_2_RESERVED1_FIELD_WIDTH 6
#define TOD_CONFIG_2_RESERVED1_FIELD_SHIFT 26

extern const ru_field_rec TOD_CONFIG_3_REF_OFFSET_FIELD;
#define TOD_CONFIG_3_REF_OFFSET_FIELD_MASK  0x00000000000003ff
#define TOD_CONFIG_3_REF_OFFSET_FIELD_WIDTH 10
#define TOD_CONFIG_3_REF_OFFSET_FIELD_SHIFT 0

extern const ru_field_rec TOD_CONFIG_3_RESERVED0_FIELD;
#define TOD_CONFIG_3_RESERVED0_FIELD_MASK  0x0000000000fffc00
#define TOD_CONFIG_3_RESERVED0_FIELD_WIDTH 14
#define TOD_CONFIG_3_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec TOD_CONFIG_3_TS48_FIFO_LD_RATE_FIELD;
#define TOD_CONFIG_3_TS48_FIFO_LD_RATE_FIELD_MASK  0x000000001f000000
#define TOD_CONFIG_3_TS48_FIFO_LD_RATE_FIELD_WIDTH 5
#define TOD_CONFIG_3_TS48_FIFO_LD_RATE_FIELD_SHIFT 24

extern const ru_field_rec TOD_CONFIG_3_RESERVED1_FIELD;
#define TOD_CONFIG_3_RESERVED1_FIELD_MASK  0x0000000060000000
#define TOD_CONFIG_3_RESERVED1_FIELD_WIDTH 2
#define TOD_CONFIG_3_RESERVED1_FIELD_SHIFT 29

extern const ru_field_rec TOD_CONFIG_3_TS48_FIFO_DIS_FIELD;
#define TOD_CONFIG_3_TS48_FIFO_DIS_FIELD_MASK  0x0000000080000000
#define TOD_CONFIG_3_TS48_FIFO_DIS_FIELD_WIDTH 1
#define TOD_CONFIG_3_TS48_FIFO_DIS_FIELD_SHIFT 31

extern const ru_field_rec TOD_STATUS_0_TS16_RX_READ_FIELD;
#define TOD_STATUS_0_TS16_RX_READ_FIELD_MASK  0x000000000000ffff
#define TOD_STATUS_0_TS16_RX_READ_FIELD_WIDTH 16
#define TOD_STATUS_0_TS16_RX_READ_FIELD_SHIFT 0

extern const ru_field_rec TOD_STATUS_0_TS16_TX_READ_FIELD;
#define TOD_STATUS_0_TS16_TX_READ_FIELD_MASK  0x00000000ffff0000
#define TOD_STATUS_0_TS16_TX_READ_FIELD_WIDTH 16
#define TOD_STATUS_0_TS16_TX_READ_FIELD_SHIFT 16

extern const ru_field_rec TOD_STATUS_1_TS16_REF_SYNCE_READ_FIELD;
#define TOD_STATUS_1_TS16_REF_SYNCE_READ_FIELD_MASK  0x000000000000ffff
#define TOD_STATUS_1_TS16_REF_SYNCE_READ_FIELD_WIDTH 16
#define TOD_STATUS_1_TS16_REF_SYNCE_READ_FIELD_SHIFT 0

extern const ru_field_rec TOD_STATUS_1_TS16_RX_SYNCE_READ_FIELD;
#define TOD_STATUS_1_TS16_RX_SYNCE_READ_FIELD_MASK  0x00000000ffff0000
#define TOD_STATUS_1_TS16_RX_SYNCE_READ_FIELD_WIDTH 16
#define TOD_STATUS_1_TS16_RX_SYNCE_READ_FIELD_SHIFT 16

extern const ru_field_rec TOD_STATUS_2_TS16_MAC_RX_READ_FIELD;
#define TOD_STATUS_2_TS16_MAC_RX_READ_FIELD_MASK  0x000000000000ffff
#define TOD_STATUS_2_TS16_MAC_RX_READ_FIELD_WIDTH 16
#define TOD_STATUS_2_TS16_MAC_RX_READ_FIELD_SHIFT 0

extern const ru_field_rec TOD_STATUS_2_TS16_MAC_TX_READ_FIELD;
#define TOD_STATUS_2_TS16_MAC_TX_READ_FIELD_MASK  0x00000000ffff0000
#define TOD_STATUS_2_TS16_MAC_TX_READ_FIELD_WIDTH 16
#define TOD_STATUS_2_TS16_MAC_TX_READ_FIELD_SHIFT 16

extern const ru_field_rec WAN_SERDES_STATUS_PMD_PLL0_LOCK_FIELD;
#define WAN_SERDES_STATUS_PMD_PLL0_LOCK_FIELD_MASK  0x0000000000000001
#define WAN_SERDES_STATUS_PMD_PLL0_LOCK_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_PMD_PLL0_LOCK_FIELD_SHIFT 0

extern const ru_field_rec WAN_SERDES_STATUS_PMD_RX_LOCK_0_INVERT_FIELD;
#define WAN_SERDES_STATUS_PMD_RX_LOCK_0_INVERT_FIELD_MASK  0x0000000000000002
#define WAN_SERDES_STATUS_PMD_RX_LOCK_0_INVERT_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_PMD_RX_LOCK_0_INVERT_FIELD_SHIFT 1

extern const ru_field_rec WAN_SERDES_STATUS_PMD_RX_CLK_VLD_0_FIELD;
#define WAN_SERDES_STATUS_PMD_RX_CLK_VLD_0_FIELD_MASK  0x0000000000000004
#define WAN_SERDES_STATUS_PMD_RX_CLK_VLD_0_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_PMD_RX_CLK_VLD_0_FIELD_SHIFT 2

extern const ru_field_rec WAN_SERDES_STATUS_PMD_TX_CLK_VLD_FIELD;
#define WAN_SERDES_STATUS_PMD_TX_CLK_VLD_FIELD_MASK  0x0000000000000008
#define WAN_SERDES_STATUS_PMD_TX_CLK_VLD_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_PMD_TX_CLK_VLD_FIELD_SHIFT 3

extern const ru_field_rec WAN_SERDES_STATUS_PMD_RX_LOCK_0_FIELD;
#define WAN_SERDES_STATUS_PMD_RX_LOCK_0_FIELD_MASK  0x0000000000000010
#define WAN_SERDES_STATUS_PMD_RX_LOCK_0_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_PMD_RX_LOCK_0_FIELD_SHIFT 4

extern const ru_field_rec WAN_SERDES_STATUS_PMD_ENERGY_DETECT_0_FIELD;
#define WAN_SERDES_STATUS_PMD_ENERGY_DETECT_0_FIELD_MASK  0x0000000000000020
#define WAN_SERDES_STATUS_PMD_ENERGY_DETECT_0_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_PMD_ENERGY_DETECT_0_FIELD_SHIFT 5

extern const ru_field_rec WAN_SERDES_STATUS_PMD_SIGNAL_DETECT_0_FIELD;
#define WAN_SERDES_STATUS_PMD_SIGNAL_DETECT_0_FIELD_MASK  0x0000000000000040
#define WAN_SERDES_STATUS_PMD_SIGNAL_DETECT_0_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_PMD_SIGNAL_DETECT_0_FIELD_SHIFT 6

extern const ru_field_rec WAN_SERDES_STATUS_PMI_LP_ACKNOWLEDGE_FIELD;
#define WAN_SERDES_STATUS_PMI_LP_ACKNOWLEDGE_FIELD_MASK  0x0000000000000080
#define WAN_SERDES_STATUS_PMI_LP_ACKNOWLEDGE_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_PMI_LP_ACKNOWLEDGE_FIELD_SHIFT 7

extern const ru_field_rec WAN_SERDES_STATUS_PMI_LP_ERROR_FIELD;
#define WAN_SERDES_STATUS_PMI_LP_ERROR_FIELD_MASK  0x0000000000000100
#define WAN_SERDES_STATUS_PMI_LP_ERROR_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_PMI_LP_ERROR_FIELD_SHIFT 8

extern const ru_field_rec WAN_SERDES_STATUS_O_LASER_BURST_EN_FIELD;
#define WAN_SERDES_STATUS_O_LASER_BURST_EN_FIELD_MASK  0x0000000000000200
#define WAN_SERDES_STATUS_O_LASER_BURST_EN_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_O_LASER_BURST_EN_FIELD_SHIFT 9

extern const ru_field_rec WAN_SERDES_STATUS_PMD_PLL1_LOCK_FIELD;
#define WAN_SERDES_STATUS_PMD_PLL1_LOCK_FIELD_MASK  0x0000000000000400
#define WAN_SERDES_STATUS_PMD_PLL1_LOCK_FIELD_WIDTH 1
#define WAN_SERDES_STATUS_PMD_PLL1_LOCK_FIELD_SHIFT 10

extern const ru_field_rec WAN_SERDES_STATUS_RESERVED0_FIELD;
#define WAN_SERDES_STATUS_RESERVED0_FIELD_MASK  0x00000000fffff800
#define WAN_SERDES_STATUS_RESERVED0_FIELD_WIDTH 21
#define WAN_SERDES_STATUS_RESERVED0_FIELD_SHIFT 11

extern const ru_field_rec GPON_GEARBOX_0_SW_RESET_TXPG_RESET_FIELD;
#define GPON_GEARBOX_0_SW_RESET_TXPG_RESET_FIELD_MASK  0x0000000000000001
#define GPON_GEARBOX_0_SW_RESET_TXPG_RESET_FIELD_WIDTH 1
#define GPON_GEARBOX_0_SW_RESET_TXPG_RESET_FIELD_SHIFT 0

extern const ru_field_rec GPON_GEARBOX_0_SW_RESET_TXFIFO_RESET_FIELD;
#define GPON_GEARBOX_0_SW_RESET_TXFIFO_RESET_FIELD_MASK  0x0000000000000002
#define GPON_GEARBOX_0_SW_RESET_TXFIFO_RESET_FIELD_WIDTH 1
#define GPON_GEARBOX_0_SW_RESET_TXFIFO_RESET_FIELD_SHIFT 1

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_CLEAR_TXFIFO_DRIFTED_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_CLEAR_TXFIFO_DRIFTED_FIELD_MASK  0x0000000000000004
#define GPON_GEARBOX_0_FIFO_CFG_0_CLEAR_TXFIFO_DRIFTED_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_CLEAR_TXFIFO_DRIFTED_FIELD_SHIFT 2

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_LOOPBACK_RX_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_LOOPBACK_RX_FIELD_MASK  0x0000000000000008
#define GPON_GEARBOX_0_FIFO_CFG_0_LOOPBACK_RX_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_LOOPBACK_RX_FIELD_SHIFT 3

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_CLEAR_TXFIFO_COLLISION_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_CLEAR_TXFIFO_COLLISION_FIELD_MASK  0x0000000000000010
#define GPON_GEARBOX_0_FIFO_CFG_0_CLEAR_TXFIFO_COLLISION_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_CLEAR_TXFIFO_COLLISION_FIELD_SHIFT 4

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_TX_WR_PTR_ADV_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_WR_PTR_ADV_FIELD_MASK  0x0000000000000020
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_WR_PTR_ADV_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_WR_PTR_ADV_FIELD_SHIFT 5

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_TX_WR_PTR_DLY_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_WR_PTR_DLY_FIELD_MASK  0x0000000000000040
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_WR_PTR_DLY_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_WR_PTR_DLY_FIELD_SHIFT 6

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_TX_BIT_INV_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_BIT_INV_FIELD_MASK  0x0000000000000080
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_BIT_INV_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_BIT_INV_FIELD_SHIFT 7

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_TX_PTR_DIST_MAX_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_PTR_DIST_MAX_FIELD_MASK  0x0000000000001f00
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_PTR_DIST_MAX_FIELD_WIDTH 5
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_PTR_DIST_MAX_FIELD_SHIFT 8

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_ASYM_LOOPBACK_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_ASYM_LOOPBACK_FIELD_MASK  0x0000000000002000
#define GPON_GEARBOX_0_FIFO_CFG_0_ASYM_LOOPBACK_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_ASYM_LOOPBACK_FIELD_SHIFT 13

extern const ru_field_rec GPON_GEARBOX_0_RESERVED0_FIELD;
#define GPON_GEARBOX_0_RESERVED0_FIELD_MASK  0x000000000000c000
#define GPON_GEARBOX_0_RESERVED0_FIELD_WIDTH 2
#define GPON_GEARBOX_0_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_TX_PTR_DIST_MIN_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_PTR_DIST_MIN_FIELD_MASK  0x00000000001f0000
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_PTR_DIST_MIN_FIELD_WIDTH 5
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_PTR_DIST_MIN_FIELD_SHIFT 16

extern const ru_field_rec GPON_GEARBOX_0_RESERVED1_FIELD;
#define GPON_GEARBOX_0_RESERVED1_FIELD_MASK  0x0000000000e00000
#define GPON_GEARBOX_0_RESERVED1_FIELD_WIDTH 3
#define GPON_GEARBOX_0_RESERVED1_FIELD_SHIFT 21

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_TX_20BIT_ORDER_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_20BIT_ORDER_FIELD_MASK  0x0000000001000000
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_20BIT_ORDER_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_20BIT_ORDER_FIELD_SHIFT 24

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_TX_8BIT_ORDER_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_8BIT_ORDER_FIELD_MASK  0x0000000002000000
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_8BIT_ORDER_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_TX_8BIT_ORDER_FIELD_SHIFT 25

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_RX_16BIT_ORDER_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_RX_16BIT_ORDER_FIELD_MASK  0x0000000004000000
#define GPON_GEARBOX_0_FIFO_CFG_0_RX_16BIT_ORDER_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_RX_16BIT_ORDER_FIELD_SHIFT 26

extern const ru_field_rec GPON_GEARBOX_0_FIFO_CFG_0_TXLBE_BIT_ORDER_FIELD;
#define GPON_GEARBOX_0_FIFO_CFG_0_TXLBE_BIT_ORDER_FIELD_MASK  0x0000000008000000
#define GPON_GEARBOX_0_FIFO_CFG_0_TXLBE_BIT_ORDER_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_CFG_0_TXLBE_BIT_ORDER_FIELD_SHIFT 27

extern const ru_field_rec GPON_GEARBOX_0_FIFO_STATUS_SEL_FIELD;
#define GPON_GEARBOX_0_FIFO_STATUS_SEL_FIELD_MASK  0x0000000010000000
#define GPON_GEARBOX_0_FIFO_STATUS_SEL_FIELD_WIDTH 1
#define GPON_GEARBOX_0_FIFO_STATUS_SEL_FIELD_SHIFT 28

extern const ru_field_rec GPON_GEARBOX_0_PTG_STATUS1_SEL_FIELD;
#define GPON_GEARBOX_0_PTG_STATUS1_SEL_FIELD_MASK  0x0000000020000000
#define GPON_GEARBOX_0_PTG_STATUS1_SEL_FIELD_WIDTH 1
#define GPON_GEARBOX_0_PTG_STATUS1_SEL_FIELD_SHIFT 29

extern const ru_field_rec GPON_GEARBOX_0_PTG_STATUS2_SEL_FIELD;
#define GPON_GEARBOX_0_PTG_STATUS2_SEL_FIELD_MASK  0x0000000040000000
#define GPON_GEARBOX_0_PTG_STATUS2_SEL_FIELD_WIDTH 1
#define GPON_GEARBOX_0_PTG_STATUS2_SEL_FIELD_SHIFT 30

extern const ru_field_rec GPON_GEARBOX_0_RESERVED2_FIELD;
#define GPON_GEARBOX_0_RESERVED2_FIELD_MASK  0x0000000080000000
#define GPON_GEARBOX_0_RESERVED2_FIELD_WIDTH 1
#define GPON_GEARBOX_0_RESERVED2_FIELD_SHIFT 31

extern const ru_field_rec GPON_GEARBOX_PATTERN_CFG1_PG_MODE_FIELD;
#define GPON_GEARBOX_PATTERN_CFG1_PG_MODE_FIELD_MASK  0x0000000000000007
#define GPON_GEARBOX_PATTERN_CFG1_PG_MODE_FIELD_WIDTH 3
#define GPON_GEARBOX_PATTERN_CFG1_PG_MODE_FIELD_SHIFT 0

extern const ru_field_rec GPON_GEARBOX_PATTERN_CFG1_RESERVED0_FIELD;
#define GPON_GEARBOX_PATTERN_CFG1_RESERVED0_FIELD_MASK  0x00000000000000f8
#define GPON_GEARBOX_PATTERN_CFG1_RESERVED0_FIELD_WIDTH 5
#define GPON_GEARBOX_PATTERN_CFG1_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec GPON_GEARBOX_PATTERN_CFG1_HEADER_FIELD;
#define GPON_GEARBOX_PATTERN_CFG1_HEADER_FIELD_MASK  0x000000000000ff00
#define GPON_GEARBOX_PATTERN_CFG1_HEADER_FIELD_WIDTH 8
#define GPON_GEARBOX_PATTERN_CFG1_HEADER_FIELD_SHIFT 8

extern const ru_field_rec GPON_GEARBOX_PATTERN_CFG1_PAYLOAD_FIELD;
#define GPON_GEARBOX_PATTERN_CFG1_PAYLOAD_FIELD_MASK  0x0000000000ff0000
#define GPON_GEARBOX_PATTERN_CFG1_PAYLOAD_FIELD_WIDTH 8
#define GPON_GEARBOX_PATTERN_CFG1_PAYLOAD_FIELD_SHIFT 16

extern const ru_field_rec GPON_GEARBOX_PATTERN_CFG1_FILLER_FIELD;
#define GPON_GEARBOX_PATTERN_CFG1_FILLER_FIELD_MASK  0x00000000ff000000
#define GPON_GEARBOX_PATTERN_CFG1_FILLER_FIELD_WIDTH 8
#define GPON_GEARBOX_PATTERN_CFG1_FILLER_FIELD_SHIFT 24

extern const ru_field_rec GPON_GEARBOX_PATTERN_CFG2_BURST_SIZE_FIELD;
#define GPON_GEARBOX_PATTERN_CFG2_BURST_SIZE_FIELD_MASK  0x00000000000000ff
#define GPON_GEARBOX_PATTERN_CFG2_BURST_SIZE_FIELD_WIDTH 8
#define GPON_GEARBOX_PATTERN_CFG2_BURST_SIZE_FIELD_SHIFT 0

extern const ru_field_rec GPON_GEARBOX_PATTERN_CFG2_GAP_SIZE_FIELD;
#define GPON_GEARBOX_PATTERN_CFG2_GAP_SIZE_FIELD_MASK  0x000000000000ff00
#define GPON_GEARBOX_PATTERN_CFG2_GAP_SIZE_FIELD_WIDTH 8
#define GPON_GEARBOX_PATTERN_CFG2_GAP_SIZE_FIELD_SHIFT 8

extern const ru_field_rec GPON_GEARBOX_PATTERN_CFG2_RESERVED0_FIELD;
#define GPON_GEARBOX_PATTERN_CFG2_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define GPON_GEARBOX_PATTERN_CFG2_RESERVED0_FIELD_WIDTH 16
#define GPON_GEARBOX_PATTERN_CFG2_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec GPON_GEARBOX_2_RESERVED0_FIELD;
#define GPON_GEARBOX_2_RESERVED0_FIELD_MASK  0x00000000000000ff
#define GPON_GEARBOX_2_RESERVED0_FIELD_WIDTH 8
#define GPON_GEARBOX_2_RESERVED0_FIELD_SHIFT 0

extern const ru_field_rec GPON_GEARBOX_2_FIFO_CFG_1_TX_RD_POINTER_FIELD;
#define GPON_GEARBOX_2_FIFO_CFG_1_TX_RD_POINTER_FIELD_MASK  0x0000000000001f00
#define GPON_GEARBOX_2_FIFO_CFG_1_TX_RD_POINTER_FIELD_WIDTH 5
#define GPON_GEARBOX_2_FIFO_CFG_1_TX_RD_POINTER_FIELD_SHIFT 8

extern const ru_field_rec GPON_GEARBOX_2_RESERVED1_FIELD;
#define GPON_GEARBOX_2_RESERVED1_FIELD_MASK  0x000000000000e000
#define GPON_GEARBOX_2_RESERVED1_FIELD_WIDTH 3
#define GPON_GEARBOX_2_RESERVED1_FIELD_SHIFT 13

extern const ru_field_rec GPON_GEARBOX_2_FIFO_CFG_1_TX_WR_POINTER_FIELD;
#define GPON_GEARBOX_2_FIFO_CFG_1_TX_WR_POINTER_FIELD_MASK  0x00000000001f0000
#define GPON_GEARBOX_2_FIFO_CFG_1_TX_WR_POINTER_FIELD_WIDTH 5
#define GPON_GEARBOX_2_FIFO_CFG_1_TX_WR_POINTER_FIELD_SHIFT 16

extern const ru_field_rec GPON_GEARBOX_2_TX_VLD_DELAY_CYC_FIELD;
#define GPON_GEARBOX_2_TX_VLD_DELAY_CYC_FIELD_MASK  0x0000000000e00000
#define GPON_GEARBOX_2_TX_VLD_DELAY_CYC_FIELD_WIDTH 3
#define GPON_GEARBOX_2_TX_VLD_DELAY_CYC_FIELD_SHIFT 21

extern const ru_field_rec GPON_GEARBOX_2_CONFIG_BURST_DELAY_CYC_FIELD;
#define GPON_GEARBOX_2_CONFIG_BURST_DELAY_CYC_FIELD_MASK  0x000000000f000000
#define GPON_GEARBOX_2_CONFIG_BURST_DELAY_CYC_FIELD_WIDTH 4
#define GPON_GEARBOX_2_CONFIG_BURST_DELAY_CYC_FIELD_SHIFT 24

extern const ru_field_rec GPON_GEARBOX_2_RESERVED2_FIELD;
#define GPON_GEARBOX_2_RESERVED2_FIELD_MASK  0x00000000f0000000
#define GPON_GEARBOX_2_RESERVED2_FIELD_WIDTH 4
#define GPON_GEARBOX_2_RESERVED2_FIELD_SHIFT 28

extern const ru_field_rec GPON_GEARBOX_STATUS_CR_RD_DATA_CLX_FIELD;
#define GPON_GEARBOX_STATUS_CR_RD_DATA_CLX_FIELD_MASK  0x00000000ffffffff
#define GPON_GEARBOX_STATUS_CR_RD_DATA_CLX_FIELD_WIDTH 32
#define GPON_GEARBOX_STATUS_CR_RD_DATA_CLX_FIELD_SHIFT 0

extern const ru_field_rec FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_FIELD;
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_FIELD_MASK  0x0000000000000001
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_FIELD_WIDTH 1
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_FIELD_SHIFT 0

extern const ru_field_rec FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_VALUE_FIELD;
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_VALUE_FIELD_MASK  0x0000000000000002
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_VALUE_FIELD_WIDTH 1
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_VALUE_FIELD_SHIFT 1

extern const ru_field_rec FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_OE_FIELD;
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_OE_FIELD_MASK  0x0000000000000004
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_OE_FIELD_WIDTH 1
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_OE_FIELD_SHIFT 2

extern const ru_field_rec FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_OE_VALUE_FIELD;
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_OE_VALUE_FIELD_MASK  0x0000000000000008
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_OE_VALUE_FIELD_WIDTH 1
#define FORCE_LBE_CONTROL_L_CFG_FORCE_LBE_OE_VALUE_FIELD_SHIFT 3

extern const ru_field_rec FORCE_LBE_CONTROL_L_RESERVED0_FIELD;
#define FORCE_LBE_CONTROL_L_RESERVED0_FIELD_MASK  0x00000000fffffff0
#define FORCE_LBE_CONTROL_L_RESERVED0_FIELD_WIDTH 28
#define FORCE_LBE_CONTROL_L_RESERVED0_FIELD_SHIFT 4

extern const ru_field_rec PRBS_CHK_CTRL_0_EN_TIMER_MODE_FIELD;
#define PRBS_CHK_CTRL_0_EN_TIMER_MODE_FIELD_MASK  0x0000000000000003
#define PRBS_CHK_CTRL_0_EN_TIMER_MODE_FIELD_WIDTH 2
#define PRBS_CHK_CTRL_0_EN_TIMER_MODE_FIELD_SHIFT 0

extern const ru_field_rec PRBS_CHK_CTRL_0_EN_TIMEOUT_FIELD;
#define PRBS_CHK_CTRL_0_EN_TIMEOUT_FIELD_MASK  0x000000000000007c
#define PRBS_CHK_CTRL_0_EN_TIMEOUT_FIELD_WIDTH 5
#define PRBS_CHK_CTRL_0_EN_TIMEOUT_FIELD_SHIFT 2

extern const ru_field_rec PRBS_CHK_CTRL_0_RESERVED0_FIELD;
#define PRBS_CHK_CTRL_0_RESERVED0_FIELD_MASK  0x0000000000000380
#define PRBS_CHK_CTRL_0_RESERVED0_FIELD_WIDTH 3
#define PRBS_CHK_CTRL_0_RESERVED0_FIELD_SHIFT 7

extern const ru_field_rec PRBS_CHK_CTRL_0_MODE_SEL_FIELD;
#define PRBS_CHK_CTRL_0_MODE_SEL_FIELD_MASK  0x0000000000001c00
#define PRBS_CHK_CTRL_0_MODE_SEL_FIELD_WIDTH 3
#define PRBS_CHK_CTRL_0_MODE_SEL_FIELD_SHIFT 10

extern const ru_field_rec PRBS_CHK_CTRL_0_ERR_CNT_BURST_MODE_FIELD;
#define PRBS_CHK_CTRL_0_ERR_CNT_BURST_MODE_FIELD_MASK  0x0000000000002000
#define PRBS_CHK_CTRL_0_ERR_CNT_BURST_MODE_FIELD_WIDTH 1
#define PRBS_CHK_CTRL_0_ERR_CNT_BURST_MODE_FIELD_SHIFT 13

extern const ru_field_rec PRBS_CHK_CTRL_0_LOCK_CNT_FIELD;
#define PRBS_CHK_CTRL_0_LOCK_CNT_FIELD_MASK  0x000000000007c000
#define PRBS_CHK_CTRL_0_LOCK_CNT_FIELD_WIDTH 5
#define PRBS_CHK_CTRL_0_LOCK_CNT_FIELD_SHIFT 14

extern const ru_field_rec PRBS_CHK_CTRL_0_OOL_CNT_FIELD;
#define PRBS_CHK_CTRL_0_OOL_CNT_FIELD_MASK  0x0000000000f80000
#define PRBS_CHK_CTRL_0_OOL_CNT_FIELD_WIDTH 5
#define PRBS_CHK_CTRL_0_OOL_CNT_FIELD_SHIFT 19

extern const ru_field_rec PRBS_CHK_CTRL_0_INV_FIELD;
#define PRBS_CHK_CTRL_0_INV_FIELD_MASK  0x0000000001000000
#define PRBS_CHK_CTRL_0_INV_FIELD_WIDTH 1
#define PRBS_CHK_CTRL_0_INV_FIELD_SHIFT 24

extern const ru_field_rec PRBS_CHK_CTRL_0_SIG_PRBS_STATUS_CLR_FIELD;
#define PRBS_CHK_CTRL_0_SIG_PRBS_STATUS_CLR_FIELD_MASK  0x0000000002000000
#define PRBS_CHK_CTRL_0_SIG_PRBS_STATUS_CLR_FIELD_WIDTH 1
#define PRBS_CHK_CTRL_0_SIG_PRBS_STATUS_CLR_FIELD_SHIFT 25

extern const ru_field_rec PRBS_CHK_CTRL_0_RESERVED1_FIELD;
#define PRBS_CHK_CTRL_0_RESERVED1_FIELD_MASK  0x00000000fc000000
#define PRBS_CHK_CTRL_0_RESERVED1_FIELD_WIDTH 6
#define PRBS_CHK_CTRL_0_RESERVED1_FIELD_SHIFT 26

extern const ru_field_rec PRBS_CHK_CTRL_1_PRBS_TIMER_VAL_FIELD;
#define PRBS_CHK_CTRL_1_PRBS_TIMER_VAL_FIELD_MASK  0x00000000000fffff
#define PRBS_CHK_CTRL_1_PRBS_TIMER_VAL_FIELD_WIDTH 20
#define PRBS_CHK_CTRL_1_PRBS_TIMER_VAL_FIELD_SHIFT 0

extern const ru_field_rec PRBS_CHK_CTRL_1_RESERVED0_FIELD;
#define PRBS_CHK_CTRL_1_RESERVED0_FIELD_MASK  0x000000001ff00000
#define PRBS_CHK_CTRL_1_RESERVED0_FIELD_WIDTH 9
#define PRBS_CHK_CTRL_1_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec PRBS_CHK_CTRL_1_PRBS_CHK_MODE_FIELD;
#define PRBS_CHK_CTRL_1_PRBS_CHK_MODE_FIELD_MASK  0x0000000060000000
#define PRBS_CHK_CTRL_1_PRBS_CHK_MODE_FIELD_WIDTH 2
#define PRBS_CHK_CTRL_1_PRBS_CHK_MODE_FIELD_SHIFT 29

extern const ru_field_rec PRBS_CHK_CTRL_1_PRBS_CHK_EN_FIELD;
#define PRBS_CHK_CTRL_1_PRBS_CHK_EN_FIELD_MASK  0x0000000080000000
#define PRBS_CHK_CTRL_1_PRBS_CHK_EN_FIELD_WIDTH 1
#define PRBS_CHK_CTRL_1_PRBS_CHK_EN_FIELD_SHIFT 31

extern const ru_field_rec PRBS_STATUS_0_ERR_CNT_FIELD;
#define PRBS_STATUS_0_ERR_CNT_FIELD_MASK  0x000000007fffffff
#define PRBS_STATUS_0_ERR_CNT_FIELD_WIDTH 31
#define PRBS_STATUS_0_ERR_CNT_FIELD_SHIFT 0

extern const ru_field_rec PRBS_STATUS_0_LOCK_LOST_LH_FIELD;
#define PRBS_STATUS_0_LOCK_LOST_LH_FIELD_MASK  0x0000000080000000
#define PRBS_STATUS_0_LOCK_LOST_LH_FIELD_WIDTH 1
#define PRBS_STATUS_0_LOCK_LOST_LH_FIELD_SHIFT 31

extern const ru_field_rec PRBS_STATUS_1_LOCK_FIELD;
#define PRBS_STATUS_1_LOCK_FIELD_MASK  0x0000000000000001
#define PRBS_STATUS_1_LOCK_FIELD_WIDTH 1
#define PRBS_STATUS_1_LOCK_FIELD_SHIFT 0

extern const ru_field_rec PRBS_STATUS_1_ANY_ERR_FIELD;
#define PRBS_STATUS_1_ANY_ERR_FIELD_MASK  0x0000000000000002
#define PRBS_STATUS_1_ANY_ERR_FIELD_WIDTH 1
#define PRBS_STATUS_1_ANY_ERR_FIELD_SHIFT 1

extern const ru_field_rec PRBS_STATUS_1_RESERVED0_FIELD;
#define PRBS_STATUS_1_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define PRBS_STATUS_1_RESERVED0_FIELD_WIDTH 30
#define PRBS_STATUS_1_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec SERDES_STATUS_PLL_CTL_PLL0_REFIN_EN_FIELD;
#define SERDES_STATUS_PLL_CTL_PLL0_REFIN_EN_FIELD_MASK  0x0000000000000001
#define SERDES_STATUS_PLL_CTL_PLL0_REFIN_EN_FIELD_WIDTH 1
#define SERDES_STATUS_PLL_CTL_PLL0_REFIN_EN_FIELD_SHIFT 0

extern const ru_field_rec SERDES_STATUS_PLL_CTL_PLL0_REFOUT_EN_FIELD;
#define SERDES_STATUS_PLL_CTL_PLL0_REFOUT_EN_FIELD_MASK  0x0000000000000002
#define SERDES_STATUS_PLL_CTL_PLL0_REFOUT_EN_FIELD_WIDTH 1
#define SERDES_STATUS_PLL_CTL_PLL0_REFOUT_EN_FIELD_SHIFT 1

extern const ru_field_rec SERDES_STATUS_PLL_CTL_PLL0_LCREF_SEL_FIELD;
#define SERDES_STATUS_PLL_CTL_PLL0_LCREF_SEL_FIELD_MASK  0x0000000000000004
#define SERDES_STATUS_PLL_CTL_PLL0_LCREF_SEL_FIELD_WIDTH 1
#define SERDES_STATUS_PLL_CTL_PLL0_LCREF_SEL_FIELD_SHIFT 2

extern const ru_field_rec SERDES_STATUS_PLL_CTL_RESERVED0_FIELD;
#define SERDES_STATUS_PLL_CTL_RESERVED0_FIELD_MASK  0x00000000000000f8
#define SERDES_STATUS_PLL_CTL_RESERVED0_FIELD_WIDTH 5
#define SERDES_STATUS_PLL_CTL_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec SERDES_STATUS_PLL_CTL_PLL1_REFIN_EN_FIELD;
#define SERDES_STATUS_PLL_CTL_PLL1_REFIN_EN_FIELD_MASK  0x0000000000000100
#define SERDES_STATUS_PLL_CTL_PLL1_REFIN_EN_FIELD_WIDTH 1
#define SERDES_STATUS_PLL_CTL_PLL1_REFIN_EN_FIELD_SHIFT 8

extern const ru_field_rec SERDES_STATUS_PLL_CTL_PLL1_REFOUT_EN_FIELD;
#define SERDES_STATUS_PLL_CTL_PLL1_REFOUT_EN_FIELD_MASK  0x0000000000000200
#define SERDES_STATUS_PLL_CTL_PLL1_REFOUT_EN_FIELD_WIDTH 1
#define SERDES_STATUS_PLL_CTL_PLL1_REFOUT_EN_FIELD_SHIFT 9

extern const ru_field_rec SERDES_STATUS_PLL_CTL_PLL1_LCREF_SEL_FIELD;
#define SERDES_STATUS_PLL_CTL_PLL1_LCREF_SEL_FIELD_MASK  0x0000000000000400
#define SERDES_STATUS_PLL_CTL_PLL1_LCREF_SEL_FIELD_WIDTH 1
#define SERDES_STATUS_PLL_CTL_PLL1_LCREF_SEL_FIELD_SHIFT 10

extern const ru_field_rec SERDES_STATUS_PLL_CTL_RESERVED1_FIELD;
#define SERDES_STATUS_PLL_CTL_RESERVED1_FIELD_MASK  0x00000000fffff800
#define SERDES_STATUS_PLL_CTL_RESERVED1_FIELD_WIDTH 21
#define SERDES_STATUS_PLL_CTL_RESERVED1_FIELD_SHIFT 11

extern const ru_field_rec SERDES_STATUS_TEMP_CTL_WAN_TEMPERATURE_READ_FIELD;
#define SERDES_STATUS_TEMP_CTL_WAN_TEMPERATURE_READ_FIELD_MASK  0x00000000000003ff
#define SERDES_STATUS_TEMP_CTL_WAN_TEMPERATURE_READ_FIELD_WIDTH 10
#define SERDES_STATUS_TEMP_CTL_WAN_TEMPERATURE_READ_FIELD_SHIFT 0

#if defined (CONFIG_BCM96878)
extern const ru_field_rec SERDES_STATUS_TEMP_CTL_WAN_TEMPERATURE_STROBE;
#define SERDES_STATUS_TEMP_CTL_WAN_TEMPERATURE_STROBE_FIELD_MASK  0x0000000000000400
#define SERDES_STATUS_TEMP_CTL_WAN_TEMPERATURE_STROBE_FIELD_WIDTH 1
#define SERDES_STATUS_TEMP_CTL_WAN_TEMPERATURE_STROBE_FIELD_SHIFT 10
extern const ru_field_rec SERDES_STATUS_TEMP_CTL_RESERVED0_FIELD;
#define SERDES_STATUS_TEMP_CTL_RESERVED0_FIELD_MASK  0x00000000fffff800
#define SERDES_STATUS_TEMP_CTL_RESERVED0_FIELD_WIDTH 21
#define SERDES_STATUS_TEMP_CTL_RESERVED0_FIELD_SHIFT 11
#else
extern const ru_field_rec SERDES_STATUS_TEMP_CTL_RESERVED0_FIELD;
#define SERDES_STATUS_TEMP_CTL_RESERVED0_FIELD_MASK  0x00000000fffffc00
#define SERDES_STATUS_TEMP_CTL_RESERVED0_FIELD_WIDTH 22
#define SERDES_STATUS_TEMP_CTL_RESERVED0_FIELD_SHIFT 10
#endif

extern const ru_field_rec SERDES_STATUS_PRAM_CTL_PRAM_ADDRESS_FIELD;
#define SERDES_STATUS_PRAM_CTL_PRAM_ADDRESS_FIELD_MASK  0x000000000000ffff
#define SERDES_STATUS_PRAM_CTL_PRAM_ADDRESS_FIELD_WIDTH 16
#define SERDES_STATUS_PRAM_CTL_PRAM_ADDRESS_FIELD_SHIFT 0

extern const ru_field_rec SERDES_STATUS_PRAM_CTL_RESERVED0_FIELD;
#define SERDES_STATUS_PRAM_CTL_RESERVED0_FIELD_MASK  0x0000000003ff0000
#define SERDES_STATUS_PRAM_CTL_RESERVED0_FIELD_WIDTH 10
#define SERDES_STATUS_PRAM_CTL_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec SERDES_STATUS_PRAM_CTL_PRAM_WE_FIELD;
#define SERDES_STATUS_PRAM_CTL_PRAM_WE_FIELD_MASK  0x0000000004000000
#define SERDES_STATUS_PRAM_CTL_PRAM_WE_FIELD_WIDTH 1
#define SERDES_STATUS_PRAM_CTL_PRAM_WE_FIELD_SHIFT 26

extern const ru_field_rec SERDES_STATUS_PRAM_CTL_RESERVED1_FIELD;
#define SERDES_STATUS_PRAM_CTL_RESERVED1_FIELD_MASK  0x0000000078000000
#define SERDES_STATUS_PRAM_CTL_RESERVED1_FIELD_WIDTH 4
#define SERDES_STATUS_PRAM_CTL_RESERVED1_FIELD_SHIFT 27

extern const ru_field_rec SERDES_STATUS_PRAM_CTL_PRAM_GO_FIELD;
#define SERDES_STATUS_PRAM_CTL_PRAM_GO_FIELD_MASK  0x0000000080000000
#define SERDES_STATUS_PRAM_CTL_PRAM_GO_FIELD_WIDTH 1
#define SERDES_STATUS_PRAM_CTL_PRAM_GO_FIELD_SHIFT 31

extern const ru_field_rec SERDES_STATUS_PRAM_VAL_LOW_VAL_FIELD;
#define SERDES_STATUS_PRAM_VAL_LOW_VAL_FIELD_MASK  0x00000000ffffffff
#define SERDES_STATUS_PRAM_VAL_LOW_VAL_FIELD_WIDTH 32
#define SERDES_STATUS_PRAM_VAL_LOW_VAL_FIELD_SHIFT 0

extern const ru_field_rec SERDES_STATUS_PRAM_VAL_HIGH_VAL_FIELD;
#define SERDES_STATUS_PRAM_VAL_HIGH_VAL_FIELD_MASK  0x00000000ffffffff
#define SERDES_STATUS_PRAM_VAL_HIGH_VAL_FIELD_WIDTH 32
#define SERDES_STATUS_PRAM_VAL_HIGH_VAL_FIELD_SHIFT 0

extern const ru_field_rec SERDES_STATUS_OVERSAMPLE_CTRL_CFG_GPON_RX_CLK_FIELD;
#define SERDES_STATUS_OVERSAMPLE_CTRL_CFG_GPON_RX_CLK_FIELD_MASK  0x0000000000000003
#define SERDES_STATUS_OVERSAMPLE_CTRL_CFG_GPON_RX_CLK_FIELD_WIDTH 2
#define SERDES_STATUS_OVERSAMPLE_CTRL_CFG_GPON_RX_CLK_FIELD_SHIFT 0

extern const ru_field_rec SERDES_STATUS_OVERSAMPLE_CTRL_TXFIFO_RD_LEGACY_MODE_FIELD;
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXFIFO_RD_LEGACY_MODE_FIELD_MASK  0x0000000000000004
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXFIFO_RD_LEGACY_MODE_FIELD_WIDTH 1
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXFIFO_RD_LEGACY_MODE_FIELD_SHIFT 2

extern const ru_field_rec SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_EN_FIELD;
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_EN_FIELD_MASK  0x0000000000000008
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_EN_FIELD_WIDTH 1
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_EN_FIELD_SHIFT 3

extern const ru_field_rec SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_INIT_VAL_FIELD;
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_INIT_VAL_FIELD_MASK  0x0000000000000070
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_INIT_VAL_FIELD_WIDTH 3
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_INIT_VAL_FIELD_SHIFT 4

extern const ru_field_rec SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_ORDER_FIELD;
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_ORDER_FIELD_MASK  0x0000000000000080
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_ORDER_FIELD_WIDTH 1
#define SERDES_STATUS_OVERSAMPLE_CTRL_TXLBE_SER_ORDER_FIELD_SHIFT 7

extern const ru_field_rec SERDES_STATUS_OVERSAMPLE_CTRL_RESERVED0_FIELD;
#define SERDES_STATUS_OVERSAMPLE_CTRL_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define SERDES_STATUS_OVERSAMPLE_CTRL_RESERVED0_FIELD_WIDTH 24
#define SERDES_STATUS_OVERSAMPLE_CTRL_RESERVED0_FIELD_SHIFT 8



/******************************************************************************
 *  Registers
 ******************************************************************************/
extern const ru_reg_rec TOP_SCRATCH_ATCH_REG;
#define TOP_SCRATCH_ATCH_REG_OFFSET 0x00000000

extern const ru_reg_rec EARLY_TXEN_TXEN_CFG_REG;
#define EARLY_TXEN_TXEN_CFG_REG_OFFSET 0x00000000

extern const ru_reg_rec RESCAL_CFG_REG;
#define RESCAL_CFG_REG_OFFSET 0x00000000

extern const ru_reg_rec RESCAL_STATUS0_REG;
#define RESCAL_STATUS0_REG_OFFSET 0x00000004

extern const ru_reg_rec RESCAL_STATUS1_REG;
#define RESCAL_STATUS1_REG_OFFSET 0x00000008

extern const ru_reg_rec MISC_0_REG;
#define MISC_0_REG_OFFSET 0x00000000

extern const ru_reg_rec MISC_1_REG;
#define MISC_1_REG_OFFSET 0x00000004

extern const ru_reg_rec MISC_2_REG;
#define MISC_2_REG_OFFSET 0x00000008

extern const ru_reg_rec MISC_3_REG;
#define MISC_3_REG_OFFSET 0x0000000c

extern const ru_reg_rec PMI_LP_0_REG;
#define PMI_LP_0_REG_OFFSET 0x00000000

extern const ru_reg_rec PMI_LP_1_REG;
#define PMI_LP_1_REG_OFFSET 0x00000004

extern const ru_reg_rec PMI_LP_2_REG;
#define PMI_LP_2_REG_OFFSET 0x00000008

extern const ru_reg_rec PMI_LP_3_REG;
#define PMI_LP_3_REG_OFFSET 0x0000000c

extern const ru_reg_rec TOD_CONFIG_0_REG;
#define TOD_CONFIG_0_REG_OFFSET 0x00000000

extern const ru_reg_rec TOD_MSB_REG;
#define TOD_MSB_REG_OFFSET 0x00000008

extern const ru_reg_rec TOD_LSB_REG;
#define TOD_LSB_REG_OFFSET 0x0000000c

extern const ru_reg_rec TOD_CONFIG_2_REG;
#define TOD_CONFIG_2_REG_OFFSET 0x00000010

extern const ru_reg_rec TOD_CONFIG_3_REG;
#define TOD_CONFIG_3_REG_OFFSET 0x00000014

extern const ru_reg_rec TOD_STATUS_0_REG;
#define TOD_STATUS_0_REG_OFFSET 0x00000018

extern const ru_reg_rec TOD_STATUS_1_REG;
#define TOD_STATUS_1_REG_OFFSET 0x0000001c

extern const ru_reg_rec TOD_STATUS_2_REG;
#define TOD_STATUS_2_REG_OFFSET 0x00000020

extern const ru_reg_rec WAN_SERDES_STATUS_REG;
#define WAN_SERDES_STATUS_REG_OFFSET 0x00000000

extern const ru_reg_rec GPON_GEARBOX_0_REG;
#define GPON_GEARBOX_0_REG_OFFSET 0x00000000

extern const ru_reg_rec GPON_GEARBOX_PATTERN_CFG1_REG;
#define GPON_GEARBOX_PATTERN_CFG1_REG_OFFSET 0x00000004

extern const ru_reg_rec GPON_GEARBOX_PATTERN_CFG2_REG;
#define GPON_GEARBOX_PATTERN_CFG2_REG_OFFSET 0x00000008

extern const ru_reg_rec GPON_GEARBOX_2_REG;
#define GPON_GEARBOX_2_REG_OFFSET 0x0000000c

extern const ru_reg_rec GPON_GEARBOX_STATUS_REG;
#define GPON_GEARBOX_STATUS_REG_OFFSET 0x00000094

extern const ru_reg_rec FORCE_LBE_CONTROL_L_REG;
#define FORCE_LBE_CONTROL_L_REG_OFFSET 0x00000000

extern const ru_reg_rec PRBS_CHK_CTRL_0_REG;
#define PRBS_CHK_CTRL_0_REG_OFFSET 0x00000000

extern const ru_reg_rec PRBS_CHK_CTRL_1_REG;
#define PRBS_CHK_CTRL_1_REG_OFFSET 0x00000004

extern const ru_reg_rec PRBS_STATUS_0_REG;
#define PRBS_STATUS_0_REG_OFFSET 0x00000008

extern const ru_reg_rec PRBS_STATUS_1_REG;
#define PRBS_STATUS_1_REG_OFFSET 0x0000000c

extern const ru_reg_rec SERDES_STATUS_PLL_CTL_REG;
#define SERDES_STATUS_PLL_CTL_REG_OFFSET 0x00000000

extern const ru_reg_rec SERDES_STATUS_TEMP_CTL_REG;
#define SERDES_STATUS_TEMP_CTL_REG_OFFSET 0x00000004

extern const ru_reg_rec SERDES_STATUS_PRAM_CTL_REG;
#define SERDES_STATUS_PRAM_CTL_REG_OFFSET 0x00000008

extern const ru_reg_rec SERDES_STATUS_PRAM_VAL_LOW_REG;
#define SERDES_STATUS_PRAM_VAL_LOW_REG_OFFSET 0x00000050

extern const ru_reg_rec SERDES_STATUS_PRAM_VAL_HIGH_REG;
#define SERDES_STATUS_PRAM_VAL_HIGH_REG_OFFSET 0x00000054

extern const ru_reg_rec SERDES_STATUS_OVERSAMPLE_CTRL_REG;
#define SERDES_STATUS_OVERSAMPLE_CTRL_REG_OFFSET 0x00000068



/******************************************************************************
 *  Blocks
 ******************************************************************************/
extern const ru_block_rec TOP_SCRATCH_BLOCK;
extern const ru_block_rec EARLY_TXEN_BLOCK;
extern const ru_block_rec RESCAL_BLOCK;
extern const ru_block_rec MISC_BLOCK;
extern const ru_block_rec PMI_BLOCK;
extern const ru_block_rec TOD_BLOCK;
extern const ru_block_rec WAN_SERDES_BLOCK;
extern const ru_block_rec GPON_BLOCK;
extern const ru_block_rec FORCE_LBE_CONTROL_BLOCK;
extern const ru_block_rec PRBS_BLOCK;
extern const ru_block_rec SERDES_STATUS_BLOCK;
extern const ru_block_rec *WAN_TOP_BLOCKS[];


#define RU_REG_COUNT 38
#define RU_FLD_COUNT 197


#endif /* End of file .h */
