/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _EARLY_TXEN_AG_H_
#define _EARLY_TXEN_AG_H_

#include "access_macros.h"
#include "bdmf_interface.h"
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif
#include "rdp_common.h"

typedef struct
{
    uint8_t cr_xgwan_top_wan_misc_early_txen_cfg_hold_time;
    uint8_t cr_xgwan_top_wan_misc_early_txen_cfg_setup_time;
    uint8_t cr_xgwan_top_wan_misc_early_txen_cfg_toff_time;
    bdmf_boolean cr_xgwan_top_wan_misc_early_txen_cfg_output_txen_polarity;
    bdmf_boolean cr_xgwan_top_wan_misc_early_txen_cfg_input_txen_polarity;
    bdmf_boolean cr_xgwan_top_wan_misc_early_txen_cfg_early_txen_bypass;
} early_txen_txen;

bdmf_error_t ag_drv_early_txen_txen_set(const early_txen_txen *txen);
bdmf_error_t ag_drv_early_txen_txen_get(early_txen_txen *txen);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_early_txen_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

