/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "drivers_common_ag.h"
#include "force_lbe_control_ag.h"
bdmf_error_t ag_drv_force_lbe_control_force_lbe_control_control_set(const force_lbe_control_force_lbe_control_control *force_lbe_control_control)
{
    uint32_t reg_control=0;

#ifdef VALIDATE_PARMS
    if(!force_lbe_control_control)
    {
        bdmf_trace("ERROR driver %s:%u| err=%s (%d)\n", __FILE__, __LINE__, bdmf_strerror(BDMF_ERR_PARM), BDMF_ERR_PARM);
        return BDMF_ERR_PARM;
    }
    if((force_lbe_control_control->cfg_force_lbe >= _1BITS_MAX_VAL_) ||
       (force_lbe_control_control->cfg_force_lbe_value >= _1BITS_MAX_VAL_) ||
       (force_lbe_control_control->cfg_force_lbe_oe >= _1BITS_MAX_VAL_) ||
       (force_lbe_control_control->cfg_force_lbe_oe_value >= _1BITS_MAX_VAL_))
    {
        bdmf_trace("ERROR driver %s:%u| err=%s (%d)\n", __FILE__, __LINE__, bdmf_strerror(BDMF_ERR_RANGE), BDMF_ERR_RANGE);
        return BDMF_ERR_RANGE;
    }
#endif

    reg_control = RU_FIELD_SET(0, FORCE_LBE_CONTROL, CONTROL, CFG_FORCE_LBE, reg_control, force_lbe_control_control->cfg_force_lbe);
    reg_control = RU_FIELD_SET(0, FORCE_LBE_CONTROL, CONTROL, CFG_FORCE_LBE_VALUE, reg_control, force_lbe_control_control->cfg_force_lbe_value);
    reg_control = RU_FIELD_SET(0, FORCE_LBE_CONTROL, CONTROL, CFG_FORCE_LBE_OE, reg_control, force_lbe_control_control->cfg_force_lbe_oe);
    reg_control = RU_FIELD_SET(0, FORCE_LBE_CONTROL, CONTROL, CFG_FORCE_LBE_OE_VALUE, reg_control, force_lbe_control_control->cfg_force_lbe_oe_value);

    RU_REG_WRITE(0, FORCE_LBE_CONTROL, CONTROL, reg_control);

    return BDMF_ERR_OK;
}

bdmf_error_t ag_drv_force_lbe_control_force_lbe_control_control_get(force_lbe_control_force_lbe_control_control *force_lbe_control_control)
{
    uint32_t reg_control=0;

#ifdef VALIDATE_PARMS
    if(!force_lbe_control_control)
    {
        bdmf_trace("ERROR driver %s:%u| err=%s (%d)\n", __FILE__, __LINE__, bdmf_strerror(BDMF_ERR_PARM), BDMF_ERR_PARM);
        return BDMF_ERR_PARM;
    }
#endif

    RU_REG_READ(0, FORCE_LBE_CONTROL, CONTROL, reg_control);

    force_lbe_control_control->cfg_force_lbe = RU_FIELD_GET(0, FORCE_LBE_CONTROL, CONTROL, CFG_FORCE_LBE, reg_control);
    force_lbe_control_control->cfg_force_lbe_value = RU_FIELD_GET(0, FORCE_LBE_CONTROL, CONTROL, CFG_FORCE_LBE_VALUE, reg_control);
    force_lbe_control_control->cfg_force_lbe_oe = RU_FIELD_GET(0, FORCE_LBE_CONTROL, CONTROL, CFG_FORCE_LBE_OE, reg_control);
    force_lbe_control_control->cfg_force_lbe_oe_value = RU_FIELD_GET(0, FORCE_LBE_CONTROL, CONTROL, CFG_FORCE_LBE_OE_VALUE, reg_control);

    return BDMF_ERR_OK;
}

