/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _RESCAL_AG_H_
#define _RESCAL_AG_H_

#include "access_macros.h"
#include "bdmf_interface.h"
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif
#include "rdp_common.h"

typedef struct
{
    uint16_t ctrl;
    bdmf_boolean pwrdn;
    bdmf_boolean diag_on;
    bdmf_boolean rstb;
} rescal_rescal_cfg;

typedef struct
{
    bdmf_boolean valid;
    bdmf_boolean comp;
    uint8_t state;
    uint16_t ctrl_dfs;
    uint8_t prev_comp_cnt;
    uint8_t pon;
    bdmf_boolean done;
} rescal_rescal_status_0;

bdmf_error_t ag_drv_rescal_rescal_cfg_set(const rescal_rescal_cfg *rescal_cfg);
bdmf_error_t ag_drv_rescal_rescal_cfg_get(rescal_rescal_cfg *rescal_cfg);
bdmf_error_t ag_drv_rescal_rescal_status_0_get(rescal_rescal_status_0 *rescal_status_0);
bdmf_error_t ag_drv_rescal_rescal_status1_get(uint8_t *curr_comp_cnt);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_rescal_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

