/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "drivers_common_ag.h"
#include "wan_epon_ag.h"
bdmf_error_t ag_drv_wan_epon_wan_epon_10g_gearbox_set(const wan_epon_wan_epon_10g_gearbox *wan_epon_10g_gearbox)
{
    uint32_t reg_10g_gearbox=0;

#ifdef VALIDATE_PARMS
    if(!wan_epon_10g_gearbox)
    {
        bdmf_trace("ERROR driver %s:%u| err=%s (%d)\n", __FILE__, __LINE__, bdmf_strerror(BDMF_ERR_PARM), BDMF_ERR_PARM);
        return BDMF_ERR_PARM;
    }
    if((wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_rx_cgen_rstn >= _1BITS_MAX_VAL_) ||
       (wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_cgen_rstn >= _1BITS_MAX_VAL_) ||
       (wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_rx_gbox_rstn >= _1BITS_MAX_VAL_) ||
       (wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_gbox_rstn >= _1BITS_MAX_VAL_) ||
       (wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_clk_en >= _1BITS_MAX_VAL_) ||
       (wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_rx_data_end >= _1BITS_MAX_VAL_) ||
       (wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx2rx_loop_en >= _1BITS_MAX_VAL_) ||
       (wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off_ld >= _1BITS_MAX_VAL_) ||
       (wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off >= _3BITS_MAX_VAL_))
    {
        bdmf_trace("ERROR driver %s:%u| err=%s (%d)\n", __FILE__, __LINE__, bdmf_strerror(BDMF_ERR_RANGE), BDMF_ERR_RANGE);
        return BDMF_ERR_RANGE;
    }
#endif

    reg_10g_gearbox = RU_FIELD_SET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_RX_CGEN_RSTN, reg_10g_gearbox, wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_rx_cgen_rstn);
    reg_10g_gearbox = RU_FIELD_SET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_TX_CGEN_RSTN, reg_10g_gearbox, wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_cgen_rstn);
    reg_10g_gearbox = RU_FIELD_SET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_RX_GBOX_RSTN, reg_10g_gearbox, wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_rx_gbox_rstn);
    reg_10g_gearbox = RU_FIELD_SET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_TX_GBOX_RSTN, reg_10g_gearbox, wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_gbox_rstn);
    reg_10g_gearbox = RU_FIELD_SET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_CLK_EN, reg_10g_gearbox, wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_clk_en);
    reg_10g_gearbox = RU_FIELD_SET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_RX_DATA_END, reg_10g_gearbox, wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_rx_data_end);
    reg_10g_gearbox = RU_FIELD_SET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_TX2RX_LOOP_EN, reg_10g_gearbox, wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx2rx_loop_en);
    reg_10g_gearbox = RU_FIELD_SET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_TX_FIFO_OFF_LD, reg_10g_gearbox, wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off_ld);
    reg_10g_gearbox = RU_FIELD_SET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_TX_FIFO_OFF, reg_10g_gearbox, wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off);

    RU_REG_WRITE(0, WAN_EPON, 10G_GEARBOX, reg_10g_gearbox);

    return BDMF_ERR_OK;
}

bdmf_error_t ag_drv_wan_epon_wan_epon_10g_gearbox_get(wan_epon_wan_epon_10g_gearbox *wan_epon_10g_gearbox)
{
    uint32_t reg_10g_gearbox=0;

#ifdef VALIDATE_PARMS
    if(!wan_epon_10g_gearbox)
    {
        bdmf_trace("ERROR driver %s:%u| err=%s (%d)\n", __FILE__, __LINE__, bdmf_strerror(BDMF_ERR_PARM), BDMF_ERR_PARM);
        return BDMF_ERR_PARM;
    }
#endif

    RU_REG_READ(0, WAN_EPON, 10G_GEARBOX, reg_10g_gearbox);

    wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_rx_cgen_rstn = RU_FIELD_GET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_RX_CGEN_RSTN, reg_10g_gearbox);
    wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_cgen_rstn = RU_FIELD_GET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_TX_CGEN_RSTN, reg_10g_gearbox);
    wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_rx_gbox_rstn = RU_FIELD_GET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_RX_GBOX_RSTN, reg_10g_gearbox);
    wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_gbox_rstn = RU_FIELD_GET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_TX_GBOX_RSTN, reg_10g_gearbox);
    wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_clk_en = RU_FIELD_GET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_CLK_EN, reg_10g_gearbox);
    wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_rx_data_end = RU_FIELD_GET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_RX_DATA_END, reg_10g_gearbox);
    wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx2rx_loop_en = RU_FIELD_GET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_TX2RX_LOOP_EN, reg_10g_gearbox);
    wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off_ld = RU_FIELD_GET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_TX_FIFO_OFF_LD, reg_10g_gearbox);
    wan_epon_10g_gearbox->cfg_sgb_pon_10g_epon_tx_fifo_off = RU_FIELD_GET(0, WAN_EPON, 10G_GEARBOX, CFG_SGB_PON_10G_EPON_TX_FIFO_OFF, reg_10g_gearbox);

    return BDMF_ERR_OK;
}

