/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _WAN_PRBS_AG_H_
#define _WAN_PRBS_AG_H_

#include "access_macros.h"
#include "bdmf_interface.h"
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif
#include "rdp_common.h"

typedef struct
{
    uint8_t en_timer_mode;
    uint8_t en_timeout;
    uint8_t mode_sel;
    bdmf_boolean err_cnt_burst_mode;
    uint8_t lock_cnt;
    uint8_t ool_cnt;
    bdmf_boolean inv;
    bdmf_boolean sig_prbs_status_clr;
} wan_prbs_wan_prbs_chk_ctrl_0;

bdmf_error_t ag_drv_wan_prbs_wan_prbs_chk_ctrl_0_set(const wan_prbs_wan_prbs_chk_ctrl_0 *wan_prbs_chk_ctrl_0);
bdmf_error_t ag_drv_wan_prbs_wan_prbs_chk_ctrl_0_get(wan_prbs_wan_prbs_chk_ctrl_0 *wan_prbs_chk_ctrl_0);
bdmf_error_t ag_drv_wan_prbs_wan_prbs_chk_ctrl_1_set(bdmf_boolean prbs_chk_en, uint8_t prbs_chk_mode, uint32_t prbs_timer_val);
bdmf_error_t ag_drv_wan_prbs_wan_prbs_chk_ctrl_1_get(bdmf_boolean *prbs_chk_en, uint8_t *prbs_chk_mode, uint32_t *prbs_timer_val);
bdmf_error_t ag_drv_wan_prbs_wan_prbs_status_0_get(bdmf_boolean *lock_lost_lh, uint32_t *err_cnt);
bdmf_error_t ag_drv_wan_prbs_wan_prbs_status_1_get(bdmf_boolean *any_err, bdmf_boolean *lock);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_wan_prbs_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

