/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _WAN_SERDES_AG_H_
#define _WAN_SERDES_AG_H_

#include "access_macros.h"
#include "bdmf_interface.h"
#ifdef USE_BDMF_SHELL
#include "bdmf_shell.h"
#endif
#include "rdp_common.h"

typedef struct
{
    bdmf_boolean pll0_refin_en;
    bdmf_boolean pll0_refout_en;
    bdmf_boolean pll0_lcref_sel;
    bdmf_boolean pll1_refin_en;
    bdmf_boolean pll1_refout_en;
    bdmf_boolean pll1_lcref_sel;
} wan_serdes_wan_serdes_pll_ctl;

typedef struct
{
    uint8_t top_osr_control_cfg_gpon_rx_clk;
    bdmf_boolean top_osr_control_txfifo_rd_legacy_mode;
    bdmf_boolean top_osr_control_txlbe_ser_en;
    uint8_t top_osr_control_txlbe_ser_init_val;
    bdmf_boolean top_osr_control_txlbe_ser_order;
} wan_serdes_top_osr_ctrl;

bdmf_error_t ag_drv_wan_serdes_wan_serdes_pll_ctl_set(const wan_serdes_wan_serdes_pll_ctl *wan_serdes_pll_ctl);
bdmf_error_t ag_drv_wan_serdes_wan_serdes_pll_ctl_get(wan_serdes_wan_serdes_pll_ctl *wan_serdes_pll_ctl);
bdmf_error_t ag_drv_wan_serdes_wan_serdes_temp_ctl_get(uint16_t *wan_temperature_read);
bdmf_error_t ag_drv_wan_serdes_wan_serdes_pram_ctl_set(bdmf_boolean pram_go, bdmf_boolean pram_we, uint16_t pram_address);
bdmf_error_t ag_drv_wan_serdes_wan_serdes_pram_ctl_get(bdmf_boolean *pram_go, bdmf_boolean *pram_we, uint16_t *pram_address);
bdmf_error_t ag_drv_wan_serdes_wan_serdes_pram_val_low_set(uint32_t val);
bdmf_error_t ag_drv_wan_serdes_wan_serdes_pram_val_low_get(uint32_t *val);
bdmf_error_t ag_drv_wan_serdes_wan_serdes_pram_val_high_set(uint32_t val);
bdmf_error_t ag_drv_wan_serdes_wan_serdes_pram_val_high_get(uint32_t *val);
bdmf_error_t ag_drv_wan_serdes_top_osr_ctrl_set(const wan_serdes_top_osr_ctrl *top_osr_ctrl);
bdmf_error_t ag_drv_wan_serdes_top_osr_ctrl_get(wan_serdes_top_osr_ctrl *top_osr_ctrl);

#ifdef USE_BDMF_SHELL
bdmfmon_handle_t ag_drv_wan_serdes_cli_init(bdmfmon_handle_t driver_dir);
#endif


#endif

