/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: WAN_SERDES_PLL_CTL_PLL0_REFIN_EN
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PLL_CTL_PLL0_REFIN_EN_FIELD =
{
    "PLL0_REFIN_EN",
#if RU_INCLUDE_DESC
    "PLL0_REFIN_EN",
    "Reference select. 0 - select pad_pll0_refclkp/n. 1 - select"
    "pll0_lcrefp/n."
    "Reset value is 0x0.",
#endif
    WAN_SERDES_PLL_CTL_PLL0_REFIN_EN_FIELD_MASK,
    0,
    WAN_SERDES_PLL_CTL_PLL0_REFIN_EN_FIELD_WIDTH,
    WAN_SERDES_PLL_CTL_PLL0_REFIN_EN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PLL_CTL_PLL0_REFOUT_EN
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PLL_CTL_PLL0_REFOUT_EN_FIELD =
{
    "PLL0_REFOUT_EN",
#if RU_INCLUDE_DESC
    "PLL0_REFOUT_EN",
    "Enables SERDES to drive the pll0_refout pin. 0 - output is hiZ. 1"
    "- output is pad_pll0_refclk."
    "Reset value is 0x0.",
#endif
    WAN_SERDES_PLL_CTL_PLL0_REFOUT_EN_FIELD_MASK,
    0,
    WAN_SERDES_PLL_CTL_PLL0_REFOUT_EN_FIELD_WIDTH,
    WAN_SERDES_PLL_CTL_PLL0_REFOUT_EN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PLL_CTL_PLL0_LCREF_SEL
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PLL_CTL_PLL0_LCREF_SEL_FIELD =
{
    "PLL0_LCREF_SEL",
#if RU_INCLUDE_DESC
    "PLL0_LCREF_SEL",
    "0 - select pll0_lcref. 1 - select pll1_lcref."
    "Reset value is 0x0.",
#endif
    WAN_SERDES_PLL_CTL_PLL0_LCREF_SEL_FIELD_MASK,
    0,
    WAN_SERDES_PLL_CTL_PLL0_LCREF_SEL_FIELD_WIDTH,
    WAN_SERDES_PLL_CTL_PLL0_LCREF_SEL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PLL_CTL_RESERVED0
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PLL_CTL_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    WAN_SERDES_PLL_CTL_RESERVED0_FIELD_MASK,
    0,
    WAN_SERDES_PLL_CTL_RESERVED0_FIELD_WIDTH,
    WAN_SERDES_PLL_CTL_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PLL_CTL_PLL1_REFIN_EN
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PLL_CTL_PLL1_REFIN_EN_FIELD =
{
    "PLL1_REFIN_EN",
#if RU_INCLUDE_DESC
    "PLL1_REFIN_EN",
    "Reference select. 0 - select pad_pll1_refclkp/n. 1 - select"
    "pll1_lcrefp/n."
    "Reset value is 0x0.",
#endif
    WAN_SERDES_PLL_CTL_PLL1_REFIN_EN_FIELD_MASK,
    0,
    WAN_SERDES_PLL_CTL_PLL1_REFIN_EN_FIELD_WIDTH,
    WAN_SERDES_PLL_CTL_PLL1_REFIN_EN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PLL_CTL_PLL1_REFOUT_EN
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PLL_CTL_PLL1_REFOUT_EN_FIELD =
{
    "PLL1_REFOUT_EN",
#if RU_INCLUDE_DESC
    "PLL1_REFOUT_EN",
    "Enables SERDES to drive the pll1_refout pin. 0 - output is hiZ. 1"
    "- output is pad_pll1_refclk."
    "Reset value is 0x0.",
#endif
    WAN_SERDES_PLL_CTL_PLL1_REFOUT_EN_FIELD_MASK,
    0,
    WAN_SERDES_PLL_CTL_PLL1_REFOUT_EN_FIELD_WIDTH,
    WAN_SERDES_PLL_CTL_PLL1_REFOUT_EN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PLL_CTL_PLL1_LCREF_SEL
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PLL_CTL_PLL1_LCREF_SEL_FIELD =
{
    "PLL1_LCREF_SEL",
#if RU_INCLUDE_DESC
    "PLL1_LCREF_SEL",
    "0 - select pll1_lcref. 1 - select pll0_lcref."
    "Reset value is 0x0.",
#endif
    WAN_SERDES_PLL_CTL_PLL1_LCREF_SEL_FIELD_MASK,
    0,
    WAN_SERDES_PLL_CTL_PLL1_LCREF_SEL_FIELD_WIDTH,
    WAN_SERDES_PLL_CTL_PLL1_LCREF_SEL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PLL_CTL_RESERVED1
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PLL_CTL_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    WAN_SERDES_PLL_CTL_RESERVED1_FIELD_MASK,
    0,
    WAN_SERDES_PLL_CTL_RESERVED1_FIELD_WIDTH,
    WAN_SERDES_PLL_CTL_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_TEMP_CTL_WAN_TEMPERATURE_READ
 ******************************************************************************/
const ru_field_rec WAN_SERDES_TEMP_CTL_WAN_TEMPERATURE_READ_FIELD =
{
    "WAN_TEMPERATURE_READ",
#if RU_INCLUDE_DESC
    "WAN_TEMPERATURE_READ",
    "10-bit temperature data. Please refer to TMON documentation for how"
    "to convert this value to a useful number."
    "Reset value is 0x0.",
#endif
    WAN_SERDES_TEMP_CTL_WAN_TEMPERATURE_READ_FIELD_MASK,
    0,
    WAN_SERDES_TEMP_CTL_WAN_TEMPERATURE_READ_FIELD_WIDTH,
    WAN_SERDES_TEMP_CTL_WAN_TEMPERATURE_READ_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_TEMP_CTL_RESERVED0
 ******************************************************************************/
const ru_field_rec WAN_SERDES_TEMP_CTL_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    WAN_SERDES_TEMP_CTL_RESERVED0_FIELD_MASK,
    0,
    WAN_SERDES_TEMP_CTL_RESERVED0_FIELD_WIDTH,
    WAN_SERDES_TEMP_CTL_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PRAM_CTL_PRAM_ADDRESS
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PRAM_CTL_PRAM_ADDRESS_FIELD =
{
    "PRAM_ADDRESS",
#if RU_INCLUDE_DESC
    "PRAM_ADDRESS",
    "Program RAM address."
    "Reset value is 0x0.",
#endif
    WAN_SERDES_PRAM_CTL_PRAM_ADDRESS_FIELD_MASK,
    0,
    WAN_SERDES_PRAM_CTL_PRAM_ADDRESS_FIELD_WIDTH,
    WAN_SERDES_PRAM_CTL_PRAM_ADDRESS_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PRAM_CTL_RESERVED0
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PRAM_CTL_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    WAN_SERDES_PRAM_CTL_RESERVED0_FIELD_MASK,
    0,
    WAN_SERDES_PRAM_CTL_RESERVED0_FIELD_WIDTH,
    WAN_SERDES_PRAM_CTL_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PRAM_CTL_PRAM_WE
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PRAM_CTL_PRAM_WE_FIELD =
{
    "PRAM_WE",
#if RU_INCLUDE_DESC
    "PRAM_WE",
    "Program RAM write strobe."
    "Reset value is 0x0.",
#endif
    WAN_SERDES_PRAM_CTL_PRAM_WE_FIELD_MASK,
    0,
    WAN_SERDES_PRAM_CTL_PRAM_WE_FIELD_WIDTH,
    WAN_SERDES_PRAM_CTL_PRAM_WE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PRAM_CTL_RESERVED1
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PRAM_CTL_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    WAN_SERDES_PRAM_CTL_RESERVED1_FIELD_MASK,
    0,
    WAN_SERDES_PRAM_CTL_RESERVED1_FIELD_WIDTH,
    WAN_SERDES_PRAM_CTL_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PRAM_CTL_PRAM_GO
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PRAM_CTL_PRAM_GO_FIELD =
{
    "PRAM_GO",
#if RU_INCLUDE_DESC
    "PRAM_GO",
    "Perform pRAM operation.  This field is only valid for the B0 or beyond.  Software sets and hardware clears this bit.  Do not write to this register if this bit is set.",
#endif
    WAN_SERDES_PRAM_CTL_PRAM_GO_FIELD_MASK,
    0,
    WAN_SERDES_PRAM_CTL_PRAM_GO_FIELD_WIDTH,
    WAN_SERDES_PRAM_CTL_PRAM_GO_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PRAM_VAL_LOW_VAL
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PRAM_VAL_LOW_VAL_FIELD =
{
    "VAL",
#if RU_INCLUDE_DESC
    "VAL",
    "Data",
#endif
    WAN_SERDES_PRAM_VAL_LOW_VAL_FIELD_MASK,
    0,
    WAN_SERDES_PRAM_VAL_LOW_VAL_FIELD_WIDTH,
    WAN_SERDES_PRAM_VAL_LOW_VAL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_PRAM_VAL_HIGH_VAL
 ******************************************************************************/
const ru_field_rec WAN_SERDES_PRAM_VAL_HIGH_VAL_FIELD =
{
    "VAL",
#if RU_INCLUDE_DESC
    "VAL",
    "Data",
#endif
    WAN_SERDES_PRAM_VAL_HIGH_VAL_FIELD_MASK,
    0,
    WAN_SERDES_PRAM_VAL_HIGH_VAL_FIELD_WIDTH,
    WAN_SERDES_PRAM_VAL_HIGH_VAL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_OVERSAMPLE_CTRL_CFG_GPON_RX_CLK
 ******************************************************************************/
const ru_field_rec WAN_SERDES_OVERSAMPLE_CTRL_CFG_GPON_RX_CLK_FIELD =
{
    "CFG_GPON_RX_CLK",
#if RU_INCLUDE_DESC
    "CFG_GPON_RX_CLK",
    "0: Selects divide-by-2 clock divider for mac_tx_clk. 1: Selects"
    "divide-by-4 clock divider for mac_tx_clk. 2: Selects divide-by-1"
    "clock divider. 3: Unused.",
#endif
    WAN_SERDES_OVERSAMPLE_CTRL_CFG_GPON_RX_CLK_FIELD_MASK,
    0,
    WAN_SERDES_OVERSAMPLE_CTRL_CFG_GPON_RX_CLK_FIELD_WIDTH,
    WAN_SERDES_OVERSAMPLE_CTRL_CFG_GPON_RX_CLK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_OVERSAMPLE_CTRL_TXFIFO_RD_LEGACY_MODE
 ******************************************************************************/
const ru_field_rec WAN_SERDES_OVERSAMPLE_CTRL_TXFIFO_RD_LEGACY_MODE_FIELD =
{
    "TXFIFO_RD_LEGACY_MODE",
#if RU_INCLUDE_DESC
    "TXFIFO_RD_LEGACY_MODE",
    "GPON gearbox TX path FIFO legacy (subrate) mode",
#endif
    WAN_SERDES_OVERSAMPLE_CTRL_TXFIFO_RD_LEGACY_MODE_FIELD_MASK,
    0,
    WAN_SERDES_OVERSAMPLE_CTRL_TXFIFO_RD_LEGACY_MODE_FIELD_WIDTH,
    WAN_SERDES_OVERSAMPLE_CTRL_TXFIFO_RD_LEGACY_MODE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_EN
 ******************************************************************************/
const ru_field_rec WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_EN_FIELD =
{
    "TXLBE_SER_EN",
#if RU_INCLUDE_DESC
    "TXLBE_SER_EN",
    "LBE serializer enable"
    ""
    "0 = parallel mode"
    "1 = serial mode",
#endif
    WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_EN_FIELD_MASK,
    0,
    WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_EN_FIELD_WIDTH,
    WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_EN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_INIT_VAL
 ******************************************************************************/
const ru_field_rec WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_INIT_VAL_FIELD =
{
    "TXLBE_SER_INIT_VAL",
#if RU_INCLUDE_DESC
    "TXLBE_SER_INIT_VAL",
    "Initial bit position for serializer",
#endif
    WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_INIT_VAL_FIELD_MASK,
    0,
    WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_INIT_VAL_FIELD_WIDTH,
    WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_INIT_VAL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_ORDER
 ******************************************************************************/
const ru_field_rec WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_ORDER_FIELD =
{
    "TXLBE_SER_ORDER",
#if RU_INCLUDE_DESC
    "TXLBE_SER_ORDER",
    "Serializer direction"
    ""
    "0 = LSB first (increasing)"
    "1 = MSB first (decreasing)",
#endif
    WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_ORDER_FIELD_MASK,
    0,
    WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_ORDER_FIELD_WIDTH,
    WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_ORDER_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: WAN_SERDES_OVERSAMPLE_CTRL_RESERVED0
 ******************************************************************************/
const ru_field_rec WAN_SERDES_OVERSAMPLE_CTRL_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    WAN_SERDES_OVERSAMPLE_CTRL_RESERVED0_FIELD_MASK,
    0,
    WAN_SERDES_OVERSAMPLE_CTRL_RESERVED0_FIELD_WIDTH,
    WAN_SERDES_OVERSAMPLE_CTRL_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: WAN_SERDES_PLL_CTL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *WAN_SERDES_PLL_CTL_FIELDS[] =
{
    &WAN_SERDES_PLL_CTL_PLL0_REFIN_EN_FIELD,
    &WAN_SERDES_PLL_CTL_PLL0_REFOUT_EN_FIELD,
    &WAN_SERDES_PLL_CTL_PLL0_LCREF_SEL_FIELD,
    &WAN_SERDES_PLL_CTL_RESERVED0_FIELD,
    &WAN_SERDES_PLL_CTL_PLL1_REFIN_EN_FIELD,
    &WAN_SERDES_PLL_CTL_PLL1_REFOUT_EN_FIELD,
    &WAN_SERDES_PLL_CTL_PLL1_LCREF_SEL_FIELD,
    &WAN_SERDES_PLL_CTL_RESERVED1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec WAN_SERDES_PLL_CTL_REG = 
{
    "PLL_CTL",
#if RU_INCLUDE_DESC
    "SERDES_PLL_CTL Register",
    "Register used for low configuration of PLL clocks.",
#endif
    WAN_SERDES_PLL_CTL_REG_OFFSET,
    0,
    0,
    24,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    8,
    WAN_SERDES_PLL_CTL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: WAN_SERDES_TEMP_CTL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *WAN_SERDES_TEMP_CTL_FIELDS[] =
{
    &WAN_SERDES_TEMP_CTL_WAN_TEMPERATURE_READ_FIELD,
    &WAN_SERDES_TEMP_CTL_RESERVED0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec WAN_SERDES_TEMP_CTL_REG = 
{
    "TEMP_CTL",
#if RU_INCLUDE_DESC
    "SERDES_TEMP_CTL Register",
    "Register used for temperature read.",
#endif
    WAN_SERDES_TEMP_CTL_REG_OFFSET,
    0,
    0,
    25,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    WAN_SERDES_TEMP_CTL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: WAN_SERDES_PRAM_CTL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *WAN_SERDES_PRAM_CTL_FIELDS[] =
{
    &WAN_SERDES_PRAM_CTL_PRAM_ADDRESS_FIELD,
    &WAN_SERDES_PRAM_CTL_RESERVED0_FIELD,
    &WAN_SERDES_PRAM_CTL_PRAM_WE_FIELD,
    &WAN_SERDES_PRAM_CTL_RESERVED1_FIELD,
    &WAN_SERDES_PRAM_CTL_PRAM_GO_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec WAN_SERDES_PRAM_CTL_REG = 
{
    "PRAM_CTL",
#if RU_INCLUDE_DESC
    "SERDES_PRAM_CTL Register",
    "Register used for PRAM control.",
#endif
    WAN_SERDES_PRAM_CTL_REG_OFFSET,
    0,
    0,
    26,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    5,
    WAN_SERDES_PRAM_CTL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: WAN_SERDES_PRAM_VAL_LOW
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *WAN_SERDES_PRAM_VAL_LOW_FIELDS[] =
{
    &WAN_SERDES_PRAM_VAL_LOW_VAL_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec WAN_SERDES_PRAM_VAL_LOW_REG = 
{
    "PRAM_VAL_LOW",
#if RU_INCLUDE_DESC
    "SERDES_PRAM_VAL_LOW Register",
    "Bits [31:0] of the 64-bit pRAM write data interface.",
#endif
    WAN_SERDES_PRAM_VAL_LOW_REG_OFFSET,
    0,
    0,
    27,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    WAN_SERDES_PRAM_VAL_LOW_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: WAN_SERDES_PRAM_VAL_HIGH
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *WAN_SERDES_PRAM_VAL_HIGH_FIELDS[] =
{
    &WAN_SERDES_PRAM_VAL_HIGH_VAL_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec WAN_SERDES_PRAM_VAL_HIGH_REG = 
{
    "PRAM_VAL_HIGH",
#if RU_INCLUDE_DESC
    "SERDES_PRAM_VAL_HIGH Register",
    "Bits [63:32] of the 64-bit pRAM write data interface.",
#endif
    WAN_SERDES_PRAM_VAL_HIGH_REG_OFFSET,
    0,
    0,
    28,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    WAN_SERDES_PRAM_VAL_HIGH_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: WAN_SERDES_OVERSAMPLE_CTRL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *WAN_SERDES_OVERSAMPLE_CTRL_FIELDS[] =
{
    &WAN_SERDES_OVERSAMPLE_CTRL_CFG_GPON_RX_CLK_FIELD,
    &WAN_SERDES_OVERSAMPLE_CTRL_TXFIFO_RD_LEGACY_MODE_FIELD,
    &WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_EN_FIELD,
    &WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_INIT_VAL_FIELD,
    &WAN_SERDES_OVERSAMPLE_CTRL_TXLBE_SER_ORDER_FIELD,
    &WAN_SERDES_OVERSAMPLE_CTRL_RESERVED0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec WAN_SERDES_OVERSAMPLE_CTRL_REG = 
{
    "OVERSAMPLE_CTRL",
#if RU_INCLUDE_DESC
    "SERDES_OVERSAMPLE_CTRL Register",
    "Control over SERDES oversample features",
#endif
    WAN_SERDES_OVERSAMPLE_CTRL_REG_OFFSET,
    0,
    0,
    29,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    6,
    WAN_SERDES_OVERSAMPLE_CTRL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: WAN_SERDES
 ******************************************************************************/
static const ru_reg_rec *WAN_SERDES_REGS[] =
{
    &WAN_SERDES_PLL_CTL_REG,
    &WAN_SERDES_TEMP_CTL_REG,
    &WAN_SERDES_PRAM_CTL_REG,
    &WAN_SERDES_PRAM_VAL_LOW_REG,
    &WAN_SERDES_PRAM_VAL_HIGH_REG,
    &WAN_SERDES_OVERSAMPLE_CTRL_REG,
};

unsigned long WAN_SERDES_ADDRS[] =
{
    0x82db2050,
};

const ru_block_rec WAN_SERDES_BLOCK = 
{
    "WAN_SERDES",
    WAN_SERDES_ADDRS,
    1,
    6,
    WAN_SERDES_REGS
};

/* End of file WAN_SERDES.c */
