#include "bp_defs.h"
#include "boardparms.h"
#include "bcmSpiRes.h"

static bp_elem_t g_bcm968781ref[] = {
  {bp_cpBoardId,               .u.cp = "968781REF"},
  {bp_InvSerdesRxPol,          .u.us = pmd_polarity_invert},
  {bp_InvSerdesTxPol,          .u.us = pmd_polarity_invert},
  {bp_usExtIntrResetToDefault, .u.us = BP_EXT_INTR_1 | BP_EXT_INTR_TYPE_IRQ_LOW_LEVEL | BP_EXT_INTR_TYPE_IRQ_SENSE_EDGE},
  {bp_usGpio_Intr,             .u.us = BP_GPIO_53_AL},
  {bp_usGpioI2cScl,            .u.us = BP_GPIO_62_AH},
  {bp_usGpioI2cSda,            .u.us = BP_GPIO_63_AH},
  {bp_ulMemoryConfig,          .u.ul = BP_DDR_SPEED_800_11_11_11 | BP_DDR_TOTAL_SIZE_256MB| BP_DDR_DEVICE_WIDTH_8 | BP_DDR_TOTAL_WIDTH_8BIT | BP_DDR_PCB_2LAYER},
  {bp_ucPhyType0,              .u.uc = BP_ENET_INTERNAL_PHY},
  {bp_ucPhyAddress,            .u.uc = 0x0},
  {bp_usConfigType,            .u.us = BP_ENET_CONFIG_MMAP},
  {bp_ulPortMap,               .u.ul = 0x0f},
  {bp_ulPhyId0,                .u.ul = 0x01 | MAC_IF_MII},
  {bp_usNetLed0,               .u.us = BP_GPIO_50_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId1,                .u.ul = 0x02 | MAC_IF_MII},
  {bp_usNetLed0,               .u.us = BP_GPIO_51_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId2,                .u.ul = 0x03 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_47_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId3,                .u.ul = 0x04 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_42_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usGpioLedWL0Act,         .u.us = BP_GPIO_45_AL}, /* wlan0 led */
  {bp_usPonLbe,                .u.us = BP_GPIO_61_AH},
  {bp_usGpioPmdReset,          .u.us = BP_GPIO_11_AL},
  {bp_usPmdMACEwakeEn,         .u.us = BP_GPIO_4_AH},
  {bp_usExtIntrPmdAlarm,       .u.us = BP_EXT_INTR_2 | BP_EXT_INTR_TYPE_IRQ_HIGH_LEVEL | BP_EXT_INTR_TYPE_IRQ_SENSE_EDGE},
  {bp_usGpio_Intr,             .u.us = BP_GPIO_13_AH},
  {bp_pmdFunc,                 .u.us = BP_PMD_APD_TYPE_BOOST | BP_PMD_APD_REG_DISABLED},
  {bp_usUsbPwrFlt0,            .u.us = BP_GPIO_66_AL},
  {bp_usUsbPwrOn0,             .u.us = BP_GPIO_67_AL},
  {bp_ucDspType0,              .u.uc = BP_VOIP_DSP},
  {bp_ucDspAddress,            .u.uc = 0},
  {bp_last}
};

static bp_elem_t g_bcm968781ref_4gphy[] = {
  {bp_cpBoardId,               .u.cp = "968781REF_4GPHY"},
  {bp_InvSerdesRxPol,          .u.us = pmd_polarity_invert},
  {bp_InvSerdesTxPol,          .u.us = pmd_polarity_invert},
  {bp_usExtIntrResetToDefault, .u.us = BP_EXT_INTR_1 | BP_EXT_INTR_TYPE_IRQ_LOW_LEVEL | BP_EXT_INTR_TYPE_IRQ_SENSE_EDGE},
  {bp_usGpio_Intr,             .u.us = BP_GPIO_53_AL},
  {bp_usGpioI2cScl,            .u.us = BP_GPIO_62_AH},
  {bp_usGpioI2cSda,            .u.us = BP_GPIO_63_AH},
  {bp_ulMemoryConfig,          .u.ul = BP_DDR_SPEED_800_11_11_11 | BP_DDR_TOTAL_SIZE_256MB| BP_DDR_DEVICE_WIDTH_8 | BP_DDR_TOTAL_WIDTH_8BIT | BP_DDR_PCB_2LAYER},
  {bp_ucPhyType0,              .u.uc = BP_ENET_INTERNAL_PHY},
  {bp_ucPhyAddress,            .u.uc = 0x0},
  {bp_usConfigType,            .u.us = BP_ENET_CONFIG_MMAP},
  {bp_ulPortMap,               .u.ul = 0x0f},
  {bp_ulPhyId0,                .u.ul = 0x01 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_50_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId1,                .u.ul = 0x02 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_51_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId2,                .u.ul = 0x03 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_47_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId3,                .u.ul = 0x04 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_42_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usGpioLedWL0Act,         .u.us = BP_GPIO_45_AL}, /* wlan0 led */
  {bp_usPonLbe,                .u.us = BP_GPIO_61_AH},
  {bp_usGpioPmdReset,          .u.us = BP_GPIO_11_AL},
  {bp_usPmdMACEwakeEn,         .u.us = BP_GPIO_4_AH},
  {bp_usExtIntrPmdAlarm,       .u.us = BP_EXT_INTR_2 | BP_EXT_INTR_TYPE_IRQ_HIGH_LEVEL | BP_EXT_INTR_TYPE_IRQ_SENSE_EDGE},
  {bp_usGpio_Intr,             .u.us = BP_GPIO_13_AH},
  {bp_pmdFunc,                 .u.us = BP_PMD_APD_TYPE_BOOST | BP_PMD_APD_REG_DISABLED},
  {bp_usUsbPwrFlt0,            .u.us = BP_GPIO_66_AL},
  {bp_usUsbPwrOn0,             .u.us = BP_GPIO_67_AL},
  {bp_ucDspType0,              .u.uc = BP_VOIP_DSP},
  {bp_ucDspAddress,            .u.uc = 0},
  {bp_last}
};

static bp_elem_t g_bcm968781href[] = {
  {bp_cpBoardId,               .u.cp = "968781HREF"},
  {bp_elemTemplate,            .u.bp_elemp = g_bcm968781ref_4gphy},
  {bp_last}
};

static bp_elem_t g_bcm968781xsv[] = {
  {bp_cpBoardId,               .u.cp = "968781XSV"},
  {bp_usGpioI2cScl,            .u.us = BP_GPIO_62_AH},
  {bp_usGpioI2cSda,            .u.us = BP_GPIO_63_AH},
  {bp_ulMemoryConfig,          .u.ul = BP_DDR_SPEED_800_11_11_11 | BP_DDR_TOTAL_SIZE_256MB| BP_DDR_DEVICE_WIDTH_8 | BP_DDR_TOTAL_WIDTH_8BIT},
  {bp_usMiiMdc,                .u.us = BP_GPIO_52_AH},
  {bp_usMiiMdio,               .u.us = BP_GPIO_53_AH},
  {bp_usRogueOnuEn,            .u.us = BP_GPIO_13_AH},
  {bp_usSerialLedData,         .u.us = BP_GPIO_9_AH},
  {bp_usSerialLedClk,          .u.us = BP_GPIO_8_AH},
  {bp_usSerialLedMask,         .u.us = BP_GPIO_7_AH},
  {bp_ucPhyType0,              .u.uc = BP_ENET_INTERNAL_PHY},
  {bp_ucPhyAddress,            .u.uc = 0x0},
  {bp_usConfigType,            .u.us = BP_ENET_CONFIG_MMAP},
  {bp_ulPortMap,               .u.ul = 0x0f},
  {bp_usGpioLedAggregateAct,   .u.us = BP_SERIAL_GPIO_6_AL},
  {bp_usGpioLedAggregateLnk,   .u.us = BP_SERIAL_GPIO_7_AL},
  {bp_ulPhyId0,                .u.ul = 0x01 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_8_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_9_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId1,                .u.ul = 0x02 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_10_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_11_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId2,                .u.ul = 0x03 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_12_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_13_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId3,                .u.ul = 0x04 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_14_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_15_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_0_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_1_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_2_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_3_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_3_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_4_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_5_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_16_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_17_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_18_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_19_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_20_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_21_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_22_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_23_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_24_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_25_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_26_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_27_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_28_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_29_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_30_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_31_AL},
  {bp_usPonLbe,                .u.us = BP_GPIO_61_AH},
  {bp_usUsbPwrFlt0,            .u.us = BP_GPIO_66_AL},
  {bp_usUsbPwrOn0,             .u.us = BP_GPIO_67_AL},
  {bp_usSpiSlaveSelectNum,     .u.us = 0},
  {bp_usSpiSlaveSelectGpioNum, .u.us = BP_GPIO_59_AH},
  {bp_ucDspType0,              .u.uc = BP_VOIP_DSP},
  {bp_ucDspAddress,            .u.uc = 0},
  {bp_last}
};

static bp_elem_t g_bcm968781refs[] = {
  {bp_cpBoardId,               .u.cp = "968781REFS"},
  {bp_elemTemplate,            .u.bp_elemp = g_bcm968781ref},
  {bp_last}
};

static bp_elem_t g_bcm968782ref[] = {
  {bp_cpBoardId,               .u.cp = "968782REF"},
  {bp_usPcmSdin,                .u.us = BP_GPIO_0_AH},
  {bp_usPcmSdout,               .u.us = BP_GPIO_1_AH},
  {bp_usPcmClk,                 .u.us = BP_GPIO_2_AH},
  {bp_usPcmFs,                  .u.us = BP_GPIO_3_AH},
  {bp_usGpioLedUSB2,            .u.us = BP_GPIO_8_AH},
  {bp_usGpioVoip1Led,           .u.us = BP_GPIO_41_AH},
  {bp_usGpioLedUSB,             .u.us = BP_GPIO_44_AH},
  {bp_usExtIntrResetToDefault, .u.us = BP_EXT_INTR_1 | BP_EXT_INTR_TYPE_IRQ_LOW_LEVEL | BP_EXT_INTR_TYPE_IRQ_SENSE_EDGE},
  {bp_usGpio_Intr,             .u.us = BP_GPIO_53_AL},
  {bp_usGpioI2cScl,            .u.us = BP_GPIO_62_AH},
  {bp_usGpioI2cSda,            .u.us = BP_GPIO_63_AH},
  {bp_ulMemoryConfig,          .u.ul = BP_DDR_SPEED_800_11_11_11 | BP_DDR_TOTAL_SIZE_512MB| BP_DDR_DEVICE_WIDTH_16 | BP_DDR_TOTAL_WIDTH_16BIT | BP_DDR_PCB_2LAYER},
  {bp_InvSerdesRxPol,          .u.us = pmd_polarity_invert},
  {bp_InvSerdesTxPol,          .u.us = pmd_polarity_invert},
  {bp_ucPhyType0,              .u.uc = BP_ENET_INTERNAL_PHY},
  {bp_ucPhyAddress,            .u.uc = 0x0},
  {bp_usConfigType,            .u.us = BP_ENET_CONFIG_MMAP},
  {bp_ulPortMap,               .u.ul = 0x0f},
  {bp_ulPhyId0,                .u.ul = 0x01 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_50_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId1,                .u.ul = 0x02 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_51_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId2,                .u.ul = 0x03 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_47_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId3,                .u.ul = 0x04 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_42_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usPmdMACEwakeEn,         .u.us = BP_GPIO_4_AH},
  {bp_usExtIntrPmdAlarm,       .u.us = BP_EXT_INTR_2 | BP_EXT_INTR_TYPE_IRQ_HIGH_LEVEL | BP_EXT_INTR_TYPE_IRQ_SENSE_EDGE},
  {bp_usGpio_Intr,             .u.us = BP_GPIO_12_AH},
  {bp_usGpioPmdReset,          .u.us = BP_GPIO_11_AL},
  {bp_pmdFunc,                 .u.us = BP_PMD_APD_TYPE_BOOST | BP_PMD_APD_REG_DISABLED},
  {bp_usPonLbe,                .u.us = BP_GPIO_61_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_16_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_17_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_22_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_23_AH},
  {bp_ucDspType0,              .u.uc = BP_VOIP_DSP},
  {bp_ucDspAddress,            .u.uc = 0},
  {bp_last}
};

static bp_elem_t g_bcm968782ref2[] = {
  {bp_cpBoardId,               .u.cp = "968782REF2"},
  {bp_elemTemplate,            .u.bp_elemp = g_bcm968782ref},
  {bp_last}
};

static bp_elem_t g_bcm968782gref[] = {
  {bp_cpBoardId,               .u.cp = "968782GREF"},
  {bp_usPcmSdin,                .u.us = BP_GPIO_0_AH},
  {bp_usPcmSdout,               .u.us = BP_GPIO_1_AH},
  {bp_usPcmClk,                 .u.us = BP_GPIO_2_AH},
  {bp_usPcmFs,                  .u.us = BP_GPIO_3_AH},
  {bp_usSerialLedData,          .u.us = BP_GPIO_9_AH},
  {bp_usSerialLedClk,           .u.us = BP_GPIO_8_AH},
  {bp_usSerialLedMask,          .u.us = BP_GPIO_7_AH},
  {bp_usMiiMdc,                 .u.us = BP_GPIO_52_AH},
  {bp_usMiiMdio,                .u.us = BP_GPIO_53_AH},
  {bp_usGpioI2cScl,             .u.us = BP_GPIO_62_AH},
  {bp_usGpioI2cSda,             .u.us = BP_GPIO_63_AH},
  {bp_ulMemoryConfig,          .u.ul = BP_DDR_SPEED_800_11_11_11 | BP_DDR_TOTAL_SIZE_512MB| BP_DDR_DEVICE_WIDTH_16 | BP_DDR_TOTAL_WIDTH_16BIT},
  {bp_usExtIntrResetToDefault, .u.us = BP_EXT_INTR_0 | BP_EXT_INTR_TYPE_IRQ_LOW_LEVEL | BP_EXT_INTR_TYPE_IRQ_SENSE_EDGE},
  {bp_usGpio_Intr,             .u.us = BP_GPIO_60_AL},
  {bp_ucPhyType0,              .u.uc = BP_ENET_INTERNAL_PHY},
  {bp_ucPhyAddress,            .u.uc = 0x0},
  {bp_usConfigType,            .u.us = BP_ENET_CONFIG_MMAP},
  {bp_ulPortMap,               .u.ul = 0x1f},
  {bp_ulPhyId0,                .u.ul = 0x01 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_8_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_9_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId1,                .u.ul = 0x02 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_10_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_11_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId2,                .u.ul = 0x03 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_12_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_13_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId3,                .u.ul = 0x04 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_14_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_15_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId4,                .u.ul = 0x07 | MAC_IF_RGMII | PHY_EXTERNAL | PHY_INTEGRATED_VALID},
  {bp_ulPortFlags,             .u.ul = PORT_FLAG_TX_INTERNAL_DELAY},
  {bp_InvSerdesRxPol,          .u.us = pmd_polarity_invert},
  {bp_InvSerdesTxPol,          .u.us = pmd_polarity_invert},
  {bp_usPmdMACEwakeEn,         .u.us = BP_GPIO_4_AH},
  {bp_usExtIntrPmdAlarm,       .u.us = BP_EXT_INTR_1 | BP_EXT_INTR_TYPE_IRQ_HIGH_LEVEL | BP_EXT_INTR_TYPE_IRQ_SENSE_EDGE},
  {bp_usGpio_Intr,             .u.us = BP_GPIO_13_AH},
  {bp_usGpioPmdReset,          .u.us = BP_GPIO_10_AL},
  {bp_pmdFunc,                 .u.us = BP_PMD_APD_TYPE_BOOST | BP_PMD_APD_REG_DISABLED},
  {bp_usPonLbe,                .u.us = BP_GPIO_61_AH},
  {bp_usUsbPwrFlt0,            .u.us = BP_GPIO_66_AL},
  {bp_usUsbPwrOn0,             .u.us = BP_GPIO_67_AL},
  {bp_usUsbPwrFlt1,            .u.us = BP_GPIO_68_AL},
  {bp_usUsbPwrOn1,             .u.us = BP_GPIO_69_AL},
  {bp_ucDspType0,              .u.uc = BP_VOIP_DSP},
  {bp_ucDspAddress,            .u.uc = 0},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_16_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_17_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_18_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_19_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_20_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_21_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_22_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_23_AL},
  {bp_last}
};

static bp_elem_t g_bcm968782gfm[] = {
  {bp_cpBoardId,               .u.cp = "968782GFM"},
  {bp_elemTemplate,            .u.bp_elemp = g_bcm968782gref},
  {bp_last}
};

static bp_elem_t g_bcm968782xsv[] = {
  {bp_cpBoardId,               .u.cp = "968782XSV"},
  {bp_usGpioI2cScl,            .u.us = BP_GPIO_62_AH},
  {bp_usGpioI2cSda,            .u.us = BP_GPIO_63_AH},
  {bp_ulMemoryConfig,          .u.ul = BP_DDR_SPEED_800_11_11_11 | BP_DDR_TOTAL_SIZE_512MB| BP_DDR_DEVICE_WIDTH_16 | BP_DDR_TOTAL_WIDTH_16BIT},
  {bp_usWanEarlyTxEn,          .u.us = BP_GPIO_4_AH},
  {bp_usMiiMdc,                .u.us = BP_GPIO_52_AH},
  {bp_usMiiMdio,               .u.us = BP_GPIO_53_AH},
  {bp_usRogueOnuEn,            .u.us = BP_GPIO_13_AH},
  {bp_usSerialLedData,         .u.us = BP_GPIO_9_AH},
  {bp_usSerialLedClk,          .u.us = BP_GPIO_8_AH},
  {bp_usSerialLedMask,         .u.us = BP_GPIO_7_AH},
  {bp_ucPhyType0,              .u.uc = BP_ENET_INTERNAL_PHY},
  {bp_ucPhyAddress,            .u.uc = 0x0},
  {bp_usConfigType,            .u.us = BP_ENET_CONFIG_MMAP},
  {bp_ulPortMap,               .u.ul = 0x1f},
  {bp_usGpioLedAggregateAct,   .u.us = BP_SERIAL_GPIO_6_AL},
  {bp_usGpioLedAggregateLnk,   .u.us = BP_SERIAL_GPIO_7_AL},
  {bp_ulPhyId0,                .u.ul = 0x01 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_8_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_9_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId1,                .u.ul = 0x02 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_10_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_11_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId2,                .u.ul = 0x03 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_12_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_13_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId3,                .u.ul = 0x04 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_SERIAL_GPIO_14_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_usNetLed1,               .u.us = BP_SERIAL_GPIO_15_AL},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId4,                .u.ul = 0x07 | MAC_IF_RGMII | PHY_EXTERNAL | PHY_INTEGRATED_VALID},
  {bp_ulPortFlags,             .u.ul = PORT_FLAG_TX_INTERNAL_DELAY},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_0_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_1_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_2_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_3_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_3_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_4_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_5_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_16_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_17_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_18_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_19_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_20_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_21_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_22_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_23_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_24_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_25_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_26_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_27_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_28_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_29_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_30_AL},
  {bp_usGpioLedReserved,       .u.us = BP_SERIAL_GPIO_31_AL},
  {bp_usPonLbe,                .u.us = BP_GPIO_61_AH},
  {bp_usUsbPwrFlt0,            .u.us = BP_GPIO_66_AL},
  {bp_usUsbPwrOn0,             .u.us = BP_GPIO_67_AL},
  {bp_usSpiSlaveSelectNum,     .u.us = 0},
  {bp_usSpiSlaveSelectGpioNum, .u.us = BP_GPIO_59_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_16_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_17_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_22_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_23_AH},
  {bp_usSpiSlaveSelectNum,     .u.us = 0},
  {bp_usSpiSlaveSelectGpioNum, .u.us = BP_GPIO_59_AH},
  {bp_ucDspType0,              .u.uc = BP_VOIP_DSP},
  {bp_ucDspAddress,            .u.uc = 0},
  // {bp_usGpioUart2Sdin,         .u.us = BP_GPIO_10_AH},
  // {bp_usGpioUart2Sdout,        .u.us = BP_GPIO_11_AH},
  // {bp_usGpioUart2Cts,          .u.us = BP_GPIO_9_AH},
  // {bp_usGpioUart2Rts,          .u.us = BP_GPIO_12_AH},
  {bp_last}
};

static bp_elem_t g_bcm968780rfdvt[] = {
  {bp_cpBoardId,               .u.cp = "968780RFDVT"},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_0_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_1_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_2_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_3_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_14_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_15_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_16_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_17_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_20_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_21_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_22_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_23_AH},
  {bp_usGpioWlanReserved,      .u.us = BP_GPIO_44_AH},
  {bp_usGpioI2cScl,            .u.us = BP_GPIO_62_AH},
  {bp_usGpioI2cSda,            .u.us = BP_GPIO_63_AH},
  {bp_ulMemoryConfig,          .u.ul = BP_DDR_SPEED_800_11_11_11 | BP_DDR_TOTAL_SIZE_512MB| BP_DDR_DEVICE_WIDTH_16 | BP_DDR_TOTAL_WIDTH_16BIT},
  {bp_usSpiSlaveSelectNum,     .u.us = 0},
  {bp_usSpiSlaveSelectGpioNum, .u.us = BP_GPIO_59_AH},
  {bp_usSpiSlaveSelectNum,     .u.us = 1},
  {bp_usSpiSlaveSelectGpioNum, .u.us = BP_GPIO_60_AH},
  {bp_usUsbPwrFlt0,            .u.us = BP_GPIO_66_AL},
  {bp_usUsbPwrOn0,             .u.us = BP_GPIO_67_AL},
  {bp_usUsbPwrFlt1,            .u.us = BP_GPIO_68_AL},
  {bp_usUsbPwrOn1,             .u.us = BP_GPIO_69_AL},
  {bp_usExtIntrResetToDefault, .u.us = BP_EXT_INTR_0 | BP_EXT_INTR_TYPE_IRQ_LOW_LEVEL | BP_EXT_INTR_TYPE_IRQ_SENSE_EDGE},
  {bp_usGpio_Intr,             .u.us = BP_GPIO_53_AL},
  {bp_ucPhyType0,              .u.uc = BP_ENET_INTERNAL_PHY},
  {bp_ucPhyAddress,            .u.uc = 0x0},
  {bp_usConfigType,            .u.us = BP_ENET_CONFIG_MMAP},
  {bp_ulPortMap,               .u.ul = 0x03},
  {bp_ulPhyId0,                .u.ul = 0x01 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_50_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulPhyId1,                .u.ul = 0x02 | MAC_IF_GMII},
  {bp_usNetLed0,               .u.us = BP_GPIO_51_AL},
  {bp_ulNetLedLink,            .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ulNetLedActivity,        .u.ul = BP_NET_LED_SPEED_GBE},
  {bp_ucDspType0,              .u.uc = BP_VOIP_DSP},
  {bp_ucDspAddress,            .u.uc = 0},
  {bp_last}
};

bp_elem_t * g_BoardParms[] = {g_bcm968781ref, g_bcm968781ref_4gphy, g_bcm968781href, g_bcm968781xsv, g_bcm968781refs, g_bcm968782ref, g_bcm968782xsv,g_bcm968780rfdvt, g_bcm968782gref, g_bcm968782ref2, g_bcm968782gfm, 0};


