/**
 * hooks for in amba-pl011.c
 */
#include <linux/errno.h>

#include "amba-pl011-dectuart.h"

struct _pl011_dectuart pl011_dectuart;

/**
 */
int pl011_dectuart_get_char(void)
{
	struct _pl011_dectuart *pdectuart = &pl011_dectuart;

	if (pdectuart->pl011_dectuart_get_char) {
		return pdectuart->pl011_dectuart_get_char();
	}
	return -ENODEV;
}
EXPORT_SYMBOL(pl011_dectuart_get_char);

/**
 */
void pl011_dectuart_put_char(unsigned char ch)
{
	struct _pl011_dectuart *pdectuart = &pl011_dectuart;

	if (pdectuart->pl011_dectuart_put_char) {
		pdectuart->pl011_dectuart_put_char(ch);
	}
}
EXPORT_SYMBOL(pl011_dectuart_put_char);

/**
 * mode: dummy
 */
void pl011_dectuart_init(unsigned int baud, int mode)
{
	struct _pl011_dectuart *pdectuart = &pl011_dectuart;

	if (pdectuart->pl011_dectuart_init) {
		pdectuart->pl011_dectuart_init(baud, mode);
	}
}
EXPORT_SYMBOL(pl011_dectuart_init);

/**
 */
void pl011_console_stop(void)
{
	struct _pl011_dectuart *pdectuart = &pl011_dectuart;

	if (pdectuart->pl011_console_stop) {
		pdectuart->shared_uart_mode = 1;
		pdectuart->pl011_console_stop();
	}
}
EXPORT_SYMBOL(pl011_console_stop);

/**
 */
void pl011_console_start(void)
{
	struct _pl011_dectuart *pdectuart = &pl011_dectuart;

	if (pdectuart->pl011_console_start) {
		pdectuart->pl011_console_start();
	}
}
EXPORT_SYMBOL(pl011_console_start);

/**
 */
void pl011_dectuart_exit(void)
{
	struct _pl011_dectuart *pdectuart = &pl011_dectuart;

	if (pdectuart->pl011_dectuart_exit) {
		pdectuart->pl011_dectuart_exit();
	}
}
EXPORT_SYMBOL(pl011_dectuart_exit);
