/**
 */
#include <asm/mach_avm.h>
struct _pl011_dectuart {
	struct uart_port *port;
	atomic_t     busy;
	unsigned int shared_uart_mode;
	unsigned int save_im;
	unsigned int irq_off;

	int (*pl011_dectuart_get_char)(void);
	void (*pl011_dectuart_put_char)(unsigned char ch);
	void (*pl011_dectuart_init)(unsigned int baud, int mode);
	void (*pl011_console_stop)(void);
	void (*pl011_console_start)(void);
	void (*pl011_dectuart_exit)(void);
};

extern struct _pl011_dectuart pl011_dectuart;

/**
 */
static inline int pl011_dectuart_is_busy(struct _pl011_dectuart *pdectuart)
{
	return atomic_read(&pdectuart->busy);
}

/**
 */
static inline int pl011_dectuart_is_shared_uart(struct _pl011_dectuart *pdectuart)
{
	return pdectuart->shared_uart_mode;
}
