/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: EPN_CONTROL_0_CFGEN1588TS
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_CFGEN1588TS_FIELD =
{
    "CFGEN1588TS",
#if RU_INCLUDE_DESC
    "",
    "Enable IEEE 1588 packet timestamping, applicable only in"
    "point-to-point mode.",
#endif
    EPN_CONTROL_0_CFGEN1588TS_FIELD_MASK,
    0,
    EPN_CONTROL_0_CFGEN1588TS_FIELD_WIDTH,
    EPN_CONTROL_0_CFGEN1588TS_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_CFGREPLACEUPFCS
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD =
{
    "CFGREPLACEUPFCS",
#if RU_INCLUDE_DESC
    "",
    "Replaces FCS of upstream packet, resulting in no change in packet's"
    "length. Set cfgAppendUpFcs/cfgReplaceUpFcs to 0 for pass-through.",
#endif
    EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD_MASK,
    0,
    EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD_WIDTH,
    EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_CFGAPPENDUPFCS
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD =
{
    "CFGAPPENDUPFCS",
#if RU_INCLUDE_DESC
    "",
    "Appends FCS to upstream packet, resulting in increase of packet's"
    "length +4 bytes.  Set cfgAppendUpFcs/cfgReplaceUpFcs to 0 for"
    "pass-through.",
#endif
    EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD_MASK,
    0,
    EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD_WIDTH,
    EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_CFGDROPSCB
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_CFGDROPSCB_FIELD =
{
    "CFGDROPSCB",
#if RU_INCLUDE_DESC
    "",
    "Drops Single Copy Broadcast packets that are unmapped by the LIF."
    "0: Ignore LLID bit 15."
    "1: Drop packets that have LLID bit 15 set and have LLID index bit 5"
    "set.",
#endif
    EPN_CONTROL_0_CFGDROPSCB_FIELD_MASK,
    0,
    EPN_CONTROL_0_CFGDROPSCB_FIELD_WIDTH,
    EPN_CONTROL_0_CFGDROPSCB_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD =
{
    "MODUNCAPPEDREPORTLIMIT",
#if RU_INCLUDE_DESC
    "",
    "Ignores the first queue set limits. This is only applied when"
    "Threshold First Queue Service Discipline is enabled."
    "0: Transmit packets in the order they were last reported in the"
    "first queue set."
    "1: Transmit packets in the order they were last reported in the"
    "un-capped queue set.",
#endif
    EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD_MASK,
    0,
    EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD_WIDTH,
    EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_MODMPQUESETFIRST
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_MODMPQUESETFIRST_FIELD =
{
    "MODMPQUESETFIRST",
#if RU_INCLUDE_DESC
    "",
    "Enables Threshold First Queue Service Discipline.  This is only"
    "applied to multi-priority reporting mode."
    "0: Strict priority. The highest priority packet is transmitted."
    "This mode 'pulls' late-arriving/un-reported high priority packets"
    "ahead of previously reported lower priority packets."
    "1: Transmit packets in the order they were last reported.",
#endif
    EPN_CONTROL_0_MODMPQUESETFIRST_FIELD_MASK,
    0,
    EPN_CONTROL_0_MODMPQUESETFIRST_FIELD_WIDTH,
    EPN_CONTROL_0_MODMPQUESETFIRST_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_CONTROL_0_RESERVED0_FIELD_MASK,
    0,
    EPN_CONTROL_0_RESERVED0_FIELD_WIDTH,
    EPN_CONTROL_0_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD =
{
    "PRVLOCALMPCPPROPAGATION",
#if RU_INCLUDE_DESC
    "",
    "Propagates the ONU's local MPCP time by replacing the last four"
    "bytes of a GATE frame with the MPCP time the GATE arrived at the"
    "ONU.  This only applies to downstream gate messages passed from the"
    "Epn to the BBH."
    "0: Do not propagate the local MPCP time"
    "1: Propagate the local MPCP time",
#endif
    EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD_MASK,
    0,
    EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD_WIDTH,
    EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_PRVTEKMODEPREFETCH
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD =
{
    "PRVTEKMODEPREFETCH",
#if RU_INCLUDE_DESC
    "",
    "Allows accumulator 3 to be prefetched before accumulator 0 is"
    "emptied and the accumulator shift occurs. This eliminates the race"
    "starting when the accumulators shift and their values are reported"
    "(i.e. accumulator 3 will fully represent the current queue state)."
    "0: Do not prefetch accumulator 3"
    "1: Prefetch accumulator 3",
#endif
    EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD_MASK,
    0,
    EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD_WIDTH,
    EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_CONTROL_0_RESERVED1_FIELD_MASK,
    0,
    EPN_CONTROL_0_RESERVED1_FIELD_WIDTH,
    EPN_CONTROL_0_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_PRVINCNONZEROACCUM
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_PRVINCNONZEROACCUM_FIELD =
{
    "PRVINCNONZEROACCUM",
#if RU_INCLUDE_DESC
    "",
    "Causes non-zero accumulator values to be incremented before being"
    "reported upstream."
    "0: No accumulator values are incremented"
    "1: Non-zero accumulator values are incremented",
#endif
    EPN_CONTROL_0_PRVINCNONZEROACCUM_FIELD_MASK,
    0,
    EPN_CONTROL_0_PRVINCNONZEROACCUM_FIELD_WIDTH,
    EPN_CONTROL_0_PRVINCNONZEROACCUM_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_PRVNOUNMAPPPEDFCS
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD =
{
    "PRVNOUNMAPPPEDFCS",
#if RU_INCLUDE_DESC
    "",
    "Disables FCS checking of un-mapped frames. This is intended to be"
    "used when passing unmapped frames to a UNI port."
    "0: All FCS errored un-mapped frames are discarded"
    "1: All un-mapped frames are passed to a UNI port",
#endif
    EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD_MASK,
    0,
    EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD_WIDTH,
    EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_PRVSUPRESSDISCEN
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD =
{
    "PRVSUPRESSDISCEN",
#if RU_INCLUDE_DESC
    "",
    "Causes discovery gates for empty queues to be discarded."
    "0: All discovery gates are processed"
    "1: Discovery gates for empty queues are discarded",
#endif
    EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD_MASK,
    0,
    EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD_WIDTH,
    EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_CFGVLANMAX
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_CFGVLANMAX_FIELD =
{
    "CFGVLANMAX",
#if RU_INCLUDE_DESC
    "",
    "Overrides the value in EPON Downstream Max Size Frame register."
    "0: Use Downstream Max Size Frame register value"
    "1: The maximum frame size for non-VLAN frames is 1518 and the"
    "maximum size for VLAN-tagged frames is 1522",
#endif
    EPN_CONTROL_0_CFGVLANMAX_FIELD_MASK,
    0,
    EPN_CONTROL_0_CFGVLANMAX_FIELD_WIDTH,
    EPN_CONTROL_0_CFGVLANMAX_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_FCSERRONLYDATAFR
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD =
{
    "FCSERRONLYDATAFR",
#if RU_INCLUDE_DESC
    "",
    "Determines which types of upstream frames are affected when forcing"
    "upstream FCS errors (as configured in EPON Force FCS Error register)"
    "0: Force FCS errors on all upstream frames."
    "1: Force FCS errors on user data frames only (not REPORT or"
    "processor frames).",
#endif
    EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD_MASK,
    0,
    EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD_WIDTH,
    EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_RESERVED2
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_RESERVED2_FIELD =
{
    "RESERVED2",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_CONTROL_0_RESERVED2_FIELD_MASK,
    0,
    EPN_CONTROL_0_RESERVED2_FIELD_WIDTH,
    EPN_CONTROL_0_RESERVED2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD =
{
    "PRVDROPUNMAPPPEDLLID",
#if RU_INCLUDE_DESC
    "",
    "Determines handling of traffic not mapped to a provisioned LLID"
    "0: Forward unmapped packets"
    "1: Drop unmapped packets",
#endif
    EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD_MASK,
    0,
    EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD_WIDTH,
    EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD =
{
    "PRVSUPPRESSLLIDMODEBIT",
#if RU_INCLUDE_DESC
    "",
    "Controls LLID mode bit suppression"
    "0: LLID mode enabled"
    "1: Suppress LLID mode by masking bit-15 of the LLID",
#endif
    EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD_MASK,
    0,
    EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD_WIDTH,
    EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_MODDISCOVERYDAFILTEREN
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD =
{
    "MODDISCOVERYDAFILTEREN",
#if RU_INCLUDE_DESC
    "",
    "Discovery gate destination address filter enable."
    "0: Always ignore discovery gate DA value"
    "1: Process discovery gate only if the following criteria are met."
    "Please keep in mind the functionality provided by the legacy \"Drop"
    "Discovery Gate\" controls. No discovery gate will be processed if the"
    "discovery gate's LLID index has been provisioned to \"Drop Discovery"
    "Gates\". Also, only the first 8 LLID index values are eligible for"
    "discovery gate processing. Discovery gates with any other LLID index"
    "values received from the LIF will not be processed."
    "When this feature is disabled the discovery DA is ignored. When this"
    "feature is enabled there are four possible scenarios:"
    "(1) Received broadcast LLID (0x7FFF) and a unicast (not broadcast"
    "and not multicast) DA."
    "Discovery gate is processed if one of the provisioned ONT addresses"
    "must match the discovery gate's DA."
    "(2) Received broadcast LLID (0x7FFF) and a broadcast DA."
    "Discovery gate is processed. i.e., the discovery gate's DA is"
    "ignored."
    "(3) Received a non-broadcast LLID and a unicast DA."
    "Discovery gate is processed if the discovery gate's LLID index"
    "provisioned ONT address matches its DA."
    "(4) Received a non-broadcast LLID and a broadcast DA."
    "Discovery gate is processed. i.e., the discovery gate's DA is"
    "ignored."
    "Please remember the \"Drop Discovery Gate\" control takes precedence"
    "over all other configuration options",
#endif
    EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD_MASK,
    0,
    EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD_WIDTH,
    EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_RPTSELECT
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_RPTSELECT_FIELD =
{
    "RPTSELECT",
#if RU_INCLUDE_DESC
    "",
    "Selects the number of Queue Sets generated for all LLID Indexes"
    "0: Dual queue set  (default)"
    "1: Multi queue set ('Teknovus-style')"
    "Others: Reserved",
#endif
    EPN_CONTROL_0_RPTSELECT_FIELD_MASK,
    0,
    EPN_CONTROL_0_RPTSELECT_FIELD_WIDTH,
    EPN_CONTROL_0_RPTSELECT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD =
{
    "PRVDISABLESVAQUESTATUSBP",
#if RU_INCLUDE_DESC
    "",
    "Disables Shaped Virtual Accumulator backpressure of BBH queue status"
    "interface."
    "0: SVA normal operation.  Allows shapers to backpressure the BBH"
    "queue status interface."
    "1: Disables Shaped Virtual Accumulator backpressure of BBH queue"
    "status interface..",
#endif
    EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD_MASK,
    0,
    EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD_WIDTH,
    EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_UTXLOOPBACK
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_UTXLOOPBACK_FIELD =
{
    "UTXLOOPBACK",
#if RU_INCLUDE_DESC
    "",
    "Places the upstream transmitter (UTX) in loopback mode."
    "0: UTX normal operation"
    "1: UTX is in loopback mode. This setting is also used for Point to"
    "Point mode (in conjunction with settings in the LIF Control"
    "register).",
#endif
    EPN_CONTROL_0_UTXLOOPBACK_FIELD_MASK,
    0,
    EPN_CONTROL_0_UTXLOOPBACK_FIELD_WIDTH,
    EPN_CONTROL_0_UTXLOOPBACK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_UTXEN
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_UTXEN_FIELD =
{
    "UTXEN",
#if RU_INCLUDE_DESC
    "",
    "UTX Enable bit."
    "0: Disable the UTX block"
    "1: Enable UTX operation",
#endif
    EPN_CONTROL_0_UTXEN_FIELD_MASK,
    0,
    EPN_CONTROL_0_UTXEN_FIELD_WIDTH,
    EPN_CONTROL_0_UTXEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_UTXRST_PRE_N
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_UTXRST_PRE_N_FIELD =
{
    "UTXRST_PRE_N",
#if RU_INCLUDE_DESC
    "",
    "Reset the EPN upstream transmitter (UTX) logic. Asserting (active"
    "low) this bit resets all UTX state machines and pointers. Note that"
    "this does not reset the UTX configuration registers."
    "0: Hold the UTX in reset"
    "1: Normal UTX operation",
#endif
    EPN_CONTROL_0_UTXRST_PRE_N_FIELD_MASK,
    0,
    EPN_CONTROL_0_UTXRST_PRE_N_FIELD_WIDTH,
    EPN_CONTROL_0_UTXRST_PRE_N_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_CFGDISABLEDNS
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_CFGDISABLEDNS_FIELD =
{
    "CFGDISABLEDNS",
#if RU_INCLUDE_DESC
    "",
    "Prevents any downstream traffic from being sent to the BBH. This"
    "control is only applied between downstream packets. So, it can be"
    "toggled any time the drxEn bit is set."
    "0: Normal operation."
    "1: No data is sent to BBH.",
#endif
    EPN_CONTROL_0_CFGDISABLEDNS_FIELD_MASK,
    0,
    EPN_CONTROL_0_CFGDISABLEDNS_FIELD_WIDTH,
    EPN_CONTROL_0_CFGDISABLEDNS_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_DRXLOOPBACK
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_DRXLOOPBACK_FIELD =
{
    "DRXLOOPBACK",
#if RU_INCLUDE_DESC
    "",
    "Places the downstream receiver (DRX) in loopback mode. The loopback"
    "mode disables the EPON processing in EPN's downstream data path. It"
    "does not 'loopback' any data."
    "0: DRX normal operation"
    "1: DRX is in loopback mode",
#endif
    EPN_CONTROL_0_DRXLOOPBACK_FIELD_MASK,
    0,
    EPN_CONTROL_0_DRXLOOPBACK_FIELD_WIDTH,
    EPN_CONTROL_0_DRXLOOPBACK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_DRXEN
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_DRXEN_FIELD =
{
    "DRXEN",
#if RU_INCLUDE_DESC
    "",
    "DRX Enable bit."
    "0: Disable the DRX block"
    "1: Enable DRX operation",
#endif
    EPN_CONTROL_0_DRXEN_FIELD_MASK,
    0,
    EPN_CONTROL_0_DRXEN_FIELD_WIDTH,
    EPN_CONTROL_0_DRXEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_0_DRXRST_PRE_N
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_0_DRXRST_PRE_N_FIELD =
{
    "DRXRST_PRE_N",
#if RU_INCLUDE_DESC
    "",
    "Reset the EPN downstream receiver (DRX) logic. Asserting (active"
    "low) this bit resets all DRX state machines and pointers. Note that"
    "this does not reset the DRX configuration registers."
    "0: Hold the DRX in reset"
    "1: Normal DRX operation",
#endif
    EPN_CONTROL_0_DRXRST_PRE_N_FIELD_MASK,
    0,
    EPN_CONTROL_0_DRXRST_PRE_N_FIELD_WIDTH,
    EPN_CONTROL_0_DRXRST_PRE_N_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_CONTROL_1_RESERVED0_FIELD_MASK,
    0,
    EPN_CONTROL_1_RESERVED0_FIELD_WIDTH,
    EPN_CONTROL_1_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_CFGIDLEPACKETTXENABLE
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_CFGIDLEPACKETTXENABLE_FIELD =
{
    "CFGIDLEPACKETTXENABLE",
#if RU_INCLUDE_DESC
    "",
    "When this bit is set, the EPON MAC will tag completely tardy"
    "upstream packets as an idle packet by replacing"
    "the SOF transfer type with 5'd23. The XIF will detect the idle"
    "packet SOF tag and replace the entire packet with idles."
    "In the case of 1G the 5'd23 SOF is converted to 3'd6 to get past the"
    "TimeStamp logic and then converted to 3'd5 so the LIF"
    "can detect the idle packet SOF tag and replace the entire packet"
    "with idles."
    "Partially tardy packets are still faked and their FCS values"
    "replaced with zeros.   Do not enable this feature for AE or P2P"
    "operating modes."
    "Default value is 0",
#endif
    EPN_CONTROL_1_CFGIDLEPACKETTXENABLE_FIELD_MASK,
    0,
    EPN_CONTROL_1_CFGIDLEPACKETTXENABLE_FIELD_WIDTH,
    EPN_CONTROL_1_CFGIDLEPACKETTXENABLE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD =
{
    "CFGDISABLEMPCPCORRECTIONDITHERING",
#if RU_INCLUDE_DESC
    "",
    "When this bit is set, the EPON MAC will not dither the MPCP"
    "correction values sent to the LIF. Default value is 0",
#endif
    EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD_MASK,
    0,
    EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD_WIDTH,
    EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD =
{
    "PRVOVERLAPPEDGNTENABLE",
#if RU_INCLUDE_DESC
    "",
    "Enables adjustment of \"destructively overlapped\" grants."
    "Destructively overlapped grants are grants that overlap by more than"
    "the provisioned grant overhead (Lon + Loff + Sync time)."
    "0: Disable adjustment of destructively overlapped grants."
    "Destuctively overlapped grants are dropped and the GrantMisalign"
    "interrupt sets."
    "1: Destructively overlapped grants are adjusted to limit overlap to"
    "the grant overhead value (which maximizes the useful length of the"
    "earlier grant).",
#endif
    EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD_MASK,
    0,
    EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD_WIDTH,
    EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_RSTMISALIGNTHR
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_RSTMISALIGNTHR_FIELD =
{
    "RSTMISALIGNTHR",
#if RU_INCLUDE_DESC
    "",
    "Reset the grant misalignment hardware",
#endif
    EPN_CONTROL_1_RSTMISALIGNTHR_FIELD_MASK,
    0,
    EPN_CONTROL_1_RSTMISALIGNTHR_FIELD_WIDTH,
    EPN_CONTROL_1_RSTMISALIGNTHR_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_CONTROL_1_RESERVED1_FIELD_MASK,
    0,
    EPN_CONTROL_1_RESERVED1_FIELD_WIDTH,
    EPN_CONTROL_1_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_CFGSTALEGNTCHK
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD =
{
    "CFGSTALEGNTCHK",
#if RU_INCLUDE_DESC
    "",
    "When this bit is set, the EPON MAC will check the grant FIFOs for"
    "stale grants, and delete them. A stale grant has a grant start time"
    "that is smaller (earlier) than the local ONU time. Default value is"
    "1",
#endif
    EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD_MASK,
    0,
    EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD_WIDTH,
    EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_FECRPTEN
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_FECRPTEN_FIELD =
{
    "FECRPTEN",
#if RU_INCLUDE_DESC
    "",
    "Global upstream FEC enable. When this bit is set, the EPON MAC will"
    "take into account FEC overhead when generating report frames and"
    "filling grants. Please note that the per-LLID index bit must also be"
    "set.",
#endif
    EPN_CONTROL_1_FECRPTEN_FIELD_MASK,
    0,
    EPN_CONTROL_1_FECRPTEN_FIELD_WIDTH,
    EPN_CONTROL_1_FECRPTEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_RESERVED2
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_RESERVED2_FIELD =
{
    "RESERVED2",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_CONTROL_1_RESERVED2_FIELD_MASK,
    0,
    EPN_CONTROL_1_RESERVED2_FIELD_WIDTH,
    EPN_CONTROL_1_RESERVED2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_CFGL1L2TRUESTRICT
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD =
{
    "CFGL1L2TRUESTRICT",
#if RU_INCLUDE_DESC
    "",
    "Enables an alternate scheme in the L1-to-L2 strict-priority"
    "scheduler. This alternate scheme is useful only when both"
    "cfgSharedBurstCap and cfgSharedL2 are set (\"TK3715 CTC"
    "compatibility\" mode)."
    "Note: Support for this bit begins in Revision B0."
    "0: Default scheme."
    "1: Alternate mode. Use only in multi-priority mode when"
    "cfgSharedBurstCap is set.",
#endif
    EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD_MASK,
    0,
    EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD_WIDTH,
    EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_CFGCTCRPT
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_CFGCTCRPT_FIELD =
{
    "CFGCTCRPT",
#if RU_INCLUDE_DESC
    "",
    "Sets the number of priorities for multi-priority mode. The 24"
    "available L2s queues are sequentially mapped to the priorities"
    "within each LLID index. For example in mode \"01\": L2s queue 0 is"
    "mapped to LLID index 0 priority 0; L2s queue 1 is mapped to LLID"
    "index 0 priority 1; L2s queue 2 is mapped to LLID index 0 priority"
    "2;  L2s queue 3 is mapped to LLID index 1 priority 0; and so on."
    ""
    "00: Multi-priority mode disabled."
    "01: Eight LLID indexes with 3 priorities each."
    "10: Six LLID indexes with 4 priorities each."
    "11: Three LLID indexes with 8-priorities each.",
#endif
    EPN_CONTROL_1_CFGCTCRPT_FIELD_MASK,
    0,
    EPN_CONTROL_1_CFGCTCRPT_FIELD_WIDTH,
    EPN_CONTROL_1_CFGCTCRPT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_CFGTSCORRDIS
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_CFGTSCORRDIS_FIELD =
{
    "CFGTSCORRDIS",
#if RU_INCLUDE_DESC
    "",
    "Disables incremental (+1, -1) correction of local downstream MPCP"
    "time. When set, MPCP time is updated only when the difference"
    "between the local MPCP time and the timestamp received in an MPCPDU"
    "is different by greater than the EPN Time Stamp Differential"
    "register value.",
#endif
    EPN_CONTROL_1_CFGTSCORRDIS_FIELD_MASK,
    0,
    EPN_CONTROL_1_CFGTSCORRDIS_FIELD_WIDTH,
    EPN_CONTROL_1_CFGTSCORRDIS_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_CFGNODISCRPT
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_CFGNODISCRPT_FIELD =
{
    "CFGNODISCRPT",
#if RU_INCLUDE_DESC
    "",
    "When set the ONU will ignore the force report bit on discovery"
    "frames.",
#endif
    EPN_CONTROL_1_CFGNODISCRPT_FIELD_MASK,
    0,
    EPN_CONTROL_1_CFGNODISCRPT_FIELD_WIDTH,
    EPN_CONTROL_1_CFGNODISCRPT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_DISABLEDISCSCALE
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_DISABLEDISCSCALE_FIELD =
{
    "DISABLEDISCSCALE",
#if RU_INCLUDE_DESC
    "",
    "When this bit is set, the start time offset for a discovery response"
    "will be equal to the discovery seed. Units of the offset are 16-bit"
    "times.",
#endif
    EPN_CONTROL_1_DISABLEDISCSCALE_FIELD_MASK,
    0,
    EPN_CONTROL_1_DISABLEDISCSCALE_FIELD_WIDTH,
    EPN_CONTROL_1_DISABLEDISCSCALE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CONTROL_1_CLRONRD
 ******************************************************************************/
const ru_field_rec EPN_CONTROL_1_CLRONRD_FIELD =
{
    "CLRONRD",
#if RU_INCLUDE_DESC
    "",
    "All statistics RAM reads will clear the read location.",
#endif
    EPN_CONTROL_1_CLRONRD_FIELD_MASK,
    0,
    EPN_CONTROL_1_CLRONRD_FIELD_WIDTH,
    EPN_CONTROL_1_CLRONRD_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT31
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT31_FIELD =
{
    "ENGNT31",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 31."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT31_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT31_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT30
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT30_FIELD =
{
    "ENGNT30",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 30."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT30_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT30_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT29
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT29_FIELD =
{
    "ENGNT29",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 29."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT29_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT29_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT28
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT28_FIELD =
{
    "ENGNT28",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 28."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT28_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT28_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT27
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT27_FIELD =
{
    "ENGNT27",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 27."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT27_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT27_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT26
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT26_FIELD =
{
    "ENGNT26",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 26."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT26_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT26_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT25
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT25_FIELD =
{
    "ENGNT25",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 25."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT25_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT25_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT24
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT24_FIELD =
{
    "ENGNT24",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 24."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT24_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT24_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT23
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT23_FIELD =
{
    "ENGNT23",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 23."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT23_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT23_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT22
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT22_FIELD =
{
    "ENGNT22",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 22."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT22_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT22_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT21
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT21_FIELD =
{
    "ENGNT21",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 21."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT21_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT21_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT20
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT20_FIELD =
{
    "ENGNT20",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 20."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT20_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT20_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT19
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT19_FIELD =
{
    "ENGNT19",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 19."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT19_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT19_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT18
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT18_FIELD =
{
    "ENGNT18",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 18."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT18_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT18_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT17
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT17_FIELD =
{
    "ENGNT17",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 17."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT17_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT17_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT16
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT16_FIELD =
{
    "ENGNT16",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 16."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT16_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT16_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT15
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT15_FIELD =
{
    "ENGNT15",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 15."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT15_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT15_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT14
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT14_FIELD =
{
    "ENGNT14",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 14."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT14_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT14_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT13
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT13_FIELD =
{
    "ENGNT13",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 13."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT13_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT13_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT12
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT12_FIELD =
{
    "ENGNT12",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 12."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT12_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT12_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT11
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT11_FIELD =
{
    "ENGNT11",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 11."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT11_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT11_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT10
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT10_FIELD =
{
    "ENGNT10",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 10."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT10_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT10_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT9
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT9_FIELD =
{
    "ENGNT9",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 9."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT9_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT9_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT8
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT8_FIELD =
{
    "ENGNT8",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 8."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT8_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT8_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT7
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT7_FIELD =
{
    "ENGNT7",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 7."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT7_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT7_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT6
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT6_FIELD =
{
    "ENGNT6",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 6."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT6_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT6_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT5
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT5_FIELD =
{
    "ENGNT5",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 5."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT5_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT5_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT4
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT4_FIELD =
{
    "ENGNT4",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 4."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT4_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT4_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT3
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT3_FIELD =
{
    "ENGNT3",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 3."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT3_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT3_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT2
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT2_FIELD =
{
    "ENGNT2",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 2."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT2_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT2_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT1
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT1_FIELD =
{
    "ENGNT1",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 1."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT1_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT1_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_GRANTS_ENGNT0
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_GRANTS_ENGNT0_FIELD =
{
    "ENGNT0",
#if RU_INCLUDE_DESC
    "",
    "Enable Grants on LLID Index 0."
    "Reset default is 1.",
#endif
    EPN_ENABLE_GRANTS_ENGNT0_FIELD_MASK,
    0,
    EPN_ENABLE_GRANTS_ENGNT0_FIELD_WIDTH,
    EPN_ENABLE_GRANTS_ENGNT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES31
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES31_FIELD =
{
    "SINKDISCGATES31",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 31.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES31_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES31_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES30
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES30_FIELD =
{
    "SINKDISCGATES30",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 30.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES30_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES30_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES29
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES29_FIELD =
{
    "SINKDISCGATES29",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 29.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES29_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES29_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES28
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES28_FIELD =
{
    "SINKDISCGATES28",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 28.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES28_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES28_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES27
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES27_FIELD =
{
    "SINKDISCGATES27",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 27.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES27_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES27_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES26
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES26_FIELD =
{
    "SINKDISCGATES26",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 26.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES26_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES26_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES25
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES25_FIELD =
{
    "SINKDISCGATES25",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 25.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES25_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES25_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES24
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES24_FIELD =
{
    "SINKDISCGATES24",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 24.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES24_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES24_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES23
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES23_FIELD =
{
    "SINKDISCGATES23",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 23.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES23_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES23_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES22
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES22_FIELD =
{
    "SINKDISCGATES22",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 22.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES22_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES22_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES21
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES21_FIELD =
{
    "SINKDISCGATES21",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 21.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES21_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES21_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES20
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES20_FIELD =
{
    "SINKDISCGATES20",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 20.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES20_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES20_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES19
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES19_FIELD =
{
    "SINKDISCGATES19",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 19.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES19_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES19_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES18
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES18_FIELD =
{
    "SINKDISCGATES18",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 18.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES18_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES18_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES17
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES17_FIELD =
{
    "SINKDISCGATES17",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 17.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES17_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES17_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES16
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES16_FIELD =
{
    "SINKDISCGATES16",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 16.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES16_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES16_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES15
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES15_FIELD =
{
    "SINKDISCGATES15",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 15.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES15_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES15_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES14
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES14_FIELD =
{
    "SINKDISCGATES14",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 14.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES14_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES14_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES13
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES13_FIELD =
{
    "SINKDISCGATES13",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 13.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES13_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES13_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES12
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES12_FIELD =
{
    "SINKDISCGATES12",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 12.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES12_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES12_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES11
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES11_FIELD =
{
    "SINKDISCGATES11",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 11.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES11_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES11_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES10
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES10_FIELD =
{
    "SINKDISCGATES10",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 10.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES10_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES10_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES9
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES9_FIELD =
{
    "SINKDISCGATES9",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 9.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES9_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES9_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES8
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES8_FIELD =
{
    "SINKDISCGATES8",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 8.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES8_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES8_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES7
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD =
{
    "SINKDISCGATES7",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 7.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES6
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD =
{
    "SINKDISCGATES6",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 6.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES5
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD =
{
    "SINKDISCGATES5",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 5.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES4
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD =
{
    "SINKDISCGATES4",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 4.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES3
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD =
{
    "SINKDISCGATES3",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 3.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES2
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD =
{
    "SINKDISCGATES2",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 2.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES1
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD =
{
    "SINKDISCGATES1",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 1.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DROP_DISC_GATES_SINKDISCGATES0
 ******************************************************************************/
const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD =
{
    "SINKDISCGATES0",
#if RU_INCLUDE_DESC
    "",
    "Discard Discovery Gates on LLID Index 0.",
#endif
    EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD_MASK,
    0,
    EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD_WIDTH,
    EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK31
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK31_FIELD =
{
    "DISABLEFCSCHK31",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 31",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK31_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK31_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK30
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK30_FIELD =
{
    "DISABLEFCSCHK30",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 30",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK30_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK30_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK29
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK29_FIELD =
{
    "DISABLEFCSCHK29",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 29",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK29_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK29_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK28
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK28_FIELD =
{
    "DISABLEFCSCHK28",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 28",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK28_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK28_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK27
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK27_FIELD =
{
    "DISABLEFCSCHK27",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 27",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK27_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK27_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK26
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK26_FIELD =
{
    "DISABLEFCSCHK26",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 26",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK26_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK26_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK25
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK25_FIELD =
{
    "DISABLEFCSCHK25",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 25",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK25_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK25_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK24
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK24_FIELD =
{
    "DISABLEFCSCHK24",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 24",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK24_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK24_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK23
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK23_FIELD =
{
    "DISABLEFCSCHK23",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 23",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK23_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK23_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK22
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK22_FIELD =
{
    "DISABLEFCSCHK22",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 22",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK22_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK22_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK21
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK21_FIELD =
{
    "DISABLEFCSCHK21",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 21",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK21_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK21_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK20
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK20_FIELD =
{
    "DISABLEFCSCHK20",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 20",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK20_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK20_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK19
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK19_FIELD =
{
    "DISABLEFCSCHK19",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 19",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK19_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK19_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK18
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK18_FIELD =
{
    "DISABLEFCSCHK18",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 18",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK18_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK18_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK17
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK17_FIELD =
{
    "DISABLEFCSCHK17",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 17",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK17_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK17_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK16
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK16_FIELD =
{
    "DISABLEFCSCHK16",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 16",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK16_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK16_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK15
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK15_FIELD =
{
    "DISABLEFCSCHK15",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 15",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK15_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK15_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK14
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK14_FIELD =
{
    "DISABLEFCSCHK14",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 14",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK14_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK14_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK13
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK13_FIELD =
{
    "DISABLEFCSCHK13",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 13",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK13_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK13_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK12
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK12_FIELD =
{
    "DISABLEFCSCHK12",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 12",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK12_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK12_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK11
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK11_FIELD =
{
    "DISABLEFCSCHK11",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 11",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK11_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK11_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK10
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK10_FIELD =
{
    "DISABLEFCSCHK10",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 10",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK10_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK10_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK9
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK9_FIELD =
{
    "DISABLEFCSCHK9",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 9",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK9_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK9_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK8
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK8_FIELD =
{
    "DISABLEFCSCHK8",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 8",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK8_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK8_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK7
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD =
{
    "DISABLEFCSCHK7",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 7",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK6
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD =
{
    "DISABLEFCSCHK6",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 6",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK5
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD =
{
    "DISABLEFCSCHK5",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 5",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK4
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD =
{
    "DISABLEFCSCHK4",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 4",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK3
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD =
{
    "DISABLEFCSCHK3",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 3",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK2
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD =
{
    "DISABLEFCSCHK2",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 2",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK1
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD =
{
    "DISABLEFCSCHK1",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 1",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DIS_FCS_CHK_DISABLEFCSCHK0
 ******************************************************************************/
const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD =
{
    "DISABLEFCSCHK0",
#if RU_INCLUDE_DESC
    "",
    "Do not check FCS on downstream frames received on LLID index 0",
#endif
    EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD_MASK,
    0,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD_WIDTH,
    EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID31
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID31_FIELD =
{
    "PASSGATELLID31",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 31",
#endif
    EPN_PASS_GATES_PASSGATELLID31_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID31_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID30
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID30_FIELD =
{
    "PASSGATELLID30",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 30",
#endif
    EPN_PASS_GATES_PASSGATELLID30_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID30_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID29
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID29_FIELD =
{
    "PASSGATELLID29",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 29",
#endif
    EPN_PASS_GATES_PASSGATELLID29_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID29_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID28
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID28_FIELD =
{
    "PASSGATELLID28",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 28",
#endif
    EPN_PASS_GATES_PASSGATELLID28_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID28_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID27
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID27_FIELD =
{
    "PASSGATELLID27",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 27",
#endif
    EPN_PASS_GATES_PASSGATELLID27_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID27_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID26
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID26_FIELD =
{
    "PASSGATELLID26",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 26",
#endif
    EPN_PASS_GATES_PASSGATELLID26_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID26_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID25
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID25_FIELD =
{
    "PASSGATELLID25",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 25",
#endif
    EPN_PASS_GATES_PASSGATELLID25_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID25_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID24
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID24_FIELD =
{
    "PASSGATELLID24",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 24",
#endif
    EPN_PASS_GATES_PASSGATELLID24_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID24_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID23
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID23_FIELD =
{
    "PASSGATELLID23",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 23",
#endif
    EPN_PASS_GATES_PASSGATELLID23_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID23_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID22
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID22_FIELD =
{
    "PASSGATELLID22",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 22",
#endif
    EPN_PASS_GATES_PASSGATELLID22_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID22_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID21
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID21_FIELD =
{
    "PASSGATELLID21",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 21",
#endif
    EPN_PASS_GATES_PASSGATELLID21_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID21_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID20
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID20_FIELD =
{
    "PASSGATELLID20",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 20",
#endif
    EPN_PASS_GATES_PASSGATELLID20_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID20_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID19
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID19_FIELD =
{
    "PASSGATELLID19",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 19",
#endif
    EPN_PASS_GATES_PASSGATELLID19_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID19_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID18
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID18_FIELD =
{
    "PASSGATELLID18",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 18",
#endif
    EPN_PASS_GATES_PASSGATELLID18_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID18_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID17
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID17_FIELD =
{
    "PASSGATELLID17",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 17",
#endif
    EPN_PASS_GATES_PASSGATELLID17_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID17_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID16
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID16_FIELD =
{
    "PASSGATELLID16",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 16",
#endif
    EPN_PASS_GATES_PASSGATELLID16_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID16_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID15
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID15_FIELD =
{
    "PASSGATELLID15",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 15",
#endif
    EPN_PASS_GATES_PASSGATELLID15_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID15_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID14
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID14_FIELD =
{
    "PASSGATELLID14",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 14",
#endif
    EPN_PASS_GATES_PASSGATELLID14_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID14_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID13
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID13_FIELD =
{
    "PASSGATELLID13",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 13",
#endif
    EPN_PASS_GATES_PASSGATELLID13_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID13_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID12
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID12_FIELD =
{
    "PASSGATELLID12",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 12",
#endif
    EPN_PASS_GATES_PASSGATELLID12_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID12_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID11
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID11_FIELD =
{
    "PASSGATELLID11",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 11",
#endif
    EPN_PASS_GATES_PASSGATELLID11_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID11_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID10
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID10_FIELD =
{
    "PASSGATELLID10",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 10",
#endif
    EPN_PASS_GATES_PASSGATELLID10_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID10_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID9
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID9_FIELD =
{
    "PASSGATELLID9",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 9",
#endif
    EPN_PASS_GATES_PASSGATELLID9_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID9_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID8
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID8_FIELD =
{
    "PASSGATELLID8",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 8",
#endif
    EPN_PASS_GATES_PASSGATELLID8_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID8_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID7
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID7_FIELD =
{
    "PASSGATELLID7",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 7",
#endif
    EPN_PASS_GATES_PASSGATELLID7_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID7_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID6
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID6_FIELD =
{
    "PASSGATELLID6",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 6",
#endif
    EPN_PASS_GATES_PASSGATELLID6_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID6_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID5
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID5_FIELD =
{
    "PASSGATELLID5",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 5",
#endif
    EPN_PASS_GATES_PASSGATELLID5_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID5_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID4
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID4_FIELD =
{
    "PASSGATELLID4",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 4",
#endif
    EPN_PASS_GATES_PASSGATELLID4_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID4_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID3
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID3_FIELD =
{
    "PASSGATELLID3",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 3",
#endif
    EPN_PASS_GATES_PASSGATELLID3_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID3_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID2
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID2_FIELD =
{
    "PASSGATELLID2",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 2",
#endif
    EPN_PASS_GATES_PASSGATELLID2_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID2_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID1
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID1_FIELD =
{
    "PASSGATELLID1",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 1",
#endif
    EPN_PASS_GATES_PASSGATELLID1_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID1_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PASS_GATES_PASSGATELLID0
 ******************************************************************************/
const ru_field_rec EPN_PASS_GATES_PASSGATELLID0_FIELD =
{
    "PASSGATELLID0",
#if RU_INCLUDE_DESC
    "",
    "If set, downstream gate frames will be passed to the BBH for LLID 0",
#endif
    EPN_PASS_GATES_PASSGATELLID0_FIELD_MASK,
    0,
    EPN_PASS_GATES_PASSGATELLID0_FIELD_WIDTH,
    EPN_PASS_GATES_PASSGATELLID0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK31
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK31_FIELD =
{
    "CFGMISALIGNFEEDBACK31",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 31. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK31_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK31_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK30
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK30_FIELD =
{
    "CFGMISALIGNFEEDBACK30",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 30. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK30_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK30_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK29
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK29_FIELD =
{
    "CFGMISALIGNFEEDBACK29",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 29. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK29_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK29_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK28
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK28_FIELD =
{
    "CFGMISALIGNFEEDBACK28",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 28. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK28_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK28_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK27
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK27_FIELD =
{
    "CFGMISALIGNFEEDBACK27",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 27. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK27_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK27_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK26
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK26_FIELD =
{
    "CFGMISALIGNFEEDBACK26",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 26. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK26_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK26_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK25
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK25_FIELD =
{
    "CFGMISALIGNFEEDBACK25",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 25. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK25_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK25_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK24
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK24_FIELD =
{
    "CFGMISALIGNFEEDBACK24",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 24. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK24_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK24_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK23
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK23_FIELD =
{
    "CFGMISALIGNFEEDBACK23",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 23. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK23_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK23_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK22
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK22_FIELD =
{
    "CFGMISALIGNFEEDBACK22",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 22. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK22_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK22_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK21
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK21_FIELD =
{
    "CFGMISALIGNFEEDBACK21",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 21. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK21_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK21_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK20
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK20_FIELD =
{
    "CFGMISALIGNFEEDBACK20",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 20. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK20_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK20_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK19
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK19_FIELD =
{
    "CFGMISALIGNFEEDBACK19",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 19. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK19_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK19_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK18
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK18_FIELD =
{
    "CFGMISALIGNFEEDBACK18",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 18. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK18_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK18_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK17
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK17_FIELD =
{
    "CFGMISALIGNFEEDBACK17",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 17. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK17_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK17_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK16
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK16_FIELD =
{
    "CFGMISALIGNFEEDBACK16",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 16. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK16_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK16_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK15
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK15_FIELD =
{
    "CFGMISALIGNFEEDBACK15",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 15. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK15_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK15_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK14
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK14_FIELD =
{
    "CFGMISALIGNFEEDBACK14",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 14. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK14_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK14_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK13
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK13_FIELD =
{
    "CFGMISALIGNFEEDBACK13",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 13. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK13_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK13_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK12
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK12_FIELD =
{
    "CFGMISALIGNFEEDBACK12",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 12. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK12_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK12_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK11
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK11_FIELD =
{
    "CFGMISALIGNFEEDBACK11",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 11. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK11_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK11_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK10
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK10_FIELD =
{
    "CFGMISALIGNFEEDBACK10",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 10. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK10_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK10_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK9
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK9_FIELD =
{
    "CFGMISALIGNFEEDBACK9",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 9. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK9_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK9_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK8
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK8_FIELD =
{
    "CFGMISALIGNFEEDBACK8",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 8. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK8_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK8_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD =
{
    "CFGMISALIGNFEEDBACK7",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 7. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD =
{
    "CFGMISALIGNFEEDBACK6",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 6. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD =
{
    "CFGMISALIGNFEEDBACK5",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 5. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD =
{
    "CFGMISALIGNFEEDBACK4",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 4. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD =
{
    "CFGMISALIGNFEEDBACK3",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 3. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD =
{
    "CFGMISALIGNFEEDBACK2",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 2. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD =
{
    "CFGMISALIGNFEEDBACK1",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 1. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0
 ******************************************************************************/
const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD =
{
    "CFGMISALIGNFEEDBACK0",
#if RU_INCLUDE_DESC
    "",
    "0: Ignore misalignment condition"
    "1: Enable grant misalignment detection on LLID Index 0. When"
    "detected, EPON MAC will temporarily report empty queue status"
    "(REPORT frame) on the LLID Index.",
#endif
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD_MASK,
    0,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD_WIDTH,
    EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISCOVERY_FILTER_PRVDISCINFOMASK
 ******************************************************************************/
const ru_field_rec EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD =
{
    "PRVDISCINFOMASK",
#if RU_INCLUDE_DESC
    "",
    "Any mask bit that is set will exclude its corresponding bit from the"
    "above comparison (i.e. set mask bits are considered \"don't care"
    "bits).",
#endif
    EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD_MASK,
    0,
    EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD_WIDTH,
    EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE
 ******************************************************************************/
const ru_field_rec EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD =
{
    "PRVDISCINFOVALUE",
#if RU_INCLUDE_DESC
    "",
    "The value to match",
#endif
    EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD_MASK,
    0,
    EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD_WIDTH,
    EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MINIMUM_GRANT_SETUP_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD_MASK,
    0,
    EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD_WIDTH,
    EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP
 ******************************************************************************/
const ru_field_rec EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD =
{
    "CFGMINGRANTSETUP",
#if RU_INCLUDE_DESC
    "",
    "Minimum amount of grant processing time required to guarantee the"
    "upstream data will be transmitted.  The units are EPON TimeQuanta"
    "(16 nS).",
#endif
    EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD_MASK,
    0,
    EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD_WIDTH,
    EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO31
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO31_FIELD =
{
    "RSTGNTFIFO31",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 31.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO31_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO31_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO30
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO30_FIELD =
{
    "RSTGNTFIFO30",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 30.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO30_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO30_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO29
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO29_FIELD =
{
    "RSTGNTFIFO29",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 29.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO29_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO29_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO28
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO28_FIELD =
{
    "RSTGNTFIFO28",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 28.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO28_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO28_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO27
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO27_FIELD =
{
    "RSTGNTFIFO27",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 27.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO27_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO27_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO26
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO26_FIELD =
{
    "RSTGNTFIFO26",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 26.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO26_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO26_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO25
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO25_FIELD =
{
    "RSTGNTFIFO25",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 25.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO25_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO25_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO24
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO24_FIELD =
{
    "RSTGNTFIFO24",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 24.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO24_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO24_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO23
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO23_FIELD =
{
    "RSTGNTFIFO23",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 23.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO23_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO23_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO22
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO22_FIELD =
{
    "RSTGNTFIFO22",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 22.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO22_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO22_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO21
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO21_FIELD =
{
    "RSTGNTFIFO21",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 21.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO21_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO21_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO20
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO20_FIELD =
{
    "RSTGNTFIFO20",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 20.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO20_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO20_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO19
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO19_FIELD =
{
    "RSTGNTFIFO19",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 19.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO19_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO19_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO18
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO18_FIELD =
{
    "RSTGNTFIFO18",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 18.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO18_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO18_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO17
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO17_FIELD =
{
    "RSTGNTFIFO17",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 17.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO17_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO17_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO16
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO16_FIELD =
{
    "RSTGNTFIFO16",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 16.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO16_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO16_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO15
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO15_FIELD =
{
    "RSTGNTFIFO15",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 15.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO15_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO15_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO14
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO14_FIELD =
{
    "RSTGNTFIFO14",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 14.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO14_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO14_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO13
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO13_FIELD =
{
    "RSTGNTFIFO13",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 13.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO13_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO13_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO12
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO12_FIELD =
{
    "RSTGNTFIFO12",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 12.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO12_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO12_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO11
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO11_FIELD =
{
    "RSTGNTFIFO11",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 11.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO11_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO11_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO10
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO10_FIELD =
{
    "RSTGNTFIFO10",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 10.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO10_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO10_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO9
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO9_FIELD =
{
    "RSTGNTFIFO9",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 9.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO9_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO9_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO8
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO8_FIELD =
{
    "RSTGNTFIFO8",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 8.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO8_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO8_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO7
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD =
{
    "RSTGNTFIFO7",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 7.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO6
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD =
{
    "RSTGNTFIFO6",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 6.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO5
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD =
{
    "RSTGNTFIFO5",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 5.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO4
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD =
{
    "RSTGNTFIFO4",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 4.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO3
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD =
{
    "RSTGNTFIFO3",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 3.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO2
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD =
{
    "RSTGNTFIFO2",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 2.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO1
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD =
{
    "RSTGNTFIFO1",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 1.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_GNT_FIFO_RSTGNTFIFO0
 ******************************************************************************/
const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD =
{
    "RSTGNTFIFO0",
#if RU_INCLUDE_DESC
    "",
    "Resets the read and write pointers for grant FIFO 0.",
#endif
    EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD_MASK,
    0,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD_WIDTH,
    EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM
 ******************************************************************************/
const ru_field_rec EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD =
{
    "CFGL1SCLRACUM",
#if RU_INCLUDE_DESC
    "",
    "Set the respective bit(s) to reset L1 accumulator(s).",
#endif
    EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD_MASK,
    0,
    EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD_WIDTH,
    EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_L1_ACCUMULATOR_SEL_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD_MASK,
    0,
    EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD_WIDTH,
    EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL
 ******************************************************************************/
const ru_field_rec EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD =
{
    "CFGL1SUVASIZESEL",
#if RU_INCLUDE_DESC
    "",
    "Selects which L1S Un-shaped Virtual Accumulator size will be"
    "reported.",
#endif
    EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD_MASK,
    0,
    EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD_WIDTH,
    EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL
 ******************************************************************************/
const ru_field_rec EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD =
{
    "CFGL1SSVASIZESEL",
#if RU_INCLUDE_DESC
    "",
    "Selects which L1S Shaped Virtual Accumulator size will be reported.",
#endif
    EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD_MASK,
    0,
    EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD_WIDTH,
    EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_L1_SVA_BYTES_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_L1_SVA_BYTES_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_L1_SVA_BYTES_RESERVED0_FIELD_MASK,
    0,
    EPN_L1_SVA_BYTES_RESERVED0_FIELD_WIDTH,
    EPN_L1_SVA_BYTES_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_L1_SVA_BYTES_L1SSVASIZE
 ******************************************************************************/
const ru_field_rec EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD =
{
    "L1SSVASIZE",
#if RU_INCLUDE_DESC
    "",
    "Signed number of bytes in the selected L1S Shaped Virtual"
    "Accumulator."
    "Bit-29 is the sign bit.  A negative number indicates the Runner/BBH"
    "created a rounding error"
    "Bit-28 can be considered an overflow indication."
    "Bits 27-0 are the actual number of bytes.",
#endif
    EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD_MASK,
    0,
    EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD_WIDTH,
    EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_L1_UVA_BYTES_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_L1_UVA_BYTES_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_L1_UVA_BYTES_RESERVED0_FIELD_MASK,
    0,
    EPN_L1_UVA_BYTES_RESERVED0_FIELD_WIDTH,
    EPN_L1_UVA_BYTES_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_L1_UVA_BYTES_L1SUVASIZE
 ******************************************************************************/
const ru_field_rec EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD =
{
    "L1SUVASIZE",
#if RU_INCLUDE_DESC
    "",
    "Signed number of bytes in the selected L1S Un-shaped Virtual"
    "Accumulator."
    "Bit-29 is the sign bit.  A negative number indicates the Runner/BBH"
    "created a rounding error"
    "Bit-28 can be considered an overflow indication."
    "Bits 27-0 are the actual number of bytes.",
#endif
    EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD_MASK,
    0,
    EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD_WIDTH,
    EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW
 ******************************************************************************/
const ru_field_rec EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD =
{
    "L1SSVAOVERFLOW",
#if RU_INCLUDE_DESC
    "",
    "Indicates which SVAs have overflowed.  The overflow can only be"
    "corrected by reset.",
#endif
    EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD_MASK,
    0,
    EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD_WIDTH,
    EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW
 ******************************************************************************/
const ru_field_rec EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD =
{
    "L1SUVAOVERFLOW",
#if RU_INCLUDE_DESC
    "",
    "Indicates which UVAs have overflowed.  The overflow can only be"
    "corrected by reset.",
#endif
    EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD_MASK,
    0,
    EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD_WIDTH,
    EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_RESET_RPT_PRI_RESERVED0_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_RESERVED0_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI15
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD =
{
    "NULLRPTPRI15",
#if RU_INCLUDE_DESC
    "",
    "Force priority 15 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI14
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD =
{
    "NULLRPTPRI14",
#if RU_INCLUDE_DESC
    "",
    "Force priority 14 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI13
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD =
{
    "NULLRPTPRI13",
#if RU_INCLUDE_DESC
    "",
    "Force priority 13 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI12
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD =
{
    "NULLRPTPRI12",
#if RU_INCLUDE_DESC
    "",
    "Force priority 12 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI11
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD =
{
    "NULLRPTPRI11",
#if RU_INCLUDE_DESC
    "",
    "Force priority 11 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI10
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD =
{
    "NULLRPTPRI10",
#if RU_INCLUDE_DESC
    "",
    "Force priority 10 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI9
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD =
{
    "NULLRPTPRI9",
#if RU_INCLUDE_DESC
    "",
    "Force priority 9 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI8
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD =
{
    "NULLRPTPRI8",
#if RU_INCLUDE_DESC
    "",
    "Force priority 8 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI7
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD =
{
    "NULLRPTPRI7",
#if RU_INCLUDE_DESC
    "",
    "Force priority 7 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI6
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD =
{
    "NULLRPTPRI6",
#if RU_INCLUDE_DESC
    "",
    "Force priority 6 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI5
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD =
{
    "NULLRPTPRI5",
#if RU_INCLUDE_DESC
    "",
    "Force priority 5 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI4
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD =
{
    "NULLRPTPRI4",
#if RU_INCLUDE_DESC
    "",
    "Force priority 4 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI3
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD =
{
    "NULLRPTPRI3",
#if RU_INCLUDE_DESC
    "",
    "Force priority 3 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI2
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD =
{
    "NULLRPTPRI2",
#if RU_INCLUDE_DESC
    "",
    "Force priority 2 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI1
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD =
{
    "NULLRPTPRI1",
#if RU_INCLUDE_DESC
    "",
    "Force priority 1 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_RPT_PRI_NULLRPTPRI0
 ******************************************************************************/
const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD =
{
    "NULLRPTPRI0",
#if RU_INCLUDE_DESC
    "",
    "Force priority 0 report values to zero.",
#endif
    EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD_MASK,
    0,
    EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD_WIDTH,
    EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE
 ******************************************************************************/
const ru_field_rec EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD =
{
    "CFGL2SCLRQUE",
#if RU_INCLUDE_DESC
    "",
    "Set the respective bit(s) to reset L2 FIFO(s).",
#endif
    EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD_MASK,
    0,
    EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD_WIDTH,
    EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD =
{
    "CFGENABLEUPSTREAMREG",
#if RU_INCLUDE_DESC
    "",
    "Set the respective bit(s) to enable the upstream LLID(s).",
#endif
    EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD_MASK,
    0,
    EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD_WIDTH,
    EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD =
{
    "CFGENABLEUPSTREAMFEEDBACK",
#if RU_INCLUDE_DESC
    "",
    "Indicates the operational state of the upstream LLIDs.  See"
    "EPN_ENABLE_UPSTREAM register description for details.",
#endif
    EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD_MASK,
    0,
    EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD_WIDTH,
    EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC
 ******************************************************************************/
const ru_field_rec EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD =
{
    "CFGENABLEUPSTREAMFEC",
#if RU_INCLUDE_DESC
    "",
    "Set the respective bit(s) to enable upstream FEC for LLID(s).",
#endif
    EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD_MASK,
    0,
    EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD_WIDTH,
    EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_REPORT_BYTE_LENGTH_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD_MASK,
    0,
    EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD_WIDTH,
    EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN
 ******************************************************************************/
const ru_field_rec EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD =
{
    "PRVRPTBYTELEN",
#if RU_INCLUDE_DESC
    "",
    "Number of bytes reserved for upstream report.",
#endif
    EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD_MASK,
    0,
    EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD_WIDTH,
    EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTBBHUPFRABORT
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD =
{
    "INTBBHUPFRABORT",
#if RU_INCLUDE_DESC
    "",
    "Indicates the Runner/BBH aborted an upstream frame transfer.  Please"
    "reference the Runner/BBH documentation for a list of events that"
    "will cause Runner/BBH to abort  packets.",
#endif
    EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD =
{
    "INTCOL2SBURSTCAPOVERFLOWPRES",
#if RU_INCLUDE_DESC
    "",
    "Coalesced per-L2 burst cap overflow event indicator.  This is"
    "triggered when the burst cap is dynamically resized below respective"
    "L2 accumulator's value.",
#endif
    EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOEMPTYRPT
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD =
{
    "INTCOEMPTYRPT",
#if RU_INCLUDE_DESC
    "",
    "Coalesced Empty Report interrupt. One or more LLID indexes has a"
    "transmitted a report in which all time quanta values were zero. See"
    "EPON Empty Report Interrupt Status for per-LLID Index interrupt"
    "bits.",
#endif
    EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD =
{
    "INTCODRXERRABORTPRES",
#if RU_INCLUDE_DESC
    "",
    "The Drx detected an error that required the frame to be aborted."
    "Culpable errors are FCS, oversize-frame, or undersize-frame."
    "Note: The intDrxErrorAbortMask will prevent this 'coalesced bit from"
    "being set. This is in contrast to the 'individual' bits (0x41b)"
    "still being set even if the interrupt is masked.",
#endif
    EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD =
{
    "INTL2SFIFOOVERRUN",
#if RU_INCLUDE_DESC
    "",
    "The Level 2 structure FIFO has overflowed. A frame length has been"
    "lost.  The Runner/BBH and EPN must be reset to recover from this.",
#endif
    EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCO1588TSINT
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD =
{
    "INTCO1588TSINT",
#if RU_INCLUDE_DESC
    "",
    "Coalesced 1588 timestamp interrupt. See"
    "EPN_1588_TIMESTAMP_INT_STATUS for the interupts.",
#endif
    EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCORPTPRES
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD =
{
    "INTCORPTPRES",
#if RU_INCLUDE_DESC
    "",
    "Coalesced Report FIFO non-empty interrupt. One or more LLID indices"
    "has a frame length present in its report FIFO. See EPON Report"
    "Present Interrupt Status for per-LLID Index interrupt bits.",
#endif
    EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOGNTPRES
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD =
{
    "INTCOGNTPRES",
#if RU_INCLUDE_DESC
    "",
    "Coalesced Grant Ready interrupt. One or more LLID indexes has a"
    "grant present in its Grant RAM. See EPON Grant Present Interrupt"
    "Status for per-LLID Index interrupt bits.",
#endif
    EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCODELSTALEGNT
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD =
{
    "INTCODELSTALEGNT",
#if RU_INCLUDE_DESC
    "",
    "Coalesced stale grant delete interrupt. One or more LLID indexes"
    "deleted a grant deleted from its grant RAM. See EPON Deleted Stale"
    "Grant Interrupt Status for per-LLID Index interrupt bits.",
#endif
    EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD =
{
    "INTCOGNTNONPOLL",
#if RU_INCLUDE_DESC
    "",
    "Coalesced grant non-poll interrupt. One or more LLID indexes"
    "exceeded the Non-poll grant interval. See EPON Non-Poll Grant"
    "Interrupt Status for per-LLID Index interrupt bits.",
#endif
    EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD =
{
    "INTCOGNTMISALIGN",
#if RU_INCLUDE_DESC
    "",
    "Coalesced grant misalign interrupt. One or more LLID indexes"
    "received a grant that was not aligned on frame boundaries. See EPON"
    "Grant Misalign Interrupt Status for per-LLID Index interrupt bits.",
#endif
    EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD =
{
    "INTCOGNTTOOFAR",
#if RU_INCLUDE_DESC
    "",
    "Coalesced grant too far abort interrupt. One or more LLID indexes"
    "received a grant for greater than 34 seconds into the future. See"
    "EPON Grant Too Far Interrupt Status for per-LLID Index interrupt"
    "bits."
    "Note: This interrupt can set during registration of the first LLID"
    "Index (before the local MPCP clock is synchronized to the OLT)."
    "Firmware should check and clear this interrupt while registering the"
    "first link.",
#endif
    EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD =
{
    "INTCOGNTINTERVAL",
#if RU_INCLUDE_DESC
    "",
    "Coalesced grant interval interrupt. One or more LLID indexes is not"
    "receiving gates fast enough. See EPON Grant Interval Interrupt"
    "Status for per-LLID Index interrupt bits.",
#endif
    EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD =
{
    "INTCOGNTDISCOVERY",
#if RU_INCLUDE_DESC
    "",
    "Coalesced Discovery Gate received interrupt. One or more LLID"
    "indexes received a Discovery Gate. See EPON Discovery Gate Interrupt"
    "Status for per-LLID Index interrupt bits.",
#endif
    EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD =
{
    "INTCOGNTMISSABORT",
#if RU_INCLUDE_DESC
    "",
    "Coalesced grant miss abort interrupt. One or more LLID indexes"
    "aborted a grant because it missed its slot time to transmit. See"
    "EPON Grant Miss Interrupt Status for per-LLID Index interrupt bits.",
#endif
    EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD =
{
    "INTCOGNTFULLABORT",
#if RU_INCLUDE_DESC
    "",
    "Coalesced grant full abort interrupt. One or more LLID indexes"
    "aborted a grant due to its grant FIFO being full. See EPON Grant"
    "Full Interrupt Status for per-LLID Index interrupt bits.",
#endif
    EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTBADUPFRLEN
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD =
{
    "INTBADUPFRLEN",
#if RU_INCLUDE_DESC
    "",
    "[FATAL] The EPN received an upstream frame whose length did not"
    "match the expected frame length.  This is a fatal event.  The entire"
    "data path must be reset to recover from this event.",
#endif
    EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTUPTARDYPACKET
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD =
{
    "INTUPTARDYPACKET",
#if RU_INCLUDE_DESC
    "",
    "The Runner/BBH upstream data path failed to deliver upstream data in"
    "time to meet the upPacketTxMargin requirement.",
#endif
    EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTUPRPTFRXMT
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD =
{
    "INTUPRPTFRXMT",
#if RU_INCLUDE_DESC
    "",
    "Report frame has been transmitted by EPON MAC.",
#endif
    EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD =
{
    "INTBIFIFOOVERRUN",
#if RU_INCLUDE_DESC
    "",
    "[FATAL] The burst information FIFO over ran. This is a fatal event"
    "and requires the entire device to be reset and re-initialized.",
#endif
    EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD =
{
    "INTBURSTGNTTOOBIG",
#if RU_INCLUDE_DESC
    "",
    "A grant passed to the Upstream transmitter has size greater than"
    "that defined EPON Max Grant Size register.",
#endif
    EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD =
{
    "INTWRGNTTOOBIG",
#if RU_INCLUDE_DESC
    "",
    "A grant written into EPON grant RAM has size greater than that"
    "defined EPON Max Grant Size register.",
#endif
    EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD =
{
    "INTRCVGNTTOOBIG",
#if RU_INCLUDE_DESC
    "",
    "A grant received by EPON MAC has size greater than that defined in"
    "the EPON Max Grant Size register.",
#endif
    EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD =
{
    "INTDNSTATSOVERRUN",
#if RU_INCLUDE_DESC
    "",
    "EPON block cannot accumulate statistics quickly enough to count runt"
    "frames. Bursts of frames less than 20 bytes in size will cause this"
    "interrupt.",
#endif
    EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD =
{
    "INTUPSTATSOVERRUN",
#if RU_INCLUDE_DESC
    "",
    "EPON block was not able to process an upstream transmission event.",
#endif
    EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTDNOUTOFORDER
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD =
{
    "INTDNOUTOFORDER",
#if RU_INCLUDE_DESC
    "",
    "An out of order grant was received",
#endif
    EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD =
{
    "INTTRUANTBBHHALT",
#if RU_INCLUDE_DESC
    "",
    "[FATAL] Fatal Event. The Runner/BBH upstream data path stopped"
    "delivering packets. All upstream traffic for all LLID indexes has"
    "been halted.  Any upstream grants received are terminated with empty"
    "reports (if requested).  The only way to recover from this fatal"
    "event is to reset the entire upstream data path."
    "Check the EPN Fatal Upstream Fault Interrupt Status register to see"
    "which LLID(s) experienced the fault.",
#endif
    EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD =
{
    "INTUPINVLDGNTLEN",
#if RU_INCLUDE_DESC
    "",
    "Grant length is less than overhead. Possible configuration error.",
#endif
    EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD =
{
    "INTCOBBHUPSFAULT",
#if RU_INCLUDE_DESC
    "",
    "[FATAL] Coalesced per-LLID index Runner/BBH fatal upstream delivery"
    "fault indicator.  Runner/BBH has lost coherency with the EPN. The"
    "four trigger events are:"
    "1. Runner/BBH aborted a packet"
    "2. Runner/BBH transferred a packet shorter than was requested"
    "3. Runner/BBH transferred a packet longer than was requested"
    "4. Runner/BBH stopped transferring packets (as indicated by"
    "intTruantBbhHalt, below)"
    "Check the EPN Fatal Upstream Fault Interrupt Status register to see"
    "which LLID(s) experienced the fault.",
#endif
    EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD =
{
    "INTDNTIMEINSYNC",
#if RU_INCLUDE_DESC
    "",
    "ONU timer is in sync",
#endif
    EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD =
{
    "INTDNTIMENOTINSYNC",
#if RU_INCLUDE_DESC
    "",
    "ONU timer is out of sync",
#endif
    EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_STATUS_INTDPORTRDY
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD =
{
    "INTDPORTRDY",
#if RU_INCLUDE_DESC
    "",
    "EPON Data Port is ready"
    "0: Data Port is busy"
    "1: Data Port is ready",
#endif
    EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD_MASK,
    0,
    EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD_WIDTH,
    EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT31
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT31_FIELD =
{
    "INTDNGNTFULLABORT31",
#if RU_INCLUDE_DESC
    "",
    "LLID index 31 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT31_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT31_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT30
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT30_FIELD =
{
    "INTDNGNTFULLABORT30",
#if RU_INCLUDE_DESC
    "",
    "LLID index 30 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT30_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT30_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT29
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT29_FIELD =
{
    "INTDNGNTFULLABORT29",
#if RU_INCLUDE_DESC
    "",
    "LLID index 29 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT29_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT29_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT28
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT28_FIELD =
{
    "INTDNGNTFULLABORT28",
#if RU_INCLUDE_DESC
    "",
    "LLID index 28 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT28_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT28_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT27
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT27_FIELD =
{
    "INTDNGNTFULLABORT27",
#if RU_INCLUDE_DESC
    "",
    "LLID index 27 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT27_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT27_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT26
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT26_FIELD =
{
    "INTDNGNTFULLABORT26",
#if RU_INCLUDE_DESC
    "",
    "LLID index 26 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT26_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT26_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT25
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT25_FIELD =
{
    "INTDNGNTFULLABORT25",
#if RU_INCLUDE_DESC
    "",
    "LLID index 25 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT25_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT25_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT24
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT24_FIELD =
{
    "INTDNGNTFULLABORT24",
#if RU_INCLUDE_DESC
    "",
    "LLID index 24 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT24_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT24_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT23
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT23_FIELD =
{
    "INTDNGNTFULLABORT23",
#if RU_INCLUDE_DESC
    "",
    "LLID index 23 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT23_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT23_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT22
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT22_FIELD =
{
    "INTDNGNTFULLABORT22",
#if RU_INCLUDE_DESC
    "",
    "LLID index 22 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT22_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT22_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT21
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT21_FIELD =
{
    "INTDNGNTFULLABORT21",
#if RU_INCLUDE_DESC
    "",
    "LLID index 21 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT21_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT21_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT20
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT20_FIELD =
{
    "INTDNGNTFULLABORT20",
#if RU_INCLUDE_DESC
    "",
    "LLID index 20 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT20_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT20_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT19
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT19_FIELD =
{
    "INTDNGNTFULLABORT19",
#if RU_INCLUDE_DESC
    "",
    "LLID index 19 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT19_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT19_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT18
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT18_FIELD =
{
    "INTDNGNTFULLABORT18",
#if RU_INCLUDE_DESC
    "",
    "LLID index 18 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT18_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT18_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT17
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT17_FIELD =
{
    "INTDNGNTFULLABORT17",
#if RU_INCLUDE_DESC
    "",
    "LLID index 17 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT17_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT17_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT16
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT16_FIELD =
{
    "INTDNGNTFULLABORT16",
#if RU_INCLUDE_DESC
    "",
    "LLID index 16 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT16_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT16_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT15
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT15_FIELD =
{
    "INTDNGNTFULLABORT15",
#if RU_INCLUDE_DESC
    "",
    "LLID index 15 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT15_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT15_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT14
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT14_FIELD =
{
    "INTDNGNTFULLABORT14",
#if RU_INCLUDE_DESC
    "",
    "LLID index 14 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT14_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT14_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT13
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT13_FIELD =
{
    "INTDNGNTFULLABORT13",
#if RU_INCLUDE_DESC
    "",
    "LLID index 13 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT13_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT13_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT12
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT12_FIELD =
{
    "INTDNGNTFULLABORT12",
#if RU_INCLUDE_DESC
    "",
    "LLID index 12 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT12_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT12_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT11
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT11_FIELD =
{
    "INTDNGNTFULLABORT11",
#if RU_INCLUDE_DESC
    "",
    "LLID index 11 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT11_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT11_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT10
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT10_FIELD =
{
    "INTDNGNTFULLABORT10",
#if RU_INCLUDE_DESC
    "",
    "LLID index 10 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT10_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT10_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT9
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT9_FIELD =
{
    "INTDNGNTFULLABORT9",
#if RU_INCLUDE_DESC
    "",
    "LLID index 9 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT9_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT9_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT8
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT8_FIELD =
{
    "INTDNGNTFULLABORT8",
#if RU_INCLUDE_DESC
    "",
    "LLID index 8 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT8_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT8_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD =
{
    "INTDNGNTFULLABORT7",
#if RU_INCLUDE_DESC
    "",
    "LLID index 7 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD =
{
    "INTDNGNTFULLABORT6",
#if RU_INCLUDE_DESC
    "",
    "LLID index 6 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD =
{
    "INTDNGNTFULLABORT5",
#if RU_INCLUDE_DESC
    "",
    "LLID index 5 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD =
{
    "INTDNGNTFULLABORT4",
#if RU_INCLUDE_DESC
    "",
    "LLID index 4 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD =
{
    "INTDNGNTFULLABORT3",
#if RU_INCLUDE_DESC
    "",
    "LLID index 3 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD =
{
    "INTDNGNTFULLABORT2",
#if RU_INCLUDE_DESC
    "",
    "LLID index 2 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD =
{
    "INTDNGNTFULLABORT1",
#if RU_INCLUDE_DESC
    "",
    "LLID index 1 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD =
{
    "INTDNGNTFULLABORT0",
#if RU_INCLUDE_DESC
    "",
    "LLID index 0 aborted a grant due to its grant FIFO being full.",
#endif
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD_WIDTH,
    EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT31
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT31_FIELD =
{
    "MASKINTDNGNTFULLABORT31",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 31 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT31_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT31_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT30
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT30_FIELD =
{
    "MASKINTDNGNTFULLABORT30",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 30 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT30_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT30_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT29
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT29_FIELD =
{
    "MASKINTDNGNTFULLABORT29",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 29 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT29_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT29_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT28
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT28_FIELD =
{
    "MASKINTDNGNTFULLABORT28",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 28 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT28_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT28_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT27
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT27_FIELD =
{
    "MASKINTDNGNTFULLABORT27",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 27 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT27_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT27_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT26
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT26_FIELD =
{
    "MASKINTDNGNTFULLABORT26",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 26 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT26_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT26_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT25
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT25_FIELD =
{
    "MASKINTDNGNTFULLABORT25",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 25 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT25_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT25_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT24
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT24_FIELD =
{
    "MASKINTDNGNTFULLABORT24",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 24 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT24_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT24_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT23
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT23_FIELD =
{
    "MASKINTDNGNTFULLABORT23",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 23 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT23_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT23_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT22
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT22_FIELD =
{
    "MASKINTDNGNTFULLABORT22",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 22 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT22_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT22_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT21
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT21_FIELD =
{
    "MASKINTDNGNTFULLABORT21",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 21 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT21_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT21_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT20
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT20_FIELD =
{
    "MASKINTDNGNTFULLABORT20",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 20 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT20_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT20_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT19
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT19_FIELD =
{
    "MASKINTDNGNTFULLABORT19",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 19 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT19_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT19_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT18
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT18_FIELD =
{
    "MASKINTDNGNTFULLABORT18",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 18 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT18_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT18_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT17
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT17_FIELD =
{
    "MASKINTDNGNTFULLABORT17",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 17 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT17_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT17_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT16
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT16_FIELD =
{
    "MASKINTDNGNTFULLABORT16",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 16 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT16_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT16_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT15
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT15_FIELD =
{
    "MASKINTDNGNTFULLABORT15",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 15 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT15_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT15_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT14
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT14_FIELD =
{
    "MASKINTDNGNTFULLABORT14",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 14 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT14_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT14_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT13
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT13_FIELD =
{
    "MASKINTDNGNTFULLABORT13",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 13 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT13_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT13_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT12
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT12_FIELD =
{
    "MASKINTDNGNTFULLABORT12",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 12 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT12_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT12_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT11
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT11_FIELD =
{
    "MASKINTDNGNTFULLABORT11",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 11 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT11_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT11_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT10
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT10_FIELD =
{
    "MASKINTDNGNTFULLABORT10",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 10 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT10_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT10_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT9
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT9_FIELD =
{
    "MASKINTDNGNTFULLABORT9",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 9 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT9_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT9_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT8
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT8_FIELD =
{
    "MASKINTDNGNTFULLABORT8",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 8 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT8_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT8_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD =
{
    "MASKINTDNGNTFULLABORT7",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 7 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD =
{
    "MASKINTDNGNTFULLABORT6",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 6 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD =
{
    "MASKINTDNGNTFULLABORT5",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 5 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD =
{
    "MASKINTDNGNTFULLABORT4",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 4 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD =
{
    "MASKINTDNGNTFULLABORT3",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 3 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD =
{
    "MASKINTDNGNTFULLABORT2",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 2 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD =
{
    "MASKINTDNGNTFULLABORT1",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 1 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0
 ******************************************************************************/
const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD =
{
    "MASKINTDNGNTFULLABORT0",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 0 aborted a grant due to its grant FIFO being full"
    "interrupt.",
#endif
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD_MASK,
    0,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD_WIDTH,
    EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT31
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT31_FIELD =
{
    "INTDNGNTMISSABORT31",
#if RU_INCLUDE_DESC
    "",
    "LLID index 31 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT31_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT31_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT30
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT30_FIELD =
{
    "INTDNGNTMISSABORT30",
#if RU_INCLUDE_DESC
    "",
    "LLID index 30 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT30_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT30_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT29
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT29_FIELD =
{
    "INTDNGNTMISSABORT29",
#if RU_INCLUDE_DESC
    "",
    "LLID index 29 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT29_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT29_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT28
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT28_FIELD =
{
    "INTDNGNTMISSABORT28",
#if RU_INCLUDE_DESC
    "",
    "LLID index 28 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT28_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT28_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT27
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT27_FIELD =
{
    "INTDNGNTMISSABORT27",
#if RU_INCLUDE_DESC
    "",
    "LLID index 27 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT27_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT27_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT26
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT26_FIELD =
{
    "INTDNGNTMISSABORT26",
#if RU_INCLUDE_DESC
    "",
    "LLID index 26 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT26_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT26_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT25
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT25_FIELD =
{
    "INTDNGNTMISSABORT25",
#if RU_INCLUDE_DESC
    "",
    "LLID index 25 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT25_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT25_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT24
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT24_FIELD =
{
    "INTDNGNTMISSABORT24",
#if RU_INCLUDE_DESC
    "",
    "LLID index 24 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT24_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT24_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT23
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT23_FIELD =
{
    "INTDNGNTMISSABORT23",
#if RU_INCLUDE_DESC
    "",
    "LLID index 23 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT23_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT23_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT22
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT22_FIELD =
{
    "INTDNGNTMISSABORT22",
#if RU_INCLUDE_DESC
    "",
    "LLID index 22 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT22_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT22_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT21
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT21_FIELD =
{
    "INTDNGNTMISSABORT21",
#if RU_INCLUDE_DESC
    "",
    "LLID index 21 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT21_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT21_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT20
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT20_FIELD =
{
    "INTDNGNTMISSABORT20",
#if RU_INCLUDE_DESC
    "",
    "LLID index 20 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT20_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT20_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT19
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT19_FIELD =
{
    "INTDNGNTMISSABORT19",
#if RU_INCLUDE_DESC
    "",
    "LLID index 19 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT19_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT19_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT18
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT18_FIELD =
{
    "INTDNGNTMISSABORT18",
#if RU_INCLUDE_DESC
    "",
    "LLID index 18 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT18_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT18_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT17
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT17_FIELD =
{
    "INTDNGNTMISSABORT17",
#if RU_INCLUDE_DESC
    "",
    "LLID index 17 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT17_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT17_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT16
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT16_FIELD =
{
    "INTDNGNTMISSABORT16",
#if RU_INCLUDE_DESC
    "",
    "LLID index 16 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT16_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT16_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT15
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT15_FIELD =
{
    "INTDNGNTMISSABORT15",
#if RU_INCLUDE_DESC
    "",
    "LLID index 15 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT15_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT15_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT14
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT14_FIELD =
{
    "INTDNGNTMISSABORT14",
#if RU_INCLUDE_DESC
    "",
    "LLID index 14 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT14_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT14_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT13
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT13_FIELD =
{
    "INTDNGNTMISSABORT13",
#if RU_INCLUDE_DESC
    "",
    "LLID index 13 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT13_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT13_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT12
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT12_FIELD =
{
    "INTDNGNTMISSABORT12",
#if RU_INCLUDE_DESC
    "",
    "LLID index 12 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT12_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT12_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT11
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT11_FIELD =
{
    "INTDNGNTMISSABORT11",
#if RU_INCLUDE_DESC
    "",
    "LLID index 11 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT11_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT11_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT10
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT10_FIELD =
{
    "INTDNGNTMISSABORT10",
#if RU_INCLUDE_DESC
    "",
    "LLID index 10 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT10_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT10_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT9
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT9_FIELD =
{
    "INTDNGNTMISSABORT9",
#if RU_INCLUDE_DESC
    "",
    "LLID index 9 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT9_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT9_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT8
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT8_FIELD =
{
    "INTDNGNTMISSABORT8",
#if RU_INCLUDE_DESC
    "",
    "LLID index 8 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT8_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT8_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD =
{
    "INTDNGNTMISSABORT7",
#if RU_INCLUDE_DESC
    "",
    "LLID index 7 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD =
{
    "INTDNGNTMISSABORT6",
#if RU_INCLUDE_DESC
    "",
    "LLID index 6 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD =
{
    "INTDNGNTMISSABORT5",
#if RU_INCLUDE_DESC
    "",
    "LLID index 5 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD =
{
    "INTDNGNTMISSABORT4",
#if RU_INCLUDE_DESC
    "",
    "LLID index 4 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD =
{
    "INTDNGNTMISSABORT3",
#if RU_INCLUDE_DESC
    "",
    "LLID index 3 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD =
{
    "INTDNGNTMISSABORT2",
#if RU_INCLUDE_DESC
    "",
    "LLID index 2 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD =
{
    "INTDNGNTMISSABORT1",
#if RU_INCLUDE_DESC
    "",
    "LLID index 1 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD =
{
    "INTDNGNTMISSABORT0",
#if RU_INCLUDE_DESC
    "",
    "LLID index 0 aborted a grant because it missed its slot time to"
    "transmit.",
#endif
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD_WIDTH,
    EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT31
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT31_FIELD =
{
    "MASKINTDNGNTMISSABORT31",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 31 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT31_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT31_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT30
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT30_FIELD =
{
    "MASKINTDNGNTMISSABORT30",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 30 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT30_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT30_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT29
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT29_FIELD =
{
    "MASKINTDNGNTMISSABORT29",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 29 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT29_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT29_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT28
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT28_FIELD =
{
    "MASKINTDNGNTMISSABORT28",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 28 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT28_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT28_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT27
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT27_FIELD =
{
    "MASKINTDNGNTMISSABORT27",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 27 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT27_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT27_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT26
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT26_FIELD =
{
    "MASKINTDNGNTMISSABORT26",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 26 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT26_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT26_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT25
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT25_FIELD =
{
    "MASKINTDNGNTMISSABORT25",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 25 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT25_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT25_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT24
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT24_FIELD =
{
    "MASKINTDNGNTMISSABORT24",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 24 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT24_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT24_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT23
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT23_FIELD =
{
    "MASKINTDNGNTMISSABORT23",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 23 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT23_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT23_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT22
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT22_FIELD =
{
    "MASKINTDNGNTMISSABORT22",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 22 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT22_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT22_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT21
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT21_FIELD =
{
    "MASKINTDNGNTMISSABORT21",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 21 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT21_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT21_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT20
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT20_FIELD =
{
    "MASKINTDNGNTMISSABORT20",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 20 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT20_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT20_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT19
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT19_FIELD =
{
    "MASKINTDNGNTMISSABORT19",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 19 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT19_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT19_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT18
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT18_FIELD =
{
    "MASKINTDNGNTMISSABORT18",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 18 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT18_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT18_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT17
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT17_FIELD =
{
    "MASKINTDNGNTMISSABORT17",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 17 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT17_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT17_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT16
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT16_FIELD =
{
    "MASKINTDNGNTMISSABORT16",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 16 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT16_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT16_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT15
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT15_FIELD =
{
    "MASKINTDNGNTMISSABORT15",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 15 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT15_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT15_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT14
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT14_FIELD =
{
    "MASKINTDNGNTMISSABORT14",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 14 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT14_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT14_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT13
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT13_FIELD =
{
    "MASKINTDNGNTMISSABORT13",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 13 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT13_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT13_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT12
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT12_FIELD =
{
    "MASKINTDNGNTMISSABORT12",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 12 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT12_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT12_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT11
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT11_FIELD =
{
    "MASKINTDNGNTMISSABORT11",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 11 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT11_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT11_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT10
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT10_FIELD =
{
    "MASKINTDNGNTMISSABORT10",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 10 aborted a grant because it missed its slot time"
    "to transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT10_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT10_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT9
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT9_FIELD =
{
    "MASKINTDNGNTMISSABORT9",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 9 aborted a grant because it missed its slot time to"
    "transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT9_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT9_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT8
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT8_FIELD =
{
    "MASKINTDNGNTMISSABORT8",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 8 aborted a grant because it missed its slot time to"
    "transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT8_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT8_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD =
{
    "MASKINTDNGNTMISSABORT7",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 7 aborted a grant because it missed its slot time to"
    "transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD =
{
    "MASKINTDNGNTMISSABORT6",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 6 aborted a grant because it missed its slot time to"
    "transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD =
{
    "MASKINTDNGNTMISSABORT5",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 5 aborted a grant because it missed its slot time to"
    "transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD =
{
    "MASKINTDNGNTMISSABORT4",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 4 aborted a grant because it missed its slot time to"
    "transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD =
{
    "MASKINTDNGNTMISSABORT3",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 3 aborted a grant because it missed its slot time to"
    "transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD =
{
    "MASKINTDNGNTMISSABORT2",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 2 aborted a grant because it missed its slot time to"
    "transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD =
{
    "MASKINTDNGNTMISSABORT1",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 1 aborted a grant because it missed its slot time to"
    "transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD =
{
    "MASKINTDNGNTMISSABORT0",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 0 aborted a grant because it missed its slot time to"
    "transmit interrupt.",
#endif
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD_MASK,
    0,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD_WIDTH,
    EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY31
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY31_FIELD =
{
    "INTDNGNTDISCOVERY31",
#if RU_INCLUDE_DESC
    "",
    "LLID index 31 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY31_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY31_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY30
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY30_FIELD =
{
    "INTDNGNTDISCOVERY30",
#if RU_INCLUDE_DESC
    "",
    "LLID index 30 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY30_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY30_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY29
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY29_FIELD =
{
    "INTDNGNTDISCOVERY29",
#if RU_INCLUDE_DESC
    "",
    "LLID index 29 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY29_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY29_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY28
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY28_FIELD =
{
    "INTDNGNTDISCOVERY28",
#if RU_INCLUDE_DESC
    "",
    "LLID index 28 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY28_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY28_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY27
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY27_FIELD =
{
    "INTDNGNTDISCOVERY27",
#if RU_INCLUDE_DESC
    "",
    "LLID index 27 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY27_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY27_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY26
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY26_FIELD =
{
    "INTDNGNTDISCOVERY26",
#if RU_INCLUDE_DESC
    "",
    "LLID index 26 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY26_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY26_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY25
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY25_FIELD =
{
    "INTDNGNTDISCOVERY25",
#if RU_INCLUDE_DESC
    "",
    "LLID index 25 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY25_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY25_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY24
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY24_FIELD =
{
    "INTDNGNTDISCOVERY24",
#if RU_INCLUDE_DESC
    "",
    "LLID index 24 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY24_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY24_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY23
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY23_FIELD =
{
    "INTDNGNTDISCOVERY23",
#if RU_INCLUDE_DESC
    "",
    "LLID index 23 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY23_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY23_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY22
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY22_FIELD =
{
    "INTDNGNTDISCOVERY22",
#if RU_INCLUDE_DESC
    "",
    "LLID index 22 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY22_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY22_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY21
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY21_FIELD =
{
    "INTDNGNTDISCOVERY21",
#if RU_INCLUDE_DESC
    "",
    "LLID index 21 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY21_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY21_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY20
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY20_FIELD =
{
    "INTDNGNTDISCOVERY20",
#if RU_INCLUDE_DESC
    "",
    "LLID index 20 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY20_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY20_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY19
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY19_FIELD =
{
    "INTDNGNTDISCOVERY19",
#if RU_INCLUDE_DESC
    "",
    "LLID index 19 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY19_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY19_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY18
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY18_FIELD =
{
    "INTDNGNTDISCOVERY18",
#if RU_INCLUDE_DESC
    "",
    "LLID index 18 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY18_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY18_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY17
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY17_FIELD =
{
    "INTDNGNTDISCOVERY17",
#if RU_INCLUDE_DESC
    "",
    "LLID index 17 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY17_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY17_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY16
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY16_FIELD =
{
    "INTDNGNTDISCOVERY16",
#if RU_INCLUDE_DESC
    "",
    "LLID index 16 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY16_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY16_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY15
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY15_FIELD =
{
    "INTDNGNTDISCOVERY15",
#if RU_INCLUDE_DESC
    "",
    "LLID index 15 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY15_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY15_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY14
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY14_FIELD =
{
    "INTDNGNTDISCOVERY14",
#if RU_INCLUDE_DESC
    "",
    "LLID index 14 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY14_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY14_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY13
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY13_FIELD =
{
    "INTDNGNTDISCOVERY13",
#if RU_INCLUDE_DESC
    "",
    "LLID index 13 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY13_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY13_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY12
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY12_FIELD =
{
    "INTDNGNTDISCOVERY12",
#if RU_INCLUDE_DESC
    "",
    "LLID index 12 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY12_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY12_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY11
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY11_FIELD =
{
    "INTDNGNTDISCOVERY11",
#if RU_INCLUDE_DESC
    "",
    "LLID index 11 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY11_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY11_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY10
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY10_FIELD =
{
    "INTDNGNTDISCOVERY10",
#if RU_INCLUDE_DESC
    "",
    "LLID index 10 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY10_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY10_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY9
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY9_FIELD =
{
    "INTDNGNTDISCOVERY9",
#if RU_INCLUDE_DESC
    "",
    "LLID index 9 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY9_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY9_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY8
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY8_FIELD =
{
    "INTDNGNTDISCOVERY8",
#if RU_INCLUDE_DESC
    "",
    "LLID index 8 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY8_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY8_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD =
{
    "INTDNGNTDISCOVERY7",
#if RU_INCLUDE_DESC
    "",
    "LLID index 7 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD =
{
    "INTDNGNTDISCOVERY6",
#if RU_INCLUDE_DESC
    "",
    "LLID index 6 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD =
{
    "INTDNGNTDISCOVERY5",
#if RU_INCLUDE_DESC
    "",
    "LLID index 5 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD =
{
    "INTDNGNTDISCOVERY4",
#if RU_INCLUDE_DESC
    "",
    "LLID index 4 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD =
{
    "INTDNGNTDISCOVERY3",
#if RU_INCLUDE_DESC
    "",
    "LLID index 3 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD =
{
    "INTDNGNTDISCOVERY2",
#if RU_INCLUDE_DESC
    "",
    "LLID index 2 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD =
{
    "INTDNGNTDISCOVERY1",
#if RU_INCLUDE_DESC
    "",
    "LLID index 1 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD =
{
    "INTDNGNTDISCOVERY0",
#if RU_INCLUDE_DESC
    "",
    "LLID index 0 received a discovery gate",
#endif
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD_WIDTH,
    EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY31
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY31_FIELD =
{
    "MASKINTDNGNTDISCOVERY31",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 31 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY31_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY31_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY30
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY30_FIELD =
{
    "MASKINTDNGNTDISCOVERY30",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 30 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY30_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY30_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY29
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY29_FIELD =
{
    "MASKINTDNGNTDISCOVERY29",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 29 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY29_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY29_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY28
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY28_FIELD =
{
    "MASKINTDNGNTDISCOVERY28",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 28 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY28_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY28_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY27
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY27_FIELD =
{
    "MASKINTDNGNTDISCOVERY27",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 27 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY27_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY27_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY26
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY26_FIELD =
{
    "MASKINTDNGNTDISCOVERY26",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 26 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY26_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY26_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY25
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY25_FIELD =
{
    "MASKINTDNGNTDISCOVERY25",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 25 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY25_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY25_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY24
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY24_FIELD =
{
    "MASKINTDNGNTDISCOVERY24",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 24 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY24_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY24_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY23
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY23_FIELD =
{
    "MASKINTDNGNTDISCOVERY23",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 23 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY23_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY23_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY22
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY22_FIELD =
{
    "MASKINTDNGNTDISCOVERY22",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 22 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY22_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY22_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY21
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY21_FIELD =
{
    "MASKINTDNGNTDISCOVERY21",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 21 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY21_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY21_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY20
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY20_FIELD =
{
    "MASKINTDNGNTDISCOVERY20",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 20 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY20_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY20_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY19
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY19_FIELD =
{
    "MASKINTDNGNTDISCOVERY19",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 19 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY19_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY19_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY18
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY18_FIELD =
{
    "MASKINTDNGNTDISCOVERY18",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 18 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY18_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY18_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY17
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY17_FIELD =
{
    "MASKINTDNGNTDISCOVERY17",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 17 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY17_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY17_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY16
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY16_FIELD =
{
    "MASKINTDNGNTDISCOVERY16",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 16 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY16_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY16_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY15
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY15_FIELD =
{
    "MASKINTDNGNTDISCOVERY15",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 15 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY15_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY15_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY14
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY14_FIELD =
{
    "MASKINTDNGNTDISCOVERY14",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 14 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY14_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY14_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY13
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY13_FIELD =
{
    "MASKINTDNGNTDISCOVERY13",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 13 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY13_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY13_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY12
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY12_FIELD =
{
    "MASKINTDNGNTDISCOVERY12",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 12 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY12_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY12_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY11
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY11_FIELD =
{
    "MASKINTDNGNTDISCOVERY11",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 11 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY11_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY11_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY10
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY10_FIELD =
{
    "MASKINTDNGNTDISCOVERY10",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 10 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY10_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY10_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY9
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY9_FIELD =
{
    "MASKINTDNGNTDISCOVERY9",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 9 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY9_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY9_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY8
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY8_FIELD =
{
    "MASKINTDNGNTDISCOVERY8",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 8 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY8_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY8_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD =
{
    "MASKINTDNGNTDISCOVERY7",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 7 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD =
{
    "MASKINTDNGNTDISCOVERY6",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 6 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD =
{
    "MASKINTDNGNTDISCOVERY5",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 5 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD =
{
    "MASKINTDNGNTDISCOVERY4",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 4 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD =
{
    "MASKINTDNGNTDISCOVERY3",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 3 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD =
{
    "MASKINTDNGNTDISCOVERY2",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 2 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD =
{
    "MASKINTDNGNTDISCOVERY1",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 1 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0
 ******************************************************************************/
const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD =
{
    "MASKINTDNGNTDISCOVERY0",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 0 received a discovery gate interrupt.",
#endif
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD_MASK,
    0,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD_WIDTH,
    EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL31
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL31_FIELD =
{
    "INTDNGNTINTERVAL31",
#if RU_INCLUDE_DESC
    "",
    "LLID index 31 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL31_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL31_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL30
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL30_FIELD =
{
    "INTDNGNTINTERVAL30",
#if RU_INCLUDE_DESC
    "",
    "LLID index 30 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL30_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL30_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL29
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL29_FIELD =
{
    "INTDNGNTINTERVAL29",
#if RU_INCLUDE_DESC
    "",
    "LLID index 29 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL29_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL29_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL28
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL28_FIELD =
{
    "INTDNGNTINTERVAL28",
#if RU_INCLUDE_DESC
    "",
    "LLID index 28 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL28_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL28_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL27
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL27_FIELD =
{
    "INTDNGNTINTERVAL27",
#if RU_INCLUDE_DESC
    "",
    "LLID index 27 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL27_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL27_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL26
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL26_FIELD =
{
    "INTDNGNTINTERVAL26",
#if RU_INCLUDE_DESC
    "",
    "LLID index 26 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL26_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL26_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL25
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL25_FIELD =
{
    "INTDNGNTINTERVAL25",
#if RU_INCLUDE_DESC
    "",
    "LLID index 25 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL25_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL25_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL24
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL24_FIELD =
{
    "INTDNGNTINTERVAL24",
#if RU_INCLUDE_DESC
    "",
    "LLID index 24 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL24_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL24_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL23
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL23_FIELD =
{
    "INTDNGNTINTERVAL23",
#if RU_INCLUDE_DESC
    "",
    "LLID index 23 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL23_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL23_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL22
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL22_FIELD =
{
    "INTDNGNTINTERVAL22",
#if RU_INCLUDE_DESC
    "",
    "LLID index 22 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL22_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL22_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL21
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL21_FIELD =
{
    "INTDNGNTINTERVAL21",
#if RU_INCLUDE_DESC
    "",
    "LLID index 21 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL21_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL21_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL20
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL20_FIELD =
{
    "INTDNGNTINTERVAL20",
#if RU_INCLUDE_DESC
    "",
    "LLID index 20 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL20_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL20_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL19
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL19_FIELD =
{
    "INTDNGNTINTERVAL19",
#if RU_INCLUDE_DESC
    "",
    "LLID index 19 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL19_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL19_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL18
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL18_FIELD =
{
    "INTDNGNTINTERVAL18",
#if RU_INCLUDE_DESC
    "",
    "LLID index 18 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL18_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL18_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL17
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL17_FIELD =
{
    "INTDNGNTINTERVAL17",
#if RU_INCLUDE_DESC
    "",
    "LLID index 17 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL17_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL17_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL16
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL16_FIELD =
{
    "INTDNGNTINTERVAL16",
#if RU_INCLUDE_DESC
    "",
    "LLID index 16 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL16_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL16_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL15
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL15_FIELD =
{
    "INTDNGNTINTERVAL15",
#if RU_INCLUDE_DESC
    "",
    "LLID index 15 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL15_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL15_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL14
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL14_FIELD =
{
    "INTDNGNTINTERVAL14",
#if RU_INCLUDE_DESC
    "",
    "LLID index 14 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL14_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL14_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL13
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL13_FIELD =
{
    "INTDNGNTINTERVAL13",
#if RU_INCLUDE_DESC
    "",
    "LLID index 13 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL13_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL13_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL12
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL12_FIELD =
{
    "INTDNGNTINTERVAL12",
#if RU_INCLUDE_DESC
    "",
    "LLID index 12 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL12_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL12_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL11
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL11_FIELD =
{
    "INTDNGNTINTERVAL11",
#if RU_INCLUDE_DESC
    "",
    "LLID index 11 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL11_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL11_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL10
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL10_FIELD =
{
    "INTDNGNTINTERVAL10",
#if RU_INCLUDE_DESC
    "",
    "LLID index 10 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL10_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL10_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL9
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL9_FIELD =
{
    "INTDNGNTINTERVAL9",
#if RU_INCLUDE_DESC
    "",
    "LLID index 9 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL9_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL9_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL8
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL8_FIELD =
{
    "INTDNGNTINTERVAL8",
#if RU_INCLUDE_DESC
    "",
    "LLID index 8 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL8_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL8_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD =
{
    "INTDNGNTINTERVAL7",
#if RU_INCLUDE_DESC
    "",
    "LLID index 7 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD =
{
    "INTDNGNTINTERVAL6",
#if RU_INCLUDE_DESC
    "",
    "LLID index 6 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD =
{
    "INTDNGNTINTERVAL5",
#if RU_INCLUDE_DESC
    "",
    "LLID index 5 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD =
{
    "INTDNGNTINTERVAL4",
#if RU_INCLUDE_DESC
    "",
    "LLID index 4 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD =
{
    "INTDNGNTINTERVAL3",
#if RU_INCLUDE_DESC
    "",
    "LLID index 3 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD =
{
    "INTDNGNTINTERVAL2",
#if RU_INCLUDE_DESC
    "",
    "LLID index 2 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD =
{
    "INTDNGNTINTERVAL1",
#if RU_INCLUDE_DESC
    "",
    "LLID index 1 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD =
{
    "INTDNGNTINTERVAL0",
#if RU_INCLUDE_DESC
    "",
    "LLID index 0 failed to receive a GATE within a time period defined"
    "by the EPN Grant Interval register.",
#endif
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD_WIDTH,
    EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL31
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL31_FIELD =
{
    "MASKINTDNGNTINTERVAL31",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 31 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL31_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL31_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL30
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL30_FIELD =
{
    "MASKINTDNGNTINTERVAL30",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 30 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL30_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL30_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL29
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL29_FIELD =
{
    "MASKINTDNGNTINTERVAL29",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 29 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL29_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL29_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL28
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL28_FIELD =
{
    "MASKINTDNGNTINTERVAL28",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 28 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL28_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL28_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL27
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL27_FIELD =
{
    "MASKINTDNGNTINTERVAL27",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 27 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL27_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL27_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL26
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL26_FIELD =
{
    "MASKINTDNGNTINTERVAL26",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 26 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL26_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL26_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL25
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL25_FIELD =
{
    "MASKINTDNGNTINTERVAL25",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 25 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL25_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL25_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL24
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL24_FIELD =
{
    "MASKINTDNGNTINTERVAL24",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 24 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL24_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL24_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL23
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL23_FIELD =
{
    "MASKINTDNGNTINTERVAL23",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 23 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL23_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL23_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL22
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL22_FIELD =
{
    "MASKINTDNGNTINTERVAL22",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 22 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL22_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL22_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL21
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL21_FIELD =
{
    "MASKINTDNGNTINTERVAL21",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 21 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL21_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL21_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL20
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL20_FIELD =
{
    "MASKINTDNGNTINTERVAL20",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 20 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL20_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL20_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL19
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL19_FIELD =
{
    "MASKINTDNGNTINTERVAL19",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 19 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL19_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL19_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL18
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL18_FIELD =
{
    "MASKINTDNGNTINTERVAL18",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 18 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL18_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL18_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL17
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL17_FIELD =
{
    "MASKINTDNGNTINTERVAL17",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 17 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL17_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL17_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL16
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL16_FIELD =
{
    "MASKINTDNGNTINTERVAL16",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 16 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL16_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL16_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL15
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL15_FIELD =
{
    "MASKINTDNGNTINTERVAL15",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 15 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL15_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL15_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL14
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL14_FIELD =
{
    "MASKINTDNGNTINTERVAL14",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 14 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL14_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL14_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL13
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL13_FIELD =
{
    "MASKINTDNGNTINTERVAL13",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 13 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL13_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL13_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL12
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL12_FIELD =
{
    "MASKINTDNGNTINTERVAL12",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 12 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL12_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL12_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL11
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL11_FIELD =
{
    "MASKINTDNGNTINTERVAL11",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 11 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL11_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL11_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL10
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL10_FIELD =
{
    "MASKINTDNGNTINTERVAL10",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 10 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL10_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL10_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL9
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL9_FIELD =
{
    "MASKINTDNGNTINTERVAL9",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 9 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL9_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL9_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL8
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL8_FIELD =
{
    "MASKINTDNGNTINTERVAL8",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 8 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL8_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL8_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD =
{
    "MASKINTDNGNTINTERVAL7",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 7 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD =
{
    "MASKINTDNGNTINTERVAL6",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 6 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD =
{
    "MASKINTDNGNTINTERVAL5",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 5 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD =
{
    "MASKINTDNGNTINTERVAL4",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 4 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD =
{
    "MASKINTDNGNTINTERVAL3",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 3 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD =
{
    "MASKINTDNGNTINTERVAL2",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 2 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD =
{
    "MASKINTDNGNTINTERVAL1",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 1 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD =
{
    "MASKINTDNGNTINTERVAL0",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 0 failed to receive a GATE within a time period"
    "defined by the EPN Grant Interval register interrupt.",
#endif
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD_MASK,
    0,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD_WIDTH,
    EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR31
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR31_FIELD =
{
    "INTDNGNTTOOFAR31",
#if RU_INCLUDE_DESC
    "",
    "LLID index 31 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR31_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR31_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR30
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR30_FIELD =
{
    "INTDNGNTTOOFAR30",
#if RU_INCLUDE_DESC
    "",
    "LLID index 30 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR30_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR30_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR29
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR29_FIELD =
{
    "INTDNGNTTOOFAR29",
#if RU_INCLUDE_DESC
    "",
    "LLID index 29 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR29_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR29_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR28
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR28_FIELD =
{
    "INTDNGNTTOOFAR28",
#if RU_INCLUDE_DESC
    "",
    "LLID index 28 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR28_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR28_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR27
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR27_FIELD =
{
    "INTDNGNTTOOFAR27",
#if RU_INCLUDE_DESC
    "",
    "LLID index 27 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR27_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR27_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR26
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR26_FIELD =
{
    "INTDNGNTTOOFAR26",
#if RU_INCLUDE_DESC
    "",
    "LLID index 26 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR26_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR26_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR25
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR25_FIELD =
{
    "INTDNGNTTOOFAR25",
#if RU_INCLUDE_DESC
    "",
    "LLID index 25 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR25_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR25_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR24
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR24_FIELD =
{
    "INTDNGNTTOOFAR24",
#if RU_INCLUDE_DESC
    "",
    "LLID index 24 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR24_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR24_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR23
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR23_FIELD =
{
    "INTDNGNTTOOFAR23",
#if RU_INCLUDE_DESC
    "",
    "LLID index 23 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR23_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR23_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR22
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR22_FIELD =
{
    "INTDNGNTTOOFAR22",
#if RU_INCLUDE_DESC
    "",
    "LLID index 22 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR22_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR22_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR21
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR21_FIELD =
{
    "INTDNGNTTOOFAR21",
#if RU_INCLUDE_DESC
    "",
    "LLID index 21 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR21_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR21_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR20
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR20_FIELD =
{
    "INTDNGNTTOOFAR20",
#if RU_INCLUDE_DESC
    "",
    "LLID index 20 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR20_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR20_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR19
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR19_FIELD =
{
    "INTDNGNTTOOFAR19",
#if RU_INCLUDE_DESC
    "",
    "LLID index 19 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR19_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR19_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR18
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR18_FIELD =
{
    "INTDNGNTTOOFAR18",
#if RU_INCLUDE_DESC
    "",
    "LLID index 18 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR18_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR18_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR17
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR17_FIELD =
{
    "INTDNGNTTOOFAR17",
#if RU_INCLUDE_DESC
    "",
    "LLID index 17 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR17_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR17_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR16
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR16_FIELD =
{
    "INTDNGNTTOOFAR16",
#if RU_INCLUDE_DESC
    "",
    "LLID index 16 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR16_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR16_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR15
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR15_FIELD =
{
    "INTDNGNTTOOFAR15",
#if RU_INCLUDE_DESC
    "",
    "LLID index 15 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR15_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR15_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR14
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR14_FIELD =
{
    "INTDNGNTTOOFAR14",
#if RU_INCLUDE_DESC
    "",
    "LLID index 14 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR14_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR14_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR13
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR13_FIELD =
{
    "INTDNGNTTOOFAR13",
#if RU_INCLUDE_DESC
    "",
    "LLID index 13 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR13_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR13_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR12
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR12_FIELD =
{
    "INTDNGNTTOOFAR12",
#if RU_INCLUDE_DESC
    "",
    "LLID index 12 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR12_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR12_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR11
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR11_FIELD =
{
    "INTDNGNTTOOFAR11",
#if RU_INCLUDE_DESC
    "",
    "LLID index 11 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR11_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR11_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR10
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR10_FIELD =
{
    "INTDNGNTTOOFAR10",
#if RU_INCLUDE_DESC
    "",
    "LLID index 10 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR10_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR10_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR9
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR9_FIELD =
{
    "INTDNGNTTOOFAR9",
#if RU_INCLUDE_DESC
    "",
    "LLID index 9 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR9_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR9_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR8
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR8_FIELD =
{
    "INTDNGNTTOOFAR8",
#if RU_INCLUDE_DESC
    "",
    "LLID index 8 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR8_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR8_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD =
{
    "INTDNGNTTOOFAR7",
#if RU_INCLUDE_DESC
    "",
    "LLID index 7 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD =
{
    "INTDNGNTTOOFAR6",
#if RU_INCLUDE_DESC
    "",
    "LLID index 6 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD =
{
    "INTDNGNTTOOFAR5",
#if RU_INCLUDE_DESC
    "",
    "LLID index 5 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD =
{
    "INTDNGNTTOOFAR4",
#if RU_INCLUDE_DESC
    "",
    "LLID index 4 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD =
{
    "INTDNGNTTOOFAR3",
#if RU_INCLUDE_DESC
    "",
    "LLID index 3 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD =
{
    "INTDNGNTTOOFAR2",
#if RU_INCLUDE_DESC
    "",
    "LLID index 2 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD =
{
    "INTDNGNTTOOFAR1",
#if RU_INCLUDE_DESC
    "",
    "LLID index 1 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD =
{
    "INTDNGNTTOOFAR0",
#if RU_INCLUDE_DESC
    "",
    "LLID index 0 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future",
#endif
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD_WIDTH,
    EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR31
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR31_FIELD =
{
    "MASKDNGNTTOOFAR31",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 31 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR31_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR31_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR30
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR30_FIELD =
{
    "MASKDNGNTTOOFAR30",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 30 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR30_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR30_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR29
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR29_FIELD =
{
    "MASKDNGNTTOOFAR29",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 29 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR29_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR29_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR28
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR28_FIELD =
{
    "MASKDNGNTTOOFAR28",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 28 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR28_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR28_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR27
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR27_FIELD =
{
    "MASKDNGNTTOOFAR27",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 27 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR27_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR27_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR26
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR26_FIELD =
{
    "MASKDNGNTTOOFAR26",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 26 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR26_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR26_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR25
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR25_FIELD =
{
    "MASKDNGNTTOOFAR25",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 25 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR25_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR25_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR24
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR24_FIELD =
{
    "MASKDNGNTTOOFAR24",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 24 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR24_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR24_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR23
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR23_FIELD =
{
    "MASKDNGNTTOOFAR23",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 23 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR23_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR23_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR22
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR22_FIELD =
{
    "MASKDNGNTTOOFAR22",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 22 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR22_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR22_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR21
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR21_FIELD =
{
    "MASKDNGNTTOOFAR21",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 21 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR21_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR21_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR20
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR20_FIELD =
{
    "MASKDNGNTTOOFAR20",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 20 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR20_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR20_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR19
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR19_FIELD =
{
    "MASKDNGNTTOOFAR19",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 19 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR19_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR19_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR18
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR18_FIELD =
{
    "MASKDNGNTTOOFAR18",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 18 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR18_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR18_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR17
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR17_FIELD =
{
    "MASKDNGNTTOOFAR17",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 17 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR17_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR17_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR16
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR16_FIELD =
{
    "MASKDNGNTTOOFAR16",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 16 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR16_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR16_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR15
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR15_FIELD =
{
    "MASKDNGNTTOOFAR15",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 15 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR15_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR15_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR14
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR14_FIELD =
{
    "MASKDNGNTTOOFAR14",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 14 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR14_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR14_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR13
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR13_FIELD =
{
    "MASKDNGNTTOOFAR13",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 13 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR13_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR13_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR12
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR12_FIELD =
{
    "MASKDNGNTTOOFAR12",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 12 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR12_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR12_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR11
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR11_FIELD =
{
    "MASKDNGNTTOOFAR11",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 11 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR11_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR11_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR10
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR10_FIELD =
{
    "MASKDNGNTTOOFAR10",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 10 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR10_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR10_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR9
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR9_FIELD =
{
    "MASKDNGNTTOOFAR9",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 9 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR9_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR9_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR8
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR8_FIELD =
{
    "MASKDNGNTTOOFAR8",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 8 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR8_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR8_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD =
{
    "MASKDNGNTTOOFAR7",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 7 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD =
{
    "MASKDNGNTTOOFAR6",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 6 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD =
{
    "MASKDNGNTTOOFAR5",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 5 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD =
{
    "MASKDNGNTTOOFAR4",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 4 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD =
{
    "MASKDNGNTTOOFAR3",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 3 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD =
{
    "MASKDNGNTTOOFAR2",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 2 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD =
{
    "MASKDNGNTTOOFAR1",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 1 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0
 ******************************************************************************/
const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD =
{
    "MASKDNGNTTOOFAR0",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 0 received (and aborted) a grant with a start time"
    "greater than 34 sec in the future interrupt",
#endif
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD_MASK,
    0,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD_WIDTH,
    EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN31
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN31_FIELD =
{
    "INTDNGNTMISALIGN31",
#if RU_INCLUDE_DESC
    "",
    "LLID index 31 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN31_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN31_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN30
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN30_FIELD =
{
    "INTDNGNTMISALIGN30",
#if RU_INCLUDE_DESC
    "",
    "LLID index 30 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN30_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN30_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN29
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN29_FIELD =
{
    "INTDNGNTMISALIGN29",
#if RU_INCLUDE_DESC
    "",
    "LLID index 29 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN29_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN29_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN28
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN28_FIELD =
{
    "INTDNGNTMISALIGN28",
#if RU_INCLUDE_DESC
    "",
    "LLID index 28 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN28_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN28_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN27
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN27_FIELD =
{
    "INTDNGNTMISALIGN27",
#if RU_INCLUDE_DESC
    "",
    "LLID index 27 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN27_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN27_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN26
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN26_FIELD =
{
    "INTDNGNTMISALIGN26",
#if RU_INCLUDE_DESC
    "",
    "LLID index 26 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN26_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN26_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN25
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN25_FIELD =
{
    "INTDNGNTMISALIGN25",
#if RU_INCLUDE_DESC
    "",
    "LLID index 25 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN25_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN25_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN24
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN24_FIELD =
{
    "INTDNGNTMISALIGN24",
#if RU_INCLUDE_DESC
    "",
    "LLID index 24 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN24_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN24_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN23
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN23_FIELD =
{
    "INTDNGNTMISALIGN23",
#if RU_INCLUDE_DESC
    "",
    "LLID index 23 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN23_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN23_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN22
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN22_FIELD =
{
    "INTDNGNTMISALIGN22",
#if RU_INCLUDE_DESC
    "",
    "LLID index 22 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN22_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN22_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN21
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN21_FIELD =
{
    "INTDNGNTMISALIGN21",
#if RU_INCLUDE_DESC
    "",
    "LLID index 21 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN21_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN21_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN20
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN20_FIELD =
{
    "INTDNGNTMISALIGN20",
#if RU_INCLUDE_DESC
    "",
    "LLID index 20 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN20_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN20_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN19
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN19_FIELD =
{
    "INTDNGNTMISALIGN19",
#if RU_INCLUDE_DESC
    "",
    "LLID index 19 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN19_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN19_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN18
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN18_FIELD =
{
    "INTDNGNTMISALIGN18",
#if RU_INCLUDE_DESC
    "",
    "LLID index 18 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN18_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN18_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN17
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN17_FIELD =
{
    "INTDNGNTMISALIGN17",
#if RU_INCLUDE_DESC
    "",
    "LLID index 17 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN17_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN17_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN16
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN16_FIELD =
{
    "INTDNGNTMISALIGN16",
#if RU_INCLUDE_DESC
    "",
    "LLID index 16 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN16_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN16_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN15
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN15_FIELD =
{
    "INTDNGNTMISALIGN15",
#if RU_INCLUDE_DESC
    "",
    "LLID index 15 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN15_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN15_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN14
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN14_FIELD =
{
    "INTDNGNTMISALIGN14",
#if RU_INCLUDE_DESC
    "",
    "LLID index 14 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN14_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN14_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN13
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN13_FIELD =
{
    "INTDNGNTMISALIGN13",
#if RU_INCLUDE_DESC
    "",
    "LLID index 13 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN13_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN13_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN12
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN12_FIELD =
{
    "INTDNGNTMISALIGN12",
#if RU_INCLUDE_DESC
    "",
    "LLID index 12 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN12_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN12_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN11
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN11_FIELD =
{
    "INTDNGNTMISALIGN11",
#if RU_INCLUDE_DESC
    "",
    "LLID index 11 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN11_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN11_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN10
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN10_FIELD =
{
    "INTDNGNTMISALIGN10",
#if RU_INCLUDE_DESC
    "",
    "LLID index 10 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN10_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN10_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN9
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN9_FIELD =
{
    "INTDNGNTMISALIGN9",
#if RU_INCLUDE_DESC
    "",
    "LLID index 9 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN9_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN9_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN8
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN8_FIELD =
{
    "INTDNGNTMISALIGN8",
#if RU_INCLUDE_DESC
    "",
    "LLID index 8 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN8_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN8_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD =
{
    "INTDNGNTMISALIGN7",
#if RU_INCLUDE_DESC
    "",
    "LLID index 7 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD =
{
    "INTDNGNTMISALIGN6",
#if RU_INCLUDE_DESC
    "",
    "LLID index 6 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD =
{
    "INTDNGNTMISALIGN5",
#if RU_INCLUDE_DESC
    "",
    "LLID index 5 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD =
{
    "INTDNGNTMISALIGN4",
#if RU_INCLUDE_DESC
    "",
    "LLID index 4 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD =
{
    "INTDNGNTMISALIGN3",
#if RU_INCLUDE_DESC
    "",
    "LLID index 3 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD =
{
    "INTDNGNTMISALIGN2",
#if RU_INCLUDE_DESC
    "",
    "LLID index 2 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD =
{
    "INTDNGNTMISALIGN1",
#if RU_INCLUDE_DESC
    "",
    "LLID index 1 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD =
{
    "INTDNGNTMISALIGN0",
#if RU_INCLUDE_DESC
    "",
    "LLID index 0 received a misaligned grant",
#endif
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN31
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN31_FIELD =
{
    "MASKINTDNGNTMISALIGN31",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 31 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN31_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN31_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN30
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN30_FIELD =
{
    "MASKINTDNGNTMISALIGN30",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 30 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN30_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN30_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN29
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN29_FIELD =
{
    "MASKINTDNGNTMISALIGN29",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 29 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN29_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN29_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN28
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN28_FIELD =
{
    "MASKINTDNGNTMISALIGN28",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 28 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN28_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN28_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN27
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN27_FIELD =
{
    "MASKINTDNGNTMISALIGN27",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 27 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN27_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN27_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN26
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN26_FIELD =
{
    "MASKINTDNGNTMISALIGN26",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 26 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN26_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN26_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN25
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN25_FIELD =
{
    "MASKINTDNGNTMISALIGN25",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 25 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN25_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN25_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN24
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN24_FIELD =
{
    "MASKINTDNGNTMISALIGN24",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 24 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN24_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN24_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN23
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN23_FIELD =
{
    "MASKINTDNGNTMISALIGN23",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 23 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN23_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN23_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN22
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN22_FIELD =
{
    "MASKINTDNGNTMISALIGN22",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 22 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN22_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN22_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN21
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN21_FIELD =
{
    "MASKINTDNGNTMISALIGN21",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 21 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN21_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN21_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN20
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN20_FIELD =
{
    "MASKINTDNGNTMISALIGN20",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 20 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN20_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN20_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN19
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN19_FIELD =
{
    "MASKINTDNGNTMISALIGN19",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 19 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN19_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN19_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN18
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN18_FIELD =
{
    "MASKINTDNGNTMISALIGN18",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 18 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN18_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN18_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN17
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN17_FIELD =
{
    "MASKINTDNGNTMISALIGN17",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 17 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN17_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN17_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN16
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN16_FIELD =
{
    "MASKINTDNGNTMISALIGN16",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 16 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN16_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN16_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN15
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN15_FIELD =
{
    "MASKINTDNGNTMISALIGN15",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 15 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN15_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN15_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN14
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN14_FIELD =
{
    "MASKINTDNGNTMISALIGN14",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 14 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN14_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN14_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN13
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN13_FIELD =
{
    "MASKINTDNGNTMISALIGN13",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 13 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN13_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN13_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN12
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN12_FIELD =
{
    "MASKINTDNGNTMISALIGN12",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 12 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN12_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN12_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN11
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN11_FIELD =
{
    "MASKINTDNGNTMISALIGN11",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 11 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN11_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN11_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN10
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN10_FIELD =
{
    "MASKINTDNGNTMISALIGN10",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 10 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN10_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN10_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN9
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN9_FIELD =
{
    "MASKINTDNGNTMISALIGN9",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 9 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN9_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN9_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN8
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN8_FIELD =
{
    "MASKINTDNGNTMISALIGN8",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 8 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN8_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN8_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD =
{
    "MASKINTDNGNTMISALIGN7",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 7 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD =
{
    "MASKINTDNGNTMISALIGN6",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 6 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD =
{
    "MASKINTDNGNTMISALIGN5",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 5 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD =
{
    "MASKINTDNGNTMISALIGN4",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 4 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD =
{
    "MASKINTDNGNTMISALIGN3",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 3 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD =
{
    "MASKINTDNGNTMISALIGN2",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 2 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD =
{
    "MASKINTDNGNTMISALIGN1",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 1 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0
 ******************************************************************************/
const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD =
{
    "MASKINTDNGNTMISALIGN0",
#if RU_INCLUDE_DESC
    "",
    "Mask LLID index 0 received a misaligned grant interrupt",
#endif
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD_MASK,
    0,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD_WIDTH,
    EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL31
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL31_FIELD =
{
    "INTDNGNTNONPOLL31",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 31",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL31_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL31_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL30
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL30_FIELD =
{
    "INTDNGNTNONPOLL30",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 30",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL30_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL30_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL29
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL29_FIELD =
{
    "INTDNGNTNONPOLL29",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 29",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL29_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL29_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL28
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL28_FIELD =
{
    "INTDNGNTNONPOLL28",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 28",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL28_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL28_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL27
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL27_FIELD =
{
    "INTDNGNTNONPOLL27",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 27",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL27_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL27_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL26
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL26_FIELD =
{
    "INTDNGNTNONPOLL26",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 26",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL26_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL26_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL25
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL25_FIELD =
{
    "INTDNGNTNONPOLL25",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 25",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL25_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL25_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL24
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL24_FIELD =
{
    "INTDNGNTNONPOLL24",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 24",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL24_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL24_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL23
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL23_FIELD =
{
    "INTDNGNTNONPOLL23",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 23",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL23_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL23_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL22
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL22_FIELD =
{
    "INTDNGNTNONPOLL22",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 22",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL22_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL22_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL21
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL21_FIELD =
{
    "INTDNGNTNONPOLL21",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 21",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL21_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL21_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL20
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL20_FIELD =
{
    "INTDNGNTNONPOLL20",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 20",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL20_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL20_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL19
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL19_FIELD =
{
    "INTDNGNTNONPOLL19",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 19",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL19_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL19_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL18
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL18_FIELD =
{
    "INTDNGNTNONPOLL18",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 18",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL18_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL18_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL17
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL17_FIELD =
{
    "INTDNGNTNONPOLL17",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 17",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL17_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL17_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL16
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL16_FIELD =
{
    "INTDNGNTNONPOLL16",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 16",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL16_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL16_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL15
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL15_FIELD =
{
    "INTDNGNTNONPOLL15",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 15",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL15_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL15_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL14
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL14_FIELD =
{
    "INTDNGNTNONPOLL14",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 14",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL14_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL14_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL13
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL13_FIELD =
{
    "INTDNGNTNONPOLL13",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 13",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL13_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL13_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL12
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL12_FIELD =
{
    "INTDNGNTNONPOLL12",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 12",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL12_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL12_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL11
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL11_FIELD =
{
    "INTDNGNTNONPOLL11",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 11",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL11_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL11_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL10
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL10_FIELD =
{
    "INTDNGNTNONPOLL10",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 10",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL10_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL10_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL9
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL9_FIELD =
{
    "INTDNGNTNONPOLL9",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 9",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL9_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL9_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL8
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL8_FIELD =
{
    "INTDNGNTNONPOLL8",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 8",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL8_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL8_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD =
{
    "INTDNGNTNONPOLL7",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 7",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD =
{
    "INTDNGNTNONPOLL6",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 6",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD =
{
    "INTDNGNTNONPOLL5",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 5",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD =
{
    "INTDNGNTNONPOLL4",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 4",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD =
{
    "INTDNGNTNONPOLL3",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 3",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD =
{
    "INTDNGNTNONPOLL2",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 2",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD =
{
    "INTDNGNTNONPOLL1",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 1",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD =
{
    "INTDNGNTNONPOLL0",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 0",
#endif
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD_WIDTH,
    EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL31
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL31_FIELD =
{
    "MASKDNGNTNONPOLL31",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 31 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL31_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL31_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL30
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL30_FIELD =
{
    "MASKDNGNTNONPOLL30",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 30 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL30_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL30_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL29
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL29_FIELD =
{
    "MASKDNGNTNONPOLL29",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 29 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL29_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL29_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL28
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL28_FIELD =
{
    "MASKDNGNTNONPOLL28",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 28 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL28_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL28_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL27
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL27_FIELD =
{
    "MASKDNGNTNONPOLL27",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 27 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL27_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL27_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL26
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL26_FIELD =
{
    "MASKDNGNTNONPOLL26",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 26 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL26_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL26_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL25
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL25_FIELD =
{
    "MASKDNGNTNONPOLL25",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 25 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL25_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL25_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL24
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL24_FIELD =
{
    "MASKDNGNTNONPOLL24",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 24 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL24_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL24_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL23
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL23_FIELD =
{
    "MASKDNGNTNONPOLL23",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 23 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL23_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL23_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL22
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL22_FIELD =
{
    "MASKDNGNTNONPOLL22",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 22 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL22_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL22_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL21
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL21_FIELD =
{
    "MASKDNGNTNONPOLL21",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 21 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL21_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL21_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL20
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL20_FIELD =
{
    "MASKDNGNTNONPOLL20",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 20 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL20_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL20_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL19
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL19_FIELD =
{
    "MASKDNGNTNONPOLL19",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 19 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL19_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL19_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL18
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL18_FIELD =
{
    "MASKDNGNTNONPOLL18",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 18 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL18_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL18_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL17
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL17_FIELD =
{
    "MASKDNGNTNONPOLL17",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 17 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL17_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL17_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL16
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL16_FIELD =
{
    "MASKDNGNTNONPOLL16",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 16 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL16_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL16_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL15
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL15_FIELD =
{
    "MASKDNGNTNONPOLL15",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 15 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL15_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL15_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL14
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL14_FIELD =
{
    "MASKDNGNTNONPOLL14",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 14 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL14_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL14_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL13
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL13_FIELD =
{
    "MASKDNGNTNONPOLL13",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 13 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL13_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL13_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL12
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL12_FIELD =
{
    "MASKDNGNTNONPOLL12",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 12 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL12_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL12_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL11
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL11_FIELD =
{
    "MASKDNGNTNONPOLL11",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 11 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL11_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL11_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL10
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL10_FIELD =
{
    "MASKDNGNTNONPOLL10",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 10 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL10_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL10_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL9
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL9_FIELD =
{
    "MASKDNGNTNONPOLL9",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 9 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL9_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL9_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL8
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL8_FIELD =
{
    "MASKDNGNTNONPOLL8",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 8 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL8_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL8_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD =
{
    "MASKDNGNTNONPOLL7",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 7 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD =
{
    "MASKDNGNTNONPOLL6",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 6 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD =
{
    "MASKDNGNTNONPOLL5",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 5 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD =
{
    "MASKDNGNTNONPOLL4",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 4 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD =
{
    "MASKDNGNTNONPOLL3",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 3 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD =
{
    "MASKDNGNTNONPOLL2",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 2 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD =
{
    "MASKDNGNTNONPOLL1",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 1 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0
 ******************************************************************************/
const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD =
{
    "MASKDNGNTNONPOLL0",
#if RU_INCLUDE_DESC
    "",
    "Non poll grant interval exceeded on LLID Index 0 interrupt mask",
#endif
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD_MASK,
    0,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD_WIDTH,
    EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT31
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT31_FIELD =
{
    "INTDELSTALEGNT31",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 31 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT31_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT31_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT30
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT30_FIELD =
{
    "INTDELSTALEGNT30",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 30 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT30_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT30_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT29
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT29_FIELD =
{
    "INTDELSTALEGNT29",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 29 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT29_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT29_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT28
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT28_FIELD =
{
    "INTDELSTALEGNT28",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 28 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT28_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT28_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT27
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT27_FIELD =
{
    "INTDELSTALEGNT27",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 27 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT27_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT27_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT26
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT26_FIELD =
{
    "INTDELSTALEGNT26",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 26 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT26_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT26_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT25
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT25_FIELD =
{
    "INTDELSTALEGNT25",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 25 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT25_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT25_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT24
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT24_FIELD =
{
    "INTDELSTALEGNT24",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 24 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT24_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT24_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT23
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT23_FIELD =
{
    "INTDELSTALEGNT23",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 23 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT23_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT23_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT22
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT22_FIELD =
{
    "INTDELSTALEGNT22",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 22 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT22_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT22_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT21
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT21_FIELD =
{
    "INTDELSTALEGNT21",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 21 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT21_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT21_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT20
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT20_FIELD =
{
    "INTDELSTALEGNT20",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 20 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT20_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT20_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT19
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT19_FIELD =
{
    "INTDELSTALEGNT19",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 19 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT19_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT19_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT18
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT18_FIELD =
{
    "INTDELSTALEGNT18",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 18 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT18_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT18_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT17
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT17_FIELD =
{
    "INTDELSTALEGNT17",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 17 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT17_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT17_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT16
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT16_FIELD =
{
    "INTDELSTALEGNT16",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 16 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT16_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT16_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT15
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT15_FIELD =
{
    "INTDELSTALEGNT15",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 15 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT15_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT15_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT14
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT14_FIELD =
{
    "INTDELSTALEGNT14",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 14 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT14_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT14_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT13
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT13_FIELD =
{
    "INTDELSTALEGNT13",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 13 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT13_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT13_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT12
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT12_FIELD =
{
    "INTDELSTALEGNT12",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 12 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT12_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT12_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT11
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT11_FIELD =
{
    "INTDELSTALEGNT11",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 11 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT11_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT11_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT10
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT10_FIELD =
{
    "INTDELSTALEGNT10",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 10 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT10_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT10_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT9
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT9_FIELD =
{
    "INTDELSTALEGNT9",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 9 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT9_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT9_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT8
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT8_FIELD =
{
    "INTDELSTALEGNT8",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 8 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT8_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT8_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD =
{
    "INTDELSTALEGNT7",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 7 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD =
{
    "INTDELSTALEGNT6",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 6 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD =
{
    "INTDELSTALEGNT5",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 5 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD =
{
    "INTDELSTALEGNT4",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 4 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD =
{
    "INTDELSTALEGNT3",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 3 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD =
{
    "INTDELSTALEGNT2",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 2 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD =
{
    "INTDELSTALEGNT1",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 1 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD =
{
    "INTDELSTALEGNT0",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 0 grant RAM.",
#endif
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD_WIDTH,
    EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT31
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT31_FIELD =
{
    "MASKINTDELSTALEGNT31",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 31 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT31_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT31_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT30
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT30_FIELD =
{
    "MASKINTDELSTALEGNT30",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 30 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT30_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT30_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT29
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT29_FIELD =
{
    "MASKINTDELSTALEGNT29",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 29 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT29_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT29_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT28
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT28_FIELD =
{
    "MASKINTDELSTALEGNT28",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 28 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT28_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT28_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT27
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT27_FIELD =
{
    "MASKINTDELSTALEGNT27",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 27 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT27_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT27_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT26
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT26_FIELD =
{
    "MASKINTDELSTALEGNT26",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 26 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT26_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT26_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT25
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT25_FIELD =
{
    "MASKINTDELSTALEGNT25",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 25 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT25_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT25_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT24
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT24_FIELD =
{
    "MASKINTDELSTALEGNT24",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 24 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT24_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT24_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT23
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT23_FIELD =
{
    "MASKINTDELSTALEGNT23",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 23 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT23_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT23_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT22
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT22_FIELD =
{
    "MASKINTDELSTALEGNT22",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 22 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT22_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT22_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT21
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT21_FIELD =
{
    "MASKINTDELSTALEGNT21",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 21 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT21_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT21_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT20
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT20_FIELD =
{
    "MASKINTDELSTALEGNT20",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 20 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT20_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT20_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT19
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT19_FIELD =
{
    "MASKINTDELSTALEGNT19",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 19 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT19_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT19_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT18
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT18_FIELD =
{
    "MASKINTDELSTALEGNT18",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 18 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT18_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT18_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT17
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT17_FIELD =
{
    "MASKINTDELSTALEGNT17",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 17 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT17_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT17_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT16
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT16_FIELD =
{
    "MASKINTDELSTALEGNT16",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 16 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT16_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT16_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT15
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT15_FIELD =
{
    "MASKINTDELSTALEGNT15",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 15 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT15_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT15_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT14
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT14_FIELD =
{
    "MASKINTDELSTALEGNT14",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 14 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT14_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT14_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT13
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT13_FIELD =
{
    "MASKINTDELSTALEGNT13",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 13 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT13_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT13_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT12
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT12_FIELD =
{
    "MASKINTDELSTALEGNT12",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 12 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT12_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT12_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT11
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT11_FIELD =
{
    "MASKINTDELSTALEGNT11",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 11 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT11_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT11_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT10
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT10_FIELD =
{
    "MASKINTDELSTALEGNT10",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 10 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT10_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT10_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT9
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT9_FIELD =
{
    "MASKINTDELSTALEGNT9",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 9 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT9_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT9_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT8
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT8_FIELD =
{
    "MASKINTDELSTALEGNT8",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 8 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT8_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT8_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD =
{
    "MASKINTDELSTALEGNT7",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 7 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD =
{
    "MASKINTDELSTALEGNT6",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 6 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD =
{
    "MASKINTDELSTALEGNT5",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 5 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD =
{
    "MASKINTDELSTALEGNT4",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 4 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD =
{
    "MASKINTDELSTALEGNT3",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 3 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD =
{
    "MASKINTDELSTALEGNT2",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 2 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD =
{
    "MASKINTDELSTALEGNT1",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 1 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0
 ******************************************************************************/
const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD =
{
    "MASKINTDELSTALEGNT0",
#if RU_INCLUDE_DESC
    "",
    "Stale grant deleted from LLID Index 0 grant RAM interrupt mask.",
#endif
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD_MASK,
    0,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD_WIDTH,
    EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY31
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY31_FIELD =
{
    "INTDNGNTRDY31",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 31 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY31_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY31_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY30
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY30_FIELD =
{
    "INTDNGNTRDY30",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 30 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY30_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY30_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY29
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY29_FIELD =
{
    "INTDNGNTRDY29",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 29 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY29_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY29_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY28
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY28_FIELD =
{
    "INTDNGNTRDY28",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 28 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY28_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY28_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY27
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY27_FIELD =
{
    "INTDNGNTRDY27",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 27 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY27_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY27_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY26
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY26_FIELD =
{
    "INTDNGNTRDY26",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 26 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY26_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY26_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY25
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY25_FIELD =
{
    "INTDNGNTRDY25",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 25 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY25_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY25_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY24
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY24_FIELD =
{
    "INTDNGNTRDY24",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 24 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY24_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY24_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY23
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY23_FIELD =
{
    "INTDNGNTRDY23",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 23 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY23_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY23_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY22
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY22_FIELD =
{
    "INTDNGNTRDY22",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 22 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY22_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY22_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY21
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY21_FIELD =
{
    "INTDNGNTRDY21",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 21 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY21_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY21_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY20
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY20_FIELD =
{
    "INTDNGNTRDY20",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 20 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY20_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY20_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY19
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY19_FIELD =
{
    "INTDNGNTRDY19",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 19 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY19_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY19_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY18
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY18_FIELD =
{
    "INTDNGNTRDY18",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 18 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY18_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY18_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY17
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY17_FIELD =
{
    "INTDNGNTRDY17",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 17 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY17_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY17_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY16
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY16_FIELD =
{
    "INTDNGNTRDY16",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 16 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY16_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY16_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY15
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY15_FIELD =
{
    "INTDNGNTRDY15",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 15 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY15_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY15_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY14
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY14_FIELD =
{
    "INTDNGNTRDY14",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 14 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY14_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY14_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY13
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY13_FIELD =
{
    "INTDNGNTRDY13",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 13 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY13_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY13_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY12
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY12_FIELD =
{
    "INTDNGNTRDY12",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 12 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY12_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY12_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY11
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY11_FIELD =
{
    "INTDNGNTRDY11",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 11 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY11_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY11_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY10
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY10_FIELD =
{
    "INTDNGNTRDY10",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 10 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY10_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY10_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY9
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY9_FIELD =
{
    "INTDNGNTRDY9",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 9 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY9_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY9_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY8
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY8_FIELD =
{
    "INTDNGNTRDY8",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 8 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY8_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY8_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD =
{
    "INTDNGNTRDY7",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 7 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD =
{
    "INTDNGNTRDY6",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 6 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD =
{
    "INTDNGNTRDY5",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 5 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD =
{
    "INTDNGNTRDY4",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 4 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD =
{
    "INTDNGNTRDY3",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 3 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD =
{
    "INTDNGNTRDY2",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 2 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD =
{
    "INTDNGNTRDY1",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 1 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD =
{
    "INTDNGNTRDY0",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 0 grant RAM",
#endif
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD_WIDTH,
    EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY31
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY31_FIELD =
{
    "MASKDNGNTRDY31",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 31 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY31_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY31_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY30
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY30_FIELD =
{
    "MASKDNGNTRDY30",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 30 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY30_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY30_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY29
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY29_FIELD =
{
    "MASKDNGNTRDY29",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 29 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY29_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY29_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY28
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY28_FIELD =
{
    "MASKDNGNTRDY28",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 28 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY28_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY28_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY27
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY27_FIELD =
{
    "MASKDNGNTRDY27",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 27 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY27_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY27_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY26
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY26_FIELD =
{
    "MASKDNGNTRDY26",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 26 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY26_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY26_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY25
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY25_FIELD =
{
    "MASKDNGNTRDY25",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 25 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY25_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY25_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY24
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY24_FIELD =
{
    "MASKDNGNTRDY24",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 24 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY24_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY24_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY23
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY23_FIELD =
{
    "MASKDNGNTRDY23",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 23 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY23_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY23_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY22
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY22_FIELD =
{
    "MASKDNGNTRDY22",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 22 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY22_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY22_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY21
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY21_FIELD =
{
    "MASKDNGNTRDY21",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 21 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY21_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY21_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY20
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY20_FIELD =
{
    "MASKDNGNTRDY20",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 20 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY20_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY20_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY19
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY19_FIELD =
{
    "MASKDNGNTRDY19",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 19 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY19_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY19_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY18
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY18_FIELD =
{
    "MASKDNGNTRDY18",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 18 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY18_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY18_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY17
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY17_FIELD =
{
    "MASKDNGNTRDY17",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 17 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY17_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY17_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY16
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY16_FIELD =
{
    "MASKDNGNTRDY16",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 16 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY16_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY16_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY15
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY15_FIELD =
{
    "MASKDNGNTRDY15",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 15 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY15_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY15_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY14
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY14_FIELD =
{
    "MASKDNGNTRDY14",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 14 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY14_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY14_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY13
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY13_FIELD =
{
    "MASKDNGNTRDY13",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 13 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY13_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY13_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY12
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY12_FIELD =
{
    "MASKDNGNTRDY12",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 12 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY12_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY12_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY11
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY11_FIELD =
{
    "MASKDNGNTRDY11",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 11 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY11_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY11_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY10
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY10_FIELD =
{
    "MASKDNGNTRDY10",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 10 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY10_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY10_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY9
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY9_FIELD =
{
    "MASKDNGNTRDY9",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 9 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY9_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY9_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY8
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY8_FIELD =
{
    "MASKDNGNTRDY8",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 8 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY8_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY8_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD =
{
    "MASKDNGNTRDY7",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 7 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD =
{
    "MASKDNGNTRDY6",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 6 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD =
{
    "MASKDNGNTRDY5",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 5 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD =
{
    "MASKDNGNTRDY4",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 4 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD =
{
    "MASKDNGNTRDY3",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 3 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD =
{
    "MASKDNGNTRDY2",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 2 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD =
{
    "MASKDNGNTRDY1",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 1 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0
 ******************************************************************************/
const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD =
{
    "MASKDNGNTRDY0",
#if RU_INCLUDE_DESC
    "",
    "Grant present in LLID Index 0 grant RAM interrupt mask",
#endif
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD_MASK,
    0,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD_WIDTH,
    EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO31
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO31_FIELD =
{
    "INTUPRPTFIFO31",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 31 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO31_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO31_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO30
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO30_FIELD =
{
    "INTUPRPTFIFO30",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 30 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO30_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO30_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO29
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO29_FIELD =
{
    "INTUPRPTFIFO29",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 29 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO29_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO29_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO28
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO28_FIELD =
{
    "INTUPRPTFIFO28",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 28 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO28_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO28_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO27
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO27_FIELD =
{
    "INTUPRPTFIFO27",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 27 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO27_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO27_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO26
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO26_FIELD =
{
    "INTUPRPTFIFO26",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 26 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO26_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO26_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO25
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO25_FIELD =
{
    "INTUPRPTFIFO25",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 25 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO25_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO25_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO24
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO24_FIELD =
{
    "INTUPRPTFIFO24",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 24 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO24_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO24_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO23
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO23_FIELD =
{
    "INTUPRPTFIFO23",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 23 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO23_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO23_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO22
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO22_FIELD =
{
    "INTUPRPTFIFO22",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 22 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO22_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO22_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO21
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO21_FIELD =
{
    "INTUPRPTFIFO21",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 21 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO21_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO21_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO20
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO20_FIELD =
{
    "INTUPRPTFIFO20",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 20 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO20_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO20_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO19
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO19_FIELD =
{
    "INTUPRPTFIFO19",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 19 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO19_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO19_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO18
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO18_FIELD =
{
    "INTUPRPTFIFO18",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 18 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO18_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO18_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO17
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO17_FIELD =
{
    "INTUPRPTFIFO17",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 17 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO17_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO17_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO16
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO16_FIELD =
{
    "INTUPRPTFIFO16",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 16 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO16_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO16_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO15
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO15_FIELD =
{
    "INTUPRPTFIFO15",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 15 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO15_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO15_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO14
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO14_FIELD =
{
    "INTUPRPTFIFO14",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 14 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO14_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO14_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO13
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO13_FIELD =
{
    "INTUPRPTFIFO13",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 13 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO13_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO13_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO12
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO12_FIELD =
{
    "INTUPRPTFIFO12",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 12 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO12_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO12_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO11
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO11_FIELD =
{
    "INTUPRPTFIFO11",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 11 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO11_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO11_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO10
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO10_FIELD =
{
    "INTUPRPTFIFO10",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 10 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO10_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO10_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO9
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO9_FIELD =
{
    "INTUPRPTFIFO9",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 9 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO9_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO9_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO8
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO8_FIELD =
{
    "INTUPRPTFIFO8",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 8 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO8_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO8_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD =
{
    "INTUPRPTFIFO7",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 7 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD =
{
    "INTUPRPTFIFO6",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 6 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD =
{
    "INTUPRPTFIFO5",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 5 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD =
{
    "INTUPRPTFIFO4",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 4 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD =
{
    "INTUPRPTFIFO3",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 3 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD =
{
    "INTUPRPTFIFO2",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 2 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD =
{
    "INTUPRPTFIFO1",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 1 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD =
{
    "INTUPRPTFIFO0",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 0 report FIFO",
#endif
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD_WIDTH,
    EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO31
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO31_FIELD =
{
    "MASKINTUPRPTFIFO31",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 31 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO31_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO31_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO30
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO30_FIELD =
{
    "MASKINTUPRPTFIFO30",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 30 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO30_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO30_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO29
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO29_FIELD =
{
    "MASKINTUPRPTFIFO29",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 29 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO29_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO29_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO28
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO28_FIELD =
{
    "MASKINTUPRPTFIFO28",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 28 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO28_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO28_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO27
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO27_FIELD =
{
    "MASKINTUPRPTFIFO27",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 27 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO27_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO27_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO26
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO26_FIELD =
{
    "MASKINTUPRPTFIFO26",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 26 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO26_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO26_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO25
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO25_FIELD =
{
    "MASKINTUPRPTFIFO25",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 25 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO25_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO25_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO24
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO24_FIELD =
{
    "MASKINTUPRPTFIFO24",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 24 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO24_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO24_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO23
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO23_FIELD =
{
    "MASKINTUPRPTFIFO23",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 23 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO23_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO23_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO22
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO22_FIELD =
{
    "MASKINTUPRPTFIFO22",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 22 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO22_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO22_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO21
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO21_FIELD =
{
    "MASKINTUPRPTFIFO21",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 21 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO21_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO21_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO20
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO20_FIELD =
{
    "MASKINTUPRPTFIFO20",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 20 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO20_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO20_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO19
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO19_FIELD =
{
    "MASKINTUPRPTFIFO19",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 19 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO19_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO19_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO18
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO18_FIELD =
{
    "MASKINTUPRPTFIFO18",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 18 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO18_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO18_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO17
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO17_FIELD =
{
    "MASKINTUPRPTFIFO17",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 17 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO17_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO17_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO16
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO16_FIELD =
{
    "MASKINTUPRPTFIFO16",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 16 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO16_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO16_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO15
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO15_FIELD =
{
    "MASKINTUPRPTFIFO15",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 15 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO15_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO15_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO14
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO14_FIELD =
{
    "MASKINTUPRPTFIFO14",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 14 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO14_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO14_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO13
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO13_FIELD =
{
    "MASKINTUPRPTFIFO13",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 13 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO13_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO13_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO12
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO12_FIELD =
{
    "MASKINTUPRPTFIFO12",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 12 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO12_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO12_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO11
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO11_FIELD =
{
    "MASKINTUPRPTFIFO11",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 11 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO11_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO11_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO10
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO10_FIELD =
{
    "MASKINTUPRPTFIFO10",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 10 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO10_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO10_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO9
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO9_FIELD =
{
    "MASKINTUPRPTFIFO9",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 9 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO9_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO9_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO8
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO8_FIELD =
{
    "MASKINTUPRPTFIFO8",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 8 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO8_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO8_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD =
{
    "MASKINTUPRPTFIFO7",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 7 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD =
{
    "MASKINTUPRPTFIFO6",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 6 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD =
{
    "MASKINTUPRPTFIFO5",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 5 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD =
{
    "MASKINTUPRPTFIFO4",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 4 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD =
{
    "MASKINTUPRPTFIFO3",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 3 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD =
{
    "MASKINTUPRPTFIFO2",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 2 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD =
{
    "MASKINTUPRPTFIFO1",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 1 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0
 ******************************************************************************/
const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD =
{
    "MASKINTUPRPTFIFO0",
#if RU_INCLUDE_DESC
    "",
    "Frame length present in LLID Index 0 report FIFO interrupt mask",
#endif
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD_MASK,
    0,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD_WIDTH,
    EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT
 ******************************************************************************/
const ru_field_rec EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD =
{
    "INTDRXERRABORT",
#if RU_INCLUDE_DESC
    "",
    "The Drx detected an error that required an LLID Index 0-31 (bitwise)"
    "frame be aborted in the RDP",
#endif
    EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD_MASK,
    0,
    EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD_WIDTH,
    EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT
 ******************************************************************************/
const ru_field_rec EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD =
{
    "MASKINTDRXERRABORT",
#if RU_INCLUDE_DESC
    "",
    "Mask the Drx detected an error that required an LLID Index 0-31"
    "(bitwise) frame be aborted in the RDP interrupt.",
#endif
    EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD_MASK,
    0,
    EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD_WIDTH,
    EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT31
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT31_FIELD =
{
    "INTEMPTYRPT31",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 31 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT31_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT31_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT30
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT30_FIELD =
{
    "INTEMPTYRPT30",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 30 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT30_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT30_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT29
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT29_FIELD =
{
    "INTEMPTYRPT29",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 29 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT29_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT29_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT28
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT28_FIELD =
{
    "INTEMPTYRPT28",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 28 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT28_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT28_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT27
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT27_FIELD =
{
    "INTEMPTYRPT27",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 27 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT27_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT27_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT26
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT26_FIELD =
{
    "INTEMPTYRPT26",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 26 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT26_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT26_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT25
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT25_FIELD =
{
    "INTEMPTYRPT25",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 25 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT25_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT25_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT24
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT24_FIELD =
{
    "INTEMPTYRPT24",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 24 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT24_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT24_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT23
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT23_FIELD =
{
    "INTEMPTYRPT23",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 23 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT23_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT23_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT22
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT22_FIELD =
{
    "INTEMPTYRPT22",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 22 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT22_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT22_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT21
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT21_FIELD =
{
    "INTEMPTYRPT21",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 21 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT21_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT21_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT20
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT20_FIELD =
{
    "INTEMPTYRPT20",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 20 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT20_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT20_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT19
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT19_FIELD =
{
    "INTEMPTYRPT19",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 19 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT19_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT19_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT18
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT18_FIELD =
{
    "INTEMPTYRPT18",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 18 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT18_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT18_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT17
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT17_FIELD =
{
    "INTEMPTYRPT17",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 17 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT17_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT17_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT16
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT16_FIELD =
{
    "INTEMPTYRPT16",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 16 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT16_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT16_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT15
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT15_FIELD =
{
    "INTEMPTYRPT15",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 15 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT15_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT15_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT14
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT14_FIELD =
{
    "INTEMPTYRPT14",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 14 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT14_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT14_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT13
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT13_FIELD =
{
    "INTEMPTYRPT13",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 13 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT13_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT13_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT12
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT12_FIELD =
{
    "INTEMPTYRPT12",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 12 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT12_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT12_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT11
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT11_FIELD =
{
    "INTEMPTYRPT11",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 11 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT11_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT11_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT10
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT10_FIELD =
{
    "INTEMPTYRPT10",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 10 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT10_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT10_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT9
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT9_FIELD =
{
    "INTEMPTYRPT9",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 9 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT9_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT9_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT8
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT8_FIELD =
{
    "INTEMPTYRPT8",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 8 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT8_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT8_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD =
{
    "INTEMPTYRPT7",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 7 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD =
{
    "INTEMPTYRPT6",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 6 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD =
{
    "INTEMPTYRPT5",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 5 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD =
{
    "INTEMPTYRPT4",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 4 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD =
{
    "INTEMPTYRPT3",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 3 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD =
{
    "INTEMPTYRPT2",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 2 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD =
{
    "INTEMPTYRPT1",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 1 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD =
{
    "INTEMPTYRPT0",
#if RU_INCLUDE_DESC
    "",
    "Time quanta values present in LLID Index 0 report were all zero.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT31
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT31_FIELD =
{
    "MASKINTEMPTYRPT31",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 31 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT31_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT31_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT30
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT30_FIELD =
{
    "MASKINTEMPTYRPT30",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 30 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT30_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT30_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT29
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT29_FIELD =
{
    "MASKINTEMPTYRPT29",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 29 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT29_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT29_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT28
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT28_FIELD =
{
    "MASKINTEMPTYRPT28",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 28 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT28_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT28_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT27
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT27_FIELD =
{
    "MASKINTEMPTYRPT27",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 27 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT27_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT27_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT26
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT26_FIELD =
{
    "MASKINTEMPTYRPT26",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 26 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT26_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT26_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT25
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT25_FIELD =
{
    "MASKINTEMPTYRPT25",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 25 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT25_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT25_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT24
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT24_FIELD =
{
    "MASKINTEMPTYRPT24",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 24 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT24_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT24_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT23
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT23_FIELD =
{
    "MASKINTEMPTYRPT23",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 23 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT23_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT23_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT22
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT22_FIELD =
{
    "MASKINTEMPTYRPT22",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 22 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT22_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT22_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT21
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT21_FIELD =
{
    "MASKINTEMPTYRPT21",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 21 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT21_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT21_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT20
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT20_FIELD =
{
    "MASKINTEMPTYRPT20",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 20 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT20_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT20_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT19
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT19_FIELD =
{
    "MASKINTEMPTYRPT19",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 19 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT19_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT19_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT18
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT18_FIELD =
{
    "MASKINTEMPTYRPT18",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 18 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT18_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT18_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT17
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT17_FIELD =
{
    "MASKINTEMPTYRPT17",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 17 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT17_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT17_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT16
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT16_FIELD =
{
    "MASKINTEMPTYRPT16",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 16 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT16_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT16_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT15
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT15_FIELD =
{
    "MASKINTEMPTYRPT15",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 15 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT15_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT15_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT14
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT14_FIELD =
{
    "MASKINTEMPTYRPT14",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 14 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT14_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT14_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT13
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT13_FIELD =
{
    "MASKINTEMPTYRPT13",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 13 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT13_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT13_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT12
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT12_FIELD =
{
    "MASKINTEMPTYRPT12",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 12 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT12_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT12_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT11
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT11_FIELD =
{
    "MASKINTEMPTYRPT11",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 11 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT11_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT11_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT10
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT10_FIELD =
{
    "MASKINTEMPTYRPT10",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 10 report were all"
    "zero interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT10_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT10_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT9
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT9_FIELD =
{
    "MASKINTEMPTYRPT9",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 9 report were all zero"
    "interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT9_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT9_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT8
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT8_FIELD =
{
    "MASKINTEMPTYRPT8",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 8 report were all zero"
    "interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT8_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT8_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD =
{
    "MASKINTEMPTYRPT7",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 7 report were all zero"
    "interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD =
{
    "MASKINTEMPTYRPT6",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 6 report were all zero"
    "interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD =
{
    "MASKINTEMPTYRPT5",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 5 report were all zero"
    "interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD =
{
    "MASKINTEMPTYRPT4",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 4 report were all zero"
    "interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD =
{
    "MASKINTEMPTYRPT3",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 3 report were all zero"
    "interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD =
{
    "MASKINTEMPTYRPT2",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 2 report were all zero"
    "interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD =
{
    "MASKINTEMPTYRPT1",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 1 report were all zero"
    "interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0
 ******************************************************************************/
const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD =
{
    "MASKINTEMPTYRPT0",
#if RU_INCLUDE_DESC
    "",
    "Mask time quanta values present in LLID Index 0 report were all zero"
    "interrupt.",
#endif
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD_MASK,
    0,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD_WIDTH,
    EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW
 ******************************************************************************/
const ru_field_rec EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD =
{
    "INTL2SBURSTCAPOVERFLOW",
#if RU_INCLUDE_DESC
    "",
    "Indicates that the L2 accumulator 0-31 (bitwise) has exceeded its"
    "burst cap value.",
#endif
    EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD_MASK,
    0,
    EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD_WIDTH,
    EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW
 ******************************************************************************/
const ru_field_rec EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD =
{
    "MASKINTL2SBURSTCAPOVERFLOW",
#if RU_INCLUDE_DESC
    "",
    "Mask interrupt indicating that the L2 accumulator 0-31 (bitwise) has"
    "exceeded its burst cap value.",
#endif
    EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD_MASK,
    0,
    EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD_WIDTH,
    EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD_MASK,
    0,
    EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD_WIDTH,
    EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW
 ******************************************************************************/
const ru_field_rec EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD =
{
    "INTBBHDNSOVERFLOW",
#if RU_INCLUDE_DESC
    "",
    "Indicates the downstream BBH interface failed to transfer the"
    "downstream fast enough.  This occurs when the Epn dropped a"
    "downstream packet (sent abort).",
#endif
    EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD_MASK,
    0,
    EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD_WIDTH,
    EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD_MASK,
    0,
    EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD_WIDTH,
    EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW
 ******************************************************************************/
const ru_field_rec EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD =
{
    "MASKINTBBHDNSOVERFLOW",
#if RU_INCLUDE_DESC
    "",
    "Mask downstream BBH data path overflow interrupt.",
#endif
    EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD_MASK,
    0,
    EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD_WIDTH,
    EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT31
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT31_FIELD =
{
    "INTBBHUPSFAULT31",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 31 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT31_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT31_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT30
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT30_FIELD =
{
    "INTBBHUPSFAULT30",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 30 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT30_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT30_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT29
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT29_FIELD =
{
    "INTBBHUPSFAULT29",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 29 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT29_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT29_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT28
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT28_FIELD =
{
    "INTBBHUPSFAULT28",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 28 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT28_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT28_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT27
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT27_FIELD =
{
    "INTBBHUPSFAULT27",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 27 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT27_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT27_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT26
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT26_FIELD =
{
    "INTBBHUPSFAULT26",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 26 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT26_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT26_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT25
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT25_FIELD =
{
    "INTBBHUPSFAULT25",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 25 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT25_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT25_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT24
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT24_FIELD =
{
    "INTBBHUPSFAULT24",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 24 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT24_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT24_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT23
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT23_FIELD =
{
    "INTBBHUPSFAULT23",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 23 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT23_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT23_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT22
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT22_FIELD =
{
    "INTBBHUPSFAULT22",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 22 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT22_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT22_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT21
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT21_FIELD =
{
    "INTBBHUPSFAULT21",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 21 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT21_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT21_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT20
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT20_FIELD =
{
    "INTBBHUPSFAULT20",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 20 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT20_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT20_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT19
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT19_FIELD =
{
    "INTBBHUPSFAULT19",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 19 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT19_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT19_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT18
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT18_FIELD =
{
    "INTBBHUPSFAULT18",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 18 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT18_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT18_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT17
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT17_FIELD =
{
    "INTBBHUPSFAULT17",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 17 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT17_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT17_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT16
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT16_FIELD =
{
    "INTBBHUPSFAULT16",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 16 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT16_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT16_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT15
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT15_FIELD =
{
    "INTBBHUPSFAULT15",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 15 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT15_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT15_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT14
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT14_FIELD =
{
    "INTBBHUPSFAULT14",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 14 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT14_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT14_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT13
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT13_FIELD =
{
    "INTBBHUPSFAULT13",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 13 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT13_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT13_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT12
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT12_FIELD =
{
    "INTBBHUPSFAULT12",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 12 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT12_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT12_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT11
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT11_FIELD =
{
    "INTBBHUPSFAULT11",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 11 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT11_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT11_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT10
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT10_FIELD =
{
    "INTBBHUPSFAULT10",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 10 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT10_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT10_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT9
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT9_FIELD =
{
    "INTBBHUPSFAULT9",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 9 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT9_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT9_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT8
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT8_FIELD =
{
    "INTBBHUPSFAULT8",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 8 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT8_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT8_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD =
{
    "INTBBHUPSFAULT7",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 7 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD =
{
    "INTBBHUPSFAULT6",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 6 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD =
{
    "INTBBHUPSFAULT5",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 5 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD =
{
    "INTBBHUPSFAULT4",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 4 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD =
{
    "INTBBHUPSFAULT3",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 3 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD =
{
    "INTBBHUPSFAULT2",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 2 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD =
{
    "INTBBHUPSFAULT1",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 1 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD =
{
    "INTBBHUPSFAULT0",
#if RU_INCLUDE_DESC
    "",
    "Indicates upstream LLID index 0 has lost coherency with the"
    "Runner/BBH. This condition can be recovered by resetting the data"
    "path associated with the LLID index."
    "Note: Do not clear these interrupts until the LLID index data path"
    "has been reset or the LLID index's upstream traffic has been"
    "disabled using 'EPN Enable Upstream' register.",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT31
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT31_FIELD =
{
    "MASKINTBBHUPSFAULT31",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 31 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT31_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT31_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT30
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT30_FIELD =
{
    "MASKINTBBHUPSFAULT30",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 30 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT30_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT30_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT29
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT29_FIELD =
{
    "MASKINTBBHUPSFAULT29",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 29 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT29_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT29_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT28
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT28_FIELD =
{
    "MASKINTBBHUPSFAULT28",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 28 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT28_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT28_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT27
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT27_FIELD =
{
    "MASKINTBBHUPSFAULT27",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 27 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT27_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT27_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT26
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT26_FIELD =
{
    "MASKINTBBHUPSFAULT26",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 26 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT26_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT26_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT25
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT25_FIELD =
{
    "MASKINTBBHUPSFAULT25",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 25 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT25_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT25_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT24
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT24_FIELD =
{
    "MASKINTBBHUPSFAULT24",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 24 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT24_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT24_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT23
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT23_FIELD =
{
    "MASKINTBBHUPSFAULT23",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 23 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT23_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT23_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT22
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT22_FIELD =
{
    "MASKINTBBHUPSFAULT22",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 22 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT22_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT22_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT21
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT21_FIELD =
{
    "MASKINTBBHUPSFAULT21",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 21 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT21_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT21_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT20
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT20_FIELD =
{
    "MASKINTBBHUPSFAULT20",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 20 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT20_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT20_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT19
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT19_FIELD =
{
    "MASKINTBBHUPSFAULT19",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 19 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT19_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT19_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT18
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT18_FIELD =
{
    "MASKINTBBHUPSFAULT18",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 18 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT18_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT18_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT17
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT17_FIELD =
{
    "MASKINTBBHUPSFAULT17",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 17 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT17_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT17_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT16
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT16_FIELD =
{
    "MASKINTBBHUPSFAULT16",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 16 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT16_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT16_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT15
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT15_FIELD =
{
    "MASKINTBBHUPSFAULT15",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 15 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT15_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT15_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT14
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT14_FIELD =
{
    "MASKINTBBHUPSFAULT14",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 14 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT14_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT14_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT13
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT13_FIELD =
{
    "MASKINTBBHUPSFAULT13",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 13 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT13_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT13_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT12
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT12_FIELD =
{
    "MASKINTBBHUPSFAULT12",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 12 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT12_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT12_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT11
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT11_FIELD =
{
    "MASKINTBBHUPSFAULT11",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 11 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT11_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT11_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT10
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT10_FIELD =
{
    "MASKINTBBHUPSFAULT10",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 10 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT10_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT10_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT9
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT9_FIELD =
{
    "MASKINTBBHUPSFAULT9",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 9 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT9_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT9_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT8
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT8_FIELD =
{
    "MASKINTBBHUPSFAULT8",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 8 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT8_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT8_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD =
{
    "MASKINTBBHUPSFAULT7",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 7 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD =
{
    "MASKINTBBHUPSFAULT6",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 6 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD =
{
    "MASKINTBBHUPSFAULT5",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 5 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD =
{
    "MASKINTBBHUPSFAULT4",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 4 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD =
{
    "MASKINTBBHUPSFAULT3",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 3 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD =
{
    "MASKINTBBHUPSFAULT2",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 2 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD =
{
    "MASKINTBBHUPSFAULT1",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 1 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD =
{
    "MASKINTBBHUPSFAULT0",
#if RU_INCLUDE_DESC
    "",
    "Mask upstream LLID index 0 has lost coherency with the Runner/BBH"
    "interrupt.",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD_MASK,
    0,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD_WIDTH,
    EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD_MASK,
    0,
    EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD_WIDTH,
    EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD =
{
    "TARDYBBHABORT",
#if RU_INCLUDE_DESC
    "",
    "[FATAL] This bit indicates that BBH aborted an upstream packet at a"
    "time it was considered tardy by EPN. It is valid only if bit 31 of"
    "register 0x4b0 (fatalTardyBbhAbortEn) is set."
    "0: BBH has not aborted a tardy upstream packet."
    "1: BBH has aborted a tardy upstream packet. All upstream data"
    "traffic has been disabled. EPN must be reset to recover from this"
    "condition.",
#endif
    EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD_MASK,
    0,
    EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD_WIDTH,
    EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD_MASK,
    0,
    EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD_WIDTH,
    EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT
 ******************************************************************************/
const ru_field_rec EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD =
{
    "MASKTARDYBBHABORT",
#if RU_INCLUDE_DESC
    "",
    "Mask BBH aborted an upstream packet at a time it was considered"
    "tardy by EPN interrupt.",
#endif
    EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD_MASK,
    0,
    EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD_WIDTH,
    EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_BBHUPFRABORTMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD =
{
    "BBHUPFRABORTMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD =
{
    "INTL2SBURSTCAPOVERFLOWMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD =
{
    "INTCOEMPTYRPTMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTDRXERRABORTMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD =
{
    "INTDRXERRABORTMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD =
{
    "INTL2SFIFOOVERRUNMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCO1588TSMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD =
{
    "INTCO1588TSMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCORPTPRESMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD =
{
    "INTCORPTPRESMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCOGNTPRESMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD =
{
    "INTCOGNTPRESMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD =
{
    "INTCODELSTALEGNTMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD =
{
    "INTCOGNTNONPOLLMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD =
{
    "INTCOGNTMISALIGNMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD =
{
    "INTCOGNTTOOFARMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD =
{
    "INTCOGNTINTERVALMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD =
{
    "INTCOGNTDISCOVERYMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD =
{
    "INTCOGNTMISSABORTMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD =
{
    "INTCOGNTFULLABORTMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_BADUPFRLENMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD =
{
    "BADUPFRLENMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_UPTARDYPACKETMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD =
{
    "UPTARDYPACKETMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_UPRPTFRXMTMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD =
{
    "UPRPTFRXMTMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD =
{
    "INTBIFIFOOVERRUNMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD =
{
    "BURSTGNTTOOBIGMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD =
{
    "WRGNTTOOBIGMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD =
{
    "RCVGNTTOOBIGMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD =
{
    "DNSTATSOVERRUNMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD =
{
    "INTUPSTATSOVERRUNMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_DNOUTOFORDERMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD =
{
    "DNOUTOFORDERMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD =
{
    "TRUANTBBHHALTMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD =
{
    "UPINVLDGNTLENMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD =
{
    "INTCOBBHUPSFAULTMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD =
{
    "DNTIMEINSYNCMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD =
{
    "DNTIMENOTINSYNCMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAIN_INT_MASK_DPORTRDYMASK
 ******************************************************************************/
const ru_field_rec EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD =
{
    "DPORTRDYMASK",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD_MASK,
    0,
    EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD_WIDTH,
    EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAX_GNT_SIZE_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_MAX_GNT_SIZE_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAX_GNT_SIZE_RESERVED0_FIELD_MASK,
    0,
    EPN_MAX_GNT_SIZE_RESERVED0_FIELD_WIDTH,
    EPN_MAX_GNT_SIZE_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAX_GNT_SIZE_MAXGNTSIZE
 ******************************************************************************/
const ru_field_rec EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD =
{
    "MAXGNTSIZE",
#if RU_INCLUDE_DESC
    "",
    "Sets the Grant Size threshold for the three Grant Too Big"
    "interrupts. Units are TQ.",
#endif
    EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD_MASK,
    0,
    EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD_WIDTH,
    EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAX_FRAME_SIZE_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_MAX_FRAME_SIZE_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MAX_FRAME_SIZE_RESERVED0_FIELD_MASK,
    0,
    EPN_MAX_FRAME_SIZE_RESERVED0_FIELD_WIDTH,
    EPN_MAX_FRAME_SIZE_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE
 ******************************************************************************/
const ru_field_rec EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD =
{
    "CFGMAXFRAMESIZE",
#if RU_INCLUDE_DESC
    "",
    "Maximum allowable downstream frame size. Frames larger than this"
    "value are discarded.",
#endif
    EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD_MASK,
    0,
    EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD_WIDTH,
    EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GRANT_OVR_HD_GNTOVRHDFEC
 ******************************************************************************/
const ru_field_rec EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD =
{
    "GNTOVRHDFEC",
#if RU_INCLUDE_DESC
    "",
    "1G upstream mode -> Grant length consumed by overhead when FEC is"
    "enabled."
    "10G upstream mode -> Not used.",
#endif
    EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD_MASK,
    0,
    EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD_WIDTH,
    EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GRANT_OVR_HD_GNTOVRHD
 ******************************************************************************/
const ru_field_rec EPN_GRANT_OVR_HD_GNTOVRHD_FIELD =
{
    "GNTOVRHD",
#if RU_INCLUDE_DESC
    "",
    "1G upstream mode -> Grant length consumed by overhead when FEC is"
    "disabled."
    "10G upstream mode -> Grant length consumed by overhead. Used for"
    "both FEC and FEC-less modes.",
#endif
    EPN_GRANT_OVR_HD_GNTOVRHD_FIELD_MASK,
    0,
    EPN_GRANT_OVR_HD_GNTOVRHD_FIELD_WIDTH,
    EPN_GRANT_OVR_HD_GNTOVRHD_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_POLL_SIZE_POLLSIZEFEC
 ******************************************************************************/
const ru_field_rec EPN_POLL_SIZE_POLLSIZEFEC_FIELD =
{
    "POLLSIZEFEC",
#if RU_INCLUDE_DESC
    "",
    "Size of polling grants when FEC is enabled. Units are TQ. Defaults"
    "to 64.",
#endif
    EPN_POLL_SIZE_POLLSIZEFEC_FIELD_MASK,
    0,
    EPN_POLL_SIZE_POLLSIZEFEC_FIELD_WIDTH,
    EPN_POLL_SIZE_POLLSIZEFEC_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_POLL_SIZE_POLLSIZE
 ******************************************************************************/
const ru_field_rec EPN_POLL_SIZE_POLLSIZE_FIELD =
{
    "POLLSIZE",
#if RU_INCLUDE_DESC
    "",
    "Size of polling grants when FEC is disabled. Units are TQ. Defaults"
    "to 64.",
#endif
    EPN_POLL_SIZE_POLLSIZE_FIELD_MASK,
    0,
    EPN_POLL_SIZE_POLLSIZE_FIELD_WIDTH,
    EPN_POLL_SIZE_POLLSIZE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_RD_GNT_MARGIN_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD_MASK,
    0,
    EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD_WIDTH,
    EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN
 ******************************************************************************/
const ru_field_rec EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD =
{
    "RDGNTSTARTMARGIN",
#if RU_INCLUDE_DESC
    "",
    "How far in advance of Grant Start Time to consider a grant for"
    "removal from the grant FIFO.",
#endif
    EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD_MASK,
    0,
    EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD_WIDTH,
    EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_TIME_START_DELTA_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD_MASK,
    0,
    EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD_WIDTH,
    EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA
 ******************************************************************************/
const ru_field_rec EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD =
{
    "GNTSTARTTIMEDELTA",
#if RU_INCLUDE_DESC
    "",
    "This value determines how far in advance of the Grant Start Time"
    "that the next selected grant (already extracted from the Grant FIFO)"
    "will be handed to the EPN UTX (upstream transmit) logic and start to"
    "pre-fetch frames.."
    "The units of this register are TQ. The reset default value is 640"
    "decimal.",
#endif
    EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD_MASK,
    0,
    EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD_WIDTH,
    EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TIME_STAMP_DIFF_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TIME_STAMP_DIFF_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TIME_STAMP_DIFF_RESERVED0_FIELD_MASK,
    0,
    EPN_TIME_STAMP_DIFF_RESERVED0_FIELD_WIDTH,
    EPN_TIME_STAMP_DIFF_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA
 ******************************************************************************/
const ru_field_rec EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD =
{
    "TIMESTAMPDIFFDELTA",
#if RU_INCLUDE_DESC
    "",
    "Threshold for local time reference updates and related interrupts."
    "Reset default is10 decimal.",
#endif
    EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD_MASK,
    0,
    EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD_WIDTH,
    EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC
 ******************************************************************************/
const ru_field_rec EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD =
{
    "TIMESTAMPOFFSETFEC",
#if RU_INCLUDE_DESC
    "",
    "Offset from Grant Start Time to use as the Timestamp field in"
    "REPORTs and processor-sent packets when FEC is enabled."
    "Only used for 1G modes."
    "Units are TQ.",
#endif
    EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD_MASK,
    0,
    EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD_WIDTH,
    EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET
 ******************************************************************************/
const ru_field_rec EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD =
{
    "TIMESTAMPOFFSET",
#if RU_INCLUDE_DESC
    "",
    "Offset from Grant Start Time to use as the Timestamp field in"
    "REPORTs and processor-sent packets when FEC is disabled."
    "Used for both 1G no FEC and all 10G modes."
    "Units are TQ.",
#endif
    EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD_MASK,
    0,
    EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD_WIDTH,
    EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTERVAL_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTERVAL_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_GNT_INTERVAL_RESERVED0_FIELD_MASK,
    0,
    EPN_GNT_INTERVAL_RESERVED0_FIELD_WIDTH,
    EPN_GNT_INTERVAL_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GNT_INTERVAL_GNTINTERVAL
 ******************************************************************************/
const ru_field_rec EPN_GNT_INTERVAL_GNTINTERVAL_FIELD =
{
    "GNTINTERVAL",
#if RU_INCLUDE_DESC
    "",
    "Grant interval",
#endif
    EPN_GNT_INTERVAL_GNTINTERVAL_FIELD_MASK,
    0,
    EPN_GNT_INTERVAL_GNTINTERVAL_FIELD_WIDTH,
    EPN_GNT_INTERVAL_GNTINTERVAL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD
 ******************************************************************************/
const ru_field_rec EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD =
{
    "PRVUNUSEDGNTTHRESHOLD",
#if RU_INCLUDE_DESC
    "",
    "Sets the minimum number of unused time quanta in a grant required in"
    "order for it to be considered misaligned.",
#endif
    EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD_MASK,
    0,
    EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD_WIDTH,
    EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_GNT_MISALIGN_THR_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD_MASK,
    0,
    EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD_WIDTH,
    EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH
 ******************************************************************************/
const ru_field_rec EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD =
{
    "GNTMISALIGNTHRESH",
#if RU_INCLUDE_DESC
    "",
    "Sets the number of misaligned grants needed to trigger misalignment"
    "handling. The value set here is one fewer than the desired number of"
    "consecutive misaligned grants, i.e. setting a value of 2 means that"
    "three misaligned grants in a row will trigger misalignment handling.",
#endif
    EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD_MASK,
    0,
    EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD_WIDTH,
    EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD_MASK,
    0,
    EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD_WIDTH,
    EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE
 ******************************************************************************/
const ru_field_rec EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD =
{
    "GNTMISALIGNPAUSE",
#if RU_INCLUDE_DESC
    "",
    "How long to stall reporting of queue status.",
#endif
    EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD_MASK,
    0,
    EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD_WIDTH,
    EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NON_POLL_INTV_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_NON_POLL_INTV_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_NON_POLL_INTV_RESERVED0_FIELD_MASK,
    0,
    EPN_NON_POLL_INTV_RESERVED0_FIELD_WIDTH,
    EPN_NON_POLL_INTV_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_NON_POLL_INTV_NONPOLLGNTINTV
 ******************************************************************************/
const ru_field_rec EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD =
{
    "NONPOLLGNTINTV",
#if RU_INCLUDE_DESC
    "",
    "If amount of time since last non poll grant exceed this value, the"
    "respective LLID's interrupt will assert. Units of 65 us.",
#endif
    EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD_MASK,
    0,
    EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD_WIDTH,
    EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR31
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR31_FIELD =
{
    "FORCEFCSERR31",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 31",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR31_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR31_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR30
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR30_FIELD =
{
    "FORCEFCSERR30",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 30",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR30_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR30_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR29
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR29_FIELD =
{
    "FORCEFCSERR29",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 29",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR29_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR29_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR28
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR28_FIELD =
{
    "FORCEFCSERR28",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 28",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR28_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR28_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR27
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR27_FIELD =
{
    "FORCEFCSERR27",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 27",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR27_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR27_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR26
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR26_FIELD =
{
    "FORCEFCSERR26",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 26",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR26_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR26_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR25
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR25_FIELD =
{
    "FORCEFCSERR25",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 25",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR25_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR25_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR24
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR24_FIELD =
{
    "FORCEFCSERR24",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 24",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR24_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR24_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR23
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR23_FIELD =
{
    "FORCEFCSERR23",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 23",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR23_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR23_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR22
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR22_FIELD =
{
    "FORCEFCSERR22",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 22",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR22_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR22_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR21
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR21_FIELD =
{
    "FORCEFCSERR21",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 21",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR21_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR21_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR20
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR20_FIELD =
{
    "FORCEFCSERR20",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 20",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR20_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR20_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR19
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR19_FIELD =
{
    "FORCEFCSERR19",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 19",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR19_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR19_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR18
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR18_FIELD =
{
    "FORCEFCSERR18",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 18",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR18_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR18_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR17
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR17_FIELD =
{
    "FORCEFCSERR17",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 17",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR17_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR17_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR16
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR16_FIELD =
{
    "FORCEFCSERR16",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 16",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR16_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR16_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR15
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR15_FIELD =
{
    "FORCEFCSERR15",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 15",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR15_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR15_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR14
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR14_FIELD =
{
    "FORCEFCSERR14",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 14",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR14_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR14_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR13
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR13_FIELD =
{
    "FORCEFCSERR13",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 13",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR13_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR13_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR12
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR12_FIELD =
{
    "FORCEFCSERR12",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 12",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR12_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR12_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR11
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR11_FIELD =
{
    "FORCEFCSERR11",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 11",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR11_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR11_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR10
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR10_FIELD =
{
    "FORCEFCSERR10",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 10",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR10_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR10_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR9
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR9_FIELD =
{
    "FORCEFCSERR9",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 9",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR9_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR9_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR8
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR8_FIELD =
{
    "FORCEFCSERR8",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 8",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR8_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR8_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR7
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD =
{
    "FORCEFCSERR7",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 7",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR6
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD =
{
    "FORCEFCSERR6",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 6",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR5
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD =
{
    "FORCEFCSERR5",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 5",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR4
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD =
{
    "FORCEFCSERR4",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 4",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR3
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD =
{
    "FORCEFCSERR3",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 3",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR2
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD =
{
    "FORCEFCSERR2",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 2",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR1
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD =
{
    "FORCEFCSERR1",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 1",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCE_FCS_ERR_FORCEFCSERR0
 ******************************************************************************/
const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD =
{
    "FORCEFCSERR0",
#if RU_INCLUDE_DESC
    "",
    "Force bad FCS for frames transmitting out of LLID 0",
#endif
    EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD_MASK,
    0,
    EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD_WIDTH,
    EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GRANT_OVERLAP_LIMIT_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD_MASK,
    0,
    EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD_WIDTH,
    EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT
 ******************************************************************************/
const ru_field_rec EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD =
{
    "PRVGRANTOVERLAPLIMIT",
#if RU_INCLUDE_DESC
    "",
    "Number of time quanta by which two consecutive grants are allowed to"
    "overlap",
#endif
    EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD_MASK,
    0,
    EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD_WIDTH,
    EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0
 ******************************************************************************/
const ru_field_rec EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD =
{
    "PRVUPSTREAMAESMODE_0",
#if RU_INCLUDE_DESC
    "",
    "LLID index 0 AES overhead mode."
    "0: Implicit SCI AES overhead mode."
    "1: Explicit SCI AES overhead mode."
    "."
    "."
    "LLID index 15 AES overhead mode."
    "30: Implicit SCI AES overhead mode."
    "31: Explicit SCI AES overhead mode.",
#endif
    EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD_MASK,
    0,
    EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD_WIDTH,
    EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_GRANT_OVR_HD_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD_MASK,
    0,
    EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD_WIDTH,
    EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD
 ******************************************************************************/
const ru_field_rec EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD =
{
    "DISCGNTOVRHD",
#if RU_INCLUDE_DESC
    "",
    "This defines the amount of overhead used for Discovery gates. Units"
    "are 16-bit words.",
#endif
    EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD_MASK,
    0,
    EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD_WIDTH,
    EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_DISCOVERY_SEED_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD_MASK,
    0,
    EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD_WIDTH,
    EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_DISCOVERY_SEED_CFGDISCSEED
 ******************************************************************************/
const ru_field_rec EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD =
{
    "CFGDISCSEED",
#if RU_INCLUDE_DESC
    "",
    "Specifies basis for generating the discovery offset. Units are TQ.",
#endif
    EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD_MASK,
    0,
    EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD_WIDTH,
    EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_DISCOVERY_INC_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DN_DISCOVERY_INC_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DN_DISCOVERY_INC_RESERVED0_FIELD_MASK,
    0,
    EPN_DN_DISCOVERY_INC_RESERVED0_FIELD_WIDTH,
    EPN_DN_DISCOVERY_INC_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_DISCOVERY_INC_CFGDISCINC
 ******************************************************************************/
const ru_field_rec EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD =
{
    "CFGDISCINC",
#if RU_INCLUDE_DESC
    "",
    "Units are TQ",
#endif
    EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD_MASK,
    0,
    EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD_WIDTH,
    EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_DISCOVERY_SIZE_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD_MASK,
    0,
    EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD_WIDTH,
    EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE
 ******************************************************************************/
const ru_field_rec EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD =
{
    "CFGDISCSIZE",
#if RU_INCLUDE_DESC
    "",
    "Size of response to discovery gate. Units are TQ.",
#endif
    EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD_MASK,
    0,
    EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD_WIDTH,
    EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FEC_IPG_LENGTH_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_FEC_IPG_LENGTH_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_FEC_IPG_LENGTH_RESERVED0_FIELD_MASK,
    0,
    EPN_FEC_IPG_LENGTH_RESERVED0_FIELD_WIDTH,
    EPN_FEC_IPG_LENGTH_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES
 ******************************************************************************/
const ru_field_rec EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD =
{
    "MODIPGPREAMBLEBYTES",
#if RU_INCLUDE_DESC
    "",
    "10G and 1G upstream: The number of the bytes in the sum of IPG +"
    "PREAMBLE.  This value must be programmed before the upstream is"
    "enabled.  It must not be modified while the upstream is active."
    "Default is 20. Units are bytes.",
#endif
    EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD_MASK,
    0,
    EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD_WIDTH,
    EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FEC_IPG_LENGTH_CFGRPTLEN
 ******************************************************************************/
const ru_field_rec EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD =
{
    "CFGRPTLEN",
#if RU_INCLUDE_DESC
    "",
    "1G upstream non-FEC: The length of the REPORT Frame + IPG +"
    "PREAMBLE. Used for non-FEC LLIDs. Use default value of 42."
    "10G upstream FEC : The length of the Report Frame + IPG + PREAMBLE +"
    "FEC. Set to 13."
    "10G upstream non-FEC : The length of the Report Frame + IPG +"
    "PREAMBLE. Set to 5."
    "Defaults to 42 for 1G non-FEC. Units are TQ.",
#endif
    EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD_MASK,
    0,
    EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD_WIDTH,
    EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH
 ******************************************************************************/
const ru_field_rec EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD =
{
    "CFGFECRPTLENGTH",
#if RU_INCLUDE_DESC
    "",
    "The length of the REPORT Frame + IPG + PREAMBLE + FEC. Used only for"
    "1G FEC upstream operation."
    "Default is 58 for 1G upstream FEC. Units are TQ.",
#endif
    EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD_MASK,
    0,
    EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD_WIDTH,
    EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH
 ******************************************************************************/
const ru_field_rec EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD =
{
    "CFGFECIPGLENGTH",
#if RU_INCLUDE_DESC
    "",
    "Length of IPG to be used in 1G upstream FEC computations. There are"
    "8-bytes of overhead built into the Epn's 1G upstream FEC"
    "calculations."
    "This means that if this register is set to zero then the Epn will"
    "add 8-bytes of overhead to each packet transmitted upstream."
    "The size of the 1G upstream FEC IPG+preamble used by the Epn is"
    "(cfgFecIpgLength + 8)."
    "The smallest supported FEC IPG+preamble value is 8. To use the"
    "LIF's short preamble (7-byte minimum) capability; set the LIF's IPG"
    "value to 1 and set the Epn's cfgFecIpgLength to 0."
    "Default 10. Units are bytes.",
#endif
    EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD_MASK,
    0,
    EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD_WIDTH,
    EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN
 ******************************************************************************/
const ru_field_rec EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD =
{
    "FAKEREPORTVALUEEN",
#if RU_INCLUDE_DESC
    "",
    "Per-LLID Index bits for enabling fake reporting. Setting a bit will"
    "cause that Index to send fake reports (when requested by a Force"
    "Report grant) with the value specified in EPN Fake Report Value.",
#endif
    EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD_MASK,
    0,
    EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD_WIDTH,
    EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FAKE_REPORT_VALUE_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD_MASK,
    0,
    EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD_WIDTH,
    EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE
 ******************************************************************************/
const ru_field_rec EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD =
{
    "FAKEREPORTVALUE",
#if RU_INCLUDE_DESC
    "",
    "The value to be used when sending fake reports. This value is in"
    "units of bytes. (This value is converted to TQ as necessary for the"
    "configured upstream data rate.)",
#endif
    EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD_MASK,
    0,
    EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD_WIDTH,
    EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_VALID_OPCODE_MAP_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_VALID_OPCODE_MAP_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_VALID_OPCODE_MAP_RESERVED0_FIELD_MASK,
    0,
    EPN_VALID_OPCODE_MAP_RESERVED0_FIELD_WIDTH,
    EPN_VALID_OPCODE_MAP_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES
 ******************************************************************************/
const ru_field_rec EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD =
{
    "PRVVALIDMPCPOPCODES",
#if RU_INCLUDE_DESC
    "",
    "The 14 MPCP opcode values in the range of 2-15 can be enabled by"
    "setting the corresponding bit."
    "Note: Opcode values 0 and 1 must always be disabled!",
#endif
    EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD_MASK,
    0,
    EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD_WIDTH,
    EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UP_PACKET_TX_MARGIN_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD_MASK,
    0,
    EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD_WIDTH,
    EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN
 ******************************************************************************/
const ru_field_rec EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD =
{
    "UPPACKETTXMARGIN",
#if RU_INCLUDE_DESC
    "",
    "Minimum upstream data setup time for LIF/XIF.  Units are TQ.",
#endif
    EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD_MASK,
    0,
    EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD_WIDTH,
    EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD =
{
    "CFGCTCSCHDEFICITEN",
#if RU_INCLUDE_DESC
    "",
    "Enables deficit accounting in the CTC scheduler. Applies only when"
    "the CTC scheduler is configured for weighted round-robin operation.",
#endif
    EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD =
{
    "PRVZEROBURSTCAPOVERRIDEMODE",
#if RU_INCLUDE_DESC
    "",
    "Determines an internal burst cap value for any priority/L2 which has"
    "its burst cap set to zero. The internal burst cap value is used by"
    "the L1-to-L2 packet transfer logic."
    "0: Use an internal burst cap value of zero. (Do not use.)"
    "1: Use an internal burst cap value of 2 KB. Reset default."
    "2: Use a \"max value\" internal burst cap: 128KB for 1G upstream."
    "3. Reserved (do not use)",
#endif
    EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_RESERVED2
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD =
{
    "RESERVED2",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_CFGSHAREDL2
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD =
{
    "CFGSHAREDL2",
#if RU_INCLUDE_DESC
    "",
    "For the burst-cap limited queue set, configures whether each queue"
    "report/priority uses a separate L2 queue, or a shared one. Setting"
    "this bit, along with cfgSharedBurstCap, configures EPN into a"
    "TK3715-compatible reporting mode."
    "Note: Using a shared L2 queue effectively disables the CTC output"
    "scheduler, since packets from all priorities are merged into a"
    "single pipe and scheduled (in strict priority) upon entry to the L2"
    "queue."
    "0: Each priority level uses its own dedicated L2 queue."
    "1: All priority levels use a single, shared L2 queue",
#endif
    EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD =
{
    "CFGSHAREDBURSTCAP",
#if RU_INCLUDE_DESC
    "",
    "For the burst-cap limited queue set, configures whether each queue"
    "report/priority is individually limited to the Burst Cap, or whether"
    "the sum of all queue report values is limited to the Burst Cap."
    "0: Limit each queue report value to a Burst Cap. Each queue"
    "report/priority uses the Burst Cap corresponding to its L2 FIFO."
    "This bit has effect only when cfgRptMultiPri is 1."
    "Note: Setting this bit, along with cfgSharedL2, configures EPN into"
    "a TK3715-compatible reporting mode."
    "1: Limit the sum of the queue reports/priorities to the Burst Cap"
    "value. (Use the Burst Cap value corresponding to the lowest L2 FIFO"
    "assigned to the LLID index)."
    "Note: The following offsets must be included in the burst cap value"
    "calculation when \"shared burst cap mode\" is enabled.  Decrease the"
    "desired burst cap value by 21 bytes in 1G non-FEC mode, 193 bytes in"
    "1G FEC mode.",
#endif
    EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD =
{
    "CFGRPTGNTSOUTST0",
#if RU_INCLUDE_DESC
    "",
    "Configures whether Multi-Priority REPORT frames include"
    "already-granted frames."
    "0: Report frames do NOT include frames that have already been"
    "granted. This is the setting for NTT operation."
    "1: Report frames DO include frames that have already been granted"
    "(but not yet sent upstream)."
    "This bit has effect only when cfgRptMultiPri is 1.",
#endif
    EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD =
{
    "CFGRPTHIPRIFIRST0",
#if RU_INCLUDE_DESC
    "",
    "Determines the order within a queue set in which priorities are"
    "reported on."
    "0: Priorities are reported low to high."
    "1: Priorities are reported high to low."
    "This bit has effect only when cfgRptMultiPri0 is 1.",
#endif
    EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD =
{
    "CFGRPTSWAPQS0",
#if RU_INCLUDE_DESC
    "",
    "Configure order of queue sets."
    "0: The first queue set reports the full packet buffer queue depths;"
    "the second queue set reports up to the T/Burst Cap 0 threshold."
    "1: Swap queue sets in Multi-Priority REPORT frames. The first Queue"
    "set reports up to the T/Burst Cap 0 threshold; the second queue set"
    "reports the the full packet buffer queue depths."
    "This bit has effect only when cfgRptMultiPri0 is 1.",
#endif
    EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_RESERVED3
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD =
{
    "RESERVED3",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0
 ******************************************************************************/
const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD =
{
    "CFGRPTMULTIPRI0",
#if RU_INCLUDE_DESC
    "",
    "Configure Multi-Priority mode."
    "0: Disable Multi-Priority mode. The reporting style is selected by"
    "Report Select bit (bit 8 in the EPON Control 0 register)."
    "1: Configured for Multi-Priority reporting mode.",
#endif
    EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD_MASK,
    0,
    EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD_WIDTH,
    EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_SHARED_BCAP_OVRFLOW_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD_MASK,
    0,
    EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD_WIDTH,
    EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW
 ******************************************************************************/
const ru_field_rec EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD =
{
    "SHAREDBURSTCAPOVERFLOW",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD_MASK,
    0,
    EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD_WIDTH,
    EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN
 ******************************************************************************/
const ru_field_rec EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD =
{
    "CFGFORCEREPORTEN",
#if RU_INCLUDE_DESC
    "",
    "Per-LLID Index bits for enabling forced reporting. Setting a bit"
    "will cause that Index to send a report as part of the first upstream"
    "burst that occurs more than the number of mS provisioned in"
    "cfgMaxReportInterval\" after the last report was sent.",
#endif
    EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD_MASK,
    0,
    EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD_WIDTH,
    EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD_MASK,
    0,
    EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD_WIDTH,
    EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL
 ******************************************************************************/
const ru_field_rec EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD =
{
    "CFGMAXREPORTINTERVAL",
#if RU_INCLUDE_DESC
    "",
    "The number of mS after the last report was sent to force the report.",
#endif
    EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD_MASK,
    0,
    EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD_WIDTH,
    EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN
 ******************************************************************************/
const ru_field_rec EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD =
{
    "CFGFLUSHL2SEN",
#if RU_INCLUDE_DESC
    "",
    "Enables the selected L2 queue to be flushed.  This configuration bit"
    "must be forced low and \"flushL2sDone\" must be read back as low;"
    "before, \"cfgFlushL2sSel\" is written."
    "0: L2 queue flush is disabled"
    "1: L2 queue flush is enabled",
#endif
    EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD_MASK,
    0,
    EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD_WIDTH,
    EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE
 ******************************************************************************/
const ru_field_rec EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD =
{
    "FLUSHL2SDONE",
#if RU_INCLUDE_DESC
    "",
    "This bit is set when the selected L2 queue has no more packets to"
    "flush. This bit will always be zero when the enable bit is zero.",
#endif
    EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD_MASK,
    0,
    EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD_WIDTH,
    EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_L2S_FLUSH_CONFIG_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD_MASK,
    0,
    EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD_WIDTH,
    EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL
 ******************************************************************************/
const ru_field_rec EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD =
{
    "CFGFLUSHL2SSEL",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 queue that will be flushed when the enable is set."
    "Do not write this register unless both \"flushL2sDone\" and"
    "cfgFlushL2sEn\" are low.",
#endif
    EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD_MASK,
    0,
    EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD_WIDTH,
    EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DATA_PORT_COMMAND_DPORTBUSY
 ******************************************************************************/
const ru_field_rec EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD =
{
    "DPORTBUSY",
#if RU_INCLUDE_DESC
    "",
    "Indicates access to RAM is in progress."
    "0: Data port is ready to accept a command"
    "1: Data port is busy",
#endif
    EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD_MASK,
    0,
    EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD_WIDTH,
    EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DATA_PORT_COMMAND_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DATA_PORT_COMMAND_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DATA_PORT_COMMAND_RESERVED0_FIELD_MASK,
    0,
    EPN_DATA_PORT_COMMAND_RESERVED0_FIELD_WIDTH,
    EPN_DATA_PORT_COMMAND_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DATA_PORT_COMMAND_DPORTSELECT
 ******************************************************************************/
const ru_field_rec EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD =
{
    "DPORTSELECT",
#if RU_INCLUDE_DESC
    "",
    "Selects RAM to be access"
    "0:   Downstream statistics RAM"
    "1:   Upstream statistics RAM"
    "2:   Reserved"
    "3:   L2 Queue RAM"
    "4-31: Reserved",
#endif
    EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD_MASK,
    0,
    EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD_WIDTH,
    EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DATA_PORT_COMMAND_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_DATA_PORT_COMMAND_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DATA_PORT_COMMAND_RESERVED1_FIELD_MASK,
    0,
    EPN_DATA_PORT_COMMAND_RESERVED1_FIELD_WIDTH,
    EPN_DATA_PORT_COMMAND_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DATA_PORT_COMMAND_DPORTCONTROL
 ******************************************************************************/
const ru_field_rec EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD =
{
    "DPORTCONTROL",
#if RU_INCLUDE_DESC
    "",
    "Indicates data port operation"
    "0: Do a RAM read operation"
    "1: Do a RAM write operation",
#endif
    EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD_MASK,
    0,
    EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD_WIDTH,
    EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DATA_PORT_ADDRESS_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD_MASK,
    0,
    EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD_WIDTH,
    EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DATA_PORT_ADDRESS_DPORTADDR
 ******************************************************************************/
const ru_field_rec EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD =
{
    "DPORTADDR",
#if RU_INCLUDE_DESC
    "",
    "Address for RAM accesses.",
#endif
    EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD_MASK,
    0,
    EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD_WIDTH,
    EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DATA_PORT_DATA_0_DPORTDATA0
 ******************************************************************************/
const ru_field_rec EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD =
{
    "DPORTDATA0",
#if RU_INCLUDE_DESC
    "",
    "Low-order data dword for data port accesses",
#endif
    EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD_MASK,
    0,
    EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD_WIDTH,
    EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT
 ******************************************************************************/
const ru_field_rec EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD =
{
    "UNMAPBIGERRCNT",
#if RU_INCLUDE_DESC
    "",
    "Counts illegally large frames.",
#endif
    EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD_MASK,
    0,
    EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD_WIDTH,
    EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNMAP_FRAME_CNT_UNMAPFRCNT
 ******************************************************************************/
const ru_field_rec EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD =
{
    "UNMAPFRCNT",
#if RU_INCLUDE_DESC
    "",
    "Counts valid frames that are not Gates or OAM frames.",
#endif
    EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD_MASK,
    0,
    EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD_WIDTH,
    EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT
 ******************************************************************************/
const ru_field_rec EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD =
{
    "UNMAPFCSERRCNT",
#if RU_INCLUDE_DESC
    "",
    "Counts frame with FCS errors.",
#endif
    EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD_MASK,
    0,
    EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD_WIDTH,
    EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNMAP_GATE_CNT_UNMAPGATECNT
 ******************************************************************************/
const ru_field_rec EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD =
{
    "UNMAPGATECNT",
#if RU_INCLUDE_DESC
    "",
    "Counts un-mapped gate frames.",
#endif
    EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD_MASK,
    0,
    EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD_WIDTH,
    EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNMAP_OAM_CNT_UNMAPOAMCNT
 ******************************************************************************/
const ru_field_rec EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD =
{
    "UNMAPOAMCNT",
#if RU_INCLUDE_DESC
    "",
    "Counts un-mapped OAM frames.",
#endif
    EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD_MASK,
    0,
    EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD_WIDTH,
    EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT
 ******************************************************************************/
const ru_field_rec EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD =
{
    "UNMAPSMALLERRCNT",
#if RU_INCLUDE_DESC
    "",
    "Counts illegally small frames.",
#endif
    EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD_MASK,
    0,
    EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD_WIDTH,
    EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT
 ******************************************************************************/
const ru_field_rec EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD =
{
    "FIFDEQUEUEEVENTCNT",
#if RU_INCLUDE_DESC
    "",
    "Debug only!",
#endif
    EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD_MASK,
    0,
    EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD_WIDTH,
    EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN
 ******************************************************************************/
const ru_field_rec EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD =
{
    "BBHUPSFAULTHALTEN",
#if RU_INCLUDE_DESC
    "",
    "Per-LLID Index Runner/BBH upstream fault halt enable."
    "0: Do not disable upstream data traffic."
    "1: Disable upstream data traffic for LLID indexes the Runner/BBH"
    "faulted on.",
#endif
    EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD_MASK,
    0,
    EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD_WIDTH,
    EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UP_TARDY_HALT_EN_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD_MASK,
    0,
    EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD_WIDTH,
    EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN
 ******************************************************************************/
const ru_field_rec EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD =
{
    "FATALTARDYBBHABORTEN",
#if RU_INCLUDE_DESC
    "",
    "Disable all upstream data traffic when the BHH aborts a tardy"
    "packet."
    "0: Do not disable upstream data traffic on tardy/abort"
    "1: Disable all upstream data traffic when the BBH aborts a tardy"
    "packet.",
#endif
    EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD_MASK,
    0,
    EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD_WIDTH,
    EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_0_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_0_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DEBUG_STATUS_0_RESERVED0_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_0_RESERVED0_FIELD_WIDTH,
    EPN_DEBUG_STATUS_0_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD =
{
    "L2SQUEFULLDEBUG",
#if RU_INCLUDE_DESC
    "",
    "Indicates which LLID's report FIFO is full",
#endif
    EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD_WIDTH,
    EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_0_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_0_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DEBUG_STATUS_0_RESERVED1_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_0_RESERVED1_FIELD_WIDTH,
    EPN_DEBUG_STATUS_0_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_0_DNDLUFULL
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD =
{
    "DNDLUFULL",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD_WIDTH,
    EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_0_DNSECFULL
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_0_DNSECFULL_FIELD =
{
    "DNSECFULL",
#if RU_INCLUDE_DESC
    "",
    "SEC and EPN downstream",
#endif
    EPN_DEBUG_STATUS_0_DNSECFULL_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_0_DNSECFULL_FIELD_WIDTH,
    EPN_DEBUG_STATUS_0_DNSECFULL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD =
{
    "EPNLIFFIFOFULL",
#if RU_INCLUDE_DESC
    "",
    "SEC and EPN upstream  interface FIFO is full",
#endif
    EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD_WIDTH,
    EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY31
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY31_FIELD =
{
    "GNTRDY31",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 31 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY31_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY31_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY30
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY30_FIELD =
{
    "GNTRDY30",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 30 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY30_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY30_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY29
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY29_FIELD =
{
    "GNTRDY29",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 29 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY29_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY29_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY28
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY28_FIELD =
{
    "GNTRDY28",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 28 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY28_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY28_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY27
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY27_FIELD =
{
    "GNTRDY27",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 27 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY27_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY27_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY26
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY26_FIELD =
{
    "GNTRDY26",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 26 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY26_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY26_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY25
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY25_FIELD =
{
    "GNTRDY25",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 25 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY25_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY25_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY24
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY24_FIELD =
{
    "GNTRDY24",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 24 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY24_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY24_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY23
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY23_FIELD =
{
    "GNTRDY23",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 23 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY23_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY23_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY22
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY22_FIELD =
{
    "GNTRDY22",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 22 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY22_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY22_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY21
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY21_FIELD =
{
    "GNTRDY21",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 21 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY21_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY21_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY20
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY20_FIELD =
{
    "GNTRDY20",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 20 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY20_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY20_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY19
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY19_FIELD =
{
    "GNTRDY19",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 19 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY19_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY19_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY18
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY18_FIELD =
{
    "GNTRDY18",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 18 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY18_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY18_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY17
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY17_FIELD =
{
    "GNTRDY17",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 17 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY17_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY17_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY16
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY16_FIELD =
{
    "GNTRDY16",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 16 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY16_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY16_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY15
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY15_FIELD =
{
    "GNTRDY15",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 15 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY15_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY15_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY14
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY14_FIELD =
{
    "GNTRDY14",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 14 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY14_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY14_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY13
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY13_FIELD =
{
    "GNTRDY13",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 13 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY13_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY13_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY12
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY12_FIELD =
{
    "GNTRDY12",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 12 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY12_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY12_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY11
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY11_FIELD =
{
    "GNTRDY11",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 11 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY11_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY11_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY10
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY10_FIELD =
{
    "GNTRDY10",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 10 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY10_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY10_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY9
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY9_FIELD =
{
    "GNTRDY9",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 9 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY9_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY9_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY8
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY8_FIELD =
{
    "GNTRDY8",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 8 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY8_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY8_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY7
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY7_FIELD =
{
    "GNTRDY7",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 7 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY7_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY7_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY6
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY6_FIELD =
{
    "GNTRDY6",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 6 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY6_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY6_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY5
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY5_FIELD =
{
    "GNTRDY5",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 5 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY5_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY5_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY4
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY4_FIELD =
{
    "GNTRDY4",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 4 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY4_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY4_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY3
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY3_FIELD =
{
    "GNTRDY3",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 3 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY3_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY3_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY2
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY2_FIELD =
{
    "GNTRDY2",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 2 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY2_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY2_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY1
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY1_FIELD =
{
    "GNTRDY1",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 1 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY1_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY1_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_STATUS_1_GNTRDY0
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY0_FIELD =
{
    "GNTRDY0",
#if RU_INCLUDE_DESC
    "",
    "LLID Index 0 has grant(s) pending",
#endif
    EPN_DEBUG_STATUS_1_GNTRDY0_FIELD_MASK,
    0,
    EPN_DEBUG_STATUS_1_GNTRDY0_FIELD_WIDTH,
    EPN_DEBUG_STATUS_1_GNTRDY0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_L2S_PTR_SEL_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD_MASK,
    0,
    EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD_WIDTH,
    EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD =
{
    "CFGL2SDEBUGPTRSEL",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD_MASK,
    0,
    EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD_WIDTH,
    EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_L2S_PTR_SEL_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD_MASK,
    0,
    EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD_WIDTH,
    EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE
 ******************************************************************************/
const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD =
{
    "L2SDEBUGPTRSTATE",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD_MASK,
    0,
    EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD_WIDTH,
    EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_OLT_MAC_ADDR_LO_OLTADDRLO
 ******************************************************************************/
const ru_field_rec EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD =
{
    "OLTADDRLO",
#if RU_INCLUDE_DESC
    "",
    "OLT MAC Address",
#endif
    EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD_MASK,
    0,
    EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD_WIDTH,
    EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_OLT_MAC_ADDR_HI_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD_MASK,
    0,
    EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD_WIDTH,
    EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_OLT_MAC_ADDR_HI_OLTADDRHI
 ******************************************************************************/
const ru_field_rec EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD =
{
    "OLTADDRHI",
#if RU_INCLUDE_DESC
    "",
    "OLT MAC Address",
#endif
    EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD_MASK,
    0,
    EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD_WIDTH,
    EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD =
{
    "L1SDQUQUEEMPTY",
#if RU_INCLUDE_DESC
    "",
    "Each bit in this register contains the status of the respective"
    "queue"
    "0: L1 accumulator is not empty"
    "1: L1 accumulator is empty",
#endif
    EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD_WIDTH,
    EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD =
{
    "L1SUNSHAPEDQUEEMPTY",
#if RU_INCLUDE_DESC
    "",
    "Each bit in this register contains the status of the respective"
    "accumulators"
    "0: L1 unshaped accumulator is not empty"
    "1: L1 unshaped accumulator is empty",
#endif
    EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD_MASK,
    0,
    EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD_WIDTH,
    EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD =
{
    "L2SQUEEMPTY",
#if RU_INCLUDE_DESC
    "",
    "Each bit in this register contains the status of the respective"
    "queue"
    "0: L2 queue is not empty"
    "1: L2 queue is empty",
#endif
    EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD_WIDTH,
    EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_FULL_L2SQUEFULL
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD =
{
    "L2SQUEFULL",
#if RU_INCLUDE_DESC
    "",
    "Each bit in this register contains the status of the respective"
    "queue"
    "0: L2 queue is not full"
    "1: L2 queue is full",
#endif
    EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD_WIDTH,
    EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD =
{
    "L2SSTOPPEDQUEUES",
#if RU_INCLUDE_DESC
    "",
    "Each bit in this register contains the status of the respective"
    "queue"
    "0: L2 queue is not stopped"
    "1: L2 queue is stopped",
#endif
    EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD_WIDTH,
    EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD_MASK,
    0,
    EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD_WIDTH,
    EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS
 ******************************************************************************/
const ru_field_rec EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD =
{
    "CFGMAXOUTSTANDINGTARDYPACKETS",
#if RU_INCLUDE_DESC
    "",
    "Maximum number of packets outstanding tardy packet the BBH can"
    "accumulate at one time.",
#endif
    EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD_MASK,
    0,
    EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD_WIDTH,
    EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD_MASK,
    0,
    EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD_WIDTH,
    EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF
 ******************************************************************************/
const ru_field_rec EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD =
{
    "PRVMINREPORTDIFF",
#if RU_INCLUDE_DESC
    "",
    "The smallest allowable difference between ajacent non-zero queue"
    "sets.",
#endif
    EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD_MASK,
    0,
    EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD_WIDTH,
    EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW
 ******************************************************************************/
const ru_field_rec EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD =
{
    "UTXBBHSTATUSFIFOOVERFLOW",
#if RU_INCLUDE_DESC
    "",
    "Indicates which BBH queue status interface event FIFOs have"
    "overflowed. The overflow can only be corrected by reset.",
#endif
    EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD_MASK,
    0,
    EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD_WIDTH,
    EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_SPARE_CTL_CFGEPNSPARE
 ******************************************************************************/
const ru_field_rec EPN_SPARE_CTL_CFGEPNSPARE_FIELD =
{
    "CFGEPNSPARE",
#if RU_INCLUDE_DESC
    "",
    "Spare RW bits",
#endif
    EPN_SPARE_CTL_CFGEPNSPARE_FIELD_MASK,
    0,
    EPN_SPARE_CTL_CFGEPNSPARE_FIELD_WIDTH,
    EPN_SPARE_CTL_CFGEPNSPARE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_SPARE_CTL_ECOUTXSNFENABLE
 ******************************************************************************/
const ru_field_rec EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD =
{
    "ECOUTXSNFENABLE",
#if RU_INCLUDE_DESC
    "",
    "Set this bit to enable store and forward upstream AE operation."
    "Only set this bit when operating in Point-to-Point or Active"
    "Ethernet modes.",
#endif
    EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD_MASK,
    0,
    EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD_WIDTH,
    EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_SPARE_CTL_ECOJIRA758ENABLE
 ******************************************************************************/
const ru_field_rec EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD =
{
    "ECOJIRA758ENABLE",
#if RU_INCLUDE_DESC
    "",
    "Set this bit to prevent transmitting when the LLID's shapers are"
    "empty.  This will prevent"
    "the ONU from using excess bandwidth granted to it by the OLT."
    "Do not set this bit when operating in Point-to-Point or Active"
    "Ethernet modes.",
#endif
    EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD_MASK,
    0,
    EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD_WIDTH,
    EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TS_SYNC_OFFSET_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TS_SYNC_OFFSET_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TS_SYNC_OFFSET_RESERVED0_FIELD_MASK,
    0,
    EPN_TS_SYNC_OFFSET_RESERVED0_FIELD_WIDTH,
    EPN_TS_SYNC_OFFSET_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET
 ******************************************************************************/
const ru_field_rec EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD =
{
    "CFGTSSYNCOFFSET",
#if RU_INCLUDE_DESC
    "",
    "Provides lowest 6 bits of timestamp synchronizer, from 250 MHz"
    "domain to 125 MHz.",
#endif
    EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD_MASK,
    0,
    EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD_WIDTH,
    EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_TS_OFFSET_CFGDNTSOFFSET
 ******************************************************************************/
const ru_field_rec EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD =
{
    "CFGDNTSOFFSET",
#if RU_INCLUDE_DESC
    "",
    "Provides signed offset for downstream packet timestamping.",
#endif
    EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD_MASK,
    0,
    EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD_WIDTH,
    EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO
 ******************************************************************************/
const ru_field_rec EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD =
{
    "CFGUPTSOFFSET_LO",
#if RU_INCLUDE_DESC
    "",
    "Provides signed offset for upstream packet timestamping.",
#endif
    EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD_MASK,
    0,
    EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD_WIDTH,
    EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UP_TS_OFFSET_HI_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD_MASK,
    0,
    EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD_WIDTH,
    EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI
 ******************************************************************************/
const ru_field_rec EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD =
{
    "CFGUPTSOFFSET_HI",
#if RU_INCLUDE_DESC
    "",
    "Provides signed offset for upstream packet timestamping.",
#endif
    EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD_MASK,
    0,
    EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD_WIDTH,
    EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD
 ******************************************************************************/
const ru_field_rec EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD =
{
    "TWOSTEPFFRD",
#if RU_INCLUDE_DESC
    "",
    "Provides the reading of the two step timestamp FIFO.  A write value"
    "of 1 will advance the FIFO to the next entry.  The 48-bits value is"
    "provided by registers"
    "EPN_TWO_STEP_TS_VALUE_HI/EPN_TWO_STEP_TS_VALUE_LO.",
#endif
    EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD_MASK,
    0,
    EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD_WIDTH,
    EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TWO_STEP_TS_CTL_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD_MASK,
    0,
    EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD_WIDTH,
    EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES
 ******************************************************************************/
const ru_field_rec EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD =
{
    "TWOSTEPFFENTRIES",
#if RU_INCLUDE_DESC
    "",
    "Indicates the number of entries in the two step timestamp FIFO.",
#endif
    EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD_MASK,
    0,
    EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD_WIDTH,
    EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO
 ******************************************************************************/
const ru_field_rec EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD =
{
    "TWOSTEPTIMESTAMP_LO",
#if RU_INCLUDE_DESC
    "",
    "Lower 32-bits of two-step timestamp value for IEEE 1588"
    "timestamping.",
#endif
    EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD_MASK,
    0,
    EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD_WIDTH,
    EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_TWO_STEP_TS_VALUE_HI_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD_MASK,
    0,
    EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD_WIDTH,
    EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI
 ******************************************************************************/
const ru_field_rec EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD =
{
    "TWOSTEPTIMESTAMP_HI",
#if RU_INCLUDE_DESC
    "",
    "Upper 16-bits of two-step timestamp value for IEEE 1588"
    "timestamping.",
#endif
    EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD_MASK,
    0,
    EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD_WIDTH,
    EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD_MASK,
    0,
    EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD_WIDTH,
    EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT
 ******************************************************************************/
const ru_field_rec EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD =
{
    "INT1588PKTABORT",
#if RU_INCLUDE_DESC
    "",
    "Indicated 1588 timestamp packet was aborted due to illegal checksum"
    "or timestamp offsets.",
#endif
    EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD_MASK,
    0,
    EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD_WIDTH,
    EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT
 ******************************************************************************/
const ru_field_rec EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD =
{
    "INT1588TWOSTEPFFINT",
#if RU_INCLUDE_DESC
    "",
    "Indicates timestamp in two step FIFO is available for reading. The"
    "48-bits value is provided by registers"
    "EPN_TWO_STEP_TS_VALUE_HI/EPN_TWO_STEP_TS_VALUE_LO.",
#endif
    EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD_MASK,
    0,
    EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD_WIDTH,
    EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_1588_TIMESTAMP_INT_MASK_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD_MASK,
    0,
    EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD_WIDTH,
    EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK
 ******************************************************************************/
const ru_field_rec EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD =
{
    "TS1588PKTABORT_MASK",
#if RU_INCLUDE_DESC
    "",
    "Mask 1588 timestamp packet abort.",
#endif
    EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD_MASK,
    0,
    EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD_WIDTH,
    EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK
 ******************************************************************************/
const ru_field_rec EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD =
{
    "TS1588TWOSTEPFF_MASK",
#if RU_INCLUDE_DESC
    "",
    "Mask two step FIFO interrupt.",
#endif
    EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD_MASK,
    0,
    EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD_WIDTH,
    EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UP_PACKET_FETCH_MARGIN_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD_MASK,
    0,
    EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD_WIDTH,
    EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN
 ******************************************************************************/
const ru_field_rec EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD =
{
    "UPPACKETFETCHMARGIN",
#if RU_INCLUDE_DESC
    "",
    "Minimum BBH upstream packet request latency. Units are TQ.",
#endif
    EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD_MASK,
    0,
    EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD_WIDTH,
    EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_DN_1588_TIMESTAMP_DN_1588_TS
 ******************************************************************************/
const ru_field_rec EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD =
{
    "DN_1588_TS",
#if RU_INCLUDE_DESC
    "",
    "32-bits timestamp value of downstream packet.",
#endif
    EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD_MASK,
    0,
    EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD_WIDTH,
    EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_read
#endif
};

/******************************************************************************
 * Field: EPN_PERSISTENT_REPORT_CFG_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD_MASK,
    0,
    EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD_WIDTH,
    EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION
 ******************************************************************************/
const ru_field_rec EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD =
{
    "CFGPERSRPTDURATION",
#if RU_INCLUDE_DESC
    "",
    "How long report persistance lasts."
    "(How many report persistance timer ticks after the last non-zero"
    "report should empty reports"
    "be replaced with a persistant report)"
    "Units are report perisitance timer ticks.",
#endif
    EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD_MASK,
    0,
    EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD_WIDTH,
    EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE
 ******************************************************************************/
const ru_field_rec EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD =
{
    "CFGPERSRPTTICKSIZE",
#if RU_INCLUDE_DESC
    "",
    "How many clock cycles are in each report persistance timer tick."
    "The 125 MHz core clock rate requires 125 clocks per 1 uS tick."
    "Units are core clock cycles.",
#endif
    EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD_MASK,
    0,
    EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD_WIDTH,
    EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE
 ******************************************************************************/
const ru_field_rec EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD =
{
    "CFGPERSRPTENABLE",
#if RU_INCLUDE_DESC
    "",
    "Per LLID enable for persistent reporting.  Set the bit to enable"
    "persistent reporting."
    "0: Disable persistent reporting."
    "1: Enable persistent reporting.",
#endif
    EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD_MASK,
    0,
    EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD_WIDTH,
    EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD_MASK,
    0,
    EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD_WIDTH,
    EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ
 ******************************************************************************/
const ru_field_rec EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD =
{
    "CFGPERSRPTREQTQ",
#if RU_INCLUDE_DESC
    "",
    "How many Time Quanta the persistent report should request.  Smaller"
    "values waste less upstream bandwidth."
    "Units are Time Quanta.",
#endif
    EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD_MASK,
    0,
    EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD_WIDTH,
    EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_AES_CONFIGURATION_1_PRVUPSTREAMAESMODE_1
 ******************************************************************************/
const ru_field_rec EPN_AES_CONFIGURATION_1_PRVUPSTREAMAESMODE_1_FIELD =
{
    "PRVUPSTREAMAESMODE_1",
#if RU_INCLUDE_DESC
    "",
    "LLID index 16 AES overhead mode."
    "0: Implicit SCI AES overhead mode."
    "1: Explicit SCI AES overhead mode."
    "."
    "."
    "LLID index 31 AES overhead mode."
    "30: Implicit SCI AES overhead mode."
    "31: Explicit SCI AES overhead mode.",
#endif
    EPN_AES_CONFIGURATION_1_PRVUPSTREAMAESMODE_1_FIELD_MASK,
    0,
    EPN_AES_CONFIGURATION_1_PRVUPSTREAMAESMODE_1_FIELD_WIDTH,
    EPN_AES_CONFIGURATION_1_PRVUPSTREAMAESMODE_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_0_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_0_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_0_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_0_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_0_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_0_BURSTCAP0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_0_BURSTCAP0_FIELD =
{
    "BURSTCAP0",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 0 in Tek mode and on"
    "L2 0 in multi-priority mode.",
#endif
    EPN_BURST_CAP_0_BURSTCAP0_FIELD_MASK,
    0,
    EPN_BURST_CAP_0_BURSTCAP0_FIELD_WIDTH,
    EPN_BURST_CAP_0_BURSTCAP0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_1_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_1_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_1_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_1_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_1_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_1_BURSTCAP1
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_1_BURSTCAP1_FIELD =
{
    "BURSTCAP1",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 1 in Tek mode and on"
    "L2 1 in multi-priority mode.",
#endif
    EPN_BURST_CAP_1_BURSTCAP1_FIELD_MASK,
    0,
    EPN_BURST_CAP_1_BURSTCAP1_FIELD_WIDTH,
    EPN_BURST_CAP_1_BURSTCAP1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_2_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_2_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_2_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_2_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_2_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_2_BURSTCAP2
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_2_BURSTCAP2_FIELD =
{
    "BURSTCAP2",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 2 in Tek mode and on"
    "L2 2 in multi-priority mode.",
#endif
    EPN_BURST_CAP_2_BURSTCAP2_FIELD_MASK,
    0,
    EPN_BURST_CAP_2_BURSTCAP2_FIELD_WIDTH,
    EPN_BURST_CAP_2_BURSTCAP2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_3_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_3_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_3_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_3_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_3_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_3_BURSTCAP3
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_3_BURSTCAP3_FIELD =
{
    "BURSTCAP3",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 3 in Tek mode and on"
    "L2 3 in multi-priority mode.",
#endif
    EPN_BURST_CAP_3_BURSTCAP3_FIELD_MASK,
    0,
    EPN_BURST_CAP_3_BURSTCAP3_FIELD_WIDTH,
    EPN_BURST_CAP_3_BURSTCAP3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_4_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_4_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_4_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_4_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_4_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_4_BURSTCAP4
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_4_BURSTCAP4_FIELD =
{
    "BURSTCAP4",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 4 in Tek mode and on"
    "L2 4 in multi-priority mode.",
#endif
    EPN_BURST_CAP_4_BURSTCAP4_FIELD_MASK,
    0,
    EPN_BURST_CAP_4_BURSTCAP4_FIELD_WIDTH,
    EPN_BURST_CAP_4_BURSTCAP4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_5_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_5_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_5_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_5_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_5_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_5_BURSTCAP5
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_5_BURSTCAP5_FIELD =
{
    "BURSTCAP5",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 5 in Tek mode and on"
    "L2 5 in multi-priority mode.",
#endif
    EPN_BURST_CAP_5_BURSTCAP5_FIELD_MASK,
    0,
    EPN_BURST_CAP_5_BURSTCAP5_FIELD_WIDTH,
    EPN_BURST_CAP_5_BURSTCAP5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_6_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_6_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_6_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_6_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_6_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_6_BURSTCAP6
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_6_BURSTCAP6_FIELD =
{
    "BURSTCAP6",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 6 in Tek mode and on"
    "L2 6 in multi-priority mode.",
#endif
    EPN_BURST_CAP_6_BURSTCAP6_FIELD_MASK,
    0,
    EPN_BURST_CAP_6_BURSTCAP6_FIELD_WIDTH,
    EPN_BURST_CAP_6_BURSTCAP6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_7_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_7_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_7_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_7_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_7_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_7_BURSTCAP7
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_7_BURSTCAP7_FIELD =
{
    "BURSTCAP7",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 7 in Tek mode and on"
    "L2 7 in multi-priority mode.",
#endif
    EPN_BURST_CAP_7_BURSTCAP7_FIELD_MASK,
    0,
    EPN_BURST_CAP_7_BURSTCAP7_FIELD_WIDTH,
    EPN_BURST_CAP_7_BURSTCAP7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_0_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_0_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_0_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_0_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_0_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_0_QUELLIDMAP0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_0_QUELLIDMAP0_FIELD =
{
    "QUELLIDMAP0",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 0 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_0_QUELLIDMAP0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_0_QUELLIDMAP0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_0_QUELLIDMAP0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_1_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_1_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_1_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_1_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_1_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_1_QUELLIDMAP1
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_1_QUELLIDMAP1_FIELD =
{
    "QUELLIDMAP1",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 1 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_1_QUELLIDMAP1_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_1_QUELLIDMAP1_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_1_QUELLIDMAP1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_2_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_2_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_2_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_2_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_2_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_2_QUELLIDMAP2
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_2_QUELLIDMAP2_FIELD =
{
    "QUELLIDMAP2",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 2 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_2_QUELLIDMAP2_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_2_QUELLIDMAP2_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_2_QUELLIDMAP2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_3_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_3_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_3_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_3_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_3_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_3_QUELLIDMAP3
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_3_QUELLIDMAP3_FIELD =
{
    "QUELLIDMAP3",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 3 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_3_QUELLIDMAP3_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_3_QUELLIDMAP3_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_3_QUELLIDMAP3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_4_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_4_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_4_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_4_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_4_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_4_QUELLIDMAP4
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_4_QUELLIDMAP4_FIELD =
{
    "QUELLIDMAP4",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 4 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_4_QUELLIDMAP4_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_4_QUELLIDMAP4_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_4_QUELLIDMAP4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_5_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_5_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_5_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_5_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_5_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_5_QUELLIDMAP5
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_5_QUELLIDMAP5_FIELD =
{
    "QUELLIDMAP5",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 5 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_5_QUELLIDMAP5_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_5_QUELLIDMAP5_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_5_QUELLIDMAP5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_6_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_6_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_6_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_6_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_6_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_6_QUELLIDMAP6
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_6_QUELLIDMAP6_FIELD =
{
    "QUELLIDMAP6",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 6 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_6_QUELLIDMAP6_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_6_QUELLIDMAP6_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_6_QUELLIDMAP6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_7_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_7_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_7_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_7_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_7_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_7_QUELLIDMAP7
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_7_QUELLIDMAP7_FIELD =
{
    "QUELLIDMAP7",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 7 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_7_QUELLIDMAP7_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_7_QUELLIDMAP7_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_7_QUELLIDMAP7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT0_UNUSEDTQCNT0
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT0_UNUSEDTQCNT0_FIELD =
{
    "UNUSEDTQCNT0",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 0.",
#endif
    EPN_UNUSED_TQ_CNT0_UNUSEDTQCNT0_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT0_UNUSEDTQCNT0_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT0_UNUSEDTQCNT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT1_UNUSEDTQCNT1
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT1_UNUSEDTQCNT1_FIELD =
{
    "UNUSEDTQCNT1",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 1.",
#endif
    EPN_UNUSED_TQ_CNT1_UNUSEDTQCNT1_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT1_UNUSEDTQCNT1_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT1_UNUSEDTQCNT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT2_UNUSEDTQCNT2
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT2_UNUSEDTQCNT2_FIELD =
{
    "UNUSEDTQCNT2",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 2.",
#endif
    EPN_UNUSED_TQ_CNT2_UNUSEDTQCNT2_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT2_UNUSEDTQCNT2_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT2_UNUSEDTQCNT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT3_UNUSEDTQCNT3
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT3_UNUSEDTQCNT3_FIELD =
{
    "UNUSEDTQCNT3",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 3.",
#endif
    EPN_UNUSED_TQ_CNT3_UNUSEDTQCNT3_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT3_UNUSEDTQCNT3_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT3_UNUSEDTQCNT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT4_UNUSEDTQCNT4
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT4_UNUSEDTQCNT4_FIELD =
{
    "UNUSEDTQCNT4",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 4.",
#endif
    EPN_UNUSED_TQ_CNT4_UNUSEDTQCNT4_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT4_UNUSEDTQCNT4_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT4_UNUSEDTQCNT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT5_UNUSEDTQCNT5
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT5_UNUSEDTQCNT5_FIELD =
{
    "UNUSEDTQCNT5",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 5.",
#endif
    EPN_UNUSED_TQ_CNT5_UNUSEDTQCNT5_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT5_UNUSEDTQCNT5_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT5_UNUSEDTQCNT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT6_UNUSEDTQCNT6
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT6_UNUSEDTQCNT6_FIELD =
{
    "UNUSEDTQCNT6",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 6.",
#endif
    EPN_UNUSED_TQ_CNT6_UNUSEDTQCNT6_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT6_UNUSEDTQCNT6_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT6_UNUSEDTQCNT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT7_UNUSEDTQCNT7
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT7_UNUSEDTQCNT7_FIELD =
{
    "UNUSEDTQCNT7",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 7.",
#endif
    EPN_UNUSED_TQ_CNT7_UNUSEDTQCNT7_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT7_UNUSEDTQCNT7_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT7_UNUSEDTQCNT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_0_CFGSHPMASK0
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_0_CFGSHPMASK0_FIELD =
{
    "CFGSHPMASK0",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 0 on"
    "the respective queue"
    "0: Shaper 0 can affect this queue"
    "1: Shaper 0 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_0_CFGSHPMASK0_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_0_CFGSHPMASK0_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_0_CFGSHPMASK0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_1_CFGSHPMASK1
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_1_CFGSHPMASK1_FIELD =
{
    "CFGSHPMASK1",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 1 on"
    "the respective queue"
    "0: Shaper 1 can affect this queue"
    "1: Shaper 1 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_1_CFGSHPMASK1_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_1_CFGSHPMASK1_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_1_CFGSHPMASK1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_2_CFGSHPMASK2
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_2_CFGSHPMASK2_FIELD =
{
    "CFGSHPMASK2",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 2 on"
    "the respective queue"
    "0: Shaper 2 can affect this queue"
    "1: Shaper 2 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_2_CFGSHPMASK2_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_2_CFGSHPMASK2_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_2_CFGSHPMASK2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_3_CFGSHPMASK3
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_3_CFGSHPMASK3_FIELD =
{
    "CFGSHPMASK3",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 3 on"
    "the respective queue"
    "0: Shaper 3 can affect this queue"
    "1: Shaper 3 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_3_CFGSHPMASK3_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_3_CFGSHPMASK3_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_3_CFGSHPMASK3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_4_CFGSHPMASK4
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_4_CFGSHPMASK4_FIELD =
{
    "CFGSHPMASK4",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 4 on"
    "the respective queue"
    "0: Shaper 4 can affect this queue"
    "1: Shaper 4 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_4_CFGSHPMASK4_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_4_CFGSHPMASK4_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_4_CFGSHPMASK4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_5_CFGSHPMASK5
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_5_CFGSHPMASK5_FIELD =
{
    "CFGSHPMASK5",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 5 on"
    "the respective queue"
    "0: Shaper 5 can affect this queue"
    "1: Shaper 5 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_5_CFGSHPMASK5_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_5_CFGSHPMASK5_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_5_CFGSHPMASK5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_6_CFGSHPMASK6
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_6_CFGSHPMASK6_FIELD =
{
    "CFGSHPMASK6",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 6 on"
    "the respective queue"
    "0: Shaper 6 can affect this queue"
    "1: Shaper 6 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_6_CFGSHPMASK6_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_6_CFGSHPMASK6_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_6_CFGSHPMASK6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_7_CFGSHPMASK7
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_7_CFGSHPMASK7_FIELD =
{
    "CFGSHPMASK7",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 7 on"
    "the respective queue"
    "0: Shaper 7 can affect this queue"
    "1: Shaper 7 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_7_CFGSHPMASK7_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_7_CFGSHPMASK7_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_7_CFGSHPMASK7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_0_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_0_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_0_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_0_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_0_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUEEND0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUEEND0_FIELD =
{
    "CFGL2SQUEEND0",
#if RU_INCLUDE_DESC
    "",
    "Queue 0 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUEEND0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUEEND0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUEEND0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_0_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_0_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_0_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_0_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_0_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUESTART0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUESTART0_FIELD =
{
    "CFGL2SQUESTART0",
#if RU_INCLUDE_DESC
    "",
    "Queue 0 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUESTART0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUESTART0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUESTART0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_1_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_1_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_1_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_1_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_1_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUEEND1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUEEND1_FIELD =
{
    "CFGL2SQUEEND1",
#if RU_INCLUDE_DESC
    "",
    "Queue 1 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUEEND1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUEEND1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUEEND1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_1_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_1_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_1_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_1_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_1_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUESTART1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUESTART1_FIELD =
{
    "CFGL2SQUESTART1",
#if RU_INCLUDE_DESC
    "",
    "Queue 1 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUESTART1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUESTART1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUESTART1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_2_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_2_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_2_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_2_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_2_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUEEND2
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUEEND2_FIELD =
{
    "CFGL2SQUEEND2",
#if RU_INCLUDE_DESC
    "",
    "Queue 2 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUEEND2_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUEEND2_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUEEND2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_2_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_2_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_2_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_2_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_2_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUESTART2
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUESTART2_FIELD =
{
    "CFGL2SQUESTART2",
#if RU_INCLUDE_DESC
    "",
    "Queue 2 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUESTART2_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUESTART2_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUESTART2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_3_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_3_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_3_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_3_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_3_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUEEND3
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUEEND3_FIELD =
{
    "CFGL2SQUEEND3",
#if RU_INCLUDE_DESC
    "",
    "Queue 3 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUEEND3_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUEEND3_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUEEND3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_3_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_3_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_3_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_3_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_3_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUESTART3
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUESTART3_FIELD =
{
    "CFGL2SQUESTART3",
#if RU_INCLUDE_DESC
    "",
    "Queue 3 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUESTART3_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUESTART3_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUESTART3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_4_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_4_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_4_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_4_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_4_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUEEND4
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUEEND4_FIELD =
{
    "CFGL2SQUEEND4",
#if RU_INCLUDE_DESC
    "",
    "Queue 4 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUEEND4_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUEEND4_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUEEND4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_4_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_4_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_4_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_4_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_4_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUESTART4
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUESTART4_FIELD =
{
    "CFGL2SQUESTART4",
#if RU_INCLUDE_DESC
    "",
    "Queue 4 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUESTART4_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUESTART4_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUESTART4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_5_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_5_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_5_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_5_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_5_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUEEND5
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUEEND5_FIELD =
{
    "CFGL2SQUEEND5",
#if RU_INCLUDE_DESC
    "",
    "Queue 5 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUEEND5_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUEEND5_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUEEND5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_5_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_5_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_5_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_5_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_5_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUESTART5
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUESTART5_FIELD =
{
    "CFGL2SQUESTART5",
#if RU_INCLUDE_DESC
    "",
    "Queue 5 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUESTART5_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUESTART5_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUESTART5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_6_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_6_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_6_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_6_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_6_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUEEND6
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUEEND6_FIELD =
{
    "CFGL2SQUEEND6",
#if RU_INCLUDE_DESC
    "",
    "Queue 6 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUEEND6_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUEEND6_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUEEND6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_6_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_6_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_6_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_6_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_6_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUESTART6
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUESTART6_FIELD =
{
    "CFGL2SQUESTART6",
#if RU_INCLUDE_DESC
    "",
    "Queue 6 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUESTART6_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUESTART6_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUESTART6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_7_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_7_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_7_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_7_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_7_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUEEND7
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUEEND7_FIELD =
{
    "CFGL2SQUEEND7",
#if RU_INCLUDE_DESC
    "",
    "Queue 7 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUEEND7_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUEEND7_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUEEND7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_7_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_7_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_7_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_7_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_7_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUESTART7
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUESTART7_FIELD =
{
    "CFGL2SQUESTART7",
#if RU_INCLUDE_DESC
    "",
    "Queue 7 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUESTART7_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUESTART7_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUESTART7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_0_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_0_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_0_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_0_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_0_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_0_PRVBURSTLIMIT0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_0_PRVBURSTLIMIT0_FIELD =
{
    "PRVBURSTLIMIT0",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 0 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_0_PRVBURSTLIMIT0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_0_PRVBURSTLIMIT0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_0_PRVBURSTLIMIT0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_1_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_1_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_1_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_1_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_1_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_1_PRVBURSTLIMIT1
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_1_PRVBURSTLIMIT1_FIELD =
{
    "PRVBURSTLIMIT1",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 1 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_1_PRVBURSTLIMIT1_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_1_PRVBURSTLIMIT1_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_1_PRVBURSTLIMIT1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_2_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_2_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_2_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_2_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_2_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_2_PRVBURSTLIMIT2
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_2_PRVBURSTLIMIT2_FIELD =
{
    "PRVBURSTLIMIT2",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 2 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_2_PRVBURSTLIMIT2_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_2_PRVBURSTLIMIT2_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_2_PRVBURSTLIMIT2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_3_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_3_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_3_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_3_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_3_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_3_PRVBURSTLIMIT3
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_3_PRVBURSTLIMIT3_FIELD =
{
    "PRVBURSTLIMIT3",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 3 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_3_PRVBURSTLIMIT3_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_3_PRVBURSTLIMIT3_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_3_PRVBURSTLIMIT3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_4_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_4_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_4_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_4_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_4_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_4_PRVBURSTLIMIT4
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_4_PRVBURSTLIMIT4_FIELD =
{
    "PRVBURSTLIMIT4",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 4 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_4_PRVBURSTLIMIT4_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_4_PRVBURSTLIMIT4_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_4_PRVBURSTLIMIT4_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_5_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_5_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_5_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_5_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_5_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_5_PRVBURSTLIMIT5
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_5_PRVBURSTLIMIT5_FIELD =
{
    "PRVBURSTLIMIT5",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 5 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_5_PRVBURSTLIMIT5_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_5_PRVBURSTLIMIT5_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_5_PRVBURSTLIMIT5_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_6_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_6_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_6_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_6_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_6_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_6_PRVBURSTLIMIT6
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_6_PRVBURSTLIMIT6_FIELD =
{
    "PRVBURSTLIMIT6",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 6 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_6_PRVBURSTLIMIT6_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_6_PRVBURSTLIMIT6_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_6_PRVBURSTLIMIT6_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_7_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_7_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_7_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_7_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_7_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_7_PRVBURSTLIMIT7
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_7_PRVBURSTLIMIT7_FIELD =
{
    "PRVBURSTLIMIT7",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 7 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_7_PRVBURSTLIMIT7_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_7_PRVBURSTLIMIT7_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_7_PRVBURSTLIMIT7_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_8_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_8_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_8_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_8_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_8_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_8_BURSTCAP8
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_8_BURSTCAP8_FIELD =
{
    "BURSTCAP8",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 8 in Tek mode and on"
    "L2 8 in multi-priority mode.",
#endif
    EPN_BURST_CAP_8_BURSTCAP8_FIELD_MASK,
    0,
    EPN_BURST_CAP_8_BURSTCAP8_FIELD_WIDTH,
    EPN_BURST_CAP_8_BURSTCAP8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_9_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_9_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_9_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_9_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_9_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_9_BURSTCAP9
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_9_BURSTCAP9_FIELD =
{
    "BURSTCAP9",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 9 in Tek mode and on"
    "L2 9 in multi-priority mode.",
#endif
    EPN_BURST_CAP_9_BURSTCAP9_FIELD_MASK,
    0,
    EPN_BURST_CAP_9_BURSTCAP9_FIELD_WIDTH,
    EPN_BURST_CAP_9_BURSTCAP9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_10_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_10_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_10_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_10_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_10_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_10_BURSTCAP10
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_10_BURSTCAP10_FIELD =
{
    "BURSTCAP10",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 10 in Tek mode and on"
    "L2 10 in multi-priority mode.",
#endif
    EPN_BURST_CAP_10_BURSTCAP10_FIELD_MASK,
    0,
    EPN_BURST_CAP_10_BURSTCAP10_FIELD_WIDTH,
    EPN_BURST_CAP_10_BURSTCAP10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_11_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_11_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_11_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_11_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_11_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_11_BURSTCAP11
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_11_BURSTCAP11_FIELD =
{
    "BURSTCAP11",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 11 in Tek mode and on"
    "L2 11 in multi-priority mode.",
#endif
    EPN_BURST_CAP_11_BURSTCAP11_FIELD_MASK,
    0,
    EPN_BURST_CAP_11_BURSTCAP11_FIELD_WIDTH,
    EPN_BURST_CAP_11_BURSTCAP11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_12_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_12_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_12_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_12_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_12_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_12_BURSTCAP12
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_12_BURSTCAP12_FIELD =
{
    "BURSTCAP12",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 12 in Tek mode and on"
    "L2 12 in multi-priority mode.",
#endif
    EPN_BURST_CAP_12_BURSTCAP12_FIELD_MASK,
    0,
    EPN_BURST_CAP_12_BURSTCAP12_FIELD_WIDTH,
    EPN_BURST_CAP_12_BURSTCAP12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_13_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_13_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_13_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_13_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_13_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_13_BURSTCAP13
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_13_BURSTCAP13_FIELD =
{
    "BURSTCAP13",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 13 in Tek mode and on"
    "L2 13 in multi-priority mode.",
#endif
    EPN_BURST_CAP_13_BURSTCAP13_FIELD_MASK,
    0,
    EPN_BURST_CAP_13_BURSTCAP13_FIELD_WIDTH,
    EPN_BURST_CAP_13_BURSTCAP13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_14_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_14_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_14_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_14_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_14_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_14_BURSTCAP14
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_14_BURSTCAP14_FIELD =
{
    "BURSTCAP14",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 14 in Tek mode and on"
    "L2 14 in multi-priority mode.",
#endif
    EPN_BURST_CAP_14_BURSTCAP14_FIELD_MASK,
    0,
    EPN_BURST_CAP_14_BURSTCAP14_FIELD_WIDTH,
    EPN_BURST_CAP_14_BURSTCAP14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_15_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_15_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_15_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_15_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_15_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_15_BURSTCAP15
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_15_BURSTCAP15_FIELD =
{
    "BURSTCAP15",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 15 in Tek mode and on"
    "L2 15 in multi-priority mode.",
#endif
    EPN_BURST_CAP_15_BURSTCAP15_FIELD_MASK,
    0,
    EPN_BURST_CAP_15_BURSTCAP15_FIELD_WIDTH,
    EPN_BURST_CAP_15_BURSTCAP15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_16_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_16_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_16_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_16_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_16_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_16_BURSTCAP16
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_16_BURSTCAP16_FIELD =
{
    "BURSTCAP16",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 16 in Tek mode and on"
    "L2 16 in multi-priority mode.",
#endif
    EPN_BURST_CAP_16_BURSTCAP16_FIELD_MASK,
    0,
    EPN_BURST_CAP_16_BURSTCAP16_FIELD_WIDTH,
    EPN_BURST_CAP_16_BURSTCAP16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_17_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_17_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_17_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_17_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_17_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_17_BURSTCAP17
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_17_BURSTCAP17_FIELD =
{
    "BURSTCAP17",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 17 in Tek mode and on"
    "L2 17 in multi-priority mode.",
#endif
    EPN_BURST_CAP_17_BURSTCAP17_FIELD_MASK,
    0,
    EPN_BURST_CAP_17_BURSTCAP17_FIELD_WIDTH,
    EPN_BURST_CAP_17_BURSTCAP17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_18_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_18_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_18_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_18_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_18_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_18_BURSTCAP18
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_18_BURSTCAP18_FIELD =
{
    "BURSTCAP18",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 18 in Tek mode and on"
    "L2 18 in multi-priority mode.",
#endif
    EPN_BURST_CAP_18_BURSTCAP18_FIELD_MASK,
    0,
    EPN_BURST_CAP_18_BURSTCAP18_FIELD_WIDTH,
    EPN_BURST_CAP_18_BURSTCAP18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_19_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_19_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_19_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_19_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_19_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_19_BURSTCAP19
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_19_BURSTCAP19_FIELD =
{
    "BURSTCAP19",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 19 in Tek mode and on"
    "L2 19 in multi-priority mode.",
#endif
    EPN_BURST_CAP_19_BURSTCAP19_FIELD_MASK,
    0,
    EPN_BURST_CAP_19_BURSTCAP19_FIELD_WIDTH,
    EPN_BURST_CAP_19_BURSTCAP19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_20_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_20_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_20_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_20_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_20_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_20_BURSTCAP20
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_20_BURSTCAP20_FIELD =
{
    "BURSTCAP20",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 20 in Tek mode and on"
    "L2 20 in multi-priority mode.",
#endif
    EPN_BURST_CAP_20_BURSTCAP20_FIELD_MASK,
    0,
    EPN_BURST_CAP_20_BURSTCAP20_FIELD_WIDTH,
    EPN_BURST_CAP_20_BURSTCAP20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_21_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_21_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_21_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_21_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_21_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_21_BURSTCAP21
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_21_BURSTCAP21_FIELD =
{
    "BURSTCAP21",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 21 in Tek mode and on"
    "L2 21 in multi-priority mode.",
#endif
    EPN_BURST_CAP_21_BURSTCAP21_FIELD_MASK,
    0,
    EPN_BURST_CAP_21_BURSTCAP21_FIELD_WIDTH,
    EPN_BURST_CAP_21_BURSTCAP21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_22_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_22_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_22_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_22_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_22_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_22_BURSTCAP22
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_22_BURSTCAP22_FIELD =
{
    "BURSTCAP22",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 22 in Tek mode and on"
    "L2 22 in multi-priority mode.",
#endif
    EPN_BURST_CAP_22_BURSTCAP22_FIELD_MASK,
    0,
    EPN_BURST_CAP_22_BURSTCAP22_FIELD_WIDTH,
    EPN_BURST_CAP_22_BURSTCAP22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_23_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_23_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_23_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_23_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_23_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_23_BURSTCAP23
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_23_BURSTCAP23_FIELD =
{
    "BURSTCAP23",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 23 in Tek mode and on"
    "L2 23 in multi-priority mode.",
#endif
    EPN_BURST_CAP_23_BURSTCAP23_FIELD_MASK,
    0,
    EPN_BURST_CAP_23_BURSTCAP23_FIELD_WIDTH,
    EPN_BURST_CAP_23_BURSTCAP23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_24_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_24_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_24_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_24_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_24_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_24_BURSTCAP24
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_24_BURSTCAP24_FIELD =
{
    "BURSTCAP24",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 24 in Tek mode and on"
    "L2 24 in multi-priority mode.",
#endif
    EPN_BURST_CAP_24_BURSTCAP24_FIELD_MASK,
    0,
    EPN_BURST_CAP_24_BURSTCAP24_FIELD_WIDTH,
    EPN_BURST_CAP_24_BURSTCAP24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_25_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_25_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_25_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_25_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_25_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_25_BURSTCAP25
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_25_BURSTCAP25_FIELD =
{
    "BURSTCAP25",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 25 in Tek mode and on"
    "L2 25 in multi-priority mode.",
#endif
    EPN_BURST_CAP_25_BURSTCAP25_FIELD_MASK,
    0,
    EPN_BURST_CAP_25_BURSTCAP25_FIELD_WIDTH,
    EPN_BURST_CAP_25_BURSTCAP25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_26_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_26_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_26_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_26_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_26_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_26_BURSTCAP26
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_26_BURSTCAP26_FIELD =
{
    "BURSTCAP26",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 26 in Tek mode and on"
    "L2 26 in multi-priority mode.",
#endif
    EPN_BURST_CAP_26_BURSTCAP26_FIELD_MASK,
    0,
    EPN_BURST_CAP_26_BURSTCAP26_FIELD_WIDTH,
    EPN_BURST_CAP_26_BURSTCAP26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_27_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_27_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_27_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_27_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_27_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_27_BURSTCAP27
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_27_BURSTCAP27_FIELD =
{
    "BURSTCAP27",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 27 in Tek mode and on"
    "L2 27 in multi-priority mode.",
#endif
    EPN_BURST_CAP_27_BURSTCAP27_FIELD_MASK,
    0,
    EPN_BURST_CAP_27_BURSTCAP27_FIELD_WIDTH,
    EPN_BURST_CAP_27_BURSTCAP27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_28_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_28_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_28_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_28_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_28_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_28_BURSTCAP28
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_28_BURSTCAP28_FIELD =
{
    "BURSTCAP28",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 28 in Tek mode and on"
    "L2 28 in multi-priority mode.",
#endif
    EPN_BURST_CAP_28_BURSTCAP28_FIELD_MASK,
    0,
    EPN_BURST_CAP_28_BURSTCAP28_FIELD_WIDTH,
    EPN_BURST_CAP_28_BURSTCAP28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_29_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_29_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_29_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_29_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_29_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_29_BURSTCAP29
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_29_BURSTCAP29_FIELD =
{
    "BURSTCAP29",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 29 in Tek mode and on"
    "L2 29 in multi-priority mode.",
#endif
    EPN_BURST_CAP_29_BURSTCAP29_FIELD_MASK,
    0,
    EPN_BURST_CAP_29_BURSTCAP29_FIELD_WIDTH,
    EPN_BURST_CAP_29_BURSTCAP29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_30_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_30_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_30_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_30_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_30_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_30_BURSTCAP30
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_30_BURSTCAP30_FIELD =
{
    "BURSTCAP30",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 30 in Tek mode and on"
    "L2 30 in multi-priority mode.",
#endif
    EPN_BURST_CAP_30_BURSTCAP30_FIELD_MASK,
    0,
    EPN_BURST_CAP_30_BURSTCAP30_FIELD_WIDTH,
    EPN_BURST_CAP_30_BURSTCAP30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_31_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_31_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_BURST_CAP_31_RESERVED0_FIELD_MASK,
    0,
    EPN_BURST_CAP_31_RESERVED0_FIELD_WIDTH,
    EPN_BURST_CAP_31_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_BURST_CAP_31_BURSTCAP31
 ******************************************************************************/
const ru_field_rec EPN_BURST_CAP_31_BURSTCAP31_FIELD =
{
    "BURSTCAP31",
#if RU_INCLUDE_DESC
    "",
    "Defines maximum size of a report on LLID index 31 in Tek mode and on"
    "L2 31 in multi-priority mode.",
#endif
    EPN_BURST_CAP_31_BURSTCAP31_FIELD_MASK,
    0,
    EPN_BURST_CAP_31_BURSTCAP31_FIELD_WIDTH,
    EPN_BURST_CAP_31_BURSTCAP31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_8_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_8_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_8_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_8_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_8_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_8_QUELLIDMAP8
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_8_QUELLIDMAP8_FIELD =
{
    "QUELLIDMAP8",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 8 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_8_QUELLIDMAP8_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_8_QUELLIDMAP8_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_8_QUELLIDMAP8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_9_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_9_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_9_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_9_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_9_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_9_QUELLIDMAP9
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_9_QUELLIDMAP9_FIELD =
{
    "QUELLIDMAP9",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 9 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_9_QUELLIDMAP9_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_9_QUELLIDMAP9_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_9_QUELLIDMAP9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_10_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_10_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_10_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_10_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_10_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_10_QUELLIDMAP10
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_10_QUELLIDMAP10_FIELD =
{
    "QUELLIDMAP10",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 10 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_10_QUELLIDMAP10_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_10_QUELLIDMAP10_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_10_QUELLIDMAP10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_11_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_11_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_11_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_11_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_11_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_11_QUELLIDMAP11
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_11_QUELLIDMAP11_FIELD =
{
    "QUELLIDMAP11",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 11 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_11_QUELLIDMAP11_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_11_QUELLIDMAP11_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_11_QUELLIDMAP11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_12_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_12_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_12_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_12_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_12_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_12_QUELLIDMAP12
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_12_QUELLIDMAP12_FIELD =
{
    "QUELLIDMAP12",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 12 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_12_QUELLIDMAP12_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_12_QUELLIDMAP12_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_12_QUELLIDMAP12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_13_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_13_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_13_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_13_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_13_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_13_QUELLIDMAP13
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_13_QUELLIDMAP13_FIELD =
{
    "QUELLIDMAP13",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 13 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_13_QUELLIDMAP13_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_13_QUELLIDMAP13_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_13_QUELLIDMAP13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_14_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_14_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_14_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_14_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_14_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_14_QUELLIDMAP14
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_14_QUELLIDMAP14_FIELD =
{
    "QUELLIDMAP14",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 14 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_14_QUELLIDMAP14_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_14_QUELLIDMAP14_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_14_QUELLIDMAP14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_15_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_15_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_15_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_15_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_15_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_15_QUELLIDMAP15
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_15_QUELLIDMAP15_FIELD =
{
    "QUELLIDMAP15",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 15 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_15_QUELLIDMAP15_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_15_QUELLIDMAP15_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_15_QUELLIDMAP15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_16_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_16_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_16_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_16_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_16_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_16_QUELLIDMAP16
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_16_QUELLIDMAP16_FIELD =
{
    "QUELLIDMAP16",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 16 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_16_QUELLIDMAP16_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_16_QUELLIDMAP16_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_16_QUELLIDMAP16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_17_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_17_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_17_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_17_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_17_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_17_QUELLIDMAP17
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_17_QUELLIDMAP17_FIELD =
{
    "QUELLIDMAP17",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 17 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_17_QUELLIDMAP17_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_17_QUELLIDMAP17_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_17_QUELLIDMAP17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_18_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_18_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_18_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_18_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_18_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_18_QUELLIDMAP18
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_18_QUELLIDMAP18_FIELD =
{
    "QUELLIDMAP18",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 18 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_18_QUELLIDMAP18_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_18_QUELLIDMAP18_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_18_QUELLIDMAP18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_19_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_19_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_19_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_19_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_19_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_19_QUELLIDMAP19
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_19_QUELLIDMAP19_FIELD =
{
    "QUELLIDMAP19",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 19 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_19_QUELLIDMAP19_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_19_QUELLIDMAP19_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_19_QUELLIDMAP19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_20_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_20_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_20_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_20_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_20_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_20_QUELLIDMAP20
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_20_QUELLIDMAP20_FIELD =
{
    "QUELLIDMAP20",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 20 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_20_QUELLIDMAP20_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_20_QUELLIDMAP20_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_20_QUELLIDMAP20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_21_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_21_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_21_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_21_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_21_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_21_QUELLIDMAP21
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_21_QUELLIDMAP21_FIELD =
{
    "QUELLIDMAP21",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 21 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_21_QUELLIDMAP21_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_21_QUELLIDMAP21_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_21_QUELLIDMAP21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_22_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_22_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_22_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_22_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_22_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_22_QUELLIDMAP22
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_22_QUELLIDMAP22_FIELD =
{
    "QUELLIDMAP22",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 22 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_22_QUELLIDMAP22_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_22_QUELLIDMAP22_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_22_QUELLIDMAP22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_23_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_23_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_23_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_23_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_23_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_23_QUELLIDMAP23
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_23_QUELLIDMAP23_FIELD =
{
    "QUELLIDMAP23",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 23 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_23_QUELLIDMAP23_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_23_QUELLIDMAP23_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_23_QUELLIDMAP23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_24_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_24_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_24_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_24_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_24_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_24_QUELLIDMAP24
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_24_QUELLIDMAP24_FIELD =
{
    "QUELLIDMAP24",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 24 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_24_QUELLIDMAP24_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_24_QUELLIDMAP24_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_24_QUELLIDMAP24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_25_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_25_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_25_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_25_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_25_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_25_QUELLIDMAP25
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_25_QUELLIDMAP25_FIELD =
{
    "QUELLIDMAP25",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 25 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_25_QUELLIDMAP25_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_25_QUELLIDMAP25_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_25_QUELLIDMAP25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_26_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_26_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_26_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_26_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_26_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_26_QUELLIDMAP26
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_26_QUELLIDMAP26_FIELD =
{
    "QUELLIDMAP26",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 26 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_26_QUELLIDMAP26_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_26_QUELLIDMAP26_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_26_QUELLIDMAP26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_27_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_27_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_27_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_27_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_27_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_27_QUELLIDMAP27
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_27_QUELLIDMAP27_FIELD =
{
    "QUELLIDMAP27",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 27 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_27_QUELLIDMAP27_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_27_QUELLIDMAP27_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_27_QUELLIDMAP27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_28_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_28_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_28_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_28_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_28_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_28_QUELLIDMAP28
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_28_QUELLIDMAP28_FIELD =
{
    "QUELLIDMAP28",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 28 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_28_QUELLIDMAP28_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_28_QUELLIDMAP28_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_28_QUELLIDMAP28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_29_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_29_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_29_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_29_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_29_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_29_QUELLIDMAP29
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_29_QUELLIDMAP29_FIELD =
{
    "QUELLIDMAP29",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 29 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_29_QUELLIDMAP29_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_29_QUELLIDMAP29_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_29_QUELLIDMAP29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_30_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_30_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_30_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_30_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_30_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_30_QUELLIDMAP30
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_30_QUELLIDMAP30_FIELD =
{
    "QUELLIDMAP30",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 30 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_30_QUELLIDMAP30_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_30_QUELLIDMAP30_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_30_QUELLIDMAP30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_31_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_31_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_QUEUE_LLID_MAP_31_RESERVED0_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_31_RESERVED0_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_31_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_QUEUE_LLID_MAP_31_QUELLIDMAP31
 ******************************************************************************/
const ru_field_rec EPN_QUEUE_LLID_MAP_31_QUELLIDMAP31_FIELD =
{
    "QUELLIDMAP31",
#if RU_INCLUDE_DESC
    "",
    "Selects the L2 FIFO to which Queue 31 is mapped.",
#endif
    EPN_QUEUE_LLID_MAP_31_QUELLIDMAP31_FIELD_MASK,
    0,
    EPN_QUEUE_LLID_MAP_31_QUELLIDMAP31_FIELD_WIDTH,
    EPN_QUEUE_LLID_MAP_31_QUELLIDMAP31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT8_UNUSEDTQCNT8
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT8_UNUSEDTQCNT8_FIELD =
{
    "UNUSEDTQCNT8",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 8.",
#endif
    EPN_UNUSED_TQ_CNT8_UNUSEDTQCNT8_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT8_UNUSEDTQCNT8_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT8_UNUSEDTQCNT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT9_UNUSEDTQCNT9
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT9_UNUSEDTQCNT9_FIELD =
{
    "UNUSEDTQCNT9",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 9.",
#endif
    EPN_UNUSED_TQ_CNT9_UNUSEDTQCNT9_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT9_UNUSEDTQCNT9_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT9_UNUSEDTQCNT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT10_UNUSEDTQCNT10
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT10_UNUSEDTQCNT10_FIELD =
{
    "UNUSEDTQCNT10",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 10.",
#endif
    EPN_UNUSED_TQ_CNT10_UNUSEDTQCNT10_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT10_UNUSEDTQCNT10_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT10_UNUSEDTQCNT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT11_UNUSEDTQCNT11
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT11_UNUSEDTQCNT11_FIELD =
{
    "UNUSEDTQCNT11",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 11.",
#endif
    EPN_UNUSED_TQ_CNT11_UNUSEDTQCNT11_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT11_UNUSEDTQCNT11_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT11_UNUSEDTQCNT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT12_UNUSEDTQCNT12
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT12_UNUSEDTQCNT12_FIELD =
{
    "UNUSEDTQCNT12",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 12.",
#endif
    EPN_UNUSED_TQ_CNT12_UNUSEDTQCNT12_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT12_UNUSEDTQCNT12_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT12_UNUSEDTQCNT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT13_UNUSEDTQCNT13
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT13_UNUSEDTQCNT13_FIELD =
{
    "UNUSEDTQCNT13",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 13.",
#endif
    EPN_UNUSED_TQ_CNT13_UNUSEDTQCNT13_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT13_UNUSEDTQCNT13_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT13_UNUSEDTQCNT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT14_UNUSEDTQCNT14
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT14_UNUSEDTQCNT14_FIELD =
{
    "UNUSEDTQCNT14",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 14.",
#endif
    EPN_UNUSED_TQ_CNT14_UNUSEDTQCNT14_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT14_UNUSEDTQCNT14_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT14_UNUSEDTQCNT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT15_UNUSEDTQCNT15
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT15_UNUSEDTQCNT15_FIELD =
{
    "UNUSEDTQCNT15",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 15.",
#endif
    EPN_UNUSED_TQ_CNT15_UNUSEDTQCNT15_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT15_UNUSEDTQCNT15_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT15_UNUSEDTQCNT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT16_UNUSEDTQCNT16
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT16_UNUSEDTQCNT16_FIELD =
{
    "UNUSEDTQCNT16",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 16.",
#endif
    EPN_UNUSED_TQ_CNT16_UNUSEDTQCNT16_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT16_UNUSEDTQCNT16_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT16_UNUSEDTQCNT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT17_UNUSEDTQCNT17
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT17_UNUSEDTQCNT17_FIELD =
{
    "UNUSEDTQCNT17",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 17.",
#endif
    EPN_UNUSED_TQ_CNT17_UNUSEDTQCNT17_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT17_UNUSEDTQCNT17_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT17_UNUSEDTQCNT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT18_UNUSEDTQCNT18
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT18_UNUSEDTQCNT18_FIELD =
{
    "UNUSEDTQCNT18",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 18.",
#endif
    EPN_UNUSED_TQ_CNT18_UNUSEDTQCNT18_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT18_UNUSEDTQCNT18_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT18_UNUSEDTQCNT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT19_UNUSEDTQCNT19
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT19_UNUSEDTQCNT19_FIELD =
{
    "UNUSEDTQCNT19",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 19.",
#endif
    EPN_UNUSED_TQ_CNT19_UNUSEDTQCNT19_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT19_UNUSEDTQCNT19_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT19_UNUSEDTQCNT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT20_UNUSEDTQCNT20
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT20_UNUSEDTQCNT20_FIELD =
{
    "UNUSEDTQCNT20",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 20.",
#endif
    EPN_UNUSED_TQ_CNT20_UNUSEDTQCNT20_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT20_UNUSEDTQCNT20_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT20_UNUSEDTQCNT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT21_UNUSEDTQCNT21
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT21_UNUSEDTQCNT21_FIELD =
{
    "UNUSEDTQCNT21",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 21.",
#endif
    EPN_UNUSED_TQ_CNT21_UNUSEDTQCNT21_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT21_UNUSEDTQCNT21_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT21_UNUSEDTQCNT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT22_UNUSEDTQCNT22
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT22_UNUSEDTQCNT22_FIELD =
{
    "UNUSEDTQCNT22",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 22.",
#endif
    EPN_UNUSED_TQ_CNT22_UNUSEDTQCNT22_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT22_UNUSEDTQCNT22_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT22_UNUSEDTQCNT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT23_UNUSEDTQCNT23
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT23_UNUSEDTQCNT23_FIELD =
{
    "UNUSEDTQCNT23",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 23.",
#endif
    EPN_UNUSED_TQ_CNT23_UNUSEDTQCNT23_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT23_UNUSEDTQCNT23_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT23_UNUSEDTQCNT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT24_UNUSEDTQCNT24
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT24_UNUSEDTQCNT24_FIELD =
{
    "UNUSEDTQCNT24",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 24.",
#endif
    EPN_UNUSED_TQ_CNT24_UNUSEDTQCNT24_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT24_UNUSEDTQCNT24_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT24_UNUSEDTQCNT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT25_UNUSEDTQCNT25
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT25_UNUSEDTQCNT25_FIELD =
{
    "UNUSEDTQCNT25",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 25.",
#endif
    EPN_UNUSED_TQ_CNT25_UNUSEDTQCNT25_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT25_UNUSEDTQCNT25_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT25_UNUSEDTQCNT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT26_UNUSEDTQCNT26
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT26_UNUSEDTQCNT26_FIELD =
{
    "UNUSEDTQCNT26",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 26.",
#endif
    EPN_UNUSED_TQ_CNT26_UNUSEDTQCNT26_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT26_UNUSEDTQCNT26_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT26_UNUSEDTQCNT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT27_UNUSEDTQCNT27
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT27_UNUSEDTQCNT27_FIELD =
{
    "UNUSEDTQCNT27",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 27.",
#endif
    EPN_UNUSED_TQ_CNT27_UNUSEDTQCNT27_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT27_UNUSEDTQCNT27_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT27_UNUSEDTQCNT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT28_UNUSEDTQCNT28
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT28_UNUSEDTQCNT28_FIELD =
{
    "UNUSEDTQCNT28",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 28.",
#endif
    EPN_UNUSED_TQ_CNT28_UNUSEDTQCNT28_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT28_UNUSEDTQCNT28_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT28_UNUSEDTQCNT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT29_UNUSEDTQCNT29
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT29_UNUSEDTQCNT29_FIELD =
{
    "UNUSEDTQCNT29",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 29.",
#endif
    EPN_UNUSED_TQ_CNT29_UNUSEDTQCNT29_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT29_UNUSEDTQCNT29_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT29_UNUSEDTQCNT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT30_UNUSEDTQCNT30
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT30_UNUSEDTQCNT30_FIELD =
{
    "UNUSEDTQCNT30",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 30.",
#endif
    EPN_UNUSED_TQ_CNT30_UNUSEDTQCNT30_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT30_UNUSEDTQCNT30_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT30_UNUSEDTQCNT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_UNUSED_TQ_CNT31_UNUSEDTQCNT31
 ******************************************************************************/
const ru_field_rec EPN_UNUSED_TQ_CNT31_UNUSEDTQCNT31_FIELD =
{
    "UNUSEDTQCNT31",
#if RU_INCLUDE_DESC
    "",
    "The number of unused time quanta for LLID 31.",
#endif
    EPN_UNUSED_TQ_CNT31_UNUSEDTQCNT31_FIELD_MASK,
    0,
    EPN_UNUSED_TQ_CNT31_UNUSEDTQCNT31_FIELD_WIDTH,
    EPN_UNUSED_TQ_CNT31_UNUSEDTQCNT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_8_CFGSHPMASK8
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_8_CFGSHPMASK8_FIELD =
{
    "CFGSHPMASK8",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 8 on"
    "the respective queue"
    "0: Shaper 8 can affect this queue"
    "1: Shaper 8 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_8_CFGSHPMASK8_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_8_CFGSHPMASK8_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_8_CFGSHPMASK8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_9_CFGSHPMASK9
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_9_CFGSHPMASK9_FIELD =
{
    "CFGSHPMASK9",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 9 on"
    "the respective queue"
    "0: Shaper 9 can affect this queue"
    "1: Shaper 9 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_9_CFGSHPMASK9_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_9_CFGSHPMASK9_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_9_CFGSHPMASK9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_10_CFGSHPMASK10
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_10_CFGSHPMASK10_FIELD =
{
    "CFGSHPMASK10",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 10 on"
    "the respective queue"
    "0: Shaper 10 can affect this queue"
    "1: Shaper 10 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_10_CFGSHPMASK10_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_10_CFGSHPMASK10_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_10_CFGSHPMASK10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_11_CFGSHPMASK11
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_11_CFGSHPMASK11_FIELD =
{
    "CFGSHPMASK11",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 11 on"
    "the respective queue"
    "0: Shaper 11 can affect this queue"
    "1: Shaper 11 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_11_CFGSHPMASK11_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_11_CFGSHPMASK11_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_11_CFGSHPMASK11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_12_CFGSHPMASK12
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_12_CFGSHPMASK12_FIELD =
{
    "CFGSHPMASK12",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 12 on"
    "the respective queue"
    "0: Shaper 12 can affect this queue"
    "1: Shaper 12 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_12_CFGSHPMASK12_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_12_CFGSHPMASK12_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_12_CFGSHPMASK12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_13_CFGSHPMASK13
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_13_CFGSHPMASK13_FIELD =
{
    "CFGSHPMASK13",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 13 on"
    "the respective queue"
    "0: Shaper 13 can affect this queue"
    "1: Shaper 13 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_13_CFGSHPMASK13_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_13_CFGSHPMASK13_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_13_CFGSHPMASK13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_14_CFGSHPMASK14
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_14_CFGSHPMASK14_FIELD =
{
    "CFGSHPMASK14",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 14 on"
    "the respective queue"
    "0: Shaper 14 can affect this queue"
    "1: Shaper 14 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_14_CFGSHPMASK14_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_14_CFGSHPMASK14_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_14_CFGSHPMASK14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_15_CFGSHPMASK15
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_15_CFGSHPMASK15_FIELD =
{
    "CFGSHPMASK15",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 15 on"
    "the respective queue"
    "0: Shaper 15 can affect this queue"
    "1: Shaper 15 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_15_CFGSHPMASK15_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_15_CFGSHPMASK15_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_15_CFGSHPMASK15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_16_CFGSHPMASK16
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_16_CFGSHPMASK16_FIELD =
{
    "CFGSHPMASK16",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 16 on"
    "the respective queue"
    "0: Shaper 16 can affect this queue"
    "1: Shaper 16 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_16_CFGSHPMASK16_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_16_CFGSHPMASK16_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_16_CFGSHPMASK16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_17_CFGSHPMASK17
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_17_CFGSHPMASK17_FIELD =
{
    "CFGSHPMASK17",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 17 on"
    "the respective queue"
    "0: Shaper 17 can affect this queue"
    "1: Shaper 17 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_17_CFGSHPMASK17_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_17_CFGSHPMASK17_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_17_CFGSHPMASK17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_18_CFGSHPMASK18
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_18_CFGSHPMASK18_FIELD =
{
    "CFGSHPMASK18",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 18 on"
    "the respective queue"
    "0: Shaper 18 can affect this queue"
    "1: Shaper 18 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_18_CFGSHPMASK18_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_18_CFGSHPMASK18_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_18_CFGSHPMASK18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_19_CFGSHPMASK19
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_19_CFGSHPMASK19_FIELD =
{
    "CFGSHPMASK19",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 19 on"
    "the respective queue"
    "0: Shaper 19 can affect this queue"
    "1: Shaper 19 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_19_CFGSHPMASK19_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_19_CFGSHPMASK19_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_19_CFGSHPMASK19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_20_CFGSHPMASK20
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_20_CFGSHPMASK20_FIELD =
{
    "CFGSHPMASK20",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 20 on"
    "the respective queue"
    "0: Shaper 20 can affect this queue"
    "1: Shaper 20 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_20_CFGSHPMASK20_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_20_CFGSHPMASK20_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_20_CFGSHPMASK20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_21_CFGSHPMASK21
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_21_CFGSHPMASK21_FIELD =
{
    "CFGSHPMASK21",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 21 on"
    "the respective queue"
    "0: Shaper 21 can affect this queue"
    "1: Shaper 21 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_21_CFGSHPMASK21_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_21_CFGSHPMASK21_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_21_CFGSHPMASK21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_22_CFGSHPMASK22
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_22_CFGSHPMASK22_FIELD =
{
    "CFGSHPMASK22",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 22 on"
    "the respective queue"
    "0: Shaper 22 can affect this queue"
    "1: Shaper 22 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_22_CFGSHPMASK22_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_22_CFGSHPMASK22_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_22_CFGSHPMASK22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_23_CFGSHPMASK23
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_23_CFGSHPMASK23_FIELD =
{
    "CFGSHPMASK23",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 23 on"
    "the respective queue"
    "0: Shaper 23 can affect this queue"
    "1: Shaper 23 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_23_CFGSHPMASK23_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_23_CFGSHPMASK23_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_23_CFGSHPMASK23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_24_CFGSHPMASK24
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_24_CFGSHPMASK24_FIELD =
{
    "CFGSHPMASK24",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 24 on"
    "the respective queue"
    "0: Shaper 24 can affect this queue"
    "1: Shaper 24 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_24_CFGSHPMASK24_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_24_CFGSHPMASK24_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_24_CFGSHPMASK24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_25_CFGSHPMASK25
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_25_CFGSHPMASK25_FIELD =
{
    "CFGSHPMASK25",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 25 on"
    "the respective queue"
    "0: Shaper 25 can affect this queue"
    "1: Shaper 25 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_25_CFGSHPMASK25_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_25_CFGSHPMASK25_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_25_CFGSHPMASK25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_26_CFGSHPMASK26
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_26_CFGSHPMASK26_FIELD =
{
    "CFGSHPMASK26",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 26 on"
    "the respective queue"
    "0: Shaper 26 can affect this queue"
    "1: Shaper 26 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_26_CFGSHPMASK26_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_26_CFGSHPMASK26_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_26_CFGSHPMASK26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_27_CFGSHPMASK27
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_27_CFGSHPMASK27_FIELD =
{
    "CFGSHPMASK27",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 27 on"
    "the respective queue"
    "0: Shaper 27 can affect this queue"
    "1: Shaper 27 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_27_CFGSHPMASK27_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_27_CFGSHPMASK27_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_27_CFGSHPMASK27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_28_CFGSHPMASK28
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_28_CFGSHPMASK28_FIELD =
{
    "CFGSHPMASK28",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 28 on"
    "the respective queue"
    "0: Shaper 28 can affect this queue"
    "1: Shaper 28 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_28_CFGSHPMASK28_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_28_CFGSHPMASK28_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_28_CFGSHPMASK28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_29_CFGSHPMASK29
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_29_CFGSHPMASK29_FIELD =
{
    "CFGSHPMASK29",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 29 on"
    "the respective queue"
    "0: Shaper 29 can affect this queue"
    "1: Shaper 29 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_29_CFGSHPMASK29_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_29_CFGSHPMASK29_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_29_CFGSHPMASK29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_30_CFGSHPMASK30
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_30_CFGSHPMASK30_FIELD =
{
    "CFGSHPMASK30",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 30 on"
    "the respective queue"
    "0: Shaper 30 can affect this queue"
    "1: Shaper 30 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_30_CFGSHPMASK30_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_30_CFGSHPMASK30_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_30_CFGSHPMASK30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L1S_SHP_QUE_MASK_31_CFGSHPMASK31
 ******************************************************************************/
const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_31_CFGSHPMASK31_FIELD =
{
    "CFGSHPMASK31",
#if RU_INCLUDE_DESC
    "",
    "Each mask bit in this register controls the effect of shaper 31 on"
    "the respective queue"
    "0: Shaper 31 can affect this queue"
    "1: Shaper 31 does not affect this queue",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_31_CFGSHPMASK31_FIELD_MASK,
    0,
    EPN_TX_L1S_SHP_QUE_MASK_31_CFGSHPMASK31_FIELD_WIDTH,
    EPN_TX_L1S_SHP_QUE_MASK_31_CFGSHPMASK31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_8_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_8_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_8_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_8_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_8_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUEEND8
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUEEND8_FIELD =
{
    "CFGL2SQUEEND8",
#if RU_INCLUDE_DESC
    "",
    "Queue 8 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUEEND8_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUEEND8_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUEEND8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_8_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_8_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_8_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_8_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_8_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUESTART8
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUESTART8_FIELD =
{
    "CFGL2SQUESTART8",
#if RU_INCLUDE_DESC
    "",
    "Queue 8 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUESTART8_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUESTART8_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUESTART8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_9_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_9_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_9_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_9_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_9_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUEEND9
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUEEND9_FIELD =
{
    "CFGL2SQUEEND9",
#if RU_INCLUDE_DESC
    "",
    "Queue 9 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUEEND9_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUEEND9_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUEEND9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_9_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_9_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_9_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_9_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_9_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUESTART9
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUESTART9_FIELD =
{
    "CFGL2SQUESTART9",
#if RU_INCLUDE_DESC
    "",
    "Queue 9 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUESTART9_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUESTART9_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUESTART9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_10_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_10_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_10_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_10_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_10_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUEEND10
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUEEND10_FIELD =
{
    "CFGL2SQUEEND10",
#if RU_INCLUDE_DESC
    "",
    "Queue 10 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUEEND10_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUEEND10_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUEEND10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_10_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_10_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_10_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_10_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_10_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUESTART10
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUESTART10_FIELD =
{
    "CFGL2SQUESTART10",
#if RU_INCLUDE_DESC
    "",
    "Queue 10 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUESTART10_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUESTART10_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUESTART10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_11_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_11_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_11_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_11_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_11_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUEEND11
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUEEND11_FIELD =
{
    "CFGL2SQUEEND11",
#if RU_INCLUDE_DESC
    "",
    "Queue 11 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUEEND11_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUEEND11_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUEEND11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_11_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_11_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_11_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_11_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_11_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUESTART11
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUESTART11_FIELD =
{
    "CFGL2SQUESTART11",
#if RU_INCLUDE_DESC
    "",
    "Queue 11 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUESTART11_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUESTART11_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUESTART11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_12_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_12_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_12_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_12_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_12_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUEEND12
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUEEND12_FIELD =
{
    "CFGL2SQUEEND12",
#if RU_INCLUDE_DESC
    "",
    "Queue 12 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUEEND12_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUEEND12_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUEEND12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_12_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_12_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_12_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_12_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_12_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUESTART12
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUESTART12_FIELD =
{
    "CFGL2SQUESTART12",
#if RU_INCLUDE_DESC
    "",
    "Queue 12 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUESTART12_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUESTART12_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUESTART12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_13_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_13_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_13_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_13_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_13_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUEEND13
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUEEND13_FIELD =
{
    "CFGL2SQUEEND13",
#if RU_INCLUDE_DESC
    "",
    "Queue 13 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUEEND13_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUEEND13_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUEEND13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_13_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_13_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_13_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_13_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_13_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUESTART13
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUESTART13_FIELD =
{
    "CFGL2SQUESTART13",
#if RU_INCLUDE_DESC
    "",
    "Queue 13 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUESTART13_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUESTART13_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUESTART13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_14_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_14_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_14_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_14_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_14_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUEEND14
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUEEND14_FIELD =
{
    "CFGL2SQUEEND14",
#if RU_INCLUDE_DESC
    "",
    "Queue 14 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUEEND14_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUEEND14_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUEEND14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_14_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_14_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_14_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_14_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_14_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUESTART14
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUESTART14_FIELD =
{
    "CFGL2SQUESTART14",
#if RU_INCLUDE_DESC
    "",
    "Queue 14 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUESTART14_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUESTART14_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUESTART14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_15_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_15_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_15_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_15_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_15_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUEEND15
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUEEND15_FIELD =
{
    "CFGL2SQUEEND15",
#if RU_INCLUDE_DESC
    "",
    "Queue 15 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUEEND15_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUEEND15_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUEEND15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_15_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_15_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_15_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_15_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_15_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUESTART15
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUESTART15_FIELD =
{
    "CFGL2SQUESTART15",
#if RU_INCLUDE_DESC
    "",
    "Queue 15 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUESTART15_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUESTART15_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUESTART15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_16_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_16_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_16_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_16_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_16_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUEEND16
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUEEND16_FIELD =
{
    "CFGL2SQUEEND16",
#if RU_INCLUDE_DESC
    "",
    "Queue 16 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUEEND16_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUEEND16_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUEEND16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_16_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_16_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_16_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_16_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_16_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUESTART16
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUESTART16_FIELD =
{
    "CFGL2SQUESTART16",
#if RU_INCLUDE_DESC
    "",
    "Queue 16 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUESTART16_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUESTART16_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUESTART16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_17_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_17_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_17_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_17_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_17_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUEEND17
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUEEND17_FIELD =
{
    "CFGL2SQUEEND17",
#if RU_INCLUDE_DESC
    "",
    "Queue 17 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUEEND17_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUEEND17_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUEEND17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_17_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_17_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_17_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_17_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_17_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUESTART17
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUESTART17_FIELD =
{
    "CFGL2SQUESTART17",
#if RU_INCLUDE_DESC
    "",
    "Queue 17 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUESTART17_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUESTART17_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUESTART17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_18_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_18_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_18_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_18_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_18_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUEEND18
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUEEND18_FIELD =
{
    "CFGL2SQUEEND18",
#if RU_INCLUDE_DESC
    "",
    "Queue 18 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUEEND18_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUEEND18_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUEEND18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_18_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_18_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_18_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_18_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_18_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUESTART18
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUESTART18_FIELD =
{
    "CFGL2SQUESTART18",
#if RU_INCLUDE_DESC
    "",
    "Queue 18 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUESTART18_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUESTART18_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUESTART18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_19_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_19_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_19_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_19_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_19_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUEEND19
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUEEND19_FIELD =
{
    "CFGL2SQUEEND19",
#if RU_INCLUDE_DESC
    "",
    "Queue 19 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUEEND19_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUEEND19_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUEEND19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_19_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_19_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_19_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_19_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_19_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUESTART19
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUESTART19_FIELD =
{
    "CFGL2SQUESTART19",
#if RU_INCLUDE_DESC
    "",
    "Queue 19 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUESTART19_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUESTART19_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUESTART19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_20_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_20_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_20_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_20_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_20_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUEEND20
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUEEND20_FIELD =
{
    "CFGL2SQUEEND20",
#if RU_INCLUDE_DESC
    "",
    "Queue 20 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUEEND20_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUEEND20_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUEEND20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_20_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_20_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_20_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_20_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_20_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUESTART20
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUESTART20_FIELD =
{
    "CFGL2SQUESTART20",
#if RU_INCLUDE_DESC
    "",
    "Queue 20 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUESTART20_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUESTART20_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUESTART20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_21_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_21_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_21_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_21_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_21_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUEEND21
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUEEND21_FIELD =
{
    "CFGL2SQUEEND21",
#if RU_INCLUDE_DESC
    "",
    "Queue 21 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUEEND21_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUEEND21_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUEEND21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_21_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_21_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_21_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_21_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_21_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUESTART21
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUESTART21_FIELD =
{
    "CFGL2SQUESTART21",
#if RU_INCLUDE_DESC
    "",
    "Queue 21 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUESTART21_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUESTART21_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUESTART21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_22_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_22_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_22_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_22_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_22_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUEEND22
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUEEND22_FIELD =
{
    "CFGL2SQUEEND22",
#if RU_INCLUDE_DESC
    "",
    "Queue 22 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUEEND22_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUEEND22_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUEEND22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_22_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_22_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_22_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_22_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_22_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUESTART22
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUESTART22_FIELD =
{
    "CFGL2SQUESTART22",
#if RU_INCLUDE_DESC
    "",
    "Queue 22 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUESTART22_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUESTART22_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUESTART22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_23_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_23_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_23_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_23_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_23_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUEEND23
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUEEND23_FIELD =
{
    "CFGL2SQUEEND23",
#if RU_INCLUDE_DESC
    "",
    "Queue 23 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUEEND23_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUEEND23_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUEEND23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_23_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_23_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_23_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_23_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_23_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUESTART23
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUESTART23_FIELD =
{
    "CFGL2SQUESTART23",
#if RU_INCLUDE_DESC
    "",
    "Queue 23 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUESTART23_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUESTART23_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUESTART23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_24_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_24_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_24_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_24_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_24_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUEEND24
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUEEND24_FIELD =
{
    "CFGL2SQUEEND24",
#if RU_INCLUDE_DESC
    "",
    "Queue 24 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUEEND24_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUEEND24_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUEEND24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_24_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_24_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_24_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_24_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_24_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUESTART24
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUESTART24_FIELD =
{
    "CFGL2SQUESTART24",
#if RU_INCLUDE_DESC
    "",
    "Queue 24 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUESTART24_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUESTART24_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUESTART24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_25_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_25_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_25_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_25_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_25_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUEEND25
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUEEND25_FIELD =
{
    "CFGL2SQUEEND25",
#if RU_INCLUDE_DESC
    "",
    "Queue 25 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUEEND25_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUEEND25_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUEEND25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_25_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_25_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_25_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_25_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_25_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUESTART25
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUESTART25_FIELD =
{
    "CFGL2SQUESTART25",
#if RU_INCLUDE_DESC
    "",
    "Queue 25 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUESTART25_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUESTART25_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUESTART25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_26_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_26_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_26_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_26_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_26_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUEEND26
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUEEND26_FIELD =
{
    "CFGL2SQUEEND26",
#if RU_INCLUDE_DESC
    "",
    "Queue 26 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUEEND26_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUEEND26_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUEEND26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_26_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_26_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_26_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_26_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_26_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUESTART26
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUESTART26_FIELD =
{
    "CFGL2SQUESTART26",
#if RU_INCLUDE_DESC
    "",
    "Queue 26 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUESTART26_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUESTART26_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUESTART26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_27_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_27_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_27_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_27_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_27_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUEEND27
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUEEND27_FIELD =
{
    "CFGL2SQUEEND27",
#if RU_INCLUDE_DESC
    "",
    "Queue 27 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUEEND27_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUEEND27_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUEEND27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_27_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_27_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_27_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_27_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_27_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUESTART27
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUESTART27_FIELD =
{
    "CFGL2SQUESTART27",
#if RU_INCLUDE_DESC
    "",
    "Queue 27 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUESTART27_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUESTART27_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUESTART27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_28_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_28_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_28_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_28_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_28_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUEEND28
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUEEND28_FIELD =
{
    "CFGL2SQUEEND28",
#if RU_INCLUDE_DESC
    "",
    "Queue 28 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUEEND28_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUEEND28_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUEEND28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_28_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_28_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_28_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_28_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_28_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUESTART28
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUESTART28_FIELD =
{
    "CFGL2SQUESTART28",
#if RU_INCLUDE_DESC
    "",
    "Queue 28 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUESTART28_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUESTART28_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUESTART28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_29_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_29_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_29_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_29_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_29_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUEEND29
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUEEND29_FIELD =
{
    "CFGL2SQUEEND29",
#if RU_INCLUDE_DESC
    "",
    "Queue 29 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUEEND29_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUEEND29_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUEEND29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_29_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_29_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_29_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_29_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_29_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUESTART29
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUESTART29_FIELD =
{
    "CFGL2SQUESTART29",
#if RU_INCLUDE_DESC
    "",
    "Queue 29 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUESTART29_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUESTART29_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUESTART29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_30_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_30_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_30_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_30_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_30_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUEEND30
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUEEND30_FIELD =
{
    "CFGL2SQUEEND30",
#if RU_INCLUDE_DESC
    "",
    "Queue 30 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUEEND30_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUEEND30_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUEEND30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_30_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_30_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_30_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_30_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_30_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUESTART30
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUESTART30_FIELD =
{
    "CFGL2SQUESTART30",
#if RU_INCLUDE_DESC
    "",
    "Queue 30 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUESTART30_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUESTART30_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUESTART30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_31_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_31_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_31_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_31_RESERVED0_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_31_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUEEND31
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUEEND31_FIELD =
{
    "CFGL2SQUEEND31",
#if RU_INCLUDE_DESC
    "",
    "Queue 31 End address",
#endif
    EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUEEND31_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUEEND31_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUEEND31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_31_RESERVED1
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_31_RESERVED1_FIELD =
{
    "RESERVED1",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_L2S_QUE_CONFIG_31_RESERVED1_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_31_RESERVED1_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_31_RESERVED1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUESTART31
 ******************************************************************************/
const ru_field_rec EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUESTART31_FIELD =
{
    "CFGL2SQUESTART31",
#if RU_INCLUDE_DESC
    "",
    "Queue 31 Start address",
#endif
    EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUESTART31_FIELD_MASK,
    0,
    EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUESTART31_FIELD_WIDTH,
    EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUESTART31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_8_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_8_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_8_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_8_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_8_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_8_PRVBURSTLIMIT8
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_8_PRVBURSTLIMIT8_FIELD =
{
    "PRVBURSTLIMIT8",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 8 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_8_PRVBURSTLIMIT8_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_8_PRVBURSTLIMIT8_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_8_PRVBURSTLIMIT8_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_9_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_9_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_9_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_9_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_9_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_9_PRVBURSTLIMIT9
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_9_PRVBURSTLIMIT9_FIELD =
{
    "PRVBURSTLIMIT9",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 9 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_9_PRVBURSTLIMIT9_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_9_PRVBURSTLIMIT9_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_9_PRVBURSTLIMIT9_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_10_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_10_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_10_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_10_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_10_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_10_PRVBURSTLIMIT10
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_10_PRVBURSTLIMIT10_FIELD =
{
    "PRVBURSTLIMIT10",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 10 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_10_PRVBURSTLIMIT10_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_10_PRVBURSTLIMIT10_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_10_PRVBURSTLIMIT10_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_11_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_11_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_11_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_11_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_11_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_11_PRVBURSTLIMIT11
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_11_PRVBURSTLIMIT11_FIELD =
{
    "PRVBURSTLIMIT11",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 11 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_11_PRVBURSTLIMIT11_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_11_PRVBURSTLIMIT11_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_11_PRVBURSTLIMIT11_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_12_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_12_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_12_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_12_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_12_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_12_PRVBURSTLIMIT12
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_12_PRVBURSTLIMIT12_FIELD =
{
    "PRVBURSTLIMIT12",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 12 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_12_PRVBURSTLIMIT12_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_12_PRVBURSTLIMIT12_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_12_PRVBURSTLIMIT12_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_13_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_13_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_13_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_13_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_13_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_13_PRVBURSTLIMIT13
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_13_PRVBURSTLIMIT13_FIELD =
{
    "PRVBURSTLIMIT13",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 13 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_13_PRVBURSTLIMIT13_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_13_PRVBURSTLIMIT13_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_13_PRVBURSTLIMIT13_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_14_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_14_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_14_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_14_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_14_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_14_PRVBURSTLIMIT14
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_14_PRVBURSTLIMIT14_FIELD =
{
    "PRVBURSTLIMIT14",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 14 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_14_PRVBURSTLIMIT14_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_14_PRVBURSTLIMIT14_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_14_PRVBURSTLIMIT14_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_15_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_15_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_15_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_15_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_15_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_15_PRVBURSTLIMIT15
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_15_PRVBURSTLIMIT15_FIELD =
{
    "PRVBURSTLIMIT15",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 15 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_15_PRVBURSTLIMIT15_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_15_PRVBURSTLIMIT15_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_15_PRVBURSTLIMIT15_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_16_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_16_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_16_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_16_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_16_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_16_PRVBURSTLIMIT16
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_16_PRVBURSTLIMIT16_FIELD =
{
    "PRVBURSTLIMIT16",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 16 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_16_PRVBURSTLIMIT16_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_16_PRVBURSTLIMIT16_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_16_PRVBURSTLIMIT16_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_17_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_17_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_17_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_17_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_17_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_17_PRVBURSTLIMIT17
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_17_PRVBURSTLIMIT17_FIELD =
{
    "PRVBURSTLIMIT17",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 17 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_17_PRVBURSTLIMIT17_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_17_PRVBURSTLIMIT17_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_17_PRVBURSTLIMIT17_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_18_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_18_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_18_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_18_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_18_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_18_PRVBURSTLIMIT18
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_18_PRVBURSTLIMIT18_FIELD =
{
    "PRVBURSTLIMIT18",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 18 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_18_PRVBURSTLIMIT18_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_18_PRVBURSTLIMIT18_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_18_PRVBURSTLIMIT18_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_19_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_19_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_19_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_19_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_19_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_19_PRVBURSTLIMIT19
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_19_PRVBURSTLIMIT19_FIELD =
{
    "PRVBURSTLIMIT19",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 19 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_19_PRVBURSTLIMIT19_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_19_PRVBURSTLIMIT19_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_19_PRVBURSTLIMIT19_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_20_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_20_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_20_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_20_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_20_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_20_PRVBURSTLIMIT20
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_20_PRVBURSTLIMIT20_FIELD =
{
    "PRVBURSTLIMIT20",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 20 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_20_PRVBURSTLIMIT20_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_20_PRVBURSTLIMIT20_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_20_PRVBURSTLIMIT20_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_21_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_21_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_21_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_21_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_21_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_21_PRVBURSTLIMIT21
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_21_PRVBURSTLIMIT21_FIELD =
{
    "PRVBURSTLIMIT21",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 21 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_21_PRVBURSTLIMIT21_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_21_PRVBURSTLIMIT21_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_21_PRVBURSTLIMIT21_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_22_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_22_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_22_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_22_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_22_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_22_PRVBURSTLIMIT22
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_22_PRVBURSTLIMIT22_FIELD =
{
    "PRVBURSTLIMIT22",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 22 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_22_PRVBURSTLIMIT22_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_22_PRVBURSTLIMIT22_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_22_PRVBURSTLIMIT22_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_23_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_23_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_23_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_23_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_23_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_23_PRVBURSTLIMIT23
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_23_PRVBURSTLIMIT23_FIELD =
{
    "PRVBURSTLIMIT23",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 23 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_23_PRVBURSTLIMIT23_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_23_PRVBURSTLIMIT23_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_23_PRVBURSTLIMIT23_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_24_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_24_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_24_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_24_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_24_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_24_PRVBURSTLIMIT24
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_24_PRVBURSTLIMIT24_FIELD =
{
    "PRVBURSTLIMIT24",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 24 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_24_PRVBURSTLIMIT24_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_24_PRVBURSTLIMIT24_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_24_PRVBURSTLIMIT24_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_25_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_25_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_25_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_25_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_25_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_25_PRVBURSTLIMIT25
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_25_PRVBURSTLIMIT25_FIELD =
{
    "PRVBURSTLIMIT25",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 25 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_25_PRVBURSTLIMIT25_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_25_PRVBURSTLIMIT25_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_25_PRVBURSTLIMIT25_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_26_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_26_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_26_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_26_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_26_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_26_PRVBURSTLIMIT26
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_26_PRVBURSTLIMIT26_FIELD =
{
    "PRVBURSTLIMIT26",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 26 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_26_PRVBURSTLIMIT26_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_26_PRVBURSTLIMIT26_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_26_PRVBURSTLIMIT26_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_27_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_27_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_27_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_27_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_27_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_27_PRVBURSTLIMIT27
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_27_PRVBURSTLIMIT27_FIELD =
{
    "PRVBURSTLIMIT27",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 27 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_27_PRVBURSTLIMIT27_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_27_PRVBURSTLIMIT27_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_27_PRVBURSTLIMIT27_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_28_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_28_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_28_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_28_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_28_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_28_PRVBURSTLIMIT28
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_28_PRVBURSTLIMIT28_FIELD =
{
    "PRVBURSTLIMIT28",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 28 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_28_PRVBURSTLIMIT28_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_28_PRVBURSTLIMIT28_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_28_PRVBURSTLIMIT28_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_29_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_29_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_29_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_29_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_29_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_29_PRVBURSTLIMIT29
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_29_PRVBURSTLIMIT29_FIELD =
{
    "PRVBURSTLIMIT29",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 29 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_29_PRVBURSTLIMIT29_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_29_PRVBURSTLIMIT29_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_29_PRVBURSTLIMIT29_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_30_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_30_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_30_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_30_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_30_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_30_PRVBURSTLIMIT30
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_30_PRVBURSTLIMIT30_FIELD =
{
    "PRVBURSTLIMIT30",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 30 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_30_PRVBURSTLIMIT30_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_30_PRVBURSTLIMIT30_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_30_PRVBURSTLIMIT30_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_31_RESERVED0
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_31_RESERVED0_FIELD =
{
    "RESERVED0",
#if RU_INCLUDE_DESC
    "",
    "",
#endif
    EPN_TX_CTC_BURST_LIMIT_31_RESERVED0_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_31_RESERVED0_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_31_RESERVED0_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_TX_CTC_BURST_LIMIT_31_PRVBURSTLIMIT31
 ******************************************************************************/
const ru_field_rec EPN_TX_CTC_BURST_LIMIT_31_PRVBURSTLIMIT31_FIELD =
{
    "PRVBURSTLIMIT31",
#if RU_INCLUDE_DESC
    "",
    "L2 queue 31 CTC mode burst limit",
#endif
    EPN_TX_CTC_BURST_LIMIT_31_PRVBURSTLIMIT31_FIELD_MASK,
    0,
    EPN_TX_CTC_BURST_LIMIT_31_PRVBURSTLIMIT31_FIELD_WIDTH,
    EPN_TX_CTC_BURST_LIMIT_31_PRVBURSTLIMIT31_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_2_FIELD =
{
    "CFGADDBURSTCAP0_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 0 queue set 2 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap0 + cfgAddBurstCap0_1 + cfgAddBurstCap0_2 +"
    "cfgAddBurstCap0_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_1_FIELD =
{
    "CFGADDBURSTCAP0_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 0 queue set 1 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap0 + cfgAddBurstCap0_1 + cfgAddBurstCap0_2 +"
    "cfgAddBurstCap0_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE1_CFGADDBURSTCAP1_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE1_CFGADDBURSTCAP1_1_FIELD =
{
    "CFGADDBURSTCAP1_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 1 queue set 1 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap1 + cfgAddBurstCap1_1 + cfgAddBurstCap1_2 +"
    "cfgAddBurstCap1_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE1_CFGADDBURSTCAP1_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE1_CFGADDBURSTCAP1_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE1_CFGADDBURSTCAP1_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE1_CFGADDBURSTCAP0_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE1_CFGADDBURSTCAP0_3_FIELD =
{
    "CFGADDBURSTCAP0_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 0 queue set 3 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap0 + cfgAddBurstCap0_1 + cfgAddBurstCap0_2 +"
    "cfgAddBurstCap0_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE1_CFGADDBURSTCAP0_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE1_CFGADDBURSTCAP0_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE1_CFGADDBURSTCAP0_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_3_FIELD =
{
    "CFGADDBURSTCAP1_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 1 queue set 3 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap1 + cfgAddBurstCap1_1 + cfgAddBurstCap1_2 +"
    "cfgAddBurstCap1_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_2_FIELD =
{
    "CFGADDBURSTCAP1_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 1 queue set 2 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap1 + cfgAddBurstCap1_1 + cfgAddBurstCap1_2 +"
    "cfgAddBurstCap1_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_2_FIELD =
{
    "CFGADDBURSTCAP2_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 2 queue set 2 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap2 + cfgAddBurstCap2_1 + cfgAddBurstCap2_2 +"
    "cfgAddBurstCap2_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_1_FIELD =
{
    "CFGADDBURSTCAP2_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 2 queue set 1 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap2 + cfgAddBurstCap2_1 + cfgAddBurstCap2_2 +"
    "cfgAddBurstCap2_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE4_CFGADDBURSTCAP3_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE4_CFGADDBURSTCAP3_1_FIELD =
{
    "CFGADDBURSTCAP3_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 3 queue set 1 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap3 + cfgAddBurstCap3_1 + cfgAddBurstCap3_2 +"
    "cfgAddBurstCap3_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE4_CFGADDBURSTCAP3_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE4_CFGADDBURSTCAP3_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE4_CFGADDBURSTCAP3_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE4_CFGADDBURSTCAP2_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE4_CFGADDBURSTCAP2_3_FIELD =
{
    "CFGADDBURSTCAP2_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 2 queue set 3 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap2 + cfgAddBurstCap2_1 + cfgAddBurstCap2_2 +"
    "cfgAddBurstCap2_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE4_CFGADDBURSTCAP2_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE4_CFGADDBURSTCAP2_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE4_CFGADDBURSTCAP2_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_3_FIELD =
{
    "CFGADDBURSTCAP3_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 3 queue set 3 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap3 + cfgAddBurstCap3_1 + cfgAddBurstCap3_2 +"
    "cfgAddBurstCap3_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_2_FIELD =
{
    "CFGADDBURSTCAP3_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 3 queue set 2 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap3 + cfgAddBurstCap3_1 + cfgAddBurstCap3_2 +"
    "cfgAddBurstCap3_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_2_FIELD =
{
    "CFGADDBURSTCAP4_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 4 queue set 2 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap4 + cfgAddBurstCap4_1 + cfgAddBurstCap4_2 +"
    "cfgAddBurstCap4_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_1_FIELD =
{
    "CFGADDBURSTCAP4_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 4 queue set 1 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap4 + cfgAddBurstCap4_1 + cfgAddBurstCap4_2 +"
    "cfgAddBurstCap4_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE7_CFGADDBURSTCAP5_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE7_CFGADDBURSTCAP5_1_FIELD =
{
    "CFGADDBURSTCAP5_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 5 queue set 1 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap5 + cfgAddBurstCap5_1 + cfgAddBurstCap5_2 +"
    "cfgAddBurstCap5_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE7_CFGADDBURSTCAP5_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE7_CFGADDBURSTCAP5_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE7_CFGADDBURSTCAP5_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE7_CFGADDBURSTCAP4_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE7_CFGADDBURSTCAP4_3_FIELD =
{
    "CFGADDBURSTCAP4_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 4 queue set 3 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap4 + cfgAddBurstCap4_1 + cfgAddBurstCap4_2 +"
    "cfgAddBurstCap4_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE7_CFGADDBURSTCAP4_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE7_CFGADDBURSTCAP4_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE7_CFGADDBURSTCAP4_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_3_FIELD =
{
    "CFGADDBURSTCAP5_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 5 queue set 3 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap5 + cfgAddBurstCap5_1 + cfgAddBurstCap5_2 +"
    "cfgAddBurstCap5_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_2_FIELD =
{
    "CFGADDBURSTCAP5_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 5 queue set 2 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap5 + cfgAddBurstCap5_1 + cfgAddBurstCap5_2 +"
    "cfgAddBurstCap5_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_2_FIELD =
{
    "CFGADDBURSTCAP6_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 6 queue set 2 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap6 + cfgAddBurstCap6_1 + cfgAddBurstCap6_2 +"
    "cfgAddBurstCap6_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_1_FIELD =
{
    "CFGADDBURSTCAP6_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 6 queue set 1 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap6 + cfgAddBurstCap6_1 + cfgAddBurstCap6_2 +"
    "cfgAddBurstCap6_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE10_CFGADDBURSTCAP7_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE10_CFGADDBURSTCAP7_1_FIELD =
{
    "CFGADDBURSTCAP7_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 7 queue set 1 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap7 + cfgAddBurstCap7_1 + cfgAddBurstCap7_2 +"
    "cfgAddBurstCap7_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE10_CFGADDBURSTCAP7_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE10_CFGADDBURSTCAP7_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE10_CFGADDBURSTCAP7_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE10_CFGADDBURSTCAP6_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE10_CFGADDBURSTCAP6_3_FIELD =
{
    "CFGADDBURSTCAP6_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 6 queue set 3 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap6 + cfgAddBurstCap6_1 + cfgAddBurstCap6_2 +"
    "cfgAddBurstCap6_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE10_CFGADDBURSTCAP6_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE10_CFGADDBURSTCAP6_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE10_CFGADDBURSTCAP6_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_3_FIELD =
{
    "CFGADDBURSTCAP7_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 7 queue set 3 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap7 + cfgAddBurstCap7_1 + cfgAddBurstCap7_2 +"
    "cfgAddBurstCap7_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_2_FIELD =
{
    "CFGADDBURSTCAP7_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 7 queue set 2 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap7 + cfgAddBurstCap7_1 + cfgAddBurstCap7_2 +"
    "cfgAddBurstCap7_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_2_FIELD =
{
    "CFGADDBURSTCAP8_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 8 queue set 2 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap8 + cfgAddBurstCap8_1 + cfgAddBurstCap8_2 +"
    "cfgAddBurstCap8_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_1_FIELD =
{
    "CFGADDBURSTCAP8_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 8 queue set 1 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap8 + cfgAddBurstCap8_1 + cfgAddBurstCap8_2 +"
    "cfgAddBurstCap8_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE13_CFGADDBURSTCAP9_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE13_CFGADDBURSTCAP9_1_FIELD =
{
    "CFGADDBURSTCAP9_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 9 queue set 1 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap9 + cfgAddBurstCap9_1 + cfgAddBurstCap9_2 +"
    "cfgAddBurstCap9_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE13_CFGADDBURSTCAP9_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE13_CFGADDBURSTCAP9_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE13_CFGADDBURSTCAP9_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE13_CFGADDBURSTCAP8_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE13_CFGADDBURSTCAP8_3_FIELD =
{
    "CFGADDBURSTCAP8_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 8 queue set 3 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap8 + cfgAddBurstCap8_1 + cfgAddBurstCap8_2 +"
    "cfgAddBurstCap8_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE13_CFGADDBURSTCAP8_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE13_CFGADDBURSTCAP8_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE13_CFGADDBURSTCAP8_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_3_FIELD =
{
    "CFGADDBURSTCAP9_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 9 queue set 3 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap9 + cfgAddBurstCap9_1 + cfgAddBurstCap9_2 +"
    "cfgAddBurstCap9_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_2_FIELD =
{
    "CFGADDBURSTCAP9_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 9 queue set 2 should use in 10G"
    "mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap9 + cfgAddBurstCap9_1 + cfgAddBurstCap9_2 +"
    "cfgAddBurstCap9_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_2_FIELD =
{
    "CFGADDBURSTCAP10_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 10 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap10 + cfgAddBurstCap10_1 + cfgAddBurstCap10_2 +"
    "cfgAddBurstCap10_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_1_FIELD =
{
    "CFGADDBURSTCAP10_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 10 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap10 + cfgAddBurstCap10_1 + cfgAddBurstCap10_2 +"
    "cfgAddBurstCap10_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE16_CFGADDBURSTCAP11_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE16_CFGADDBURSTCAP11_1_FIELD =
{
    "CFGADDBURSTCAP11_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 11 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap11 + cfgAddBurstCap11_1 + cfgAddBurstCap11_2 +"
    "cfgAddBurstCap11_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE16_CFGADDBURSTCAP11_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE16_CFGADDBURSTCAP11_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE16_CFGADDBURSTCAP11_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE16_CFGADDBURSTCAP10_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE16_CFGADDBURSTCAP10_3_FIELD =
{
    "CFGADDBURSTCAP10_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 10 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap10 + cfgAddBurstCap10_1 + cfgAddBurstCap10_2 +"
    "cfgAddBurstCap10_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE16_CFGADDBURSTCAP10_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE16_CFGADDBURSTCAP10_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE16_CFGADDBURSTCAP10_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_3_FIELD =
{
    "CFGADDBURSTCAP11_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 11 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap11 + cfgAddBurstCap11_1 + cfgAddBurstCap11_2 +"
    "cfgAddBurstCap11_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_2_FIELD =
{
    "CFGADDBURSTCAP11_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 11 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap11 + cfgAddBurstCap11_1 + cfgAddBurstCap11_2 +"
    "cfgAddBurstCap11_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_2_FIELD =
{
    "CFGADDBURSTCAP12_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 12 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap12 + cfgAddBurstCap12_1 + cfgAddBurstCap12_2 +"
    "cfgAddBurstCap12_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_1_FIELD =
{
    "CFGADDBURSTCAP12_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 12 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap12 + cfgAddBurstCap12_1 + cfgAddBurstCap12_2 +"
    "cfgAddBurstCap12_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE19_CFGADDBURSTCAP13_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE19_CFGADDBURSTCAP13_1_FIELD =
{
    "CFGADDBURSTCAP13_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 13 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap13 + cfgAddBurstCap13_1 + cfgAddBurstCap13_2 +"
    "cfgAddBurstCap13_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE19_CFGADDBURSTCAP13_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE19_CFGADDBURSTCAP13_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE19_CFGADDBURSTCAP13_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE19_CFGADDBURSTCAP12_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE19_CFGADDBURSTCAP12_3_FIELD =
{
    "CFGADDBURSTCAP12_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 12 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap12 + cfgAddBurstCap12_1 + cfgAddBurstCap12_2 +"
    "cfgAddBurstCap12_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE19_CFGADDBURSTCAP12_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE19_CFGADDBURSTCAP12_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE19_CFGADDBURSTCAP12_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_3_FIELD =
{
    "CFGADDBURSTCAP13_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 13 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap13 + cfgAddBurstCap13_1 + cfgAddBurstCap13_2 +"
    "cfgAddBurstCap13_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_2_FIELD =
{
    "CFGADDBURSTCAP13_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 13 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap13 + cfgAddBurstCap13_1 + cfgAddBurstCap13_2 +"
    "cfgAddBurstCap13_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_2_FIELD =
{
    "CFGADDBURSTCAP14_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 14 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap14 + cfgAddBurstCap14_1 + cfgAddBurstCap14_2 +"
    "cfgAddBurstCap14_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_1_FIELD =
{
    "CFGADDBURSTCAP14_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 14 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap14 + cfgAddBurstCap14_1 + cfgAddBurstCap14_2 +"
    "cfgAddBurstCap14_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE22_CFGADDBURSTCAP15_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE22_CFGADDBURSTCAP15_1_FIELD =
{
    "CFGADDBURSTCAP15_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 15 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap15 + cfgAddBurstCap15_1 + cfgAddBurstCap15_2 +"
    "cfgAddBurstCap15_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE22_CFGADDBURSTCAP15_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE22_CFGADDBURSTCAP15_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE22_CFGADDBURSTCAP15_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE22_CFGADDBURSTCAP14_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE22_CFGADDBURSTCAP14_3_FIELD =
{
    "CFGADDBURSTCAP14_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 14 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap14 + cfgAddBurstCap14_1 + cfgAddBurstCap14_2 +"
    "cfgAddBurstCap14_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE22_CFGADDBURSTCAP14_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE22_CFGADDBURSTCAP14_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE22_CFGADDBURSTCAP14_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_3_FIELD =
{
    "CFGADDBURSTCAP15_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 15 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap15 + cfgAddBurstCap15_1 + cfgAddBurstCap15_2 +"
    "cfgAddBurstCap15_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_2_FIELD =
{
    "CFGADDBURSTCAP15_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 15 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap15 + cfgAddBurstCap15_1 + cfgAddBurstCap15_2 +"
    "cfgAddBurstCap15_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_2_FIELD =
{
    "CFGADDBURSTCAP16_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 16 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap16 + cfgAddBurstCap16_1 + cfgAddBurstCap16_2 +"
    "cfgAddBurstCap16_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_1_FIELD =
{
    "CFGADDBURSTCAP16_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 16 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap16 + cfgAddBurstCap16_1 + cfgAddBurstCap16_2 +"
    "cfgAddBurstCap16_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE25_CFGADDBURSTCAP17_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE25_CFGADDBURSTCAP17_1_FIELD =
{
    "CFGADDBURSTCAP17_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 17 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap17 + cfgAddBurstCap17_1 + cfgAddBurstCap17_2 +"
    "cfgAddBurstCap17_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE25_CFGADDBURSTCAP17_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE25_CFGADDBURSTCAP17_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE25_CFGADDBURSTCAP17_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE25_CFGADDBURSTCAP16_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE25_CFGADDBURSTCAP16_3_FIELD =
{
    "CFGADDBURSTCAP16_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 16 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap16 + cfgAddBurstCap16_1 + cfgAddBurstCap16_2 +"
    "cfgAddBurstCap16_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE25_CFGADDBURSTCAP16_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE25_CFGADDBURSTCAP16_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE25_CFGADDBURSTCAP16_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_3_FIELD =
{
    "CFGADDBURSTCAP17_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 17 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap17 + cfgAddBurstCap17_1 + cfgAddBurstCap17_2 +"
    "cfgAddBurstCap17_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_2_FIELD =
{
    "CFGADDBURSTCAP17_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 17 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap17 + cfgAddBurstCap17_1 + cfgAddBurstCap17_2 +"
    "cfgAddBurstCap17_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_2_FIELD =
{
    "CFGADDBURSTCAP18_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 18 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap18 + cfgAddBurstCap18_1 + cfgAddBurstCap18_2 +"
    "cfgAddBurstCap18_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_1_FIELD =
{
    "CFGADDBURSTCAP18_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 18 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap18 + cfgAddBurstCap18_1 + cfgAddBurstCap18_2 +"
    "cfgAddBurstCap18_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE28_CFGADDBURSTCAP19_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE28_CFGADDBURSTCAP19_1_FIELD =
{
    "CFGADDBURSTCAP19_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 19 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap19 + cfgAddBurstCap19_1 + cfgAddBurstCap19_2 +"
    "cfgAddBurstCap19_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE28_CFGADDBURSTCAP19_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE28_CFGADDBURSTCAP19_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE28_CFGADDBURSTCAP19_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE28_CFGADDBURSTCAP18_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE28_CFGADDBURSTCAP18_3_FIELD =
{
    "CFGADDBURSTCAP18_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 18 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap18 + cfgAddBurstCap18_1 + cfgAddBurstCap18_2 +"
    "cfgAddBurstCap18_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE28_CFGADDBURSTCAP18_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE28_CFGADDBURSTCAP18_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE28_CFGADDBURSTCAP18_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_3_FIELD =
{
    "CFGADDBURSTCAP19_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 19 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap19 + cfgAddBurstCap19_1 + cfgAddBurstCap19_2 +"
    "cfgAddBurstCap19_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_2_FIELD =
{
    "CFGADDBURSTCAP19_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 19 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap19 + cfgAddBurstCap19_1 + cfgAddBurstCap19_2 +"
    "cfgAddBurstCap19_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_2_FIELD =
{
    "CFGADDBURSTCAP20_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 20 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap20 + cfgAddBurstCap20_1 + cfgAddBurstCap20_2 +"
    "cfgAddBurstCap20_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_1_FIELD =
{
    "CFGADDBURSTCAP20_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 20 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap20 + cfgAddBurstCap20_1 + cfgAddBurstCap20_2 +"
    "cfgAddBurstCap20_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE31_CFGADDBURSTCAP21_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE31_CFGADDBURSTCAP21_1_FIELD =
{
    "CFGADDBURSTCAP21_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 21 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap21 + cfgAddBurstCap21_1 + cfgAddBurstCap21_2 +"
    "cfgAddBurstCap21_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE31_CFGADDBURSTCAP21_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE31_CFGADDBURSTCAP21_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE31_CFGADDBURSTCAP21_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE31_CFGADDBURSTCAP20_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE31_CFGADDBURSTCAP20_3_FIELD =
{
    "CFGADDBURSTCAP20_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 20 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap20 + cfgAddBurstCap20_1 + cfgAddBurstCap20_2 +"
    "cfgAddBurstCap20_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE31_CFGADDBURSTCAP20_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE31_CFGADDBURSTCAP20_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE31_CFGADDBURSTCAP20_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_3_FIELD =
{
    "CFGADDBURSTCAP21_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 21 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap21 + cfgAddBurstCap21_1 + cfgAddBurstCap21_2 +"
    "cfgAddBurstCap21_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_2_FIELD =
{
    "CFGADDBURSTCAP21_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 21 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap21 + cfgAddBurstCap21_1 + cfgAddBurstCap21_2 +"
    "cfgAddBurstCap21_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_2_FIELD =
{
    "CFGADDBURSTCAP22_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 22 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap22 + cfgAddBurstCap22_1 + cfgAddBurstCap22_2 +"
    "cfgAddBurstCap22_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_1_FIELD =
{
    "CFGADDBURSTCAP22_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 22 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap22 + cfgAddBurstCap22_1 + cfgAddBurstCap22_2 +"
    "cfgAddBurstCap22_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE34_CFGADDBURSTCAP23_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE34_CFGADDBURSTCAP23_1_FIELD =
{
    "CFGADDBURSTCAP23_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 23 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap23 + cfgAddBurstCap23_1 + cfgAddBurstCap23_2 +"
    "cfgAddBurstCap23_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE34_CFGADDBURSTCAP23_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE34_CFGADDBURSTCAP23_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE34_CFGADDBURSTCAP23_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE34_CFGADDBURSTCAP22_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE34_CFGADDBURSTCAP22_3_FIELD =
{
    "CFGADDBURSTCAP22_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 22 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap22 + cfgAddBurstCap22_1 + cfgAddBurstCap22_2 +"
    "cfgAddBurstCap22_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE34_CFGADDBURSTCAP22_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE34_CFGADDBURSTCAP22_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE34_CFGADDBURSTCAP22_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_3_FIELD =
{
    "CFGADDBURSTCAP23_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 23 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap23 + cfgAddBurstCap23_1 + cfgAddBurstCap23_2 +"
    "cfgAddBurstCap23_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_2_FIELD =
{
    "CFGADDBURSTCAP23_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 23 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap23 + cfgAddBurstCap23_1 + cfgAddBurstCap23_2 +"
    "cfgAddBurstCap23_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_2_FIELD =
{
    "CFGADDBURSTCAP24_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 24 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap24 + cfgAddBurstCap24_1 + cfgAddBurstCap24_2 +"
    "cfgAddBurstCap24_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_1_FIELD =
{
    "CFGADDBURSTCAP24_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 24 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap24 + cfgAddBurstCap24_1 + cfgAddBurstCap24_2 +"
    "cfgAddBurstCap24_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE37_CFGADDBURSTCAP25_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE37_CFGADDBURSTCAP25_1_FIELD =
{
    "CFGADDBURSTCAP25_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 25 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap25 + cfgAddBurstCap25_1 + cfgAddBurstCap25_2 +"
    "cfgAddBurstCap25_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE37_CFGADDBURSTCAP25_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE37_CFGADDBURSTCAP25_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE37_CFGADDBURSTCAP25_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE37_CFGADDBURSTCAP24_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE37_CFGADDBURSTCAP24_3_FIELD =
{
    "CFGADDBURSTCAP24_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 24 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap24 + cfgAddBurstCap24_1 + cfgAddBurstCap24_2 +"
    "cfgAddBurstCap24_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE37_CFGADDBURSTCAP24_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE37_CFGADDBURSTCAP24_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE37_CFGADDBURSTCAP24_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_3_FIELD =
{
    "CFGADDBURSTCAP25_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 25 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap25 + cfgAddBurstCap25_1 + cfgAddBurstCap25_2 +"
    "cfgAddBurstCap25_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_2_FIELD =
{
    "CFGADDBURSTCAP25_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 25 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap25 + cfgAddBurstCap25_1 + cfgAddBurstCap25_2 +"
    "cfgAddBurstCap25_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_2_FIELD =
{
    "CFGADDBURSTCAP26_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 26 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap26 + cfgAddBurstCap26_1 + cfgAddBurstCap26_2 +"
    "cfgAddBurstCap26_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_1_FIELD =
{
    "CFGADDBURSTCAP26_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 26 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap26 + cfgAddBurstCap26_1 + cfgAddBurstCap26_2 +"
    "cfgAddBurstCap26_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE40_CFGADDBURSTCAP27_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE40_CFGADDBURSTCAP27_1_FIELD =
{
    "CFGADDBURSTCAP27_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 27 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap27 + cfgAddBurstCap27_1 + cfgAddBurstCap27_2 +"
    "cfgAddBurstCap27_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE40_CFGADDBURSTCAP27_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE40_CFGADDBURSTCAP27_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE40_CFGADDBURSTCAP27_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE40_CFGADDBURSTCAP26_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE40_CFGADDBURSTCAP26_3_FIELD =
{
    "CFGADDBURSTCAP26_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 26 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap26 + cfgAddBurstCap26_1 + cfgAddBurstCap26_2 +"
    "cfgAddBurstCap26_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE40_CFGADDBURSTCAP26_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE40_CFGADDBURSTCAP26_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE40_CFGADDBURSTCAP26_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_3_FIELD =
{
    "CFGADDBURSTCAP27_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 27 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap27 + cfgAddBurstCap27_1 + cfgAddBurstCap27_2 +"
    "cfgAddBurstCap27_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_2_FIELD =
{
    "CFGADDBURSTCAP27_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 27 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap27 + cfgAddBurstCap27_1 + cfgAddBurstCap27_2 +"
    "cfgAddBurstCap27_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_2_FIELD =
{
    "CFGADDBURSTCAP28_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 28 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap28 + cfgAddBurstCap28_1 + cfgAddBurstCap28_2 +"
    "cfgAddBurstCap28_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_1_FIELD =
{
    "CFGADDBURSTCAP28_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 28 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap28 + cfgAddBurstCap28_1 + cfgAddBurstCap28_2 +"
    "cfgAddBurstCap28_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE43_CFGADDBURSTCAP29_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE43_CFGADDBURSTCAP29_1_FIELD =
{
    "CFGADDBURSTCAP29_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 29 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap29 + cfgAddBurstCap29_1 + cfgAddBurstCap29_2 +"
    "cfgAddBurstCap29_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE43_CFGADDBURSTCAP29_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE43_CFGADDBURSTCAP29_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE43_CFGADDBURSTCAP29_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE43_CFGADDBURSTCAP28_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE43_CFGADDBURSTCAP28_3_FIELD =
{
    "CFGADDBURSTCAP28_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 28 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap28 + cfgAddBurstCap28_1 + cfgAddBurstCap28_2 +"
    "cfgAddBurstCap28_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE43_CFGADDBURSTCAP28_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE43_CFGADDBURSTCAP28_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE43_CFGADDBURSTCAP28_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_3_FIELD =
{
    "CFGADDBURSTCAP29_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 29 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap29 + cfgAddBurstCap29_1 + cfgAddBurstCap29_2 +"
    "cfgAddBurstCap29_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_2_FIELD =
{
    "CFGADDBURSTCAP29_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 29 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap29 + cfgAddBurstCap29_1 + cfgAddBurstCap29_2 +"
    "cfgAddBurstCap29_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_2_FIELD =
{
    "CFGADDBURSTCAP30_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 30 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap30 + cfgAddBurstCap30_1 + cfgAddBurstCap30_2 +"
    "cfgAddBurstCap30_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_1_FIELD =
{
    "CFGADDBURSTCAP30_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 30 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap30 + cfgAddBurstCap30_1 + cfgAddBurstCap30_2 +"
    "cfgAddBurstCap30_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE46_CFGADDBURSTCAP31_1
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE46_CFGADDBURSTCAP31_1_FIELD =
{
    "CFGADDBURSTCAP31_1",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 31 queue set 1 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap31 + cfgAddBurstCap31_1 + cfgAddBurstCap31_2 +"
    "cfgAddBurstCap31_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE46_CFGADDBURSTCAP31_1_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE46_CFGADDBURSTCAP31_1_FIELD_WIDTH,
    EPN_10G_ABC_SIZE46_CFGADDBURSTCAP31_1_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE46_CFGADDBURSTCAP30_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE46_CFGADDBURSTCAP30_3_FIELD =
{
    "CFGADDBURSTCAP30_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 30 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap30 + cfgAddBurstCap30_1 + cfgAddBurstCap30_2 +"
    "cfgAddBurstCap30_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE46_CFGADDBURSTCAP30_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE46_CFGADDBURSTCAP30_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE46_CFGADDBURSTCAP30_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_3
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_3_FIELD =
{
    "CFGADDBURSTCAP31_3",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 31 queue set 3 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap31 + cfgAddBurstCap31_1 + cfgAddBurstCap31_2 +"
    "cfgAddBurstCap31_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_3_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_3_FIELD_WIDTH,
    EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_3_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_2
 ******************************************************************************/
const ru_field_rec EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_2_FIELD =
{
    "CFGADDBURSTCAP31_2",
#if RU_INCLUDE_DESC
    "",
    "How many additional Time Quanta LLID 31 queue set 2 should use in"
    "10G mode."
    "If all three ABC registers are non-zero; this LLID's effective burst"
    "cap will be:"
    "burstCap31 + cfgAddBurstCap31_1 + cfgAddBurstCap31_2 +"
    "cfgAddBurstCap31_3."
    "Units are Time Quanta.",
#endif
    EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_2_FIELD_MASK,
    0,
    EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_2_FIELD_WIDTH,
    EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_2_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: EPN_CONTROL_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_CONTROL_0_FIELDS[] =
{
    &EPN_CONTROL_0_CFGEN1588TS_FIELD,
    &EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD,
    &EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD,
    &EPN_CONTROL_0_CFGDROPSCB_FIELD,
    &EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD,
    &EPN_CONTROL_0_MODMPQUESETFIRST_FIELD,
    &EPN_CONTROL_0_RESERVED0_FIELD,
    &EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD,
    &EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD,
    &EPN_CONTROL_0_RESERVED1_FIELD,
    &EPN_CONTROL_0_PRVINCNONZEROACCUM_FIELD,
    &EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD,
    &EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD,
    &EPN_CONTROL_0_CFGVLANMAX_FIELD,
    &EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD,
    &EPN_CONTROL_0_RESERVED2_FIELD,
    &EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD,
    &EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD,
    &EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD,
    &EPN_CONTROL_0_RPTSELECT_FIELD,
    &EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD,
    &EPN_CONTROL_0_UTXLOOPBACK_FIELD,
    &EPN_CONTROL_0_UTXEN_FIELD,
    &EPN_CONTROL_0_UTXRST_PRE_N_FIELD,
    &EPN_CONTROL_0_CFGDISABLEDNS_FIELD,
    &EPN_CONTROL_0_DRXLOOPBACK_FIELD,
    &EPN_CONTROL_0_DRXEN_FIELD,
    &EPN_CONTROL_0_DRXRST_PRE_N_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_CONTROL_0_REG = 
{
    "CONTROL_0",
#if RU_INCLUDE_DESC
    "EPN_CONTROL_0 Register",
    "This register controls and configures the modules in the EPON block.",
#endif
    EPN_CONTROL_0_REG_OFFSET,
    0,
    0,
    22,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    28,
    EPN_CONTROL_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_CONTROL_1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_CONTROL_1_FIELDS[] =
{
    &EPN_CONTROL_1_RESERVED0_FIELD,
    &EPN_CONTROL_1_CFGIDLEPACKETTXENABLE_FIELD,
    &EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD,
    &EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD,
    &EPN_CONTROL_1_RSTMISALIGNTHR_FIELD,
    &EPN_CONTROL_1_RESERVED1_FIELD,
    &EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD,
    &EPN_CONTROL_1_FECRPTEN_FIELD,
    &EPN_CONTROL_1_RESERVED2_FIELD,
    &EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD,
    &EPN_CONTROL_1_CFGCTCRPT_FIELD,
    &EPN_CONTROL_1_CFGTSCORRDIS_FIELD,
    &EPN_CONTROL_1_CFGNODISCRPT_FIELD,
    &EPN_CONTROL_1_DISABLEDISCSCALE_FIELD,
    &EPN_CONTROL_1_CLRONRD_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_CONTROL_1_REG = 
{
    "CONTROL_1",
#if RU_INCLUDE_DESC
    "EPN_CONTROL_1 Register",
    "This register controls and configures the modules in the EPN block.",
#endif
    EPN_CONTROL_1_REG_OFFSET,
    0,
    0,
    23,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    15,
    EPN_CONTROL_1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_ENABLE_GRANTS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_ENABLE_GRANTS_FIELDS[] =
{
    &EPN_ENABLE_GRANTS_ENGNT31_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT30_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT29_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT28_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT27_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT26_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT25_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT24_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT23_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT22_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT21_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT20_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT19_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT18_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT17_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT16_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT15_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT14_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT13_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT12_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT11_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT10_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT9_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT8_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT7_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT6_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT5_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT4_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT3_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT2_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT1_FIELD,
    &EPN_ENABLE_GRANTS_ENGNT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_ENABLE_GRANTS_REG = 
{
    "ENABLE_GRANTS",
#if RU_INCLUDE_DESC
    "EPN_ENABLE_GRANTS Register",
    "This register allows per-LLID control over whether the EPON MAC accepts"
    "grants from the OLT.",
#endif
    EPN_ENABLE_GRANTS_REG_OFFSET,
    0,
    0,
    24,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_ENABLE_GRANTS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DROP_DISC_GATES
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DROP_DISC_GATES_FIELDS[] =
{
    &EPN_DROP_DISC_GATES_SINKDISCGATES31_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES30_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES29_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES28_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES27_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES26_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES25_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES24_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES23_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES22_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES21_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES20_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES19_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES18_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES17_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES16_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES15_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES14_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES13_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES12_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES11_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES10_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES9_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES8_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD,
    &EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DROP_DISC_GATES_REG = 
{
    "DROP_DISC_GATES",
#if RU_INCLUDE_DESC
    "EPN_DROP_DISC_GATES Register",
    "This register allows per-LLID control over whether the EPON MAC"
    "processes Discovery Gates.",
#endif
    EPN_DROP_DISC_GATES_REG_OFFSET,
    0,
    0,
    25,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_DROP_DISC_GATES_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DIS_FCS_CHK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DIS_FCS_CHK_FIELDS[] =
{
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK31_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK30_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK29_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK28_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK27_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK26_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK25_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK24_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK23_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK22_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK21_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK20_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK19_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK18_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK17_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK16_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK15_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK14_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK13_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK12_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK11_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK10_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK9_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK8_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD,
    &EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DIS_FCS_CHK_REG = 
{
    "DIS_FCS_CHK",
#if RU_INCLUDE_DESC
    "EPN_DIS_FCS_CHK Register",
    "This register allows per-LLID control over Ethernet frame CRC checking"
    "in the EPON downstream block.",
#endif
    EPN_DIS_FCS_CHK_REG_OFFSET,
    0,
    0,
    26,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_DIS_FCS_CHK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_PASS_GATES
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_PASS_GATES_FIELDS[] =
{
    &EPN_PASS_GATES_PASSGATELLID31_FIELD,
    &EPN_PASS_GATES_PASSGATELLID30_FIELD,
    &EPN_PASS_GATES_PASSGATELLID29_FIELD,
    &EPN_PASS_GATES_PASSGATELLID28_FIELD,
    &EPN_PASS_GATES_PASSGATELLID27_FIELD,
    &EPN_PASS_GATES_PASSGATELLID26_FIELD,
    &EPN_PASS_GATES_PASSGATELLID25_FIELD,
    &EPN_PASS_GATES_PASSGATELLID24_FIELD,
    &EPN_PASS_GATES_PASSGATELLID23_FIELD,
    &EPN_PASS_GATES_PASSGATELLID22_FIELD,
    &EPN_PASS_GATES_PASSGATELLID21_FIELD,
    &EPN_PASS_GATES_PASSGATELLID20_FIELD,
    &EPN_PASS_GATES_PASSGATELLID19_FIELD,
    &EPN_PASS_GATES_PASSGATELLID18_FIELD,
    &EPN_PASS_GATES_PASSGATELLID17_FIELD,
    &EPN_PASS_GATES_PASSGATELLID16_FIELD,
    &EPN_PASS_GATES_PASSGATELLID15_FIELD,
    &EPN_PASS_GATES_PASSGATELLID14_FIELD,
    &EPN_PASS_GATES_PASSGATELLID13_FIELD,
    &EPN_PASS_GATES_PASSGATELLID12_FIELD,
    &EPN_PASS_GATES_PASSGATELLID11_FIELD,
    &EPN_PASS_GATES_PASSGATELLID10_FIELD,
    &EPN_PASS_GATES_PASSGATELLID9_FIELD,
    &EPN_PASS_GATES_PASSGATELLID8_FIELD,
    &EPN_PASS_GATES_PASSGATELLID7_FIELD,
    &EPN_PASS_GATES_PASSGATELLID6_FIELD,
    &EPN_PASS_GATES_PASSGATELLID5_FIELD,
    &EPN_PASS_GATES_PASSGATELLID4_FIELD,
    &EPN_PASS_GATES_PASSGATELLID3_FIELD,
    &EPN_PASS_GATES_PASSGATELLID2_FIELD,
    &EPN_PASS_GATES_PASSGATELLID1_FIELD,
    &EPN_PASS_GATES_PASSGATELLID0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_PASS_GATES_REG = 
{
    "PASS_GATES",
#if RU_INCLUDE_DESC
    "EPN_PASS_GATES Register",
    "This register allows per-LLID control over whether the EPON MAC passes"
    "downstream gate frames to the BBH.",
#endif
    EPN_PASS_GATES_REG_OFFSET,
    0,
    0,
    27,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_PASS_GATES_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_CFG_MISALGN_FB
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_CFG_MISALGN_FB_FIELDS[] =
{
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK31_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK30_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK29_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK28_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK27_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK26_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK25_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK24_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK23_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK22_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK21_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK20_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK19_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK18_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK17_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK16_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK15_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK14_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK13_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK12_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK11_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK10_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK9_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK8_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD,
    &EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_CFG_MISALGN_FB_REG = 
{
    "CFG_MISALGN_FB",
#if RU_INCLUDE_DESC
    "EPN_CFG_MISALGN_FB Register",
    "This register allows per-LLID control over grant misalignment checking"
    "and feedback.",
#endif
    EPN_CFG_MISALGN_FB_REG_OFFSET,
    0,
    0,
    28,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_CFG_MISALGN_FB_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DISCOVERY_FILTER
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DISCOVERY_FILTER_FIELDS[] =
{
    &EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD,
    &EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DISCOVERY_FILTER_REG = 
{
    "DISCOVERY_FILTER",
#if RU_INCLUDE_DESC
    "EPN_DISCOVERY_FILTER Register",
    "The 10G Discovery Information field is 16 bits right after the Sync"
    "time in the Disc Gate. The 10G discovery gate filter consistes of two"
    "bit-fields: a 16-bit Disc Info Value and 16-bit Disc Info Mask. For all"
    "bits in Disc Info Value whose corresponding Mask bits are clear (not"
    "masked), the bits in Disc Info Value must exactly match the"
    "corresponding bits in the GATE Discovery Information field. If they"
    "don't match, drop the GATE (nothing is added into the Grant FIFO). If"
    "they match, the Start Time and Length are added to the Grant FIFO.",
#endif
    EPN_DISCOVERY_FILTER_REG_OFFSET,
    0,
    0,
    29,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_DISCOVERY_FILTER_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_MINIMUM_GRANT_SETUP
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_MINIMUM_GRANT_SETUP_FIELDS[] =
{
    &EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD,
    &EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_MINIMUM_GRANT_SETUP_REG = 
{
    "MINIMUM_GRANT_SETUP",
#if RU_INCLUDE_DESC
    "EPN_MINIMUM_GRANT_SETUP Register",
    "The EPN requires a minimum amount of time to process each grant.  This"
    "processing time includes the time for the BBH to fetch a packet and"
    "setup time for the"
    "upstream data to be processed by the LIF/XIF.  It is possible for"
    "backpressure generated by the BBH and LIF/XIF to stall the grant"
    "processing beyond the time required to process the grant."
    "Any grants that are not processed this many TimeQuanta before it Grant"
    "Start Time will be aborted and a grant miss-abort interrupt will be"
    "generated.",
#endif
    EPN_MINIMUM_GRANT_SETUP_REG_OFFSET,
    0,
    0,
    30,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_MINIMUM_GRANT_SETUP_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_RESET_GNT_FIFO
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_RESET_GNT_FIFO_FIELDS[] =
{
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO31_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO30_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO29_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO28_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO27_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO26_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO25_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO24_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO23_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO22_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO21_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO20_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO19_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO18_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO17_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO16_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO15_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO14_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO13_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO12_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO11_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO10_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO9_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO8_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD,
    &EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_RESET_GNT_FIFO_REG = 
{
    "RESET_GNT_FIFO",
#if RU_INCLUDE_DESC
    "EPN_RESET_GNT_FIFO Register",
    "This register allows resetting of the Grant FIFOs on a per-LLID basis.",
#endif
    EPN_RESET_GNT_FIFO_REG_OFFSET,
    0,
    0,
    31,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_RESET_GNT_FIFO_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_RESET_L1_ACCUMULATOR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_RESET_L1_ACCUMULATOR_FIELDS[] =
{
    &EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_RESET_L1_ACCUMULATOR_REG = 
{
    "RESET_L1_ACCUMULATOR",
#if RU_INCLUDE_DESC
    "EPN_RESET_L1_ACCUMULATOR Register",
    "This register allows resetting of the L1 accumulators.",
#endif
    EPN_RESET_L1_ACCUMULATOR_REG_OFFSET,
    0,
    0,
    32,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_RESET_L1_ACCUMULATOR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_L1_ACCUMULATOR_SEL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_L1_ACCUMULATOR_SEL_FIELDS[] =
{
    &EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD,
    &EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD,
    &EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_L1_ACCUMULATOR_SEL_REG = 
{
    "L1_ACCUMULATOR_SEL",
#if RU_INCLUDE_DESC
    "EPN_L1_ACCUMULATOR_SEL Register",
    "This register selects which virtual accumulator sizes are reported.",
#endif
    EPN_L1_ACCUMULATOR_SEL_REG_OFFSET,
    0,
    0,
    33,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    3,
    EPN_L1_ACCUMULATOR_SEL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_L1_SVA_BYTES
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_L1_SVA_BYTES_FIELDS[] =
{
    &EPN_L1_SVA_BYTES_RESERVED0_FIELD,
    &EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_L1_SVA_BYTES_REG = 
{
    "L1_SVA_BYTES",
#if RU_INCLUDE_DESC
    "EPN_L1_SVA_BYTES Register",
    "Signed number of bytes in the selected L1S Shaped Virtual Accumulator",
#endif
    EPN_L1_SVA_BYTES_REG_OFFSET,
    0,
    0,
    34,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_L1_SVA_BYTES_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_L1_UVA_BYTES
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_L1_UVA_BYTES_FIELDS[] =
{
    &EPN_L1_UVA_BYTES_RESERVED0_FIELD,
    &EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_L1_UVA_BYTES_REG = 
{
    "L1_UVA_BYTES",
#if RU_INCLUDE_DESC
    "EPN_L1_UVA_BYTES Register",
    "Signed number of bytes in the selected L1S Un-shaped Virtual"
    "Accumulator",
#endif
    EPN_L1_UVA_BYTES_REG_OFFSET,
    0,
    0,
    35,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_L1_UVA_BYTES_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_L1_SVA_OVERFLOW
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_L1_SVA_OVERFLOW_FIELDS[] =
{
    &EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_L1_SVA_OVERFLOW_REG = 
{
    "L1_SVA_OVERFLOW",
#if RU_INCLUDE_DESC
    "EPN_L1_SVA_OVERFLOW Register",
    "Indicates which SVAs have overflowed",
#endif
    EPN_L1_SVA_OVERFLOW_REG_OFFSET,
    0,
    0,
    36,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_L1_SVA_OVERFLOW_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_L1_UVA_OVERFLOW
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_L1_UVA_OVERFLOW_FIELDS[] =
{
    &EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_L1_UVA_OVERFLOW_REG = 
{
    "L1_UVA_OVERFLOW",
#if RU_INCLUDE_DESC
    "EPN_L1_UVA_OVERFLOW Register",
    "Indicates which UVAs have overflowed",
#endif
    EPN_L1_UVA_OVERFLOW_REG_OFFSET,
    0,
    0,
    37,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_L1_UVA_OVERFLOW_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_RESET_RPT_PRI
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_RESET_RPT_PRI_FIELDS[] =
{
    &EPN_RESET_RPT_PRI_RESERVED0_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD,
    &EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_RESET_RPT_PRI_REG = 
{
    "RESET_RPT_PRI",
#if RU_INCLUDE_DESC
    "EPN_RESET_RPT_PRI Register",
    "This register allows real-time forcing the per-priority report values"
    "to zero. This applies only to multi-priority reporting modes (CTC,"
    "NTT)."
    "Note: These bits are used for debug only.",
#endif
    EPN_RESET_RPT_PRI_REG_OFFSET,
    0,
    0,
    38,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    17,
    EPN_RESET_RPT_PRI_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_RESET_L2_RPT_FIFO
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_RESET_L2_RPT_FIFO_FIELDS[] =
{
    &EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_RESET_L2_RPT_FIFO_REG = 
{
    "RESET_L2_RPT_FIFO",
#if RU_INCLUDE_DESC
    "EPN_RESET_L2_RPT_FIFO Register",
    "This register allows resetting of the L2 Report FIFO pointers. The"
    "corresponding L2 accumulators are also cleared.",
#endif
    EPN_RESET_L2_RPT_FIFO_REG_OFFSET,
    0,
    0,
    39,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_RESET_L2_RPT_FIFO_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_ENABLE_UPSTREAM
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_ENABLE_UPSTREAM_FIELDS[] =
{
    &EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_ENABLE_UPSTREAM_REG = 
{
    "ENABLE_UPSTREAM",
#if RU_INCLUDE_DESC
    "EPN_ENABLE_UPSTREAM Register",
    "This register allows per-LLID enabling of upstream traffic. Disabling"
    "the upstream on a particular LLID Index means that:"
    "1. REPORT frames sent upstream on the LLID Index will report NO"
    "data"
    "2. Grants on the LLID Index will be acted upon (the laser will"
    "turn on and any requested REPORT frame will be sent), but no user"
    "frames will be pulled from FIF and sent upstream.",
#endif
    EPN_ENABLE_UPSTREAM_REG_OFFSET,
    0,
    0,
    40,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_ENABLE_UPSTREAM_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_ENABLE_UPSTREAM_FB
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_ENABLE_UPSTREAM_FB_FIELDS[] =
{
    &EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_ENABLE_UPSTREAM_FB_REG = 
{
    "ENABLE_UPSTREAM_FB",
#if RU_INCLUDE_DESC
    "EPN_ENABLE_UPSTREAM_FB Register",
    "Feedback register to indicate pending/complete changes in the EPN"
    "Enable Upstream register. A non-zero result from a bitwise XOR between"
    "this register and EPN Enable Upstream indicates that a new value"
    "written to EPN Enable Upstream has not yet taken effect.",
#endif
    EPN_ENABLE_UPSTREAM_FB_REG_OFFSET,
    0,
    0,
    41,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_ENABLE_UPSTREAM_FB_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_ENABLE_UPSTREAM_FEC
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_ENABLE_UPSTREAM_FEC_FIELDS[] =
{
    &EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_ENABLE_UPSTREAM_FEC_REG = 
{
    "ENABLE_UPSTREAM_FEC",
#if RU_INCLUDE_DESC
    "EPN_ENABLE_UPSTREAM_FEC Register",
    "Per-LLID index based upstream FEC enable. Set the bit corresponding to"
    "the LLID index to enable FEC overhead to be added to the packet length"
    "adjustment. Please note that the global FEC enable in Control register"
    "1 must also be set. For 10G upstream operation, per-LLID FEC enable is"
    "not supported; set all of these bits for FEC operation, and clear all"
    "of them for non-FEC.",
#endif
    EPN_ENABLE_UPSTREAM_FEC_REG_OFFSET,
    0,
    0,
    42,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_ENABLE_UPSTREAM_FEC_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_REPORT_BYTE_LENGTH
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_REPORT_BYTE_LENGTH_FIELDS[] =
{
    &EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD,
    &EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_REPORT_BYTE_LENGTH_REG = 
{
    "REPORT_BYTE_LENGTH",
#if RU_INCLUDE_DESC
    "EPN_REPORT_BYTE_LENGTH Register",
    "The number of bytes of 10G upstream payload that should be reserved for"
    "a piggy-back report."
    "Note that if the \"force report\" is not set then this register is not"
    "used. Also, this value must be increased by 16-bytes for FEC-less"
    "upstream 10G mode. The extra bytes are required to compensate for the"
    "10G upstream \"scrambler sync pattern\".",
#endif
    EPN_REPORT_BYTE_LENGTH_REG_OFFSET,
    0,
    0,
    43,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_REPORT_BYTE_LENGTH_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_MAIN_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_MAIN_INT_STATUS_FIELDS[] =
{
    &EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD,
    &EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD,
    &EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD,
    &EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD,
    &EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD,
    &EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD,
    &EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD,
    &EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD,
    &EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD,
    &EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD,
    &EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD,
    &EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD,
    &EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD,
    &EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD,
    &EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD,
    &EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD,
    &EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD,
    &EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD,
    &EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD,
    &EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD,
    &EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD,
    &EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_MAIN_INT_STATUS_REG = 
{
    "MAIN_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_MAIN_INT_STATUS Register",
    "This register contains interrupt status for the EPON module. These bits"
    "are sticky; to clear a bit, write 1 to it."
    ""
    "The Data Port Busy Interrupt indicates whether or not the data port is"
    "free to do another RAM access."
    ""
    "The Grant Full interrupt indicates that a grant was aborted due to its"
    "grant FIFO being full."
    ""
    "The Missed Grant interrupt indicates that a grant missed its time to"
    "transmit and was aborted. This occurs from the MPCP time having"
    "exceeded the start time when the grant is to be scheduled. (Note that"
    "grant start time is adjusted by the Grant Start Time Delta register for"
    "this calculation)"
    ""
    "The Grant Interval interrupt indicates that an LLID is not receiving"
    "gates quickly enough. If the amount of time elapsed since receiving a"
    "Gate frame exceeds a programmed value the interrupt will be asserted."
    "See the EPON LLID Grant Interval register."
    ""
    "The Discovery Gate interrupt indicates that a discovery gate was"
    "received."
    ""
    "The Local Time Not Synced interrupt is used to indicate that the ONU's"
    "local time is out of sync with EPON time. The time a MPCPDU frames"
    "arrives is compared with the value of its time stamp. If this"
    "difference is greater than value specified by the Time Stamp"
    "Differential register the interrupt will assert."
    ""
    "The Local Time Synced interrupt is used to indicate that the ONU's"
    "local time is in sync with the OLT EPON time. The time a MPCPDU frames"
    "arrives is compared with the value of its time stamp. If this"
    "difference is less than or equal to the value specified by the Time"
    "Stamp Differential register the interrupt will assert.",
#endif
    EPN_MAIN_INT_STATUS_REG_OFFSET,
    0,
    0,
    44,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_MAIN_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_FULL_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_FULL_INT_STATUS_FIELDS[] =
{
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT31_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT30_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT29_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT28_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT27_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT26_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT25_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT24_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT23_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT22_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT21_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT20_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT19_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT18_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT17_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT16_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT15_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT14_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT13_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT12_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT11_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT10_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT9_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT8_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD,
    &EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_FULL_INT_STATUS_REG = 
{
    "GNT_FULL_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_GNT_FULL_INT_STATUS Register",
    "This register contains interrupt status for the EPON module. These bits"
    "are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_GNT_FULL_INT_STATUS_REG_OFFSET,
    0,
    0,
    45,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_FULL_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_FULL_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_FULL_INT_MASK_FIELDS[] =
{
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT31_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT30_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT29_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT28_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT27_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT26_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT25_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT24_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT23_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT22_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT21_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT20_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT19_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT18_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT17_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT16_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT15_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT14_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT13_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT12_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT11_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT10_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT9_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT8_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD,
    &EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_FULL_INT_MASK_REG = 
{
    "GNT_FULL_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_GNT_FULL_INT_MASK Register",
    "This register contains interrupt mask for the EPON module.",
#endif
    EPN_GNT_FULL_INT_MASK_REG_OFFSET,
    0,
    0,
    46,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_FULL_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_MISS_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_MISS_INT_STATUS_FIELDS[] =
{
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT31_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT30_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT29_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT28_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT27_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT26_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT25_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT24_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT23_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT22_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT21_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT20_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT19_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT18_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT17_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT16_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT15_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT14_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT13_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT12_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT11_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT10_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT9_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT8_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD,
    &EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_MISS_INT_STATUS_REG = 
{
    "GNT_MISS_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_GNT_MISS_INT_STATUS Register",
    "This register contains interrupt status for the EPON module. These bits"
    "are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_GNT_MISS_INT_STATUS_REG_OFFSET,
    0,
    0,
    47,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_MISS_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_MISS_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_MISS_INT_MASK_FIELDS[] =
{
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT31_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT30_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT29_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT28_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT27_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT26_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT25_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT24_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT23_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT22_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT21_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT20_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT19_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT18_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT17_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT16_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT15_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT14_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT13_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT12_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT11_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT10_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT9_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT8_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD,
    &EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_MISS_INT_MASK_REG = 
{
    "GNT_MISS_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_GNT_MISS_INT_MASK Register",
    "This register contains interrupt mask for the EPON module.",
#endif
    EPN_GNT_MISS_INT_MASK_REG_OFFSET,
    0,
    0,
    48,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_MISS_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DISC_RX_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DISC_RX_INT_STATUS_FIELDS[] =
{
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY31_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY30_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY29_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY28_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY27_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY26_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY25_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY24_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY23_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY22_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY21_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY20_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY19_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY18_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY17_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY16_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY15_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY14_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY13_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY12_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY11_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY10_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY9_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY8_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD,
    &EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DISC_RX_INT_STATUS_REG = 
{
    "DISC_RX_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_DISC_RX_INT_STATUS Register",
    "This register contains interrupt status for the EPON module. These bits"
    "are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_DISC_RX_INT_STATUS_REG_OFFSET,
    0,
    0,
    49,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_DISC_RX_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DISC_RX_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DISC_RX_INT_MASK_FIELDS[] =
{
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY31_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY30_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY29_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY28_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY27_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY26_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY25_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY24_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY23_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY22_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY21_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY20_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY19_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY18_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY17_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY16_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY15_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY14_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY13_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY12_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY11_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY10_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY9_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY8_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD,
    &EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DISC_RX_INT_MASK_REG = 
{
    "DISC_RX_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_DISC_RX_INT_MASK Register",
    "This register contains interrupt mask for the EPON module.",
#endif
    EPN_DISC_RX_INT_MASK_REG_OFFSET,
    0,
    0,
    50,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_DISC_RX_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_INTV_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_INTV_INT_STATUS_FIELDS[] =
{
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL31_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL30_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL29_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL28_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL27_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL26_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL25_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL24_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL23_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL22_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL21_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL20_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL19_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL18_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL17_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL16_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL15_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL14_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL13_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL12_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL11_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL10_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL9_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL8_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD,
    &EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_INTV_INT_STATUS_REG = 
{
    "GNT_INTV_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_GNT_INTV_INT_STATUS Register",
    "This register contains interrupt status for the EPON module. These bits"
    "are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_GNT_INTV_INT_STATUS_REG_OFFSET,
    0,
    0,
    51,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_INTV_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_INTV_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_INTV_INT_MASK_FIELDS[] =
{
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL31_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL30_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL29_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL28_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL27_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL26_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL25_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL24_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL23_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL22_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL21_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL20_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL19_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL18_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL17_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL16_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL15_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL14_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL13_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL12_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL11_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL10_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL9_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL8_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD,
    &EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_INTV_INT_MASK_REG = 
{
    "GNT_INTV_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_GNT_INTV_INT_MASK Register",
    "This register contains interrupt mask for the EPON module.",
#endif
    EPN_GNT_INTV_INT_MASK_REG_OFFSET,
    0,
    0,
    52,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_INTV_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_FAR_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_FAR_INT_STATUS_FIELDS[] =
{
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR31_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR30_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR29_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR28_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR27_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR26_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR25_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR24_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR23_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR22_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR21_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR20_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR19_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR18_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR17_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR16_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR15_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR14_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR13_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR12_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR11_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR10_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR9_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR8_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD,
    &EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_FAR_INT_STATUS_REG = 
{
    "GNT_FAR_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_GNT_FAR_INT_STATUS Register",
    "This register contains interrupt status for the EPON module. These bits"
    "are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_GNT_FAR_INT_STATUS_REG_OFFSET,
    0,
    0,
    53,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_FAR_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_FAR_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_FAR_INT_MASK_FIELDS[] =
{
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR31_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR30_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR29_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR28_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR27_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR26_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR25_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR24_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR23_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR22_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR21_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR20_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR19_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR18_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR17_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR16_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR15_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR14_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR13_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR12_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR11_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR10_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR9_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR8_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD,
    &EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_FAR_INT_MASK_REG = 
{
    "GNT_FAR_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_GNT_FAR_INT_MASK Register",
    "This register contains interrupt mask for the EPON module.",
#endif
    EPN_GNT_FAR_INT_MASK_REG_OFFSET,
    0,
    0,
    54,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_FAR_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_MISALGN_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_MISALGN_INT_STATUS_FIELDS[] =
{
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN31_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN30_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN29_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN28_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN27_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN26_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN25_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN24_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN23_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN22_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN21_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN20_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN19_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN18_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN17_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN16_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN15_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN14_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN13_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN12_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN11_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN10_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN9_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN8_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD,
    &EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_MISALGN_INT_STATUS_REG = 
{
    "GNT_MISALGN_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_GNT_MISALGN_INT_STATUS Register",
    "This register contains interrupt status for the EPON module.These bits"
    "are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_GNT_MISALGN_INT_STATUS_REG_OFFSET,
    0,
    0,
    55,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_MISALGN_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_MISALGN_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_MISALGN_INT_MASK_FIELDS[] =
{
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN31_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN30_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN29_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN28_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN27_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN26_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN25_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN24_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN23_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN22_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN21_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN20_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN19_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN18_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN17_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN16_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN15_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN14_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN13_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN12_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN11_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN10_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN9_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN8_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD,
    &EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_MISALGN_INT_MASK_REG = 
{
    "GNT_MISALGN_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_GNT_MISALGN_INT_MASK Register",
    "This register contains interrupt mask for the EPON module.",
#endif
    EPN_GNT_MISALGN_INT_MASK_REG_OFFSET,
    0,
    0,
    56,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_MISALGN_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_NP_GNT_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_NP_GNT_INT_STATUS_FIELDS[] =
{
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL31_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL30_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL29_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL28_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL27_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL26_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL25_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL24_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL23_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL22_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL21_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL20_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL19_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL18_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL17_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL16_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL15_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL14_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL13_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL12_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL11_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL10_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL9_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL8_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD,
    &EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_NP_GNT_INT_STATUS_REG = 
{
    "NP_GNT_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_NP_GNT_INT_STATUS Register",
    "This register contains interrupt status for the EPON module. These bits"
    "are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_NP_GNT_INT_STATUS_REG_OFFSET,
    0,
    0,
    57,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_NP_GNT_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_NP_GNT_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_NP_GNT_INT_MASK_FIELDS[] =
{
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL31_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL30_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL29_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL28_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL27_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL26_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL25_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL24_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL23_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL22_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL21_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL20_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL19_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL18_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL17_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL16_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL15_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL14_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL13_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL12_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL11_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL10_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL9_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL8_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD,
    &EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_NP_GNT_INT_MASK_REG = 
{
    "NP_GNT_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_NP_GNT_INT_MASK Register",
    "This register contains interrupt mask for the EPON module.",
#endif
    EPN_NP_GNT_INT_MASK_REG_OFFSET,
    0,
    0,
    58,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_NP_GNT_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DEL_STALE_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DEL_STALE_INT_STATUS_FIELDS[] =
{
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT31_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT30_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT29_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT28_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT27_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT26_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT25_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT24_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT23_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT22_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT21_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT20_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT19_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT18_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT17_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT16_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT15_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT14_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT13_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT12_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT11_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT10_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT9_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT8_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD,
    &EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DEL_STALE_INT_STATUS_REG = 
{
    "DEL_STALE_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_DEL_STALE_INT_STATUS Register",
    "This register contains interrupt status for the EPON module. These bits"
    "are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_DEL_STALE_INT_STATUS_REG_OFFSET,
    0,
    0,
    59,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_DEL_STALE_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DEL_STALE_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DEL_STALE_INT_MASK_FIELDS[] =
{
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT31_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT30_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT29_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT28_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT27_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT26_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT25_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT24_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT23_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT22_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT21_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT20_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT19_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT18_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT17_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT16_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT15_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT14_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT13_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT12_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT11_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT10_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT9_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT8_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD,
    &EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DEL_STALE_INT_MASK_REG = 
{
    "DEL_STALE_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_DEL_STALE_INT_MASK Register",
    "Interrupt mask for EPN_DEL_STALE_INT_STATUS",
#endif
    EPN_DEL_STALE_INT_MASK_REG_OFFSET,
    0,
    0,
    60,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_DEL_STALE_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_PRES_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_PRES_INT_STATUS_FIELDS[] =
{
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY31_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY30_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY29_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY28_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY27_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY26_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY25_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY24_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY23_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY22_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY21_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY20_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY19_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY18_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY17_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY16_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY15_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY14_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY13_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY12_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY11_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY10_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY9_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY8_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD,
    &EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_PRES_INT_STATUS_REG = 
{
    "GNT_PRES_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_GNT_PRES_INT_STATUS Register",
    "This register contains interrupt status for the EPON module. These bits"
    "are sticky; to clear a bit, write a 1 to it.",
#endif
    EPN_GNT_PRES_INT_STATUS_REG_OFFSET,
    0,
    0,
    61,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_PRES_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_PRES_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_PRES_INT_MASK_FIELDS[] =
{
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY31_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY30_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY29_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY28_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY27_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY26_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY25_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY24_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY23_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY22_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY21_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY20_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY19_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY18_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY17_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY16_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY15_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY14_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY13_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY12_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY11_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY10_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY9_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY8_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD,
    &EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_PRES_INT_MASK_REG = 
{
    "GNT_PRES_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_GNT_PRES_INT_MASK Register",
    "This register contains interrupt mask for the EPON module.",
#endif
    EPN_GNT_PRES_INT_MASK_REG_OFFSET,
    0,
    0,
    62,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_GNT_PRES_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_RPT_PRES_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_RPT_PRES_INT_STATUS_FIELDS[] =
{
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO31_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO30_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO29_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO28_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO27_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO26_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO25_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO24_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO23_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO22_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO21_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO20_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO19_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO18_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO17_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO16_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO15_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO14_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO13_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO12_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO11_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO10_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO9_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO8_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD,
    &EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_RPT_PRES_INT_STATUS_REG = 
{
    "RPT_PRES_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_RPT_PRES_INT_STATUS Register",
    "This register contains interrupt status for the EPON module. These bits"
    "are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_RPT_PRES_INT_STATUS_REG_OFFSET,
    0,
    0,
    63,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_RPT_PRES_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_RPT_PRES_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_RPT_PRES_INT_MASK_FIELDS[] =
{
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO31_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO30_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO29_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO28_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO27_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO26_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO25_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO24_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO23_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO22_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO21_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO20_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO19_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO18_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO17_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO16_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO15_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO14_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO13_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO12_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO11_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO10_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO9_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO8_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD,
    &EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_RPT_PRES_INT_MASK_REG = 
{
    "RPT_PRES_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_RPT_PRES_INT_MASK Register",
    "This register contains interrupt mask for the EPON module.",
#endif
    EPN_RPT_PRES_INT_MASK_REG_OFFSET,
    0,
    0,
    64,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_RPT_PRES_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DRX_ABORT_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DRX_ABORT_INT_STATUS_FIELDS[] =
{
    &EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DRX_ABORT_INT_STATUS_REG = 
{
    "DRX_ABORT_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_DRX_ABORT_INT_STATUS Register",
    "This register contains interrupt status for the Drx error abort events."
    "These bits are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_DRX_ABORT_INT_STATUS_REG_OFFSET,
    0,
    0,
    65,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_DRX_ABORT_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DRX_ABORT_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DRX_ABORT_INT_MASK_FIELDS[] =
{
    &EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DRX_ABORT_INT_MASK_REG = 
{
    "DRX_ABORT_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_DRX_ABORT_INT_MASK Register",
    "This register contains interrupt mask for the Drx error abort events.",
#endif
    EPN_DRX_ABORT_INT_MASK_REG_OFFSET,
    0,
    0,
    66,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_DRX_ABORT_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_EMPTY_RPT_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_EMPTY_RPT_INT_STATUS_FIELDS[] =
{
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT31_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT30_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT29_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT28_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT27_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT26_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT25_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT24_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT23_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT22_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT21_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT20_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT19_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT18_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT17_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT16_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT15_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT14_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT13_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT12_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT11_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT10_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT9_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT8_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD,
    &EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_EMPTY_RPT_INT_STATUS_REG = 
{
    "EMPTY_RPT_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_EMPTY_RPT_INT_STATUS Register",
    "This register contains interrupt status for the EPON module's empty"
    "report transmission. Any time the EPON module sends a report upstream"
    "and all the report values are zero, the bit corresponding to the LLID"
    "index will be set. These bits are sticky; to clear a bit, write 1 to"
    "it.",
#endif
    EPN_EMPTY_RPT_INT_STATUS_REG_OFFSET,
    0,
    0,
    67,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_EMPTY_RPT_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_EMPTY_RPT_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_EMPTY_RPT_INT_MASK_FIELDS[] =
{
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT31_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT30_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT29_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT28_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT27_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT26_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT25_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT24_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT23_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT22_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT21_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT20_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT19_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT18_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT17_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT16_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT15_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT14_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT13_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT12_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT11_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT10_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT9_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT8_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD,
    &EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_EMPTY_RPT_INT_MASK_REG = 
{
    "EMPTY_RPT_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_EMPTY_RPT_INT_MASK Register",
    "This register contains interrupt mask for the EPON module's empty"
    "report transmission. Any time the EPON module sends a report upstream"
    "and all the report values are zero, the bit corresponding to the LLID"
    "index will be set.",
#endif
    EPN_EMPTY_RPT_INT_MASK_REG_OFFSET,
    0,
    0,
    68,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_EMPTY_RPT_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BCAP_OVERFLOW_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BCAP_OVERFLOW_INT_STATUS_FIELDS[] =
{
    &EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BCAP_OVERFLOW_INT_STATUS_REG = 
{
    "BCAP_OVERFLOW_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_BCAP_OVERFLOW_INT_STATUS Register",
    "This register contains interrupt status indicating when the L2"
    "accumulators exceed their burst-cap values. These bits are sticky; to"
    "clear a bit, write 1 to it.",
#endif
    EPN_BCAP_OVERFLOW_INT_STATUS_REG_OFFSET,
    0,
    0,
    69,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_BCAP_OVERFLOW_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BCAP_OVERFLOW_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BCAP_OVERFLOW_INT_MASK_FIELDS[] =
{
    &EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BCAP_OVERFLOW_INT_MASK_REG = 
{
    "BCAP_OVERFLOW_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_BCAP_OVERFLOW_INT_MASK Register",
    "This register contains interrupt mask indicating when the L2"
    "accumulators exceed their burst-cap values.",
#endif
    EPN_BCAP_OVERFLOW_INT_MASK_REG_OFFSET,
    0,
    0,
    70,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_BCAP_OVERFLOW_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BBH_DNS_FAULT_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BBH_DNS_FAULT_INT_STATUS_FIELDS[] =
{
    &EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD,
    &EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BBH_DNS_FAULT_INT_STATUS_REG = 
{
    "BBH_DNS_FAULT_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_BBH_DNS_FAULT_INT_STATUS Register",
    "",
#endif
    EPN_BBH_DNS_FAULT_INT_STATUS_REG_OFFSET,
    0,
    0,
    71,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BBH_DNS_FAULT_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BBH_DNS_FAULT_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BBH_DNS_FAULT_INT_MASK_FIELDS[] =
{
    &EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD,
    &EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BBH_DNS_FAULT_INT_MASK_REG = 
{
    "BBH_DNS_FAULT_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_BBH_DNS_FAULT_INT_MASK Register",
    "",
#endif
    EPN_BBH_DNS_FAULT_INT_MASK_REG_OFFSET,
    0,
    0,
    72,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BBH_DNS_FAULT_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BBH_UPS_FAULT_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BBH_UPS_FAULT_INT_STATUS_FIELDS[] =
{
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT31_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT30_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT29_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT28_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT27_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT26_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT25_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT24_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT23_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT22_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT21_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT20_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT19_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT18_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT17_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT16_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT15_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT14_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT13_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT12_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT11_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT10_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT9_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT8_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD,
    &EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BBH_UPS_FAULT_INT_STATUS_REG = 
{
    "BBH_UPS_FAULT_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_BBH_UPS_FAULT_INT_STATUS Register",
    "",
#endif
    EPN_BBH_UPS_FAULT_INT_STATUS_REG_OFFSET,
    0,
    0,
    73,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_BBH_UPS_FAULT_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BBH_UPS_FAULT_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BBH_UPS_FAULT_INT_MASK_FIELDS[] =
{
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT31_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT30_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT29_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT28_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT27_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT26_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT25_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT24_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT23_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT22_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT21_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT20_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT19_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT18_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT17_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT16_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT15_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT14_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT13_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT12_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT11_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT10_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT9_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT8_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD,
    &EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BBH_UPS_FAULT_INT_MASK_REG = 
{
    "BBH_UPS_FAULT_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_BBH_UPS_FAULT_INT_MASK Register",
    "",
#endif
    EPN_BBH_UPS_FAULT_INT_MASK_REG_OFFSET,
    0,
    0,
    74,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_BBH_UPS_FAULT_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BBH_UPS_ABORT_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BBH_UPS_ABORT_INT_STATUS_FIELDS[] =
{
    &EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD,
    &EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BBH_UPS_ABORT_INT_STATUS_REG = 
{
    "BBH_UPS_ABORT_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_BBH_UPS_ABORT_INT_STATUS Register",
    "",
#endif
    EPN_BBH_UPS_ABORT_INT_STATUS_REG_OFFSET,
    0,
    0,
    75,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BBH_UPS_ABORT_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BBH_UPS_ABORT_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BBH_UPS_ABORT_INT_MASK_FIELDS[] =
{
    &EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD,
    &EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BBH_UPS_ABORT_INT_MASK_REG = 
{
    "BBH_UPS_ABORT_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_BBH_UPS_ABORT_INT_MASK Register",
    "",
#endif
    EPN_BBH_UPS_ABORT_INT_MASK_REG_OFFSET,
    0,
    0,
    76,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BBH_UPS_ABORT_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_MAIN_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_MAIN_INT_MASK_FIELDS[] =
{
    &EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD,
    &EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD,
    &EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD,
    &EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD,
    &EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD,
    &EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD,
    &EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD,
    &EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD,
    &EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD,
    &EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD,
    &EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD,
    &EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD,
    &EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD,
    &EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD,
    &EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_MAIN_INT_MASK_REG = 
{
    "MAIN_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_MAIN_INT_MASK Register",
    "",
#endif
    EPN_MAIN_INT_MASK_REG_OFFSET,
    0,
    0,
    77,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_MAIN_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_MAX_GNT_SIZE
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_MAX_GNT_SIZE_FIELDS[] =
{
    &EPN_MAX_GNT_SIZE_RESERVED0_FIELD,
    &EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_MAX_GNT_SIZE_REG = 
{
    "MAX_GNT_SIZE",
#if RU_INCLUDE_DESC
    "EPN_MAX_GNT_SIZE Register",
    "The Maximum Grant Size register sets the threshold for the three Grant"
    "Too Big interrupts (in the EPN Main Interrupt Status register).",
#endif
    EPN_MAX_GNT_SIZE_REG_OFFSET,
    0,
    0,
    78,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_MAX_GNT_SIZE_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_MAX_FRAME_SIZE
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_MAX_FRAME_SIZE_FIELDS[] =
{
    &EPN_MAX_FRAME_SIZE_RESERVED0_FIELD,
    &EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_MAX_FRAME_SIZE_REG = 
{
    "MAX_FRAME_SIZE",
#if RU_INCLUDE_DESC
    "EPN_MAX_FRAME_SIZE Register",
    "Provisions the maximum allowable downstream frame size. The reset"
    "default is 1536. This register is overridden by the cfgVlanMaxSize bit."
    "The maximum allowable value for this register is 2000 in 1G/2G mode and"
    "10000 in 10G mode.",
#endif
    EPN_MAX_FRAME_SIZE_REG_OFFSET,
    0,
    0,
    79,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_MAX_FRAME_SIZE_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GRANT_OVR_HD
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GRANT_OVR_HD_FIELDS[] =
{
    &EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD,
    &EPN_GRANT_OVR_HD_GNTOVRHD_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GRANT_OVR_HD_REG = 
{
    "GRANT_OVR_HD",
#if RU_INCLUDE_DESC
    "EPN_GRANT_OVR_HD Register",
    "Defines how much of the grant length is consumed by laser on time,"
    "laser off time, and idle (sync) time. This value is subtracted from the"
    "grant length and the remainder is used to fill frames from FIF queues"
    "into the upstream burst. This register is used in both 1G and 10G"
    "upstream modes. The units are in TQ. Reset default is 0."
    "NOTE: In 10G mode the Xif requires 2 extra TimeQuanta for \"Eob\". Also,"
    "in FECless 10G mode the Epn's \"Report Byte Length\" must have an extra"
    "16-bytes added to its value to account for 10G \"scrambler sync time\".",
#endif
    EPN_GRANT_OVR_HD_REG_OFFSET,
    0,
    0,
    80,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_GRANT_OVR_HD_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_POLL_SIZE
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_POLL_SIZE_FIELDS[] =
{
    &EPN_POLL_SIZE_POLLSIZEFEC_FIELD,
    &EPN_POLL_SIZE_POLLSIZE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_POLL_SIZE_REG = 
{
    "POLL_SIZE",
#if RU_INCLUDE_DESC
    "EPN_POLL_SIZE Register",
    "Sets the size of polling grants for the purpose of generating the"
    "dnGntNonPoll interrupts. If a received grant's length, less EPN Grant"
    "Length Overhead, is less than or equal to the poll size, the grant is"
    "considered a poll and resets the poll grant interval timer for the LLID"
    "Index. Reset default is 64 decimal.",
#endif
    EPN_POLL_SIZE_REG_OFFSET,
    0,
    0,
    81,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_POLL_SIZE_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DN_RD_GNT_MARGIN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DN_RD_GNT_MARGIN_FIELDS[] =
{
    &EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD,
    &EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DN_RD_GNT_MARGIN_REG = 
{
    "DN_RD_GNT_MARGIN",
#if RU_INCLUDE_DESC
    "EPN_DN_RD_GNT_MARGIN Register",
    "This register determines how far in advance of the Grant Start Time"
    "that grants are considered for removal from the DRX Grant FIFO. Once a"
    "grant is chosen (the various LLID Indexes compete for the next burst"
    "slot - the Index with a grant that is within Read Grant Margin and"
    "closest to its Grant Start Time wins), it is popped from its grant FIFO"
    "and held until it meets the Grant Start Time Delta criteria (see"
    "below)."
    "The units of this register are TQ. The reset default value is 256"
    "decimal.",
#endif
    EPN_DN_RD_GNT_MARGIN_REG_OFFSET,
    0,
    0,
    82,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_DN_RD_GNT_MARGIN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_TIME_START_DELTA
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_TIME_START_DELTA_FIELDS[] =
{
    &EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD,
    &EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_TIME_START_DELTA_REG = 
{
    "GNT_TIME_START_DELTA",
#if RU_INCLUDE_DESC
    "EPN_GNT_TIME_START_DELTA Register",
    "This value determines how far in advance of the Grant Start Time that"
    "the next selected grant (already extracted from the Grant FIFO) will be"
    "handed to the EPN UTX (upstream transmit) logic and start to pre-fetch"
    "frames.."
    "The units of this register are TQ. The reset default value is 640"
    "decimal.",
#endif
    EPN_GNT_TIME_START_DELTA_REG_OFFSET,
    0,
    0,
    83,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_GNT_TIME_START_DELTA_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TIME_STAMP_DIFF
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TIME_STAMP_DIFF_FIELDS[] =
{
    &EPN_TIME_STAMP_DIFF_RESERVED0_FIELD,
    &EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TIME_STAMP_DIFF_REG = 
{
    "TIME_STAMP_DIFF",
#if RU_INCLUDE_DESC
    "EPN_TIME_STAMP_DIFF Register",
    "This register sets a threshold for LocalTimeInSync/LocalTimeNotSync"
    "interrupts, and for local time reference updates. When the difference"
    "between the EPON MAC's local time and an MPCPDU's timestamp exceeds"
    "this value the LocalTimeNotSync interrupt is asserted. The units of"
    "this register are TQ. Reset default is 10 decimal.",
#endif
    EPN_TIME_STAMP_DIFF_REG_OFFSET,
    0,
    0,
    84,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TIME_STAMP_DIFF_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UP_TIME_STAMP_OFF
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UP_TIME_STAMP_OFF_FIELDS[] =
{
    &EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD,
    &EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UP_TIME_STAMP_OFF_REG = 
{
    "UP_TIME_STAMP_OFF",
#if RU_INCLUDE_DESC
    "EPN_UP_TIME_STAMP_OFF Register",
    "This register helps determine the value for the Timestamp field"
    "inserted into REPORT and Processor frames. This value specifies an"
    "offset from the Grant Start Time of the upstream burst. The value"
    "programmed here will be roughly equivalent to the sum of Laser-On time"
    "plus IDLE time plus Preamble time. The goal is for the Timestamp"
    "inserted into a frame to match the MPCP time at which the first byte of"
    "the frame's Destination Address is transmitted.",
#endif
    EPN_UP_TIME_STAMP_OFF_REG_OFFSET,
    0,
    0,
    85,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_UP_TIME_STAMP_OFF_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GNT_INTERVAL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GNT_INTERVAL_FIELDS[] =
{
    &EPN_GNT_INTERVAL_RESERVED0_FIELD,
    &EPN_GNT_INTERVAL_GNTINTERVAL_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GNT_INTERVAL_REG = 
{
    "GNT_INTERVAL",
#if RU_INCLUDE_DESC
    "EPN_GNT_INTERVAL Register",
    "This register specifies the maximum allowed time between GATE messages"
    "received on an LLID. If the time elapsed is greater than the specified"
    "value, the Gate Interval interrupt asserts for that LLID Index. The"
    "units of this register are 262 us. The maximum interval is ~17 seconds.",
#endif
    EPN_GNT_INTERVAL_REG_OFFSET,
    0,
    0,
    86,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_GNT_INTERVAL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DN_GNT_MISALIGN_THR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DN_GNT_MISALIGN_THR_FIELDS[] =
{
    &EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD,
    &EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD,
    &EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DN_GNT_MISALIGN_THR_REG = 
{
    "DN_GNT_MISALIGN_THR",
#if RU_INCLUDE_DESC
    "EPN_DN_GNT_MISALIGN_THR Register",
    "Sets the threshold for misalignment detection and handling."
    "A grant misalignment condition is detected by the ONU whenever a grant"
    "to the ONU cannot be used efficiently (due to the grant size not"
    "aligning to even frame boundaries)."
    "When cfgGntMisalignX bits are set, the ONU uses this register to"
    "determine a misalignment condition and to take corrective action."
    "prvUnusedGntThresh determines how many unused TQ there must be in a"
    "given grant in order for it to be considered misaligned."
    "gntMisalignThresh indicates how many consecutive misaligned grants must"
    "be received in order to trigger handling of this condition."
    "The ONU handles the misaligned condition by temporarily reporting 0"
    "(\"no data\") in that LLID's REPORT frames.",
#endif
    EPN_DN_GNT_MISALIGN_THR_REG_OFFSET,
    0,
    0,
    87,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    3,
    EPN_DN_GNT_MISALIGN_THR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DN_GNT_MISALIGN_PAUSE
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DN_GNT_MISALIGN_PAUSE_FIELDS[] =
{
    &EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD,
    &EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DN_GNT_MISALIGN_PAUSE_REG = 
{
    "DN_GNT_MISALIGN_PAUSE",
#if RU_INCLUDE_DESC
    "EPN_DN_GNT_MISALIGN_PAUSE Register",
    "Indicates for how long after the misalignment condition is detected"
    "that the LLID Index's reporting will be \"paused\". This is achieved"
    "through reporting queue report values of zero."
    "Units are 1 us.",
#endif
    EPN_DN_GNT_MISALIGN_PAUSE_REG_OFFSET,
    0,
    0,
    88,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_DN_GNT_MISALIGN_PAUSE_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_NON_POLL_INTV
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_NON_POLL_INTV_FIELDS[] =
{
    &EPN_NON_POLL_INTV_RESERVED0_FIELD,
    &EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_NON_POLL_INTV_REG = 
{
    "NON_POLL_INTV",
#if RU_INCLUDE_DESC
    "EPN_NON_POLL_INTV Register",
    "Defines the amount of time required for triggering the non poll grant"
    "interrupts.",
#endif
    EPN_NON_POLL_INTV_REG_OFFSET,
    0,
    0,
    89,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_NON_POLL_INTV_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_FORCE_FCS_ERR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_FORCE_FCS_ERR_FIELDS[] =
{
    &EPN_FORCE_FCS_ERR_FORCEFCSERR31_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR30_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR29_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR28_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR27_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR26_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR25_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR24_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR23_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR22_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR21_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR20_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR19_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR18_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR17_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR16_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR15_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR14_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR13_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR12_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR11_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR10_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR9_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR8_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD,
    &EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_FORCE_FCS_ERR_REG = 
{
    "FORCE_FCS_ERR",
#if RU_INCLUDE_DESC
    "EPN_FORCE_FCS_ERR Register",
    "Forces upstream FCS errors on the selected LLID(s).",
#endif
    EPN_FORCE_FCS_ERR_REG_OFFSET,
    0,
    0,
    90,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_FORCE_FCS_ERR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_GRANT_OVERLAP_LIMIT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_GRANT_OVERLAP_LIMIT_FIELDS[] =
{
    &EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD,
    &EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_GRANT_OVERLAP_LIMIT_REG = 
{
    "GRANT_OVERLAP_LIMIT",
#if RU_INCLUDE_DESC
    "EPN_GRANT_OVERLAP_LIMIT Register",
    "Defines how much overlap is allowed between consecutive grants to the"
    "same ONU. Effectively this register defines how much of the grant"
    "overhead the Epn should attempt to recover when processing overlapped"
    "grants. Normally this register is provisioned with the same value as in"
    "the EPN Grant Overhead Length register. However, if the Xif or Lif"
    "require extra overhead not associated with Lon/Sync/Loff, then this"
    "register value must be smaller than the EPN Grant Overhead Length"
    "register value."
    "This register is used in both 1G and 10G upstream modes. The units are"
    "in TQ. Reset default is 0."
    "NOTE: In 10G upstream mode this register must be provisioned to match"
    "the value written to the XIF Overlapping Grant Overhead register"
    "(0x0364). The proper value is calculated as:"
    "EPN Grant Overlap Limit = Lon + Sync Time + Loff - 1 (start of burst) -"
    "1 (Idle Sync) - 3 (XIF Overlapping Grant Overhead).",
#endif
    EPN_GRANT_OVERLAP_LIMIT_REG_OFFSET,
    0,
    0,
    91,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_GRANT_OVERLAP_LIMIT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_AES_CONFIGURATION_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_AES_CONFIGURATION_0_FIELDS[] =
{
    &EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_AES_CONFIGURATION_0_REG = 
{
    "AES_CONFIGURATION_0",
#if RU_INCLUDE_DESC
    "EPN_AES_CONFIGURATION_0 Register",
    "Allows control over reporting the extra per-packet overhead associated"
    "with 802.1AE encryption. The AES overhead compensation logic supports"
    "two overhead modes: implicit SCI and explicit SCI. The implicit SCI"
    "mode increases the per-packet overhead by 24 bytes. Explicit SCI mode"
    "increases the per-packet overhead by 32 bytes.",
#endif
    EPN_AES_CONFIGURATION_0_REG_OFFSET,
    0,
    0,
    92,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_AES_CONFIGURATION_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DISC_GRANT_OVR_HD
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DISC_GRANT_OVR_HD_FIELDS[] =
{
    &EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD,
    &EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DISC_GRANT_OVR_HD_REG = 
{
    "DISC_GRANT_OVR_HD",
#if RU_INCLUDE_DESC
    "EPN_DISC_GRANT_OVR_HD Register",
    "The amount of overhead used in discovery gates.",
#endif
    EPN_DISC_GRANT_OVR_HD_REG_OFFSET,
    0,
    0,
    93,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_DISC_GRANT_OVR_HD_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DN_DISCOVERY_SEED
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DN_DISCOVERY_SEED_FIELDS[] =
{
    &EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD,
    &EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DN_DISCOVERY_SEED_REG = 
{
    "DN_DISCOVERY_SEED",
#if RU_INCLUDE_DESC
    "EPN_DN_DISCOVERY_SEED Register",
    "Serves as the seed for generating the random offset during discovery"
    "gates. When this register is written the discovery random offset become"
    "this value",
#endif
    EPN_DN_DISCOVERY_SEED_REG_OFFSET,
    0,
    0,
    94,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_DN_DISCOVERY_SEED_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DN_DISCOVERY_INC
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DN_DISCOVERY_INC_FIELDS[] =
{
    &EPN_DN_DISCOVERY_INC_RESERVED0_FIELD,
    &EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DN_DISCOVERY_INC_REG = 
{
    "DN_DISCOVERY_INC",
#if RU_INCLUDE_DESC
    "EPN_DN_DISCOVERY_INC Register",
    "Sets the amount by which the discovery random offset is incremented.",
#endif
    EPN_DN_DISCOVERY_INC_REG_OFFSET,
    0,
    0,
    95,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_DN_DISCOVERY_INC_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DN_DISCOVERY_SIZE
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DN_DISCOVERY_SIZE_FIELDS[] =
{
    &EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD,
    &EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DN_DISCOVERY_SIZE_REG = 
{
    "DN_DISCOVERY_SIZE",
#if RU_INCLUDE_DESC
    "EPN_DN_DISCOVERY_SIZE Register",
    "Size of the grant for responses to Discovery Gates. When a Discovery"
    "Gate is received from the PON, EPN substitutes this value into the"
    "grant length as the grant goes into the Grant FIFO. Normally, the value"
    "set in this register will be 42 greater than what is set in EPN"
    "Discovery Gate Overhead.",
#endif
    EPN_DN_DISCOVERY_SIZE_REG_OFFSET,
    0,
    0,
    96,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_DN_DISCOVERY_SIZE_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_FEC_IPG_LENGTH
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_FEC_IPG_LENGTH_FIELDS[] =
{
    &EPN_FEC_IPG_LENGTH_RESERVED0_FIELD,
    &EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD,
    &EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD,
    &EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD,
    &EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_FEC_IPG_LENGTH_REG = 
{
    "FEC_IPG_LENGTH",
#if RU_INCLUDE_DESC
    "EPN_FEC_IPG_LENGTH Register",
    "Specifies the IPG and REPORT frame sizes used in computating reported"
    "values. cfgRptLen and cfgFecRptLen are also used to qualify grant"
    "lengths and generate the intInvGntLength interrupt."
    "Note the operating modes in which each of these fields is used:"
    "cfgFecIpgLength - Used only in 1G upstream FEC. Note 8-bytes of"
    "overhead are built in to the Epn's 1G upstream FEC calculations."
    "cfgFecRptLen - Used only in 1G upstream, for LLIDs which are"
    "FEC-enabled."
    "cfgRptLen - Used in 1G upstream for non-FEC LLIDs. Also used in 10G"
    "upstream, whether or not FEC is enabled (FEC is global at 10G"
    "upstream).",
#endif
    EPN_FEC_IPG_LENGTH_REG_OFFSET,
    0,
    0,
    97,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    5,
    EPN_FEC_IPG_LENGTH_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_FAKE_REPORT_VALUE_EN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_FAKE_REPORT_VALUE_EN_FIELDS[] =
{
    &EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_FAKE_REPORT_VALUE_EN_REG = 
{
    "FAKE_REPORT_VALUE_EN",
#if RU_INCLUDE_DESC
    "EPN_FAKE_REPORT_VALUE_EN Register",
    "Enables a mode in which an LLID Index falsely reports that it has data,"
    "even when it does not. This mode is enabled per-LLID Index. Enabling"
    "this mode for an LLID Index causes it to report the value set in EPN"
    "Fake Report Value, regardless of any actual data that is in its"
    "associated queue(s).",
#endif
    EPN_FAKE_REPORT_VALUE_EN_REG_OFFSET,
    0,
    0,
    98,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_FAKE_REPORT_VALUE_EN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_FAKE_REPORT_VALUE
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_FAKE_REPORT_VALUE_FIELDS[] =
{
    &EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD,
    &EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_FAKE_REPORT_VALUE_REG = 
{
    "FAKE_REPORT_VALUE",
#if RU_INCLUDE_DESC
    "EPN_FAKE_REPORT_VALUE Register",
    "Specifies the value sent in fake reports.",
#endif
    EPN_FAKE_REPORT_VALUE_REG_OFFSET,
    0,
    0,
    99,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_FAKE_REPORT_VALUE_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_VALID_OPCODE_MAP
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_VALID_OPCODE_MAP_FIELDS[] =
{
    &EPN_VALID_OPCODE_MAP_RESERVED0_FIELD,
    &EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_VALID_OPCODE_MAP_REG = 
{
    "VALID_OPCODE_MAP",
#if RU_INCLUDE_DESC
    "EPN_VALID_OPCODE_MAP Register",
    "Specifies which of the first 16 MPCP opcode values should have their"
    "MPCP time overwritten. Opcode values 0 and 1 are always disabled.  The"
    "14 MPCP opcode values in the range of 2-15 can be enabled by setting"
    "the corresponding bit. The reset default value is 0x0058.",
#endif
    EPN_VALID_OPCODE_MAP_REG_OFFSET,
    0,
    0,
    100,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_VALID_OPCODE_MAP_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UP_PACKET_TX_MARGIN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UP_PACKET_TX_MARGIN_FIELDS[] =
{
    &EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD,
    &EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UP_PACKET_TX_MARGIN_REG = 
{
    "UP_PACKET_TX_MARGIN",
#if RU_INCLUDE_DESC
    "EPN_UP_PACKET_TX_MARGIN Register",
    "Specifies the setup time margin for upstream data transfers to LIF."
    "This margin is used to police the arrival time of data from the"
    "Runner/BBH upstream data path. If BBH fails to deliver (any part of) a"
    "packet in time, EPON inserts a \"fake packet\" into the upstream burst to"
    "substitute for the late-delivered packet. When the actual packet is"
    "eventually delivered from BBH, EPON discards it. Fake packets are"
    "zero-padded and contain a guaranteed-bad FCS."
    "The upPacketTxMargin value needs to be larger than the upstream data"
    "path latency. The upstream data path latency is composed of LIF data"
    "path delay + MPCP time jitter + EPN data path delay (upTimeStampOff +"
    "42 + 1 + 10). Please note that EPN's 10 TQ upstream data path latency"
    "includes 3 TQ for the LIF to respond to valid data on the upstream"
    "EPN-to-LIF interface, and LIF's upstream data path latency includes the"
    "provisioned upTimeStampOff value.  This is because the LIF does not"
    "process a grant until it receives data from the EPN.  So, the initial"
    "packet data must arrive 42 time quanta before the Grant Start Time.",
#endif
    EPN_UP_PACKET_TX_MARGIN_REG_OFFSET,
    0,
    0,
    101,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_UP_PACKET_TX_MARGIN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_MULTI_PRI_CFG_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_MULTI_PRI_CFG_0_FIELDS[] =
{
    &EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD,
    &EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD,
    &EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD,
    &EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD,
    &EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD,
    &EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD,
    &EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD,
    &EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD,
    &EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD,
    &EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD,
    &EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD,
    &EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_MULTI_PRI_CFG_0_REG = 
{
    "MULTI_PRI_CFG_0",
#if RU_INCLUDE_DESC
    "EPN_MULTI_PRI_CFG_0 Register",
    "This register configures Multi-Priority reporting for all LLID indices",
#endif
    EPN_MULTI_PRI_CFG_0_REG_OFFSET,
    0,
    0,
    102,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    12,
    EPN_MULTI_PRI_CFG_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_SHARED_BCAP_OVRFLOW
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_SHARED_BCAP_OVRFLOW_FIELDS[] =
{
    &EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD,
    &EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_SHARED_BCAP_OVRFLOW_REG = 
{
    "SHARED_BCAP_OVRFLOW",
#if RU_INCLUDE_DESC
    "EPN_SHARED_BCAP_OVRFLOW Register",
    "",
#endif
    EPN_SHARED_BCAP_OVRFLOW_REG_OFFSET,
    0,
    0,
    103,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_SHARED_BCAP_OVRFLOW_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_FORCED_REPORT_EN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_FORCED_REPORT_EN_FIELDS[] =
{
    &EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_FORCED_REPORT_EN_REG = 
{
    "FORCED_REPORT_EN",
#if RU_INCLUDE_DESC
    "EPN_FORCED_REPORT_EN Register",
    "Option to force an upstream report for an LLID Index that has not"
    "received an upstream grant with the \"force report\" bit set in more than"
    "50 mS. This mode is enabled per-LLID Index.   Discovery gates will not"
    "have their \"force report\" bits set.  This bit should not be enabled"
    "unless the LLID index is registered with the OLT.",
#endif
    EPN_FORCED_REPORT_EN_REG_OFFSET,
    0,
    0,
    104,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_FORCED_REPORT_EN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_FORCED_REPORT_MAX_INTERVAL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_FORCED_REPORT_MAX_INTERVAL_FIELDS[] =
{
    &EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD,
    &EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_FORCED_REPORT_MAX_INTERVAL_REG = 
{
    "FORCED_REPORT_MAX_INTERVAL",
#if RU_INCLUDE_DESC
    "EPN_FORCED_REPORT_MAX_INTERVAL Register",
    "Option to force an upstream report for an LLID Index that has not"
    "received an upstream grant with the \"force report\" bit set in more than"
    "50 mS. This mode is enabled per-LLID Index.   Discovery gates will not"
    "have their \"force report\" bits set.  This bit should not be enabled"
    "unless the LLID index is registered with the OLT.",
#endif
    EPN_FORCED_REPORT_MAX_INTERVAL_REG_OFFSET,
    0,
    0,
    105,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_FORCED_REPORT_MAX_INTERVAL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_L2S_FLUSH_CONFIG
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_L2S_FLUSH_CONFIG_FIELDS[] =
{
    &EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD,
    &EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD,
    &EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD,
    &EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_L2S_FLUSH_CONFIG_REG = 
{
    "L2S_FLUSH_CONFIG",
#if RU_INCLUDE_DESC
    "EPN_L2S_FLUSH_CONFIG Register",
    "Provides a mechanism to flush an L2 queue. The associated LLID index"
    "must be upstream disabled (including waiting for the upstream LLID"
    "index enable feedback confirmation) before starting the flush"
    "mechanism. Once an LLID index has been disabled, the L2 queues that"
    "comprise it may be flushed one at a time via this register. A flush is"
    "started by writing the cfgFlushL2sSel field and setting the"
    "cfgFlushL2sEn bit. The flushL2sDone bit will be set by the hardware"
    "when the selected L2 queue has been flushed.  Note: Do not change the"
    "cfgFlushL2sSel value unless both \"flushL2sDone\" and \"cfgFlushL2sEn\" are"
    "low.",
#endif
    EPN_L2S_FLUSH_CONFIG_REG_OFFSET,
    0,
    0,
    106,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_L2S_FLUSH_CONFIG_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DATA_PORT_COMMAND
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DATA_PORT_COMMAND_FIELDS[] =
{
    &EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD,
    &EPN_DATA_PORT_COMMAND_RESERVED0_FIELD,
    &EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD,
    &EPN_DATA_PORT_COMMAND_RESERVED1_FIELD,
    &EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DATA_PORT_COMMAND_REG = 
{
    "DATA_PORT_COMMAND",
#if RU_INCLUDE_DESC
    "EPN_DATA_PORT_COMMAND Register",
    "This set of registers allows processor access to RAMs controlled by the"
    "modules in the EPON block. Data Port Control indicates whether a read"
    "or write access is occurring. Data Port Select indicates which RAM is"
    "being accessed. Writing to the Data Port Command register (offset 0)"
    "initiates the memory access."
    "The processor may only access the Downstream Statistics RAM and"
    "Upstream Statistics RAM during run time. Accessing the L2 queue RAM may"
    "cause the EPON to fail in an unknown and random way."
    "The flow for a write operation is as follows."
    "1. Check if the Data Port Interrupt is ready."
    "2. Update the Data Port Address register."
    "3. Update the Data Port Data register"
    "4. Update the Data Port Command register. Write a \"1\" to the Data"
    "Port Control and the RAM's index into the Data Port Select."
    "5. The operation is completed when the Data Port Interrupt is"
    "ready again."
    "The flow for a read operation is as follows."
    "1. Check if the Data Port Interrupt is ready."
    "2. Update the Data Port Address register."
    "3. Update the Data Port Command register. Write a \"0\" to the Data"
    "Port Control and the RAM's index into the Data Port Select."
    "4. Check to see if the Data Port Interrupt is read."
    "5. Read the Data Port Data register to get the operation's"
    "results."
    ""
    "RAM Name  RAM Size AutoInit?"
    "Downstream Statistics   672 x 32 Yes"
    "Upstream Statistics  1088 x 32 Yes"
    "L2 Queue RAM  16384 x 22 No"
    ""
    "The Downstream Statistics RAMs accumulate statistics for 32 LLIDs. Each"
    "LLID occupies 21 RAM offsets.  Downstream Statistics RAM definition are"
    "as follows :"
    ""
    "LLID Index RAM Locations"
    "0    0 - 20"
    "1   21 - 41"
    "2   42 - 62"
    "."
    "."
    "n (up to 32)  (n*21) - (n*21)+20"
    ""
    "RAM Offset  Description"
    "0     Total bytes received"
    "1     FCS Errors"
    "2     OAM frames received"
    "3     GATE frames received"
    "4     64 byte frames received"
    "5     65 - 127 byte frames received"
    "6     128 - 255 byte frames received"
    "7     256 - 511 byte frames received"
    "8     512 - 1023 byte frames received"
    "9     1024 - 1518 byte frames received"
    "10     1519 - 2047 byte frames received"
    "11     2048 - 4095 byte frames received"
    "12     4096 - 9216 byte frames received"
    "13     Greater than 9216 byte frames received"
    "14     Oversized frames received"
    "15     Broadcast frames received"
    "16     Multicast frames received"
    "17     Unicast frames received"
    "18     Undersized frames received"
    "19     OAM bytes received"
    "20     Register frames received"
    ""
    "The Upstream Statistics RAMs accumulate statistics for 32 LLIDs. Each"
    "LLID occupies 17 RAM offsets.  It is logically divided into 64"
    "segments.  The lower 32 segments contain the normal upstream statistics"
    "for each of the 32 LLID Indexes.  The upper 32 segments are used to"
    "report the \"fake packet\" statistics.  Fake packets are inserted into"
    "upstream bursts to substitute for packets that are delivered late from"
    "the Runner/BBH subsystem. Fake packets are zero-padded and contain a"
    "guaranteed-bad FCS. Note that a faked packet can cause broadcast and"
    "multicast packets to be reported as unicast packets, depending on"
    "whether the Runner/BBH upstream data delivery failure occurred before"
    "the DA data was delivered."
    ""
    "LLID Index RAM Locations"
    "0    0 - 16"
    "1   17 - 33"
    "2   34 - 50"
    "."
    "."
    "n (up to 32)  (n*17) - (n*17)+16"
    "Fake packet 0  544 - 560"
    "Fake packet 1  561 - 577"
    "Fake packet 2  578 - 594"
    "."
    "."
    "Fake packet n  [544+(n*17)] - [544+(n*17)+16]"
    ""
    ""
    "RAM Offset  Description"
    "0     Total bytes sent"
    "1     OAM frames sent"
    "2     REPORT frames sent"
    "3     64 byte frames sent"
    "4     65 - 127 byte frames sent"
    "5     128 - 255 byte frames sent"
    "6     256 - 511 byte frames sent"
    "7     512 - 1023 byte frames sent"
    "8     1024 - 1518 byte frames sent"
    "9     1519 - 2047 byte frames sent"
    "10     2048 - 4095 byte frames sent"
    "11     4096 - 9216 byte frames sent"
    "12     Greater than 9216 byte frames sent"
    "13     OAM bytes sent"
    "14     Broadcast frames sent"
    "15     Multicast frames sent"
    "16     Unicast frames sent"
    ""
    "Notes:"
    "Total bytes sent do not include OAM or Report frames."
    "The various frame \"bucket\" statistics do not include OAM or Report"
    "frames."
    "Oversized frames are frames that are greater than the value specified"
    "by the EPON Max Frame Size register. The exception is when cfgVlanMax"
    "mode is used. In this case an oversized condition occurs when a frame"
    "is greater than 1522 byte when a VLAN tag is present, otherwise greater"
    "than 1518 bytes"
    "An undersized frame condition occurs when the received frame is less"
    "than 64 bytes in length and has a valid FCS."
    "The Unused Words counts the number of words that in a grant that the"
    "LLID was not able to send upstream traffic on. If the LLID received a"
    "grant for 2K words, but it has only 1K words of data, the unused word"
    "count will increase by 1 K. In most cases this condition should not"
    "happen. It indicates that the OLT is granting inefficiently. There"
    "could be a problem with the ONU's EPON overhead setting being"
    "incorrect.",
#endif
    EPN_DATA_PORT_COMMAND_REG_OFFSET,
    0,
    0,
    107,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    5,
    EPN_DATA_PORT_COMMAND_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DATA_PORT_ADDRESS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DATA_PORT_ADDRESS_FIELDS[] =
{
    &EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD,
    &EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DATA_PORT_ADDRESS_REG = 
{
    "DATA_PORT_ADDRESS",
#if RU_INCLUDE_DESC
    "EPN_DATA_PORT_ADDRESS Register",
    "",
#endif
    EPN_DATA_PORT_ADDRESS_REG_OFFSET,
    0,
    0,
    108,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_DATA_PORT_ADDRESS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DATA_PORT_DATA_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DATA_PORT_DATA_0_FIELDS[] =
{
    &EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DATA_PORT_DATA_0_REG = 
{
    "DATA_PORT_DATA_0",
#if RU_INCLUDE_DESC
    "EPN_DATA_PORT_DATA_0 Register",
    "",
#endif
    EPN_DATA_PORT_DATA_0_REG_OFFSET,
    0,
    0,
    109,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_DATA_PORT_DATA_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNMAP_BIG_CNT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNMAP_BIG_CNT_FIELDS[] =
{
    &EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNMAP_BIG_CNT_REG = 
{
    "UNMAP_BIG_CNT",
#if RU_INCLUDE_DESC
    "EPN_UNMAP_BIG_CNT Register",
    "Statistics register for traffic sent on unmapped LLIDs."
    "This register saturates at maximum value and self-clears when read.",
#endif
    EPN_UNMAP_BIG_CNT_REG_OFFSET,
    0,
    0,
    110,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNMAP_BIG_CNT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNMAP_FRAME_CNT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNMAP_FRAME_CNT_FIELDS[] =
{
    &EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNMAP_FRAME_CNT_REG = 
{
    "UNMAP_FRAME_CNT",
#if RU_INCLUDE_DESC
    "EPN_UNMAP_FRAME_CNT Register",
    "Statistics register for traffic sent on unmapped LLIDs."
    "This register saturates at maximum value and self-clears when read.",
#endif
    EPN_UNMAP_FRAME_CNT_REG_OFFSET,
    0,
    0,
    111,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNMAP_FRAME_CNT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNMAP_FCS_CNT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNMAP_FCS_CNT_FIELDS[] =
{
    &EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNMAP_FCS_CNT_REG = 
{
    "UNMAP_FCS_CNT",
#if RU_INCLUDE_DESC
    "EPN_UNMAP_FCS_CNT Register",
    "Statistics register for traffic sent on unmapped LLIDs."
    "This register saturates at maximum value and self-clears when read.",
#endif
    EPN_UNMAP_FCS_CNT_REG_OFFSET,
    0,
    0,
    112,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNMAP_FCS_CNT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNMAP_GATE_CNT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNMAP_GATE_CNT_FIELDS[] =
{
    &EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNMAP_GATE_CNT_REG = 
{
    "UNMAP_GATE_CNT",
#if RU_INCLUDE_DESC
    "EPN_UNMAP_GATE_CNT Register",
    "Statistics register for traffic sent on unmapped LLIDs."
    "This register saturates at maximum value and self-clears when read.",
#endif
    EPN_UNMAP_GATE_CNT_REG_OFFSET,
    0,
    0,
    113,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNMAP_GATE_CNT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNMAP_OAM_CNT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNMAP_OAM_CNT_FIELDS[] =
{
    &EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNMAP_OAM_CNT_REG = 
{
    "UNMAP_OAM_CNT",
#if RU_INCLUDE_DESC
    "EPN_UNMAP_OAM_CNT Register",
    "Statistics register for traffic sent on unmapped LLIDs."
    "This register saturates at maximum value and self-clears when read.",
#endif
    EPN_UNMAP_OAM_CNT_REG_OFFSET,
    0,
    0,
    114,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNMAP_OAM_CNT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNMAP_SMALL_CNT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNMAP_SMALL_CNT_FIELDS[] =
{
    &EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNMAP_SMALL_CNT_REG = 
{
    "UNMAP_SMALL_CNT",
#if RU_INCLUDE_DESC
    "EPN_UNMAP_SMALL_CNT Register",
    "Statistics register for traffic sent on unmapped LLIDs."
    "This register saturates at maximum value and self-clears when read.",
#endif
    EPN_UNMAP_SMALL_CNT_REG_OFFSET,
    0,
    0,
    115,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNMAP_SMALL_CNT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_FIF_DEQUEUE_EVENT_CNT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_FIF_DEQUEUE_EVENT_CNT_FIELDS[] =
{
    &EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_FIF_DEQUEUE_EVENT_CNT_REG = 
{
    "FIF_DEQUEUE_EVENT_CNT",
#if RU_INCLUDE_DESC
    "EPN_FIF_DEQUEUE_EVENT_CNT Register",
    "",
#endif
    EPN_FIF_DEQUEUE_EVENT_CNT_REG_OFFSET,
    0,
    0,
    116,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_FIF_DEQUEUE_EVENT_CNT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BBH_UP_FAULT_HALT_EN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BBH_UP_FAULT_HALT_EN_FIELDS[] =
{
    &EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BBH_UP_FAULT_HALT_EN_REG = 
{
    "BBH_UP_FAULT_HALT_EN",
#if RU_INCLUDE_DESC
    "EPN_BBH_UP_FAULT_HALT_EN Register",
    "Per-LLID index Runner/BBH upstream fault halt enable.  This allows the"
    "default fatal upstream fault halt behavior to be disabled.  The reset"
    "default value is enabled (all ones).  This register should only be used"
    "for debug.  All the bits in this register must be set during normal"
    "operation.",
#endif
    EPN_BBH_UP_FAULT_HALT_EN_REG_OFFSET,
    0,
    0,
    117,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_BBH_UP_FAULT_HALT_EN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BBH_UP_TARDY_HALT_EN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BBH_UP_TARDY_HALT_EN_FIELDS[] =
{
    &EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD,
    &EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BBH_UP_TARDY_HALT_EN_REG = 
{
    "BBH_UP_TARDY_HALT_EN",
#if RU_INCLUDE_DESC
    "EPN_BBH_UP_TARDY_HALT_EN Register",
    "Per-LLID index Runner/BBH upstream fault halt enable.  This allows the"
    "default fatal upstream fault halt behavior to be disabled.  The reset"
    "default value is enabled (all ones).  This register should only be used"
    "for debug.  All the bits in this register must be set during normal"
    "operation.",
#endif
    EPN_BBH_UP_TARDY_HALT_EN_REG_OFFSET,
    0,
    0,
    118,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BBH_UP_TARDY_HALT_EN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DEBUG_STATUS_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DEBUG_STATUS_0_FIELDS[] =
{
    &EPN_DEBUG_STATUS_0_RESERVED0_FIELD,
    &EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD,
    &EPN_DEBUG_STATUS_0_RESERVED1_FIELD,
    &EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD,
    &EPN_DEBUG_STATUS_0_DNSECFULL_FIELD,
    &EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DEBUG_STATUS_0_REG = 
{
    "DEBUG_STATUS_0",
#if RU_INCLUDE_DESC
    "EPN_DEBUG_STATUS_0 Register",
    "This register contains the real time status bits to aid debugging the"
    "EPN module.",
#endif
    EPN_DEBUG_STATUS_0_REG_OFFSET,
    0,
    0,
    119,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    6,
    EPN_DEBUG_STATUS_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DEBUG_STATUS_1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DEBUG_STATUS_1_FIELDS[] =
{
    &EPN_DEBUG_STATUS_1_GNTRDY31_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY30_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY29_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY28_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY27_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY26_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY25_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY24_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY23_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY22_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY21_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY20_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY19_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY18_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY17_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY16_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY15_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY14_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY13_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY12_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY11_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY10_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY9_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY8_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY7_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY6_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY5_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY4_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY3_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY2_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY1_FIELD,
    &EPN_DEBUG_STATUS_1_GNTRDY0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DEBUG_STATUS_1_REG = 
{
    "DEBUG_STATUS_1",
#if RU_INCLUDE_DESC
    "EPN_DEBUG_STATUS_1 Register",
    "This register contains the real time status bits to aid debugging the"
    "EPN module.",
#endif
    EPN_DEBUG_STATUS_1_REG_OFFSET,
    0,
    0,
    120,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    32,
    EPN_DEBUG_STATUS_1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DEBUG_L2S_PTR_SEL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DEBUG_L2S_PTR_SEL_FIELDS[] =
{
    &EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD,
    &EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD,
    &EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD,
    &EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DEBUG_L2S_PTR_SEL_REG = 
{
    "DEBUG_L2S_PTR_SEL",
#if RU_INCLUDE_DESC
    "EPN_DEBUG_L2S_PTR_SEL Register",
    "",
#endif
    EPN_DEBUG_L2S_PTR_SEL_REG_OFFSET,
    0,
    0,
    121,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_DEBUG_L2S_PTR_SEL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_OLT_MAC_ADDR_LO
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_OLT_MAC_ADDR_LO_FIELDS[] =
{
    &EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_OLT_MAC_ADDR_LO_REG = 
{
    "OLT_MAC_ADDR_LO",
#if RU_INCLUDE_DESC
    "EPN_OLT_MAC_ADDR_LO Register",
    "This register stores a MAC address for the OLT. This address is"
    "inserted as the DA in REPORT frames sent upstream.",
#endif
    EPN_OLT_MAC_ADDR_LO_REG_OFFSET,
    0,
    0,
    122,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_OLT_MAC_ADDR_LO_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_OLT_MAC_ADDR_HI
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_OLT_MAC_ADDR_HI_FIELDS[] =
{
    &EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD,
    &EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_OLT_MAC_ADDR_HI_REG = 
{
    "OLT_MAC_ADDR_HI",
#if RU_INCLUDE_DESC
    "EPN_OLT_MAC_ADDR_HI Register",
    "This register stores a MAC address for the OLT. This address is"
    "inserted as the DA in REPORT frames sent upstream.",
#endif
    EPN_OLT_MAC_ADDR_HI_REG_OFFSET,
    0,
    0,
    123,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_OLT_MAC_ADDR_HI_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_DQU_EMPTY
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_DQU_EMPTY_FIELDS[] =
{
    &EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_DQU_EMPTY_REG = 
{
    "TX_L1S_SHP_DQU_EMPTY",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_DQU_EMPTY Register",
    "Indicates empty status of L1 shaped queues",
#endif
    EPN_TX_L1S_SHP_DQU_EMPTY_REG_OFFSET,
    0,
    0,
    124,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_DQU_EMPTY_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_UNSHAPED_EMPTY
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_UNSHAPED_EMPTY_FIELDS[] =
{
    &EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_UNSHAPED_EMPTY_REG = 
{
    "TX_L1S_UNSHAPED_EMPTY",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_UNSHAPED_EMPTY Register",
    "Indicates status of L1 unshaped-empty accumulators",
#endif
    EPN_TX_L1S_UNSHAPED_EMPTY_REG_OFFSET,
    0,
    0,
    125,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_UNSHAPED_EMPTY_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_EMPTY
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_EMPTY_FIELDS[] =
{
    &EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_EMPTY_REG = 
{
    "TX_L2S_QUE_EMPTY",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_EMPTY Register",
    "L2 queue empty status",
#endif
    EPN_TX_L2S_QUE_EMPTY_REG_OFFSET,
    0,
    0,
    126,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L2S_QUE_EMPTY_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_FULL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_FULL_FIELDS[] =
{
    &EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_FULL_REG = 
{
    "TX_L2S_QUE_FULL",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_FULL Register",
    "L2 queue full status",
#endif
    EPN_TX_L2S_QUE_FULL_REG_OFFSET,
    0,
    0,
    127,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L2S_QUE_FULL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_STOPPED
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_STOPPED_FIELDS[] =
{
    &EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_STOPPED_REG = 
{
    "TX_L2S_QUE_STOPPED",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_STOPPED Register",
    "L2 queue stopped status",
#endif
    EPN_TX_L2S_QUE_STOPPED_REG_OFFSET,
    0,
    0,
    128,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L2S_QUE_STOPPED_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_FIELDS[] =
{
    &EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD,
    &EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_REG = 
{
    "BBH_MAX_OUTSTANDING_TARDY_PACKETS",
#if RU_INCLUDE_DESC
    "EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS Register",
    "Everytime the BBH fails to deliver a packet in time to be transmitted"
    "upstream"
    "it is placed in failed state and the Epn increments a tardy packet"
    "counter.  Every time the BBH delivers a packet"
    "while it is in the failed state the tardy packet counter is"
    "decremented.  The BBH will be taken out of the"
    "failed state when the tardy packet counter reaches 0.  If the tardy"
    "packet counter"
    "value exceeds the value of this register; then the BBH becomes truant"
    "and the Epn stops upstream traffic until"
    "the Epn is reset.  It is expected the BBH, runner and Epn will be reset"
    "at the same time.",
#endif
    EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_REG_OFFSET,
    0,
    0,
    129,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_MIN_REPORT_VALUE_DIFFERENCE
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_MIN_REPORT_VALUE_DIFFERENCE_FIELDS[] =
{
    &EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD,
    &EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_MIN_REPORT_VALUE_DIFFERENCE_REG = 
{
    "MIN_REPORT_VALUE_DIFFERENCE",
#if RU_INCLUDE_DESC
    "EPN_MIN_REPORT_VALUE_DIFFERENCE Register",
    "The Virtual Thresholds are determined from the smaller of the queue set"
    "shaper and the accumulated queue length.  The Virtual Thresholds must"
    "also prevent pathological values from being reported.  The reported"
    "value should be at least one maximum frame length greater than the"
    "previous queue set threshold or else it will be reported as zero.  This"
    "prevents a head of line blocking issue if a large frame is at the head"
    "of the queue and also prevents from reporting illegally short grant"
    "lengths.Everytime the BBH fails to deliver a packet in time to be"
    "transmitted upstream",
#endif
    EPN_MIN_REPORT_VALUE_DIFFERENCE_REG_OFFSET,
    0,
    0,
    130,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_MIN_REPORT_VALUE_DIFFERENCE_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BBH_STATUS_FIFO_OVERFLOW
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BBH_STATUS_FIFO_OVERFLOW_FIELDS[] =
{
    &EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BBH_STATUS_FIFO_OVERFLOW_REG = 
{
    "BBH_STATUS_FIFO_OVERFLOW",
#if RU_INCLUDE_DESC
    "EPN_BBH_STATUS_FIFO_OVERFLOW Register",
    "Indicates which BBH queue status interface event FIFOs have overflowed."
    "Note: These bits are used for debug only.",
#endif
    EPN_BBH_STATUS_FIFO_OVERFLOW_REG_OFFSET,
    0,
    0,
    131,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_BBH_STATUS_FIFO_OVERFLOW_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_SPARE_CTL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_SPARE_CTL_FIELDS[] =
{
    &EPN_SPARE_CTL_CFGEPNSPARE_FIELD,
    &EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD,
    &EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_SPARE_CTL_REG = 
{
    "SPARE_CTL",
#if RU_INCLUDE_DESC
    "EPN_SPARE_CTL Register",
    "Spare RW bits",
#endif
    EPN_SPARE_CTL_REG_OFFSET,
    0,
    0,
    132,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    3,
    EPN_SPARE_CTL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TS_SYNC_OFFSET
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TS_SYNC_OFFSET_FIELDS[] =
{
    &EPN_TS_SYNC_OFFSET_RESERVED0_FIELD,
    &EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TS_SYNC_OFFSET_REG = 
{
    "TS_SYNC_OFFSET",
#if RU_INCLUDE_DESC
    "EPN_TS_SYNC_OFFSET Register",
    "Timestamp synchronizer offset.",
#endif
    EPN_TS_SYNC_OFFSET_REG_OFFSET,
    0,
    0,
    133,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TS_SYNC_OFFSET_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DN_TS_OFFSET
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DN_TS_OFFSET_FIELDS[] =
{
    &EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DN_TS_OFFSET_REG = 
{
    "DN_TS_OFFSET",
#if RU_INCLUDE_DESC
    "EPN_DN_TS_OFFSET Register",
    "Downstream timestamp offset.",
#endif
    EPN_DN_TS_OFFSET_REG_OFFSET,
    0,
    0,
    134,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_DN_TS_OFFSET_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UP_TS_OFFSET_LO
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UP_TS_OFFSET_LO_FIELDS[] =
{
    &EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UP_TS_OFFSET_LO_REG = 
{
    "UP_TS_OFFSET_LO",
#if RU_INCLUDE_DESC
    "EPN_UP_TS_OFFSET_LO Register",
    "Upstream timestamp offset, lower 32 bits.",
#endif
    EPN_UP_TS_OFFSET_LO_REG_OFFSET,
    0,
    0,
    135,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UP_TS_OFFSET_LO_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UP_TS_OFFSET_HI
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UP_TS_OFFSET_HI_FIELDS[] =
{
    &EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD,
    &EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UP_TS_OFFSET_HI_REG = 
{
    "UP_TS_OFFSET_HI",
#if RU_INCLUDE_DESC
    "EPN_UP_TS_OFFSET_HI Register",
    "Upstream timestamp offset, upper 16 bits.",
#endif
    EPN_UP_TS_OFFSET_HI_REG_OFFSET,
    0,
    0,
    136,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_UP_TS_OFFSET_HI_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TWO_STEP_TS_CTL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TWO_STEP_TS_CTL_FIELDS[] =
{
    &EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD,
    &EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD,
    &EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TWO_STEP_TS_CTL_REG = 
{
    "TWO_STEP_TS_CTL",
#if RU_INCLUDE_DESC
    "EPN_TWO_STEP_TS_CTL Register",
    "Provides control for the reading of two step timestamp FIFO, 4 entries"
    "deep.",
#endif
    EPN_TWO_STEP_TS_CTL_REG_OFFSET,
    0,
    0,
    137,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    3,
    EPN_TWO_STEP_TS_CTL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TWO_STEP_TS_VALUE_LO
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TWO_STEP_TS_VALUE_LO_FIELDS[] =
{
    &EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TWO_STEP_TS_VALUE_LO_REG = 
{
    "TWO_STEP_TS_VALUE_LO",
#if RU_INCLUDE_DESC
    "EPN_TWO_STEP_TS_VALUE_LO Register",
    "Lower 32-bits of 48-bits timestamp value, applicable for two step"
    "timestamping.",
#endif
    EPN_TWO_STEP_TS_VALUE_LO_REG_OFFSET,
    0,
    0,
    138,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TWO_STEP_TS_VALUE_LO_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TWO_STEP_TS_VALUE_HI
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TWO_STEP_TS_VALUE_HI_FIELDS[] =
{
    &EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD,
    &EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TWO_STEP_TS_VALUE_HI_REG = 
{
    "TWO_STEP_TS_VALUE_HI",
#if RU_INCLUDE_DESC
    "EPN_TWO_STEP_TS_VALUE_HI Register",
    "Upper 16-bits of 48-bits timestamp value, applicable for two step"
    "timestamping.",
#endif
    EPN_TWO_STEP_TS_VALUE_HI_REG_OFFSET,
    0,
    0,
    139,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TWO_STEP_TS_VALUE_HI_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_1588_TIMESTAMP_INT_STATUS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_1588_TIMESTAMP_INT_STATUS_FIELDS[] =
{
    &EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD,
    &EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD,
    &EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_1588_TIMESTAMP_INT_STATUS_REG = 
{
    "1588_TIMESTAMP_INT_STATUS",
#if RU_INCLUDE_DESC
    "EPN_1588_TIMESTAMP_INT_STATUS Register",
    "This register contains interrupt status for 1588 timestamp. These bits"
    "are sticky; to clear a bit, write 1 to it.",
#endif
    EPN_1588_TIMESTAMP_INT_STATUS_REG_OFFSET,
    0,
    0,
    140,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    3,
    EPN_1588_TIMESTAMP_INT_STATUS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_1588_TIMESTAMP_INT_MASK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_1588_TIMESTAMP_INT_MASK_FIELDS[] =
{
    &EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD,
    &EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD,
    &EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_1588_TIMESTAMP_INT_MASK_REG = 
{
    "1588_TIMESTAMP_INT_MASK",
#if RU_INCLUDE_DESC
    "EPN_1588_TIMESTAMP_INT_MASK Register",
    "This register contains interrupt mask for 1588 timestamp interrupts.",
#endif
    EPN_1588_TIMESTAMP_INT_MASK_REG_OFFSET,
    0,
    0,
    141,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    3,
    EPN_1588_TIMESTAMP_INT_MASK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UP_PACKET_FETCH_MARGIN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UP_PACKET_FETCH_MARGIN_FIELDS[] =
{
    &EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD,
    &EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UP_PACKET_FETCH_MARGIN_REG = 
{
    "UP_PACKET_FETCH_MARGIN",
#if RU_INCLUDE_DESC
    "EPN_UP_PACKET_FETCH_MARGIN Register",
    "Specifies the setup time margin for the BBH to fetch upstream data to"
    "transfer to EPN."
    "This margin MUST be used when the Epn is provisioned to delay the burst"
    "termination while waiting for the Runner/BBH upstream queue status to"
    "be updated."
    "(see prvBbhQueStatDelay)"
    "The Power-On Reset default value of 0 will disable this delay."
    "The units are in TimeQuanta (TQ = 16nS).  The estimated DDR latency is"
    "2 [uS].  So, the minimum non-zero value for this register is 223 [TQ].",
#endif
    EPN_UP_PACKET_FETCH_MARGIN_REG_OFFSET,
    0,
    0,
    142,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_UP_PACKET_FETCH_MARGIN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_DN_1588_TIMESTAMP
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_DN_1588_TIMESTAMP_FIELDS[] =
{
    &EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_DN_1588_TIMESTAMP_REG = 
{
    "DN_1588_TIMESTAMP",
#if RU_INCLUDE_DESC
    "EPN_DN_1588_TIMESTAMP Register",
    "Provides real time indication of 1588 downstream timestamp.  A change"
    "in value indicates downstream traffic to BBH.",
#endif
    EPN_DN_1588_TIMESTAMP_REG_OFFSET,
    0,
    0,
    143,
#if RU_INCLUDE_ACCESS
    ru_access_read,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_DN_1588_TIMESTAMP_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_PERSISTENT_REPORT_CFG
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_PERSISTENT_REPORT_CFG_FIELDS[] =
{
    &EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD,
    &EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD,
    &EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_PERSISTENT_REPORT_CFG_REG = 
{
    "PERSISTENT_REPORT_CFG",
#if RU_INCLUDE_DESC
    "EPN_PERSISTENT_REPORT_CFG Register",
    "Specifies how long reports should persist.",
#endif
    EPN_PERSISTENT_REPORT_CFG_REG_OFFSET,
    0,
    0,
    144,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    3,
    EPN_PERSISTENT_REPORT_CFG_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_PERSISTENT_REPORT_ENABLES
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_PERSISTENT_REPORT_ENABLES_FIELDS[] =
{
    &EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_PERSISTENT_REPORT_ENABLES_REG = 
{
    "PERSISTENT_REPORT_ENABLES",
#if RU_INCLUDE_DESC
    "EPN_PERSISTENT_REPORT_ENABLES Register",
    "Per LLID enable for persistent reporting.",
#endif
    EPN_PERSISTENT_REPORT_ENABLES_REG_OFFSET,
    0,
    0,
    145,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_PERSISTENT_REPORT_ENABLES_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_PERSISTENT_REPORT_REQUEST_SIZE
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_PERSISTENT_REPORT_REQUEST_SIZE_FIELDS[] =
{
    &EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD,
    &EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_PERSISTENT_REPORT_REQUEST_SIZE_REG = 
{
    "PERSISTENT_REPORT_REQUEST_SIZE",
#if RU_INCLUDE_DESC
    "EPN_PERSISTENT_REPORT_REQUEST_SIZE Register",
    "How many Time Quanta the persistent report should request.",
#endif
    EPN_PERSISTENT_REPORT_REQUEST_SIZE_REG_OFFSET,
    0,
    0,
    146,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_PERSISTENT_REPORT_REQUEST_SIZE_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_AES_CONFIGURATION_1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_AES_CONFIGURATION_1_FIELDS[] =
{
    &EPN_AES_CONFIGURATION_1_PRVUPSTREAMAESMODE_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_AES_CONFIGURATION_1_REG = 
{
    "AES_CONFIGURATION_1",
#if RU_INCLUDE_DESC
    "EPN_AES_CONFIGURATION_1 Register",
    "Allows control over reporting the extra per-packet overhead associated"
    "with 802.1AE encryption. The AES overhead compensation logic supports"
    "two overhead modes: implicit SCI and explicit SCI. The implicit SCI"
    "mode increases the per-packet overhead by 24 bytes. Explicit SCI mode"
    "increases the per-packet overhead by 32 bytes.",
#endif
    EPN_AES_CONFIGURATION_1_REG_OFFSET,
    0,
    0,
    147,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_AES_CONFIGURATION_1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_0_FIELDS[] =
{
    &EPN_BURST_CAP_0_RESERVED0_FIELD,
    &EPN_BURST_CAP_0_BURSTCAP0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_0_REG = 
{
    "BURST_CAP_0",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_0 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_0_REG_OFFSET,
    0,
    0,
    148,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_1_FIELDS[] =
{
    &EPN_BURST_CAP_1_RESERVED0_FIELD,
    &EPN_BURST_CAP_1_BURSTCAP1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_1_REG = 
{
    "BURST_CAP_1",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_1 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_1_REG_OFFSET,
    0,
    0,
    149,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_2_FIELDS[] =
{
    &EPN_BURST_CAP_2_RESERVED0_FIELD,
    &EPN_BURST_CAP_2_BURSTCAP2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_2_REG = 
{
    "BURST_CAP_2",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_2 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_2_REG_OFFSET,
    0,
    0,
    150,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_3_FIELDS[] =
{
    &EPN_BURST_CAP_3_RESERVED0_FIELD,
    &EPN_BURST_CAP_3_BURSTCAP3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_3_REG = 
{
    "BURST_CAP_3",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_3 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_3_REG_OFFSET,
    0,
    0,
    151,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_4
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_4_FIELDS[] =
{
    &EPN_BURST_CAP_4_RESERVED0_FIELD,
    &EPN_BURST_CAP_4_BURSTCAP4_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_4_REG = 
{
    "BURST_CAP_4",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_4 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_4_REG_OFFSET,
    0,
    0,
    152,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_4_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_5
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_5_FIELDS[] =
{
    &EPN_BURST_CAP_5_RESERVED0_FIELD,
    &EPN_BURST_CAP_5_BURSTCAP5_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_5_REG = 
{
    "BURST_CAP_5",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_5 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_5_REG_OFFSET,
    0,
    0,
    153,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_5_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_6
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_6_FIELDS[] =
{
    &EPN_BURST_CAP_6_RESERVED0_FIELD,
    &EPN_BURST_CAP_6_BURSTCAP6_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_6_REG = 
{
    "BURST_CAP_6",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_6 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_6_REG_OFFSET,
    0,
    0,
    154,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_6_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_7
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_7_FIELDS[] =
{
    &EPN_BURST_CAP_7_RESERVED0_FIELD,
    &EPN_BURST_CAP_7_BURSTCAP7_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_7_REG = 
{
    "BURST_CAP_7",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_7 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_7_REG_OFFSET,
    0,
    0,
    155,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_7_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_0_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_0_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_0_QUELLIDMAP0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_0_REG = 
{
    "QUEUE_LLID_MAP_0",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_0 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_0_REG_OFFSET,
    0,
    0,
    156,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_1_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_1_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_1_QUELLIDMAP1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_1_REG = 
{
    "QUEUE_LLID_MAP_1",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_1 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_1_REG_OFFSET,
    0,
    0,
    157,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_2_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_2_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_2_QUELLIDMAP2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_2_REG = 
{
    "QUEUE_LLID_MAP_2",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_2 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_2_REG_OFFSET,
    0,
    0,
    158,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_3_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_3_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_3_QUELLIDMAP3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_3_REG = 
{
    "QUEUE_LLID_MAP_3",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_3 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_3_REG_OFFSET,
    0,
    0,
    159,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_4
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_4_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_4_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_4_QUELLIDMAP4_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_4_REG = 
{
    "QUEUE_LLID_MAP_4",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_4 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_4_REG_OFFSET,
    0,
    0,
    160,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_4_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_5
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_5_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_5_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_5_QUELLIDMAP5_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_5_REG = 
{
    "QUEUE_LLID_MAP_5",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_5 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_5_REG_OFFSET,
    0,
    0,
    161,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_5_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_6
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_6_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_6_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_6_QUELLIDMAP6_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_6_REG = 
{
    "QUEUE_LLID_MAP_6",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_6 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_6_REG_OFFSET,
    0,
    0,
    162,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_6_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_7
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_7_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_7_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_7_QUELLIDMAP7_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_7_REG = 
{
    "QUEUE_LLID_MAP_7",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_7 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_7_REG_OFFSET,
    0,
    0,
    163,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_7_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT0_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT0_UNUSEDTQCNT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT0_REG = 
{
    "UNUSED_TQ_CNT0",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT0 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT0_REG_OFFSET,
    0,
    0,
    164,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT1_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT1_UNUSEDTQCNT1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT1_REG = 
{
    "UNUSED_TQ_CNT1",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT1 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT1_REG_OFFSET,
    0,
    0,
    165,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT2_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT2_UNUSEDTQCNT2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT2_REG = 
{
    "UNUSED_TQ_CNT2",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT2 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT2_REG_OFFSET,
    0,
    0,
    166,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT3_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT3_UNUSEDTQCNT3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT3_REG = 
{
    "UNUSED_TQ_CNT3",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT3 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT3_REG_OFFSET,
    0,
    0,
    167,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT4
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT4_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT4_UNUSEDTQCNT4_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT4_REG = 
{
    "UNUSED_TQ_CNT4",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT4 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT4_REG_OFFSET,
    0,
    0,
    168,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT4_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT5
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT5_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT5_UNUSEDTQCNT5_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT5_REG = 
{
    "UNUSED_TQ_CNT5",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT5 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT5_REG_OFFSET,
    0,
    0,
    169,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT5_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT6
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT6_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT6_UNUSEDTQCNT6_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT6_REG = 
{
    "UNUSED_TQ_CNT6",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT6 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT6_REG_OFFSET,
    0,
    0,
    170,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT6_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT7
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT7_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT7_UNUSEDTQCNT7_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT7_REG = 
{
    "UNUSED_TQ_CNT7",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT7 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT7_REG_OFFSET,
    0,
    0,
    171,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT7_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_0_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_0_CFGSHPMASK0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_0_REG = 
{
    "TX_L1S_SHP_QUE_MASK_0",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_0 Register",
    "This register allows the effects of the upstream shaper 0 to be masked."
    "When multiple priority queues point to a common shaping bucket, the"
    "low priority traffic can use all the credits prior to a high priority"
    "frame arriving. The high priority would then incur additional latency"
    "waiting for credits to accrue. This adds undesirable delay to the data"
    "path. This feature separates the queues that apply credit to a shaper"
    "and those that are masked by the shaper. The Shaping function has an"
    "input that credits the shaping bucket when a frame is sent. It also has"
    "an output that masks a queue from being eligible to transmit when the"
    "shaping rate is violated. In this case the low priority queue will both"
    "credit and be masked by the shaper as typically done. The high priority"
    "on the other hand will credit the shaper, but not be limited by it. The"
    "shaper will then be allowed to go into a deficit. In most cases the"
    "high priority is a small portion of the total bandwidth. In some cases"
    "however it may be desired to limit the high priority traffic with a"
    "different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_0_REG_OFFSET,
    0,
    0,
    172,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_1_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_1_CFGSHPMASK1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_1_REG = 
{
    "TX_L1S_SHP_QUE_MASK_1",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_1 Register",
    "This register allows the effects of the upstream shaper 1 to be masked."
    "When multiple priority queues point to a common shaping bucket, the"
    "low priority traffic can use all the credits prior to a high priority"
    "frame arriving. The high priority would then incur additional latency"
    "waiting for credits to accrue. This adds undesirable delay to the data"
    "path. This feature separates the queues that apply credit to a shaper"
    "and those that are masked by the shaper. The Shaping function has an"
    "input that credits the shaping bucket when a frame is sent. It also has"
    "an output that masks a queue from being eligible to transmit when the"
    "shaping rate is violated. In this case the low priority queue will both"
    "credit and be masked by the shaper as typically done. The high priority"
    "on the other hand will credit the shaper, but not be limited by it. The"
    "shaper will then be allowed to go into a deficit. In most cases the"
    "high priority is a small portion of the total bandwidth. In some cases"
    "however it may be desired to limit the high priority traffic with a"
    "different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_1_REG_OFFSET,
    0,
    0,
    173,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_2_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_2_CFGSHPMASK2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_2_REG = 
{
    "TX_L1S_SHP_QUE_MASK_2",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_2 Register",
    "This register allows the effects of the upstream shaper 2 to be masked."
    "When multiple priority queues point to a common shaping bucket, the"
    "low priority traffic can use all the credits prior to a high priority"
    "frame arriving. The high priority would then incur additional latency"
    "waiting for credits to accrue. This adds undesirable delay to the data"
    "path. This feature separates the queues that apply credit to a shaper"
    "and those that are masked by the shaper. The Shaping function has an"
    "input that credits the shaping bucket when a frame is sent. It also has"
    "an output that masks a queue from being eligible to transmit when the"
    "shaping rate is violated. In this case the low priority queue will both"
    "credit and be masked by the shaper as typically done. The high priority"
    "on the other hand will credit the shaper, but not be limited by it. The"
    "shaper will then be allowed to go into a deficit. In most cases the"
    "high priority is a small portion of the total bandwidth. In some cases"
    "however it may be desired to limit the high priority traffic with a"
    "different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_2_REG_OFFSET,
    0,
    0,
    174,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_3_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_3_CFGSHPMASK3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_3_REG = 
{
    "TX_L1S_SHP_QUE_MASK_3",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_3 Register",
    "This register allows the effects of the upstream shaper 3 to be masked."
    "When multiple priority queues point to a common shaping bucket, the"
    "low priority traffic can use all the credits prior to a high priority"
    "frame arriving. The high priority would then incur additional latency"
    "waiting for credits to accrue. This adds undesirable delay to the data"
    "path. This feature separates the queues that apply credit to a shaper"
    "and those that are masked by the shaper. The Shaping function has an"
    "input that credits the shaping bucket when a frame is sent. It also has"
    "an output that masks a queue from being eligible to transmit when the"
    "shaping rate is violated. In this case the low priority queue will both"
    "credit and be masked by the shaper as typically done. The high priority"
    "on the other hand will credit the shaper, but not be limited by it. The"
    "shaper will then be allowed to go into a deficit. In most cases the"
    "high priority is a small portion of the total bandwidth. In some cases"
    "however it may be desired to limit the high priority traffic with a"
    "different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_3_REG_OFFSET,
    0,
    0,
    175,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_4
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_4_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_4_CFGSHPMASK4_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_4_REG = 
{
    "TX_L1S_SHP_QUE_MASK_4",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_4 Register",
    "This register allows the effects of the upstream shaper 4 to be masked."
    "When multiple priority queues point to a common shaping bucket, the"
    "low priority traffic can use all the credits prior to a high priority"
    "frame arriving. The high priority would then incur additional latency"
    "waiting for credits to accrue. This adds undesirable delay to the data"
    "path. This feature separates the queues that apply credit to a shaper"
    "and those that are masked by the shaper. The Shaping function has an"
    "input that credits the shaping bucket when a frame is sent. It also has"
    "an output that masks a queue from being eligible to transmit when the"
    "shaping rate is violated. In this case the low priority queue will both"
    "credit and be masked by the shaper as typically done. The high priority"
    "on the other hand will credit the shaper, but not be limited by it. The"
    "shaper will then be allowed to go into a deficit. In most cases the"
    "high priority is a small portion of the total bandwidth. In some cases"
    "however it may be desired to limit the high priority traffic with a"
    "different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_4_REG_OFFSET,
    0,
    0,
    176,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_4_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_5
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_5_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_5_CFGSHPMASK5_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_5_REG = 
{
    "TX_L1S_SHP_QUE_MASK_5",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_5 Register",
    "This register allows the effects of the upstream shaper 5 to be masked."
    "When multiple priority queues point to a common shaping bucket, the"
    "low priority traffic can use all the credits prior to a high priority"
    "frame arriving. The high priority would then incur additional latency"
    "waiting for credits to accrue. This adds undesirable delay to the data"
    "path. This feature separates the queues that apply credit to a shaper"
    "and those that are masked by the shaper. The Shaping function has an"
    "input that credits the shaping bucket when a frame is sent. It also has"
    "an output that masks a queue from being eligible to transmit when the"
    "shaping rate is violated. In this case the low priority queue will both"
    "credit and be masked by the shaper as typically done. The high priority"
    "on the other hand will credit the shaper, but not be limited by it. The"
    "shaper will then be allowed to go into a deficit. In most cases the"
    "high priority is a small portion of the total bandwidth. In some cases"
    "however it may be desired to limit the high priority traffic with a"
    "different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_5_REG_OFFSET,
    0,
    0,
    177,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_5_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_6
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_6_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_6_CFGSHPMASK6_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_6_REG = 
{
    "TX_L1S_SHP_QUE_MASK_6",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_6 Register",
    "This register allows the effects of the upstream shaper 6 to be masked."
    "When multiple priority queues point to a common shaping bucket, the"
    "low priority traffic can use all the credits prior to a high priority"
    "frame arriving. The high priority would then incur additional latency"
    "waiting for credits to accrue. This adds undesirable delay to the data"
    "path. This feature separates the queues that apply credit to a shaper"
    "and those that are masked by the shaper. The Shaping function has an"
    "input that credits the shaping bucket when a frame is sent. It also has"
    "an output that masks a queue from being eligible to transmit when the"
    "shaping rate is violated. In this case the low priority queue will both"
    "credit and be masked by the shaper as typically done. The high priority"
    "on the other hand will credit the shaper, but not be limited by it. The"
    "shaper will then be allowed to go into a deficit. In most cases the"
    "high priority is a small portion of the total bandwidth. In some cases"
    "however it may be desired to limit the high priority traffic with a"
    "different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_6_REG_OFFSET,
    0,
    0,
    178,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_6_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_7
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_7_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_7_CFGSHPMASK7_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_7_REG = 
{
    "TX_L1S_SHP_QUE_MASK_7",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_7 Register",
    "This register allows the effects of the upstream shaper 7 to be masked."
    "When multiple priority queues point to a common shaping bucket, the"
    "low priority traffic can use all the credits prior to a high priority"
    "frame arriving. The high priority would then incur additional latency"
    "waiting for credits to accrue. This adds undesirable delay to the data"
    "path. This feature separates the queues that apply credit to a shaper"
    "and those that are masked by the shaper. The Shaping function has an"
    "input that credits the shaping bucket when a frame is sent. It also has"
    "an output that masks a queue from being eligible to transmit when the"
    "shaping rate is violated. In this case the low priority queue will both"
    "credit and be masked by the shaper as typically done. The high priority"
    "on the other hand will credit the shaper, but not be limited by it. The"
    "shaper will then be allowed to go into a deficit. In most cases the"
    "high priority is a small portion of the total bandwidth. In some cases"
    "however it may be desired to limit the high priority traffic with a"
    "different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_7_REG_OFFSET,
    0,
    0,
    179,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_7_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_0_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_0_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUEEND0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_0_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUESTART0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_0_REG = 
{
    "TX_L2S_QUE_CONFIG_0",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_0 Register",
    "This registers configures the base addresses of the L2 structure 0."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_0_REG_OFFSET,
    0,
    0,
    180,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_1_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_1_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUEEND1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_1_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUESTART1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_1_REG = 
{
    "TX_L2S_QUE_CONFIG_1",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_1 Register",
    "This registers configures the base addresses of the L2 structure 1."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_1_REG_OFFSET,
    0,
    0,
    181,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_2_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_2_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUEEND2_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_2_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUESTART2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_2_REG = 
{
    "TX_L2S_QUE_CONFIG_2",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_2 Register",
    "This registers configures the base addresses of the L2 structure 2."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_2_REG_OFFSET,
    0,
    0,
    182,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_3_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_3_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUEEND3_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_3_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUESTART3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_3_REG = 
{
    "TX_L2S_QUE_CONFIG_3",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_3 Register",
    "This registers configures the base addresses of the L2 structure 3."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_3_REG_OFFSET,
    0,
    0,
    183,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_4
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_4_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_4_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUEEND4_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_4_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUESTART4_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_4_REG = 
{
    "TX_L2S_QUE_CONFIG_4",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_4 Register",
    "This registers configures the base addresses of the L2 structure 4."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_4_REG_OFFSET,
    0,
    0,
    184,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_4_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_5
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_5_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_5_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUEEND5_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_5_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUESTART5_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_5_REG = 
{
    "TX_L2S_QUE_CONFIG_5",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_5 Register",
    "This registers configures the base addresses of the L2 structure 5."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_5_REG_OFFSET,
    0,
    0,
    185,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_5_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_6
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_6_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_6_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUEEND6_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_6_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUESTART6_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_6_REG = 
{
    "TX_L2S_QUE_CONFIG_6",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_6 Register",
    "This registers configures the base addresses of the L2 structure 6."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_6_REG_OFFSET,
    0,
    0,
    186,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_6_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_7
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_7_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_7_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUEEND7_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_7_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUESTART7_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_7_REG = 
{
    "TX_L2S_QUE_CONFIG_7",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_7 Register",
    "This registers configures the base addresses of the L2 structure 7."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_7_REG_OFFSET,
    0,
    0,
    187,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_7_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_0_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_0_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_0_PRVBURSTLIMIT0_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_0_REG = 
{
    "TX_CTC_BURST_LIMIT_0",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_0 Register",
    "This register configures the maximum number of bytes that L2 queue 0"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_0_REG_OFFSET,
    0,
    0,
    188,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_1_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_1_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_1_PRVBURSTLIMIT1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_1_REG = 
{
    "TX_CTC_BURST_LIMIT_1",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_1 Register",
    "This register configures the maximum number of bytes that L2 queue 1"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_1_REG_OFFSET,
    0,
    0,
    189,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_2_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_2_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_2_PRVBURSTLIMIT2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_2_REG = 
{
    "TX_CTC_BURST_LIMIT_2",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_2 Register",
    "This register configures the maximum number of bytes that L2 queue 2"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_2_REG_OFFSET,
    0,
    0,
    190,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_3_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_3_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_3_PRVBURSTLIMIT3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_3_REG = 
{
    "TX_CTC_BURST_LIMIT_3",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_3 Register",
    "This register configures the maximum number of bytes that L2 queue 3"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_3_REG_OFFSET,
    0,
    0,
    191,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_4
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_4_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_4_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_4_PRVBURSTLIMIT4_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_4_REG = 
{
    "TX_CTC_BURST_LIMIT_4",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_4 Register",
    "This register configures the maximum number of bytes that L2 queue 4"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_4_REG_OFFSET,
    0,
    0,
    192,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_4_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_5
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_5_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_5_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_5_PRVBURSTLIMIT5_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_5_REG = 
{
    "TX_CTC_BURST_LIMIT_5",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_5 Register",
    "This register configures the maximum number of bytes that L2 queue 5"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_5_REG_OFFSET,
    0,
    0,
    193,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_5_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_6
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_6_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_6_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_6_PRVBURSTLIMIT6_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_6_REG = 
{
    "TX_CTC_BURST_LIMIT_6",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_6 Register",
    "This register configures the maximum number of bytes that L2 queue 6"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_6_REG_OFFSET,
    0,
    0,
    194,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_6_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_7
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_7_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_7_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_7_PRVBURSTLIMIT7_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_7_REG = 
{
    "TX_CTC_BURST_LIMIT_7",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_7 Register",
    "This register configures the maximum number of bytes that L2 queue 7"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_7_REG_OFFSET,
    0,
    0,
    195,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_7_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_8
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_8_FIELDS[] =
{
    &EPN_BURST_CAP_8_RESERVED0_FIELD,
    &EPN_BURST_CAP_8_BURSTCAP8_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_8_REG = 
{
    "BURST_CAP_8",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_8 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_8_REG_OFFSET,
    0,
    0,
    196,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_8_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_9
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_9_FIELDS[] =
{
    &EPN_BURST_CAP_9_RESERVED0_FIELD,
    &EPN_BURST_CAP_9_BURSTCAP9_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_9_REG = 
{
    "BURST_CAP_9",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_9 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_9_REG_OFFSET,
    0,
    0,
    197,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_9_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_10
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_10_FIELDS[] =
{
    &EPN_BURST_CAP_10_RESERVED0_FIELD,
    &EPN_BURST_CAP_10_BURSTCAP10_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_10_REG = 
{
    "BURST_CAP_10",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_10 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_10_REG_OFFSET,
    0,
    0,
    198,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_10_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_11
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_11_FIELDS[] =
{
    &EPN_BURST_CAP_11_RESERVED0_FIELD,
    &EPN_BURST_CAP_11_BURSTCAP11_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_11_REG = 
{
    "BURST_CAP_11",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_11 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_11_REG_OFFSET,
    0,
    0,
    199,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_11_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_12
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_12_FIELDS[] =
{
    &EPN_BURST_CAP_12_RESERVED0_FIELD,
    &EPN_BURST_CAP_12_BURSTCAP12_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_12_REG = 
{
    "BURST_CAP_12",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_12 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_12_REG_OFFSET,
    0,
    0,
    200,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_12_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_13
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_13_FIELDS[] =
{
    &EPN_BURST_CAP_13_RESERVED0_FIELD,
    &EPN_BURST_CAP_13_BURSTCAP13_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_13_REG = 
{
    "BURST_CAP_13",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_13 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_13_REG_OFFSET,
    0,
    0,
    201,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_13_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_14
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_14_FIELDS[] =
{
    &EPN_BURST_CAP_14_RESERVED0_FIELD,
    &EPN_BURST_CAP_14_BURSTCAP14_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_14_REG = 
{
    "BURST_CAP_14",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_14 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_14_REG_OFFSET,
    0,
    0,
    202,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_14_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_15
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_15_FIELDS[] =
{
    &EPN_BURST_CAP_15_RESERVED0_FIELD,
    &EPN_BURST_CAP_15_BURSTCAP15_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_15_REG = 
{
    "BURST_CAP_15",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_15 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_15_REG_OFFSET,
    0,
    0,
    203,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_15_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_16
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_16_FIELDS[] =
{
    &EPN_BURST_CAP_16_RESERVED0_FIELD,
    &EPN_BURST_CAP_16_BURSTCAP16_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_16_REG = 
{
    "BURST_CAP_16",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_16 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_16_REG_OFFSET,
    0,
    0,
    204,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_16_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_17
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_17_FIELDS[] =
{
    &EPN_BURST_CAP_17_RESERVED0_FIELD,
    &EPN_BURST_CAP_17_BURSTCAP17_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_17_REG = 
{
    "BURST_CAP_17",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_17 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_17_REG_OFFSET,
    0,
    0,
    205,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_17_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_18
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_18_FIELDS[] =
{
    &EPN_BURST_CAP_18_RESERVED0_FIELD,
    &EPN_BURST_CAP_18_BURSTCAP18_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_18_REG = 
{
    "BURST_CAP_18",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_18 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_18_REG_OFFSET,
    0,
    0,
    206,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_18_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_19
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_19_FIELDS[] =
{
    &EPN_BURST_CAP_19_RESERVED0_FIELD,
    &EPN_BURST_CAP_19_BURSTCAP19_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_19_REG = 
{
    "BURST_CAP_19",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_19 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_19_REG_OFFSET,
    0,
    0,
    207,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_19_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_20
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_20_FIELDS[] =
{
    &EPN_BURST_CAP_20_RESERVED0_FIELD,
    &EPN_BURST_CAP_20_BURSTCAP20_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_20_REG = 
{
    "BURST_CAP_20",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_20 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_20_REG_OFFSET,
    0,
    0,
    208,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_20_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_21
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_21_FIELDS[] =
{
    &EPN_BURST_CAP_21_RESERVED0_FIELD,
    &EPN_BURST_CAP_21_BURSTCAP21_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_21_REG = 
{
    "BURST_CAP_21",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_21 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_21_REG_OFFSET,
    0,
    0,
    209,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_21_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_22
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_22_FIELDS[] =
{
    &EPN_BURST_CAP_22_RESERVED0_FIELD,
    &EPN_BURST_CAP_22_BURSTCAP22_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_22_REG = 
{
    "BURST_CAP_22",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_22 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_22_REG_OFFSET,
    0,
    0,
    210,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_22_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_23
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_23_FIELDS[] =
{
    &EPN_BURST_CAP_23_RESERVED0_FIELD,
    &EPN_BURST_CAP_23_BURSTCAP23_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_23_REG = 
{
    "BURST_CAP_23",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_23 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_23_REG_OFFSET,
    0,
    0,
    211,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_23_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_24
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_24_FIELDS[] =
{
    &EPN_BURST_CAP_24_RESERVED0_FIELD,
    &EPN_BURST_CAP_24_BURSTCAP24_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_24_REG = 
{
    "BURST_CAP_24",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_24 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_24_REG_OFFSET,
    0,
    0,
    212,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_24_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_25
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_25_FIELDS[] =
{
    &EPN_BURST_CAP_25_RESERVED0_FIELD,
    &EPN_BURST_CAP_25_BURSTCAP25_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_25_REG = 
{
    "BURST_CAP_25",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_25 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_25_REG_OFFSET,
    0,
    0,
    213,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_25_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_26
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_26_FIELDS[] =
{
    &EPN_BURST_CAP_26_RESERVED0_FIELD,
    &EPN_BURST_CAP_26_BURSTCAP26_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_26_REG = 
{
    "BURST_CAP_26",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_26 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_26_REG_OFFSET,
    0,
    0,
    214,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_26_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_27
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_27_FIELDS[] =
{
    &EPN_BURST_CAP_27_RESERVED0_FIELD,
    &EPN_BURST_CAP_27_BURSTCAP27_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_27_REG = 
{
    "BURST_CAP_27",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_27 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_27_REG_OFFSET,
    0,
    0,
    215,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_27_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_28
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_28_FIELDS[] =
{
    &EPN_BURST_CAP_28_RESERVED0_FIELD,
    &EPN_BURST_CAP_28_BURSTCAP28_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_28_REG = 
{
    "BURST_CAP_28",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_28 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_28_REG_OFFSET,
    0,
    0,
    216,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_28_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_29
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_29_FIELDS[] =
{
    &EPN_BURST_CAP_29_RESERVED0_FIELD,
    &EPN_BURST_CAP_29_BURSTCAP29_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_29_REG = 
{
    "BURST_CAP_29",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_29 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_29_REG_OFFSET,
    0,
    0,
    217,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_29_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_30
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_30_FIELDS[] =
{
    &EPN_BURST_CAP_30_RESERVED0_FIELD,
    &EPN_BURST_CAP_30_BURSTCAP30_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_30_REG = 
{
    "BURST_CAP_30",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_30 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_30_REG_OFFSET,
    0,
    0,
    218,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_30_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_BURST_CAP_31
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_BURST_CAP_31_FIELDS[] =
{
    &EPN_BURST_CAP_31_RESERVED0_FIELD,
    &EPN_BURST_CAP_31_BURSTCAP31_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_BURST_CAP_31_REG = 
{
    "BURST_CAP_31",
#if RU_INCLUDE_DESC
    "EPN_BURST_CAP_31 Register",
    "These registers limit how much data can be reported in REPORT frames."
    "The EPON MAC reports data (that is sitting in the FIFO Queues) in"
    "between 1 and 4 \"chunks\". The size of these chunks is determined by the"
    "Burst Cap settings here. The units for these registers are 1 TQ for 1G"
    "upstream mode. The units are one-tenth of a TQ for 10G upstream mode."
    "To provision 4 TQ in 1G upstream mode, write a value of 4. To provision"
    "4 TQ in 10G upstream mode write a value of 40. Note that when register"
    "0x400 bit 21 is set that the provisioned value must be one time quantum"
    "less than the maximum value that should be reported to the OLT."
    "When configured in shared burst cap mode, the burst cap value must be"
    "reduced by the following amounts (relative to the threshold/token size"
    "value sent from the OLT)"
    "Mode         Reduction Amount (bytes)"
    "----------------       -----------------------------------"
    "1G non-FEC  21 + number of CTC priority levels"
    "1G FEC         193 + number of CTC priority levels"
    "10G   20 + number of CTC priority levels"
    "10G implicit SCI 44 + number of CTC priority levels"
    "10G explicit SCI 52 + number of CTC priority levels",
#endif
    EPN_BURST_CAP_31_REG_OFFSET,
    0,
    0,
    219,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_BURST_CAP_31_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_8
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_8_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_8_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_8_QUELLIDMAP8_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_8_REG = 
{
    "QUEUE_LLID_MAP_8",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_8 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_8_REG_OFFSET,
    0,
    0,
    220,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_8_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_9
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_9_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_9_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_9_QUELLIDMAP9_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_9_REG = 
{
    "QUEUE_LLID_MAP_9",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_9 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_9_REG_OFFSET,
    0,
    0,
    221,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_9_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_10
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_10_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_10_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_10_QUELLIDMAP10_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_10_REG = 
{
    "QUEUE_LLID_MAP_10",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_10 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_10_REG_OFFSET,
    0,
    0,
    222,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_10_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_11
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_11_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_11_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_11_QUELLIDMAP11_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_11_REG = 
{
    "QUEUE_LLID_MAP_11",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_11 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_11_REG_OFFSET,
    0,
    0,
    223,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_11_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_12
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_12_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_12_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_12_QUELLIDMAP12_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_12_REG = 
{
    "QUEUE_LLID_MAP_12",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_12 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_12_REG_OFFSET,
    0,
    0,
    224,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_12_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_13
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_13_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_13_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_13_QUELLIDMAP13_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_13_REG = 
{
    "QUEUE_LLID_MAP_13",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_13 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_13_REG_OFFSET,
    0,
    0,
    225,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_13_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_14
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_14_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_14_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_14_QUELLIDMAP14_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_14_REG = 
{
    "QUEUE_LLID_MAP_14",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_14 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_14_REG_OFFSET,
    0,
    0,
    226,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_14_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_15
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_15_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_15_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_15_QUELLIDMAP15_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_15_REG = 
{
    "QUEUE_LLID_MAP_15",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_15 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_15_REG_OFFSET,
    0,
    0,
    227,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_15_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_16
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_16_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_16_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_16_QUELLIDMAP16_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_16_REG = 
{
    "QUEUE_LLID_MAP_16",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_16 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_16_REG_OFFSET,
    0,
    0,
    228,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_16_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_17
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_17_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_17_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_17_QUELLIDMAP17_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_17_REG = 
{
    "QUEUE_LLID_MAP_17",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_17 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_17_REG_OFFSET,
    0,
    0,
    229,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_17_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_18
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_18_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_18_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_18_QUELLIDMAP18_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_18_REG = 
{
    "QUEUE_LLID_MAP_18",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_18 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_18_REG_OFFSET,
    0,
    0,
    230,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_18_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_19
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_19_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_19_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_19_QUELLIDMAP19_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_19_REG = 
{
    "QUEUE_LLID_MAP_19",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_19 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_19_REG_OFFSET,
    0,
    0,
    231,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_19_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_20
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_20_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_20_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_20_QUELLIDMAP20_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_20_REG = 
{
    "QUEUE_LLID_MAP_20",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_20 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_20_REG_OFFSET,
    0,
    0,
    232,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_20_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_21
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_21_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_21_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_21_QUELLIDMAP21_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_21_REG = 
{
    "QUEUE_LLID_MAP_21",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_21 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_21_REG_OFFSET,
    0,
    0,
    233,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_21_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_22
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_22_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_22_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_22_QUELLIDMAP22_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_22_REG = 
{
    "QUEUE_LLID_MAP_22",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_22 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_22_REG_OFFSET,
    0,
    0,
    234,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_22_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_23
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_23_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_23_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_23_QUELLIDMAP23_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_23_REG = 
{
    "QUEUE_LLID_MAP_23",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_23 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_23_REG_OFFSET,
    0,
    0,
    235,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_23_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_24
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_24_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_24_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_24_QUELLIDMAP24_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_24_REG = 
{
    "QUEUE_LLID_MAP_24",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_24 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_24_REG_OFFSET,
    0,
    0,
    236,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_24_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_25
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_25_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_25_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_25_QUELLIDMAP25_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_25_REG = 
{
    "QUEUE_LLID_MAP_25",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_25 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_25_REG_OFFSET,
    0,
    0,
    237,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_25_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_26
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_26_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_26_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_26_QUELLIDMAP26_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_26_REG = 
{
    "QUEUE_LLID_MAP_26",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_26 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_26_REG_OFFSET,
    0,
    0,
    238,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_26_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_27
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_27_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_27_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_27_QUELLIDMAP27_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_27_REG = 
{
    "QUEUE_LLID_MAP_27",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_27 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_27_REG_OFFSET,
    0,
    0,
    239,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_27_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_28
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_28_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_28_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_28_QUELLIDMAP28_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_28_REG = 
{
    "QUEUE_LLID_MAP_28",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_28 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_28_REG_OFFSET,
    0,
    0,
    240,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_28_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_29
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_29_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_29_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_29_QUELLIDMAP29_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_29_REG = 
{
    "QUEUE_LLID_MAP_29",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_29 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_29_REG_OFFSET,
    0,
    0,
    241,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_29_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_30
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_30_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_30_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_30_QUELLIDMAP30_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_30_REG = 
{
    "QUEUE_LLID_MAP_30",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_30 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_30_REG_OFFSET,
    0,
    0,
    242,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_30_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_QUEUE_LLID_MAP_31
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_QUEUE_LLID_MAP_31_FIELDS[] =
{
    &EPN_QUEUE_LLID_MAP_31_RESERVED0_FIELD,
    &EPN_QUEUE_LLID_MAP_31_QUELLIDMAP31_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_QUEUE_LLID_MAP_31_REG = 
{
    "QUEUE_LLID_MAP_31",
#if RU_INCLUDE_DESC
    "EPN_QUEUE_LLID_MAP_31 Register",
    "",
#endif
    EPN_QUEUE_LLID_MAP_31_REG_OFFSET,
    0,
    0,
    243,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_QUEUE_LLID_MAP_31_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT8
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT8_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT8_UNUSEDTQCNT8_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT8_REG = 
{
    "UNUSED_TQ_CNT8",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT8 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT8_REG_OFFSET,
    0,
    0,
    244,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT8_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT9
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT9_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT9_UNUSEDTQCNT9_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT9_REG = 
{
    "UNUSED_TQ_CNT9",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT9 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT9_REG_OFFSET,
    0,
    0,
    245,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT9_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT10
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT10_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT10_UNUSEDTQCNT10_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT10_REG = 
{
    "UNUSED_TQ_CNT10",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT10 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT10_REG_OFFSET,
    0,
    0,
    246,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT10_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT11
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT11_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT11_UNUSEDTQCNT11_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT11_REG = 
{
    "UNUSED_TQ_CNT11",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT11 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT11_REG_OFFSET,
    0,
    0,
    247,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT11_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT12
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT12_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT12_UNUSEDTQCNT12_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT12_REG = 
{
    "UNUSED_TQ_CNT12",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT12 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT12_REG_OFFSET,
    0,
    0,
    248,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT12_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT13
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT13_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT13_UNUSEDTQCNT13_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT13_REG = 
{
    "UNUSED_TQ_CNT13",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT13 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT13_REG_OFFSET,
    0,
    0,
    249,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT13_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT14
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT14_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT14_UNUSEDTQCNT14_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT14_REG = 
{
    "UNUSED_TQ_CNT14",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT14 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT14_REG_OFFSET,
    0,
    0,
    250,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT14_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT15
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT15_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT15_UNUSEDTQCNT15_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT15_REG = 
{
    "UNUSED_TQ_CNT15",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT15 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT15_REG_OFFSET,
    0,
    0,
    251,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT15_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT16
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT16_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT16_UNUSEDTQCNT16_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT16_REG = 
{
    "UNUSED_TQ_CNT16",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT16 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT16_REG_OFFSET,
    0,
    0,
    252,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT16_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT17
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT17_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT17_UNUSEDTQCNT17_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT17_REG = 
{
    "UNUSED_TQ_CNT17",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT17 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT17_REG_OFFSET,
    0,
    0,
    253,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT17_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT18
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT18_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT18_UNUSEDTQCNT18_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT18_REG = 
{
    "UNUSED_TQ_CNT18",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT18 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT18_REG_OFFSET,
    0,
    0,
    254,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT18_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT19
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT19_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT19_UNUSEDTQCNT19_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT19_REG = 
{
    "UNUSED_TQ_CNT19",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT19 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT19_REG_OFFSET,
    0,
    0,
    255,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT19_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT20
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT20_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT20_UNUSEDTQCNT20_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT20_REG = 
{
    "UNUSED_TQ_CNT20",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT20 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT20_REG_OFFSET,
    0,
    0,
    256,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT20_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT21
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT21_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT21_UNUSEDTQCNT21_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT21_REG = 
{
    "UNUSED_TQ_CNT21",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT21 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT21_REG_OFFSET,
    0,
    0,
    257,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT21_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT22
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT22_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT22_UNUSEDTQCNT22_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT22_REG = 
{
    "UNUSED_TQ_CNT22",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT22 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT22_REG_OFFSET,
    0,
    0,
    258,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT22_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT23
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT23_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT23_UNUSEDTQCNT23_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT23_REG = 
{
    "UNUSED_TQ_CNT23",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT23 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT23_REG_OFFSET,
    0,
    0,
    259,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT23_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT24
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT24_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT24_UNUSEDTQCNT24_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT24_REG = 
{
    "UNUSED_TQ_CNT24",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT24 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT24_REG_OFFSET,
    0,
    0,
    260,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT24_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT25
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT25_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT25_UNUSEDTQCNT25_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT25_REG = 
{
    "UNUSED_TQ_CNT25",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT25 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT25_REG_OFFSET,
    0,
    0,
    261,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT25_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT26
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT26_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT26_UNUSEDTQCNT26_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT26_REG = 
{
    "UNUSED_TQ_CNT26",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT26 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT26_REG_OFFSET,
    0,
    0,
    262,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT26_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT27
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT27_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT27_UNUSEDTQCNT27_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT27_REG = 
{
    "UNUSED_TQ_CNT27",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT27 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT27_REG_OFFSET,
    0,
    0,
    263,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT27_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT28
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT28_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT28_UNUSEDTQCNT28_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT28_REG = 
{
    "UNUSED_TQ_CNT28",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT28 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT28_REG_OFFSET,
    0,
    0,
    264,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT28_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT29
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT29_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT29_UNUSEDTQCNT29_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT29_REG = 
{
    "UNUSED_TQ_CNT29",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT29 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT29_REG_OFFSET,
    0,
    0,
    265,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT29_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT30
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT30_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT30_UNUSEDTQCNT30_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT30_REG = 
{
    "UNUSED_TQ_CNT30",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT30 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT30_REG_OFFSET,
    0,
    0,
    266,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT30_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_UNUSED_TQ_CNT31
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_UNUSED_TQ_CNT31_FIELDS[] =
{
    &EPN_UNUSED_TQ_CNT31_UNUSEDTQCNT31_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_UNUSED_TQ_CNT31_REG = 
{
    "UNUSED_TQ_CNT31",
#if RU_INCLUDE_DESC
    "EPN_UNUSED_TQ_CNT31 Register",
    "Statistics register that accumulates the number of upstream unused time"
    "quanta for an upstream LLID."
    "The register saturates at maximum value. The register will clear upon"
    "read.",
#endif
    EPN_UNUSED_TQ_CNT31_REG_OFFSET,
    0,
    0,
    267,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_UNUSED_TQ_CNT31_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_8
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_8_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_8_CFGSHPMASK8_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_8_REG = 
{
    "TX_L1S_SHP_QUE_MASK_8",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_8 Register",
    "This register allows the effects of the upstream shaper 8 to be masked."
    "When multiple priority queues point to a common shaping bucket, the"
    "low priority traffic can use all the credits prior to a high priority"
    "frame arriving. The high priority would then incur additional latency"
    "waiting for credits to accrue. This adds undesirable delay to the data"
    "path. This feature separates the queues that apply credit to a shaper"
    "and those that are masked by the shaper. The Shaping function has an"
    "input that credits the shaping bucket when a frame is sent. It also has"
    "an output that masks a queue from being eligible to transmit when the"
    "shaping rate is violated. In this case the low priority queue will both"
    "credit and be masked by the shaper as typically done. The high priority"
    "on the other hand will credit the shaper, but not be limited by it. The"
    "shaper will then be allowed to go into a deficit. In most cases the"
    "high priority is a small portion of the total bandwidth. In some cases"
    "however it may be desired to limit the high priority traffic with a"
    "different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_8_REG_OFFSET,
    0,
    0,
    268,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_8_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_9
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_9_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_9_CFGSHPMASK9_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_9_REG = 
{
    "TX_L1S_SHP_QUE_MASK_9",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_9 Register",
    "This register allows the effects of the upstream shaper 9 to be masked."
    "When multiple priority queues point to a common shaping bucket, the"
    "low priority traffic can use all the credits prior to a high priority"
    "frame arriving. The high priority would then incur additional latency"
    "waiting for credits to accrue. This adds undesirable delay to the data"
    "path. This feature separates the queues that apply credit to a shaper"
    "and those that are masked by the shaper. The Shaping function has an"
    "input that credits the shaping bucket when a frame is sent. It also has"
    "an output that masks a queue from being eligible to transmit when the"
    "shaping rate is violated. In this case the low priority queue will both"
    "credit and be masked by the shaper as typically done. The high priority"
    "on the other hand will credit the shaper, but not be limited by it. The"
    "shaper will then be allowed to go into a deficit. In most cases the"
    "high priority is a small portion of the total bandwidth. In some cases"
    "however it may be desired to limit the high priority traffic with a"
    "different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_9_REG_OFFSET,
    0,
    0,
    269,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_9_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_10
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_10_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_10_CFGSHPMASK10_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_10_REG = 
{
    "TX_L1S_SHP_QUE_MASK_10",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_10 Register",
    "This register allows the effects of the upstream shaper 10 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_10_REG_OFFSET,
    0,
    0,
    270,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_10_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_11
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_11_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_11_CFGSHPMASK11_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_11_REG = 
{
    "TX_L1S_SHP_QUE_MASK_11",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_11 Register",
    "This register allows the effects of the upstream shaper 11 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_11_REG_OFFSET,
    0,
    0,
    271,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_11_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_12
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_12_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_12_CFGSHPMASK12_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_12_REG = 
{
    "TX_L1S_SHP_QUE_MASK_12",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_12 Register",
    "This register allows the effects of the upstream shaper 12 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_12_REG_OFFSET,
    0,
    0,
    272,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_12_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_13
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_13_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_13_CFGSHPMASK13_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_13_REG = 
{
    "TX_L1S_SHP_QUE_MASK_13",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_13 Register",
    "This register allows the effects of the upstream shaper 13 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_13_REG_OFFSET,
    0,
    0,
    273,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_13_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_14
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_14_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_14_CFGSHPMASK14_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_14_REG = 
{
    "TX_L1S_SHP_QUE_MASK_14",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_14 Register",
    "This register allows the effects of the upstream shaper 14 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_14_REG_OFFSET,
    0,
    0,
    274,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_14_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_15
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_15_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_15_CFGSHPMASK15_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_15_REG = 
{
    "TX_L1S_SHP_QUE_MASK_15",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_15 Register",
    "This register allows the effects of the upstream shaper 15 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_15_REG_OFFSET,
    0,
    0,
    275,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_15_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_16
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_16_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_16_CFGSHPMASK16_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_16_REG = 
{
    "TX_L1S_SHP_QUE_MASK_16",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_16 Register",
    "This register allows the effects of the upstream shaper 16 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_16_REG_OFFSET,
    0,
    0,
    276,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_16_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_17
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_17_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_17_CFGSHPMASK17_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_17_REG = 
{
    "TX_L1S_SHP_QUE_MASK_17",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_17 Register",
    "This register allows the effects of the upstream shaper 17 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_17_REG_OFFSET,
    0,
    0,
    277,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_17_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_18
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_18_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_18_CFGSHPMASK18_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_18_REG = 
{
    "TX_L1S_SHP_QUE_MASK_18",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_18 Register",
    "This register allows the effects of the upstream shaper 18 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_18_REG_OFFSET,
    0,
    0,
    278,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_18_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_19
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_19_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_19_CFGSHPMASK19_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_19_REG = 
{
    "TX_L1S_SHP_QUE_MASK_19",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_19 Register",
    "This register allows the effects of the upstream shaper 19 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_19_REG_OFFSET,
    0,
    0,
    279,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_19_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_20
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_20_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_20_CFGSHPMASK20_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_20_REG = 
{
    "TX_L1S_SHP_QUE_MASK_20",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_20 Register",
    "This register allows the effects of the upstream shaper 20 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_20_REG_OFFSET,
    0,
    0,
    280,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_20_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_21
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_21_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_21_CFGSHPMASK21_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_21_REG = 
{
    "TX_L1S_SHP_QUE_MASK_21",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_21 Register",
    "This register allows the effects of the upstream shaper 21 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_21_REG_OFFSET,
    0,
    0,
    281,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_21_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_22
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_22_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_22_CFGSHPMASK22_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_22_REG = 
{
    "TX_L1S_SHP_QUE_MASK_22",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_22 Register",
    "This register allows the effects of the upstream shaper 22 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_22_REG_OFFSET,
    0,
    0,
    282,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_22_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_23
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_23_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_23_CFGSHPMASK23_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_23_REG = 
{
    "TX_L1S_SHP_QUE_MASK_23",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_23 Register",
    "This register allows the effects of the upstream shaper 23 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_23_REG_OFFSET,
    0,
    0,
    283,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_23_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_24
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_24_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_24_CFGSHPMASK24_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_24_REG = 
{
    "TX_L1S_SHP_QUE_MASK_24",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_24 Register",
    "This register allows the effects of the upstream shaper 24 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_24_REG_OFFSET,
    0,
    0,
    284,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_24_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_25
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_25_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_25_CFGSHPMASK25_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_25_REG = 
{
    "TX_L1S_SHP_QUE_MASK_25",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_25 Register",
    "This register allows the effects of the upstream shaper 25 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_25_REG_OFFSET,
    0,
    0,
    285,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_25_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_26
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_26_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_26_CFGSHPMASK26_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_26_REG = 
{
    "TX_L1S_SHP_QUE_MASK_26",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_26 Register",
    "This register allows the effects of the upstream shaper 26 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_26_REG_OFFSET,
    0,
    0,
    286,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_26_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_27
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_27_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_27_CFGSHPMASK27_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_27_REG = 
{
    "TX_L1S_SHP_QUE_MASK_27",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_27 Register",
    "This register allows the effects of the upstream shaper 27 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_27_REG_OFFSET,
    0,
    0,
    287,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_27_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_28
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_28_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_28_CFGSHPMASK28_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_28_REG = 
{
    "TX_L1S_SHP_QUE_MASK_28",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_28 Register",
    "This register allows the effects of the upstream shaper 28 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_28_REG_OFFSET,
    0,
    0,
    288,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_28_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_29
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_29_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_29_CFGSHPMASK29_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_29_REG = 
{
    "TX_L1S_SHP_QUE_MASK_29",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_29 Register",
    "This register allows the effects of the upstream shaper 29 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_29_REG_OFFSET,
    0,
    0,
    289,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_29_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_30
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_30_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_30_CFGSHPMASK30_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_30_REG = 
{
    "TX_L1S_SHP_QUE_MASK_30",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_30 Register",
    "This register allows the effects of the upstream shaper 30 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_30_REG_OFFSET,
    0,
    0,
    290,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_30_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L1S_SHP_QUE_MASK_31
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L1S_SHP_QUE_MASK_31_FIELDS[] =
{
    &EPN_TX_L1S_SHP_QUE_MASK_31_CFGSHPMASK31_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_31_REG = 
{
    "TX_L1S_SHP_QUE_MASK_31",
#if RU_INCLUDE_DESC
    "EPN_TX_L1S_SHP_QUE_MASK_31 Register",
    "This register allows the effects of the upstream shaper 31 to be"
    "masked.  When multiple priority queues point to a common shaping"
    "bucket, the low priority traffic can use all the credits prior to a"
    "high priority frame arriving. The high priority would then incur"
    "additional latency waiting for credits to accrue. This adds undesirable"
    "delay to the data path. This feature separates the queues that apply"
    "credit to a shaper and those that are masked by the shaper. The Shaping"
    "function has an input that credits the shaping bucket when a frame is"
    "sent. It also has an output that masks a queue from being eligible to"
    "transmit when the shaping rate is violated. In this case the low"
    "priority queue will both credit and be masked by the shaper as"
    "typically done. The high priority on the other hand will credit the"
    "shaper, but not be limited by it. The shaper will then be allowed to go"
    "into a deficit. In most cases the high priority is a small portion of"
    "the total bandwidth. In some cases however it may be desired to limit"
    "the high priority traffic with a different shaper.",
#endif
    EPN_TX_L1S_SHP_QUE_MASK_31_REG_OFFSET,
    0,
    0,
    291,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    EPN_TX_L1S_SHP_QUE_MASK_31_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_8
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_8_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_8_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUEEND8_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_8_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUESTART8_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_8_REG = 
{
    "TX_L2S_QUE_CONFIG_8",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_8 Register",
    "This registers configures the base addresses of the L2 structure 8."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_8_REG_OFFSET,
    0,
    0,
    292,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_8_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_9
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_9_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_9_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUEEND9_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_9_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUESTART9_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_9_REG = 
{
    "TX_L2S_QUE_CONFIG_9",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_9 Register",
    "This registers configures the base addresses of the L2 structure 9."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_9_REG_OFFSET,
    0,
    0,
    293,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_9_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_10
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_10_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_10_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUEEND10_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_10_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUESTART10_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_10_REG = 
{
    "TX_L2S_QUE_CONFIG_10",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_10 Register",
    "This registers configures the base addresses of the L2 structure 10."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_10_REG_OFFSET,
    0,
    0,
    294,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_10_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_11
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_11_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_11_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUEEND11_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_11_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUESTART11_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_11_REG = 
{
    "TX_L2S_QUE_CONFIG_11",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_11 Register",
    "This registers configures the base addresses of the L2 structure 11."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_11_REG_OFFSET,
    0,
    0,
    295,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_11_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_12
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_12_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_12_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUEEND12_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_12_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUESTART12_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_12_REG = 
{
    "TX_L2S_QUE_CONFIG_12",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_12 Register",
    "This registers configures the base addresses of the L2 structure 12."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_12_REG_OFFSET,
    0,
    0,
    296,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_12_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_13
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_13_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_13_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUEEND13_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_13_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUESTART13_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_13_REG = 
{
    "TX_L2S_QUE_CONFIG_13",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_13 Register",
    "This registers configures the base addresses of the L2 structure 13."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_13_REG_OFFSET,
    0,
    0,
    297,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_13_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_14
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_14_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_14_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUEEND14_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_14_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUESTART14_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_14_REG = 
{
    "TX_L2S_QUE_CONFIG_14",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_14 Register",
    "This registers configures the base addresses of the L2 structure 14."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_14_REG_OFFSET,
    0,
    0,
    298,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_14_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_15
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_15_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_15_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUEEND15_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_15_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUESTART15_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_15_REG = 
{
    "TX_L2S_QUE_CONFIG_15",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_15 Register",
    "This registers configures the base addresses of the L2 structure 15."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_15_REG_OFFSET,
    0,
    0,
    299,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_15_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_16
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_16_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_16_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUEEND16_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_16_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUESTART16_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_16_REG = 
{
    "TX_L2S_QUE_CONFIG_16",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_16 Register",
    "This registers configures the base addresses of the L2 structure 16."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_16_REG_OFFSET,
    0,
    0,
    300,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_16_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_17
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_17_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_17_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUEEND17_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_17_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUESTART17_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_17_REG = 
{
    "TX_L2S_QUE_CONFIG_17",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_17 Register",
    "This registers configures the base addresses of the L2 structure 17."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_17_REG_OFFSET,
    0,
    0,
    301,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_17_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_18
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_18_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_18_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUEEND18_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_18_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUESTART18_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_18_REG = 
{
    "TX_L2S_QUE_CONFIG_18",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_18 Register",
    "This registers configures the base addresses of the L2 structure 18."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_18_REG_OFFSET,
    0,
    0,
    302,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_18_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_19
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_19_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_19_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUEEND19_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_19_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUESTART19_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_19_REG = 
{
    "TX_L2S_QUE_CONFIG_19",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_19 Register",
    "This registers configures the base addresses of the L2 structure 19."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_19_REG_OFFSET,
    0,
    0,
    303,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_19_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_20
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_20_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_20_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUEEND20_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_20_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUESTART20_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_20_REG = 
{
    "TX_L2S_QUE_CONFIG_20",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_20 Register",
    "This registers configures the base addresses of the L2 structure 20."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_20_REG_OFFSET,
    0,
    0,
    304,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_20_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_21
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_21_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_21_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUEEND21_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_21_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUESTART21_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_21_REG = 
{
    "TX_L2S_QUE_CONFIG_21",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_21 Register",
    "This registers configures the base addresses of the L2 structure 21."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_21_REG_OFFSET,
    0,
    0,
    305,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_21_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_22
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_22_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_22_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUEEND22_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_22_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUESTART22_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_22_REG = 
{
    "TX_L2S_QUE_CONFIG_22",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_22 Register",
    "This registers configures the base addresses of the L2 structure 22."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_22_REG_OFFSET,
    0,
    0,
    306,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_22_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_23
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_23_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_23_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUEEND23_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_23_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUESTART23_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_23_REG = 
{
    "TX_L2S_QUE_CONFIG_23",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_23 Register",
    "This registers configures the base addresses of the L2 structure 23."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_23_REG_OFFSET,
    0,
    0,
    307,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_23_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_24
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_24_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_24_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUEEND24_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_24_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUESTART24_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_24_REG = 
{
    "TX_L2S_QUE_CONFIG_24",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_24 Register",
    "This registers configures the base addresses of the L2 structure 23."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_24_REG_OFFSET,
    0,
    0,
    308,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_24_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_25
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_25_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_25_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUEEND25_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_25_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUESTART25_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_25_REG = 
{
    "TX_L2S_QUE_CONFIG_25",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_25 Register",
    "This registers configures the base addresses of the L2 structure 23."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_25_REG_OFFSET,
    0,
    0,
    309,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_25_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_26
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_26_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_26_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUEEND26_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_26_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUESTART26_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_26_REG = 
{
    "TX_L2S_QUE_CONFIG_26",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_26 Register",
    "This registers configures the base addresses of the L2 structure 23."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_26_REG_OFFSET,
    0,
    0,
    310,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_26_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_27
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_27_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_27_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUEEND27_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_27_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUESTART27_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_27_REG = 
{
    "TX_L2S_QUE_CONFIG_27",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_27 Register",
    "This registers configures the base addresses of the L2 structure 23."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_27_REG_OFFSET,
    0,
    0,
    311,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_27_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_28
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_28_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_28_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUEEND28_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_28_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUESTART28_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_28_REG = 
{
    "TX_L2S_QUE_CONFIG_28",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_28 Register",
    "This registers configures the base addresses of the L2 structure 23."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_28_REG_OFFSET,
    0,
    0,
    312,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_28_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_29
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_29_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_29_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUEEND29_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_29_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUESTART29_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_29_REG = 
{
    "TX_L2S_QUE_CONFIG_29",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_29 Register",
    "This registers configures the base addresses of the L2 structure 23."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_29_REG_OFFSET,
    0,
    0,
    313,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_29_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_30
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_30_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_30_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUEEND30_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_30_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUESTART30_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_30_REG = 
{
    "TX_L2S_QUE_CONFIG_30",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_30 Register",
    "This registers configures the base addresses of the L2 structure 23."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_30_REG_OFFSET,
    0,
    0,
    314,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_30_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_L2S_QUE_CONFIG_31
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_L2S_QUE_CONFIG_31_FIELDS[] =
{
    &EPN_TX_L2S_QUE_CONFIG_31_RESERVED0_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUEEND31_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_31_RESERVED1_FIELD,
    &EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUESTART31_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_31_REG = 
{
    "TX_L2S_QUE_CONFIG_31",
#if RU_INCLUDE_DESC
    "EPN_TX_L2S_QUE_CONFIG_31 Register",
    "This registers configures the base addresses of the L2 structure 23."
    "Internally the least significant two bits are treated as constants: The"
    "two least significant start address bits are 0 and the two least"
    "significant end address bits are 1. Therefore the queue base addresses"
    "cannot be read directly from the register contents without performing"
    "some mental gymnastics. Try to picture a 2-bit left shift and stuff"
    "operation. The base address granularity is 4 entries. It is critical"
    "that the number of entries allocated for each FIFO be sufficient to"
    "accommodate the worst case number of frames that can be contained in"
    "the associated Fif queue. A general rule-of-thumb would be to divide"
    "the number of bytes in the respective Fif queue by 80. The quotient+1"
    "will be the minimum number of entries that should be allocated. Do not"
    "forget to round up to the nearest 4-entry quanta.  If the L2 is being"
    "sized to match the burst cap (instead of the entire Fif queue size) do"
    "not forget to multiply the quotient+1 by four (or by 5 if"
    "prvTekModePrefetch is set) when operating in Teknovus mode. There are"
    "four burst cap values reported in Teknovus mode"
    "Note: This register cannot be programmed \"on-the-fly\". The queue"
    "start/end address values should be changed only when its associated"
    "clear L2 report FIFO\" bit is set.",
#endif
    EPN_TX_L2S_QUE_CONFIG_31_REG_OFFSET,
    0,
    0,
    315,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    4,
    EPN_TX_L2S_QUE_CONFIG_31_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_8
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_8_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_8_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_8_PRVBURSTLIMIT8_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_8_REG = 
{
    "TX_CTC_BURST_LIMIT_8",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_8 Register",
    "This register configures the maximum number of bytes that L2 queue 8"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_8_REG_OFFSET,
    0,
    0,
    316,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_8_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_9
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_9_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_9_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_9_PRVBURSTLIMIT9_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_9_REG = 
{
    "TX_CTC_BURST_LIMIT_9",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_9 Register",
    "This register configures the maximum number of bytes that L2 queue 9"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_9_REG_OFFSET,
    0,
    0,
    317,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_9_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_10
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_10_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_10_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_10_PRVBURSTLIMIT10_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_10_REG = 
{
    "TX_CTC_BURST_LIMIT_10",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_10 Register",
    "This register configures the maximum number of bytes that L2 queue 10"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_10_REG_OFFSET,
    0,
    0,
    318,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_10_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_11
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_11_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_11_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_11_PRVBURSTLIMIT11_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_11_REG = 
{
    "TX_CTC_BURST_LIMIT_11",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_11 Register",
    "This register configures the maximum number of bytes that L2 queue 11"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_11_REG_OFFSET,
    0,
    0,
    319,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_11_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_12
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_12_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_12_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_12_PRVBURSTLIMIT12_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_12_REG = 
{
    "TX_CTC_BURST_LIMIT_12",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_12 Register",
    "This register configures the maximum number of bytes that L2 queue 12"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_12_REG_OFFSET,
    0,
    0,
    320,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_12_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_13
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_13_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_13_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_13_PRVBURSTLIMIT13_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_13_REG = 
{
    "TX_CTC_BURST_LIMIT_13",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_13 Register",
    "This register configures the maximum number of bytes that L2 queue 13"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_13_REG_OFFSET,
    0,
    0,
    321,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_13_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_14
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_14_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_14_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_14_PRVBURSTLIMIT14_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_14_REG = 
{
    "TX_CTC_BURST_LIMIT_14",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_14 Register",
    "This register configures the maximum number of bytes that L2 queue 14"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_14_REG_OFFSET,
    0,
    0,
    322,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_14_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_15
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_15_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_15_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_15_PRVBURSTLIMIT15_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_15_REG = 
{
    "TX_CTC_BURST_LIMIT_15",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_15 Register",
    "This register configures the maximum number of bytes that L2 queue 15"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_15_REG_OFFSET,
    0,
    0,
    323,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_15_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_16
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_16_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_16_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_16_PRVBURSTLIMIT16_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_16_REG = 
{
    "TX_CTC_BURST_LIMIT_16",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_16 Register",
    "This register configures the maximum number of bytes that L2 queue 16"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_16_REG_OFFSET,
    0,
    0,
    324,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_16_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_17
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_17_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_17_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_17_PRVBURSTLIMIT17_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_17_REG = 
{
    "TX_CTC_BURST_LIMIT_17",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_17 Register",
    "This register configures the maximum number of bytes that L2 queue 17"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_17_REG_OFFSET,
    0,
    0,
    325,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_17_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_18
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_18_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_18_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_18_PRVBURSTLIMIT18_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_18_REG = 
{
    "TX_CTC_BURST_LIMIT_18",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_18 Register",
    "This register configures the maximum number of bytes that L2 queue 18"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_18_REG_OFFSET,
    0,
    0,
    326,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_18_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_19
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_19_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_19_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_19_PRVBURSTLIMIT19_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_19_REG = 
{
    "TX_CTC_BURST_LIMIT_19",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_19 Register",
    "This register configures the maximum number of bytes that L2 queue 19"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_19_REG_OFFSET,
    0,
    0,
    327,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_19_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_20
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_20_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_20_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_20_PRVBURSTLIMIT20_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_20_REG = 
{
    "TX_CTC_BURST_LIMIT_20",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_20 Register",
    "This register configures the maximum number of bytes that L2 queue 20"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_20_REG_OFFSET,
    0,
    0,
    328,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_20_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_21
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_21_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_21_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_21_PRVBURSTLIMIT21_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_21_REG = 
{
    "TX_CTC_BURST_LIMIT_21",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_21 Register",
    "This register configures the maximum number of bytes that L2 queue 21"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_21_REG_OFFSET,
    0,
    0,
    329,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_21_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_22
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_22_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_22_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_22_PRVBURSTLIMIT22_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_22_REG = 
{
    "TX_CTC_BURST_LIMIT_22",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_22 Register",
    "This register configures the maximum number of bytes that L2 queue 22"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_22_REG_OFFSET,
    0,
    0,
    330,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_22_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_23
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_23_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_23_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_23_PRVBURSTLIMIT23_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_23_REG = 
{
    "TX_CTC_BURST_LIMIT_23",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_23 Register",
    "This register configures the maximum number of bytes that L2 queue 23"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_23_REG_OFFSET,
    0,
    0,
    331,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_23_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_24
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_24_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_24_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_24_PRVBURSTLIMIT24_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_24_REG = 
{
    "TX_CTC_BURST_LIMIT_24",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_24 Register",
    "This register configures the maximum number of bytes that L2 queue 23"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_24_REG_OFFSET,
    0,
    0,
    332,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_24_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_25
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_25_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_25_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_25_PRVBURSTLIMIT25_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_25_REG = 
{
    "TX_CTC_BURST_LIMIT_25",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_25 Register",
    "This register configures the maximum number of bytes that L2 queue 23"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_25_REG_OFFSET,
    0,
    0,
    333,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_25_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_26
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_26_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_26_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_26_PRVBURSTLIMIT26_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_26_REG = 
{
    "TX_CTC_BURST_LIMIT_26",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_26 Register",
    "This register configures the maximum number of bytes that L2 queue 23"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_26_REG_OFFSET,
    0,
    0,
    334,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_26_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_27
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_27_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_27_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_27_PRVBURSTLIMIT27_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_27_REG = 
{
    "TX_CTC_BURST_LIMIT_27",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_27 Register",
    "This register configures the maximum number of bytes that L2 queue 23"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_27_REG_OFFSET,
    0,
    0,
    335,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_27_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_28
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_28_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_28_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_28_PRVBURSTLIMIT28_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_28_REG = 
{
    "TX_CTC_BURST_LIMIT_28",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_28 Register",
    "This register configures the maximum number of bytes that L2 queue 23"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_28_REG_OFFSET,
    0,
    0,
    336,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_28_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_29
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_29_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_29_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_29_PRVBURSTLIMIT29_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_29_REG = 
{
    "TX_CTC_BURST_LIMIT_29",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_29 Register",
    "This register configures the maximum number of bytes that L2 queue 23"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_29_REG_OFFSET,
    0,
    0,
    337,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_29_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_30
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_30_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_30_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_30_PRVBURSTLIMIT30_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_30_REG = 
{
    "TX_CTC_BURST_LIMIT_30",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_30 Register",
    "This register configures the maximum number of bytes that L2 queue 23"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_30_REG_OFFSET,
    0,
    0,
    338,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_30_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_TX_CTC_BURST_LIMIT_31
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_TX_CTC_BURST_LIMIT_31_FIELDS[] =
{
    &EPN_TX_CTC_BURST_LIMIT_31_RESERVED0_FIELD,
    &EPN_TX_CTC_BURST_LIMIT_31_PRVBURSTLIMIT31_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_31_REG = 
{
    "TX_CTC_BURST_LIMIT_31",
#if RU_INCLUDE_DESC
    "EPN_TX_CTC_BURST_LIMIT_31 Register",
    "This register configures the maximum number of bytes that L2 queue 23"
    "can transmit during any given round. A round ends when all L2 queues"
    "have reached their respective burst limit or there is no more data to"
    "transmit. Note that setting a burst limit to zero enables the"
    "respective L2 queue to transmit in strict priority. Also, any burst"
    "limits that are set to 1 will cause those L2 queues to transmit in"
    "round-robin\" fashion. It is possible to allocate bandwidth as a"
    "percentage. Simply multiply the desired percentage by 2000 bytes (the"
    "maximum frame length) and write that value in the associated burst"
    "limit register."
    "Example bandwidth sharing configuration:"
    ""
    "Priority   Burst Limit Description"
    "--------   ----------- ------------"
    "0    0  High priority unlimited bandwidth"
    "1    0  Low priority unlimited bandwidth"
    "2    1  Equal priority UNI 1 unlimited bandwidth"
    "3    1  Equal priority UNI 2 unlimited bandwidth"
    "4    1  Equal priority UNI 3 unlimited bandwidth"
    "5    1  Equal priority UNI 4 unlimited bandwidth"
    "6    0  High priority best effort bandwidth"
    "7    0  Low priority best effort bandwidth"
    ""
    "Priority 0 is for the highest priority traffic. i.e., Management"
    "traffic"
    "Priority 1 is for real-time traffic. i.e., VOIP"
    "Priorities 2, 3, 4 and 5 equally share bandwidth, i.e. Premium business"
    "traffic."
    "Priorities 6 and 7 provide two classes of best effort traffic, i.e. two"
    "classes of consumer traffic"
    ""
    "Please note that the EPN shaper is the mechanism used to limit the"
    "amount of traffic.",
#endif
    EPN_TX_CTC_BURST_LIMIT_31_REG_OFFSET,
    0,
    0,
    339,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_TX_CTC_BURST_LIMIT_31_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE0_FIELDS[] =
{
    &EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_2_FIELD,
    &EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE0_REG = 
{
    "10G_ABC_SIZE0",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE0 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE0_REG_OFFSET,
    0,
    0,
    340,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE1_FIELDS[] =
{
    &EPN_10G_ABC_SIZE1_CFGADDBURSTCAP1_1_FIELD,
    &EPN_10G_ABC_SIZE1_CFGADDBURSTCAP0_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE1_REG = 
{
    "10G_ABC_SIZE1",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE1 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE1_REG_OFFSET,
    0,
    0,
    341,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE2_FIELDS[] =
{
    &EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_3_FIELD,
    &EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE2_REG = 
{
    "10G_ABC_SIZE2",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE2 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE2_REG_OFFSET,
    0,
    0,
    342,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE3_FIELDS[] =
{
    &EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_2_FIELD,
    &EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE3_REG = 
{
    "10G_ABC_SIZE3",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE3 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE3_REG_OFFSET,
    0,
    0,
    343,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE4
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE4_FIELDS[] =
{
    &EPN_10G_ABC_SIZE4_CFGADDBURSTCAP3_1_FIELD,
    &EPN_10G_ABC_SIZE4_CFGADDBURSTCAP2_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE4_REG = 
{
    "10G_ABC_SIZE4",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE4 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE4_REG_OFFSET,
    0,
    0,
    344,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE4_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE5
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE5_FIELDS[] =
{
    &EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_3_FIELD,
    &EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE5_REG = 
{
    "10G_ABC_SIZE5",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE5 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE5_REG_OFFSET,
    0,
    0,
    345,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE5_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE6
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE6_FIELDS[] =
{
    &EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_2_FIELD,
    &EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE6_REG = 
{
    "10G_ABC_SIZE6",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE6 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE6_REG_OFFSET,
    0,
    0,
    346,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE6_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE7
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE7_FIELDS[] =
{
    &EPN_10G_ABC_SIZE7_CFGADDBURSTCAP5_1_FIELD,
    &EPN_10G_ABC_SIZE7_CFGADDBURSTCAP4_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE7_REG = 
{
    "10G_ABC_SIZE7",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE7 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE7_REG_OFFSET,
    0,
    0,
    347,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE7_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE8
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE8_FIELDS[] =
{
    &EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_3_FIELD,
    &EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE8_REG = 
{
    "10G_ABC_SIZE8",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE8 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE8_REG_OFFSET,
    0,
    0,
    348,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE8_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE9
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE9_FIELDS[] =
{
    &EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_2_FIELD,
    &EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE9_REG = 
{
    "10G_ABC_SIZE9",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE9 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE9_REG_OFFSET,
    0,
    0,
    349,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE9_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE10
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE10_FIELDS[] =
{
    &EPN_10G_ABC_SIZE10_CFGADDBURSTCAP7_1_FIELD,
    &EPN_10G_ABC_SIZE10_CFGADDBURSTCAP6_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE10_REG = 
{
    "10G_ABC_SIZE10",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE10 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE10_REG_OFFSET,
    0,
    0,
    350,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE10_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE11
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE11_FIELDS[] =
{
    &EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_3_FIELD,
    &EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE11_REG = 
{
    "10G_ABC_SIZE11",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE11 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE11_REG_OFFSET,
    0,
    0,
    351,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE11_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE12
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE12_FIELDS[] =
{
    &EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_2_FIELD,
    &EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE12_REG = 
{
    "10G_ABC_SIZE12",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE12 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE12_REG_OFFSET,
    0,
    0,
    352,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE12_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE13
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE13_FIELDS[] =
{
    &EPN_10G_ABC_SIZE13_CFGADDBURSTCAP9_1_FIELD,
    &EPN_10G_ABC_SIZE13_CFGADDBURSTCAP8_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE13_REG = 
{
    "10G_ABC_SIZE13",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE13 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE13_REG_OFFSET,
    0,
    0,
    353,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE13_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE14
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE14_FIELDS[] =
{
    &EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_3_FIELD,
    &EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE14_REG = 
{
    "10G_ABC_SIZE14",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE14 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE14_REG_OFFSET,
    0,
    0,
    354,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE14_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE15
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE15_FIELDS[] =
{
    &EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_2_FIELD,
    &EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE15_REG = 
{
    "10G_ABC_SIZE15",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE15 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE15_REG_OFFSET,
    0,
    0,
    355,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE15_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE16
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE16_FIELDS[] =
{
    &EPN_10G_ABC_SIZE16_CFGADDBURSTCAP11_1_FIELD,
    &EPN_10G_ABC_SIZE16_CFGADDBURSTCAP10_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE16_REG = 
{
    "10G_ABC_SIZE16",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE16 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE16_REG_OFFSET,
    0,
    0,
    356,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE16_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE17
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE17_FIELDS[] =
{
    &EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_3_FIELD,
    &EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE17_REG = 
{
    "10G_ABC_SIZE17",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE17 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE17_REG_OFFSET,
    0,
    0,
    357,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE17_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE18
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE18_FIELDS[] =
{
    &EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_2_FIELD,
    &EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE18_REG = 
{
    "10G_ABC_SIZE18",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE18 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE18_REG_OFFSET,
    0,
    0,
    358,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE18_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE19
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE19_FIELDS[] =
{
    &EPN_10G_ABC_SIZE19_CFGADDBURSTCAP13_1_FIELD,
    &EPN_10G_ABC_SIZE19_CFGADDBURSTCAP12_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE19_REG = 
{
    "10G_ABC_SIZE19",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE19 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE19_REG_OFFSET,
    0,
    0,
    359,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE19_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE20
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE20_FIELDS[] =
{
    &EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_3_FIELD,
    &EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE20_REG = 
{
    "10G_ABC_SIZE20",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE20 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE20_REG_OFFSET,
    0,
    0,
    360,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE20_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE21
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE21_FIELDS[] =
{
    &EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_2_FIELD,
    &EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE21_REG = 
{
    "10G_ABC_SIZE21",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE21 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE21_REG_OFFSET,
    0,
    0,
    361,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE21_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE22
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE22_FIELDS[] =
{
    &EPN_10G_ABC_SIZE22_CFGADDBURSTCAP15_1_FIELD,
    &EPN_10G_ABC_SIZE22_CFGADDBURSTCAP14_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE22_REG = 
{
    "10G_ABC_SIZE22",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE22 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE22_REG_OFFSET,
    0,
    0,
    362,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE22_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE23
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE23_FIELDS[] =
{
    &EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_3_FIELD,
    &EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE23_REG = 
{
    "10G_ABC_SIZE23",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE23 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE23_REG_OFFSET,
    0,
    0,
    363,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE23_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE24
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE24_FIELDS[] =
{
    &EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_2_FIELD,
    &EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE24_REG = 
{
    "10G_ABC_SIZE24",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE24 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE24_REG_OFFSET,
    0,
    0,
    364,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE24_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE25
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE25_FIELDS[] =
{
    &EPN_10G_ABC_SIZE25_CFGADDBURSTCAP17_1_FIELD,
    &EPN_10G_ABC_SIZE25_CFGADDBURSTCAP16_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE25_REG = 
{
    "10G_ABC_SIZE25",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE25 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE25_REG_OFFSET,
    0,
    0,
    365,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE25_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE26
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE26_FIELDS[] =
{
    &EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_3_FIELD,
    &EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE26_REG = 
{
    "10G_ABC_SIZE26",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE26 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE26_REG_OFFSET,
    0,
    0,
    366,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE26_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE27
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE27_FIELDS[] =
{
    &EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_2_FIELD,
    &EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE27_REG = 
{
    "10G_ABC_SIZE27",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE27 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE27_REG_OFFSET,
    0,
    0,
    367,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE27_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE28
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE28_FIELDS[] =
{
    &EPN_10G_ABC_SIZE28_CFGADDBURSTCAP19_1_FIELD,
    &EPN_10G_ABC_SIZE28_CFGADDBURSTCAP18_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE28_REG = 
{
    "10G_ABC_SIZE28",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE28 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE28_REG_OFFSET,
    0,
    0,
    368,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE28_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE29
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE29_FIELDS[] =
{
    &EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_3_FIELD,
    &EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE29_REG = 
{
    "10G_ABC_SIZE29",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE29 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE29_REG_OFFSET,
    0,
    0,
    369,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE29_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE30
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE30_FIELDS[] =
{
    &EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_2_FIELD,
    &EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE30_REG = 
{
    "10G_ABC_SIZE30",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE30 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE30_REG_OFFSET,
    0,
    0,
    370,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE30_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE31
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE31_FIELDS[] =
{
    &EPN_10G_ABC_SIZE31_CFGADDBURSTCAP21_1_FIELD,
    &EPN_10G_ABC_SIZE31_CFGADDBURSTCAP20_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE31_REG = 
{
    "10G_ABC_SIZE31",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE31 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE31_REG_OFFSET,
    0,
    0,
    371,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE31_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE32
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE32_FIELDS[] =
{
    &EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_3_FIELD,
    &EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE32_REG = 
{
    "10G_ABC_SIZE32",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE32 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE32_REG_OFFSET,
    0,
    0,
    372,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE32_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE33
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE33_FIELDS[] =
{
    &EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_2_FIELD,
    &EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE33_REG = 
{
    "10G_ABC_SIZE33",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE33 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE33_REG_OFFSET,
    0,
    0,
    373,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE33_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE34
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE34_FIELDS[] =
{
    &EPN_10G_ABC_SIZE34_CFGADDBURSTCAP23_1_FIELD,
    &EPN_10G_ABC_SIZE34_CFGADDBURSTCAP22_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE34_REG = 
{
    "10G_ABC_SIZE34",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE34 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE34_REG_OFFSET,
    0,
    0,
    374,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE34_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE35
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE35_FIELDS[] =
{
    &EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_3_FIELD,
    &EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE35_REG = 
{
    "10G_ABC_SIZE35",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE35 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE35_REG_OFFSET,
    0,
    0,
    375,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE35_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE36
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE36_FIELDS[] =
{
    &EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_2_FIELD,
    &EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE36_REG = 
{
    "10G_ABC_SIZE36",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE36 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE36_REG_OFFSET,
    0,
    0,
    376,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE36_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE37
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE37_FIELDS[] =
{
    &EPN_10G_ABC_SIZE37_CFGADDBURSTCAP25_1_FIELD,
    &EPN_10G_ABC_SIZE37_CFGADDBURSTCAP24_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE37_REG = 
{
    "10G_ABC_SIZE37",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE37 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE37_REG_OFFSET,
    0,
    0,
    377,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE37_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE38
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE38_FIELDS[] =
{
    &EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_3_FIELD,
    &EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE38_REG = 
{
    "10G_ABC_SIZE38",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE38 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE38_REG_OFFSET,
    0,
    0,
    378,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE38_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE39
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE39_FIELDS[] =
{
    &EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_2_FIELD,
    &EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE39_REG = 
{
    "10G_ABC_SIZE39",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE39 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE39_REG_OFFSET,
    0,
    0,
    379,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE39_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE40
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE40_FIELDS[] =
{
    &EPN_10G_ABC_SIZE40_CFGADDBURSTCAP27_1_FIELD,
    &EPN_10G_ABC_SIZE40_CFGADDBURSTCAP26_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE40_REG = 
{
    "10G_ABC_SIZE40",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE40 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE40_REG_OFFSET,
    0,
    0,
    380,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE40_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE41
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE41_FIELDS[] =
{
    &EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_3_FIELD,
    &EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE41_REG = 
{
    "10G_ABC_SIZE41",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE41 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE41_REG_OFFSET,
    0,
    0,
    381,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE41_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE42
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE42_FIELDS[] =
{
    &EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_2_FIELD,
    &EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE42_REG = 
{
    "10G_ABC_SIZE42",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE42 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE42_REG_OFFSET,
    0,
    0,
    382,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE42_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE43
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE43_FIELDS[] =
{
    &EPN_10G_ABC_SIZE43_CFGADDBURSTCAP29_1_FIELD,
    &EPN_10G_ABC_SIZE43_CFGADDBURSTCAP28_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE43_REG = 
{
    "10G_ABC_SIZE43",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE43 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE43_REG_OFFSET,
    0,
    0,
    383,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE43_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE44
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE44_FIELDS[] =
{
    &EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_3_FIELD,
    &EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE44_REG = 
{
    "10G_ABC_SIZE44",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE44 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE44_REG_OFFSET,
    0,
    0,
    384,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE44_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE45
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE45_FIELDS[] =
{
    &EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_2_FIELD,
    &EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_1_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE45_REG = 
{
    "10G_ABC_SIZE45",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE45 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE45_REG_OFFSET,
    0,
    0,
    385,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE45_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE46
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE46_FIELDS[] =
{
    &EPN_10G_ABC_SIZE46_CFGADDBURSTCAP31_1_FIELD,
    &EPN_10G_ABC_SIZE46_CFGADDBURSTCAP30_3_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE46_REG = 
{
    "10G_ABC_SIZE46",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE46 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE46_REG_OFFSET,
    0,
    0,
    386,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE46_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Register: EPN_10G_ABC_SIZE47
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *EPN_10G_ABC_SIZE47_FIELDS[] =
{
    &EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_3_FIELD,
    &EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_2_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec EPN_10G_ABC_SIZE47_REG = 
{
    "10G_ABC_SIZE47",
#if RU_INCLUDE_DESC
    "EPN_10G_ABC_SIZE47 Register",
    "How many additional Time Quanta the queue sets should use in 10G mode."
    "This feature is intended to be used in"
    "SIEPON mode.",
#endif
    EPN_10G_ABC_SIZE47_REG_OFFSET,
    0,
    0,
    387,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    2,
    EPN_10G_ABC_SIZE47_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_32
};

/******************************************************************************
 * Block: EPN
 ******************************************************************************/
static const ru_reg_rec *EPN_REGS[] =
{
    &EPN_CONTROL_0_REG,
    &EPN_CONTROL_1_REG,
    &EPN_ENABLE_GRANTS_REG,
    &EPN_DROP_DISC_GATES_REG,
    &EPN_DIS_FCS_CHK_REG,
    &EPN_PASS_GATES_REG,
    &EPN_CFG_MISALGN_FB_REG,
    &EPN_DISCOVERY_FILTER_REG,
    &EPN_MINIMUM_GRANT_SETUP_REG,
    &EPN_RESET_GNT_FIFO_REG,
    &EPN_RESET_L1_ACCUMULATOR_REG,
    &EPN_L1_ACCUMULATOR_SEL_REG,
    &EPN_L1_SVA_BYTES_REG,
    &EPN_L1_UVA_BYTES_REG,
    &EPN_L1_SVA_OVERFLOW_REG,
    &EPN_L1_UVA_OVERFLOW_REG,
    &EPN_RESET_RPT_PRI_REG,
    &EPN_RESET_L2_RPT_FIFO_REG,
    &EPN_ENABLE_UPSTREAM_REG,
    &EPN_ENABLE_UPSTREAM_FB_REG,
    &EPN_ENABLE_UPSTREAM_FEC_REG,
    &EPN_REPORT_BYTE_LENGTH_REG,
    &EPN_MAIN_INT_STATUS_REG,
    &EPN_GNT_FULL_INT_STATUS_REG,
    &EPN_GNT_FULL_INT_MASK_REG,
    &EPN_GNT_MISS_INT_STATUS_REG,
    &EPN_GNT_MISS_INT_MASK_REG,
    &EPN_DISC_RX_INT_STATUS_REG,
    &EPN_DISC_RX_INT_MASK_REG,
    &EPN_GNT_INTV_INT_STATUS_REG,
    &EPN_GNT_INTV_INT_MASK_REG,
    &EPN_GNT_FAR_INT_STATUS_REG,
    &EPN_GNT_FAR_INT_MASK_REG,
    &EPN_GNT_MISALGN_INT_STATUS_REG,
    &EPN_GNT_MISALGN_INT_MASK_REG,
    &EPN_NP_GNT_INT_STATUS_REG,
    &EPN_NP_GNT_INT_MASK_REG,
    &EPN_DEL_STALE_INT_STATUS_REG,
    &EPN_DEL_STALE_INT_MASK_REG,
    &EPN_GNT_PRES_INT_STATUS_REG,
    &EPN_GNT_PRES_INT_MASK_REG,
    &EPN_RPT_PRES_INT_STATUS_REG,
    &EPN_RPT_PRES_INT_MASK_REG,
    &EPN_DRX_ABORT_INT_STATUS_REG,
    &EPN_DRX_ABORT_INT_MASK_REG,
    &EPN_EMPTY_RPT_INT_STATUS_REG,
    &EPN_EMPTY_RPT_INT_MASK_REG,
    &EPN_BCAP_OVERFLOW_INT_STATUS_REG,
    &EPN_BCAP_OVERFLOW_INT_MASK_REG,
    &EPN_BBH_DNS_FAULT_INT_STATUS_REG,
    &EPN_BBH_DNS_FAULT_INT_MASK_REG,
    &EPN_BBH_UPS_FAULT_INT_STATUS_REG,
    &EPN_BBH_UPS_FAULT_INT_MASK_REG,
    &EPN_BBH_UPS_ABORT_INT_STATUS_REG,
    &EPN_BBH_UPS_ABORT_INT_MASK_REG,
    &EPN_MAIN_INT_MASK_REG,
    &EPN_MAX_GNT_SIZE_REG,
    &EPN_MAX_FRAME_SIZE_REG,
    &EPN_GRANT_OVR_HD_REG,
    &EPN_POLL_SIZE_REG,
    &EPN_DN_RD_GNT_MARGIN_REG,
    &EPN_GNT_TIME_START_DELTA_REG,
    &EPN_TIME_STAMP_DIFF_REG,
    &EPN_UP_TIME_STAMP_OFF_REG,
    &EPN_GNT_INTERVAL_REG,
    &EPN_DN_GNT_MISALIGN_THR_REG,
    &EPN_DN_GNT_MISALIGN_PAUSE_REG,
    &EPN_NON_POLL_INTV_REG,
    &EPN_FORCE_FCS_ERR_REG,
    &EPN_GRANT_OVERLAP_LIMIT_REG,
    &EPN_AES_CONFIGURATION_0_REG,
    &EPN_DISC_GRANT_OVR_HD_REG,
    &EPN_DN_DISCOVERY_SEED_REG,
    &EPN_DN_DISCOVERY_INC_REG,
    &EPN_DN_DISCOVERY_SIZE_REG,
    &EPN_FEC_IPG_LENGTH_REG,
    &EPN_FAKE_REPORT_VALUE_EN_REG,
    &EPN_FAKE_REPORT_VALUE_REG,
    &EPN_VALID_OPCODE_MAP_REG,
    &EPN_UP_PACKET_TX_MARGIN_REG,
    &EPN_MULTI_PRI_CFG_0_REG,
    &EPN_SHARED_BCAP_OVRFLOW_REG,
    &EPN_FORCED_REPORT_EN_REG,
    &EPN_FORCED_REPORT_MAX_INTERVAL_REG,
    &EPN_L2S_FLUSH_CONFIG_REG,
    &EPN_DATA_PORT_COMMAND_REG,
    &EPN_DATA_PORT_ADDRESS_REG,
    &EPN_DATA_PORT_DATA_0_REG,
    &EPN_UNMAP_BIG_CNT_REG,
    &EPN_UNMAP_FRAME_CNT_REG,
    &EPN_UNMAP_FCS_CNT_REG,
    &EPN_UNMAP_GATE_CNT_REG,
    &EPN_UNMAP_OAM_CNT_REG,
    &EPN_UNMAP_SMALL_CNT_REG,
    &EPN_FIF_DEQUEUE_EVENT_CNT_REG,
    &EPN_BBH_UP_FAULT_HALT_EN_REG,
    &EPN_BBH_UP_TARDY_HALT_EN_REG,
    &EPN_DEBUG_STATUS_0_REG,
    &EPN_DEBUG_STATUS_1_REG,
    &EPN_DEBUG_L2S_PTR_SEL_REG,
    &EPN_OLT_MAC_ADDR_LO_REG,
    &EPN_OLT_MAC_ADDR_HI_REG,
    &EPN_TX_L1S_SHP_DQU_EMPTY_REG,
    &EPN_TX_L1S_UNSHAPED_EMPTY_REG,
    &EPN_TX_L2S_QUE_EMPTY_REG,
    &EPN_TX_L2S_QUE_FULL_REG,
    &EPN_TX_L2S_QUE_STOPPED_REG,
    &EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_REG,
    &EPN_MIN_REPORT_VALUE_DIFFERENCE_REG,
    &EPN_BBH_STATUS_FIFO_OVERFLOW_REG,
    &EPN_SPARE_CTL_REG,
    &EPN_TS_SYNC_OFFSET_REG,
    &EPN_DN_TS_OFFSET_REG,
    &EPN_UP_TS_OFFSET_LO_REG,
    &EPN_UP_TS_OFFSET_HI_REG,
    &EPN_TWO_STEP_TS_CTL_REG,
    &EPN_TWO_STEP_TS_VALUE_LO_REG,
    &EPN_TWO_STEP_TS_VALUE_HI_REG,
    &EPN_1588_TIMESTAMP_INT_STATUS_REG,
    &EPN_1588_TIMESTAMP_INT_MASK_REG,
    &EPN_UP_PACKET_FETCH_MARGIN_REG,
    &EPN_DN_1588_TIMESTAMP_REG,
    &EPN_PERSISTENT_REPORT_CFG_REG,
    &EPN_PERSISTENT_REPORT_ENABLES_REG,
    &EPN_PERSISTENT_REPORT_REQUEST_SIZE_REG,
    &EPN_AES_CONFIGURATION_1_REG,
    &EPN_BURST_CAP_0_REG,
    &EPN_BURST_CAP_1_REG,
    &EPN_BURST_CAP_2_REG,
    &EPN_BURST_CAP_3_REG,
    &EPN_BURST_CAP_4_REG,
    &EPN_BURST_CAP_5_REG,
    &EPN_BURST_CAP_6_REG,
    &EPN_BURST_CAP_7_REG,
    &EPN_QUEUE_LLID_MAP_0_REG,
    &EPN_QUEUE_LLID_MAP_1_REG,
    &EPN_QUEUE_LLID_MAP_2_REG,
    &EPN_QUEUE_LLID_MAP_3_REG,
    &EPN_QUEUE_LLID_MAP_4_REG,
    &EPN_QUEUE_LLID_MAP_5_REG,
    &EPN_QUEUE_LLID_MAP_6_REG,
    &EPN_QUEUE_LLID_MAP_7_REG,
    &EPN_UNUSED_TQ_CNT0_REG,
    &EPN_UNUSED_TQ_CNT1_REG,
    &EPN_UNUSED_TQ_CNT2_REG,
    &EPN_UNUSED_TQ_CNT3_REG,
    &EPN_UNUSED_TQ_CNT4_REG,
    &EPN_UNUSED_TQ_CNT5_REG,
    &EPN_UNUSED_TQ_CNT6_REG,
    &EPN_UNUSED_TQ_CNT7_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_0_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_1_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_2_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_3_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_4_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_5_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_6_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_7_REG,
    &EPN_TX_L2S_QUE_CONFIG_0_REG,
    &EPN_TX_L2S_QUE_CONFIG_1_REG,
    &EPN_TX_L2S_QUE_CONFIG_2_REG,
    &EPN_TX_L2S_QUE_CONFIG_3_REG,
    &EPN_TX_L2S_QUE_CONFIG_4_REG,
    &EPN_TX_L2S_QUE_CONFIG_5_REG,
    &EPN_TX_L2S_QUE_CONFIG_6_REG,
    &EPN_TX_L2S_QUE_CONFIG_7_REG,
    &EPN_TX_CTC_BURST_LIMIT_0_REG,
    &EPN_TX_CTC_BURST_LIMIT_1_REG,
    &EPN_TX_CTC_BURST_LIMIT_2_REG,
    &EPN_TX_CTC_BURST_LIMIT_3_REG,
    &EPN_TX_CTC_BURST_LIMIT_4_REG,
    &EPN_TX_CTC_BURST_LIMIT_5_REG,
    &EPN_TX_CTC_BURST_LIMIT_6_REG,
    &EPN_TX_CTC_BURST_LIMIT_7_REG,
    &EPN_BURST_CAP_8_REG,
    &EPN_BURST_CAP_9_REG,
    &EPN_BURST_CAP_10_REG,
    &EPN_BURST_CAP_11_REG,
    &EPN_BURST_CAP_12_REG,
    &EPN_BURST_CAP_13_REG,
    &EPN_BURST_CAP_14_REG,
    &EPN_BURST_CAP_15_REG,
    &EPN_BURST_CAP_16_REG,
    &EPN_BURST_CAP_17_REG,
    &EPN_BURST_CAP_18_REG,
    &EPN_BURST_CAP_19_REG,
    &EPN_BURST_CAP_20_REG,
    &EPN_BURST_CAP_21_REG,
    &EPN_BURST_CAP_22_REG,
    &EPN_BURST_CAP_23_REG,
    &EPN_BURST_CAP_24_REG,
    &EPN_BURST_CAP_25_REG,
    &EPN_BURST_CAP_26_REG,
    &EPN_BURST_CAP_27_REG,
    &EPN_BURST_CAP_28_REG,
    &EPN_BURST_CAP_29_REG,
    &EPN_BURST_CAP_30_REG,
    &EPN_BURST_CAP_31_REG,
    &EPN_QUEUE_LLID_MAP_8_REG,
    &EPN_QUEUE_LLID_MAP_9_REG,
    &EPN_QUEUE_LLID_MAP_10_REG,
    &EPN_QUEUE_LLID_MAP_11_REG,
    &EPN_QUEUE_LLID_MAP_12_REG,
    &EPN_QUEUE_LLID_MAP_13_REG,
    &EPN_QUEUE_LLID_MAP_14_REG,
    &EPN_QUEUE_LLID_MAP_15_REG,
    &EPN_QUEUE_LLID_MAP_16_REG,
    &EPN_QUEUE_LLID_MAP_17_REG,
    &EPN_QUEUE_LLID_MAP_18_REG,
    &EPN_QUEUE_LLID_MAP_19_REG,
    &EPN_QUEUE_LLID_MAP_20_REG,
    &EPN_QUEUE_LLID_MAP_21_REG,
    &EPN_QUEUE_LLID_MAP_22_REG,
    &EPN_QUEUE_LLID_MAP_23_REG,
    &EPN_QUEUE_LLID_MAP_24_REG,
    &EPN_QUEUE_LLID_MAP_25_REG,
    &EPN_QUEUE_LLID_MAP_26_REG,
    &EPN_QUEUE_LLID_MAP_27_REG,
    &EPN_QUEUE_LLID_MAP_28_REG,
    &EPN_QUEUE_LLID_MAP_29_REG,
    &EPN_QUEUE_LLID_MAP_30_REG,
    &EPN_QUEUE_LLID_MAP_31_REG,
    &EPN_UNUSED_TQ_CNT8_REG,
    &EPN_UNUSED_TQ_CNT9_REG,
    &EPN_UNUSED_TQ_CNT10_REG,
    &EPN_UNUSED_TQ_CNT11_REG,
    &EPN_UNUSED_TQ_CNT12_REG,
    &EPN_UNUSED_TQ_CNT13_REG,
    &EPN_UNUSED_TQ_CNT14_REG,
    &EPN_UNUSED_TQ_CNT15_REG,
    &EPN_UNUSED_TQ_CNT16_REG,
    &EPN_UNUSED_TQ_CNT17_REG,
    &EPN_UNUSED_TQ_CNT18_REG,
    &EPN_UNUSED_TQ_CNT19_REG,
    &EPN_UNUSED_TQ_CNT20_REG,
    &EPN_UNUSED_TQ_CNT21_REG,
    &EPN_UNUSED_TQ_CNT22_REG,
    &EPN_UNUSED_TQ_CNT23_REG,
    &EPN_UNUSED_TQ_CNT24_REG,
    &EPN_UNUSED_TQ_CNT25_REG,
    &EPN_UNUSED_TQ_CNT26_REG,
    &EPN_UNUSED_TQ_CNT27_REG,
    &EPN_UNUSED_TQ_CNT28_REG,
    &EPN_UNUSED_TQ_CNT29_REG,
    &EPN_UNUSED_TQ_CNT30_REG,
    &EPN_UNUSED_TQ_CNT31_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_8_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_9_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_10_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_11_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_12_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_13_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_14_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_15_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_16_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_17_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_18_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_19_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_20_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_21_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_22_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_23_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_24_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_25_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_26_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_27_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_28_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_29_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_30_REG,
    &EPN_TX_L1S_SHP_QUE_MASK_31_REG,
    &EPN_TX_L2S_QUE_CONFIG_8_REG,
    &EPN_TX_L2S_QUE_CONFIG_9_REG,
    &EPN_TX_L2S_QUE_CONFIG_10_REG,
    &EPN_TX_L2S_QUE_CONFIG_11_REG,
    &EPN_TX_L2S_QUE_CONFIG_12_REG,
    &EPN_TX_L2S_QUE_CONFIG_13_REG,
    &EPN_TX_L2S_QUE_CONFIG_14_REG,
    &EPN_TX_L2S_QUE_CONFIG_15_REG,
    &EPN_TX_L2S_QUE_CONFIG_16_REG,
    &EPN_TX_L2S_QUE_CONFIG_17_REG,
    &EPN_TX_L2S_QUE_CONFIG_18_REG,
    &EPN_TX_L2S_QUE_CONFIG_19_REG,
    &EPN_TX_L2S_QUE_CONFIG_20_REG,
    &EPN_TX_L2S_QUE_CONFIG_21_REG,
    &EPN_TX_L2S_QUE_CONFIG_22_REG,
    &EPN_TX_L2S_QUE_CONFIG_23_REG,
    &EPN_TX_L2S_QUE_CONFIG_24_REG,
    &EPN_TX_L2S_QUE_CONFIG_25_REG,
    &EPN_TX_L2S_QUE_CONFIG_26_REG,
    &EPN_TX_L2S_QUE_CONFIG_27_REG,
    &EPN_TX_L2S_QUE_CONFIG_28_REG,
    &EPN_TX_L2S_QUE_CONFIG_29_REG,
    &EPN_TX_L2S_QUE_CONFIG_30_REG,
    &EPN_TX_L2S_QUE_CONFIG_31_REG,
    &EPN_TX_CTC_BURST_LIMIT_8_REG,
    &EPN_TX_CTC_BURST_LIMIT_9_REG,
    &EPN_TX_CTC_BURST_LIMIT_10_REG,
    &EPN_TX_CTC_BURST_LIMIT_11_REG,
    &EPN_TX_CTC_BURST_LIMIT_12_REG,
    &EPN_TX_CTC_BURST_LIMIT_13_REG,
    &EPN_TX_CTC_BURST_LIMIT_14_REG,
    &EPN_TX_CTC_BURST_LIMIT_15_REG,
    &EPN_TX_CTC_BURST_LIMIT_16_REG,
    &EPN_TX_CTC_BURST_LIMIT_17_REG,
    &EPN_TX_CTC_BURST_LIMIT_18_REG,
    &EPN_TX_CTC_BURST_LIMIT_19_REG,
    &EPN_TX_CTC_BURST_LIMIT_20_REG,
    &EPN_TX_CTC_BURST_LIMIT_21_REG,
    &EPN_TX_CTC_BURST_LIMIT_22_REG,
    &EPN_TX_CTC_BURST_LIMIT_23_REG,
    &EPN_TX_CTC_BURST_LIMIT_24_REG,
    &EPN_TX_CTC_BURST_LIMIT_25_REG,
    &EPN_TX_CTC_BURST_LIMIT_26_REG,
    &EPN_TX_CTC_BURST_LIMIT_27_REG,
    &EPN_TX_CTC_BURST_LIMIT_28_REG,
    &EPN_TX_CTC_BURST_LIMIT_29_REG,
    &EPN_TX_CTC_BURST_LIMIT_30_REG,
    &EPN_TX_CTC_BURST_LIMIT_31_REG,
    &EPN_10G_ABC_SIZE0_REG,
    &EPN_10G_ABC_SIZE1_REG,
    &EPN_10G_ABC_SIZE2_REG,
    &EPN_10G_ABC_SIZE3_REG,
    &EPN_10G_ABC_SIZE4_REG,
    &EPN_10G_ABC_SIZE5_REG,
    &EPN_10G_ABC_SIZE6_REG,
    &EPN_10G_ABC_SIZE7_REG,
    &EPN_10G_ABC_SIZE8_REG,
    &EPN_10G_ABC_SIZE9_REG,
    &EPN_10G_ABC_SIZE10_REG,
    &EPN_10G_ABC_SIZE11_REG,
    &EPN_10G_ABC_SIZE12_REG,
    &EPN_10G_ABC_SIZE13_REG,
    &EPN_10G_ABC_SIZE14_REG,
    &EPN_10G_ABC_SIZE15_REG,
    &EPN_10G_ABC_SIZE16_REG,
    &EPN_10G_ABC_SIZE17_REG,
    &EPN_10G_ABC_SIZE18_REG,
    &EPN_10G_ABC_SIZE19_REG,
    &EPN_10G_ABC_SIZE20_REG,
    &EPN_10G_ABC_SIZE21_REG,
    &EPN_10G_ABC_SIZE22_REG,
    &EPN_10G_ABC_SIZE23_REG,
    &EPN_10G_ABC_SIZE24_REG,
    &EPN_10G_ABC_SIZE25_REG,
    &EPN_10G_ABC_SIZE26_REG,
    &EPN_10G_ABC_SIZE27_REG,
    &EPN_10G_ABC_SIZE28_REG,
    &EPN_10G_ABC_SIZE29_REG,
    &EPN_10G_ABC_SIZE30_REG,
    &EPN_10G_ABC_SIZE31_REG,
    &EPN_10G_ABC_SIZE32_REG,
    &EPN_10G_ABC_SIZE33_REG,
    &EPN_10G_ABC_SIZE34_REG,
    &EPN_10G_ABC_SIZE35_REG,
    &EPN_10G_ABC_SIZE36_REG,
    &EPN_10G_ABC_SIZE37_REG,
    &EPN_10G_ABC_SIZE38_REG,
    &EPN_10G_ABC_SIZE39_REG,
    &EPN_10G_ABC_SIZE40_REG,
    &EPN_10G_ABC_SIZE41_REG,
    &EPN_10G_ABC_SIZE42_REG,
    &EPN_10G_ABC_SIZE43_REG,
    &EPN_10G_ABC_SIZE44_REG,
    &EPN_10G_ABC_SIZE45_REG,
    &EPN_10G_ABC_SIZE46_REG,
    &EPN_10G_ABC_SIZE47_REG,
};

static unsigned long EPN_ADDRS[] =
{
    0x82dad000,
};

const ru_block_rec EPN_BLOCK = 
{
    "EPN",
    EPN_ADDRS,
    1,
    366,
    EPN_REGS
};

/* End of file EPON_EPN.c */
