/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _EPON_AG_H_
#define _EPON_AG_H_

#include "ru.h"

/******************************************************************************
 * EPON Fields
 ******************************************************************************/
extern const ru_field_rec EPON_TOP_SCRATCH_SCRATCH_FIELD;
#define EPON_TOP_SCRATCH_SCRATCH_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_SCRATCH_SCRATCH_FIELD_WIDTH 32
#define EPON_TOP_SCRATCH_SCRATCH_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_RESET_RESERVED0_FIELD;
#define EPON_TOP_RESET_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPON_TOP_RESET_RESERVED0_FIELD_WIDTH 24
#define EPON_TOP_RESET_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPON_TOP_RESET_XPCSRXRST_N_FIELD;
#define EPON_TOP_RESET_XPCSRXRST_N_FIELD_MASK  0x0000000000000080
#define EPON_TOP_RESET_XPCSRXRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_XPCSRXRST_N_FIELD_SHIFT 7

extern const ru_field_rec EPON_TOP_RESET_XPCSTXRST_N_FIELD;
#define EPON_TOP_RESET_XPCSTXRST_N_FIELD_MASK  0x0000000000000040
#define EPON_TOP_RESET_XPCSTXRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_XPCSTXRST_N_FIELD_SHIFT 6

extern const ru_field_rec EPON_TOP_RESET_XIFRST_N_FIELD;
#define EPON_TOP_RESET_XIFRST_N_FIELD_MASK  0x0000000000000020
#define EPON_TOP_RESET_XIFRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_XIFRST_N_FIELD_SHIFT 5

extern const ru_field_rec EPON_TOP_RESET_TODRST_N_FIELD;
#define EPON_TOP_RESET_TODRST_N_FIELD_MASK  0x0000000000000010
#define EPON_TOP_RESET_TODRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_TODRST_N_FIELD_SHIFT 4

extern const ru_field_rec EPON_TOP_RESET_CLKPRGRST_N_FIELD;
#define EPON_TOP_RESET_CLKPRGRST_N_FIELD_MASK  0x0000000000000008
#define EPON_TOP_RESET_CLKPRGRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_CLKPRGRST_N_FIELD_SHIFT 3

extern const ru_field_rec EPON_TOP_RESET_NCORST_N_FIELD;
#define EPON_TOP_RESET_NCORST_N_FIELD_MASK  0x0000000000000004
#define EPON_TOP_RESET_NCORST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_NCORST_N_FIELD_SHIFT 2

extern const ru_field_rec EPON_TOP_RESET_LIFRST_N_FIELD;
#define EPON_TOP_RESET_LIFRST_N_FIELD_MASK  0x0000000000000002
#define EPON_TOP_RESET_LIFRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_LIFRST_N_FIELD_SHIFT 1

extern const ru_field_rec EPON_TOP_RESET_EPNRST_N_FIELD;
#define EPON_TOP_RESET_EPNRST_N_FIELD_MASK  0x0000000000000001
#define EPON_TOP_RESET_EPNRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_EPNRST_N_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_INTERRUPT_RESERVED0_FIELD;
#define EPON_TOP_INTERRUPT_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPON_TOP_INTERRUPT_RESERVED0_FIELD_WIDTH 24
#define EPON_TOP_INTERRUPT_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_1PPS_FIELD;
#define EPON_TOP_INTERRUPT_INT_1PPS_FIELD_MASK  0x0000000000000080
#define EPON_TOP_INTERRUPT_INT_1PPS_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_1PPS_FIELD_SHIFT 7

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_XPCS_TX_FIELD;
#define EPON_TOP_INTERRUPT_INT_XPCS_TX_FIELD_MASK  0x0000000000000040
#define EPON_TOP_INTERRUPT_INT_XPCS_TX_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_XPCS_TX_FIELD_SHIFT 6

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_XPCS_RX_FIELD;
#define EPON_TOP_INTERRUPT_INT_XPCS_RX_FIELD_MASK  0x0000000000000020
#define EPON_TOP_INTERRUPT_INT_XPCS_RX_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_XPCS_RX_FIELD_SHIFT 5

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_XIF_FIELD;
#define EPON_TOP_INTERRUPT_INT_XIF_FIELD_MASK  0x0000000000000010
#define EPON_TOP_INTERRUPT_INT_XIF_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_XIF_FIELD_SHIFT 4

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_NCO_FIELD;
#define EPON_TOP_INTERRUPT_INT_NCO_FIELD_MASK  0x0000000000000008
#define EPON_TOP_INTERRUPT_INT_NCO_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_NCO_FIELD_SHIFT 3

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_LIF_FIELD;
#define EPON_TOP_INTERRUPT_INT_LIF_FIELD_MASK  0x0000000000000004
#define EPON_TOP_INTERRUPT_INT_LIF_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_LIF_FIELD_SHIFT 2

extern const ru_field_rec EPON_TOP_INTERRUPT_RESERVED1_FIELD;
#define EPON_TOP_INTERRUPT_RESERVED1_FIELD_MASK  0x0000000000000002
#define EPON_TOP_INTERRUPT_RESERVED1_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_RESERVED1_FIELD_SHIFT 1

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_EPN_FIELD;
#define EPON_TOP_INTERRUPT_INT_EPN_FIELD_MASK  0x0000000000000001
#define EPON_TOP_INTERRUPT_INT_EPN_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_EPN_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_RESERVED0_FIELD;
#define EPON_TOP_INTERRUPT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPON_TOP_INTERRUPT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPON_TOP_INTERRUPT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_1PPS_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_1PPS_MASK_FIELD_MASK  0x0000000000000080
#define EPON_TOP_INTERRUPT_MASK_INT_1PPS_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_1PPS_MASK_FIELD_SHIFT 7

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_XPCS_TX_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_XPCS_TX_MASK_FIELD_MASK  0x0000000000000040
#define EPON_TOP_INTERRUPT_MASK_INT_XPCS_TX_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_XPCS_TX_MASK_FIELD_SHIFT 6

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_XPCS_RX_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_XPCS_RX_MASK_FIELD_MASK  0x0000000000000020
#define EPON_TOP_INTERRUPT_MASK_INT_XPCS_RX_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_XPCS_RX_MASK_FIELD_SHIFT 5

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_XIF_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_XIF_MASK_FIELD_MASK  0x0000000000000010
#define EPON_TOP_INTERRUPT_MASK_INT_XIF_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_XIF_MASK_FIELD_SHIFT 4

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_NCO_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_NCO_MASK_FIELD_MASK  0x0000000000000008
#define EPON_TOP_INTERRUPT_MASK_INT_NCO_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_NCO_MASK_FIELD_SHIFT 3

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_LIF_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_LIF_MASK_FIELD_MASK  0x0000000000000004
#define EPON_TOP_INTERRUPT_MASK_INT_LIF_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_LIF_MASK_FIELD_SHIFT 2

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_RESERVED1_FIELD;
#define EPON_TOP_INTERRUPT_MASK_RESERVED1_FIELD_MASK  0x0000000000000002
#define EPON_TOP_INTERRUPT_MASK_RESERVED1_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_RESERVED1_FIELD_SHIFT 1

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_EPN_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_EPN_MASK_FIELD_MASK  0x0000000000000001
#define EPON_TOP_INTERRUPT_MASK_INT_EPN_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_EPN_MASK_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_CONTROL_RESERVED0_FIELD;
#define EPON_TOP_CONTROL_RESERVED0_FIELD_MASK  0x00000000fffffff8
#define EPON_TOP_CONTROL_RESERVED0_FIELD_WIDTH 29
#define EPON_TOP_CONTROL_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec EPON_TOP_CONTROL_CFGTWOGIGPONDNS_FIELD;
#define EPON_TOP_CONTROL_CFGTWOGIGPONDNS_FIELD_MASK  0x0000000000000004
#define EPON_TOP_CONTROL_CFGTWOGIGPONDNS_FIELD_WIDTH 1
#define EPON_TOP_CONTROL_CFGTWOGIGPONDNS_FIELD_SHIFT 2

extern const ru_field_rec EPON_TOP_CONTROL_CFGTENGIGPONUP_FIELD;
#define EPON_TOP_CONTROL_CFGTENGIGPONUP_FIELD_MASK  0x0000000000000002
#define EPON_TOP_CONTROL_CFGTENGIGPONUP_FIELD_WIDTH 1
#define EPON_TOP_CONTROL_CFGTENGIGPONUP_FIELD_SHIFT 1

extern const ru_field_rec EPON_TOP_CONTROL_CFGTENGIGDNS_FIELD;
#define EPON_TOP_CONTROL_CFGTENGIGDNS_FIELD_MASK  0x0000000000000001
#define EPON_TOP_CONTROL_CFGTENGIGDNS_FIELD_WIDTH 1
#define EPON_TOP_CONTROL_CFGTENGIGDNS_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_ONE_PPS_MPCP_OFFSET_CFG_1PPS_MPCP_OFFSET_FIELD;
#define EPON_TOP_ONE_PPS_MPCP_OFFSET_CFG_1PPS_MPCP_OFFSET_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_ONE_PPS_MPCP_OFFSET_CFG_1PPS_MPCP_OFFSET_FIELD_WIDTH 32
#define EPON_TOP_ONE_PPS_MPCP_OFFSET_CFG_1PPS_MPCP_OFFSET_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_CAPTURE_1PPS_MPCP_TIME_FIELD;
#define EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_CAPTURE_1PPS_MPCP_TIME_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_CAPTURE_1PPS_MPCP_TIME_FIELD_WIDTH 32
#define EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_CAPTURE_1PPS_MPCP_TIME_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_NS_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_NS_FIELD_MASK  0x0000000080000000
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_NS_FIELD_WIDTH 1
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_NS_FIELD_SHIFT 31

extern const ru_field_rec EPON_TOP_TOD_CONFIG_RESERVED0_FIELD;
#define EPON_TOP_TOD_CONFIG_RESERVED0_FIELD_MASK  0x000000007f000000
#define EPON_TOP_TOD_CONFIG_RESERVED0_FIELD_WIDTH 7
#define EPON_TOP_TOD_CONFIG_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_READ_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_FIELD_MASK  0x0000000000800000
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_FIELD_WIDTH 1
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_FIELD_SHIFT 23

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_READ_SEL_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_SEL_FIELD_MASK  0x0000000000600000
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_SEL_FIELD_WIDTH 2
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_SEL_FIELD_SHIFT 21

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_PPS_CLEAR_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_PPS_CLEAR_FIELD_MASK  0x0000000000100000
#define EPON_TOP_TOD_CONFIG_CFG_TOD_PPS_CLEAR_FIELD_WIDTH 1
#define EPON_TOP_TOD_CONFIG_CFG_TOD_PPS_CLEAR_FIELD_SHIFT 20

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_FIELD_MASK  0x0000000000080000
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_FIELD_WIDTH 1
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_FIELD_SHIFT 19

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_SECONDS_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_SECONDS_FIELD_MASK  0x000000000007ffff
#define EPON_TOP_TOD_CONFIG_CFG_TOD_SECONDS_FIELD_WIDTH 19
#define EPON_TOP_TOD_CONFIG_CFG_TOD_SECONDS_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TOD_NS_CFG_TOD_NS_FIELD;
#define EPON_TOP_TOD_NS_CFG_TOD_NS_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_TOD_NS_CFG_TOD_NS_FIELD_WIDTH 32
#define EPON_TOP_TOD_NS_CFG_TOD_NS_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TOD_MPCP_CFG_TOD_MPCP_FIELD;
#define EPON_TOP_TOD_MPCP_CFG_TOD_MPCP_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_TOD_MPCP_CFG_TOD_MPCP_FIELD_WIDTH 32
#define EPON_TOP_TOD_MPCP_CFG_TOD_MPCP_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TS48_MSB_RESERVED0_FIELD;
#define EPON_TOP_TS48_MSB_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPON_TOP_TS48_MSB_RESERVED0_FIELD_WIDTH 16
#define EPON_TOP_TS48_MSB_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPON_TOP_TS48_MSB_TS48_EPON_READ_MSB_FIELD;
#define EPON_TOP_TS48_MSB_TS48_EPON_READ_MSB_FIELD_MASK  0x000000000000ffff
#define EPON_TOP_TS48_MSB_TS48_EPON_READ_MSB_FIELD_WIDTH 16
#define EPON_TOP_TS48_MSB_TS48_EPON_READ_MSB_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TS48_LSB_TS48_EPON_READ_LSB_FIELD;
#define EPON_TOP_TS48_LSB_TS48_EPON_READ_LSB_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_TS48_LSB_TS48_EPON_READ_LSB_FIELD_WIDTH 32
#define EPON_TOP_TS48_LSB_TS48_EPON_READ_LSB_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TSEC_RESERVED0_FIELD;
#define EPON_TOP_TSEC_RESERVED0_FIELD_MASK  0x00000000fff80000
#define EPON_TOP_TSEC_RESERVED0_FIELD_WIDTH 13
#define EPON_TOP_TSEC_RESERVED0_FIELD_SHIFT 19

extern const ru_field_rec EPON_TOP_TSEC_TSEC_EPON_READ_FIELD;
#define EPON_TOP_TSEC_TSEC_EPON_READ_FIELD_MASK  0x000000000007ffff
#define EPON_TOP_TSEC_TSEC_EPON_READ_FIELD_WIDTH 19
#define EPON_TOP_TSEC_TSEC_EPON_READ_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TNS_EPON_TNS_EPON_READ_FIELD;
#define EPON_TOP_TNS_EPON_TNS_EPON_READ_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_TNS_EPON_TNS_EPON_READ_FIELD_WIDTH 32
#define EPON_TOP_TNS_EPON_TNS_EPON_READ_FIELD_SHIFT 0

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKSEL_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKSEL_FIELD_MASK  0x00000000e0000000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKSEL_FIELD_WIDTH 3
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKSEL_FIELD_SHIFT 29

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_RESERVED0_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_RESERVED0_FIELD_MASK  0x0000000010000000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_RESERVED0_FIELD_WIDTH 1
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKDIVIDE_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKDIVIDE_FIELD_MASK  0x000000000fffffff
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKDIVIDE_FIELD_WIDTH 28
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKDIVIDE_FIELD_SHIFT 0

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_RESERVED0_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_RESERVED0_FIELD_MASK  0x00000000ffffe000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_RESERVED0_FIELD_WIDTH 19
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_RESERVED0_FIELD_SHIFT 13

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_CFGPRGCLKDENOM_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_CFGPRGCLKDENOM_FIELD_MASK  0x0000000000001fff
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_CFGPRGCLKDENOM_FIELD_WIDTH 13
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_CFGPRGCLKDENOM_FIELD_SHIFT 0

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKSEL_1_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKSEL_1_FIELD_MASK  0x00000000e0000000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKSEL_1_FIELD_WIDTH 3
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKSEL_1_FIELD_SHIFT 29

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_RESERVED0_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_RESERVED0_FIELD_MASK  0x0000000010000000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_RESERVED0_FIELD_WIDTH 1
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKDIVIDE_1_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKDIVIDE_1_FIELD_MASK  0x000000000fffffff
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKDIVIDE_1_FIELD_WIDTH 28
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKDIVIDE_1_FIELD_SHIFT 0

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_RESERVED0_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_RESERVED0_FIELD_MASK  0x00000000ffffe000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_RESERVED0_FIELD_WIDTH 19
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_RESERVED0_FIELD_SHIFT 13

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_CFGPRGCLKDENOM_1_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_CFGPRGCLKDENOM_1_FIELD_MASK  0x0000000000001fff
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_CFGPRGCLKDENOM_1_FIELD_WIDTH 13
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_CFGPRGCLKDENOM_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_ONU_MAC_ADDR_LO_MFGADDRREGLO_FIELD;
#define EPN_ONU_MAC_ADDR_LO_MFGADDRREGLO_FIELD_MASK  0x00000000ff000000
#define EPN_ONU_MAC_ADDR_LO_MFGADDRREGLO_FIELD_WIDTH 8
#define EPN_ONU_MAC_ADDR_LO_MFGADDRREGLO_FIELD_SHIFT 24

extern const ru_field_rec EPN_ONU_MAC_ADDR_LO_ONUADDRREG_FIELD;
#define EPN_ONU_MAC_ADDR_LO_ONUADDRREG_FIELD_MASK  0x0000000000ffffff
#define EPN_ONU_MAC_ADDR_LO_ONUADDRREG_FIELD_WIDTH 24
#define EPN_ONU_MAC_ADDR_LO_ONUADDRREG_FIELD_SHIFT 0

extern const ru_field_rec EPN_ONU_MAC_ADDR_HI_RESERVED0_FIELD;
#define EPN_ONU_MAC_ADDR_HI_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_ONU_MAC_ADDR_HI_RESERVED0_FIELD_WIDTH 16
#define EPN_ONU_MAC_ADDR_HI_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_ONU_MAC_ADDR_HI_MFGADDRREGHI_FIELD;
#define EPN_ONU_MAC_ADDR_HI_MFGADDRREGHI_FIELD_MASK  0x000000000000ffff
#define EPN_ONU_MAC_ADDR_HI_MFGADDRREGHI_FIELD_WIDTH 16
#define EPN_ONU_MAC_ADDR_HI_MFGADDRREGHI_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_CONFIG_RESERVED0_FIELD;
#define EPN_TX_L1S_SHP_CONFIG_RESERVED0_FIELD_MASK  0x0000000080000000
#define EPN_TX_L1S_SHP_CONFIG_RESERVED0_FIELD_WIDTH 1
#define EPN_TX_L1S_SHP_CONFIG_RESERVED0_FIELD_SHIFT 31

extern const ru_field_rec EPN_TX_L1S_SHP_CONFIG_CFGSHPRATE_FIELD;
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPRATE_FIELD_MASK  0x000000007fffff00
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPRATE_FIELD_WIDTH 23
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPRATE_FIELD_SHIFT 8

extern const ru_field_rec EPN_TX_L1S_SHP_CONFIG_CFGSHPBSTSIZE_FIELD;
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPBSTSIZE_FIELD_MASK  0x00000000000000ff
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPBSTSIZE_FIELD_WIDTH 8
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPBSTSIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_EN_CFGSHPEN_FIELD;
#define EPN_TX_L1S_SHP_QUE_EN_CFGSHPEN_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_EN_CFGSHPEN_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_EN_CFGSHPEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_CONTROL_0_CFGEN1588TS_FIELD;
#define EPN_CONTROL_0_CFGEN1588TS_FIELD_MASK  0x0000000080000000
#define EPN_CONTROL_0_CFGEN1588TS_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGEN1588TS_FIELD_SHIFT 31

extern const ru_field_rec EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD;
#define EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD_MASK  0x0000000040000000
#define EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD_SHIFT 30

extern const ru_field_rec EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD;
#define EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD_MASK  0x0000000020000000
#define EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD_SHIFT 29

extern const ru_field_rec EPN_CONTROL_0_CFGDROPSCB_FIELD;
#define EPN_CONTROL_0_CFGDROPSCB_FIELD_MASK  0x0000000010000000
#define EPN_CONTROL_0_CFGDROPSCB_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGDROPSCB_FIELD_SHIFT 28

extern const ru_field_rec EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD;
#define EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD_MASK  0x0000000008000000
#define EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD_WIDTH 1
#define EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD_SHIFT 27

extern const ru_field_rec EPN_CONTROL_0_MODMPQUESETFIRST_FIELD;
#define EPN_CONTROL_0_MODMPQUESETFIRST_FIELD_MASK  0x0000000004000000
#define EPN_CONTROL_0_MODMPQUESETFIRST_FIELD_WIDTH 1
#define EPN_CONTROL_0_MODMPQUESETFIRST_FIELD_SHIFT 26

extern const ru_field_rec EPN_CONTROL_0_RESERVED0_FIELD;
#define EPN_CONTROL_0_RESERVED0_FIELD_MASK  0x0000000002000000
#define EPN_CONTROL_0_RESERVED0_FIELD_WIDTH 1
#define EPN_CONTROL_0_RESERVED0_FIELD_SHIFT 25

extern const ru_field_rec EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD;
#define EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD_MASK  0x0000000001000000
#define EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD_SHIFT 24

extern const ru_field_rec EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD;
#define EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD_MASK  0x0000000000800000
#define EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD_SHIFT 23

extern const ru_field_rec EPN_CONTROL_0_RESERVED1_FIELD;
#define EPN_CONTROL_0_RESERVED1_FIELD_MASK  0x0000000000400000
#define EPN_CONTROL_0_RESERVED1_FIELD_WIDTH 1
#define EPN_CONTROL_0_RESERVED1_FIELD_SHIFT 22

extern const ru_field_rec EPN_CONTROL_0_PRVINCNONZEROACCUM_FIELD;
#define EPN_CONTROL_0_PRVINCNONZEROACCUM_FIELD_MASK  0x0000000000200000
#define EPN_CONTROL_0_PRVINCNONZEROACCUM_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVINCNONZEROACCUM_FIELD_SHIFT 21

extern const ru_field_rec EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD;
#define EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD_MASK  0x0000000000100000
#define EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD_SHIFT 20

extern const ru_field_rec EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD;
#define EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD_MASK  0x0000000000080000
#define EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD_SHIFT 19

extern const ru_field_rec EPN_CONTROL_0_CFGVLANMAX_FIELD;
#define EPN_CONTROL_0_CFGVLANMAX_FIELD_MASK  0x0000000000040000
#define EPN_CONTROL_0_CFGVLANMAX_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGVLANMAX_FIELD_SHIFT 18

extern const ru_field_rec EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD;
#define EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD_MASK  0x0000000000020000
#define EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD_WIDTH 1
#define EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD_SHIFT 17

extern const ru_field_rec EPN_CONTROL_0_RESERVED2_FIELD;
#define EPN_CONTROL_0_RESERVED2_FIELD_MASK  0x000000000001e000
#define EPN_CONTROL_0_RESERVED2_FIELD_WIDTH 4
#define EPN_CONTROL_0_RESERVED2_FIELD_SHIFT 13

extern const ru_field_rec EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD;
#define EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD_MASK  0x0000000000001000
#define EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD_SHIFT 12

extern const ru_field_rec EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD;
#define EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD_MASK  0x0000000000000800
#define EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD_SHIFT 11

extern const ru_field_rec EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD;
#define EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD_MASK  0x0000000000000400
#define EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD_WIDTH 1
#define EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD_SHIFT 10

extern const ru_field_rec EPN_CONTROL_0_RPTSELECT_FIELD;
#define EPN_CONTROL_0_RPTSELECT_FIELD_MASK  0x0000000000000300
#define EPN_CONTROL_0_RPTSELECT_FIELD_WIDTH 2
#define EPN_CONTROL_0_RPTSELECT_FIELD_SHIFT 8

extern const ru_field_rec EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD;
#define EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD_MASK  0x0000000000000080
#define EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD_SHIFT 7

extern const ru_field_rec EPN_CONTROL_0_UTXLOOPBACK_FIELD;
#define EPN_CONTROL_0_UTXLOOPBACK_FIELD_MASK  0x0000000000000040
#define EPN_CONTROL_0_UTXLOOPBACK_FIELD_WIDTH 1
#define EPN_CONTROL_0_UTXLOOPBACK_FIELD_SHIFT 6

extern const ru_field_rec EPN_CONTROL_0_UTXEN_FIELD;
#define EPN_CONTROL_0_UTXEN_FIELD_MASK  0x0000000000000020
#define EPN_CONTROL_0_UTXEN_FIELD_WIDTH 1
#define EPN_CONTROL_0_UTXEN_FIELD_SHIFT 5

extern const ru_field_rec EPN_CONTROL_0_UTXRST_PRE_N_FIELD;
#define EPN_CONTROL_0_UTXRST_PRE_N_FIELD_MASK  0x0000000000000010
#define EPN_CONTROL_0_UTXRST_PRE_N_FIELD_WIDTH 1
#define EPN_CONTROL_0_UTXRST_PRE_N_FIELD_SHIFT 4

extern const ru_field_rec EPN_CONTROL_0_CFGDISABLEDNS_FIELD;
#define EPN_CONTROL_0_CFGDISABLEDNS_FIELD_MASK  0x0000000000000008
#define EPN_CONTROL_0_CFGDISABLEDNS_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGDISABLEDNS_FIELD_SHIFT 3

extern const ru_field_rec EPN_CONTROL_0_DRXLOOPBACK_FIELD;
#define EPN_CONTROL_0_DRXLOOPBACK_FIELD_MASK  0x0000000000000004
#define EPN_CONTROL_0_DRXLOOPBACK_FIELD_WIDTH 1
#define EPN_CONTROL_0_DRXLOOPBACK_FIELD_SHIFT 2

extern const ru_field_rec EPN_CONTROL_0_DRXEN_FIELD;
#define EPN_CONTROL_0_DRXEN_FIELD_MASK  0x0000000000000002
#define EPN_CONTROL_0_DRXEN_FIELD_WIDTH 1
#define EPN_CONTROL_0_DRXEN_FIELD_SHIFT 1

extern const ru_field_rec EPN_CONTROL_0_DRXRST_PRE_N_FIELD;
#define EPN_CONTROL_0_DRXRST_PRE_N_FIELD_MASK  0x0000000000000001
#define EPN_CONTROL_0_DRXRST_PRE_N_FIELD_WIDTH 1
#define EPN_CONTROL_0_DRXRST_PRE_N_FIELD_SHIFT 0

extern const ru_field_rec EPN_CONTROL_1_RESERVED0_FIELD;
#define EPN_CONTROL_1_RESERVED0_FIELD_MASK  0x00000000ff000000
#define EPN_CONTROL_1_RESERVED0_FIELD_WIDTH 8
#define EPN_CONTROL_1_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec EPN_CONTROL_1_CFGIDLEPACKETTXENABLE_FIELD;
#define EPN_CONTROL_1_CFGIDLEPACKETTXENABLE_FIELD_MASK  0x0000000000800000
#define EPN_CONTROL_1_CFGIDLEPACKETTXENABLE_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGIDLEPACKETTXENABLE_FIELD_SHIFT 23

extern const ru_field_rec EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD;
#define EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD_MASK  0x0000000000400000
#define EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD_SHIFT 22

extern const ru_field_rec EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD;
#define EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD_MASK  0x0000000000200000
#define EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD_WIDTH 1
#define EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD_SHIFT 21

extern const ru_field_rec EPN_CONTROL_1_RSTMISALIGNTHR_FIELD;
#define EPN_CONTROL_1_RSTMISALIGNTHR_FIELD_MASK  0x0000000000100000
#define EPN_CONTROL_1_RSTMISALIGNTHR_FIELD_WIDTH 1
#define EPN_CONTROL_1_RSTMISALIGNTHR_FIELD_SHIFT 20

extern const ru_field_rec EPN_CONTROL_1_RESERVED1_FIELD;
#define EPN_CONTROL_1_RESERVED1_FIELD_MASK  0x0000000000080000
#define EPN_CONTROL_1_RESERVED1_FIELD_WIDTH 1
#define EPN_CONTROL_1_RESERVED1_FIELD_SHIFT 19

extern const ru_field_rec EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD;
#define EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD_MASK  0x0000000000040000
#define EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD_SHIFT 18

extern const ru_field_rec EPN_CONTROL_1_FECRPTEN_FIELD;
#define EPN_CONTROL_1_FECRPTEN_FIELD_MASK  0x0000000000020000
#define EPN_CONTROL_1_FECRPTEN_FIELD_WIDTH 1
#define EPN_CONTROL_1_FECRPTEN_FIELD_SHIFT 17

extern const ru_field_rec EPN_CONTROL_1_RESERVED2_FIELD;
#define EPN_CONTROL_1_RESERVED2_FIELD_MASK  0x000000000001ff00
#define EPN_CONTROL_1_RESERVED2_FIELD_WIDTH 9
#define EPN_CONTROL_1_RESERVED2_FIELD_SHIFT 8

extern const ru_field_rec EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD;
#define EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD_MASK  0x0000000000000080
#define EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD_SHIFT 7

extern const ru_field_rec EPN_CONTROL_1_CFGCTCRPT_FIELD;
#define EPN_CONTROL_1_CFGCTCRPT_FIELD_MASK  0x0000000000000060
#define EPN_CONTROL_1_CFGCTCRPT_FIELD_WIDTH 2
#define EPN_CONTROL_1_CFGCTCRPT_FIELD_SHIFT 5

extern const ru_field_rec EPN_CONTROL_1_CFGTSCORRDIS_FIELD;
#define EPN_CONTROL_1_CFGTSCORRDIS_FIELD_MASK  0x0000000000000010
#define EPN_CONTROL_1_CFGTSCORRDIS_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGTSCORRDIS_FIELD_SHIFT 4

extern const ru_field_rec EPN_CONTROL_1_CFGNODISCRPT_FIELD;
#define EPN_CONTROL_1_CFGNODISCRPT_FIELD_MASK  0x0000000000000008
#define EPN_CONTROL_1_CFGNODISCRPT_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGNODISCRPT_FIELD_SHIFT 3

extern const ru_field_rec EPN_CONTROL_1_DISABLEDISCSCALE_FIELD;
#define EPN_CONTROL_1_DISABLEDISCSCALE_FIELD_MASK  0x0000000000000004
#define EPN_CONTROL_1_DISABLEDISCSCALE_FIELD_WIDTH 1
#define EPN_CONTROL_1_DISABLEDISCSCALE_FIELD_SHIFT 2

extern const ru_field_rec EPN_CONTROL_1_CLRONRD_FIELD;
#define EPN_CONTROL_1_CLRONRD_FIELD_MASK  0x0000000000000002
#define EPN_CONTROL_1_CLRONRD_FIELD_WIDTH 1
#define EPN_CONTROL_1_CLRONRD_FIELD_SHIFT 1

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT31_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT31_FIELD_MASK  0x0000000080000000
#define EPN_ENABLE_GRANTS_ENGNT31_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT30_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT30_FIELD_MASK  0x0000000040000000
#define EPN_ENABLE_GRANTS_ENGNT30_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT29_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT29_FIELD_MASK  0x0000000020000000
#define EPN_ENABLE_GRANTS_ENGNT29_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT28_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT28_FIELD_MASK  0x0000000010000000
#define EPN_ENABLE_GRANTS_ENGNT28_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT27_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT27_FIELD_MASK  0x0000000008000000
#define EPN_ENABLE_GRANTS_ENGNT27_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT26_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT26_FIELD_MASK  0x0000000004000000
#define EPN_ENABLE_GRANTS_ENGNT26_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT25_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT25_FIELD_MASK  0x0000000002000000
#define EPN_ENABLE_GRANTS_ENGNT25_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT24_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT24_FIELD_MASK  0x0000000001000000
#define EPN_ENABLE_GRANTS_ENGNT24_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT23_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT23_FIELD_MASK  0x0000000000800000
#define EPN_ENABLE_GRANTS_ENGNT23_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT22_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT22_FIELD_MASK  0x0000000000400000
#define EPN_ENABLE_GRANTS_ENGNT22_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT21_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT21_FIELD_MASK  0x0000000000200000
#define EPN_ENABLE_GRANTS_ENGNT21_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT20_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT20_FIELD_MASK  0x0000000000100000
#define EPN_ENABLE_GRANTS_ENGNT20_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT19_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT19_FIELD_MASK  0x0000000000080000
#define EPN_ENABLE_GRANTS_ENGNT19_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT18_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT18_FIELD_MASK  0x0000000000040000
#define EPN_ENABLE_GRANTS_ENGNT18_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT17_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT17_FIELD_MASK  0x0000000000020000
#define EPN_ENABLE_GRANTS_ENGNT17_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT16_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT16_FIELD_MASK  0x0000000000010000
#define EPN_ENABLE_GRANTS_ENGNT16_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT15_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT15_FIELD_MASK  0x0000000000008000
#define EPN_ENABLE_GRANTS_ENGNT15_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT14_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT14_FIELD_MASK  0x0000000000004000
#define EPN_ENABLE_GRANTS_ENGNT14_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT13_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT13_FIELD_MASK  0x0000000000002000
#define EPN_ENABLE_GRANTS_ENGNT13_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT12_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT12_FIELD_MASK  0x0000000000001000
#define EPN_ENABLE_GRANTS_ENGNT12_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT11_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT11_FIELD_MASK  0x0000000000000800
#define EPN_ENABLE_GRANTS_ENGNT11_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT10_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT10_FIELD_MASK  0x0000000000000400
#define EPN_ENABLE_GRANTS_ENGNT10_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT9_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT9_FIELD_MASK  0x0000000000000200
#define EPN_ENABLE_GRANTS_ENGNT9_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT8_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT8_FIELD_MASK  0x0000000000000100
#define EPN_ENABLE_GRANTS_ENGNT8_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT7_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT7_FIELD_MASK  0x0000000000000080
#define EPN_ENABLE_GRANTS_ENGNT7_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT6_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT6_FIELD_MASK  0x0000000000000040
#define EPN_ENABLE_GRANTS_ENGNT6_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT5_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT5_FIELD_MASK  0x0000000000000020
#define EPN_ENABLE_GRANTS_ENGNT5_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT4_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT4_FIELD_MASK  0x0000000000000010
#define EPN_ENABLE_GRANTS_ENGNT4_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT3_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT3_FIELD_MASK  0x0000000000000008
#define EPN_ENABLE_GRANTS_ENGNT3_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT2_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT2_FIELD_MASK  0x0000000000000004
#define EPN_ENABLE_GRANTS_ENGNT2_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT1_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT1_FIELD_MASK  0x0000000000000002
#define EPN_ENABLE_GRANTS_ENGNT1_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT0_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT0_FIELD_MASK  0x0000000000000001
#define EPN_ENABLE_GRANTS_ENGNT0_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES31_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES31_FIELD_MASK  0x0000000080000000
#define EPN_DROP_DISC_GATES_SINKDISCGATES31_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES31_FIELD_SHIFT 31

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES30_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES30_FIELD_MASK  0x0000000040000000
#define EPN_DROP_DISC_GATES_SINKDISCGATES30_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES30_FIELD_SHIFT 30

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES29_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES29_FIELD_MASK  0x0000000020000000
#define EPN_DROP_DISC_GATES_SINKDISCGATES29_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES29_FIELD_SHIFT 29

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES28_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES28_FIELD_MASK  0x0000000010000000
#define EPN_DROP_DISC_GATES_SINKDISCGATES28_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES28_FIELD_SHIFT 28

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES27_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES27_FIELD_MASK  0x0000000008000000
#define EPN_DROP_DISC_GATES_SINKDISCGATES27_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES27_FIELD_SHIFT 27

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES26_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES26_FIELD_MASK  0x0000000004000000
#define EPN_DROP_DISC_GATES_SINKDISCGATES26_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES26_FIELD_SHIFT 26

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES25_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES25_FIELD_MASK  0x0000000002000000
#define EPN_DROP_DISC_GATES_SINKDISCGATES25_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES25_FIELD_SHIFT 25

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES24_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES24_FIELD_MASK  0x0000000001000000
#define EPN_DROP_DISC_GATES_SINKDISCGATES24_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES24_FIELD_SHIFT 24

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES23_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES23_FIELD_MASK  0x0000000000800000
#define EPN_DROP_DISC_GATES_SINKDISCGATES23_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES23_FIELD_SHIFT 23

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES22_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES22_FIELD_MASK  0x0000000000400000
#define EPN_DROP_DISC_GATES_SINKDISCGATES22_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES22_FIELD_SHIFT 22

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES21_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES21_FIELD_MASK  0x0000000000200000
#define EPN_DROP_DISC_GATES_SINKDISCGATES21_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES21_FIELD_SHIFT 21

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES20_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES20_FIELD_MASK  0x0000000000100000
#define EPN_DROP_DISC_GATES_SINKDISCGATES20_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES20_FIELD_SHIFT 20

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES19_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES19_FIELD_MASK  0x0000000000080000
#define EPN_DROP_DISC_GATES_SINKDISCGATES19_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES19_FIELD_SHIFT 19

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES18_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES18_FIELD_MASK  0x0000000000040000
#define EPN_DROP_DISC_GATES_SINKDISCGATES18_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES18_FIELD_SHIFT 18

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES17_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES17_FIELD_MASK  0x0000000000020000
#define EPN_DROP_DISC_GATES_SINKDISCGATES17_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES17_FIELD_SHIFT 17

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES16_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES16_FIELD_MASK  0x0000000000010000
#define EPN_DROP_DISC_GATES_SINKDISCGATES16_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES16_FIELD_SHIFT 16

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES15_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES15_FIELD_MASK  0x0000000000008000
#define EPN_DROP_DISC_GATES_SINKDISCGATES15_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES15_FIELD_SHIFT 15

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES14_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES14_FIELD_MASK  0x0000000000004000
#define EPN_DROP_DISC_GATES_SINKDISCGATES14_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES14_FIELD_SHIFT 14

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES13_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES13_FIELD_MASK  0x0000000000002000
#define EPN_DROP_DISC_GATES_SINKDISCGATES13_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES13_FIELD_SHIFT 13

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES12_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES12_FIELD_MASK  0x0000000000001000
#define EPN_DROP_DISC_GATES_SINKDISCGATES12_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES12_FIELD_SHIFT 12

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES11_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES11_FIELD_MASK  0x0000000000000800
#define EPN_DROP_DISC_GATES_SINKDISCGATES11_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES11_FIELD_SHIFT 11

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES10_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES10_FIELD_MASK  0x0000000000000400
#define EPN_DROP_DISC_GATES_SINKDISCGATES10_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES10_FIELD_SHIFT 10

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES9_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES9_FIELD_MASK  0x0000000000000200
#define EPN_DROP_DISC_GATES_SINKDISCGATES9_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES9_FIELD_SHIFT 9

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES8_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES8_FIELD_MASK  0x0000000000000100
#define EPN_DROP_DISC_GATES_SINKDISCGATES8_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES8_FIELD_SHIFT 8

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD_MASK  0x0000000000000080
#define EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD_MASK  0x0000000000000040
#define EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD_MASK  0x0000000000000020
#define EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD_MASK  0x0000000000000010
#define EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD_MASK  0x0000000000000008
#define EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD_MASK  0x0000000000000004
#define EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD_MASK  0x0000000000000002
#define EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD_MASK  0x0000000000000001
#define EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK31_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK31_FIELD_MASK  0x0000000080000000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK31_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK31_FIELD_SHIFT 31

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK30_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK30_FIELD_MASK  0x0000000040000000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK30_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK30_FIELD_SHIFT 30

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK29_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK29_FIELD_MASK  0x0000000020000000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK29_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK29_FIELD_SHIFT 29

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK28_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK28_FIELD_MASK  0x0000000010000000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK28_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK28_FIELD_SHIFT 28

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK27_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK27_FIELD_MASK  0x0000000008000000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK27_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK27_FIELD_SHIFT 27

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK26_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK26_FIELD_MASK  0x0000000004000000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK26_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK26_FIELD_SHIFT 26

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK25_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK25_FIELD_MASK  0x0000000002000000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK25_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK25_FIELD_SHIFT 25

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK24_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK24_FIELD_MASK  0x0000000001000000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK24_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK24_FIELD_SHIFT 24

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK23_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK23_FIELD_MASK  0x0000000000800000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK23_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK23_FIELD_SHIFT 23

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK22_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK22_FIELD_MASK  0x0000000000400000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK22_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK22_FIELD_SHIFT 22

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK21_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK21_FIELD_MASK  0x0000000000200000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK21_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK21_FIELD_SHIFT 21

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK20_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK20_FIELD_MASK  0x0000000000100000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK20_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK20_FIELD_SHIFT 20

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK19_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK19_FIELD_MASK  0x0000000000080000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK19_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK19_FIELD_SHIFT 19

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK18_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK18_FIELD_MASK  0x0000000000040000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK18_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK18_FIELD_SHIFT 18

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK17_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK17_FIELD_MASK  0x0000000000020000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK17_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK17_FIELD_SHIFT 17

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK16_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK16_FIELD_MASK  0x0000000000010000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK16_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK16_FIELD_SHIFT 16

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK15_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK15_FIELD_MASK  0x0000000000008000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK15_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK15_FIELD_SHIFT 15

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK14_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK14_FIELD_MASK  0x0000000000004000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK14_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK14_FIELD_SHIFT 14

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK13_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK13_FIELD_MASK  0x0000000000002000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK13_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK13_FIELD_SHIFT 13

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK12_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK12_FIELD_MASK  0x0000000000001000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK12_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK12_FIELD_SHIFT 12

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK11_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK11_FIELD_MASK  0x0000000000000800
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK11_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK11_FIELD_SHIFT 11

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK10_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK10_FIELD_MASK  0x0000000000000400
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK10_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK10_FIELD_SHIFT 10

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK9_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK9_FIELD_MASK  0x0000000000000200
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK9_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK9_FIELD_SHIFT 9

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK8_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK8_FIELD_MASK  0x0000000000000100
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK8_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK8_FIELD_SHIFT 8

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD_MASK  0x0000000000000080
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD_MASK  0x0000000000000040
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD_MASK  0x0000000000000020
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD_MASK  0x0000000000000010
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD_MASK  0x0000000000000008
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD_MASK  0x0000000000000004
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD_MASK  0x0000000000000002
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD_MASK  0x0000000000000001
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD_SHIFT 0

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID31_FIELD;
#define EPN_PASS_GATES_PASSGATELLID31_FIELD_MASK  0x0000000080000000
#define EPN_PASS_GATES_PASSGATELLID31_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID31_FIELD_SHIFT 31

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID30_FIELD;
#define EPN_PASS_GATES_PASSGATELLID30_FIELD_MASK  0x0000000040000000
#define EPN_PASS_GATES_PASSGATELLID30_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID30_FIELD_SHIFT 30

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID29_FIELD;
#define EPN_PASS_GATES_PASSGATELLID29_FIELD_MASK  0x0000000020000000
#define EPN_PASS_GATES_PASSGATELLID29_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID29_FIELD_SHIFT 29

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID28_FIELD;
#define EPN_PASS_GATES_PASSGATELLID28_FIELD_MASK  0x0000000010000000
#define EPN_PASS_GATES_PASSGATELLID28_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID28_FIELD_SHIFT 28

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID27_FIELD;
#define EPN_PASS_GATES_PASSGATELLID27_FIELD_MASK  0x0000000008000000
#define EPN_PASS_GATES_PASSGATELLID27_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID27_FIELD_SHIFT 27

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID26_FIELD;
#define EPN_PASS_GATES_PASSGATELLID26_FIELD_MASK  0x0000000004000000
#define EPN_PASS_GATES_PASSGATELLID26_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID26_FIELD_SHIFT 26

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID25_FIELD;
#define EPN_PASS_GATES_PASSGATELLID25_FIELD_MASK  0x0000000002000000
#define EPN_PASS_GATES_PASSGATELLID25_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID25_FIELD_SHIFT 25

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID24_FIELD;
#define EPN_PASS_GATES_PASSGATELLID24_FIELD_MASK  0x0000000001000000
#define EPN_PASS_GATES_PASSGATELLID24_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID24_FIELD_SHIFT 24

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID23_FIELD;
#define EPN_PASS_GATES_PASSGATELLID23_FIELD_MASK  0x0000000000800000
#define EPN_PASS_GATES_PASSGATELLID23_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID23_FIELD_SHIFT 23

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID22_FIELD;
#define EPN_PASS_GATES_PASSGATELLID22_FIELD_MASK  0x0000000000400000
#define EPN_PASS_GATES_PASSGATELLID22_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID22_FIELD_SHIFT 22

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID21_FIELD;
#define EPN_PASS_GATES_PASSGATELLID21_FIELD_MASK  0x0000000000200000
#define EPN_PASS_GATES_PASSGATELLID21_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID21_FIELD_SHIFT 21

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID20_FIELD;
#define EPN_PASS_GATES_PASSGATELLID20_FIELD_MASK  0x0000000000100000
#define EPN_PASS_GATES_PASSGATELLID20_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID20_FIELD_SHIFT 20

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID19_FIELD;
#define EPN_PASS_GATES_PASSGATELLID19_FIELD_MASK  0x0000000000080000
#define EPN_PASS_GATES_PASSGATELLID19_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID19_FIELD_SHIFT 19

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID18_FIELD;
#define EPN_PASS_GATES_PASSGATELLID18_FIELD_MASK  0x0000000000040000
#define EPN_PASS_GATES_PASSGATELLID18_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID18_FIELD_SHIFT 18

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID17_FIELD;
#define EPN_PASS_GATES_PASSGATELLID17_FIELD_MASK  0x0000000000020000
#define EPN_PASS_GATES_PASSGATELLID17_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID17_FIELD_SHIFT 17

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID16_FIELD;
#define EPN_PASS_GATES_PASSGATELLID16_FIELD_MASK  0x0000000000010000
#define EPN_PASS_GATES_PASSGATELLID16_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID16_FIELD_SHIFT 16

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID15_FIELD;
#define EPN_PASS_GATES_PASSGATELLID15_FIELD_MASK  0x0000000000008000
#define EPN_PASS_GATES_PASSGATELLID15_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID15_FIELD_SHIFT 15

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID14_FIELD;
#define EPN_PASS_GATES_PASSGATELLID14_FIELD_MASK  0x0000000000004000
#define EPN_PASS_GATES_PASSGATELLID14_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID14_FIELD_SHIFT 14

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID13_FIELD;
#define EPN_PASS_GATES_PASSGATELLID13_FIELD_MASK  0x0000000000002000
#define EPN_PASS_GATES_PASSGATELLID13_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID13_FIELD_SHIFT 13

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID12_FIELD;
#define EPN_PASS_GATES_PASSGATELLID12_FIELD_MASK  0x0000000000001000
#define EPN_PASS_GATES_PASSGATELLID12_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID12_FIELD_SHIFT 12

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID11_FIELD;
#define EPN_PASS_GATES_PASSGATELLID11_FIELD_MASK  0x0000000000000800
#define EPN_PASS_GATES_PASSGATELLID11_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID11_FIELD_SHIFT 11

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID10_FIELD;
#define EPN_PASS_GATES_PASSGATELLID10_FIELD_MASK  0x0000000000000400
#define EPN_PASS_GATES_PASSGATELLID10_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID10_FIELD_SHIFT 10

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID9_FIELD;
#define EPN_PASS_GATES_PASSGATELLID9_FIELD_MASK  0x0000000000000200
#define EPN_PASS_GATES_PASSGATELLID9_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID9_FIELD_SHIFT 9

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID8_FIELD;
#define EPN_PASS_GATES_PASSGATELLID8_FIELD_MASK  0x0000000000000100
#define EPN_PASS_GATES_PASSGATELLID8_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID8_FIELD_SHIFT 8

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID7_FIELD;
#define EPN_PASS_GATES_PASSGATELLID7_FIELD_MASK  0x0000000000000080
#define EPN_PASS_GATES_PASSGATELLID7_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID7_FIELD_SHIFT 7

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID6_FIELD;
#define EPN_PASS_GATES_PASSGATELLID6_FIELD_MASK  0x0000000000000040
#define EPN_PASS_GATES_PASSGATELLID6_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID6_FIELD_SHIFT 6

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID5_FIELD;
#define EPN_PASS_GATES_PASSGATELLID5_FIELD_MASK  0x0000000000000020
#define EPN_PASS_GATES_PASSGATELLID5_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID5_FIELD_SHIFT 5

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID4_FIELD;
#define EPN_PASS_GATES_PASSGATELLID4_FIELD_MASK  0x0000000000000010
#define EPN_PASS_GATES_PASSGATELLID4_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID4_FIELD_SHIFT 4

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID3_FIELD;
#define EPN_PASS_GATES_PASSGATELLID3_FIELD_MASK  0x0000000000000008
#define EPN_PASS_GATES_PASSGATELLID3_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID3_FIELD_SHIFT 3

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID2_FIELD;
#define EPN_PASS_GATES_PASSGATELLID2_FIELD_MASK  0x0000000000000004
#define EPN_PASS_GATES_PASSGATELLID2_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID2_FIELD_SHIFT 2

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID1_FIELD;
#define EPN_PASS_GATES_PASSGATELLID1_FIELD_MASK  0x0000000000000002
#define EPN_PASS_GATES_PASSGATELLID1_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID1_FIELD_SHIFT 1

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID0_FIELD;
#define EPN_PASS_GATES_PASSGATELLID0_FIELD_MASK  0x0000000000000001
#define EPN_PASS_GATES_PASSGATELLID0_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID0_FIELD_SHIFT 0

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK31_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK31_FIELD_MASK  0x0000000080000000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK31_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK31_FIELD_SHIFT 31

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK30_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK30_FIELD_MASK  0x0000000040000000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK30_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK30_FIELD_SHIFT 30

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK29_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK29_FIELD_MASK  0x0000000020000000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK29_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK29_FIELD_SHIFT 29

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK28_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK28_FIELD_MASK  0x0000000010000000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK28_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK28_FIELD_SHIFT 28

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK27_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK27_FIELD_MASK  0x0000000008000000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK27_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK27_FIELD_SHIFT 27

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK26_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK26_FIELD_MASK  0x0000000004000000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK26_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK26_FIELD_SHIFT 26

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK25_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK25_FIELD_MASK  0x0000000002000000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK25_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK25_FIELD_SHIFT 25

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK24_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK24_FIELD_MASK  0x0000000001000000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK24_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK24_FIELD_SHIFT 24

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK23_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK23_FIELD_MASK  0x0000000000800000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK23_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK23_FIELD_SHIFT 23

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK22_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK22_FIELD_MASK  0x0000000000400000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK22_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK22_FIELD_SHIFT 22

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK21_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK21_FIELD_MASK  0x0000000000200000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK21_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK21_FIELD_SHIFT 21

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK20_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK20_FIELD_MASK  0x0000000000100000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK20_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK20_FIELD_SHIFT 20

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK19_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK19_FIELD_MASK  0x0000000000080000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK19_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK19_FIELD_SHIFT 19

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK18_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK18_FIELD_MASK  0x0000000000040000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK18_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK18_FIELD_SHIFT 18

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK17_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK17_FIELD_MASK  0x0000000000020000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK17_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK17_FIELD_SHIFT 17

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK16_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK16_FIELD_MASK  0x0000000000010000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK16_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK16_FIELD_SHIFT 16

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK15_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK15_FIELD_MASK  0x0000000000008000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK15_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK15_FIELD_SHIFT 15

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK14_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK14_FIELD_MASK  0x0000000000004000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK14_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK14_FIELD_SHIFT 14

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK13_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK13_FIELD_MASK  0x0000000000002000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK13_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK13_FIELD_SHIFT 13

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK12_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK12_FIELD_MASK  0x0000000000001000
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK12_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK12_FIELD_SHIFT 12

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK11_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK11_FIELD_MASK  0x0000000000000800
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK11_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK11_FIELD_SHIFT 11

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK10_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK10_FIELD_MASK  0x0000000000000400
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK10_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK10_FIELD_SHIFT 10

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK9_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK9_FIELD_MASK  0x0000000000000200
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK9_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK9_FIELD_SHIFT 9

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK8_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK8_FIELD_MASK  0x0000000000000100
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK8_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK8_FIELD_SHIFT 8

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD_MASK  0x0000000000000080
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD_SHIFT 7

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD_MASK  0x0000000000000040
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD_SHIFT 6

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD_MASK  0x0000000000000020
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD_SHIFT 5

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD_MASK  0x0000000000000010
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD_SHIFT 4

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD_MASK  0x0000000000000008
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD_SHIFT 3

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD_MASK  0x0000000000000004
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD_SHIFT 2

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD_MASK  0x0000000000000002
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD_SHIFT 1

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD_MASK  0x0000000000000001
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD;
#define EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD_MASK  0x00000000ffff0000
#define EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD_WIDTH 16
#define EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD_SHIFT 16

extern const ru_field_rec EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD;
#define EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD_MASK  0x000000000000ffff
#define EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD_WIDTH 16
#define EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD_SHIFT 0

extern const ru_field_rec EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD;
#define EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD_WIDTH 16
#define EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD;
#define EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD_MASK  0x000000000000ffff
#define EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD_WIDTH 16
#define EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD_SHIFT 0

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO31_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO31_FIELD_MASK  0x0000000080000000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO31_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO31_FIELD_SHIFT 31

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO30_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO30_FIELD_MASK  0x0000000040000000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO30_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO30_FIELD_SHIFT 30

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO29_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO29_FIELD_MASK  0x0000000020000000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO29_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO29_FIELD_SHIFT 29

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO28_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO28_FIELD_MASK  0x0000000010000000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO28_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO28_FIELD_SHIFT 28

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO27_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO27_FIELD_MASK  0x0000000008000000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO27_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO27_FIELD_SHIFT 27

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO26_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO26_FIELD_MASK  0x0000000004000000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO26_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO26_FIELD_SHIFT 26

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO25_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO25_FIELD_MASK  0x0000000002000000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO25_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO25_FIELD_SHIFT 25

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO24_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO24_FIELD_MASK  0x0000000001000000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO24_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO24_FIELD_SHIFT 24

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO23_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO23_FIELD_MASK  0x0000000000800000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO23_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO23_FIELD_SHIFT 23

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO22_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO22_FIELD_MASK  0x0000000000400000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO22_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO22_FIELD_SHIFT 22

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO21_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO21_FIELD_MASK  0x0000000000200000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO21_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO21_FIELD_SHIFT 21

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO20_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO20_FIELD_MASK  0x0000000000100000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO20_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO20_FIELD_SHIFT 20

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO19_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO19_FIELD_MASK  0x0000000000080000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO19_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO19_FIELD_SHIFT 19

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO18_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO18_FIELD_MASK  0x0000000000040000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO18_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO18_FIELD_SHIFT 18

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO17_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO17_FIELD_MASK  0x0000000000020000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO17_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO17_FIELD_SHIFT 17

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO16_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO16_FIELD_MASK  0x0000000000010000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO16_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO16_FIELD_SHIFT 16

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO15_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO15_FIELD_MASK  0x0000000000008000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO15_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO15_FIELD_SHIFT 15

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO14_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO14_FIELD_MASK  0x0000000000004000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO14_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO14_FIELD_SHIFT 14

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO13_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO13_FIELD_MASK  0x0000000000002000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO13_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO13_FIELD_SHIFT 13

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO12_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO12_FIELD_MASK  0x0000000000001000
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO12_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO12_FIELD_SHIFT 12

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO11_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO11_FIELD_MASK  0x0000000000000800
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO11_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO11_FIELD_SHIFT 11

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO10_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO10_FIELD_MASK  0x0000000000000400
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO10_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO10_FIELD_SHIFT 10

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO9_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO9_FIELD_MASK  0x0000000000000200
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO9_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO9_FIELD_SHIFT 9

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO8_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO8_FIELD_MASK  0x0000000000000100
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO8_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO8_FIELD_SHIFT 8

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD_MASK  0x0000000000000080
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD_SHIFT 7

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD_MASK  0x0000000000000040
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD_SHIFT 6

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD_MASK  0x0000000000000020
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD_SHIFT 5

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD_MASK  0x0000000000000010
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD_SHIFT 4

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD_MASK  0x0000000000000008
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD_SHIFT 3

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD_MASK  0x0000000000000004
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD_SHIFT 2

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD_MASK  0x0000000000000002
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD_SHIFT 1

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD_MASK  0x0000000000000001
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD_SHIFT 0

extern const ru_field_rec EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD;
#define EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD_MASK  0x00000000ffffffff
#define EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD_WIDTH 32
#define EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD_SHIFT 0

extern const ru_field_rec EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD;
#define EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD_MASK  0x00000000fffffc00
#define EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD_WIDTH 22
#define EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD;
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD_MASK  0x00000000000003e0
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD_WIDTH 5
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD_SHIFT 5

extern const ru_field_rec EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD;
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD_MASK  0x000000000000001f
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD_WIDTH 5
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD_SHIFT 0

extern const ru_field_rec EPN_L1_SVA_BYTES_RESERVED0_FIELD;
#define EPN_L1_SVA_BYTES_RESERVED0_FIELD_MASK  0x00000000c0000000
#define EPN_L1_SVA_BYTES_RESERVED0_FIELD_WIDTH 2
#define EPN_L1_SVA_BYTES_RESERVED0_FIELD_SHIFT 30

extern const ru_field_rec EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD;
#define EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD_MASK  0x000000003fffffff
#define EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD_WIDTH 30
#define EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_L1_UVA_BYTES_RESERVED0_FIELD;
#define EPN_L1_UVA_BYTES_RESERVED0_FIELD_MASK  0x00000000c0000000
#define EPN_L1_UVA_BYTES_RESERVED0_FIELD_WIDTH 2
#define EPN_L1_UVA_BYTES_RESERVED0_FIELD_SHIFT 30

extern const ru_field_rec EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD;
#define EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD_MASK  0x000000003fffffff
#define EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD_WIDTH 30
#define EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD;
#define EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD_MASK  0x00000000ffffffff
#define EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD_WIDTH 32
#define EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD;
#define EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD_MASK  0x00000000ffffffff
#define EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD_WIDTH 32
#define EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_RESET_RPT_PRI_RESERVED0_FIELD;
#define EPN_RESET_RPT_PRI_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_RESET_RPT_PRI_RESERVED0_FIELD_WIDTH 16
#define EPN_RESET_RPT_PRI_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD_MASK  0x0000000000008000
#define EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD_SHIFT 15

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD_MASK  0x0000000000004000
#define EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD_SHIFT 14

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD_MASK  0x0000000000002000
#define EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD_SHIFT 13

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD_MASK  0x0000000000001000
#define EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD_SHIFT 12

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD_MASK  0x0000000000000800
#define EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD_SHIFT 11

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD_MASK  0x0000000000000400
#define EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD_SHIFT 10

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD_MASK  0x0000000000000200
#define EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD_SHIFT 9

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD_MASK  0x0000000000000100
#define EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD_SHIFT 8

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD_MASK  0x0000000000000080
#define EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD_SHIFT 7

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD_MASK  0x0000000000000040
#define EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD_SHIFT 6

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD_MASK  0x0000000000000020
#define EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD_SHIFT 5

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD_MASK  0x0000000000000010
#define EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD_SHIFT 4

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD_MASK  0x0000000000000008
#define EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD_SHIFT 3

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD_MASK  0x0000000000000004
#define EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD_SHIFT 2

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD_MASK  0x0000000000000002
#define EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD_SHIFT 1

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD_MASK  0x0000000000000001
#define EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD_SHIFT 0

extern const ru_field_rec EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD;
#define EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD_MASK  0x00000000ffffffff
#define EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD_WIDTH 32
#define EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD_SHIFT 0

extern const ru_field_rec EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD;
#define EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD_MASK  0x00000000ffffffff
#define EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD_WIDTH 32
#define EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD_SHIFT 0

extern const ru_field_rec EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD;
#define EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD_MASK  0x00000000ffffffff
#define EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD_WIDTH 32
#define EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD_SHIFT 0

extern const ru_field_rec EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD;
#define EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD_MASK  0x00000000ffffffff
#define EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD_WIDTH 32
#define EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD_SHIFT 0

extern const ru_field_rec EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD;
#define EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD_WIDTH 24
#define EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD;
#define EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD_MASK  0x00000000000000ff
#define EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD_WIDTH 8
#define EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD;
#define EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD_MASK  0x0000000080000000
#define EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD_SHIFT 31

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD_MASK  0x0000000040000000
#define EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD_SHIFT 30

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD_MASK  0x0000000020000000
#define EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD_SHIFT 29

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD;
#define EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD_MASK  0x0000000010000000
#define EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD_SHIFT 28

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD;
#define EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD_MASK  0x0000000008000000
#define EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD_SHIFT 27

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD_MASK  0x0000000004000000
#define EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD_SHIFT 26

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD;
#define EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD_MASK  0x0000000002000000
#define EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD_SHIFT 25

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD_MASK  0x0000000001000000
#define EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD_SHIFT 24

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD_MASK  0x0000000000800000
#define EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD_SHIFT 23

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD_MASK  0x0000000000400000
#define EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD_SHIFT 22

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD_MASK  0x0000000000200000
#define EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD_SHIFT 21

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD_MASK  0x0000000000100000
#define EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD_SHIFT 20

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD_MASK  0x0000000000080000
#define EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD_SHIFT 19

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD_MASK  0x0000000000040000
#define EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD_SHIFT 18

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD_MASK  0x0000000000020000
#define EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD_SHIFT 17

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD_MASK  0x0000000000010000
#define EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD_SHIFT 16

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD;
#define EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD_MASK  0x0000000000008000
#define EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD_SHIFT 15

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD;
#define EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD_MASK  0x0000000000004000
#define EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD_SHIFT 14

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD;
#define EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD_MASK  0x0000000000002000
#define EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD_SHIFT 13

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD;
#define EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD_MASK  0x0000000000001000
#define EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD_SHIFT 12

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD;
#define EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD_MASK  0x0000000000000800
#define EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD_SHIFT 11

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD;
#define EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD_MASK  0x0000000000000400
#define EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD_SHIFT 10

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD;
#define EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD_MASK  0x0000000000000200
#define EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD_SHIFT 9

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD;
#define EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD_MASK  0x0000000000000100
#define EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD_SHIFT 8

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD;
#define EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD_MASK  0x0000000000000080
#define EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD_SHIFT 7

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD;
#define EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD_MASK  0x0000000000000040
#define EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD_SHIFT 6

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD;
#define EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD_MASK  0x0000000000000020
#define EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD_SHIFT 5

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD;
#define EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD_MASK  0x0000000000000010
#define EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD_SHIFT 4

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD_MASK  0x0000000000000008
#define EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD_SHIFT 3

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD;
#define EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD_MASK  0x0000000000000004
#define EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD_SHIFT 2

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD;
#define EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD_MASK  0x0000000000000002
#define EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD_SHIFT 1

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD;
#define EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD_MASK  0x0000000000000001
#define EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT31_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT31_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT30_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT30_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT29_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT29_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT28_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT28_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT27_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT27_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT26_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT26_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT25_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT25_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT24_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT24_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT23_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT23_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT22_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT22_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT21_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT21_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT20_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT20_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT19_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT19_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT18_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT18_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT17_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT17_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT16_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT16_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT15_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT15_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT14_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT14_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT13_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT13_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT12_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT12_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT11_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT11_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT10_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT10_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT9_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT9_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT8_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT8_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT31_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT31_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT30_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT30_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT29_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT29_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT28_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT28_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT27_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT27_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT26_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT26_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT25_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT25_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT24_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT24_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT23_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT23_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT22_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT22_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT21_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT21_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT20_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT20_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT19_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT19_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT18_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT18_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT17_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT17_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT16_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT16_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT15_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT15_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT14_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT14_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT13_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT13_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT12_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT12_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT11_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT11_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT10_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT10_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT9_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT9_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT8_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT8_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT31_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT31_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT30_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT30_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT29_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT29_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT28_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT28_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT27_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT27_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT26_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT26_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT25_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT25_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT24_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT24_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT23_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT23_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT22_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT22_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT21_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT21_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT20_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT20_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT19_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT19_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT18_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT18_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT17_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT17_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT16_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT16_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT15_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT15_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT14_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT14_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT13_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT13_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT12_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT12_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT11_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT11_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT10_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT10_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT9_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT9_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT8_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT8_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT31_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT31_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT30_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT30_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT29_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT29_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT28_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT28_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT27_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT27_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT26_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT26_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT25_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT25_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT24_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT24_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT23_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT23_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT22_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT22_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT21_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT21_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT20_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT20_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT19_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT19_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT18_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT18_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT17_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT17_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT16_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT16_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT15_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT15_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT14_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT14_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT13_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT13_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT12_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT12_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT11_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT11_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT10_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT10_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT9_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT9_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT8_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT8_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY31_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY31_FIELD_MASK  0x0000000080000000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY31_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY31_FIELD_SHIFT 31

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY30_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY30_FIELD_MASK  0x0000000040000000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY30_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY30_FIELD_SHIFT 30

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY29_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY29_FIELD_MASK  0x0000000020000000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY29_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY29_FIELD_SHIFT 29

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY28_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY28_FIELD_MASK  0x0000000010000000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY28_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY28_FIELD_SHIFT 28

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY27_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY27_FIELD_MASK  0x0000000008000000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY27_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY27_FIELD_SHIFT 27

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY26_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY26_FIELD_MASK  0x0000000004000000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY26_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY26_FIELD_SHIFT 26

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY25_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY25_FIELD_MASK  0x0000000002000000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY25_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY25_FIELD_SHIFT 25

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY24_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY24_FIELD_MASK  0x0000000001000000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY24_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY24_FIELD_SHIFT 24

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY23_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY23_FIELD_MASK  0x0000000000800000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY23_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY23_FIELD_SHIFT 23

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY22_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY22_FIELD_MASK  0x0000000000400000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY22_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY22_FIELD_SHIFT 22

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY21_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY21_FIELD_MASK  0x0000000000200000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY21_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY21_FIELD_SHIFT 21

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY20_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY20_FIELD_MASK  0x0000000000100000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY20_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY20_FIELD_SHIFT 20

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY19_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY19_FIELD_MASK  0x0000000000080000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY19_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY19_FIELD_SHIFT 19

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY18_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY18_FIELD_MASK  0x0000000000040000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY18_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY18_FIELD_SHIFT 18

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY17_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY17_FIELD_MASK  0x0000000000020000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY17_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY17_FIELD_SHIFT 17

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY16_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY16_FIELD_MASK  0x0000000000010000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY16_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY16_FIELD_SHIFT 16

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY15_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY15_FIELD_MASK  0x0000000000008000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY15_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY15_FIELD_SHIFT 15

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY14_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY14_FIELD_MASK  0x0000000000004000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY14_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY14_FIELD_SHIFT 14

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY13_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY13_FIELD_MASK  0x0000000000002000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY13_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY13_FIELD_SHIFT 13

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY12_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY12_FIELD_MASK  0x0000000000001000
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY12_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY12_FIELD_SHIFT 12

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY11_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY11_FIELD_MASK  0x0000000000000800
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY11_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY11_FIELD_SHIFT 11

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY10_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY10_FIELD_MASK  0x0000000000000400
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY10_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY10_FIELD_SHIFT 10

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY9_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY9_FIELD_MASK  0x0000000000000200
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY9_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY9_FIELD_SHIFT 9

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY8_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY8_FIELD_MASK  0x0000000000000100
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY8_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY8_FIELD_SHIFT 8

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD_MASK  0x0000000000000080
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD_MASK  0x0000000000000040
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD_MASK  0x0000000000000020
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD_MASK  0x0000000000000010
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD_MASK  0x0000000000000008
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD_MASK  0x0000000000000004
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD_MASK  0x0000000000000002
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD_MASK  0x0000000000000001
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY31_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY31_FIELD_MASK  0x0000000080000000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY31_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY31_FIELD_SHIFT 31

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY30_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY30_FIELD_MASK  0x0000000040000000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY30_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY30_FIELD_SHIFT 30

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY29_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY29_FIELD_MASK  0x0000000020000000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY29_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY29_FIELD_SHIFT 29

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY28_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY28_FIELD_MASK  0x0000000010000000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY28_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY28_FIELD_SHIFT 28

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY27_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY27_FIELD_MASK  0x0000000008000000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY27_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY27_FIELD_SHIFT 27

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY26_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY26_FIELD_MASK  0x0000000004000000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY26_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY26_FIELD_SHIFT 26

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY25_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY25_FIELD_MASK  0x0000000002000000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY25_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY25_FIELD_SHIFT 25

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY24_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY24_FIELD_MASK  0x0000000001000000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY24_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY24_FIELD_SHIFT 24

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY23_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY23_FIELD_MASK  0x0000000000800000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY23_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY23_FIELD_SHIFT 23

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY22_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY22_FIELD_MASK  0x0000000000400000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY22_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY22_FIELD_SHIFT 22

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY21_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY21_FIELD_MASK  0x0000000000200000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY21_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY21_FIELD_SHIFT 21

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY20_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY20_FIELD_MASK  0x0000000000100000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY20_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY20_FIELD_SHIFT 20

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY19_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY19_FIELD_MASK  0x0000000000080000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY19_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY19_FIELD_SHIFT 19

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY18_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY18_FIELD_MASK  0x0000000000040000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY18_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY18_FIELD_SHIFT 18

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY17_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY17_FIELD_MASK  0x0000000000020000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY17_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY17_FIELD_SHIFT 17

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY16_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY16_FIELD_MASK  0x0000000000010000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY16_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY16_FIELD_SHIFT 16

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY15_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY15_FIELD_MASK  0x0000000000008000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY15_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY15_FIELD_SHIFT 15

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY14_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY14_FIELD_MASK  0x0000000000004000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY14_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY14_FIELD_SHIFT 14

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY13_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY13_FIELD_MASK  0x0000000000002000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY13_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY13_FIELD_SHIFT 13

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY12_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY12_FIELD_MASK  0x0000000000001000
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY12_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY12_FIELD_SHIFT 12

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY11_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY11_FIELD_MASK  0x0000000000000800
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY11_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY11_FIELD_SHIFT 11

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY10_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY10_FIELD_MASK  0x0000000000000400
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY10_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY10_FIELD_SHIFT 10

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY9_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY9_FIELD_MASK  0x0000000000000200
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY9_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY9_FIELD_SHIFT 9

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY8_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY8_FIELD_MASK  0x0000000000000100
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY8_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY8_FIELD_SHIFT 8

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD_MASK  0x0000000000000080
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD_MASK  0x0000000000000040
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD_MASK  0x0000000000000020
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD_MASK  0x0000000000000010
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD_MASK  0x0000000000000008
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD_MASK  0x0000000000000004
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD_MASK  0x0000000000000002
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD_MASK  0x0000000000000001
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL31_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL31_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL30_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL30_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL29_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL29_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL28_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL28_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL27_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL27_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL26_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL26_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL25_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL25_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL24_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL24_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL23_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL23_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL22_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL22_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL21_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL21_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL20_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL20_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL19_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL19_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL18_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL18_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL17_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL17_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL16_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL16_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL15_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL15_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL14_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL14_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL13_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL13_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL12_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL12_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL11_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL11_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL10_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL10_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL9_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL9_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL8_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL8_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL31_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL31_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL30_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL30_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL29_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL29_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL28_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL28_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL27_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL27_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL26_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL26_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL25_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL25_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL24_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL24_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL23_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL23_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL22_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL22_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL21_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL21_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL20_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL20_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL19_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL19_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL18_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL18_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL17_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL17_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL16_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL16_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL15_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL15_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL14_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL14_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL13_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL13_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL12_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL12_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL11_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL11_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL10_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL10_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL9_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL9_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL8_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL8_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR31_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR31_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR30_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR30_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR29_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR29_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR28_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR28_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR27_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR27_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR26_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR26_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR25_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR25_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR24_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR24_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR23_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR23_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR22_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR22_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR21_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR21_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR20_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR20_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR19_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR19_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR18_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR18_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR17_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR17_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR16_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR16_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR15_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR15_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR14_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR14_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR13_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR13_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR12_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR12_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR11_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR11_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR10_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR10_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR9_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR9_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR8_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR8_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR31_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR31_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR30_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR30_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR29_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR29_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR28_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR28_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR27_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR27_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR26_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR26_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR25_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR25_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR24_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR24_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR23_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR23_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR22_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR22_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR21_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR21_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR20_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR20_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR19_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR19_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR18_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR18_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR17_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR17_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR16_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR16_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR15_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR15_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR14_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR14_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR13_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR13_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR12_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR12_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR11_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR11_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR10_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR10_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR9_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR9_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR8_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR8_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN31_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN31_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN30_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN30_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN29_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN29_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN28_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN28_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN27_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN27_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN26_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN26_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN25_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN25_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN24_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN24_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN23_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN23_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN22_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN22_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN21_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN21_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN20_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN20_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN19_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN19_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN18_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN18_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN17_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN17_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN16_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN16_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN15_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN15_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN14_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN14_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN13_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN13_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN12_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN12_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN11_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN11_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN10_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN10_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN9_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN9_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN8_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN8_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN31_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN31_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN30_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN30_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN29_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN29_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN28_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN28_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN27_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN27_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN26_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN26_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN25_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN25_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN24_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN24_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN23_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN23_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN22_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN22_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN21_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN21_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN20_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN20_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN19_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN19_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN18_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN18_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN17_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN17_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN16_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN16_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN15_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN15_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN14_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN14_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN13_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN13_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN12_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN12_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN11_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN11_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN10_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN10_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN9_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN9_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN8_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN8_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD_SHIFT 0

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL31_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL31_FIELD_MASK  0x0000000080000000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL31_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL31_FIELD_SHIFT 31

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL30_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL30_FIELD_MASK  0x0000000040000000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL30_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL30_FIELD_SHIFT 30

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL29_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL29_FIELD_MASK  0x0000000020000000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL29_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL29_FIELD_SHIFT 29

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL28_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL28_FIELD_MASK  0x0000000010000000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL28_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL28_FIELD_SHIFT 28

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL27_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL27_FIELD_MASK  0x0000000008000000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL27_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL27_FIELD_SHIFT 27

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL26_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL26_FIELD_MASK  0x0000000004000000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL26_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL26_FIELD_SHIFT 26

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL25_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL25_FIELD_MASK  0x0000000002000000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL25_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL25_FIELD_SHIFT 25

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL24_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL24_FIELD_MASK  0x0000000001000000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL24_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL24_FIELD_SHIFT 24

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL23_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL23_FIELD_MASK  0x0000000000800000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL23_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL23_FIELD_SHIFT 23

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL22_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL22_FIELD_MASK  0x0000000000400000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL22_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL22_FIELD_SHIFT 22

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL21_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL21_FIELD_MASK  0x0000000000200000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL21_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL21_FIELD_SHIFT 21

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL20_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL20_FIELD_MASK  0x0000000000100000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL20_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL20_FIELD_SHIFT 20

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL19_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL19_FIELD_MASK  0x0000000000080000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL19_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL19_FIELD_SHIFT 19

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL18_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL18_FIELD_MASK  0x0000000000040000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL18_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL18_FIELD_SHIFT 18

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL17_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL17_FIELD_MASK  0x0000000000020000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL17_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL17_FIELD_SHIFT 17

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL16_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL16_FIELD_MASK  0x0000000000010000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL16_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL16_FIELD_SHIFT 16

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL15_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL15_FIELD_MASK  0x0000000000008000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL15_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL15_FIELD_SHIFT 15

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL14_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL14_FIELD_MASK  0x0000000000004000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL14_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL14_FIELD_SHIFT 14

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL13_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL13_FIELD_MASK  0x0000000000002000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL13_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL13_FIELD_SHIFT 13

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL12_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL12_FIELD_MASK  0x0000000000001000
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL12_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL12_FIELD_SHIFT 12

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL11_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL11_FIELD_MASK  0x0000000000000800
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL11_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL11_FIELD_SHIFT 11

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL10_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL10_FIELD_MASK  0x0000000000000400
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL10_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL10_FIELD_SHIFT 10

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL9_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL9_FIELD_MASK  0x0000000000000200
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL9_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL9_FIELD_SHIFT 9

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL8_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL8_FIELD_MASK  0x0000000000000100
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL8_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL8_FIELD_SHIFT 8

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD_MASK  0x0000000000000080
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD_SHIFT 7

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD_MASK  0x0000000000000040
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD_SHIFT 6

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD_MASK  0x0000000000000020
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD_SHIFT 5

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD_MASK  0x0000000000000010
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD_SHIFT 4

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD_MASK  0x0000000000000008
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD_SHIFT 3

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD_MASK  0x0000000000000004
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD_SHIFT 2

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD_MASK  0x0000000000000002
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD_SHIFT 1

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD_MASK  0x0000000000000001
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD_SHIFT 0

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL31_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL31_FIELD_MASK  0x0000000080000000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL31_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL31_FIELD_SHIFT 31

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL30_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL30_FIELD_MASK  0x0000000040000000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL30_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL30_FIELD_SHIFT 30

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL29_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL29_FIELD_MASK  0x0000000020000000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL29_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL29_FIELD_SHIFT 29

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL28_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL28_FIELD_MASK  0x0000000010000000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL28_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL28_FIELD_SHIFT 28

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL27_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL27_FIELD_MASK  0x0000000008000000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL27_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL27_FIELD_SHIFT 27

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL26_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL26_FIELD_MASK  0x0000000004000000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL26_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL26_FIELD_SHIFT 26

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL25_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL25_FIELD_MASK  0x0000000002000000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL25_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL25_FIELD_SHIFT 25

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL24_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL24_FIELD_MASK  0x0000000001000000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL24_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL24_FIELD_SHIFT 24

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL23_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL23_FIELD_MASK  0x0000000000800000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL23_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL23_FIELD_SHIFT 23

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL22_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL22_FIELD_MASK  0x0000000000400000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL22_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL22_FIELD_SHIFT 22

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL21_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL21_FIELD_MASK  0x0000000000200000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL21_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL21_FIELD_SHIFT 21

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL20_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL20_FIELD_MASK  0x0000000000100000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL20_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL20_FIELD_SHIFT 20

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL19_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL19_FIELD_MASK  0x0000000000080000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL19_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL19_FIELD_SHIFT 19

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL18_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL18_FIELD_MASK  0x0000000000040000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL18_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL18_FIELD_SHIFT 18

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL17_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL17_FIELD_MASK  0x0000000000020000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL17_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL17_FIELD_SHIFT 17

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL16_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL16_FIELD_MASK  0x0000000000010000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL16_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL16_FIELD_SHIFT 16

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL15_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL15_FIELD_MASK  0x0000000000008000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL15_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL15_FIELD_SHIFT 15

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL14_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL14_FIELD_MASK  0x0000000000004000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL14_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL14_FIELD_SHIFT 14

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL13_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL13_FIELD_MASK  0x0000000000002000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL13_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL13_FIELD_SHIFT 13

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL12_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL12_FIELD_MASK  0x0000000000001000
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL12_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL12_FIELD_SHIFT 12

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL11_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL11_FIELD_MASK  0x0000000000000800
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL11_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL11_FIELD_SHIFT 11

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL10_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL10_FIELD_MASK  0x0000000000000400
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL10_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL10_FIELD_SHIFT 10

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL9_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL9_FIELD_MASK  0x0000000000000200
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL9_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL9_FIELD_SHIFT 9

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL8_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL8_FIELD_MASK  0x0000000000000100
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL8_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL8_FIELD_SHIFT 8

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD_MASK  0x0000000000000080
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD_SHIFT 7

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD_MASK  0x0000000000000040
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD_SHIFT 6

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD_MASK  0x0000000000000020
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD_SHIFT 5

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD_MASK  0x0000000000000010
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD_SHIFT 4

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD_MASK  0x0000000000000008
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD_SHIFT 3

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD_MASK  0x0000000000000004
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD_SHIFT 2

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD_MASK  0x0000000000000002
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD_SHIFT 1

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD_MASK  0x0000000000000001
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT31_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT31_FIELD_MASK  0x0000000080000000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT31_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT30_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT30_FIELD_MASK  0x0000000040000000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT30_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT29_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT29_FIELD_MASK  0x0000000020000000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT29_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT28_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT28_FIELD_MASK  0x0000000010000000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT28_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT27_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT27_FIELD_MASK  0x0000000008000000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT27_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT26_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT26_FIELD_MASK  0x0000000004000000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT26_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT25_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT25_FIELD_MASK  0x0000000002000000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT25_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT24_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT24_FIELD_MASK  0x0000000001000000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT24_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT23_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT23_FIELD_MASK  0x0000000000800000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT23_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT22_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT22_FIELD_MASK  0x0000000000400000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT22_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT21_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT21_FIELD_MASK  0x0000000000200000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT21_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT20_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT20_FIELD_MASK  0x0000000000100000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT20_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT19_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT19_FIELD_MASK  0x0000000000080000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT19_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT18_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT18_FIELD_MASK  0x0000000000040000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT18_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT17_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT17_FIELD_MASK  0x0000000000020000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT17_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT16_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT16_FIELD_MASK  0x0000000000010000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT16_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT15_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT15_FIELD_MASK  0x0000000000008000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT15_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT14_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT14_FIELD_MASK  0x0000000000004000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT14_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT13_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT13_FIELD_MASK  0x0000000000002000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT13_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT12_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT12_FIELD_MASK  0x0000000000001000
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT12_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT11_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT11_FIELD_MASK  0x0000000000000800
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT11_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT10_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT10_FIELD_MASK  0x0000000000000400
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT10_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT9_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT9_FIELD_MASK  0x0000000000000200
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT9_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT8_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT8_FIELD_MASK  0x0000000000000100
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT8_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD_MASK  0x0000000000000080
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD_MASK  0x0000000000000040
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD_MASK  0x0000000000000020
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD_MASK  0x0000000000000010
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD_MASK  0x0000000000000008
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD_MASK  0x0000000000000004
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD_MASK  0x0000000000000002
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD_MASK  0x0000000000000001
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT31_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT31_FIELD_MASK  0x0000000080000000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT31_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT30_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT30_FIELD_MASK  0x0000000040000000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT30_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT29_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT29_FIELD_MASK  0x0000000020000000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT29_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT28_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT28_FIELD_MASK  0x0000000010000000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT28_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT27_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT27_FIELD_MASK  0x0000000008000000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT27_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT26_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT26_FIELD_MASK  0x0000000004000000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT26_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT25_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT25_FIELD_MASK  0x0000000002000000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT25_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT24_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT24_FIELD_MASK  0x0000000001000000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT24_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT23_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT23_FIELD_MASK  0x0000000000800000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT23_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT22_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT22_FIELD_MASK  0x0000000000400000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT22_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT21_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT21_FIELD_MASK  0x0000000000200000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT21_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT20_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT20_FIELD_MASK  0x0000000000100000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT20_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT19_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT19_FIELD_MASK  0x0000000000080000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT19_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT18_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT18_FIELD_MASK  0x0000000000040000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT18_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT17_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT17_FIELD_MASK  0x0000000000020000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT17_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT16_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT16_FIELD_MASK  0x0000000000010000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT16_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT15_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT15_FIELD_MASK  0x0000000000008000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT15_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT14_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT14_FIELD_MASK  0x0000000000004000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT14_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT13_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT13_FIELD_MASK  0x0000000000002000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT13_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT12_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT12_FIELD_MASK  0x0000000000001000
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT12_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT11_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT11_FIELD_MASK  0x0000000000000800
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT11_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT10_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT10_FIELD_MASK  0x0000000000000400
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT10_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT9_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT9_FIELD_MASK  0x0000000000000200
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT9_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT8_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT8_FIELD_MASK  0x0000000000000100
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT8_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD_MASK  0x0000000000000080
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD_MASK  0x0000000000000040
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD_MASK  0x0000000000000020
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD_MASK  0x0000000000000010
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD_MASK  0x0000000000000008
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD_MASK  0x0000000000000004
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD_MASK  0x0000000000000002
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD_MASK  0x0000000000000001
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY31_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY31_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY30_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY30_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY29_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY29_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY28_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY28_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY27_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY27_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY26_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY26_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY25_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY25_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY24_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY24_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY23_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY23_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY22_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY22_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY21_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY21_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY20_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY20_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY19_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY19_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY18_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY18_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY17_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY17_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY16_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY16_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY15_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY15_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY14_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY14_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY13_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY13_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY12_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY12_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY11_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY11_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY10_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY10_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY9_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY9_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY8_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY8_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY31_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY31_FIELD_MASK  0x0000000080000000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY31_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY31_FIELD_SHIFT 31

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY30_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY30_FIELD_MASK  0x0000000040000000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY30_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY30_FIELD_SHIFT 30

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY29_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY29_FIELD_MASK  0x0000000020000000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY29_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY29_FIELD_SHIFT 29

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY28_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY28_FIELD_MASK  0x0000000010000000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY28_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY28_FIELD_SHIFT 28

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY27_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY27_FIELD_MASK  0x0000000008000000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY27_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY27_FIELD_SHIFT 27

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY26_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY26_FIELD_MASK  0x0000000004000000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY26_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY26_FIELD_SHIFT 26

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY25_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY25_FIELD_MASK  0x0000000002000000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY25_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY25_FIELD_SHIFT 25

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY24_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY24_FIELD_MASK  0x0000000001000000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY24_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY24_FIELD_SHIFT 24

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY23_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY23_FIELD_MASK  0x0000000000800000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY23_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY23_FIELD_SHIFT 23

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY22_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY22_FIELD_MASK  0x0000000000400000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY22_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY22_FIELD_SHIFT 22

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY21_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY21_FIELD_MASK  0x0000000000200000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY21_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY21_FIELD_SHIFT 21

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY20_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY20_FIELD_MASK  0x0000000000100000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY20_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY20_FIELD_SHIFT 20

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY19_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY19_FIELD_MASK  0x0000000000080000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY19_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY19_FIELD_SHIFT 19

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY18_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY18_FIELD_MASK  0x0000000000040000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY18_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY18_FIELD_SHIFT 18

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY17_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY17_FIELD_MASK  0x0000000000020000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY17_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY17_FIELD_SHIFT 17

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY16_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY16_FIELD_MASK  0x0000000000010000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY16_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY16_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY15_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY15_FIELD_MASK  0x0000000000008000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY15_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY15_FIELD_SHIFT 15

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY14_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY14_FIELD_MASK  0x0000000000004000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY14_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY14_FIELD_SHIFT 14

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY13_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY13_FIELD_MASK  0x0000000000002000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY13_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY13_FIELD_SHIFT 13

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY12_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY12_FIELD_MASK  0x0000000000001000
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY12_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY12_FIELD_SHIFT 12

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY11_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY11_FIELD_MASK  0x0000000000000800
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY11_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY11_FIELD_SHIFT 11

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY10_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY10_FIELD_MASK  0x0000000000000400
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY10_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY10_FIELD_SHIFT 10

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY9_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY9_FIELD_MASK  0x0000000000000200
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY9_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY9_FIELD_SHIFT 9

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY8_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY8_FIELD_MASK  0x0000000000000100
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY8_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY8_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD_SHIFT 0

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO31_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO31_FIELD_MASK  0x0000000080000000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO31_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO31_FIELD_SHIFT 31

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO30_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO30_FIELD_MASK  0x0000000040000000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO30_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO30_FIELD_SHIFT 30

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO29_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO29_FIELD_MASK  0x0000000020000000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO29_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO29_FIELD_SHIFT 29

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO28_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO28_FIELD_MASK  0x0000000010000000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO28_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO28_FIELD_SHIFT 28

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO27_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO27_FIELD_MASK  0x0000000008000000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO27_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO27_FIELD_SHIFT 27

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO26_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO26_FIELD_MASK  0x0000000004000000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO26_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO26_FIELD_SHIFT 26

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO25_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO25_FIELD_MASK  0x0000000002000000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO25_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO25_FIELD_SHIFT 25

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO24_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO24_FIELD_MASK  0x0000000001000000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO24_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO24_FIELD_SHIFT 24

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO23_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO23_FIELD_MASK  0x0000000000800000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO23_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO23_FIELD_SHIFT 23

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO22_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO22_FIELD_MASK  0x0000000000400000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO22_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO22_FIELD_SHIFT 22

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO21_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO21_FIELD_MASK  0x0000000000200000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO21_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO21_FIELD_SHIFT 21

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO20_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO20_FIELD_MASK  0x0000000000100000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO20_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO20_FIELD_SHIFT 20

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO19_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO19_FIELD_MASK  0x0000000000080000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO19_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO19_FIELD_SHIFT 19

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO18_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO18_FIELD_MASK  0x0000000000040000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO18_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO18_FIELD_SHIFT 18

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO17_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO17_FIELD_MASK  0x0000000000020000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO17_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO17_FIELD_SHIFT 17

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO16_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO16_FIELD_MASK  0x0000000000010000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO16_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO16_FIELD_SHIFT 16

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO15_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO15_FIELD_MASK  0x0000000000008000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO15_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO15_FIELD_SHIFT 15

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO14_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO14_FIELD_MASK  0x0000000000004000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO14_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO14_FIELD_SHIFT 14

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO13_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO13_FIELD_MASK  0x0000000000002000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO13_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO13_FIELD_SHIFT 13

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO12_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO12_FIELD_MASK  0x0000000000001000
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO12_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO12_FIELD_SHIFT 12

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO11_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO11_FIELD_MASK  0x0000000000000800
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO11_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO11_FIELD_SHIFT 11

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO10_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO10_FIELD_MASK  0x0000000000000400
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO10_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO10_FIELD_SHIFT 10

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO9_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO9_FIELD_MASK  0x0000000000000200
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO9_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO9_FIELD_SHIFT 9

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO8_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO8_FIELD_MASK  0x0000000000000100
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO8_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO8_FIELD_SHIFT 8

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD_MASK  0x0000000000000080
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD_SHIFT 7

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD_MASK  0x0000000000000040
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD_SHIFT 6

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD_MASK  0x0000000000000020
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD_SHIFT 5

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD_MASK  0x0000000000000010
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD_SHIFT 4

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD_MASK  0x0000000000000008
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD_SHIFT 3

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD_MASK  0x0000000000000004
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD_SHIFT 2

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD_MASK  0x0000000000000002
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD_SHIFT 1

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD_MASK  0x0000000000000001
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD_SHIFT 0

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO31_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO31_FIELD_MASK  0x0000000080000000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO31_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO31_FIELD_SHIFT 31

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO30_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO30_FIELD_MASK  0x0000000040000000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO30_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO30_FIELD_SHIFT 30

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO29_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO29_FIELD_MASK  0x0000000020000000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO29_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO29_FIELD_SHIFT 29

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO28_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO28_FIELD_MASK  0x0000000010000000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO28_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO28_FIELD_SHIFT 28

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO27_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO27_FIELD_MASK  0x0000000008000000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO27_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO27_FIELD_SHIFT 27

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO26_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO26_FIELD_MASK  0x0000000004000000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO26_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO26_FIELD_SHIFT 26

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO25_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO25_FIELD_MASK  0x0000000002000000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO25_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO25_FIELD_SHIFT 25

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO24_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO24_FIELD_MASK  0x0000000001000000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO24_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO24_FIELD_SHIFT 24

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO23_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO23_FIELD_MASK  0x0000000000800000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO23_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO23_FIELD_SHIFT 23

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO22_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO22_FIELD_MASK  0x0000000000400000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO22_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO22_FIELD_SHIFT 22

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO21_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO21_FIELD_MASK  0x0000000000200000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO21_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO21_FIELD_SHIFT 21

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO20_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO20_FIELD_MASK  0x0000000000100000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO20_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO20_FIELD_SHIFT 20

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO19_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO19_FIELD_MASK  0x0000000000080000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO19_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO19_FIELD_SHIFT 19

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO18_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO18_FIELD_MASK  0x0000000000040000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO18_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO18_FIELD_SHIFT 18

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO17_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO17_FIELD_MASK  0x0000000000020000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO17_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO17_FIELD_SHIFT 17

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO16_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO16_FIELD_MASK  0x0000000000010000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO16_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO16_FIELD_SHIFT 16

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO15_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO15_FIELD_MASK  0x0000000000008000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO15_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO15_FIELD_SHIFT 15

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO14_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO14_FIELD_MASK  0x0000000000004000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO14_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO14_FIELD_SHIFT 14

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO13_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO13_FIELD_MASK  0x0000000000002000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO13_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO13_FIELD_SHIFT 13

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO12_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO12_FIELD_MASK  0x0000000000001000
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO12_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO12_FIELD_SHIFT 12

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO11_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO11_FIELD_MASK  0x0000000000000800
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO11_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO11_FIELD_SHIFT 11

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO10_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO10_FIELD_MASK  0x0000000000000400
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO10_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO10_FIELD_SHIFT 10

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO9_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO9_FIELD_MASK  0x0000000000000200
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO9_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO9_FIELD_SHIFT 9

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO8_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO8_FIELD_MASK  0x0000000000000100
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO8_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO8_FIELD_SHIFT 8

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD_MASK  0x0000000000000080
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD_SHIFT 7

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD_MASK  0x0000000000000040
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD_SHIFT 6

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD_MASK  0x0000000000000020
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD_SHIFT 5

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD_MASK  0x0000000000000010
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD_SHIFT 4

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD_MASK  0x0000000000000008
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD_SHIFT 3

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD_MASK  0x0000000000000004
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD_SHIFT 2

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD_MASK  0x0000000000000002
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD_SHIFT 1

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD_MASK  0x0000000000000001
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD;
#define EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD_MASK  0x00000000ffffffff
#define EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD_WIDTH 32
#define EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD_SHIFT 0

extern const ru_field_rec EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD;
#define EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD_MASK  0x00000000ffffffff
#define EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD_WIDTH 32
#define EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD_SHIFT 0

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT31_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT31_FIELD_MASK  0x0000000080000000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT31_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT30_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT30_FIELD_MASK  0x0000000040000000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT30_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT29_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT29_FIELD_MASK  0x0000000020000000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT29_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT28_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT28_FIELD_MASK  0x0000000010000000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT28_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT27_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT27_FIELD_MASK  0x0000000008000000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT27_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT26_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT26_FIELD_MASK  0x0000000004000000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT26_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT25_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT25_FIELD_MASK  0x0000000002000000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT25_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT24_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT24_FIELD_MASK  0x0000000001000000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT24_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT23_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT23_FIELD_MASK  0x0000000000800000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT23_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT22_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT22_FIELD_MASK  0x0000000000400000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT22_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT21_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT21_FIELD_MASK  0x0000000000200000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT21_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT20_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT20_FIELD_MASK  0x0000000000100000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT20_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT19_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT19_FIELD_MASK  0x0000000000080000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT19_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT18_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT18_FIELD_MASK  0x0000000000040000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT18_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT17_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT17_FIELD_MASK  0x0000000000020000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT17_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT16_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT16_FIELD_MASK  0x0000000000010000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT16_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT15_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT15_FIELD_MASK  0x0000000000008000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT15_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT14_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT14_FIELD_MASK  0x0000000000004000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT14_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT13_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT13_FIELD_MASK  0x0000000000002000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT13_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT12_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT12_FIELD_MASK  0x0000000000001000
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT12_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT11_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT11_FIELD_MASK  0x0000000000000800
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT11_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT10_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT10_FIELD_MASK  0x0000000000000400
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT10_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT9_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT9_FIELD_MASK  0x0000000000000200
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT9_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT8_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT8_FIELD_MASK  0x0000000000000100
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT8_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD_MASK  0x0000000000000080
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD_MASK  0x0000000000000040
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD_MASK  0x0000000000000020
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD_MASK  0x0000000000000010
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD_MASK  0x0000000000000008
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD_MASK  0x0000000000000004
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD_MASK  0x0000000000000002
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD_MASK  0x0000000000000001
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT31_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT31_FIELD_MASK  0x0000000080000000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT31_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT30_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT30_FIELD_MASK  0x0000000040000000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT30_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT29_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT29_FIELD_MASK  0x0000000020000000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT29_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT28_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT28_FIELD_MASK  0x0000000010000000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT28_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT27_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT27_FIELD_MASK  0x0000000008000000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT27_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT26_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT26_FIELD_MASK  0x0000000004000000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT26_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT25_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT25_FIELD_MASK  0x0000000002000000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT25_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT24_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT24_FIELD_MASK  0x0000000001000000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT24_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT23_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT23_FIELD_MASK  0x0000000000800000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT23_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT22_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT22_FIELD_MASK  0x0000000000400000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT22_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT21_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT21_FIELD_MASK  0x0000000000200000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT21_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT20_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT20_FIELD_MASK  0x0000000000100000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT20_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT19_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT19_FIELD_MASK  0x0000000000080000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT19_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT18_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT18_FIELD_MASK  0x0000000000040000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT18_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT17_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT17_FIELD_MASK  0x0000000000020000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT17_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT16_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT16_FIELD_MASK  0x0000000000010000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT16_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT15_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT15_FIELD_MASK  0x0000000000008000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT15_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT14_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT14_FIELD_MASK  0x0000000000004000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT14_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT13_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT13_FIELD_MASK  0x0000000000002000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT13_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT12_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT12_FIELD_MASK  0x0000000000001000
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT12_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT11_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT11_FIELD_MASK  0x0000000000000800
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT11_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT10_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT10_FIELD_MASK  0x0000000000000400
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT10_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT9_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT9_FIELD_MASK  0x0000000000000200
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT9_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT8_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT8_FIELD_MASK  0x0000000000000100
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT8_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD_MASK  0x0000000000000080
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD_MASK  0x0000000000000040
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD_MASK  0x0000000000000020
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD_MASK  0x0000000000000010
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD_MASK  0x0000000000000008
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD_MASK  0x0000000000000004
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD_MASK  0x0000000000000002
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD_MASK  0x0000000000000001
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD;
#define EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD_MASK  0x00000000ffffffff
#define EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD_WIDTH 32
#define EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD;
#define EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD_MASK  0x00000000ffffffff
#define EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD_WIDTH 32
#define EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD;
#define EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD_WIDTH 31
#define EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD;
#define EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD_MASK  0x0000000000000001
#define EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD_WIDTH 1
#define EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD;
#define EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD_WIDTH 31
#define EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD;
#define EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD_MASK  0x0000000000000001
#define EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD_WIDTH 1
#define EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT31_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT31_FIELD_MASK  0x0000000080000000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT31_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT30_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT30_FIELD_MASK  0x0000000040000000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT30_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT29_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT29_FIELD_MASK  0x0000000020000000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT29_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT28_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT28_FIELD_MASK  0x0000000010000000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT28_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT27_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT27_FIELD_MASK  0x0000000008000000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT27_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT26_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT26_FIELD_MASK  0x0000000004000000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT26_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT25_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT25_FIELD_MASK  0x0000000002000000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT25_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT24_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT24_FIELD_MASK  0x0000000001000000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT24_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT23_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT23_FIELD_MASK  0x0000000000800000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT23_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT22_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT22_FIELD_MASK  0x0000000000400000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT22_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT21_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT21_FIELD_MASK  0x0000000000200000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT21_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT20_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT20_FIELD_MASK  0x0000000000100000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT20_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT19_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT19_FIELD_MASK  0x0000000000080000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT19_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT18_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT18_FIELD_MASK  0x0000000000040000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT18_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT17_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT17_FIELD_MASK  0x0000000000020000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT17_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT16_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT16_FIELD_MASK  0x0000000000010000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT16_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT15_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT15_FIELD_MASK  0x0000000000008000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT15_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT14_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT14_FIELD_MASK  0x0000000000004000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT14_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT13_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT13_FIELD_MASK  0x0000000000002000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT13_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT12_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT12_FIELD_MASK  0x0000000000001000
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT12_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT11_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT11_FIELD_MASK  0x0000000000000800
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT11_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT10_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT10_FIELD_MASK  0x0000000000000400
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT10_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT9_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT9_FIELD_MASK  0x0000000000000200
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT9_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT8_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT8_FIELD_MASK  0x0000000000000100
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT8_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD_MASK  0x0000000000000080
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD_MASK  0x0000000000000040
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD_MASK  0x0000000000000020
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD_MASK  0x0000000000000010
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD_MASK  0x0000000000000008
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD_MASK  0x0000000000000004
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD_MASK  0x0000000000000002
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD_MASK  0x0000000000000001
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT31_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT31_FIELD_MASK  0x0000000080000000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT31_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT31_FIELD_SHIFT 31

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT30_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT30_FIELD_MASK  0x0000000040000000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT30_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT30_FIELD_SHIFT 30

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT29_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT29_FIELD_MASK  0x0000000020000000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT29_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT29_FIELD_SHIFT 29

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT28_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT28_FIELD_MASK  0x0000000010000000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT28_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT28_FIELD_SHIFT 28

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT27_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT27_FIELD_MASK  0x0000000008000000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT27_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT27_FIELD_SHIFT 27

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT26_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT26_FIELD_MASK  0x0000000004000000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT26_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT26_FIELD_SHIFT 26

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT25_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT25_FIELD_MASK  0x0000000002000000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT25_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT25_FIELD_SHIFT 25

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT24_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT24_FIELD_MASK  0x0000000001000000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT24_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT24_FIELD_SHIFT 24

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT23_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT23_FIELD_MASK  0x0000000000800000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT23_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT23_FIELD_SHIFT 23

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT22_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT22_FIELD_MASK  0x0000000000400000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT22_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT22_FIELD_SHIFT 22

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT21_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT21_FIELD_MASK  0x0000000000200000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT21_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT21_FIELD_SHIFT 21

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT20_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT20_FIELD_MASK  0x0000000000100000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT20_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT20_FIELD_SHIFT 20

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT19_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT19_FIELD_MASK  0x0000000000080000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT19_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT19_FIELD_SHIFT 19

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT18_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT18_FIELD_MASK  0x0000000000040000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT18_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT18_FIELD_SHIFT 18

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT17_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT17_FIELD_MASK  0x0000000000020000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT17_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT17_FIELD_SHIFT 17

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT16_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT16_FIELD_MASK  0x0000000000010000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT16_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT16_FIELD_SHIFT 16

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT15_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT15_FIELD_MASK  0x0000000000008000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT15_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT15_FIELD_SHIFT 15

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT14_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT14_FIELD_MASK  0x0000000000004000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT14_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT14_FIELD_SHIFT 14

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT13_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT13_FIELD_MASK  0x0000000000002000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT13_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT13_FIELD_SHIFT 13

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT12_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT12_FIELD_MASK  0x0000000000001000
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT12_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT12_FIELD_SHIFT 12

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT11_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT11_FIELD_MASK  0x0000000000000800
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT11_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT11_FIELD_SHIFT 11

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT10_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT10_FIELD_MASK  0x0000000000000400
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT10_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT10_FIELD_SHIFT 10

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT9_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT9_FIELD_MASK  0x0000000000000200
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT9_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT9_FIELD_SHIFT 9

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT8_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT8_FIELD_MASK  0x0000000000000100
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT8_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT8_FIELD_SHIFT 8

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD_MASK  0x0000000000000080
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD_MASK  0x0000000000000040
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD_MASK  0x0000000000000020
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD_MASK  0x0000000000000010
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD_MASK  0x0000000000000008
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD_MASK  0x0000000000000004
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD_MASK  0x0000000000000002
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD_MASK  0x0000000000000001
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD;
#define EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD_WIDTH 31
#define EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD;
#define EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD_MASK  0x0000000000000001
#define EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD_WIDTH 1
#define EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD;
#define EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD_WIDTH 31
#define EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD;
#define EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD_MASK  0x0000000000000001
#define EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD_WIDTH 1
#define EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD_SHIFT 0

extern const ru_field_rec EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD;
#define EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD_MASK  0x0000000080000000
#define EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD_SHIFT 31

extern const ru_field_rec EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD_MASK  0x0000000040000000
#define EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD_SHIFT 30

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD_MASK  0x0000000020000000
#define EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD_SHIFT 29

extern const ru_field_rec EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD_MASK  0x0000000010000000
#define EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD_SHIFT 28

extern const ru_field_rec EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD_MASK  0x0000000008000000
#define EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD_SHIFT 27

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD_MASK  0x0000000004000000
#define EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD_SHIFT 26

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD_MASK  0x0000000002000000
#define EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD_SHIFT 25

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD_MASK  0x0000000001000000
#define EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD_SHIFT 24

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD_MASK  0x0000000000800000
#define EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD_SHIFT 23

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD_MASK  0x0000000000400000
#define EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD_SHIFT 22

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD_MASK  0x0000000000200000
#define EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD_SHIFT 21

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD_MASK  0x0000000000100000
#define EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD_SHIFT 20

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD_MASK  0x0000000000080000
#define EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD_SHIFT 19

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD_MASK  0x0000000000040000
#define EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD_SHIFT 18

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD_MASK  0x0000000000020000
#define EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD_SHIFT 17

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD_MASK  0x0000000000010000
#define EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD_SHIFT 16

extern const ru_field_rec EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD;
#define EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD_MASK  0x0000000000008000
#define EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD_SHIFT 15

extern const ru_field_rec EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD;
#define EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD_MASK  0x0000000000004000
#define EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD_SHIFT 14

extern const ru_field_rec EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD;
#define EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD_MASK  0x0000000000002000
#define EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD_SHIFT 13

extern const ru_field_rec EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD_MASK  0x0000000000001000
#define EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD_SHIFT 12

extern const ru_field_rec EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD;
#define EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD_MASK  0x0000000000000800
#define EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD_SHIFT 11

extern const ru_field_rec EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD;
#define EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD_MASK  0x0000000000000400
#define EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD_SHIFT 10

extern const ru_field_rec EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD;
#define EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD_MASK  0x0000000000000200
#define EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD_SHIFT 9

extern const ru_field_rec EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD;
#define EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD_MASK  0x0000000000000100
#define EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD_SHIFT 8

extern const ru_field_rec EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD_MASK  0x0000000000000080
#define EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD_SHIFT 7

extern const ru_field_rec EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD;
#define EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD_MASK  0x0000000000000040
#define EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD_SHIFT 6

extern const ru_field_rec EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD;
#define EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD_MASK  0x0000000000000020
#define EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD_SHIFT 5

extern const ru_field_rec EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD;
#define EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD_MASK  0x0000000000000010
#define EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD_SHIFT 4

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD_MASK  0x0000000000000008
#define EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD_SHIFT 3

extern const ru_field_rec EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD;
#define EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD_MASK  0x0000000000000004
#define EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD_SHIFT 2

extern const ru_field_rec EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD;
#define EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD_MASK  0x0000000000000002
#define EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD_SHIFT 1

extern const ru_field_rec EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD;
#define EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD_MASK  0x0000000000000001
#define EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD_SHIFT 0

extern const ru_field_rec EPN_MAX_GNT_SIZE_RESERVED0_FIELD;
#define EPN_MAX_GNT_SIZE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_MAX_GNT_SIZE_RESERVED0_FIELD_WIDTH 16
#define EPN_MAX_GNT_SIZE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD;
#define EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD_MASK  0x000000000000ffff
#define EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD_WIDTH 16
#define EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_MAX_FRAME_SIZE_RESERVED0_FIELD;
#define EPN_MAX_FRAME_SIZE_RESERVED0_FIELD_MASK  0x00000000ffffc000
#define EPN_MAX_FRAME_SIZE_RESERVED0_FIELD_WIDTH 18
#define EPN_MAX_FRAME_SIZE_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD;
#define EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD_MASK  0x0000000000003fff
#define EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD_WIDTH 14
#define EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD;
#define EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD_MASK  0x00000000ffff0000
#define EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD_WIDTH 16
#define EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD_SHIFT 16

extern const ru_field_rec EPN_GRANT_OVR_HD_GNTOVRHD_FIELD;
#define EPN_GRANT_OVR_HD_GNTOVRHD_FIELD_MASK  0x000000000000ffff
#define EPN_GRANT_OVR_HD_GNTOVRHD_FIELD_WIDTH 16
#define EPN_GRANT_OVR_HD_GNTOVRHD_FIELD_SHIFT 0

extern const ru_field_rec EPN_POLL_SIZE_POLLSIZEFEC_FIELD;
#define EPN_POLL_SIZE_POLLSIZEFEC_FIELD_MASK  0x00000000ffff0000
#define EPN_POLL_SIZE_POLLSIZEFEC_FIELD_WIDTH 16
#define EPN_POLL_SIZE_POLLSIZEFEC_FIELD_SHIFT 16

extern const ru_field_rec EPN_POLL_SIZE_POLLSIZE_FIELD;
#define EPN_POLL_SIZE_POLLSIZE_FIELD_MASK  0x000000000000ffff
#define EPN_POLL_SIZE_POLLSIZE_FIELD_WIDTH 16
#define EPN_POLL_SIZE_POLLSIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD;
#define EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD_WIDTH 16
#define EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD;
#define EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD_MASK  0x000000000000ffff
#define EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD_WIDTH 16
#define EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD;
#define EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD_WIDTH 16
#define EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD;
#define EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD_MASK  0x000000000000ffff
#define EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD_WIDTH 16
#define EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD_SHIFT 0

extern const ru_field_rec EPN_TIME_STAMP_DIFF_RESERVED0_FIELD;
#define EPN_TIME_STAMP_DIFF_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_TIME_STAMP_DIFF_RESERVED0_FIELD_WIDTH 16
#define EPN_TIME_STAMP_DIFF_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD;
#define EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD_MASK  0x000000000000ffff
#define EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD_WIDTH 16
#define EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD_SHIFT 0

extern const ru_field_rec EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD;
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD_MASK  0x00000000ffff0000
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD_WIDTH 16
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD_SHIFT 16

extern const ru_field_rec EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD;
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD_MASK  0x000000000000ffff
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD_WIDTH 16
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_INTERVAL_RESERVED0_FIELD;
#define EPN_GNT_INTERVAL_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_GNT_INTERVAL_RESERVED0_FIELD_WIDTH 16
#define EPN_GNT_INTERVAL_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_INTERVAL_GNTINTERVAL_FIELD;
#define EPN_GNT_INTERVAL_GNTINTERVAL_FIELD_MASK  0x000000000000ffff
#define EPN_GNT_INTERVAL_GNTINTERVAL_FIELD_WIDTH 16
#define EPN_GNT_INTERVAL_GNTINTERVAL_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD;
#define EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD_MASK  0x00000000ffff0000
#define EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD_WIDTH 16
#define EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD_SHIFT 16

extern const ru_field_rec EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD;
#define EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD_MASK  0x000000000000fc00
#define EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD_WIDTH 6
#define EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD;
#define EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD_MASK  0x00000000000003ff
#define EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD_WIDTH 10
#define EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD;
#define EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD_WIDTH 16
#define EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD;
#define EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD_MASK  0x000000000000ffff
#define EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD_WIDTH 16
#define EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD_SHIFT 0

extern const ru_field_rec EPN_NON_POLL_INTV_RESERVED0_FIELD;
#define EPN_NON_POLL_INTV_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_NON_POLL_INTV_RESERVED0_FIELD_WIDTH 16
#define EPN_NON_POLL_INTV_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD;
#define EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD_MASK  0x000000000000ffff
#define EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD_WIDTH 16
#define EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD_SHIFT 0

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR31_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR31_FIELD_MASK  0x0000000080000000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR31_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR31_FIELD_SHIFT 31

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR30_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR30_FIELD_MASK  0x0000000040000000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR30_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR30_FIELD_SHIFT 30

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR29_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR29_FIELD_MASK  0x0000000020000000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR29_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR29_FIELD_SHIFT 29

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR28_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR28_FIELD_MASK  0x0000000010000000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR28_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR28_FIELD_SHIFT 28

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR27_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR27_FIELD_MASK  0x0000000008000000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR27_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR27_FIELD_SHIFT 27

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR26_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR26_FIELD_MASK  0x0000000004000000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR26_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR26_FIELD_SHIFT 26

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR25_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR25_FIELD_MASK  0x0000000002000000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR25_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR25_FIELD_SHIFT 25

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR24_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR24_FIELD_MASK  0x0000000001000000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR24_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR24_FIELD_SHIFT 24

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR23_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR23_FIELD_MASK  0x0000000000800000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR23_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR23_FIELD_SHIFT 23

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR22_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR22_FIELD_MASK  0x0000000000400000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR22_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR22_FIELD_SHIFT 22

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR21_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR21_FIELD_MASK  0x0000000000200000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR21_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR21_FIELD_SHIFT 21

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR20_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR20_FIELD_MASK  0x0000000000100000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR20_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR20_FIELD_SHIFT 20

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR19_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR19_FIELD_MASK  0x0000000000080000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR19_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR19_FIELD_SHIFT 19

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR18_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR18_FIELD_MASK  0x0000000000040000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR18_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR18_FIELD_SHIFT 18

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR17_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR17_FIELD_MASK  0x0000000000020000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR17_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR17_FIELD_SHIFT 17

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR16_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR16_FIELD_MASK  0x0000000000010000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR16_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR16_FIELD_SHIFT 16

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR15_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR15_FIELD_MASK  0x0000000000008000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR15_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR15_FIELD_SHIFT 15

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR14_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR14_FIELD_MASK  0x0000000000004000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR14_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR14_FIELD_SHIFT 14

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR13_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR13_FIELD_MASK  0x0000000000002000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR13_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR13_FIELD_SHIFT 13

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR12_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR12_FIELD_MASK  0x0000000000001000
#define EPN_FORCE_FCS_ERR_FORCEFCSERR12_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR12_FIELD_SHIFT 12

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR11_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR11_FIELD_MASK  0x0000000000000800
#define EPN_FORCE_FCS_ERR_FORCEFCSERR11_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR11_FIELD_SHIFT 11

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR10_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR10_FIELD_MASK  0x0000000000000400
#define EPN_FORCE_FCS_ERR_FORCEFCSERR10_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR10_FIELD_SHIFT 10

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR9_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR9_FIELD_MASK  0x0000000000000200
#define EPN_FORCE_FCS_ERR_FORCEFCSERR9_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR9_FIELD_SHIFT 9

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR8_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR8_FIELD_MASK  0x0000000000000100
#define EPN_FORCE_FCS_ERR_FORCEFCSERR8_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR8_FIELD_SHIFT 8

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD_MASK  0x0000000000000080
#define EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD_SHIFT 7

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD_MASK  0x0000000000000040
#define EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD_SHIFT 6

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD_MASK  0x0000000000000020
#define EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD_SHIFT 5

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD_MASK  0x0000000000000010
#define EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD_SHIFT 4

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD_MASK  0x0000000000000008
#define EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD_SHIFT 3

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD_MASK  0x0000000000000004
#define EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD_SHIFT 2

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD_MASK  0x0000000000000002
#define EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD_SHIFT 1

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD_MASK  0x0000000000000001
#define EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD;
#define EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD_WIDTH 16
#define EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD;
#define EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD_MASK  0x000000000000ffff
#define EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD_WIDTH 16
#define EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD_SHIFT 0

extern const ru_field_rec EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD;
#define EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD_MASK  0x00000000ffffffff
#define EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD_WIDTH 32
#define EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD;
#define EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD_WIDTH 16
#define EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD;
#define EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD_MASK  0x000000000000ffff
#define EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD_WIDTH 16
#define EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD;
#define EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD_MASK  0x00000000fffff000
#define EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD_WIDTH 20
#define EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD_SHIFT 12

extern const ru_field_rec EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD;
#define EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD_MASK  0x0000000000000fff
#define EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD_WIDTH 12
#define EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_DISCOVERY_INC_RESERVED0_FIELD;
#define EPN_DN_DISCOVERY_INC_RESERVED0_FIELD_MASK  0x00000000fffffc00
#define EPN_DN_DISCOVERY_INC_RESERVED0_FIELD_WIDTH 22
#define EPN_DN_DISCOVERY_INC_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD;
#define EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD_MASK  0x00000000000003ff
#define EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD_WIDTH 10
#define EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD;
#define EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD_WIDTH 16
#define EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD;
#define EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD_MASK  0x000000000000ffff
#define EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD_WIDTH 16
#define EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_FEC_IPG_LENGTH_RESERVED0_FIELD;
#define EPN_FEC_IPG_LENGTH_RESERVED0_FIELD_MASK  0x00000000e0000000
#define EPN_FEC_IPG_LENGTH_RESERVED0_FIELD_WIDTH 3
#define EPN_FEC_IPG_LENGTH_RESERVED0_FIELD_SHIFT 29

extern const ru_field_rec EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD;
#define EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD_MASK  0x000000001f000000
#define EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD_WIDTH 5
#define EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD_SHIFT 24

extern const ru_field_rec EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD;
#define EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD_MASK  0x0000000000ff0000
#define EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD_WIDTH 8
#define EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD_SHIFT 16

extern const ru_field_rec EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD;
#define EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD_MASK  0x000000000000ff00
#define EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD_WIDTH 8
#define EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD_SHIFT 8

extern const ru_field_rec EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD;
#define EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD_MASK  0x00000000000000ff
#define EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD_WIDTH 8
#define EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD_SHIFT 0

extern const ru_field_rec EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD;
#define EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD_MASK  0x00000000ffffffff
#define EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD_WIDTH 32
#define EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD;
#define EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD_MASK  0x00000000ffe00000
#define EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD_WIDTH 11
#define EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD_SHIFT 21

extern const ru_field_rec EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD;
#define EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD_MASK  0x00000000001fffff
#define EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD_WIDTH 21
#define EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD_SHIFT 0

extern const ru_field_rec EPN_VALID_OPCODE_MAP_RESERVED0_FIELD;
#define EPN_VALID_OPCODE_MAP_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_VALID_OPCODE_MAP_RESERVED0_FIELD_WIDTH 16
#define EPN_VALID_OPCODE_MAP_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD;
#define EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD_MASK  0x000000000000ffff
#define EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD_WIDTH 16
#define EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD_SHIFT 0

extern const ru_field_rec EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD;
#define EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD_WIDTH 16
#define EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD;
#define EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD_MASK  0x000000000000ffff
#define EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD_WIDTH 16
#define EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD_SHIFT 0

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD;
#define EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD_MASK  0x00000000ffffe000
#define EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD_WIDTH 19
#define EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD_SHIFT 13

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD_MASK  0x0000000000001000
#define EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD_SHIFT 12

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD;
#define EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD_MASK  0x0000000000000c00
#define EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD_WIDTH 2
#define EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD_SHIFT 10

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD;
#define EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD_MASK  0x0000000000000300
#define EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD_WIDTH 2
#define EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD_SHIFT 8

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD;
#define EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD_MASK  0x0000000000000080
#define EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD_SHIFT 7

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD_MASK  0x0000000000000040
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD_SHIFT 6

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD_MASK  0x0000000000000020
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD_SHIFT 5

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD_MASK  0x0000000000000010
#define EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD_SHIFT 4

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD_MASK  0x0000000000000008
#define EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD_SHIFT 3

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD_MASK  0x0000000000000004
#define EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD_SHIFT 2

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD;
#define EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD_MASK  0x0000000000000002
#define EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD_SHIFT 1

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD_MASK  0x0000000000000001
#define EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD_SHIFT 0

extern const ru_field_rec EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD;
#define EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD_MASK  0x00000000fffff800
#define EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD_WIDTH 21
#define EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD_SHIFT 11

extern const ru_field_rec EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD;
#define EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD_MASK  0x00000000000007ff
#define EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD_WIDTH 11
#define EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD;
#define EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD_MASK  0x00000000ffffffff
#define EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD_WIDTH 32
#define EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD;
#define EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD_WIDTH 26
#define EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD;
#define EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD_MASK  0x000000000000003f
#define EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD_WIDTH 6
#define EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD_SHIFT 0

extern const ru_field_rec EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD;
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD_MASK  0x0000000080000000
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD_WIDTH 1
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD_SHIFT 31

extern const ru_field_rec EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD;
#define EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD_MASK  0x0000000040000000
#define EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD_WIDTH 1
#define EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD_SHIFT 30

extern const ru_field_rec EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD;
#define EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD_MASK  0x000000003fffffe0
#define EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD_WIDTH 25
#define EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD;
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD_MASK  0x000000000000001f
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD_WIDTH 5
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD_SHIFT 0

extern const ru_field_rec EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD;
#define EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD_MASK  0x0000000080000000
#define EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD_WIDTH 1
#define EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD_SHIFT 31

extern const ru_field_rec EPN_DATA_PORT_COMMAND_RESERVED0_FIELD;
#define EPN_DATA_PORT_COMMAND_RESERVED0_FIELD_MASK  0x000000007ffffe00
#define EPN_DATA_PORT_COMMAND_RESERVED0_FIELD_WIDTH 22
#define EPN_DATA_PORT_COMMAND_RESERVED0_FIELD_SHIFT 9

extern const ru_field_rec EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD;
#define EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD_MASK  0x00000000000001f0
#define EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD_WIDTH 5
#define EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD_SHIFT 4

extern const ru_field_rec EPN_DATA_PORT_COMMAND_RESERVED1_FIELD;
#define EPN_DATA_PORT_COMMAND_RESERVED1_FIELD_MASK  0x000000000000000e
#define EPN_DATA_PORT_COMMAND_RESERVED1_FIELD_WIDTH 3
#define EPN_DATA_PORT_COMMAND_RESERVED1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD;
#define EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD_MASK  0x0000000000000001
#define EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD_WIDTH 1
#define EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD_SHIFT 0

extern const ru_field_rec EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD;
#define EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD_MASK  0x00000000ffffc000
#define EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD_WIDTH 18
#define EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD;
#define EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD_MASK  0x0000000000003fff
#define EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD_WIDTH 14
#define EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD_SHIFT 0

extern const ru_field_rec EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD;
#define EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD_MASK  0x00000000ffffffff
#define EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD_WIDTH 32
#define EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD;
#define EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD_WIDTH 32
#define EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD;
#define EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD_WIDTH 32
#define EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD;
#define EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD_WIDTH 32
#define EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD;
#define EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD_WIDTH 32
#define EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD;
#define EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD_WIDTH 32
#define EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD;
#define EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD_WIDTH 32
#define EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD;
#define EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD_WIDTH 32
#define EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD;
#define EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD_MASK  0x00000000ffffffff
#define EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD_WIDTH 32
#define EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD;
#define EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD_WIDTH 31
#define EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD;
#define EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD_MASK  0x0000000000000001
#define EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD_WIDTH 1
#define EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_DEBUG_STATUS_0_RESERVED0_FIELD;
#define EPN_DEBUG_STATUS_0_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_DEBUG_STATUS_0_RESERVED0_FIELD_WIDTH 16
#define EPN_DEBUG_STATUS_0_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD;
#define EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD_MASK  0x000000000000ff00
#define EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD_WIDTH 8
#define EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD_SHIFT 8

extern const ru_field_rec EPN_DEBUG_STATUS_0_RESERVED1_FIELD;
#define EPN_DEBUG_STATUS_0_RESERVED1_FIELD_MASK  0x00000000000000e0
#define EPN_DEBUG_STATUS_0_RESERVED1_FIELD_WIDTH 3
#define EPN_DEBUG_STATUS_0_RESERVED1_FIELD_SHIFT 5

extern const ru_field_rec EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD;
#define EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD_MASK  0x0000000000000010
#define EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD_SHIFT 4

extern const ru_field_rec EPN_DEBUG_STATUS_0_DNSECFULL_FIELD;
#define EPN_DEBUG_STATUS_0_DNSECFULL_FIELD_MASK  0x0000000000000008
#define EPN_DEBUG_STATUS_0_DNSECFULL_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_0_DNSECFULL_FIELD_SHIFT 3

extern const ru_field_rec EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD;
#define EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD_MASK  0x0000000000000004
#define EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD_SHIFT 2

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY31_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY31_FIELD_MASK  0x0000000080000000
#define EPN_DEBUG_STATUS_1_GNTRDY31_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY31_FIELD_SHIFT 31

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY30_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY30_FIELD_MASK  0x0000000040000000
#define EPN_DEBUG_STATUS_1_GNTRDY30_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY30_FIELD_SHIFT 30

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY29_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY29_FIELD_MASK  0x0000000020000000
#define EPN_DEBUG_STATUS_1_GNTRDY29_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY29_FIELD_SHIFT 29

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY28_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY28_FIELD_MASK  0x0000000010000000
#define EPN_DEBUG_STATUS_1_GNTRDY28_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY28_FIELD_SHIFT 28

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY27_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY27_FIELD_MASK  0x0000000008000000
#define EPN_DEBUG_STATUS_1_GNTRDY27_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY27_FIELD_SHIFT 27

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY26_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY26_FIELD_MASK  0x0000000004000000
#define EPN_DEBUG_STATUS_1_GNTRDY26_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY26_FIELD_SHIFT 26

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY25_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY25_FIELD_MASK  0x0000000002000000
#define EPN_DEBUG_STATUS_1_GNTRDY25_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY25_FIELD_SHIFT 25

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY24_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY24_FIELD_MASK  0x0000000001000000
#define EPN_DEBUG_STATUS_1_GNTRDY24_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY24_FIELD_SHIFT 24

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY23_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY23_FIELD_MASK  0x0000000000800000
#define EPN_DEBUG_STATUS_1_GNTRDY23_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY23_FIELD_SHIFT 23

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY22_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY22_FIELD_MASK  0x0000000000400000
#define EPN_DEBUG_STATUS_1_GNTRDY22_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY22_FIELD_SHIFT 22

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY21_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY21_FIELD_MASK  0x0000000000200000
#define EPN_DEBUG_STATUS_1_GNTRDY21_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY21_FIELD_SHIFT 21

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY20_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY20_FIELD_MASK  0x0000000000100000
#define EPN_DEBUG_STATUS_1_GNTRDY20_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY20_FIELD_SHIFT 20

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY19_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY19_FIELD_MASK  0x0000000000080000
#define EPN_DEBUG_STATUS_1_GNTRDY19_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY19_FIELD_SHIFT 19

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY18_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY18_FIELD_MASK  0x0000000000040000
#define EPN_DEBUG_STATUS_1_GNTRDY18_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY18_FIELD_SHIFT 18

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY17_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY17_FIELD_MASK  0x0000000000020000
#define EPN_DEBUG_STATUS_1_GNTRDY17_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY17_FIELD_SHIFT 17

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY16_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY16_FIELD_MASK  0x0000000000010000
#define EPN_DEBUG_STATUS_1_GNTRDY16_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY16_FIELD_SHIFT 16

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY15_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY15_FIELD_MASK  0x0000000000008000
#define EPN_DEBUG_STATUS_1_GNTRDY15_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY15_FIELD_SHIFT 15

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY14_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY14_FIELD_MASK  0x0000000000004000
#define EPN_DEBUG_STATUS_1_GNTRDY14_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY14_FIELD_SHIFT 14

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY13_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY13_FIELD_MASK  0x0000000000002000
#define EPN_DEBUG_STATUS_1_GNTRDY13_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY13_FIELD_SHIFT 13

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY12_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY12_FIELD_MASK  0x0000000000001000
#define EPN_DEBUG_STATUS_1_GNTRDY12_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY12_FIELD_SHIFT 12

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY11_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY11_FIELD_MASK  0x0000000000000800
#define EPN_DEBUG_STATUS_1_GNTRDY11_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY11_FIELD_SHIFT 11

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY10_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY10_FIELD_MASK  0x0000000000000400
#define EPN_DEBUG_STATUS_1_GNTRDY10_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY10_FIELD_SHIFT 10

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY9_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY9_FIELD_MASK  0x0000000000000200
#define EPN_DEBUG_STATUS_1_GNTRDY9_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY9_FIELD_SHIFT 9

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY8_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY8_FIELD_MASK  0x0000000000000100
#define EPN_DEBUG_STATUS_1_GNTRDY8_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY8_FIELD_SHIFT 8

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY7_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY7_FIELD_MASK  0x0000000000000080
#define EPN_DEBUG_STATUS_1_GNTRDY7_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY6_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY6_FIELD_MASK  0x0000000000000040
#define EPN_DEBUG_STATUS_1_GNTRDY6_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY5_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY5_FIELD_MASK  0x0000000000000020
#define EPN_DEBUG_STATUS_1_GNTRDY5_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY4_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY4_FIELD_MASK  0x0000000000000010
#define EPN_DEBUG_STATUS_1_GNTRDY4_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY3_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY3_FIELD_MASK  0x0000000000000008
#define EPN_DEBUG_STATUS_1_GNTRDY3_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY2_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY2_FIELD_MASK  0x0000000000000004
#define EPN_DEBUG_STATUS_1_GNTRDY2_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY1_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY1_FIELD_MASK  0x0000000000000002
#define EPN_DEBUG_STATUS_1_GNTRDY1_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY0_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY0_FIELD_MASK  0x0000000000000001
#define EPN_DEBUG_STATUS_1_GNTRDY0_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD;
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD_MASK  0x00000000fff80000
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD_WIDTH 13
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD_SHIFT 19

extern const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD;
#define EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD_MASK  0x0000000000070000
#define EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD_WIDTH 3
#define EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD_SHIFT 16

extern const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD;
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD_MASK  0x0000000000008000
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD_WIDTH 1
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD_SHIFT 15

extern const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD;
#define EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD_MASK  0x0000000000007fff
#define EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD_WIDTH 15
#define EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD_SHIFT 0

extern const ru_field_rec EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD;
#define EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD_MASK  0x00000000ffffffff
#define EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD_WIDTH 32
#define EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD_SHIFT 0

extern const ru_field_rec EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD;
#define EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD_WIDTH 16
#define EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD;
#define EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD_MASK  0x000000000000ffff
#define EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD_WIDTH 16
#define EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD;
#define EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD;
#define EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD_WIDTH 32
#define EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD;
#define EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD_WIDTH 32
#define EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD;
#define EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD_WIDTH 32
#define EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD;
#define EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD_WIDTH 32
#define EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD;
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD_MASK  0x00000000fffffc00
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD_WIDTH 22
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD;
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD_MASK  0x00000000000003ff
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD_WIDTH 10
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD_SHIFT 0

extern const ru_field_rec EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD;
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD_MASK  0x00000000ffffc000
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD_WIDTH 18
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD;
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD_MASK  0x0000000000003fff
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD_WIDTH 14
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD;
#define EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD_MASK  0x00000000ffffffff
#define EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD_WIDTH 32
#define EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_SPARE_CTL_CFGEPNSPARE_FIELD;
#define EPN_SPARE_CTL_CFGEPNSPARE_FIELD_MASK  0x00000000fffffffc
#define EPN_SPARE_CTL_CFGEPNSPARE_FIELD_WIDTH 30
#define EPN_SPARE_CTL_CFGEPNSPARE_FIELD_SHIFT 2

extern const ru_field_rec EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD;
#define EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD_MASK  0x0000000000000002
#define EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD_WIDTH 1
#define EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD_SHIFT 1

extern const ru_field_rec EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD;
#define EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD_MASK  0x0000000000000001
#define EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD_WIDTH 1
#define EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD_SHIFT 0

extern const ru_field_rec EPN_TS_SYNC_OFFSET_RESERVED0_FIELD;
#define EPN_TS_SYNC_OFFSET_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define EPN_TS_SYNC_OFFSET_RESERVED0_FIELD_WIDTH 26
#define EPN_TS_SYNC_OFFSET_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD;
#define EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD_MASK  0x000000000000003f
#define EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD_WIDTH 6
#define EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD;
#define EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD_MASK  0x00000000ffffffff
#define EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD_WIDTH 32
#define EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD_SHIFT 0

extern const ru_field_rec EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD;
#define EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD_MASK  0x00000000ffffffff
#define EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD_WIDTH 32
#define EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD_SHIFT 0

extern const ru_field_rec EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD;
#define EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD_WIDTH 16
#define EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD;
#define EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD_MASK  0x000000000000ffff
#define EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD_WIDTH 16
#define EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD_SHIFT 0

extern const ru_field_rec EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD;
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD_MASK  0x0000000080000000
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD_WIDTH 1
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD_SHIFT 31

extern const ru_field_rec EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD;
#define EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD_MASK  0x000000007ffffff8
#define EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD_WIDTH 28
#define EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD;
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD_MASK  0x0000000000000007
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD_WIDTH 3
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD_SHIFT 0

extern const ru_field_rec EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD;
#define EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD_MASK  0x00000000ffffffff
#define EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD_WIDTH 32
#define EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD_SHIFT 0

extern const ru_field_rec EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD;
#define EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD_WIDTH 16
#define EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD;
#define EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD_MASK  0x000000000000ffff
#define EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD_WIDTH 16
#define EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD_SHIFT 0

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD;
#define EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD_WIDTH 30
#define EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD;
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD_MASK  0x0000000000000002
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD_WIDTH 1
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD_SHIFT 1

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD;
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD_MASK  0x0000000000000001
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD_WIDTH 1
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD_SHIFT 0

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD;
#define EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD_WIDTH 30
#define EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD;
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD_MASK  0x0000000000000002
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD_WIDTH 1
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD_SHIFT 1

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD;
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD_MASK  0x0000000000000001
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD_WIDTH 1
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD_SHIFT 0

extern const ru_field_rec EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD;
#define EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD_WIDTH 16
#define EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD;
#define EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD_MASK  0x000000000000ffff
#define EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD_WIDTH 16
#define EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD;
#define EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD_MASK  0x00000000ffffffff
#define EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD_WIDTH 32
#define EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD_SHIFT 0

extern const ru_field_rec EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD;
#define EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD_MASK  0x00000000fc000000
#define EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD_WIDTH 6
#define EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD_SHIFT 26

extern const ru_field_rec EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD;
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD_MASK  0x0000000003ff0000
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD_WIDTH 10
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD_SHIFT 16

extern const ru_field_rec EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD;
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD_MASK  0x000000000000ffff
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD_WIDTH 16
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD;
#define EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD_MASK  0x00000000ffffffff
#define EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD_WIDTH 32
#define EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD_SHIFT 0

extern const ru_field_rec EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD;
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD_WIDTH 16
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD;
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD_MASK  0x000000000000ffff
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD_WIDTH 16
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD_SHIFT 0

extern const ru_field_rec EPN_AES_CONFIGURATION_1_PRVUPSTREAMAESMODE_1_FIELD;
#define EPN_AES_CONFIGURATION_1_PRVUPSTREAMAESMODE_1_FIELD_MASK  0x00000000ffffffff
#define EPN_AES_CONFIGURATION_1_PRVUPSTREAMAESMODE_1_FIELD_WIDTH 32
#define EPN_AES_CONFIGURATION_1_PRVUPSTREAMAESMODE_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_0_RESERVED0_FIELD;
#define EPN_BURST_CAP_0_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_0_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_0_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_0_BURSTCAP0_FIELD;
#define EPN_BURST_CAP_0_BURSTCAP0_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_0_BURSTCAP0_FIELD_WIDTH 20
#define EPN_BURST_CAP_0_BURSTCAP0_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_1_RESERVED0_FIELD;
#define EPN_BURST_CAP_1_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_1_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_1_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_1_BURSTCAP1_FIELD;
#define EPN_BURST_CAP_1_BURSTCAP1_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_1_BURSTCAP1_FIELD_WIDTH 20
#define EPN_BURST_CAP_1_BURSTCAP1_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_2_RESERVED0_FIELD;
#define EPN_BURST_CAP_2_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_2_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_2_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_2_BURSTCAP2_FIELD;
#define EPN_BURST_CAP_2_BURSTCAP2_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_2_BURSTCAP2_FIELD_WIDTH 20
#define EPN_BURST_CAP_2_BURSTCAP2_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_3_RESERVED0_FIELD;
#define EPN_BURST_CAP_3_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_3_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_3_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_3_BURSTCAP3_FIELD;
#define EPN_BURST_CAP_3_BURSTCAP3_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_3_BURSTCAP3_FIELD_WIDTH 20
#define EPN_BURST_CAP_3_BURSTCAP3_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_4_RESERVED0_FIELD;
#define EPN_BURST_CAP_4_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_4_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_4_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_4_BURSTCAP4_FIELD;
#define EPN_BURST_CAP_4_BURSTCAP4_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_4_BURSTCAP4_FIELD_WIDTH 20
#define EPN_BURST_CAP_4_BURSTCAP4_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_5_RESERVED0_FIELD;
#define EPN_BURST_CAP_5_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_5_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_5_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_5_BURSTCAP5_FIELD;
#define EPN_BURST_CAP_5_BURSTCAP5_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_5_BURSTCAP5_FIELD_WIDTH 20
#define EPN_BURST_CAP_5_BURSTCAP5_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_6_RESERVED0_FIELD;
#define EPN_BURST_CAP_6_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_6_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_6_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_6_BURSTCAP6_FIELD;
#define EPN_BURST_CAP_6_BURSTCAP6_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_6_BURSTCAP6_FIELD_WIDTH 20
#define EPN_BURST_CAP_6_BURSTCAP6_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_7_RESERVED0_FIELD;
#define EPN_BURST_CAP_7_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_7_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_7_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_7_BURSTCAP7_FIELD;
#define EPN_BURST_CAP_7_BURSTCAP7_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_7_BURSTCAP7_FIELD_WIDTH 20
#define EPN_BURST_CAP_7_BURSTCAP7_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_0_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_0_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_0_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_0_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_0_QUELLIDMAP0_FIELD;
#define EPN_QUEUE_LLID_MAP_0_QUELLIDMAP0_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_0_QUELLIDMAP0_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_0_QUELLIDMAP0_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_1_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_1_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_1_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_1_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_1_QUELLIDMAP1_FIELD;
#define EPN_QUEUE_LLID_MAP_1_QUELLIDMAP1_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_1_QUELLIDMAP1_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_1_QUELLIDMAP1_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_2_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_2_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_2_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_2_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_2_QUELLIDMAP2_FIELD;
#define EPN_QUEUE_LLID_MAP_2_QUELLIDMAP2_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_2_QUELLIDMAP2_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_2_QUELLIDMAP2_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_3_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_3_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_3_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_3_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_3_QUELLIDMAP3_FIELD;
#define EPN_QUEUE_LLID_MAP_3_QUELLIDMAP3_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_3_QUELLIDMAP3_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_3_QUELLIDMAP3_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_4_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_4_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_4_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_4_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_4_QUELLIDMAP4_FIELD;
#define EPN_QUEUE_LLID_MAP_4_QUELLIDMAP4_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_4_QUELLIDMAP4_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_4_QUELLIDMAP4_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_5_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_5_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_5_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_5_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_5_QUELLIDMAP5_FIELD;
#define EPN_QUEUE_LLID_MAP_5_QUELLIDMAP5_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_5_QUELLIDMAP5_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_5_QUELLIDMAP5_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_6_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_6_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_6_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_6_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_6_QUELLIDMAP6_FIELD;
#define EPN_QUEUE_LLID_MAP_6_QUELLIDMAP6_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_6_QUELLIDMAP6_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_6_QUELLIDMAP6_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_7_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_7_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_7_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_7_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_7_QUELLIDMAP7_FIELD;
#define EPN_QUEUE_LLID_MAP_7_QUELLIDMAP7_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_7_QUELLIDMAP7_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_7_QUELLIDMAP7_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT0_UNUSEDTQCNT0_FIELD;
#define EPN_UNUSED_TQ_CNT0_UNUSEDTQCNT0_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT0_UNUSEDTQCNT0_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT0_UNUSEDTQCNT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT1_UNUSEDTQCNT1_FIELD;
#define EPN_UNUSED_TQ_CNT1_UNUSEDTQCNT1_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT1_UNUSEDTQCNT1_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT1_UNUSEDTQCNT1_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT2_UNUSEDTQCNT2_FIELD;
#define EPN_UNUSED_TQ_CNT2_UNUSEDTQCNT2_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT2_UNUSEDTQCNT2_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT2_UNUSEDTQCNT2_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT3_UNUSEDTQCNT3_FIELD;
#define EPN_UNUSED_TQ_CNT3_UNUSEDTQCNT3_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT3_UNUSEDTQCNT3_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT3_UNUSEDTQCNT3_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT4_UNUSEDTQCNT4_FIELD;
#define EPN_UNUSED_TQ_CNT4_UNUSEDTQCNT4_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT4_UNUSEDTQCNT4_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT4_UNUSEDTQCNT4_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT5_UNUSEDTQCNT5_FIELD;
#define EPN_UNUSED_TQ_CNT5_UNUSEDTQCNT5_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT5_UNUSEDTQCNT5_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT5_UNUSEDTQCNT5_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT6_UNUSEDTQCNT6_FIELD;
#define EPN_UNUSED_TQ_CNT6_UNUSEDTQCNT6_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT6_UNUSEDTQCNT6_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT6_UNUSEDTQCNT6_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT7_UNUSEDTQCNT7_FIELD;
#define EPN_UNUSED_TQ_CNT7_UNUSEDTQCNT7_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT7_UNUSEDTQCNT7_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT7_UNUSEDTQCNT7_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_0_CFGSHPMASK0_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_0_CFGSHPMASK0_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_0_CFGSHPMASK0_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_0_CFGSHPMASK0_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_1_CFGSHPMASK1_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_1_CFGSHPMASK1_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_1_CFGSHPMASK1_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_1_CFGSHPMASK1_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_2_CFGSHPMASK2_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_2_CFGSHPMASK2_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_2_CFGSHPMASK2_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_2_CFGSHPMASK2_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_3_CFGSHPMASK3_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_3_CFGSHPMASK3_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_3_CFGSHPMASK3_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_3_CFGSHPMASK3_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_4_CFGSHPMASK4_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_4_CFGSHPMASK4_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_4_CFGSHPMASK4_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_4_CFGSHPMASK4_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_5_CFGSHPMASK5_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_5_CFGSHPMASK5_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_5_CFGSHPMASK5_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_5_CFGSHPMASK5_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_6_CFGSHPMASK6_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_6_CFGSHPMASK6_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_6_CFGSHPMASK6_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_6_CFGSHPMASK6_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_7_CFGSHPMASK7_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_7_CFGSHPMASK7_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_7_CFGSHPMASK7_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_7_CFGSHPMASK7_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_0_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_0_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_0_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_0_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUEEND0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUEEND0_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUEEND0_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUEEND0_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_0_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_0_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_0_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_0_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUESTART0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUESTART0_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUESTART0_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_0_CFGL2SQUESTART0_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_1_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_1_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_1_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_1_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUEEND1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUEEND1_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUEEND1_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUEEND1_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_1_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_1_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_1_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_1_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUESTART1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUESTART1_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUESTART1_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_1_CFGL2SQUESTART1_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_2_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_2_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_2_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_2_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUEEND2_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUEEND2_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUEEND2_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUEEND2_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_2_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_2_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_2_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_2_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUESTART2_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUESTART2_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUESTART2_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_2_CFGL2SQUESTART2_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_3_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_3_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_3_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_3_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUEEND3_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUEEND3_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUEEND3_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUEEND3_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_3_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_3_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_3_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_3_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUESTART3_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUESTART3_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUESTART3_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_3_CFGL2SQUESTART3_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_4_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_4_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_4_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_4_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUEEND4_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUEEND4_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUEEND4_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUEEND4_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_4_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_4_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_4_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_4_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUESTART4_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUESTART4_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUESTART4_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_4_CFGL2SQUESTART4_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_5_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_5_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_5_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_5_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUEEND5_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUEEND5_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUEEND5_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUEEND5_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_5_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_5_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_5_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_5_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUESTART5_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUESTART5_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUESTART5_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_5_CFGL2SQUESTART5_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_6_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_6_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_6_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_6_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUEEND6_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUEEND6_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUEEND6_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUEEND6_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_6_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_6_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_6_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_6_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUESTART6_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUESTART6_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUESTART6_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_6_CFGL2SQUESTART6_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_7_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_7_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_7_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_7_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUEEND7_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUEEND7_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUEEND7_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUEEND7_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_7_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_7_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_7_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_7_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUESTART7_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUESTART7_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUESTART7_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_7_CFGL2SQUESTART7_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_0_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_0_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_0_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_0_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_0_PRVBURSTLIMIT0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_0_PRVBURSTLIMIT0_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_0_PRVBURSTLIMIT0_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_0_PRVBURSTLIMIT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_1_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_1_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_1_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_1_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_1_PRVBURSTLIMIT1_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_1_PRVBURSTLIMIT1_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_1_PRVBURSTLIMIT1_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_1_PRVBURSTLIMIT1_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_2_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_2_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_2_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_2_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_2_PRVBURSTLIMIT2_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_2_PRVBURSTLIMIT2_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_2_PRVBURSTLIMIT2_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_2_PRVBURSTLIMIT2_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_3_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_3_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_3_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_3_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_3_PRVBURSTLIMIT3_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_3_PRVBURSTLIMIT3_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_3_PRVBURSTLIMIT3_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_3_PRVBURSTLIMIT3_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_4_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_4_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_4_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_4_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_4_PRVBURSTLIMIT4_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_4_PRVBURSTLIMIT4_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_4_PRVBURSTLIMIT4_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_4_PRVBURSTLIMIT4_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_5_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_5_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_5_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_5_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_5_PRVBURSTLIMIT5_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_5_PRVBURSTLIMIT5_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_5_PRVBURSTLIMIT5_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_5_PRVBURSTLIMIT5_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_6_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_6_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_6_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_6_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_6_PRVBURSTLIMIT6_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_6_PRVBURSTLIMIT6_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_6_PRVBURSTLIMIT6_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_6_PRVBURSTLIMIT6_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_7_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_7_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_7_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_7_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_7_PRVBURSTLIMIT7_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_7_PRVBURSTLIMIT7_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_7_PRVBURSTLIMIT7_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_7_PRVBURSTLIMIT7_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_8_RESERVED0_FIELD;
#define EPN_BURST_CAP_8_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_8_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_8_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_8_BURSTCAP8_FIELD;
#define EPN_BURST_CAP_8_BURSTCAP8_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_8_BURSTCAP8_FIELD_WIDTH 20
#define EPN_BURST_CAP_8_BURSTCAP8_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_9_RESERVED0_FIELD;
#define EPN_BURST_CAP_9_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_9_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_9_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_9_BURSTCAP9_FIELD;
#define EPN_BURST_CAP_9_BURSTCAP9_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_9_BURSTCAP9_FIELD_WIDTH 20
#define EPN_BURST_CAP_9_BURSTCAP9_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_10_RESERVED0_FIELD;
#define EPN_BURST_CAP_10_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_10_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_10_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_10_BURSTCAP10_FIELD;
#define EPN_BURST_CAP_10_BURSTCAP10_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_10_BURSTCAP10_FIELD_WIDTH 20
#define EPN_BURST_CAP_10_BURSTCAP10_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_11_RESERVED0_FIELD;
#define EPN_BURST_CAP_11_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_11_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_11_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_11_BURSTCAP11_FIELD;
#define EPN_BURST_CAP_11_BURSTCAP11_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_11_BURSTCAP11_FIELD_WIDTH 20
#define EPN_BURST_CAP_11_BURSTCAP11_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_12_RESERVED0_FIELD;
#define EPN_BURST_CAP_12_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_12_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_12_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_12_BURSTCAP12_FIELD;
#define EPN_BURST_CAP_12_BURSTCAP12_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_12_BURSTCAP12_FIELD_WIDTH 20
#define EPN_BURST_CAP_12_BURSTCAP12_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_13_RESERVED0_FIELD;
#define EPN_BURST_CAP_13_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_13_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_13_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_13_BURSTCAP13_FIELD;
#define EPN_BURST_CAP_13_BURSTCAP13_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_13_BURSTCAP13_FIELD_WIDTH 20
#define EPN_BURST_CAP_13_BURSTCAP13_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_14_RESERVED0_FIELD;
#define EPN_BURST_CAP_14_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_14_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_14_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_14_BURSTCAP14_FIELD;
#define EPN_BURST_CAP_14_BURSTCAP14_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_14_BURSTCAP14_FIELD_WIDTH 20
#define EPN_BURST_CAP_14_BURSTCAP14_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_15_RESERVED0_FIELD;
#define EPN_BURST_CAP_15_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_15_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_15_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_15_BURSTCAP15_FIELD;
#define EPN_BURST_CAP_15_BURSTCAP15_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_15_BURSTCAP15_FIELD_WIDTH 20
#define EPN_BURST_CAP_15_BURSTCAP15_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_16_RESERVED0_FIELD;
#define EPN_BURST_CAP_16_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_16_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_16_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_16_BURSTCAP16_FIELD;
#define EPN_BURST_CAP_16_BURSTCAP16_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_16_BURSTCAP16_FIELD_WIDTH 20
#define EPN_BURST_CAP_16_BURSTCAP16_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_17_RESERVED0_FIELD;
#define EPN_BURST_CAP_17_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_17_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_17_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_17_BURSTCAP17_FIELD;
#define EPN_BURST_CAP_17_BURSTCAP17_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_17_BURSTCAP17_FIELD_WIDTH 20
#define EPN_BURST_CAP_17_BURSTCAP17_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_18_RESERVED0_FIELD;
#define EPN_BURST_CAP_18_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_18_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_18_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_18_BURSTCAP18_FIELD;
#define EPN_BURST_CAP_18_BURSTCAP18_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_18_BURSTCAP18_FIELD_WIDTH 20
#define EPN_BURST_CAP_18_BURSTCAP18_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_19_RESERVED0_FIELD;
#define EPN_BURST_CAP_19_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_19_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_19_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_19_BURSTCAP19_FIELD;
#define EPN_BURST_CAP_19_BURSTCAP19_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_19_BURSTCAP19_FIELD_WIDTH 20
#define EPN_BURST_CAP_19_BURSTCAP19_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_20_RESERVED0_FIELD;
#define EPN_BURST_CAP_20_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_20_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_20_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_20_BURSTCAP20_FIELD;
#define EPN_BURST_CAP_20_BURSTCAP20_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_20_BURSTCAP20_FIELD_WIDTH 20
#define EPN_BURST_CAP_20_BURSTCAP20_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_21_RESERVED0_FIELD;
#define EPN_BURST_CAP_21_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_21_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_21_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_21_BURSTCAP21_FIELD;
#define EPN_BURST_CAP_21_BURSTCAP21_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_21_BURSTCAP21_FIELD_WIDTH 20
#define EPN_BURST_CAP_21_BURSTCAP21_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_22_RESERVED0_FIELD;
#define EPN_BURST_CAP_22_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_22_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_22_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_22_BURSTCAP22_FIELD;
#define EPN_BURST_CAP_22_BURSTCAP22_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_22_BURSTCAP22_FIELD_WIDTH 20
#define EPN_BURST_CAP_22_BURSTCAP22_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_23_RESERVED0_FIELD;
#define EPN_BURST_CAP_23_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_23_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_23_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_23_BURSTCAP23_FIELD;
#define EPN_BURST_CAP_23_BURSTCAP23_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_23_BURSTCAP23_FIELD_WIDTH 20
#define EPN_BURST_CAP_23_BURSTCAP23_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_24_RESERVED0_FIELD;
#define EPN_BURST_CAP_24_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_24_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_24_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_24_BURSTCAP24_FIELD;
#define EPN_BURST_CAP_24_BURSTCAP24_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_24_BURSTCAP24_FIELD_WIDTH 20
#define EPN_BURST_CAP_24_BURSTCAP24_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_25_RESERVED0_FIELD;
#define EPN_BURST_CAP_25_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_25_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_25_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_25_BURSTCAP25_FIELD;
#define EPN_BURST_CAP_25_BURSTCAP25_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_25_BURSTCAP25_FIELD_WIDTH 20
#define EPN_BURST_CAP_25_BURSTCAP25_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_26_RESERVED0_FIELD;
#define EPN_BURST_CAP_26_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_26_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_26_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_26_BURSTCAP26_FIELD;
#define EPN_BURST_CAP_26_BURSTCAP26_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_26_BURSTCAP26_FIELD_WIDTH 20
#define EPN_BURST_CAP_26_BURSTCAP26_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_27_RESERVED0_FIELD;
#define EPN_BURST_CAP_27_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_27_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_27_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_27_BURSTCAP27_FIELD;
#define EPN_BURST_CAP_27_BURSTCAP27_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_27_BURSTCAP27_FIELD_WIDTH 20
#define EPN_BURST_CAP_27_BURSTCAP27_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_28_RESERVED0_FIELD;
#define EPN_BURST_CAP_28_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_28_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_28_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_28_BURSTCAP28_FIELD;
#define EPN_BURST_CAP_28_BURSTCAP28_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_28_BURSTCAP28_FIELD_WIDTH 20
#define EPN_BURST_CAP_28_BURSTCAP28_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_29_RESERVED0_FIELD;
#define EPN_BURST_CAP_29_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_29_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_29_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_29_BURSTCAP29_FIELD;
#define EPN_BURST_CAP_29_BURSTCAP29_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_29_BURSTCAP29_FIELD_WIDTH 20
#define EPN_BURST_CAP_29_BURSTCAP29_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_30_RESERVED0_FIELD;
#define EPN_BURST_CAP_30_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_30_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_30_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_30_BURSTCAP30_FIELD;
#define EPN_BURST_CAP_30_BURSTCAP30_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_30_BURSTCAP30_FIELD_WIDTH 20
#define EPN_BURST_CAP_30_BURSTCAP30_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP_31_RESERVED0_FIELD;
#define EPN_BURST_CAP_31_RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP_31_RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP_31_RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP_31_BURSTCAP31_FIELD;
#define EPN_BURST_CAP_31_BURSTCAP31_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP_31_BURSTCAP31_FIELD_WIDTH 20
#define EPN_BURST_CAP_31_BURSTCAP31_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_8_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_8_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_8_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_8_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_8_QUELLIDMAP8_FIELD;
#define EPN_QUEUE_LLID_MAP_8_QUELLIDMAP8_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_8_QUELLIDMAP8_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_8_QUELLIDMAP8_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_9_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_9_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_9_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_9_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_9_QUELLIDMAP9_FIELD;
#define EPN_QUEUE_LLID_MAP_9_QUELLIDMAP9_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_9_QUELLIDMAP9_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_9_QUELLIDMAP9_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_10_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_10_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_10_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_10_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_10_QUELLIDMAP10_FIELD;
#define EPN_QUEUE_LLID_MAP_10_QUELLIDMAP10_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_10_QUELLIDMAP10_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_10_QUELLIDMAP10_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_11_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_11_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_11_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_11_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_11_QUELLIDMAP11_FIELD;
#define EPN_QUEUE_LLID_MAP_11_QUELLIDMAP11_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_11_QUELLIDMAP11_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_11_QUELLIDMAP11_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_12_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_12_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_12_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_12_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_12_QUELLIDMAP12_FIELD;
#define EPN_QUEUE_LLID_MAP_12_QUELLIDMAP12_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_12_QUELLIDMAP12_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_12_QUELLIDMAP12_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_13_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_13_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_13_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_13_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_13_QUELLIDMAP13_FIELD;
#define EPN_QUEUE_LLID_MAP_13_QUELLIDMAP13_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_13_QUELLIDMAP13_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_13_QUELLIDMAP13_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_14_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_14_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_14_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_14_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_14_QUELLIDMAP14_FIELD;
#define EPN_QUEUE_LLID_MAP_14_QUELLIDMAP14_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_14_QUELLIDMAP14_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_14_QUELLIDMAP14_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_15_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_15_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_15_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_15_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_15_QUELLIDMAP15_FIELD;
#define EPN_QUEUE_LLID_MAP_15_QUELLIDMAP15_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_15_QUELLIDMAP15_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_15_QUELLIDMAP15_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_16_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_16_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_16_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_16_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_16_QUELLIDMAP16_FIELD;
#define EPN_QUEUE_LLID_MAP_16_QUELLIDMAP16_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_16_QUELLIDMAP16_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_16_QUELLIDMAP16_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_17_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_17_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_17_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_17_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_17_QUELLIDMAP17_FIELD;
#define EPN_QUEUE_LLID_MAP_17_QUELLIDMAP17_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_17_QUELLIDMAP17_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_17_QUELLIDMAP17_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_18_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_18_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_18_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_18_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_18_QUELLIDMAP18_FIELD;
#define EPN_QUEUE_LLID_MAP_18_QUELLIDMAP18_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_18_QUELLIDMAP18_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_18_QUELLIDMAP18_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_19_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_19_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_19_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_19_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_19_QUELLIDMAP19_FIELD;
#define EPN_QUEUE_LLID_MAP_19_QUELLIDMAP19_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_19_QUELLIDMAP19_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_19_QUELLIDMAP19_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_20_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_20_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_20_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_20_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_20_QUELLIDMAP20_FIELD;
#define EPN_QUEUE_LLID_MAP_20_QUELLIDMAP20_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_20_QUELLIDMAP20_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_20_QUELLIDMAP20_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_21_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_21_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_21_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_21_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_21_QUELLIDMAP21_FIELD;
#define EPN_QUEUE_LLID_MAP_21_QUELLIDMAP21_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_21_QUELLIDMAP21_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_21_QUELLIDMAP21_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_22_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_22_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_22_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_22_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_22_QUELLIDMAP22_FIELD;
#define EPN_QUEUE_LLID_MAP_22_QUELLIDMAP22_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_22_QUELLIDMAP22_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_22_QUELLIDMAP22_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_23_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_23_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_23_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_23_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_23_QUELLIDMAP23_FIELD;
#define EPN_QUEUE_LLID_MAP_23_QUELLIDMAP23_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_23_QUELLIDMAP23_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_23_QUELLIDMAP23_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_24_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_24_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_24_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_24_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_24_QUELLIDMAP24_FIELD;
#define EPN_QUEUE_LLID_MAP_24_QUELLIDMAP24_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_24_QUELLIDMAP24_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_24_QUELLIDMAP24_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_25_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_25_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_25_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_25_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_25_QUELLIDMAP25_FIELD;
#define EPN_QUEUE_LLID_MAP_25_QUELLIDMAP25_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_25_QUELLIDMAP25_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_25_QUELLIDMAP25_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_26_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_26_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_26_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_26_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_26_QUELLIDMAP26_FIELD;
#define EPN_QUEUE_LLID_MAP_26_QUELLIDMAP26_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_26_QUELLIDMAP26_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_26_QUELLIDMAP26_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_27_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_27_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_27_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_27_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_27_QUELLIDMAP27_FIELD;
#define EPN_QUEUE_LLID_MAP_27_QUELLIDMAP27_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_27_QUELLIDMAP27_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_27_QUELLIDMAP27_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_28_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_28_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_28_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_28_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_28_QUELLIDMAP28_FIELD;
#define EPN_QUEUE_LLID_MAP_28_QUELLIDMAP28_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_28_QUELLIDMAP28_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_28_QUELLIDMAP28_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_29_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_29_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_29_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_29_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_29_QUELLIDMAP29_FIELD;
#define EPN_QUEUE_LLID_MAP_29_QUELLIDMAP29_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_29_QUELLIDMAP29_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_29_QUELLIDMAP29_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_30_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_30_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_30_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_30_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_30_QUELLIDMAP30_FIELD;
#define EPN_QUEUE_LLID_MAP_30_QUELLIDMAP30_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_30_QUELLIDMAP30_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_30_QUELLIDMAP30_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP_31_RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP_31_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPN_QUEUE_LLID_MAP_31_RESERVED0_FIELD_WIDTH 27
#define EPN_QUEUE_LLID_MAP_31_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPN_QUEUE_LLID_MAP_31_QUELLIDMAP31_FIELD;
#define EPN_QUEUE_LLID_MAP_31_QUELLIDMAP31_FIELD_MASK  0x000000000000001f
#define EPN_QUEUE_LLID_MAP_31_QUELLIDMAP31_FIELD_WIDTH 5
#define EPN_QUEUE_LLID_MAP_31_QUELLIDMAP31_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT8_UNUSEDTQCNT8_FIELD;
#define EPN_UNUSED_TQ_CNT8_UNUSEDTQCNT8_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT8_UNUSEDTQCNT8_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT8_UNUSEDTQCNT8_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT9_UNUSEDTQCNT9_FIELD;
#define EPN_UNUSED_TQ_CNT9_UNUSEDTQCNT9_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT9_UNUSEDTQCNT9_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT9_UNUSEDTQCNT9_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT10_UNUSEDTQCNT10_FIELD;
#define EPN_UNUSED_TQ_CNT10_UNUSEDTQCNT10_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT10_UNUSEDTQCNT10_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT10_UNUSEDTQCNT10_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT11_UNUSEDTQCNT11_FIELD;
#define EPN_UNUSED_TQ_CNT11_UNUSEDTQCNT11_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT11_UNUSEDTQCNT11_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT11_UNUSEDTQCNT11_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT12_UNUSEDTQCNT12_FIELD;
#define EPN_UNUSED_TQ_CNT12_UNUSEDTQCNT12_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT12_UNUSEDTQCNT12_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT12_UNUSEDTQCNT12_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT13_UNUSEDTQCNT13_FIELD;
#define EPN_UNUSED_TQ_CNT13_UNUSEDTQCNT13_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT13_UNUSEDTQCNT13_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT13_UNUSEDTQCNT13_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT14_UNUSEDTQCNT14_FIELD;
#define EPN_UNUSED_TQ_CNT14_UNUSEDTQCNT14_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT14_UNUSEDTQCNT14_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT14_UNUSEDTQCNT14_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT15_UNUSEDTQCNT15_FIELD;
#define EPN_UNUSED_TQ_CNT15_UNUSEDTQCNT15_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT15_UNUSEDTQCNT15_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT15_UNUSEDTQCNT15_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT16_UNUSEDTQCNT16_FIELD;
#define EPN_UNUSED_TQ_CNT16_UNUSEDTQCNT16_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT16_UNUSEDTQCNT16_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT16_UNUSEDTQCNT16_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT17_UNUSEDTQCNT17_FIELD;
#define EPN_UNUSED_TQ_CNT17_UNUSEDTQCNT17_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT17_UNUSEDTQCNT17_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT17_UNUSEDTQCNT17_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT18_UNUSEDTQCNT18_FIELD;
#define EPN_UNUSED_TQ_CNT18_UNUSEDTQCNT18_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT18_UNUSEDTQCNT18_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT18_UNUSEDTQCNT18_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT19_UNUSEDTQCNT19_FIELD;
#define EPN_UNUSED_TQ_CNT19_UNUSEDTQCNT19_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT19_UNUSEDTQCNT19_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT19_UNUSEDTQCNT19_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT20_UNUSEDTQCNT20_FIELD;
#define EPN_UNUSED_TQ_CNT20_UNUSEDTQCNT20_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT20_UNUSEDTQCNT20_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT20_UNUSEDTQCNT20_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT21_UNUSEDTQCNT21_FIELD;
#define EPN_UNUSED_TQ_CNT21_UNUSEDTQCNT21_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT21_UNUSEDTQCNT21_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT21_UNUSEDTQCNT21_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT22_UNUSEDTQCNT22_FIELD;
#define EPN_UNUSED_TQ_CNT22_UNUSEDTQCNT22_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT22_UNUSEDTQCNT22_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT22_UNUSEDTQCNT22_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT23_UNUSEDTQCNT23_FIELD;
#define EPN_UNUSED_TQ_CNT23_UNUSEDTQCNT23_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT23_UNUSEDTQCNT23_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT23_UNUSEDTQCNT23_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT24_UNUSEDTQCNT24_FIELD;
#define EPN_UNUSED_TQ_CNT24_UNUSEDTQCNT24_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT24_UNUSEDTQCNT24_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT24_UNUSEDTQCNT24_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT25_UNUSEDTQCNT25_FIELD;
#define EPN_UNUSED_TQ_CNT25_UNUSEDTQCNT25_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT25_UNUSEDTQCNT25_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT25_UNUSEDTQCNT25_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT26_UNUSEDTQCNT26_FIELD;
#define EPN_UNUSED_TQ_CNT26_UNUSEDTQCNT26_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT26_UNUSEDTQCNT26_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT26_UNUSEDTQCNT26_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT27_UNUSEDTQCNT27_FIELD;
#define EPN_UNUSED_TQ_CNT27_UNUSEDTQCNT27_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT27_UNUSEDTQCNT27_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT27_UNUSEDTQCNT27_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT28_UNUSEDTQCNT28_FIELD;
#define EPN_UNUSED_TQ_CNT28_UNUSEDTQCNT28_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT28_UNUSEDTQCNT28_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT28_UNUSEDTQCNT28_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT29_UNUSEDTQCNT29_FIELD;
#define EPN_UNUSED_TQ_CNT29_UNUSEDTQCNT29_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT29_UNUSEDTQCNT29_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT29_UNUSEDTQCNT29_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT30_UNUSEDTQCNT30_FIELD;
#define EPN_UNUSED_TQ_CNT30_UNUSEDTQCNT30_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT30_UNUSEDTQCNT30_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT30_UNUSEDTQCNT30_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT31_UNUSEDTQCNT31_FIELD;
#define EPN_UNUSED_TQ_CNT31_UNUSEDTQCNT31_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT31_UNUSEDTQCNT31_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT31_UNUSEDTQCNT31_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_8_CFGSHPMASK8_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_8_CFGSHPMASK8_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_8_CFGSHPMASK8_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_8_CFGSHPMASK8_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_9_CFGSHPMASK9_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_9_CFGSHPMASK9_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_9_CFGSHPMASK9_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_9_CFGSHPMASK9_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_10_CFGSHPMASK10_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_10_CFGSHPMASK10_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_10_CFGSHPMASK10_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_10_CFGSHPMASK10_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_11_CFGSHPMASK11_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_11_CFGSHPMASK11_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_11_CFGSHPMASK11_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_11_CFGSHPMASK11_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_12_CFGSHPMASK12_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_12_CFGSHPMASK12_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_12_CFGSHPMASK12_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_12_CFGSHPMASK12_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_13_CFGSHPMASK13_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_13_CFGSHPMASK13_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_13_CFGSHPMASK13_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_13_CFGSHPMASK13_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_14_CFGSHPMASK14_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_14_CFGSHPMASK14_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_14_CFGSHPMASK14_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_14_CFGSHPMASK14_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_15_CFGSHPMASK15_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_15_CFGSHPMASK15_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_15_CFGSHPMASK15_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_15_CFGSHPMASK15_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_16_CFGSHPMASK16_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_16_CFGSHPMASK16_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_16_CFGSHPMASK16_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_16_CFGSHPMASK16_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_17_CFGSHPMASK17_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_17_CFGSHPMASK17_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_17_CFGSHPMASK17_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_17_CFGSHPMASK17_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_18_CFGSHPMASK18_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_18_CFGSHPMASK18_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_18_CFGSHPMASK18_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_18_CFGSHPMASK18_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_19_CFGSHPMASK19_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_19_CFGSHPMASK19_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_19_CFGSHPMASK19_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_19_CFGSHPMASK19_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_20_CFGSHPMASK20_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_20_CFGSHPMASK20_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_20_CFGSHPMASK20_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_20_CFGSHPMASK20_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_21_CFGSHPMASK21_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_21_CFGSHPMASK21_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_21_CFGSHPMASK21_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_21_CFGSHPMASK21_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_22_CFGSHPMASK22_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_22_CFGSHPMASK22_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_22_CFGSHPMASK22_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_22_CFGSHPMASK22_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_23_CFGSHPMASK23_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_23_CFGSHPMASK23_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_23_CFGSHPMASK23_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_23_CFGSHPMASK23_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_24_CFGSHPMASK24_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_24_CFGSHPMASK24_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_24_CFGSHPMASK24_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_24_CFGSHPMASK24_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_25_CFGSHPMASK25_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_25_CFGSHPMASK25_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_25_CFGSHPMASK25_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_25_CFGSHPMASK25_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_26_CFGSHPMASK26_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_26_CFGSHPMASK26_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_26_CFGSHPMASK26_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_26_CFGSHPMASK26_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_27_CFGSHPMASK27_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_27_CFGSHPMASK27_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_27_CFGSHPMASK27_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_27_CFGSHPMASK27_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_28_CFGSHPMASK28_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_28_CFGSHPMASK28_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_28_CFGSHPMASK28_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_28_CFGSHPMASK28_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_29_CFGSHPMASK29_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_29_CFGSHPMASK29_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_29_CFGSHPMASK29_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_29_CFGSHPMASK29_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_30_CFGSHPMASK30_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_30_CFGSHPMASK30_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_30_CFGSHPMASK30_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_30_CFGSHPMASK30_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK_31_CFGSHPMASK31_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK_31_CFGSHPMASK31_FIELD_MASK  0x00000000ffffffff
#define EPN_TX_L1S_SHP_QUE_MASK_31_CFGSHPMASK31_FIELD_WIDTH 32
#define EPN_TX_L1S_SHP_QUE_MASK_31_CFGSHPMASK31_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_8_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_8_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_8_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_8_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUEEND8_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUEEND8_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUEEND8_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUEEND8_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_8_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_8_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_8_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_8_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUESTART8_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUESTART8_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUESTART8_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_8_CFGL2SQUESTART8_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_9_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_9_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_9_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_9_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUEEND9_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUEEND9_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUEEND9_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUEEND9_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_9_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_9_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_9_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_9_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUESTART9_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUESTART9_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUESTART9_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_9_CFGL2SQUESTART9_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_10_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_10_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_10_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_10_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUEEND10_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUEEND10_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUEEND10_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUEEND10_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_10_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_10_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_10_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_10_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUESTART10_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUESTART10_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUESTART10_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_10_CFGL2SQUESTART10_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_11_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_11_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_11_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_11_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUEEND11_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUEEND11_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUEEND11_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUEEND11_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_11_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_11_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_11_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_11_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUESTART11_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUESTART11_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUESTART11_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_11_CFGL2SQUESTART11_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_12_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_12_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_12_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_12_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUEEND12_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUEEND12_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUEEND12_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUEEND12_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_12_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_12_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_12_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_12_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUESTART12_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUESTART12_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUESTART12_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_12_CFGL2SQUESTART12_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_13_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_13_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_13_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_13_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUEEND13_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUEEND13_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUEEND13_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUEEND13_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_13_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_13_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_13_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_13_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUESTART13_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUESTART13_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUESTART13_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_13_CFGL2SQUESTART13_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_14_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_14_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_14_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_14_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUEEND14_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUEEND14_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUEEND14_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUEEND14_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_14_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_14_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_14_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_14_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUESTART14_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUESTART14_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUESTART14_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_14_CFGL2SQUESTART14_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_15_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_15_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_15_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_15_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUEEND15_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUEEND15_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUEEND15_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUEEND15_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_15_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_15_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_15_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_15_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUESTART15_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUESTART15_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUESTART15_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_15_CFGL2SQUESTART15_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_16_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_16_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_16_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_16_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUEEND16_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUEEND16_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUEEND16_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUEEND16_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_16_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_16_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_16_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_16_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUESTART16_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUESTART16_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUESTART16_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_16_CFGL2SQUESTART16_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_17_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_17_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_17_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_17_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUEEND17_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUEEND17_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUEEND17_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUEEND17_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_17_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_17_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_17_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_17_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUESTART17_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUESTART17_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUESTART17_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_17_CFGL2SQUESTART17_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_18_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_18_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_18_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_18_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUEEND18_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUEEND18_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUEEND18_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUEEND18_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_18_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_18_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_18_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_18_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUESTART18_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUESTART18_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUESTART18_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_18_CFGL2SQUESTART18_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_19_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_19_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_19_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_19_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUEEND19_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUEEND19_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUEEND19_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUEEND19_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_19_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_19_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_19_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_19_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUESTART19_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUESTART19_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUESTART19_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_19_CFGL2SQUESTART19_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_20_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_20_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_20_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_20_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUEEND20_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUEEND20_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUEEND20_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUEEND20_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_20_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_20_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_20_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_20_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUESTART20_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUESTART20_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUESTART20_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_20_CFGL2SQUESTART20_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_21_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_21_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_21_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_21_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUEEND21_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUEEND21_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUEEND21_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUEEND21_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_21_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_21_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_21_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_21_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUESTART21_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUESTART21_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUESTART21_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_21_CFGL2SQUESTART21_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_22_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_22_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_22_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_22_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUEEND22_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUEEND22_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUEEND22_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUEEND22_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_22_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_22_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_22_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_22_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUESTART22_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUESTART22_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUESTART22_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_22_CFGL2SQUESTART22_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_23_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_23_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_23_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_23_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUEEND23_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUEEND23_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUEEND23_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUEEND23_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_23_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_23_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_23_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_23_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUESTART23_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUESTART23_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUESTART23_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_23_CFGL2SQUESTART23_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_24_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_24_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_24_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_24_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUEEND24_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUEEND24_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUEEND24_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUEEND24_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_24_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_24_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_24_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_24_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUESTART24_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUESTART24_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUESTART24_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_24_CFGL2SQUESTART24_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_25_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_25_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_25_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_25_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUEEND25_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUEEND25_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUEEND25_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUEEND25_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_25_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_25_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_25_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_25_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUESTART25_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUESTART25_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUESTART25_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_25_CFGL2SQUESTART25_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_26_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_26_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_26_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_26_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUEEND26_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUEEND26_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUEEND26_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUEEND26_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_26_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_26_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_26_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_26_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUESTART26_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUESTART26_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUESTART26_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_26_CFGL2SQUESTART26_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_27_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_27_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_27_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_27_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUEEND27_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUEEND27_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUEEND27_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUEEND27_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_27_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_27_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_27_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_27_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUESTART27_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUESTART27_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUESTART27_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_27_CFGL2SQUESTART27_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_28_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_28_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_28_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_28_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUEEND28_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUEEND28_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUEEND28_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUEEND28_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_28_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_28_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_28_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_28_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUESTART28_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUESTART28_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUESTART28_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_28_CFGL2SQUESTART28_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_29_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_29_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_29_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_29_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUEEND29_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUEEND29_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUEEND29_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUEEND29_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_29_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_29_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_29_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_29_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUESTART29_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUESTART29_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUESTART29_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_29_CFGL2SQUESTART29_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_30_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_30_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_30_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_30_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUEEND30_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUEEND30_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUEEND30_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUEEND30_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_30_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_30_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_30_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_30_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUESTART30_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUESTART30_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUESTART30_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_30_CFGL2SQUESTART30_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_31_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_31_RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG_31_RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_31_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUEEND31_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUEEND31_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUEEND31_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUEEND31_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_31_RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_31_RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG_31_RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG_31_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUESTART31_FIELD;
#define EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUESTART31_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUESTART31_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG_31_CFGL2SQUESTART31_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_8_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_8_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_8_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_8_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_8_PRVBURSTLIMIT8_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_8_PRVBURSTLIMIT8_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_8_PRVBURSTLIMIT8_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_8_PRVBURSTLIMIT8_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_9_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_9_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_9_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_9_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_9_PRVBURSTLIMIT9_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_9_PRVBURSTLIMIT9_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_9_PRVBURSTLIMIT9_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_9_PRVBURSTLIMIT9_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_10_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_10_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_10_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_10_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_10_PRVBURSTLIMIT10_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_10_PRVBURSTLIMIT10_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_10_PRVBURSTLIMIT10_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_10_PRVBURSTLIMIT10_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_11_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_11_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_11_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_11_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_11_PRVBURSTLIMIT11_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_11_PRVBURSTLIMIT11_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_11_PRVBURSTLIMIT11_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_11_PRVBURSTLIMIT11_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_12_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_12_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_12_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_12_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_12_PRVBURSTLIMIT12_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_12_PRVBURSTLIMIT12_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_12_PRVBURSTLIMIT12_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_12_PRVBURSTLIMIT12_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_13_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_13_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_13_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_13_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_13_PRVBURSTLIMIT13_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_13_PRVBURSTLIMIT13_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_13_PRVBURSTLIMIT13_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_13_PRVBURSTLIMIT13_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_14_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_14_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_14_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_14_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_14_PRVBURSTLIMIT14_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_14_PRVBURSTLIMIT14_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_14_PRVBURSTLIMIT14_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_14_PRVBURSTLIMIT14_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_15_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_15_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_15_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_15_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_15_PRVBURSTLIMIT15_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_15_PRVBURSTLIMIT15_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_15_PRVBURSTLIMIT15_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_15_PRVBURSTLIMIT15_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_16_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_16_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_16_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_16_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_16_PRVBURSTLIMIT16_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_16_PRVBURSTLIMIT16_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_16_PRVBURSTLIMIT16_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_16_PRVBURSTLIMIT16_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_17_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_17_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_17_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_17_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_17_PRVBURSTLIMIT17_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_17_PRVBURSTLIMIT17_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_17_PRVBURSTLIMIT17_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_17_PRVBURSTLIMIT17_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_18_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_18_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_18_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_18_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_18_PRVBURSTLIMIT18_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_18_PRVBURSTLIMIT18_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_18_PRVBURSTLIMIT18_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_18_PRVBURSTLIMIT18_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_19_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_19_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_19_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_19_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_19_PRVBURSTLIMIT19_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_19_PRVBURSTLIMIT19_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_19_PRVBURSTLIMIT19_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_19_PRVBURSTLIMIT19_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_20_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_20_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_20_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_20_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_20_PRVBURSTLIMIT20_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_20_PRVBURSTLIMIT20_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_20_PRVBURSTLIMIT20_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_20_PRVBURSTLIMIT20_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_21_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_21_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_21_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_21_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_21_PRVBURSTLIMIT21_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_21_PRVBURSTLIMIT21_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_21_PRVBURSTLIMIT21_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_21_PRVBURSTLIMIT21_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_22_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_22_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_22_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_22_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_22_PRVBURSTLIMIT22_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_22_PRVBURSTLIMIT22_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_22_PRVBURSTLIMIT22_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_22_PRVBURSTLIMIT22_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_23_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_23_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_23_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_23_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_23_PRVBURSTLIMIT23_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_23_PRVBURSTLIMIT23_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_23_PRVBURSTLIMIT23_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_23_PRVBURSTLIMIT23_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_24_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_24_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_24_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_24_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_24_PRVBURSTLIMIT24_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_24_PRVBURSTLIMIT24_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_24_PRVBURSTLIMIT24_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_24_PRVBURSTLIMIT24_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_25_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_25_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_25_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_25_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_25_PRVBURSTLIMIT25_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_25_PRVBURSTLIMIT25_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_25_PRVBURSTLIMIT25_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_25_PRVBURSTLIMIT25_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_26_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_26_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_26_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_26_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_26_PRVBURSTLIMIT26_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_26_PRVBURSTLIMIT26_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_26_PRVBURSTLIMIT26_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_26_PRVBURSTLIMIT26_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_27_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_27_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_27_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_27_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_27_PRVBURSTLIMIT27_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_27_PRVBURSTLIMIT27_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_27_PRVBURSTLIMIT27_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_27_PRVBURSTLIMIT27_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_28_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_28_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_28_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_28_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_28_PRVBURSTLIMIT28_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_28_PRVBURSTLIMIT28_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_28_PRVBURSTLIMIT28_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_28_PRVBURSTLIMIT28_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_29_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_29_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_29_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_29_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_29_PRVBURSTLIMIT29_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_29_PRVBURSTLIMIT29_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_29_PRVBURSTLIMIT29_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_29_PRVBURSTLIMIT29_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_30_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_30_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_30_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_30_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_30_PRVBURSTLIMIT30_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_30_PRVBURSTLIMIT30_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_30_PRVBURSTLIMIT30_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_30_PRVBURSTLIMIT30_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_31_RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_31_RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT_31_RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT_31_RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT_31_PRVBURSTLIMIT31_FIELD;
#define EPN_TX_CTC_BURST_LIMIT_31_PRVBURSTLIMIT31_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT_31_PRVBURSTLIMIT31_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT_31_PRVBURSTLIMIT31_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_2_FIELD;
#define EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_1_FIELD;
#define EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE0_CFGADDBURSTCAP0_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE1_CFGADDBURSTCAP1_1_FIELD;
#define EPN_10G_ABC_SIZE1_CFGADDBURSTCAP1_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE1_CFGADDBURSTCAP1_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE1_CFGADDBURSTCAP1_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE1_CFGADDBURSTCAP0_3_FIELD;
#define EPN_10G_ABC_SIZE1_CFGADDBURSTCAP0_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE1_CFGADDBURSTCAP0_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE1_CFGADDBURSTCAP0_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_3_FIELD;
#define EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_2_FIELD;
#define EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE2_CFGADDBURSTCAP1_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_2_FIELD;
#define EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_1_FIELD;
#define EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE3_CFGADDBURSTCAP2_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE4_CFGADDBURSTCAP3_1_FIELD;
#define EPN_10G_ABC_SIZE4_CFGADDBURSTCAP3_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE4_CFGADDBURSTCAP3_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE4_CFGADDBURSTCAP3_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE4_CFGADDBURSTCAP2_3_FIELD;
#define EPN_10G_ABC_SIZE4_CFGADDBURSTCAP2_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE4_CFGADDBURSTCAP2_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE4_CFGADDBURSTCAP2_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_3_FIELD;
#define EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_2_FIELD;
#define EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE5_CFGADDBURSTCAP3_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_2_FIELD;
#define EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_1_FIELD;
#define EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE6_CFGADDBURSTCAP4_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE7_CFGADDBURSTCAP5_1_FIELD;
#define EPN_10G_ABC_SIZE7_CFGADDBURSTCAP5_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE7_CFGADDBURSTCAP5_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE7_CFGADDBURSTCAP5_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE7_CFGADDBURSTCAP4_3_FIELD;
#define EPN_10G_ABC_SIZE7_CFGADDBURSTCAP4_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE7_CFGADDBURSTCAP4_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE7_CFGADDBURSTCAP4_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_3_FIELD;
#define EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_2_FIELD;
#define EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE8_CFGADDBURSTCAP5_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_2_FIELD;
#define EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_1_FIELD;
#define EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE9_CFGADDBURSTCAP6_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE10_CFGADDBURSTCAP7_1_FIELD;
#define EPN_10G_ABC_SIZE10_CFGADDBURSTCAP7_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE10_CFGADDBURSTCAP7_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE10_CFGADDBURSTCAP7_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE10_CFGADDBURSTCAP6_3_FIELD;
#define EPN_10G_ABC_SIZE10_CFGADDBURSTCAP6_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE10_CFGADDBURSTCAP6_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE10_CFGADDBURSTCAP6_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_3_FIELD;
#define EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_2_FIELD;
#define EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE11_CFGADDBURSTCAP7_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_2_FIELD;
#define EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_1_FIELD;
#define EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE12_CFGADDBURSTCAP8_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE13_CFGADDBURSTCAP9_1_FIELD;
#define EPN_10G_ABC_SIZE13_CFGADDBURSTCAP9_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE13_CFGADDBURSTCAP9_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE13_CFGADDBURSTCAP9_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE13_CFGADDBURSTCAP8_3_FIELD;
#define EPN_10G_ABC_SIZE13_CFGADDBURSTCAP8_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE13_CFGADDBURSTCAP8_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE13_CFGADDBURSTCAP8_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_3_FIELD;
#define EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_2_FIELD;
#define EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE14_CFGADDBURSTCAP9_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_2_FIELD;
#define EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_1_FIELD;
#define EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE15_CFGADDBURSTCAP10_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE16_CFGADDBURSTCAP11_1_FIELD;
#define EPN_10G_ABC_SIZE16_CFGADDBURSTCAP11_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE16_CFGADDBURSTCAP11_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE16_CFGADDBURSTCAP11_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE16_CFGADDBURSTCAP10_3_FIELD;
#define EPN_10G_ABC_SIZE16_CFGADDBURSTCAP10_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE16_CFGADDBURSTCAP10_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE16_CFGADDBURSTCAP10_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_3_FIELD;
#define EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_2_FIELD;
#define EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE17_CFGADDBURSTCAP11_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_2_FIELD;
#define EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_1_FIELD;
#define EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE18_CFGADDBURSTCAP12_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE19_CFGADDBURSTCAP13_1_FIELD;
#define EPN_10G_ABC_SIZE19_CFGADDBURSTCAP13_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE19_CFGADDBURSTCAP13_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE19_CFGADDBURSTCAP13_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE19_CFGADDBURSTCAP12_3_FIELD;
#define EPN_10G_ABC_SIZE19_CFGADDBURSTCAP12_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE19_CFGADDBURSTCAP12_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE19_CFGADDBURSTCAP12_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_3_FIELD;
#define EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_2_FIELD;
#define EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE20_CFGADDBURSTCAP13_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_2_FIELD;
#define EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_1_FIELD;
#define EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE21_CFGADDBURSTCAP14_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE22_CFGADDBURSTCAP15_1_FIELD;
#define EPN_10G_ABC_SIZE22_CFGADDBURSTCAP15_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE22_CFGADDBURSTCAP15_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE22_CFGADDBURSTCAP15_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE22_CFGADDBURSTCAP14_3_FIELD;
#define EPN_10G_ABC_SIZE22_CFGADDBURSTCAP14_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE22_CFGADDBURSTCAP14_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE22_CFGADDBURSTCAP14_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_3_FIELD;
#define EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_2_FIELD;
#define EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE23_CFGADDBURSTCAP15_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_2_FIELD;
#define EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_1_FIELD;
#define EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE24_CFGADDBURSTCAP16_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE25_CFGADDBURSTCAP17_1_FIELD;
#define EPN_10G_ABC_SIZE25_CFGADDBURSTCAP17_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE25_CFGADDBURSTCAP17_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE25_CFGADDBURSTCAP17_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE25_CFGADDBURSTCAP16_3_FIELD;
#define EPN_10G_ABC_SIZE25_CFGADDBURSTCAP16_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE25_CFGADDBURSTCAP16_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE25_CFGADDBURSTCAP16_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_3_FIELD;
#define EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_2_FIELD;
#define EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE26_CFGADDBURSTCAP17_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_2_FIELD;
#define EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_1_FIELD;
#define EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE27_CFGADDBURSTCAP18_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE28_CFGADDBURSTCAP19_1_FIELD;
#define EPN_10G_ABC_SIZE28_CFGADDBURSTCAP19_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE28_CFGADDBURSTCAP19_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE28_CFGADDBURSTCAP19_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE28_CFGADDBURSTCAP18_3_FIELD;
#define EPN_10G_ABC_SIZE28_CFGADDBURSTCAP18_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE28_CFGADDBURSTCAP18_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE28_CFGADDBURSTCAP18_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_3_FIELD;
#define EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_2_FIELD;
#define EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE29_CFGADDBURSTCAP19_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_2_FIELD;
#define EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_1_FIELD;
#define EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE30_CFGADDBURSTCAP20_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE31_CFGADDBURSTCAP21_1_FIELD;
#define EPN_10G_ABC_SIZE31_CFGADDBURSTCAP21_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE31_CFGADDBURSTCAP21_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE31_CFGADDBURSTCAP21_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE31_CFGADDBURSTCAP20_3_FIELD;
#define EPN_10G_ABC_SIZE31_CFGADDBURSTCAP20_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE31_CFGADDBURSTCAP20_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE31_CFGADDBURSTCAP20_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_3_FIELD;
#define EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_2_FIELD;
#define EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE32_CFGADDBURSTCAP21_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_2_FIELD;
#define EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_1_FIELD;
#define EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE33_CFGADDBURSTCAP22_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE34_CFGADDBURSTCAP23_1_FIELD;
#define EPN_10G_ABC_SIZE34_CFGADDBURSTCAP23_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE34_CFGADDBURSTCAP23_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE34_CFGADDBURSTCAP23_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE34_CFGADDBURSTCAP22_3_FIELD;
#define EPN_10G_ABC_SIZE34_CFGADDBURSTCAP22_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE34_CFGADDBURSTCAP22_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE34_CFGADDBURSTCAP22_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_3_FIELD;
#define EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_2_FIELD;
#define EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE35_CFGADDBURSTCAP23_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_2_FIELD;
#define EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_1_FIELD;
#define EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE36_CFGADDBURSTCAP24_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE37_CFGADDBURSTCAP25_1_FIELD;
#define EPN_10G_ABC_SIZE37_CFGADDBURSTCAP25_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE37_CFGADDBURSTCAP25_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE37_CFGADDBURSTCAP25_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE37_CFGADDBURSTCAP24_3_FIELD;
#define EPN_10G_ABC_SIZE37_CFGADDBURSTCAP24_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE37_CFGADDBURSTCAP24_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE37_CFGADDBURSTCAP24_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_3_FIELD;
#define EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_2_FIELD;
#define EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE38_CFGADDBURSTCAP25_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_2_FIELD;
#define EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_1_FIELD;
#define EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE39_CFGADDBURSTCAP26_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE40_CFGADDBURSTCAP27_1_FIELD;
#define EPN_10G_ABC_SIZE40_CFGADDBURSTCAP27_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE40_CFGADDBURSTCAP27_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE40_CFGADDBURSTCAP27_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE40_CFGADDBURSTCAP26_3_FIELD;
#define EPN_10G_ABC_SIZE40_CFGADDBURSTCAP26_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE40_CFGADDBURSTCAP26_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE40_CFGADDBURSTCAP26_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_3_FIELD;
#define EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_2_FIELD;
#define EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE41_CFGADDBURSTCAP27_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_2_FIELD;
#define EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_1_FIELD;
#define EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE42_CFGADDBURSTCAP28_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE43_CFGADDBURSTCAP29_1_FIELD;
#define EPN_10G_ABC_SIZE43_CFGADDBURSTCAP29_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE43_CFGADDBURSTCAP29_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE43_CFGADDBURSTCAP29_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE43_CFGADDBURSTCAP28_3_FIELD;
#define EPN_10G_ABC_SIZE43_CFGADDBURSTCAP28_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE43_CFGADDBURSTCAP28_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE43_CFGADDBURSTCAP28_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_3_FIELD;
#define EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_2_FIELD;
#define EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE44_CFGADDBURSTCAP29_2_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_2_FIELD;
#define EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_2_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_2_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_1_FIELD;
#define EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_1_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE45_CFGADDBURSTCAP30_1_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE46_CFGADDBURSTCAP31_1_FIELD;
#define EPN_10G_ABC_SIZE46_CFGADDBURSTCAP31_1_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE46_CFGADDBURSTCAP31_1_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE46_CFGADDBURSTCAP31_1_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE46_CFGADDBURSTCAP30_3_FIELD;
#define EPN_10G_ABC_SIZE46_CFGADDBURSTCAP30_3_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE46_CFGADDBURSTCAP30_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE46_CFGADDBURSTCAP30_3_FIELD_SHIFT 0

extern const ru_field_rec EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_3_FIELD;
#define EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_3_FIELD_MASK  0x00000000ffff0000
#define EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_3_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_3_FIELD_SHIFT 16

extern const ru_field_rec EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_2_FIELD;
#define EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_2_FIELD_MASK  0x000000000000ffff
#define EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_2_FIELD_WIDTH 16
#define EPN_10G_ABC_SIZE47_CFGADDBURSTCAP31_2_FIELD_SHIFT 0

extern const ru_field_rec LIF_PON_CONTROL_RESERVED0_FIELD;
#define LIF_PON_CONTROL_RESERVED0_FIELD_MASK  0x00000000c0000000
#define LIF_PON_CONTROL_RESERVED0_FIELD_WIDTH 2
#define LIF_PON_CONTROL_RESERVED0_FIELD_SHIFT 30

extern const ru_field_rec LIF_PON_CONTROL_CFGDISRUNTFILTER_FIELD;
#define LIF_PON_CONTROL_CFGDISRUNTFILTER_FIELD_MASK  0x0000000020000000
#define LIF_PON_CONTROL_CFGDISRUNTFILTER_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFGDISRUNTFILTER_FIELD_SHIFT 29

extern const ru_field_rec LIF_PON_CONTROL_CFMAXCOMMAERRCNT_FIELD;
#define LIF_PON_CONTROL_CFMAXCOMMAERRCNT_FIELD_MASK  0x000000001e000000
#define LIF_PON_CONTROL_CFMAXCOMMAERRCNT_FIELD_WIDTH 4
#define LIF_PON_CONTROL_CFMAXCOMMAERRCNT_FIELD_SHIFT 25

extern const ru_field_rec LIF_PON_CONTROL_CFSYNCSMSELECT_FIELD;
#define LIF_PON_CONTROL_CFSYNCSMSELECT_FIELD_MASK  0x0000000001800000
#define LIF_PON_CONTROL_CFSYNCSMSELECT_FIELD_WIDTH 2
#define LIF_PON_CONTROL_CFSYNCSMSELECT_FIELD_SHIFT 23

extern const ru_field_rec LIF_PON_CONTROL_CFPONRXFORCENONFECABORT_FIELD;
#define LIF_PON_CONTROL_CFPONRXFORCENONFECABORT_FIELD_MASK  0x0000000000400000
#define LIF_PON_CONTROL_CFPONRXFORCENONFECABORT_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFPONRXFORCENONFECABORT_FIELD_SHIFT 22

extern const ru_field_rec LIF_PON_CONTROL_CFPONRXFORCEFECABORT_FIELD;
#define LIF_PON_CONTROL_CFPONRXFORCEFECABORT_FIELD_MASK  0x0000000000200000
#define LIF_PON_CONTROL_CFPONRXFORCEFECABORT_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFPONRXFORCEFECABORT_FIELD_SHIFT 21

extern const ru_field_rec LIF_PON_CONTROL_CFGRXDATABITFLIP_FIELD;
#define LIF_PON_CONTROL_CFGRXDATABITFLIP_FIELD_MASK  0x0000000000100000
#define LIF_PON_CONTROL_CFGRXDATABITFLIP_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFGRXDATABITFLIP_FIELD_SHIFT 20

extern const ru_field_rec LIF_PON_CONTROL_RESERVED1_FIELD;
#define LIF_PON_CONTROL_RESERVED1_FIELD_MASK  0x0000000000080000
#define LIF_PON_CONTROL_RESERVED1_FIELD_WIDTH 1
#define LIF_PON_CONTROL_RESERVED1_FIELD_SHIFT 19

extern const ru_field_rec LIF_PON_CONTROL_CFGENMPCPOAMPAD_FIELD;
#define LIF_PON_CONTROL_CFGENMPCPOAMPAD_FIELD_MASK  0x0000000000040000
#define LIF_PON_CONTROL_CFGENMPCPOAMPAD_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFGENMPCPOAMPAD_FIELD_SHIFT 18

extern const ru_field_rec LIF_PON_CONTROL_CFGENTXIDLEPKT_FIELD;
#define LIF_PON_CONTROL_CFGENTXIDLEPKT_FIELD_MASK  0x0000000000020000
#define LIF_PON_CONTROL_CFGENTXIDLEPKT_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFGENTXIDLEPKT_FIELD_SHIFT 17

extern const ru_field_rec LIF_PON_CONTROL_CFENABLESOFTWARESYNCHOLD_FIELD;
#define LIF_PON_CONTROL_CFENABLESOFTWARESYNCHOLD_FIELD_MASK  0x0000000000010000
#define LIF_PON_CONTROL_CFENABLESOFTWARESYNCHOLD_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFENABLESOFTWARESYNCHOLD_FIELD_SHIFT 16

extern const ru_field_rec LIF_PON_CONTROL_CFENABLEEXTENDSYNC_FIELD;
#define LIF_PON_CONTROL_CFENABLEEXTENDSYNC_FIELD_MASK  0x0000000000008000
#define LIF_PON_CONTROL_CFENABLEEXTENDSYNC_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFENABLEEXTENDSYNC_FIELD_SHIFT 15

extern const ru_field_rec LIF_PON_CONTROL_CFENABLEQUICKSYNC_FIELD;
#define LIF_PON_CONTROL_CFENABLEQUICKSYNC_FIELD_MASK  0x0000000000004000
#define LIF_PON_CONTROL_CFENABLEQUICKSYNC_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFENABLEQUICKSYNC_FIELD_SHIFT 14

extern const ru_field_rec LIF_PON_CONTROL_CFPPSEN_FIELD;
#define LIF_PON_CONTROL_CFPPSEN_FIELD_MASK  0x0000000000002000
#define LIF_PON_CONTROL_CFPPSEN_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFPPSEN_FIELD_SHIFT 13

extern const ru_field_rec LIF_PON_CONTROL_CFPPSCLKRBC_FIELD;
#define LIF_PON_CONTROL_CFPPSCLKRBC_FIELD_MASK  0x0000000000001000
#define LIF_PON_CONTROL_CFPPSCLKRBC_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFPPSCLKRBC_FIELD_SHIFT 12

extern const ru_field_rec LIF_PON_CONTROL_CFRX2TXLPBACK_FIELD;
#define LIF_PON_CONTROL_CFRX2TXLPBACK_FIELD_MASK  0x0000000000000800
#define LIF_PON_CONTROL_CFRX2TXLPBACK_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFRX2TXLPBACK_FIELD_SHIFT 11

extern const ru_field_rec LIF_PON_CONTROL_CFTX2RXLPBACK_FIELD;
#define LIF_PON_CONTROL_CFTX2RXLPBACK_FIELD_MASK  0x0000000000000400
#define LIF_PON_CONTROL_CFTX2RXLPBACK_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFTX2RXLPBACK_FIELD_SHIFT 10

extern const ru_field_rec LIF_PON_CONTROL_CFTXDATAENDURLON_FIELD;
#define LIF_PON_CONTROL_CFTXDATAENDURLON_FIELD_MASK  0x0000000000000200
#define LIF_PON_CONTROL_CFTXDATAENDURLON_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFTXDATAENDURLON_FIELD_SHIFT 9

extern const ru_field_rec LIF_PON_CONTROL_CFP2PMODE_FIELD;
#define LIF_PON_CONTROL_CFP2PMODE_FIELD_MASK  0x0000000000000100
#define LIF_PON_CONTROL_CFP2PMODE_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFP2PMODE_FIELD_SHIFT 8

extern const ru_field_rec LIF_PON_CONTROL_CFP2PSHORTPRE_FIELD;
#define LIF_PON_CONTROL_CFP2PSHORTPRE_FIELD_MASK  0x0000000000000080
#define LIF_PON_CONTROL_CFP2PSHORTPRE_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFP2PSHORTPRE_FIELD_SHIFT 7

extern const ru_field_rec LIF_PON_CONTROL_CFLASEREN_FIELD;
#define LIF_PON_CONTROL_CFLASEREN_FIELD_MASK  0x0000000000000040
#define LIF_PON_CONTROL_CFLASEREN_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFLASEREN_FIELD_SHIFT 6

extern const ru_field_rec LIF_PON_CONTROL_CFTXLASERON_FIELD;
#define LIF_PON_CONTROL_CFTXLASERON_FIELD_MASK  0x0000000000000020
#define LIF_PON_CONTROL_CFTXLASERON_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFTXLASERON_FIELD_SHIFT 5

extern const ru_field_rec LIF_PON_CONTROL_CFTXLASERONACTHI_FIELD;
#define LIF_PON_CONTROL_CFTXLASERONACTHI_FIELD_MASK  0x0000000000000010
#define LIF_PON_CONTROL_CFTXLASERONACTHI_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFTXLASERONACTHI_FIELD_SHIFT 4

extern const ru_field_rec LIF_PON_CONTROL_LIFTXRSTN_PRE_FIELD;
#define LIF_PON_CONTROL_LIFTXRSTN_PRE_FIELD_MASK  0x0000000000000008
#define LIF_PON_CONTROL_LIFTXRSTN_PRE_FIELD_WIDTH 1
#define LIF_PON_CONTROL_LIFTXRSTN_PRE_FIELD_SHIFT 3

extern const ru_field_rec LIF_PON_CONTROL_LIFRXRSTN_PRE_FIELD;
#define LIF_PON_CONTROL_LIFRXRSTN_PRE_FIELD_MASK  0x0000000000000004
#define LIF_PON_CONTROL_LIFRXRSTN_PRE_FIELD_WIDTH 1
#define LIF_PON_CONTROL_LIFRXRSTN_PRE_FIELD_SHIFT 2

extern const ru_field_rec LIF_PON_CONTROL_LIFTXEN_FIELD;
#define LIF_PON_CONTROL_LIFTXEN_FIELD_MASK  0x0000000000000002
#define LIF_PON_CONTROL_LIFTXEN_FIELD_WIDTH 1
#define LIF_PON_CONTROL_LIFTXEN_FIELD_SHIFT 1

extern const ru_field_rec LIF_PON_CONTROL_LIFRXEN_FIELD;
#define LIF_PON_CONTROL_LIFRXEN_FIELD_MASK  0x0000000000000001
#define LIF_PON_CONTROL_LIFRXEN_FIELD_WIDTH 1
#define LIF_PON_CONTROL_LIFRXEN_FIELD_SHIFT 0

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_RESERVED0_FIELD;
#define LIF_PON_INTER_OP_CONTROL_RESERVED0_FIELD_MASK  0x0000000080000000
#define LIF_PON_INTER_OP_CONTROL_RESERVED0_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_RESERVED0_FIELD_SHIFT 31

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFIPGFILTER_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFIPGFILTER_FIELD_MASK  0x0000000078000000
#define LIF_PON_INTER_OP_CONTROL_CFIPGFILTER_FIELD_WIDTH 4
#define LIF_PON_INTER_OP_CONTROL_CFIPGFILTER_FIELD_SHIFT 27

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFDISABLELOSLASERBLOCK_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFDISABLELOSLASERBLOCK_FIELD_MASK  0x0000000004000000
#define LIF_PON_INTER_OP_CONTROL_CFDISABLELOSLASERBLOCK_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFDISABLELOSLASERBLOCK_FIELD_SHIFT 26

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFGLLIDPROMISCUOUSMODE_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDPROMISCUOUSMODE_FIELD_MASK  0x0000000002000000
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDPROMISCUOUSMODE_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDPROMISCUOUSMODE_FIELD_SHIFT 25

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFGLLIDMODMSK_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDMODMSK_FIELD_MASK  0x0000000001000000
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDMODMSK_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDMODMSK_FIELD_SHIFT 24

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFUSEFECIPG_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFUSEFECIPG_FIELD_MASK  0x0000000000800000
#define LIF_PON_INTER_OP_CONTROL_CFUSEFECIPG_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFUSEFECIPG_FIELD_SHIFT 23

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFRXCRC8INVCHK_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8INVCHK_FIELD_MASK  0x0000000000400000
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8INVCHK_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8INVCHK_FIELD_SHIFT 22

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFRXCRC8BITSWAP_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8BITSWAP_FIELD_MASK  0x0000000000200000
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8BITSWAP_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8BITSWAP_FIELD_SHIFT 21

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFRXCRC8MSB2LSB_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8MSB2LSB_FIELD_MASK  0x0000000000100000
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8MSB2LSB_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8MSB2LSB_FIELD_SHIFT 20

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFRXCRC8DISABLE_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8DISABLE_FIELD_MASK  0x0000000000080000
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8DISABLE_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8DISABLE_FIELD_SHIFT 19

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_RESERVED1_FIELD;
#define LIF_PON_INTER_OP_CONTROL_RESERVED1_FIELD_MASK  0x0000000000040000
#define LIF_PON_INTER_OP_CONTROL_RESERVED1_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_RESERVED1_FIELD_SHIFT 18

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXLLIDBIT15SET_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXLLIDBIT15SET_FIELD_MASK  0x0000000000020000
#define LIF_PON_INTER_OP_CONTROL_CFTXLLIDBIT15SET_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXLLIDBIT15SET_FIELD_SHIFT 17

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXCRC8INV_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8INV_FIELD_MASK  0x0000000000010000
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8INV_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8INV_FIELD_SHIFT 16

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXCRC8BAD_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BAD_FIELD_MASK  0x0000000000008000
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BAD_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BAD_FIELD_SHIFT 15

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXCRC8BITSWAP_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BITSWAP_FIELD_MASK  0x0000000000004000
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BITSWAP_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BITSWAP_FIELD_SHIFT 14

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXCRC8MSB2LSB_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8MSB2LSB_FIELD_MASK  0x0000000000002000
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8MSB2LSB_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8MSB2LSB_FIELD_SHIFT 13

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXSHORTPRE_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXSHORTPRE_FIELD_MASK  0x0000000000001000
#define LIF_PON_INTER_OP_CONTROL_CFTXSHORTPRE_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXSHORTPRE_FIELD_SHIFT 12

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXIPGCNT_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXIPGCNT_FIELD_MASK  0x0000000000000f00
#define LIF_PON_INTER_OP_CONTROL_CFTXIPGCNT_FIELD_WIDTH 4
#define LIF_PON_INTER_OP_CONTROL_CFTXIPGCNT_FIELD_SHIFT 8

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXAASYNCLEN_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXAASYNCLEN_FIELD_MASK  0x00000000000000f0
#define LIF_PON_INTER_OP_CONTROL_CFTXAASYNCLEN_FIELD_WIDTH 4
#define LIF_PON_INTER_OP_CONTROL_CFTXAASYNCLEN_FIELD_SHIFT 4

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXPIPEDELAY_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXPIPEDELAY_FIELD_MASK  0x000000000000000f
#define LIF_PON_INTER_OP_CONTROL_CFTXPIPEDELAY_FIELD_WIDTH 4
#define LIF_PON_INTER_OP_CONTROL_CFTXPIPEDELAY_FIELD_SHIFT 0

extern const ru_field_rec LIF_FEC_CONTROL_RESERVED0_FIELD;
#define LIF_FEC_CONTROL_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define LIF_FEC_CONTROL_RESERVED0_FIELD_WIDTH 26
#define LIF_FEC_CONTROL_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec LIF_FEC_CONTROL_CFFECRXERRORPROP_FIELD;
#define LIF_FEC_CONTROL_CFFECRXERRORPROP_FIELD_MASK  0x0000000000000020
#define LIF_FEC_CONTROL_CFFECRXERRORPROP_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECRXERRORPROP_FIELD_SHIFT 5

extern const ru_field_rec LIF_FEC_CONTROL_CFFECRXFORCENONFECABORT_FIELD;
#define LIF_FEC_CONTROL_CFFECRXFORCENONFECABORT_FIELD_MASK  0x0000000000000010
#define LIF_FEC_CONTROL_CFFECRXFORCENONFECABORT_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECRXFORCENONFECABORT_FIELD_SHIFT 4

extern const ru_field_rec LIF_FEC_CONTROL_CFFECRXFORCEFECABORT_FIELD;
#define LIF_FEC_CONTROL_CFFECRXFORCEFECABORT_FIELD_MASK  0x0000000000000008
#define LIF_FEC_CONTROL_CFFECRXFORCEFECABORT_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECRXFORCEFECABORT_FIELD_SHIFT 3

extern const ru_field_rec LIF_FEC_CONTROL_CFFECRXENABLE_FIELD;
#define LIF_FEC_CONTROL_CFFECRXENABLE_FIELD_MASK  0x0000000000000004
#define LIF_FEC_CONTROL_CFFECRXENABLE_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECRXENABLE_FIELD_SHIFT 2

extern const ru_field_rec LIF_FEC_CONTROL_CFFECTXFECPERLLID_FIELD;
#define LIF_FEC_CONTROL_CFFECTXFECPERLLID_FIELD_MASK  0x0000000000000002
#define LIF_FEC_CONTROL_CFFECTXFECPERLLID_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECTXFECPERLLID_FIELD_SHIFT 1

extern const ru_field_rec LIF_FEC_CONTROL_CFFECTXENABLE_FIELD;
#define LIF_FEC_CONTROL_CFFECTXENABLE_FIELD_MASK  0x0000000000000001
#define LIF_FEC_CONTROL_CFFECTXENABLE_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECTXENABLE_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_CONTROL_CFGDISMPCPENCRYPT_FIELD;
#define LIF_SEC_CONTROL_CFGDISMPCPENCRYPT_FIELD_MASK  0x0000000080000000
#define LIF_SEC_CONTROL_CFGDISMPCPENCRYPT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGDISMPCPENCRYPT_FIELD_SHIFT 31

extern const ru_field_rec LIF_SEC_CONTROL_CFGDISOAMENCRYPT_FIELD;
#define LIF_SEC_CONTROL_CFGDISOAMENCRYPT_FIELD_MASK  0x0000000040000000
#define LIF_SEC_CONTROL_CFGDISOAMENCRYPT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGDISOAMENCRYPT_FIELD_SHIFT 30

extern const ru_field_rec LIF_SEC_CONTROL_CFGSECENSHORTLEN_FIELD;
#define LIF_SEC_CONTROL_CFGSECENSHORTLEN_FIELD_MASK  0x0000000020000000
#define LIF_SEC_CONTROL_CFGSECENSHORTLEN_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGSECENSHORTLEN_FIELD_SHIFT 29

extern const ru_field_rec LIF_SEC_CONTROL_RESERVED0_FIELD;
#define LIF_SEC_CONTROL_RESERVED0_FIELD_MASK  0x0000000018000000
#define LIF_SEC_CONTROL_RESERVED0_FIELD_WIDTH 2
#define LIF_SEC_CONTROL_RESERVED0_FIELD_SHIFT 27

extern const ru_field_rec LIF_SEC_CONTROL_CFGENAEREPLAYPRCT_FIELD;
#define LIF_SEC_CONTROL_CFGENAEREPLAYPRCT_FIELD_MASK  0x0000000004000000
#define LIF_SEC_CONTROL_CFGENAEREPLAYPRCT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGENAEREPLAYPRCT_FIELD_SHIFT 26

extern const ru_field_rec LIF_SEC_CONTROL_CFGENLEGACYRCC_FIELD;
#define LIF_SEC_CONTROL_CFGENLEGACYRCC_FIELD_MASK  0x0000000002000000
#define LIF_SEC_CONTROL_CFGENLEGACYRCC_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGENLEGACYRCC_FIELD_SHIFT 25

extern const ru_field_rec LIF_SEC_CONTROL_ENFAKEUPAES_FIELD;
#define LIF_SEC_CONTROL_ENFAKEUPAES_FIELD_MASK  0x0000000001000000
#define LIF_SEC_CONTROL_ENFAKEUPAES_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_ENFAKEUPAES_FIELD_SHIFT 24

extern const ru_field_rec LIF_SEC_CONTROL_ENFAKEDNAES_FIELD;
#define LIF_SEC_CONTROL_ENFAKEDNAES_FIELD_MASK  0x0000000000800000
#define LIF_SEC_CONTROL_ENFAKEDNAES_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_ENFAKEDNAES_FIELD_SHIFT 23

extern const ru_field_rec LIF_SEC_CONTROL_RESERVED1_FIELD;
#define LIF_SEC_CONTROL_RESERVED1_FIELD_MASK  0x0000000000600000
#define LIF_SEC_CONTROL_RESERVED1_FIELD_WIDTH 2
#define LIF_SEC_CONTROL_RESERVED1_FIELD_SHIFT 21

extern const ru_field_rec LIF_SEC_CONTROL_CFGFECIPGLEN_FIELD;
#define LIF_SEC_CONTROL_CFGFECIPGLEN_FIELD_MASK  0x00000000001fe000
#define LIF_SEC_CONTROL_CFGFECIPGLEN_FIELD_WIDTH 8
#define LIF_SEC_CONTROL_CFGFECIPGLEN_FIELD_SHIFT 13

extern const ru_field_rec LIF_SEC_CONTROL_DISDNDASAENCRPT_FIELD;
#define LIF_SEC_CONTROL_DISDNDASAENCRPT_FIELD_MASK  0x0000000000001000
#define LIF_SEC_CONTROL_DISDNDASAENCRPT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_DISDNDASAENCRPT_FIELD_SHIFT 12

extern const ru_field_rec LIF_SEC_CONTROL_ENTRIPLECHURN_FIELD;
#define LIF_SEC_CONTROL_ENTRIPLECHURN_FIELD_MASK  0x0000000000000800
#define LIF_SEC_CONTROL_ENTRIPLECHURN_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_ENTRIPLECHURN_FIELD_SHIFT 11

extern const ru_field_rec LIF_SEC_CONTROL_ENEPNMIXENCRYPT_FIELD;
#define LIF_SEC_CONTROL_ENEPNMIXENCRYPT_FIELD_MASK  0x0000000000000400
#define LIF_SEC_CONTROL_ENEPNMIXENCRYPT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_ENEPNMIXENCRYPT_FIELD_SHIFT 10

extern const ru_field_rec LIF_SEC_CONTROL_DISUPDASAENCRPT_FIELD;
#define LIF_SEC_CONTROL_DISUPDASAENCRPT_FIELD_MASK  0x0000000000000200
#define LIF_SEC_CONTROL_DISUPDASAENCRPT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_DISUPDASAENCRPT_FIELD_SHIFT 9

extern const ru_field_rec LIF_SEC_CONTROL_SECUPENCRYPTSCHEME_FIELD;
#define LIF_SEC_CONTROL_SECUPENCRYPTSCHEME_FIELD_MASK  0x0000000000000180
#define LIF_SEC_CONTROL_SECUPENCRYPTSCHEME_FIELD_WIDTH 2
#define LIF_SEC_CONTROL_SECUPENCRYPTSCHEME_FIELD_SHIFT 7

extern const ru_field_rec LIF_SEC_CONTROL_SECDNENCRYPTSCHEME_FIELD;
#define LIF_SEC_CONTROL_SECDNENCRYPTSCHEME_FIELD_MASK  0x0000000000000070
#define LIF_SEC_CONTROL_SECDNENCRYPTSCHEME_FIELD_WIDTH 3
#define LIF_SEC_CONTROL_SECDNENCRYPTSCHEME_FIELD_SHIFT 4

extern const ru_field_rec LIF_SEC_CONTROL_SECUPRSTN_PRE_FIELD;
#define LIF_SEC_CONTROL_SECUPRSTN_PRE_FIELD_MASK  0x0000000000000008
#define LIF_SEC_CONTROL_SECUPRSTN_PRE_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_SECUPRSTN_PRE_FIELD_SHIFT 3

extern const ru_field_rec LIF_SEC_CONTROL_SECDNRSTN_PRE_FIELD;
#define LIF_SEC_CONTROL_SECDNRSTN_PRE_FIELD_MASK  0x0000000000000004
#define LIF_SEC_CONTROL_SECDNRSTN_PRE_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_SECDNRSTN_PRE_FIELD_SHIFT 2

extern const ru_field_rec LIF_SEC_CONTROL_SECENUP_FIELD;
#define LIF_SEC_CONTROL_SECENUP_FIELD_MASK  0x0000000000000002
#define LIF_SEC_CONTROL_SECENUP_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_SECENUP_FIELD_SHIFT 1

extern const ru_field_rec LIF_SEC_CONTROL_SECENDN_FIELD;
#define LIF_SEC_CONTROL_SECENDN_FIELD_MASK  0x0000000000000001
#define LIF_SEC_CONTROL_SECENDN_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_SECENDN_FIELD_SHIFT 0

extern const ru_field_rec LIF_MACSEC_RESERVED0_FIELD;
#define LIF_MACSEC_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_MACSEC_RESERVED0_FIELD_WIDTH 16
#define LIF_MACSEC_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_MACSEC_CFGMACSECETHERTYPE_FIELD;
#define LIF_MACSEC_CFGMACSECETHERTYPE_FIELD_MASK  0x000000000000ffff
#define LIF_MACSEC_CFGMACSECETHERTYPE_FIELD_WIDTH 16
#define LIF_MACSEC_CFGMACSECETHERTYPE_FIELD_SHIFT 0

extern const ru_field_rec LIF_INT_STATUS_RESERVED0_FIELD;
#define LIF_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffc00000
#define LIF_INT_STATUS_RESERVED0_FIELD_WIDTH 10
#define LIF_INT_STATUS_RESERVED0_FIELD_SHIFT 22

extern const ru_field_rec LIF_INT_STATUS_INT_SOP_SFEC_IPG_VIOLATION_FIELD;
#define LIF_INT_STATUS_INT_SOP_SFEC_IPG_VIOLATION_FIELD_MASK  0x0000000000200000
#define LIF_INT_STATUS_INT_SOP_SFEC_IPG_VIOLATION_FIELD_WIDTH 1
#define LIF_INT_STATUS_INT_SOP_SFEC_IPG_VIOLATION_FIELD_SHIFT 21

extern const ru_field_rec LIF_INT_STATUS_LASERONMAX_FIELD;
#define LIF_INT_STATUS_LASERONMAX_FIELD_MASK  0x0000000000100000
#define LIF_INT_STATUS_LASERONMAX_FIELD_WIDTH 1
#define LIF_INT_STATUS_LASERONMAX_FIELD_SHIFT 20

extern const ru_field_rec LIF_INT_STATUS_LASEROFF_FIELD;
#define LIF_INT_STATUS_LASEROFF_FIELD_MASK  0x0000000000080000
#define LIF_INT_STATUS_LASEROFF_FIELD_WIDTH 1
#define LIF_INT_STATUS_LASEROFF_FIELD_SHIFT 19

extern const ru_field_rec LIF_INT_STATUS_SECDNREPLAYPROTCTABORT_FIELD;
#define LIF_INT_STATUS_SECDNREPLAYPROTCTABORT_FIELD_MASK  0x0000000000040000
#define LIF_INT_STATUS_SECDNREPLAYPROTCTABORT_FIELD_WIDTH 1
#define LIF_INT_STATUS_SECDNREPLAYPROTCTABORT_FIELD_SHIFT 18

extern const ru_field_rec LIF_INT_STATUS_SECUPPKTNUMOVERFLOW_FIELD;
#define LIF_INT_STATUS_SECUPPKTNUMOVERFLOW_FIELD_MASK  0x0000000000020000
#define LIF_INT_STATUS_SECUPPKTNUMOVERFLOW_FIELD_WIDTH 1
#define LIF_INT_STATUS_SECUPPKTNUMOVERFLOW_FIELD_SHIFT 17

extern const ru_field_rec LIF_INT_STATUS_INTLASEROFFDURBURST_FIELD;
#define LIF_INT_STATUS_INTLASEROFFDURBURST_FIELD_MASK  0x0000000000010000
#define LIF_INT_STATUS_INTLASEROFFDURBURST_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTLASEROFFDURBURST_FIELD_SHIFT 16

extern const ru_field_rec LIF_INT_STATUS_INTRXBERTHRESHEXC_FIELD;
#define LIF_INT_STATUS_INTRXBERTHRESHEXC_FIELD_MASK  0x0000000000008000
#define LIF_INT_STATUS_INTRXBERTHRESHEXC_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTRXBERTHRESHEXC_FIELD_SHIFT 15

extern const ru_field_rec LIF_INT_STATUS_INTFECRXFECRECVSTATUS_FIELD;
#define LIF_INT_STATUS_INTFECRXFECRECVSTATUS_FIELD_MASK  0x0000000000004000
#define LIF_INT_STATUS_INTFECRXFECRECVSTATUS_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECRXFECRECVSTATUS_FIELD_SHIFT 14

extern const ru_field_rec LIF_INT_STATUS_INTFECRXCORERRFIFOFULLSTATUS_FIELD;
#define LIF_INT_STATUS_INTFECRXCORERRFIFOFULLSTATUS_FIELD_MASK  0x0000000000002000
#define LIF_INT_STATUS_INTFECRXCORERRFIFOFULLSTATUS_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECRXCORERRFIFOFULLSTATUS_FIELD_SHIFT 13

extern const ru_field_rec LIF_INT_STATUS_INTFECRXCORERRFIFOUNEXPEMPTY_FIELD;
#define LIF_INT_STATUS_INTFECRXCORERRFIFOUNEXPEMPTY_FIELD_MASK  0x0000000000001000
#define LIF_INT_STATUS_INTFECRXCORERRFIFOUNEXPEMPTY_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECRXCORERRFIFOUNEXPEMPTY_FIELD_SHIFT 12

extern const ru_field_rec LIF_INT_STATUS_INTFECBUFPOPEMPTYPUSH_FIELD;
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYPUSH_FIELD_MASK  0x0000000000000800
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYPUSH_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYPUSH_FIELD_SHIFT 11

extern const ru_field_rec LIF_INT_STATUS_INTFECBUFPOPEMPTYNOPUSH_FIELD;
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYNOPUSH_FIELD_MASK  0x0000000000000400
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYNOPUSH_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYNOPUSH_FIELD_SHIFT 10

extern const ru_field_rec LIF_INT_STATUS_INTFECBUFPUSHFULL_FIELD;
#define LIF_INT_STATUS_INTFECBUFPUSHFULL_FIELD_MASK  0x0000000000000200
#define LIF_INT_STATUS_INTFECBUFPUSHFULL_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECBUFPUSHFULL_FIELD_SHIFT 9

extern const ru_field_rec LIF_INT_STATUS_INTUPTIMEFULLUPDSTAT_FIELD;
#define LIF_INT_STATUS_INTUPTIMEFULLUPDSTAT_FIELD_MASK  0x0000000000000100
#define LIF_INT_STATUS_INTUPTIMEFULLUPDSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTUPTIMEFULLUPDSTAT_FIELD_SHIFT 8

extern const ru_field_rec LIF_INT_STATUS_INTFROUTOFALIGNSTAT_FIELD;
#define LIF_INT_STATUS_INTFROUTOFALIGNSTAT_FIELD_MASK  0x0000000000000080
#define LIF_INT_STATUS_INTFROUTOFALIGNSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFROUTOFALIGNSTAT_FIELD_SHIFT 7

extern const ru_field_rec LIF_INT_STATUS_INTGRNTSTARTTIMELAGSTAT_FIELD;
#define LIF_INT_STATUS_INTGRNTSTARTTIMELAGSTAT_FIELD_MASK  0x0000000000000040
#define LIF_INT_STATUS_INTGRNTSTARTTIMELAGSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTGRNTSTARTTIMELAGSTAT_FIELD_SHIFT 6

extern const ru_field_rec LIF_INT_STATUS_INTABORTRXFRMSTAT_FIELD;
#define LIF_INT_STATUS_INTABORTRXFRMSTAT_FIELD_MASK  0x0000000000000020
#define LIF_INT_STATUS_INTABORTRXFRMSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTABORTRXFRMSTAT_FIELD_SHIFT 5

extern const ru_field_rec LIF_INT_STATUS_INTNORXCLKSTAT_FIELD;
#define LIF_INT_STATUS_INTNORXCLKSTAT_FIELD_MASK  0x0000000000000010
#define LIF_INT_STATUS_INTNORXCLKSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTNORXCLKSTAT_FIELD_SHIFT 4

extern const ru_field_rec LIF_INT_STATUS_INTRXMAXLENERRSTAT_FIELD;
#define LIF_INT_STATUS_INTRXMAXLENERRSTAT_FIELD_MASK  0x0000000000000008
#define LIF_INT_STATUS_INTRXMAXLENERRSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTRXMAXLENERRSTAT_FIELD_SHIFT 3

extern const ru_field_rec LIF_INT_STATUS_INTRXERRAFTALIGNSTAT_FIELD;
#define LIF_INT_STATUS_INTRXERRAFTALIGNSTAT_FIELD_MASK  0x0000000000000004
#define LIF_INT_STATUS_INTRXERRAFTALIGNSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTRXERRAFTALIGNSTAT_FIELD_SHIFT 2

extern const ru_field_rec LIF_INT_STATUS_INTRXSYNCHACQSTAT_FIELD;
#define LIF_INT_STATUS_INTRXSYNCHACQSTAT_FIELD_MASK  0x0000000000000002
#define LIF_INT_STATUS_INTRXSYNCHACQSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTRXSYNCHACQSTAT_FIELD_SHIFT 1

extern const ru_field_rec LIF_INT_STATUS_INTRXOUTOFSYNCHSTAT_FIELD;
#define LIF_INT_STATUS_INTRXOUTOFSYNCHSTAT_FIELD_MASK  0x0000000000000001
#define LIF_INT_STATUS_INTRXOUTOFSYNCHSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTRXOUTOFSYNCHSTAT_FIELD_SHIFT 0

extern const ru_field_rec LIF_INT_MASK_RESERVED0_FIELD;
#define LIF_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffc00000
#define LIF_INT_MASK_RESERVED0_FIELD_WIDTH 10
#define LIF_INT_MASK_RESERVED0_FIELD_SHIFT 22

extern const ru_field_rec LIF_INT_MASK_INT_SOP_SFEC_IPG_VIOLATION_MASK_FIELD;
#define LIF_INT_MASK_INT_SOP_SFEC_IPG_VIOLATION_MASK_FIELD_MASK  0x0000000000200000
#define LIF_INT_MASK_INT_SOP_SFEC_IPG_VIOLATION_MASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INT_SOP_SFEC_IPG_VIOLATION_MASK_FIELD_SHIFT 21

extern const ru_field_rec LIF_INT_MASK_LASERONMAXMASK_FIELD;
#define LIF_INT_MASK_LASERONMAXMASK_FIELD_MASK  0x0000000000100000
#define LIF_INT_MASK_LASERONMAXMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_LASERONMAXMASK_FIELD_SHIFT 20

extern const ru_field_rec LIF_INT_MASK_LASEROFFMASK_FIELD;
#define LIF_INT_MASK_LASEROFFMASK_FIELD_MASK  0x0000000000080000
#define LIF_INT_MASK_LASEROFFMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_LASEROFFMASK_FIELD_SHIFT 19

extern const ru_field_rec LIF_INT_MASK_SECDNREPLAYPROTCTABORTMSK_FIELD;
#define LIF_INT_MASK_SECDNREPLAYPROTCTABORTMSK_FIELD_MASK  0x0000000000040000
#define LIF_INT_MASK_SECDNREPLAYPROTCTABORTMSK_FIELD_WIDTH 1
#define LIF_INT_MASK_SECDNREPLAYPROTCTABORTMSK_FIELD_SHIFT 18

extern const ru_field_rec LIF_INT_MASK_SECUPPKTNUMOVERFLOWMSK_FIELD;
#define LIF_INT_MASK_SECUPPKTNUMOVERFLOWMSK_FIELD_MASK  0x0000000000020000
#define LIF_INT_MASK_SECUPPKTNUMOVERFLOWMSK_FIELD_WIDTH 1
#define LIF_INT_MASK_SECUPPKTNUMOVERFLOWMSK_FIELD_SHIFT 17

extern const ru_field_rec LIF_INT_MASK_INTLASEROFFDURBURSTMASK_FIELD;
#define LIF_INT_MASK_INTLASEROFFDURBURSTMASK_FIELD_MASK  0x0000000000010000
#define LIF_INT_MASK_INTLASEROFFDURBURSTMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTLASEROFFDURBURSTMASK_FIELD_SHIFT 16

extern const ru_field_rec LIF_INT_MASK_INTRXBERTHRESHEXCMASK_FIELD;
#define LIF_INT_MASK_INTRXBERTHRESHEXCMASK_FIELD_MASK  0x0000000000008000
#define LIF_INT_MASK_INTRXBERTHRESHEXCMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTRXBERTHRESHEXCMASK_FIELD_SHIFT 15

extern const ru_field_rec LIF_INT_MASK_INTFECRXFECRECVMASK_FIELD;
#define LIF_INT_MASK_INTFECRXFECRECVMASK_FIELD_MASK  0x0000000000004000
#define LIF_INT_MASK_INTFECRXFECRECVMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECRXFECRECVMASK_FIELD_SHIFT 14

extern const ru_field_rec LIF_INT_MASK_INTFECRXCORERRFIFOFULLMASK_FIELD;
#define LIF_INT_MASK_INTFECRXCORERRFIFOFULLMASK_FIELD_MASK  0x0000000000002000
#define LIF_INT_MASK_INTFECRXCORERRFIFOFULLMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECRXCORERRFIFOFULLMASK_FIELD_SHIFT 13

extern const ru_field_rec LIF_INT_MASK_INTFECRXCORERRFIFOUNEXPEMPTYMASK_FIELD;
#define LIF_INT_MASK_INTFECRXCORERRFIFOUNEXPEMPTYMASK_FIELD_MASK  0x0000000000001000
#define LIF_INT_MASK_INTFECRXCORERRFIFOUNEXPEMPTYMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECRXCORERRFIFOUNEXPEMPTYMASK_FIELD_SHIFT 12

extern const ru_field_rec LIF_INT_MASK_INTFECBUFPOPEMPTYPUSHMASK_FIELD;
#define LIF_INT_MASK_INTFECBUFPOPEMPTYPUSHMASK_FIELD_MASK  0x0000000000000800
#define LIF_INT_MASK_INTFECBUFPOPEMPTYPUSHMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECBUFPOPEMPTYPUSHMASK_FIELD_SHIFT 11

extern const ru_field_rec LIF_INT_MASK_INTFECBUFPOPEMPTYNOPUSHMASK_FIELD;
#define LIF_INT_MASK_INTFECBUFPOPEMPTYNOPUSHMASK_FIELD_MASK  0x0000000000000400
#define LIF_INT_MASK_INTFECBUFPOPEMPTYNOPUSHMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECBUFPOPEMPTYNOPUSHMASK_FIELD_SHIFT 10

extern const ru_field_rec LIF_INT_MASK_INTFECBUFPUSHFULLMASK_FIELD;
#define LIF_INT_MASK_INTFECBUFPUSHFULLMASK_FIELD_MASK  0x0000000000000200
#define LIF_INT_MASK_INTFECBUFPUSHFULLMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECBUFPUSHFULLMASK_FIELD_SHIFT 9

extern const ru_field_rec LIF_INT_MASK_INTUPTIMEFULLUPDMASK_FIELD;
#define LIF_INT_MASK_INTUPTIMEFULLUPDMASK_FIELD_MASK  0x0000000000000100
#define LIF_INT_MASK_INTUPTIMEFULLUPDMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTUPTIMEFULLUPDMASK_FIELD_SHIFT 8

extern const ru_field_rec LIF_INT_MASK_INTFROUTOFALIGNMASK_FIELD;
#define LIF_INT_MASK_INTFROUTOFALIGNMASK_FIELD_MASK  0x0000000000000080
#define LIF_INT_MASK_INTFROUTOFALIGNMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFROUTOFALIGNMASK_FIELD_SHIFT 7

extern const ru_field_rec LIF_INT_MASK_INTGRNTSTARTTIMELAGMASK_FIELD;
#define LIF_INT_MASK_INTGRNTSTARTTIMELAGMASK_FIELD_MASK  0x0000000000000040
#define LIF_INT_MASK_INTGRNTSTARTTIMELAGMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTGRNTSTARTTIMELAGMASK_FIELD_SHIFT 6

extern const ru_field_rec LIF_INT_MASK_INTABORTRXFRMMASK_FIELD;
#define LIF_INT_MASK_INTABORTRXFRMMASK_FIELD_MASK  0x0000000000000020
#define LIF_INT_MASK_INTABORTRXFRMMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTABORTRXFRMMASK_FIELD_SHIFT 5

extern const ru_field_rec LIF_INT_MASK_INTNORXCLKMASK_FIELD;
#define LIF_INT_MASK_INTNORXCLKMASK_FIELD_MASK  0x0000000000000010
#define LIF_INT_MASK_INTNORXCLKMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTNORXCLKMASK_FIELD_SHIFT 4

extern const ru_field_rec LIF_INT_MASK_INTRXMAXLENERRMASK_FIELD;
#define LIF_INT_MASK_INTRXMAXLENERRMASK_FIELD_MASK  0x0000000000000008
#define LIF_INT_MASK_INTRXMAXLENERRMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTRXMAXLENERRMASK_FIELD_SHIFT 3

extern const ru_field_rec LIF_INT_MASK_INTRXERRAFTALIGNMASK_FIELD;
#define LIF_INT_MASK_INTRXERRAFTALIGNMASK_FIELD_MASK  0x0000000000000004
#define LIF_INT_MASK_INTRXERRAFTALIGNMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTRXERRAFTALIGNMASK_FIELD_SHIFT 2

extern const ru_field_rec LIF_INT_MASK_INTRXSYNCHACQMASK_FIELD;
#define LIF_INT_MASK_INTRXSYNCHACQMASK_FIELD_MASK  0x0000000000000002
#define LIF_INT_MASK_INTRXSYNCHACQMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTRXSYNCHACQMASK_FIELD_SHIFT 1

extern const ru_field_rec LIF_INT_MASK_INTRXOUTOFSYNCHMASK_FIELD;
#define LIF_INT_MASK_INTRXOUTOFSYNCHMASK_FIELD_MASK  0x0000000000000001
#define LIF_INT_MASK_INTRXOUTOFSYNCHMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTRXOUTOFSYNCHMASK_FIELD_SHIFT 0

extern const ru_field_rec LIF_DATA_PORT_COMMAND_DATA_PORT_BUSY_FIELD;
#define LIF_DATA_PORT_COMMAND_DATA_PORT_BUSY_FIELD_MASK  0x0000000080000000
#define LIF_DATA_PORT_COMMAND_DATA_PORT_BUSY_FIELD_WIDTH 1
#define LIF_DATA_PORT_COMMAND_DATA_PORT_BUSY_FIELD_SHIFT 31

extern const ru_field_rec LIF_DATA_PORT_COMMAND_DATA_PORT_ERROR_FIELD;
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ERROR_FIELD_MASK  0x0000000040000000
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ERROR_FIELD_WIDTH 1
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ERROR_FIELD_SHIFT 30

extern const ru_field_rec LIF_DATA_PORT_COMMAND_RAM_SELECT_FIELD;
#define LIF_DATA_PORT_COMMAND_RAM_SELECT_FIELD_MASK  0x000000003f000000
#define LIF_DATA_PORT_COMMAND_RAM_SELECT_FIELD_WIDTH 6
#define LIF_DATA_PORT_COMMAND_RAM_SELECT_FIELD_SHIFT 24

extern const ru_field_rec LIF_DATA_PORT_COMMAND_DATA_PORT_OP_CODE_FIELD;
#define LIF_DATA_PORT_COMMAND_DATA_PORT_OP_CODE_FIELD_MASK  0x0000000000ff0000
#define LIF_DATA_PORT_COMMAND_DATA_PORT_OP_CODE_FIELD_WIDTH 8
#define LIF_DATA_PORT_COMMAND_DATA_PORT_OP_CODE_FIELD_SHIFT 16

extern const ru_field_rec LIF_DATA_PORT_COMMAND_DATA_PORT_ADDR_FIELD;
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ADDR_FIELD_MASK  0x000000000000ffff
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ADDR_FIELD_WIDTH 16
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ADDR_FIELD_SHIFT 0

extern const ru_field_rec LIF_DATA_PORT_DATA_PBIPORTDATA_FIELD;
#define LIF_DATA_PORT_DATA_PBIPORTDATA_FIELD_MASK  0x00000000ffffffff
#define LIF_DATA_PORT_DATA_PBIPORTDATA_FIELD_WIDTH 32
#define LIF_DATA_PORT_DATA_PBIPORTDATA_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_0_RESERVED0_FIELD;
#define LIF_LLID_0_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_0_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_0_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_0_CFGLLID0_FIELD;
#define LIF_LLID_0_CFGLLID0_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_0_CFGLLID0_FIELD_WIDTH 17
#define LIF_LLID_0_CFGLLID0_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_1_RESERVED0_FIELD;
#define LIF_LLID_1_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_1_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_1_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_1_CFGLLID1_FIELD;
#define LIF_LLID_1_CFGLLID1_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_1_CFGLLID1_FIELD_WIDTH 17
#define LIF_LLID_1_CFGLLID1_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_2_RESERVED0_FIELD;
#define LIF_LLID_2_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_2_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_2_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_2_CFGLLID2_FIELD;
#define LIF_LLID_2_CFGLLID2_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_2_CFGLLID2_FIELD_WIDTH 17
#define LIF_LLID_2_CFGLLID2_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_3_RESERVED0_FIELD;
#define LIF_LLID_3_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_3_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_3_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_3_CFGLLID3_FIELD;
#define LIF_LLID_3_CFGLLID3_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_3_CFGLLID3_FIELD_WIDTH 17
#define LIF_LLID_3_CFGLLID3_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_4_RESERVED0_FIELD;
#define LIF_LLID_4_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_4_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_4_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_4_CFGLLID4_FIELD;
#define LIF_LLID_4_CFGLLID4_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_4_CFGLLID4_FIELD_WIDTH 17
#define LIF_LLID_4_CFGLLID4_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_5_RESERVED0_FIELD;
#define LIF_LLID_5_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_5_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_5_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_5_CFGLLID5_FIELD;
#define LIF_LLID_5_CFGLLID5_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_5_CFGLLID5_FIELD_WIDTH 17
#define LIF_LLID_5_CFGLLID5_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_6_RESERVED0_FIELD;
#define LIF_LLID_6_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_6_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_6_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_6_CFGLLID6_FIELD;
#define LIF_LLID_6_CFGLLID6_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_6_CFGLLID6_FIELD_WIDTH 17
#define LIF_LLID_6_CFGLLID6_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_7_RESERVED0_FIELD;
#define LIF_LLID_7_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_7_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_7_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_7_CFGLLID7_FIELD;
#define LIF_LLID_7_CFGLLID7_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_7_CFGLLID7_FIELD_WIDTH 17
#define LIF_LLID_7_CFGLLID7_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_16_RESERVED0_FIELD;
#define LIF_LLID_16_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_16_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_16_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_16_CFGLLID16_FIELD;
#define LIF_LLID_16_CFGLLID16_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_16_CFGLLID16_FIELD_WIDTH 17
#define LIF_LLID_16_CFGLLID16_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_17_RESERVED0_FIELD;
#define LIF_LLID_17_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_17_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_17_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_17_CFGLLID17_FIELD;
#define LIF_LLID_17_CFGLLID17_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_17_CFGLLID17_FIELD_WIDTH 17
#define LIF_LLID_17_CFGLLID17_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_18_RESERVED0_FIELD;
#define LIF_LLID_18_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_18_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_18_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_18_CFGLLID18_FIELD;
#define LIF_LLID_18_CFGLLID18_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_18_CFGLLID18_FIELD_WIDTH 17
#define LIF_LLID_18_CFGLLID18_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_19_RESERVED0_FIELD;
#define LIF_LLID_19_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_19_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_19_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_19_CFGLLID19_FIELD;
#define LIF_LLID_19_CFGLLID19_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_19_CFGLLID19_FIELD_WIDTH 17
#define LIF_LLID_19_CFGLLID19_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_20_RESERVED0_FIELD;
#define LIF_LLID_20_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_20_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_20_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_20_CFGLLID20_FIELD;
#define LIF_LLID_20_CFGLLID20_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_20_CFGLLID20_FIELD_WIDTH 17
#define LIF_LLID_20_CFGLLID20_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_21_RESERVED0_FIELD;
#define LIF_LLID_21_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_21_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_21_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_21_CFGLLID21_FIELD;
#define LIF_LLID_21_CFGLLID21_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_21_CFGLLID21_FIELD_WIDTH 17
#define LIF_LLID_21_CFGLLID21_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_22_RESERVED0_FIELD;
#define LIF_LLID_22_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_22_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_22_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_22_CFGLLID22_FIELD;
#define LIF_LLID_22_CFGLLID22_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_22_CFGLLID22_FIELD_WIDTH 17
#define LIF_LLID_22_CFGLLID22_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_23_RESERVED0_FIELD;
#define LIF_LLID_23_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_23_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_23_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_23_CFGLLID23_FIELD;
#define LIF_LLID_23_CFGLLID23_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_23_CFGLLID23_FIELD_WIDTH 17
#define LIF_LLID_23_CFGLLID23_FIELD_SHIFT 0

extern const ru_field_rec LIF_TIME_REF_CNT_RESERVED0_FIELD;
#define LIF_TIME_REF_CNT_RESERVED0_FIELD_MASK  0x00000000ff000000
#define LIF_TIME_REF_CNT_RESERVED0_FIELD_WIDTH 8
#define LIF_TIME_REF_CNT_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec LIF_TIME_REF_CNT_CFFULLUPDATEVALUE_FIELD;
#define LIF_TIME_REF_CNT_CFFULLUPDATEVALUE_FIELD_MASK  0x0000000000ff0000
#define LIF_TIME_REF_CNT_CFFULLUPDATEVALUE_FIELD_WIDTH 8
#define LIF_TIME_REF_CNT_CFFULLUPDATEVALUE_FIELD_SHIFT 16

extern const ru_field_rec LIF_TIME_REF_CNT_CFMAXNEGVALUE_FIELD;
#define LIF_TIME_REF_CNT_CFMAXNEGVALUE_FIELD_MASK  0x000000000000ff00
#define LIF_TIME_REF_CNT_CFMAXNEGVALUE_FIELD_WIDTH 8
#define LIF_TIME_REF_CNT_CFMAXNEGVALUE_FIELD_SHIFT 8

extern const ru_field_rec LIF_TIME_REF_CNT_CFMAXPOSVALUE_FIELD;
#define LIF_TIME_REF_CNT_CFMAXPOSVALUE_FIELD_MASK  0x00000000000000ff
#define LIF_TIME_REF_CNT_CFMAXPOSVALUE_FIELD_WIDTH 8
#define LIF_TIME_REF_CNT_CFMAXPOSVALUE_FIELD_SHIFT 0

extern const ru_field_rec LIF_TIMESTAMP_UPD_PER_RESERVED0_FIELD;
#define LIF_TIMESTAMP_UPD_PER_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_TIMESTAMP_UPD_PER_RESERVED0_FIELD_WIDTH 16
#define LIF_TIMESTAMP_UPD_PER_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_TIMESTAMP_UPD_PER_CFTIMESTAMPUPDPER_FIELD;
#define LIF_TIMESTAMP_UPD_PER_CFTIMESTAMPUPDPER_FIELD_MASK  0x000000000000ffff
#define LIF_TIMESTAMP_UPD_PER_CFTIMESTAMPUPDPER_FIELD_WIDTH 16
#define LIF_TIMESTAMP_UPD_PER_CFTIMESTAMPUPDPER_FIELD_SHIFT 0

extern const ru_field_rec LIF_TP_TIME_CFTRANSPORTTIME_FIELD;
#define LIF_TP_TIME_CFTRANSPORTTIME_FIELD_MASK  0x00000000ffffffff
#define LIF_TP_TIME_CFTRANSPORTTIME_FIELD_WIDTH 32
#define LIF_TP_TIME_CFTRANSPORTTIME_FIELD_SHIFT 0

extern const ru_field_rec LIF_MPCP_TIME_LTMPCPTIME_FIELD;
#define LIF_MPCP_TIME_LTMPCPTIME_FIELD_MASK  0x00000000ffffffff
#define LIF_MPCP_TIME_LTMPCPTIME_FIELD_WIDTH 32
#define LIF_MPCP_TIME_LTMPCPTIME_FIELD_SHIFT 0

extern const ru_field_rec LIF_MAXLEN_CTR_RESERVED0_FIELD;
#define LIF_MAXLEN_CTR_RESERVED0_FIELD_MASK  0x00000000ffffc000
#define LIF_MAXLEN_CTR_RESERVED0_FIELD_WIDTH 18
#define LIF_MAXLEN_CTR_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec LIF_MAXLEN_CTR_CFRXMAXFRAMELENGTH_FIELD;
#define LIF_MAXLEN_CTR_CFRXMAXFRAMELENGTH_FIELD_MASK  0x0000000000003fff
#define LIF_MAXLEN_CTR_CFRXMAXFRAMELENGTH_FIELD_WIDTH 14
#define LIF_MAXLEN_CTR_CFRXMAXFRAMELENGTH_FIELD_SHIFT 0

extern const ru_field_rec LIF_LASER_ON_DELTA_RESERVED0_FIELD;
#define LIF_LASER_ON_DELTA_RESERVED0_FIELD_MASK  0x00000000ffffe000
#define LIF_LASER_ON_DELTA_RESERVED0_FIELD_WIDTH 19
#define LIF_LASER_ON_DELTA_RESERVED0_FIELD_SHIFT 13

extern const ru_field_rec LIF_LASER_ON_DELTA_CFTXLASERONDELTA_FIELD;
#define LIF_LASER_ON_DELTA_CFTXLASERONDELTA_FIELD_MASK  0x0000000000001fff
#define LIF_LASER_ON_DELTA_CFTXLASERONDELTA_FIELD_WIDTH 13
#define LIF_LASER_ON_DELTA_CFTXLASERONDELTA_FIELD_SHIFT 0

extern const ru_field_rec LIF_LASER_OFF_IDLE_CFTXINITIDLE_FIELD;
#define LIF_LASER_OFF_IDLE_CFTXINITIDLE_FIELD_MASK  0x00000000ffff0000
#define LIF_LASER_OFF_IDLE_CFTXINITIDLE_FIELD_WIDTH 16
#define LIF_LASER_OFF_IDLE_CFTXINITIDLE_FIELD_SHIFT 16

extern const ru_field_rec LIF_LASER_OFF_IDLE_RESERVED0_FIELD;
#define LIF_LASER_OFF_IDLE_RESERVED0_FIELD_MASK  0x000000000000ff00
#define LIF_LASER_OFF_IDLE_RESERVED0_FIELD_WIDTH 8
#define LIF_LASER_OFF_IDLE_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec LIF_LASER_OFF_IDLE_CFTXLASEROFFDELTA_FIELD;
#define LIF_LASER_OFF_IDLE_CFTXLASEROFFDELTA_FIELD_MASK  0x00000000000000ff
#define LIF_LASER_OFF_IDLE_CFTXLASEROFFDELTA_FIELD_WIDTH 8
#define LIF_LASER_OFF_IDLE_CFTXLASEROFFDELTA_FIELD_SHIFT 0

extern const ru_field_rec LIF_FEC_INIT_IDLE_RESERVED0_FIELD;
#define LIF_FEC_INIT_IDLE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_FEC_INIT_IDLE_RESERVED0_FIELD_WIDTH 16
#define LIF_FEC_INIT_IDLE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_FEC_INIT_IDLE_CFTXFECINITIDLE_FIELD;
#define LIF_FEC_INIT_IDLE_CFTXFECINITIDLE_FIELD_MASK  0x000000000000ffff
#define LIF_FEC_INIT_IDLE_CFTXFECINITIDLE_FIELD_WIDTH 16
#define LIF_FEC_INIT_IDLE_CFTXFECINITIDLE_FIELD_SHIFT 0

extern const ru_field_rec LIF_FEC_ERR_ALLOW_RESERVED0_FIELD;
#define LIF_FEC_ERR_ALLOW_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define LIF_FEC_ERR_ALLOW_RESERVED0_FIELD_WIDTH 24
#define LIF_FEC_ERR_ALLOW_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec LIF_FEC_ERR_ALLOW_CFRXTFECBITERRALLOW_FIELD;
#define LIF_FEC_ERR_ALLOW_CFRXTFECBITERRALLOW_FIELD_MASK  0x00000000000000f0
#define LIF_FEC_ERR_ALLOW_CFRXTFECBITERRALLOW_FIELD_WIDTH 4
#define LIF_FEC_ERR_ALLOW_CFRXTFECBITERRALLOW_FIELD_SHIFT 4

extern const ru_field_rec LIF_FEC_ERR_ALLOW_CFRXSFECBITERRALLOW_FIELD;
#define LIF_FEC_ERR_ALLOW_CFRXSFECBITERRALLOW_FIELD_MASK  0x000000000000000f
#define LIF_FEC_ERR_ALLOW_CFRXSFECBITERRALLOW_FIELD_WIDTH 4
#define LIF_FEC_ERR_ALLOW_CFRXSFECBITERRALLOW_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_KEY_SEL_KEYSEL_FIELD;
#define LIF_SEC_KEY_SEL_KEYSEL_FIELD_MASK  0x00000000ffffffff
#define LIF_SEC_KEY_SEL_KEYSEL_FIELD_WIDTH 32
#define LIF_SEC_KEY_SEL_KEYSEL_FIELD_SHIFT 0

extern const ru_field_rec LIF_DN_ENCRYPT_STAT_ENENCRYPT_FIELD;
#define LIF_DN_ENCRYPT_STAT_ENENCRYPT_FIELD_MASK  0x00000000ffffffff
#define LIF_DN_ENCRYPT_STAT_ENENCRYPT_FIELD_WIDTH 32
#define LIF_DN_ENCRYPT_STAT_ENENCRYPT_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_UP_KEY_STAT_KEYUPSEL_FIELD;
#define LIF_SEC_UP_KEY_STAT_KEYUPSEL_FIELD_MASK  0x00000000ffffffff
#define LIF_SEC_UP_KEY_STAT_KEYUPSEL_FIELD_WIDTH 32
#define LIF_SEC_UP_KEY_STAT_KEYUPSEL_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_UP_ENCRYPT_STAT_ENUPENCRYPT_FIELD;
#define LIF_SEC_UP_ENCRYPT_STAT_ENUPENCRYPT_FIELD_MASK  0x00000000ffffffff
#define LIF_SEC_UP_ENCRYPT_STAT_ENUPENCRYPT_FIELD_WIDTH 32
#define LIF_SEC_UP_ENCRYPT_STAT_ENUPENCRYPT_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_UP_MPCP_OFFSET_SECUPMPCPOFFSET_FIELD;
#define LIF_SEC_UP_MPCP_OFFSET_SECUPMPCPOFFSET_FIELD_MASK  0x00000000ffffffff
#define LIF_SEC_UP_MPCP_OFFSET_SECUPMPCPOFFSET_FIELD_WIDTH 32
#define LIF_SEC_UP_MPCP_OFFSET_SECUPMPCPOFFSET_FIELD_SHIFT 0

extern const ru_field_rec LIF_FEC_PER_LLID_CFFECTXFECENLLID_FIELD;
#define LIF_FEC_PER_LLID_CFFECTXFECENLLID_FIELD_MASK  0x00000000ffffffff
#define LIF_FEC_PER_LLID_CFFECTXFECENLLID_FIELD_WIDTH 32
#define LIF_FEC_PER_LLID_CFFECTXFECENLLID_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_LINE_CODE_ERR_CNT_RXLINECODEERRCNT_FIELD;
#define LIF_RX_LINE_CODE_ERR_CNT_RXLINECODEERRCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_LINE_CODE_ERR_CNT_RXLINECODEERRCNT_FIELD_WIDTH 32
#define LIF_RX_LINE_CODE_ERR_CNT_RXLINECODEERRCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_MPCP_FRM_RXAGGMPCPCNT_FIELD;
#define LIF_RX_AGG_MPCP_FRM_RXAGGMPCPCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_MPCP_FRM_RXAGGMPCPCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_MPCP_FRM_RXAGGMPCPCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_GOOD_FRM_RXAGGGOODCNT_FIELD;
#define LIF_RX_AGG_GOOD_FRM_RXAGGGOODCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_GOOD_FRM_RXAGGGOODCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_GOOD_FRM_RXAGGGOODCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_GOOD_BYTE_RXAGGGOODBYTESCNT_FIELD;
#define LIF_RX_AGG_GOOD_BYTE_RXAGGGOODBYTESCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_GOOD_BYTE_RXAGGGOODBYTESCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_GOOD_BYTE_RXAGGGOODBYTESCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_UNDERSZ_FRM_RXAGGUNDERSZCNT_FIELD;
#define LIF_RX_AGG_UNDERSZ_FRM_RXAGGUNDERSZCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_UNDERSZ_FRM_RXAGGUNDERSZCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_UNDERSZ_FRM_RXAGGUNDERSZCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_OVERSZ_FRM_RXAGGOVERSZCNT_FIELD;
#define LIF_RX_AGG_OVERSZ_FRM_RXAGGOVERSZCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_OVERSZ_FRM_RXAGGOVERSZCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_OVERSZ_FRM_RXAGGOVERSZCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_CRC8_FRM_RXAGGCRC8ERRCNT_FIELD;
#define LIF_RX_AGG_CRC8_FRM_RXAGGCRC8ERRCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_CRC8_FRM_RXAGGCRC8ERRCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_CRC8_FRM_RXAGGCRC8ERRCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_FEC_FRM_RXAGGFEC_FIELD;
#define LIF_RX_AGG_FEC_FRM_RXAGGFEC_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_FEC_FRM_RXAGGFEC_FIELD_WIDTH 32
#define LIF_RX_AGG_FEC_FRM_RXAGGFEC_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_FEC_BYTE_RXAGGFECBYTES_FIELD;
#define LIF_RX_AGG_FEC_BYTE_RXAGGFECBYTES_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_FEC_BYTE_RXAGGFECBYTES_FIELD_WIDTH 32
#define LIF_RX_AGG_FEC_BYTE_RXAGGFECBYTES_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_FEC_EXC_ERR_FRM_RXAGGFECEXCEEDERRS_FIELD;
#define LIF_RX_AGG_FEC_EXC_ERR_FRM_RXAGGFECEXCEEDERRS_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_FEC_EXC_ERR_FRM_RXAGGFECEXCEEDERRS_FIELD_WIDTH 32
#define LIF_RX_AGG_FEC_EXC_ERR_FRM_RXAGGFECEXCEEDERRS_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_NONFEC_GOOD_FRM_RXAGGNONFECGOOD_FIELD;
#define LIF_RX_AGG_NONFEC_GOOD_FRM_RXAGGNONFECGOOD_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_NONFEC_GOOD_FRM_RXAGGNONFECGOOD_FIELD_WIDTH 32
#define LIF_RX_AGG_NONFEC_GOOD_FRM_RXAGGNONFECGOOD_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_NONFEC_GOOD_BYTE_RXAGGNONFECGOODBYTES_FIELD;
#define LIF_RX_AGG_NONFEC_GOOD_BYTE_RXAGGNONFECGOODBYTES_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_NONFEC_GOOD_BYTE_RXAGGNONFECGOODBYTES_FIELD_WIDTH 32
#define LIF_RX_AGG_NONFEC_GOOD_BYTE_RXAGGNONFECGOODBYTES_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_ERR_BYTES_RXAGGERRBYTES_FIELD;
#define LIF_RX_AGG_ERR_BYTES_RXAGGERRBYTES_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_ERR_BYTES_RXAGGERRBYTES_FIELD_WIDTH 32
#define LIF_RX_AGG_ERR_BYTES_RXAGGERRBYTES_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_ERR_ZEROES_RXAGGERRZEROES_FIELD;
#define LIF_RX_AGG_ERR_ZEROES_RXAGGERRZEROES_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_ERR_ZEROES_RXAGGERRZEROES_FIELD_WIDTH 32
#define LIF_RX_AGG_ERR_ZEROES_RXAGGERRZEROES_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_NO_ERR_BLKS_RXAGGNOERRBLKS_FIELD;
#define LIF_RX_AGG_NO_ERR_BLKS_RXAGGNOERRBLKS_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_NO_ERR_BLKS_RXAGGNOERRBLKS_FIELD_WIDTH 32
#define LIF_RX_AGG_NO_ERR_BLKS_RXAGGNOERRBLKS_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_COR_BLKS_RXAGGCORRBLKS_FIELD;
#define LIF_RX_AGG_COR_BLKS_RXAGGCORRBLKS_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_COR_BLKS_RXAGGCORRBLKS_FIELD_WIDTH 32
#define LIF_RX_AGG_COR_BLKS_RXAGGCORRBLKS_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_UNCOR_BLKS_RXAGGUNCORRBLKS_FIELD;
#define LIF_RX_AGG_UNCOR_BLKS_RXAGGUNCORRBLKS_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_UNCOR_BLKS_RXAGGUNCORRBLKS_FIELD_WIDTH 32
#define LIF_RX_AGG_UNCOR_BLKS_RXAGGUNCORRBLKS_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_ERR_ONES_RXAGGERRONES_FIELD;
#define LIF_RX_AGG_ERR_ONES_RXAGGERRONES_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_ERR_ONES_RXAGGERRONES_FIELD_WIDTH 32
#define LIF_RX_AGG_ERR_ONES_RXAGGERRONES_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_ERR_FRM_RXAGGERROREDCNT_FIELD;
#define LIF_RX_AGG_ERR_FRM_RXAGGERROREDCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_ERR_FRM_RXAGGERROREDCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_ERR_FRM_RXAGGERROREDCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_PKT_CNT_TXFRAMECNT_FIELD;
#define LIF_TX_PKT_CNT_TXFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_PKT_CNT_TXFRAMECNT_FIELD_WIDTH 32
#define LIF_TX_PKT_CNT_TXFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_BYTE_CNT_TXBYTECNT_FIELD;
#define LIF_TX_BYTE_CNT_TXBYTECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_BYTE_CNT_TXBYTECNT_FIELD_WIDTH 32
#define LIF_TX_BYTE_CNT_TXBYTECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_NON_FEC_PKT_CNT_TXNONFECFRAMECNT_FIELD;
#define LIF_TX_NON_FEC_PKT_CNT_TXNONFECFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_NON_FEC_PKT_CNT_TXNONFECFRAMECNT_FIELD_WIDTH 32
#define LIF_TX_NON_FEC_PKT_CNT_TXNONFECFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_NON_FEC_BYTE_CNT_TXNONFECBYTECNT_FIELD;
#define LIF_TX_NON_FEC_BYTE_CNT_TXNONFECBYTECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_NON_FEC_BYTE_CNT_TXNONFECBYTECNT_FIELD_WIDTH 32
#define LIF_TX_NON_FEC_BYTE_CNT_TXNONFECBYTECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_FEC_PKT_CNT_TXFECFRAMECNT_FIELD;
#define LIF_TX_FEC_PKT_CNT_TXFECFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_FEC_PKT_CNT_TXFECFRAMECNT_FIELD_WIDTH 32
#define LIF_TX_FEC_PKT_CNT_TXFECFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_FEC_BYTE_CNT_TXFECBYTECNT_FIELD;
#define LIF_TX_FEC_BYTE_CNT_TXFECBYTECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_FEC_BYTE_CNT_TXFECBYTECNT_FIELD_WIDTH 32
#define LIF_TX_FEC_BYTE_CNT_TXFECBYTECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_FEC_BLK_CNT_TXFECBLKSCNT_FIELD;
#define LIF_TX_FEC_BLK_CNT_TXFECBLKSCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_FEC_BLK_CNT_TXFECBLKSCNT_FIELD_WIDTH 32
#define LIF_TX_FEC_BLK_CNT_TXFECBLKSCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_MPCP_PKT_CNT_TXMPCPFRAMECNT_FIELD;
#define LIF_TX_MPCP_PKT_CNT_TXMPCPFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_MPCP_PKT_CNT_TXMPCPFRAMECNT_FIELD_WIDTH 32
#define LIF_TX_MPCP_PKT_CNT_TXMPCPFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_DEBUG_TX_DATA_PKT_CNT_TXDATAFRAMECNT_FIELD;
#define LIF_DEBUG_TX_DATA_PKT_CNT_TXDATAFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_DEBUG_TX_DATA_PKT_CNT_TXDATAFRAMECNT_FIELD_WIDTH 32
#define LIF_DEBUG_TX_DATA_PKT_CNT_TXDATAFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_FEC_LLID_STATUS_STKYFECREVCLLIDBMSK_FIELD;
#define LIF_FEC_LLID_STATUS_STKYFECREVCLLIDBMSK_FIELD_MASK  0x00000000ffffffff
#define LIF_FEC_LLID_STATUS_STKYFECREVCLLIDBMSK_FIELD_WIDTH 32
#define LIF_FEC_LLID_STATUS_STKYFECREVCLLIDBMSK_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_RX_TEK_IG_IV_LLID_RESERVED0_FIELD;
#define LIF_SEC_RX_TEK_IG_IV_LLID_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_SEC_RX_TEK_IG_IV_LLID_RESERVED0_FIELD_WIDTH 15
#define LIF_SEC_RX_TEK_IG_IV_LLID_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_SEC_RX_TEK_IG_IV_LLID_CFIGIVNULLLLID_FIELD;
#define LIF_SEC_RX_TEK_IG_IV_LLID_CFIGIVNULLLLID_FIELD_MASK  0x000000000001ffff
#define LIF_SEC_RX_TEK_IG_IV_LLID_CFIGIVNULLLLID_FIELD_WIDTH 17
#define LIF_SEC_RX_TEK_IG_IV_LLID_CFIGIVNULLLLID_FIELD_SHIFT 0

extern const ru_field_rec LIF_PON_BER_INTERV_THRESH_CFRXLIFBERINTERVAL_FIELD;
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERINTERVAL_FIELD_MASK  0x00000000ffff8000
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERINTERVAL_FIELD_WIDTH 17
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERINTERVAL_FIELD_SHIFT 15

extern const ru_field_rec LIF_PON_BER_INTERV_THRESH_CFRXLIFBERTHRESHLD_FIELD;
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERTHRESHLD_FIELD_MASK  0x0000000000007ffc
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERTHRESHLD_FIELD_WIDTH 13
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERTHRESHLD_FIELD_SHIFT 2

extern const ru_field_rec LIF_PON_BER_INTERV_THRESH_CFRXLIFBERCNTRL_FIELD;
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERCNTRL_FIELD_MASK  0x0000000000000003
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERCNTRL_FIELD_WIDTH 2
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERCNTRL_FIELD_SHIFT 0

extern const ru_field_rec LIF_LSR_MON_A_CTRL_RESERVED0_FIELD;
#define LIF_LSR_MON_A_CTRL_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define LIF_LSR_MON_A_CTRL_RESERVED0_FIELD_WIDTH 26
#define LIF_LSR_MON_A_CTRL_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec LIF_LSR_MON_A_CTRL_IOPBILASERENS1A_FIELD;
#define LIF_LSR_MON_A_CTRL_IOPBILASERENS1A_FIELD_MASK  0x0000000000000020
#define LIF_LSR_MON_A_CTRL_IOPBILASERENS1A_FIELD_WIDTH 1
#define LIF_LSR_MON_A_CTRL_IOPBILASERENS1A_FIELD_SHIFT 5

extern const ru_field_rec LIF_LSR_MON_A_CTRL_CFGLSRMONACTHI_FIELD;
#define LIF_LSR_MON_A_CTRL_CFGLSRMONACTHI_FIELD_MASK  0x0000000000000010
#define LIF_LSR_MON_A_CTRL_CFGLSRMONACTHI_FIELD_WIDTH 1
#define LIF_LSR_MON_A_CTRL_CFGLSRMONACTHI_FIELD_SHIFT 4

extern const ru_field_rec LIF_LSR_MON_A_CTRL_RESERVED1_FIELD;
#define LIF_LSR_MON_A_CTRL_RESERVED1_FIELD_MASK  0x000000000000000e
#define LIF_LSR_MON_A_CTRL_RESERVED1_FIELD_WIDTH 3
#define LIF_LSR_MON_A_CTRL_RESERVED1_FIELD_SHIFT 1

extern const ru_field_rec LIF_LSR_MON_A_CTRL_PBILASERMONRSTA_N_PRE_FIELD;
#define LIF_LSR_MON_A_CTRL_PBILASERMONRSTA_N_PRE_FIELD_MASK  0x0000000000000001
#define LIF_LSR_MON_A_CTRL_PBILASERMONRSTA_N_PRE_FIELD_WIDTH 1
#define LIF_LSR_MON_A_CTRL_PBILASERMONRSTA_N_PRE_FIELD_SHIFT 0

extern const ru_field_rec LIF_LSR_MON_A_MAX_THR_CFGLASERMONMAXA_FIELD;
#define LIF_LSR_MON_A_MAX_THR_CFGLASERMONMAXA_FIELD_MASK  0x00000000ffffffff
#define LIF_LSR_MON_A_MAX_THR_CFGLASERMONMAXA_FIELD_WIDTH 32
#define LIF_LSR_MON_A_MAX_THR_CFGLASERMONMAXA_FIELD_SHIFT 0

extern const ru_field_rec LIF_LSR_MON_A_BST_LEN_LASERONTIMEA_FIELD;
#define LIF_LSR_MON_A_BST_LEN_LASERONTIMEA_FIELD_MASK  0x00000000ffffffff
#define LIF_LSR_MON_A_BST_LEN_LASERONTIMEA_FIELD_WIDTH 32
#define LIF_LSR_MON_A_BST_LEN_LASERONTIMEA_FIELD_SHIFT 0

extern const ru_field_rec LIF_LSR_MON_A_BST_CNT_LASERMONBRSTCNTA_FIELD;
#define LIF_LSR_MON_A_BST_CNT_LASERMONBRSTCNTA_FIELD_MASK  0x00000000ffffffff
#define LIF_LSR_MON_A_BST_CNT_LASERMONBRSTCNTA_FIELD_WIDTH 32
#define LIF_LSR_MON_A_BST_CNT_LASERMONBRSTCNTA_FIELD_SHIFT 0

extern const ru_field_rec LIF_DEBUG_PON_SM_RESERVED0_FIELD;
#define LIF_DEBUG_PON_SM_RESERVED0_FIELD_MASK  0x00000000ffffc000
#define LIF_DEBUG_PON_SM_RESERVED0_FIELD_WIDTH 18
#define LIF_DEBUG_PON_SM_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec LIF_DEBUG_PON_SM_ALIGNCSQQ_FIELD;
#define LIF_DEBUG_PON_SM_ALIGNCSQQ_FIELD_MASK  0x0000000000003f00
#define LIF_DEBUG_PON_SM_ALIGNCSQQ_FIELD_WIDTH 6
#define LIF_DEBUG_PON_SM_ALIGNCSQQ_FIELD_SHIFT 8

extern const ru_field_rec LIF_DEBUG_PON_SM_RESERVED1_FIELD;
#define LIF_DEBUG_PON_SM_RESERVED1_FIELD_MASK  0x00000000000000e0
#define LIF_DEBUG_PON_SM_RESERVED1_FIELD_WIDTH 3
#define LIF_DEBUG_PON_SM_RESERVED1_FIELD_SHIFT 5

extern const ru_field_rec LIF_DEBUG_PON_SM_RXFECIFCSQQ_FIELD;
#define LIF_DEBUG_PON_SM_RXFECIFCSQQ_FIELD_MASK  0x000000000000001f
#define LIF_DEBUG_PON_SM_RXFECIFCSQQ_FIELD_WIDTH 5
#define LIF_DEBUG_PON_SM_RXFECIFCSQQ_FIELD_SHIFT 0

extern const ru_field_rec LIF_DEBUG_FEC_SM_RESERVED0_FIELD;
#define LIF_DEBUG_FEC_SM_RESERVED0_FIELD_MASK  0x00000000ffe00000
#define LIF_DEBUG_FEC_SM_RESERVED0_FIELD_WIDTH 11
#define LIF_DEBUG_FEC_SM_RESERVED0_FIELD_SHIFT 21

extern const ru_field_rec LIF_DEBUG_FEC_SM_RXSYNCSQQ_FIELD;
#define LIF_DEBUG_FEC_SM_RXSYNCSQQ_FIELD_MASK  0x00000000001f0000
#define LIF_DEBUG_FEC_SM_RXSYNCSQQ_FIELD_WIDTH 5
#define LIF_DEBUG_FEC_SM_RXSYNCSQQ_FIELD_SHIFT 16

extern const ru_field_rec LIF_DEBUG_FEC_SM_RESERVED1_FIELD;
#define LIF_DEBUG_FEC_SM_RESERVED1_FIELD_MASK  0x000000000000fc00
#define LIF_DEBUG_FEC_SM_RESERVED1_FIELD_WIDTH 6
#define LIF_DEBUG_FEC_SM_RESERVED1_FIELD_SHIFT 10

extern const ru_field_rec LIF_DEBUG_FEC_SM_RXCORCS_FIELD;
#define LIF_DEBUG_FEC_SM_RXCORCS_FIELD_MASK  0x0000000000000300
#define LIF_DEBUG_FEC_SM_RXCORCS_FIELD_WIDTH 2
#define LIF_DEBUG_FEC_SM_RXCORCS_FIELD_SHIFT 8

extern const ru_field_rec LIF_DEBUG_FEC_SM_RESERVED2_FIELD;
#define LIF_DEBUG_FEC_SM_RESERVED2_FIELD_MASK  0x00000000000000e0
#define LIF_DEBUG_FEC_SM_RESERVED2_FIELD_WIDTH 3
#define LIF_DEBUG_FEC_SM_RESERVED2_FIELD_SHIFT 5

extern const ru_field_rec LIF_DEBUG_FEC_SM_FECRXOUTCS_FIELD;
#define LIF_DEBUG_FEC_SM_FECRXOUTCS_FIELD_MASK  0x000000000000001f
#define LIF_DEBUG_FEC_SM_FECRXOUTCS_FIELD_WIDTH 5
#define LIF_DEBUG_FEC_SM_FECRXOUTCS_FIELD_SHIFT 0

extern const ru_field_rec LIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD;
#define LIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD_MASK  0x00000000ffffffff
#define LIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD_WIDTH 32
#define LIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD_SHIFT 0

extern const ru_field_rec LIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD;
#define LIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD_MASK  0x00000000ffffffff
#define LIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD_WIDTH 32
#define LIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD_SHIFT 0

extern const ru_field_rec LIF_AE_PKTNUM_STAT_RESERVED0_FIELD;
#define LIF_AE_PKTNUM_STAT_RESERVED0_FIELD_MASK  0x00000000ffe00000
#define LIF_AE_PKTNUM_STAT_RESERVED0_FIELD_WIDTH 11
#define LIF_AE_PKTNUM_STAT_RESERVED0_FIELD_SHIFT 21

extern const ru_field_rec LIF_AE_PKTNUM_STAT_SECUPINDXWTPKTNUMMAX_FIELD;
#define LIF_AE_PKTNUM_STAT_SECUPINDXWTPKTNUMMAX_FIELD_MASK  0x00000000001f0000
#define LIF_AE_PKTNUM_STAT_SECUPINDXWTPKTNUMMAX_FIELD_WIDTH 5
#define LIF_AE_PKTNUM_STAT_SECUPINDXWTPKTNUMMAX_FIELD_SHIFT 16

extern const ru_field_rec LIF_AE_PKTNUM_STAT_RESERVED1_FIELD;
#define LIF_AE_PKTNUM_STAT_RESERVED1_FIELD_MASK  0x000000000000ffe0
#define LIF_AE_PKTNUM_STAT_RESERVED1_FIELD_WIDTH 11
#define LIF_AE_PKTNUM_STAT_RESERVED1_FIELD_SHIFT 5

extern const ru_field_rec LIF_AE_PKTNUM_STAT_SECDNINDXWTPKTNUMABORT_FIELD;
#define LIF_AE_PKTNUM_STAT_SECDNINDXWTPKTNUMABORT_FIELD_MASK  0x000000000000001f
#define LIF_AE_PKTNUM_STAT_SECDNINDXWTPKTNUMABORT_FIELD_WIDTH 5
#define LIF_AE_PKTNUM_STAT_SECDNINDXWTPKTNUMABORT_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_8_RESERVED0_FIELD;
#define LIF_LLID_8_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_8_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_8_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_8_CFGLLID8_FIELD;
#define LIF_LLID_8_CFGLLID8_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_8_CFGLLID8_FIELD_WIDTH 17
#define LIF_LLID_8_CFGLLID8_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_9_RESERVED0_FIELD;
#define LIF_LLID_9_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_9_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_9_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_9_CFGLLID9_FIELD;
#define LIF_LLID_9_CFGLLID9_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_9_CFGLLID9_FIELD_WIDTH 17
#define LIF_LLID_9_CFGLLID9_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_10_RESERVED0_FIELD;
#define LIF_LLID_10_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_10_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_10_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_10_CFGLLID10_FIELD;
#define LIF_LLID_10_CFGLLID10_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_10_CFGLLID10_FIELD_WIDTH 17
#define LIF_LLID_10_CFGLLID10_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_11_RESERVED0_FIELD;
#define LIF_LLID_11_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_11_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_11_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_11_CFGLLID11_FIELD;
#define LIF_LLID_11_CFGLLID11_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_11_CFGLLID11_FIELD_WIDTH 17
#define LIF_LLID_11_CFGLLID11_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_12_RESERVED0_FIELD;
#define LIF_LLID_12_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_12_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_12_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_12_CFGLLID12_FIELD;
#define LIF_LLID_12_CFGLLID12_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_12_CFGLLID12_FIELD_WIDTH 17
#define LIF_LLID_12_CFGLLID12_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_13_RESERVED0_FIELD;
#define LIF_LLID_13_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_13_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_13_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_13_CFGLLID13_FIELD;
#define LIF_LLID_13_CFGLLID13_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_13_CFGLLID13_FIELD_WIDTH 17
#define LIF_LLID_13_CFGLLID13_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_14_RESERVED0_FIELD;
#define LIF_LLID_14_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_14_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_14_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_14_CFGLLID14_FIELD;
#define LIF_LLID_14_CFGLLID14_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_14_CFGLLID14_FIELD_WIDTH 17
#define LIF_LLID_14_CFGLLID14_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_15_RESERVED0_FIELD;
#define LIF_LLID_15_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_15_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_15_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_15_CFGLLID15_FIELD;
#define LIF_LLID_15_CFGLLID15_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_15_CFGLLID15_FIELD_WIDTH 17
#define LIF_LLID_15_CFGLLID15_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_24_RESERVED0_FIELD;
#define LIF_LLID_24_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_24_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_24_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_24_CFGLLID24_FIELD;
#define LIF_LLID_24_CFGLLID24_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_24_CFGLLID24_FIELD_WIDTH 17
#define LIF_LLID_24_CFGLLID24_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_25_RESERVED0_FIELD;
#define LIF_LLID_25_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_25_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_25_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_25_CFGLLID25_FIELD;
#define LIF_LLID_25_CFGLLID25_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_25_CFGLLID25_FIELD_WIDTH 17
#define LIF_LLID_25_CFGLLID25_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_26_RESERVED0_FIELD;
#define LIF_LLID_26_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_26_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_26_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_26_CFGLLID26_FIELD;
#define LIF_LLID_26_CFGLLID26_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_26_CFGLLID26_FIELD_WIDTH 17
#define LIF_LLID_26_CFGLLID26_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_27_RESERVED0_FIELD;
#define LIF_LLID_27_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_27_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_27_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_27_CFGLLID27_FIELD;
#define LIF_LLID_27_CFGLLID27_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_27_CFGLLID27_FIELD_WIDTH 17
#define LIF_LLID_27_CFGLLID27_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_28_RESERVED0_FIELD;
#define LIF_LLID_28_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_28_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_28_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_28_CFGLLID28_FIELD;
#define LIF_LLID_28_CFGLLID28_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_28_CFGLLID28_FIELD_WIDTH 17
#define LIF_LLID_28_CFGLLID28_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_29_RESERVED0_FIELD;
#define LIF_LLID_29_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_29_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_29_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_29_CFGLLID29_FIELD;
#define LIF_LLID_29_CFGLLID29_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_29_CFGLLID29_FIELD_WIDTH 17
#define LIF_LLID_29_CFGLLID29_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_30_RESERVED0_FIELD;
#define LIF_LLID_30_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_30_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_30_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_30_CFGLLID30_FIELD;
#define LIF_LLID_30_CFGLLID30_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_30_CFGLLID30_FIELD_WIDTH 17
#define LIF_LLID_30_CFGLLID30_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_31_RESERVED0_FIELD;
#define LIF_LLID_31_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_31_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_31_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_31_CFGLLID31_FIELD;
#define LIF_LLID_31_CFGLLID31_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_31_CFGLLID31_FIELD_WIDTH 17
#define LIF_LLID_31_CFGLLID31_FIELD_SHIFT 0

extern const ru_field_rec LIF_VLAN_TYPE_RESERVED0_FIELD;
#define LIF_VLAN_TYPE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_VLAN_TYPE_RESERVED0_FIELD_WIDTH 16
#define LIF_VLAN_TYPE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_VLAN_TYPE_CFGVLANTYPE_FIELD;
#define LIF_VLAN_TYPE_CFGVLANTYPE_FIELD_MASK  0x000000000000ffff
#define LIF_VLAN_TYPE_CFGVLANTYPE_FIELD_WIDTH 16
#define LIF_VLAN_TYPE_CFGVLANTYPE_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_EN_RESERVED0_FIELD;
#define LIF_P2P_AE_SCI_EN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_P2P_AE_SCI_EN_RESERVED0_FIELD_WIDTH 16
#define LIF_P2P_AE_SCI_EN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_P2P_AE_SCI_EN_CFGP2PSCIEN_FIELD;
#define LIF_P2P_AE_SCI_EN_CFGP2PSCIEN_FIELD_MASK  0x000000000000ffff
#define LIF_P2P_AE_SCI_EN_CFGP2PSCIEN_FIELD_WIDTH 16
#define LIF_P2P_AE_SCI_EN_CFGP2PSCIEN_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_0_CFGP2PSCI_LO_0_FIELD;
#define LIF_P2P_AE_SCI_LO_0_CFGP2PSCI_LO_0_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_0_CFGP2PSCI_LO_0_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_0_CFGP2PSCI_LO_0_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_0_CFGP2PSCI_HI_0_FIELD;
#define LIF_P2P_AE_SCI_HI_0_CFGP2PSCI_HI_0_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_0_CFGP2PSCI_HI_0_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_0_CFGP2PSCI_HI_0_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_1_CFGP2PSCI_LO_1_FIELD;
#define LIF_P2P_AE_SCI_LO_1_CFGP2PSCI_LO_1_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_1_CFGP2PSCI_LO_1_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_1_CFGP2PSCI_LO_1_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_1_CFGP2PSCI_HI_1_FIELD;
#define LIF_P2P_AE_SCI_HI_1_CFGP2PSCI_HI_1_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_1_CFGP2PSCI_HI_1_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_1_CFGP2PSCI_HI_1_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_2_CFGP2PSCI_LO_2_FIELD;
#define LIF_P2P_AE_SCI_LO_2_CFGP2PSCI_LO_2_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_2_CFGP2PSCI_LO_2_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_2_CFGP2PSCI_LO_2_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_2_CFGP2PSCI_HI_2_FIELD;
#define LIF_P2P_AE_SCI_HI_2_CFGP2PSCI_HI_2_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_2_CFGP2PSCI_HI_2_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_2_CFGP2PSCI_HI_2_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_3_CFGP2PSCI_LO_3_FIELD;
#define LIF_P2P_AE_SCI_LO_3_CFGP2PSCI_LO_3_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_3_CFGP2PSCI_LO_3_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_3_CFGP2PSCI_LO_3_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_3_CFGP2PSCI_HI_3_FIELD;
#define LIF_P2P_AE_SCI_HI_3_CFGP2PSCI_HI_3_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_3_CFGP2PSCI_HI_3_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_3_CFGP2PSCI_HI_3_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_4_CFGP2PSCI_LO_4_FIELD;
#define LIF_P2P_AE_SCI_LO_4_CFGP2PSCI_LO_4_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_4_CFGP2PSCI_LO_4_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_4_CFGP2PSCI_LO_4_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_4_CFGP2PSCI_HI_4_FIELD;
#define LIF_P2P_AE_SCI_HI_4_CFGP2PSCI_HI_4_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_4_CFGP2PSCI_HI_4_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_4_CFGP2PSCI_HI_4_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_5_CFGP2PSCI_LO_5_FIELD;
#define LIF_P2P_AE_SCI_LO_5_CFGP2PSCI_LO_5_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_5_CFGP2PSCI_LO_5_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_5_CFGP2PSCI_LO_5_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_5_CFGP2PSCI_HI_5_FIELD;
#define LIF_P2P_AE_SCI_HI_5_CFGP2PSCI_HI_5_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_5_CFGP2PSCI_HI_5_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_5_CFGP2PSCI_HI_5_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_6_CFGP2PSCI_LO_6_FIELD;
#define LIF_P2P_AE_SCI_LO_6_CFGP2PSCI_LO_6_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_6_CFGP2PSCI_LO_6_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_6_CFGP2PSCI_LO_6_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_6_CFGP2PSCI_HI_6_FIELD;
#define LIF_P2P_AE_SCI_HI_6_CFGP2PSCI_HI_6_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_6_CFGP2PSCI_HI_6_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_6_CFGP2PSCI_HI_6_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_7_CFGP2PSCI_LO_7_FIELD;
#define LIF_P2P_AE_SCI_LO_7_CFGP2PSCI_LO_7_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_7_CFGP2PSCI_LO_7_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_7_CFGP2PSCI_LO_7_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_7_CFGP2PSCI_HI_7_FIELD;
#define LIF_P2P_AE_SCI_HI_7_CFGP2PSCI_HI_7_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_7_CFGP2PSCI_HI_7_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_7_CFGP2PSCI_HI_7_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_8_CFGP2PSCI_LO_8_FIELD;
#define LIF_P2P_AE_SCI_LO_8_CFGP2PSCI_LO_8_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_8_CFGP2PSCI_LO_8_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_8_CFGP2PSCI_LO_8_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_8_CFGP2PSCI_HI_8_FIELD;
#define LIF_P2P_AE_SCI_HI_8_CFGP2PSCI_HI_8_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_8_CFGP2PSCI_HI_8_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_8_CFGP2PSCI_HI_8_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_9_CFGP2PSCI_LO_9_FIELD;
#define LIF_P2P_AE_SCI_LO_9_CFGP2PSCI_LO_9_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_9_CFGP2PSCI_LO_9_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_9_CFGP2PSCI_LO_9_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_9_CFGP2PSCI_HI_9_FIELD;
#define LIF_P2P_AE_SCI_HI_9_CFGP2PSCI_HI_9_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_9_CFGP2PSCI_HI_9_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_9_CFGP2PSCI_HI_9_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_10_CFGP2PSCI_LO_10_FIELD;
#define LIF_P2P_AE_SCI_LO_10_CFGP2PSCI_LO_10_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_10_CFGP2PSCI_LO_10_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_10_CFGP2PSCI_LO_10_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_10_CFGP2PSCI_HI_10_FIELD;
#define LIF_P2P_AE_SCI_HI_10_CFGP2PSCI_HI_10_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_10_CFGP2PSCI_HI_10_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_10_CFGP2PSCI_HI_10_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_11_CFGP2PSCI_LO_11_FIELD;
#define LIF_P2P_AE_SCI_LO_11_CFGP2PSCI_LO_11_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_11_CFGP2PSCI_LO_11_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_11_CFGP2PSCI_LO_11_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_11_CFGP2PSCI_HI_11_FIELD;
#define LIF_P2P_AE_SCI_HI_11_CFGP2PSCI_HI_11_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_11_CFGP2PSCI_HI_11_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_11_CFGP2PSCI_HI_11_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_12_CFGP2PSCI_LO_12_FIELD;
#define LIF_P2P_AE_SCI_LO_12_CFGP2PSCI_LO_12_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_12_CFGP2PSCI_LO_12_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_12_CFGP2PSCI_LO_12_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_12_CFGP2PSCI_HI_12_FIELD;
#define LIF_P2P_AE_SCI_HI_12_CFGP2PSCI_HI_12_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_12_CFGP2PSCI_HI_12_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_12_CFGP2PSCI_HI_12_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_13_CFGP2PSCI_LO_13_FIELD;
#define LIF_P2P_AE_SCI_LO_13_CFGP2PSCI_LO_13_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_13_CFGP2PSCI_LO_13_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_13_CFGP2PSCI_LO_13_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_13_CFGP2PSCI_HI_13_FIELD;
#define LIF_P2P_AE_SCI_HI_13_CFGP2PSCI_HI_13_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_13_CFGP2PSCI_HI_13_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_13_CFGP2PSCI_HI_13_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_14_CFGP2PSCI_LO_14_FIELD;
#define LIF_P2P_AE_SCI_LO_14_CFGP2PSCI_LO_14_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_14_CFGP2PSCI_LO_14_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_14_CFGP2PSCI_LO_14_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_14_CFGP2PSCI_HI_14_FIELD;
#define LIF_P2P_AE_SCI_HI_14_CFGP2PSCI_HI_14_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_14_CFGP2PSCI_HI_14_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_14_CFGP2PSCI_HI_14_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_LO_15_CFGP2PSCI_LO_15_FIELD;
#define LIF_P2P_AE_SCI_LO_15_CFGP2PSCI_LO_15_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_LO_15_CFGP2PSCI_LO_15_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_LO_15_CFGP2PSCI_LO_15_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AE_SCI_HI_15_CFGP2PSCI_HI_15_FIELD;
#define LIF_P2P_AE_SCI_HI_15_CFGP2PSCI_HI_15_FIELD_MASK  0x00000000ffffffff
#define LIF_P2P_AE_SCI_HI_15_CFGP2PSCI_HI_15_FIELD_WIDTH 32
#define LIF_P2P_AE_SCI_HI_15_CFGP2PSCI_HI_15_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_UP_KEY_STAT_1_KEYUPSEL_HI_FIELD;
#define LIF_SEC_UP_KEY_STAT_1_KEYUPSEL_HI_FIELD_MASK  0x00000000ffffffff
#define LIF_SEC_UP_KEY_STAT_1_KEYUPSEL_HI_FIELD_WIDTH 32
#define LIF_SEC_UP_KEY_STAT_1_KEYUPSEL_HI_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_KEY_SEL_1_KEYSEL_HI_FIELD;
#define LIF_SEC_KEY_SEL_1_KEYSEL_HI_FIELD_MASK  0x00000000ffffffff
#define LIF_SEC_KEY_SEL_1_KEYSEL_HI_FIELD_WIDTH 32
#define LIF_SEC_KEY_SEL_1_KEYSEL_HI_FIELD_SHIFT 0

extern const ru_field_rec LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_RESERVED0_FIELD;
#define LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_RESERVED0_FIELD_MASK  0x00000000fffff000
#define LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_RESERVED0_FIELD_WIDTH 20
#define LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_RESERVED0_FIELD_SHIFT 12

extern const ru_field_rec LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_CF_PLAINTXT_OH_B_IDLE_PAD_FIELD;
#define LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_CF_PLAINTXT_OH_B_IDLE_PAD_FIELD_MASK  0x0000000000000fc0
#define LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_CF_PLAINTXT_OH_B_IDLE_PAD_FIELD_WIDTH 6
#define LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_CF_PLAINTXT_OH_B_IDLE_PAD_FIELD_SHIFT 6

extern const ru_field_rec LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_CF_PLAINTXT_OH_A_IDLE_PAD_FIELD;
#define LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_CF_PLAINTXT_OH_A_IDLE_PAD_FIELD_MASK  0x000000000000003f
#define LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_CF_PLAINTXT_OH_A_IDLE_PAD_FIELD_WIDTH 6
#define LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_CF_PLAINTXT_OH_A_IDLE_PAD_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_LINKTIMER_FIELD;
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_LINKTIMER_FIELD_MASK  0x00000000ffff0000
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_LINKTIMER_FIELD_WIDTH 16
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_LINKTIMER_FIELD_SHIFT 16

extern const ru_field_rec LIF_P2P_AUTONEG_CONTROL_RESERVED0_FIELD;
#define LIF_P2P_AUTONEG_CONTROL_RESERVED0_FIELD_MASK  0x000000000000fff8
#define LIF_P2P_AUTONEG_CONTROL_RESERVED0_FIELD_WIDTH 13
#define LIF_P2P_AUTONEG_CONTROL_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_MODE_SEL_FIELD;
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_MODE_SEL_FIELD_MASK  0x0000000000000004
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_MODE_SEL_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_MODE_SEL_FIELD_SHIFT 2

extern const ru_field_rec LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_RESTART_FIELD;
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_RESTART_FIELD_MASK  0x0000000000000002
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_RESTART_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_RESTART_FIELD_SHIFT 1

extern const ru_field_rec LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_EN_FIELD;
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_EN_FIELD_MASK  0x0000000000000001
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_EN_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_EN_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AUTONEG_STATUS_RESERVED0_FIELD;
#define LIF_P2P_AUTONEG_STATUS_RESERVED0_FIELD_MASK  0x00000000fffffff8
#define LIF_P2P_AUTONEG_STATUS_RESERVED0_FIELD_WIDTH 29
#define LIF_P2P_AUTONEG_STATUS_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec LIF_P2P_AUTONEG_STATUS_AN_LP_REMOTE_FAULT_FIELD;
#define LIF_P2P_AUTONEG_STATUS_AN_LP_REMOTE_FAULT_FIELD_MASK  0x0000000000000004
#define LIF_P2P_AUTONEG_STATUS_AN_LP_REMOTE_FAULT_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_STATUS_AN_LP_REMOTE_FAULT_FIELD_SHIFT 2

extern const ru_field_rec LIF_P2P_AUTONEG_STATUS_AN_SYNC_STATUS_FIELD;
#define LIF_P2P_AUTONEG_STATUS_AN_SYNC_STATUS_FIELD_MASK  0x0000000000000002
#define LIF_P2P_AUTONEG_STATUS_AN_SYNC_STATUS_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_STATUS_AN_SYNC_STATUS_FIELD_SHIFT 1

extern const ru_field_rec LIF_P2P_AUTONEG_STATUS_AN_COMPLETE_FIELD;
#define LIF_P2P_AUTONEG_STATUS_AN_COMPLETE_FIELD_MASK  0x0000000000000001
#define LIF_P2P_AUTONEG_STATUS_AN_COMPLETE_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_STATUS_AN_COMPLETE_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_RESERVED0_FIELD;
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_RESERVED0_FIELD_WIDTH 16
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_CF_LIF_P2P_AE_AUTONEG_CONFIG_ABILITY_FIELD;
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_CF_LIF_P2P_AE_AUTONEG_CONFIG_ABILITY_FIELD_MASK  0x000000000000ffff
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_CF_LIF_P2P_AE_AUTONEG_CONFIG_ABILITY_FIELD_WIDTH 16
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_CF_LIF_P2P_AE_AUTONEG_CONFIG_ABILITY_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_RESERVED0_FIELD;
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_RESERVED0_FIELD_WIDTH 16
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_CF_LIF_P2P_AE_AUTONEG_LP_ABILITY_READ_FIELD;
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_CF_LIF_P2P_AE_AUTONEG_LP_ABILITY_READ_FIELD_MASK  0x000000000000ffff
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_CF_LIF_P2P_AE_AUTONEG_LP_ABILITY_READ_FIELD_WIDTH 16
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_CF_LIF_P2P_AE_AUTONEG_LP_ABILITY_READ_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_CFG_RESERVED0_FIELD;
#define NCO_ADDR_NCO_CFG_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define NCO_ADDR_NCO_CFG_RESERVED0_FIELD_WIDTH 24
#define NCO_ADDR_NCO_CFG_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec NCO_ADDR_NCO_CFG_CFGBYPASS_FIELD;
#define NCO_ADDR_NCO_CFG_CFGBYPASS_FIELD_MASK  0x0000000000000080
#define NCO_ADDR_NCO_CFG_CFGBYPASS_FIELD_WIDTH 1
#define NCO_ADDR_NCO_CFG_CFGBYPASS_FIELD_SHIFT 7

extern const ru_field_rec NCO_ADDR_NCO_CFG_CFGSRCOUT10MHZ_FIELD;
#define NCO_ADDR_NCO_CFG_CFGSRCOUT10MHZ_FIELD_MASK  0x0000000000000060
#define NCO_ADDR_NCO_CFG_CFGSRCOUT10MHZ_FIELD_WIDTH 2
#define NCO_ADDR_NCO_CFG_CFGSRCOUT10MHZ_FIELD_SHIFT 5

extern const ru_field_rec NCO_ADDR_NCO_CFG_CFGSRCOUT_FIELD;
#define NCO_ADDR_NCO_CFG_CFGSRCOUT_FIELD_MASK  0x0000000000000018
#define NCO_ADDR_NCO_CFG_CFGSRCOUT_FIELD_WIDTH 2
#define NCO_ADDR_NCO_CFG_CFGSRCOUT_FIELD_SHIFT 3

extern const ru_field_rec NCO_ADDR_NCO_CFG_CFGSRCIN_FIELD;
#define NCO_ADDR_NCO_CFG_CFGSRCIN_FIELD_MASK  0x0000000000000006
#define NCO_ADDR_NCO_CFG_CFGSRCIN_FIELD_WIDTH 2
#define NCO_ADDR_NCO_CFG_CFGSRCIN_FIELD_SHIFT 1

extern const ru_field_rec NCO_ADDR_NCO_CFG_CFGNCOCLR_FIELD;
#define NCO_ADDR_NCO_CFG_CFGNCOCLR_FIELD_MASK  0x0000000000000001
#define NCO_ADDR_NCO_CFG_CFGNCOCLR_FIELD_WIDTH 1
#define NCO_ADDR_NCO_CFG_CFGNCOCLR_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_INT_RESERVED0_FIELD;
#define NCO_ADDR_NCO_INT_RESERVED0_FIELD_MASK  0x00000000fffffff8
#define NCO_ADDR_NCO_INT_RESERVED0_FIELD_WIDTH 29
#define NCO_ADDR_NCO_INT_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec NCO_ADDR_NCO_INT_INTNONCOSYNC_FIELD;
#define NCO_ADDR_NCO_INT_INTNONCOSYNC_FIELD_MASK  0x0000000000000004
#define NCO_ADDR_NCO_INT_INTNONCOSYNC_FIELD_WIDTH 1
#define NCO_ADDR_NCO_INT_INTNONCOSYNC_FIELD_SHIFT 2

extern const ru_field_rec NCO_ADDR_NCO_INT_INTNOXIFPPS_FIELD;
#define NCO_ADDR_NCO_INT_INTNOXIFPPS_FIELD_MASK  0x0000000000000002
#define NCO_ADDR_NCO_INT_INTNOXIFPPS_FIELD_WIDTH 1
#define NCO_ADDR_NCO_INT_INTNOXIFPPS_FIELD_SHIFT 1

extern const ru_field_rec NCO_ADDR_NCO_INT_INTNOLIFPPS_FIELD;
#define NCO_ADDR_NCO_INT_INTNOLIFPPS_FIELD_MASK  0x0000000000000001
#define NCO_ADDR_NCO_INT_INTNOLIFPPS_FIELD_WIDTH 1
#define NCO_ADDR_NCO_INT_INTNOLIFPPS_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_MSK_RESERVED0_FIELD;
#define NCO_ADDR_NCO_MSK_RESERVED0_FIELD_MASK  0x00000000fffffff8
#define NCO_ADDR_NCO_MSK_RESERVED0_FIELD_WIDTH 29
#define NCO_ADDR_NCO_MSK_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec NCO_ADDR_NCO_MSK_INTNONCOSYNCMASK_FIELD;
#define NCO_ADDR_NCO_MSK_INTNONCOSYNCMASK_FIELD_MASK  0x0000000000000004
#define NCO_ADDR_NCO_MSK_INTNONCOSYNCMASK_FIELD_WIDTH 1
#define NCO_ADDR_NCO_MSK_INTNONCOSYNCMASK_FIELD_SHIFT 2

extern const ru_field_rec NCO_ADDR_NCO_MSK_INTNOXIFPPSMASK_FIELD;
#define NCO_ADDR_NCO_MSK_INTNOXIFPPSMASK_FIELD_MASK  0x0000000000000002
#define NCO_ADDR_NCO_MSK_INTNOXIFPPSMASK_FIELD_WIDTH 1
#define NCO_ADDR_NCO_MSK_INTNOXIFPPSMASK_FIELD_SHIFT 1

extern const ru_field_rec NCO_ADDR_NCO_MSK_INTNOLIFPPSMASK_FIELD;
#define NCO_ADDR_NCO_MSK_INTNOLIFPPSMASK_FIELD_MASK  0x0000000000000001
#define NCO_ADDR_NCO_MSK_INTNOLIFPPSMASK_FIELD_WIDTH 1
#define NCO_ADDR_NCO_MSK_INTNOLIFPPSMASK_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_1PPS_PERIOD_RESERVED0_FIELD;
#define NCO_ADDR_NCO_1PPS_PERIOD_RESERVED0_FIELD_MASK  0x00000000ff000000
#define NCO_ADDR_NCO_1PPS_PERIOD_RESERVED0_FIELD_WIDTH 8
#define NCO_ADDR_NCO_1PPS_PERIOD_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec NCO_ADDR_NCO_1PPS_PERIOD_CFG1PPSPERIOD_FIELD;
#define NCO_ADDR_NCO_1PPS_PERIOD_CFG1PPSPERIOD_FIELD_MASK  0x0000000000ffffff
#define NCO_ADDR_NCO_1PPS_PERIOD_CFG1PPSPERIOD_FIELD_WIDTH 24
#define NCO_ADDR_NCO_1PPS_PERIOD_CFG1PPSPERIOD_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_8KHZ_PERIOD_RESERVED0_FIELD;
#define NCO_ADDR_NCO_8KHZ_PERIOD_RESERVED0_FIELD_MASK  0x00000000ff000000
#define NCO_ADDR_NCO_8KHZ_PERIOD_RESERVED0_FIELD_WIDTH 8
#define NCO_ADDR_NCO_8KHZ_PERIOD_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec NCO_ADDR_NCO_8KHZ_PERIOD_CFG8KHZPERIOD_FIELD;
#define NCO_ADDR_NCO_8KHZ_PERIOD_CFG8KHZPERIOD_FIELD_MASK  0x0000000000ffffff
#define NCO_ADDR_NCO_8KHZ_PERIOD_CFG8KHZPERIOD_FIELD_WIDTH 24
#define NCO_ADDR_NCO_8KHZ_PERIOD_CFG8KHZPERIOD_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_CENTER_FREQUENCY_CFGNCODEFAULT_FIELD;
#define NCO_ADDR_NCO_CENTER_FREQUENCY_CFGNCODEFAULT_FIELD_MASK  0x00000000ffffffff
#define NCO_ADDR_NCO_CENTER_FREQUENCY_CFGNCODEFAULT_FIELD_WIDTH 32
#define NCO_ADDR_NCO_CENTER_FREQUENCY_CFGNCODEFAULT_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_INT_GAIN_RESERVED0_FIELD;
#define NCO_ADDR_NCO_INT_GAIN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define NCO_ADDR_NCO_INT_GAIN_RESERVED0_FIELD_WIDTH 16
#define NCO_ADDR_NCO_INT_GAIN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec NCO_ADDR_NCO_INT_GAIN_CFGNCOGAIN_FIELD;
#define NCO_ADDR_NCO_INT_GAIN_CFGNCOGAIN_FIELD_MASK  0x000000000000ffff
#define NCO_ADDR_NCO_INT_GAIN_CFGNCOGAIN_FIELD_WIDTH 16
#define NCO_ADDR_NCO_INT_GAIN_CFGNCOGAIN_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_PRO_GAIN_RESERVED0_FIELD;
#define NCO_ADDR_NCO_PRO_GAIN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define NCO_ADDR_NCO_PRO_GAIN_RESERVED0_FIELD_WIDTH 16
#define NCO_ADDR_NCO_PRO_GAIN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec NCO_ADDR_NCO_PRO_GAIN_CFGNCOPROPGAIN_FIELD;
#define NCO_ADDR_NCO_PRO_GAIN_CFGNCOPROPGAIN_FIELD_MASK  0x000000000000ffff
#define NCO_ADDR_NCO_PRO_GAIN_CFGNCOPROPGAIN_FIELD_WIDTH 16
#define NCO_ADDR_NCO_PRO_GAIN_CFGNCOPROPGAIN_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_CNT_NCOCNT_FIELD;
#define NCO_ADDR_NCO_CNT_NCOCNT_FIELD_MASK  0x00000000ffffffff
#define NCO_ADDR_NCO_CNT_NCOCNT_FIELD_WIDTH 32
#define NCO_ADDR_NCO_CNT_NCOCNT_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_1PPS_HALF_RESERVED0_FIELD;
#define NCO_ADDR_NCO_1PPS_HALF_RESERVED0_FIELD_MASK  0x00000000ff000000
#define NCO_ADDR_NCO_1PPS_HALF_RESERVED0_FIELD_WIDTH 8
#define NCO_ADDR_NCO_1PPS_HALF_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec NCO_ADDR_NCO_1PPS_HALF_CFG1PPSHALFPERIOD_FIELD;
#define NCO_ADDR_NCO_1PPS_HALF_CFG1PPSHALFPERIOD_FIELD_MASK  0x0000000000ffffff
#define NCO_ADDR_NCO_1PPS_HALF_CFG1PPSHALFPERIOD_FIELD_WIDTH 24
#define NCO_ADDR_NCO_1PPS_HALF_CFG1PPSHALFPERIOD_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_8KHZ_HALF_RESERVED0_FIELD;
#define NCO_ADDR_NCO_8KHZ_HALF_RESERVED0_FIELD_MASK  0x00000000ff000000
#define NCO_ADDR_NCO_8KHZ_HALF_RESERVED0_FIELD_WIDTH 8
#define NCO_ADDR_NCO_8KHZ_HALF_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec NCO_ADDR_NCO_8KHZ_HALF_CFG8KHZHALFPERIOD_FIELD;
#define NCO_ADDR_NCO_8KHZ_HALF_CFG8KHZHALFPERIOD_FIELD_MASK  0x0000000000ffffff
#define NCO_ADDR_NCO_8KHZ_HALF_CFG8KHZHALFPERIOD_FIELD_WIDTH 24
#define NCO_ADDR_NCO_8KHZ_HALF_CFG8KHZHALFPERIOD_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_PERIOD_CNT_PERIODCNT_FIELD;
#define NCO_ADDR_NCO_PERIOD_CNT_PERIODCNT_FIELD_MASK  0x00000000ffffffff
#define NCO_ADDR_NCO_PERIOD_CNT_PERIODCNT_FIELD_WIDTH 32
#define NCO_ADDR_NCO_PERIOD_CNT_PERIODCNT_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_PHS_ERR_CNT_RESERVED0_FIELD;
#define NCO_ADDR_NCO_PHS_ERR_CNT_RESERVED0_FIELD_MASK  0x00000000fffff000
#define NCO_ADDR_NCO_PHS_ERR_CNT_RESERVED0_FIELD_WIDTH 20
#define NCO_ADDR_NCO_PHS_ERR_CNT_RESERVED0_FIELD_SHIFT 12

extern const ru_field_rec NCO_ADDR_NCO_PHS_ERR_CNT_NCOPHSERR_FIELD;
#define NCO_ADDR_NCO_PHS_ERR_CNT_NCOPHSERR_FIELD_MASK  0x0000000000000fff
#define NCO_ADDR_NCO_PHS_ERR_CNT_NCOPHSERR_FIELD_WIDTH 12
#define NCO_ADDR_NCO_PHS_ERR_CNT_NCOPHSERR_FIELD_SHIFT 0

extern const ru_field_rec XIF_CTL_RXENCRYPTEN_FIELD;
#define XIF_CTL_RXENCRYPTEN_FIELD_MASK  0x0000000080000000
#define XIF_CTL_RXENCRYPTEN_FIELD_WIDTH 1
#define XIF_CTL_RXENCRYPTEN_FIELD_SHIFT 31

extern const ru_field_rec XIF_CTL_CFGDISRXDASAENCRPT_FIELD;
#define XIF_CTL_CFGDISRXDASAENCRPT_FIELD_MASK  0x0000000040000000
#define XIF_CTL_CFGDISRXDASAENCRPT_FIELD_WIDTH 1
#define XIF_CTL_CFGDISRXDASAENCRPT_FIELD_SHIFT 30

extern const ru_field_rec XIF_CTL_RXENCRYPTMODE_FIELD;
#define XIF_CTL_RXENCRYPTMODE_FIELD_MASK  0x0000000030000000
#define XIF_CTL_RXENCRYPTMODE_FIELD_WIDTH 2
#define XIF_CTL_RXENCRYPTMODE_FIELD_SHIFT 28

extern const ru_field_rec XIF_CTL_TXENCRYPTEN_FIELD;
#define XIF_CTL_TXENCRYPTEN_FIELD_MASK  0x0000000008000000
#define XIF_CTL_TXENCRYPTEN_FIELD_WIDTH 1
#define XIF_CTL_TXENCRYPTEN_FIELD_SHIFT 27

extern const ru_field_rec XIF_CTL_CFGDISTXDASAENCRPT_FIELD;
#define XIF_CTL_CFGDISTXDASAENCRPT_FIELD_MASK  0x0000000004000000
#define XIF_CTL_CFGDISTXDASAENCRPT_FIELD_WIDTH 1
#define XIF_CTL_CFGDISTXDASAENCRPT_FIELD_SHIFT 26

extern const ru_field_rec XIF_CTL_TXENCRYPTMODE_FIELD;
#define XIF_CTL_TXENCRYPTMODE_FIELD_MASK  0x0000000003000000
#define XIF_CTL_TXENCRYPTMODE_FIELD_WIDTH 2
#define XIF_CTL_TXENCRYPTMODE_FIELD_SHIFT 24

extern const ru_field_rec XIF_CTL_RESERVED0_FIELD;
#define XIF_CTL_RESERVED0_FIELD_MASK  0x0000000000800000
#define XIF_CTL_RESERVED0_FIELD_WIDTH 1
#define XIF_CTL_RESERVED0_FIELD_SHIFT 23

extern const ru_field_rec XIF_CTL_CFGLLIDMODEMSK_FIELD;
#define XIF_CTL_CFGLLIDMODEMSK_FIELD_MASK  0x0000000000400000
#define XIF_CTL_CFGLLIDMODEMSK_FIELD_WIDTH 1
#define XIF_CTL_CFGLLIDMODEMSK_FIELD_SHIFT 22

extern const ru_field_rec XIF_CTL_CFGXPNBADCRC32_FIELD;
#define XIF_CTL_CFGXPNBADCRC32_FIELD_MASK  0x0000000000200000
#define XIF_CTL_CFGXPNBADCRC32_FIELD_WIDTH 1
#define XIF_CTL_CFGXPNBADCRC32_FIELD_SHIFT 21

extern const ru_field_rec XIF_CTL_CFGDISDISCINFO_FIELD;
#define XIF_CTL_CFGDISDISCINFO_FIELD_MASK  0x0000000000100000
#define XIF_CTL_CFGDISDISCINFO_FIELD_WIDTH 1
#define XIF_CTL_CFGDISDISCINFO_FIELD_SHIFT 20

extern const ru_field_rec XIF_CTL_CFGPMCTX2RXLPBK_FIELD;
#define XIF_CTL_CFGPMCTX2RXLPBK_FIELD_MASK  0x0000000000080000
#define XIF_CTL_CFGPMCTX2RXLPBK_FIELD_WIDTH 1
#define XIF_CTL_CFGPMCTX2RXLPBK_FIELD_SHIFT 19

extern const ru_field_rec XIF_CTL_CFGPMCTXENCRC8BAD_FIELD;
#define XIF_CTL_CFGPMCTXENCRC8BAD_FIELD_MASK  0x0000000000040000
#define XIF_CTL_CFGPMCTXENCRC8BAD_FIELD_WIDTH 1
#define XIF_CTL_CFGPMCTXENCRC8BAD_FIELD_SHIFT 18

extern const ru_field_rec XIF_CTL_CFGENP2P_FIELD;
#define XIF_CTL_CFGENP2P_FIELD_MASK  0x0000000000020000
#define XIF_CTL_CFGENP2P_FIELD_WIDTH 1
#define XIF_CTL_CFGENP2P_FIELD_SHIFT 17

extern const ru_field_rec XIF_CTL_CFGLLIDPROMISCUOUSMODE_FIELD;
#define XIF_CTL_CFGLLIDPROMISCUOUSMODE_FIELD_MASK  0x0000000000010000
#define XIF_CTL_CFGLLIDPROMISCUOUSMODE_FIELD_WIDTH 1
#define XIF_CTL_CFGLLIDPROMISCUOUSMODE_FIELD_SHIFT 16

extern const ru_field_rec XIF_CTL_CFGENIDLEPKTSUP_FIELD;
#define XIF_CTL_CFGENIDLEPKTSUP_FIELD_MASK  0x0000000000008000
#define XIF_CTL_CFGENIDLEPKTSUP_FIELD_WIDTH 1
#define XIF_CTL_CFGENIDLEPKTSUP_FIELD_SHIFT 15

extern const ru_field_rec XIF_CTL_CFGPMCRXENCRC8CHK_FIELD;
#define XIF_CTL_CFGPMCRXENCRC8CHK_FIELD_MASK  0x0000000000004000
#define XIF_CTL_CFGPMCRXENCRC8CHK_FIELD_WIDTH 1
#define XIF_CTL_CFGPMCRXENCRC8CHK_FIELD_SHIFT 14

extern const ru_field_rec XIF_CTL_CFGEN1STIDLEPKTCONVERT_FIELD;
#define XIF_CTL_CFGEN1STIDLEPKTCONVERT_FIELD_MASK  0x0000000000002000
#define XIF_CTL_CFGEN1STIDLEPKTCONVERT_FIELD_WIDTH 1
#define XIF_CTL_CFGEN1STIDLEPKTCONVERT_FIELD_SHIFT 13

extern const ru_field_rec XIF_CTL_CFGFECEN_FIELD;
#define XIF_CTL_CFGFECEN_FIELD_MASK  0x0000000000001000
#define XIF_CTL_CFGFECEN_FIELD_WIDTH 1
#define XIF_CTL_CFGFECEN_FIELD_SHIFT 12

extern const ru_field_rec XIF_CTL_CFGLEGACYRCVTSUPD_FIELD;
#define XIF_CTL_CFGLEGACYRCVTSUPD_FIELD_MASK  0x0000000000000800
#define XIF_CTL_CFGLEGACYRCVTSUPD_FIELD_WIDTH 1
#define XIF_CTL_CFGLEGACYRCVTSUPD_FIELD_SHIFT 11

extern const ru_field_rec XIF_CTL_CFGXPNENCRCPASSTHRU_FIELD;
#define XIF_CTL_CFGXPNENCRCPASSTHRU_FIELD_MASK  0x0000000000000400
#define XIF_CTL_CFGXPNENCRCPASSTHRU_FIELD_WIDTH 1
#define XIF_CTL_CFGXPNENCRCPASSTHRU_FIELD_SHIFT 10

extern const ru_field_rec XIF_CTL_CFGXPNDISTIMESTAMPMOD_FIELD;
#define XIF_CTL_CFGXPNDISTIMESTAMPMOD_FIELD_MASK  0x0000000000000200
#define XIF_CTL_CFGXPNDISTIMESTAMPMOD_FIELD_WIDTH 1
#define XIF_CTL_CFGXPNDISTIMESTAMPMOD_FIELD_SHIFT 9

extern const ru_field_rec XIF_CTL_XIFNOTRDY_FIELD;
#define XIF_CTL_XIFNOTRDY_FIELD_MASK  0x0000000000000100
#define XIF_CTL_XIFNOTRDY_FIELD_WIDTH 1
#define XIF_CTL_XIFNOTRDY_FIELD_SHIFT 8

extern const ru_field_rec XIF_CTL_XIFDTPORTRSTN_FIELD;
#define XIF_CTL_XIFDTPORTRSTN_FIELD_MASK  0x0000000000000080
#define XIF_CTL_XIFDTPORTRSTN_FIELD_WIDTH 1
#define XIF_CTL_XIFDTPORTRSTN_FIELD_SHIFT 7

extern const ru_field_rec XIF_CTL_XPNTXRSTN_FIELD;
#define XIF_CTL_XPNTXRSTN_FIELD_MASK  0x0000000000000040
#define XIF_CTL_XPNTXRSTN_FIELD_WIDTH 1
#define XIF_CTL_XPNTXRSTN_FIELD_SHIFT 6

extern const ru_field_rec XIF_CTL_PMCTXRSTN_FIELD;
#define XIF_CTL_PMCTXRSTN_FIELD_MASK  0x0000000000000020
#define XIF_CTL_PMCTXRSTN_FIELD_WIDTH 1
#define XIF_CTL_PMCTXRSTN_FIELD_SHIFT 5

extern const ru_field_rec XIF_CTL_SECTXRSTN_FIELD;
#define XIF_CTL_SECTXRSTN_FIELD_MASK  0x0000000000000010
#define XIF_CTL_SECTXRSTN_FIELD_WIDTH 1
#define XIF_CTL_SECTXRSTN_FIELD_SHIFT 4

extern const ru_field_rec XIF_CTL_CFGDISTXOAMENCRPT_FIELD;
#define XIF_CTL_CFGDISTXOAMENCRPT_FIELD_MASK  0x0000000000000008
#define XIF_CTL_CFGDISTXOAMENCRPT_FIELD_WIDTH 1
#define XIF_CTL_CFGDISTXOAMENCRPT_FIELD_SHIFT 3

extern const ru_field_rec XIF_CTL_CFGDISTXMPCPENCRPT_FIELD;
#define XIF_CTL_CFGDISTXMPCPENCRPT_FIELD_MASK  0x0000000000000004
#define XIF_CTL_CFGDISTXMPCPENCRPT_FIELD_WIDTH 1
#define XIF_CTL_CFGDISTXMPCPENCRPT_FIELD_SHIFT 2

extern const ru_field_rec XIF_CTL_PMCRXRSTN_FIELD;
#define XIF_CTL_PMCRXRSTN_FIELD_MASK  0x0000000000000002
#define XIF_CTL_PMCRXRSTN_FIELD_WIDTH 1
#define XIF_CTL_PMCRXRSTN_FIELD_SHIFT 1

extern const ru_field_rec XIF_CTL_SECRXRSTN_FIELD;
#define XIF_CTL_SECRXRSTN_FIELD_MASK  0x0000000000000001
#define XIF_CTL_SECRXRSTN_FIELD_WIDTH 1
#define XIF_CTL_SECRXRSTN_FIELD_SHIFT 0

extern const ru_field_rec XIF_INT_STATUS_RESERVED0_FIELD;
#define XIF_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XIF_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define XIF_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XIF_INT_STATUS_SECRXRPLYPRTCTABRTINT_FIELD;
#define XIF_INT_STATUS_SECRXRPLYPRTCTABRTINT_FIELD_MASK  0x0000000000000080
#define XIF_INT_STATUS_SECRXRPLYPRTCTABRTINT_FIELD_WIDTH 1
#define XIF_INT_STATUS_SECRXRPLYPRTCTABRTINT_FIELD_SHIFT 7

extern const ru_field_rec XIF_INT_STATUS_SECTXPKTNUMMAXINT_FIELD;
#define XIF_INT_STATUS_SECTXPKTNUMMAXINT_FIELD_MASK  0x0000000000000040
#define XIF_INT_STATUS_SECTXPKTNUMMAXINT_FIELD_WIDTH 1
#define XIF_INT_STATUS_SECTXPKTNUMMAXINT_FIELD_SHIFT 6

extern const ru_field_rec XIF_INT_STATUS_RESERVED1_FIELD;
#define XIF_INT_STATUS_RESERVED1_FIELD_MASK  0x0000000000000020
#define XIF_INT_STATUS_RESERVED1_FIELD_WIDTH 1
#define XIF_INT_STATUS_RESERVED1_FIELD_SHIFT 5

extern const ru_field_rec XIF_INT_STATUS_TSFULLUPDINT_FIELD;
#define XIF_INT_STATUS_TSFULLUPDINT_FIELD_MASK  0x0000000000000010
#define XIF_INT_STATUS_TSFULLUPDINT_FIELD_WIDTH 1
#define XIF_INT_STATUS_TSFULLUPDINT_FIELD_SHIFT 4

extern const ru_field_rec XIF_INT_STATUS_TXHANGINT_FIELD;
#define XIF_INT_STATUS_TXHANGINT_FIELD_MASK  0x0000000000000008
#define XIF_INT_STATUS_TXHANGINT_FIELD_WIDTH 1
#define XIF_INT_STATUS_TXHANGINT_FIELD_SHIFT 3

extern const ru_field_rec XIF_INT_STATUS_NEGTIMEINT_FIELD;
#define XIF_INT_STATUS_NEGTIMEINT_FIELD_MASK  0x0000000000000004
#define XIF_INT_STATUS_NEGTIMEINT_FIELD_WIDTH 1
#define XIF_INT_STATUS_NEGTIMEINT_FIELD_SHIFT 2

extern const ru_field_rec XIF_INT_STATUS_PMCTSJTTRINT_FIELD;
#define XIF_INT_STATUS_PMCTSJTTRINT_FIELD_MASK  0x0000000000000002
#define XIF_INT_STATUS_PMCTSJTTRINT_FIELD_WIDTH 1
#define XIF_INT_STATUS_PMCTSJTTRINT_FIELD_SHIFT 1

extern const ru_field_rec XIF_INT_STATUS_SECRXOUTFFOVRFLWINT_FIELD;
#define XIF_INT_STATUS_SECRXOUTFFOVRFLWINT_FIELD_MASK  0x0000000000000001
#define XIF_INT_STATUS_SECRXOUTFFOVRFLWINT_FIELD_WIDTH 1
#define XIF_INT_STATUS_SECRXOUTFFOVRFLWINT_FIELD_SHIFT 0

extern const ru_field_rec XIF_INT_MASK_RESERVED0_FIELD;
#define XIF_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XIF_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define XIF_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XIF_INT_MASK_MSKSECRXREPLAYPROTCTABORT_FIELD;
#define XIF_INT_MASK_MSKSECRXREPLAYPROTCTABORT_FIELD_MASK  0x0000000000000080
#define XIF_INT_MASK_MSKSECRXREPLAYPROTCTABORT_FIELD_WIDTH 1
#define XIF_INT_MASK_MSKSECRXREPLAYPROTCTABORT_FIELD_SHIFT 7

extern const ru_field_rec XIF_INT_MASK_MSKPKTNUMTHRESHINT_FIELD;
#define XIF_INT_MASK_MSKPKTNUMTHRESHINT_FIELD_MASK  0x0000000000000040
#define XIF_INT_MASK_MSKPKTNUMTHRESHINT_FIELD_WIDTH 1
#define XIF_INT_MASK_MSKPKTNUMTHRESHINT_FIELD_SHIFT 6

extern const ru_field_rec XIF_INT_MASK_RESERVED1_FIELD;
#define XIF_INT_MASK_RESERVED1_FIELD_MASK  0x0000000000000020
#define XIF_INT_MASK_RESERVED1_FIELD_WIDTH 1
#define XIF_INT_MASK_RESERVED1_FIELD_SHIFT 5

extern const ru_field_rec XIF_INT_MASK_MSKTSFULLUPDINT_FIELD;
#define XIF_INT_MASK_MSKTSFULLUPDINT_FIELD_MASK  0x0000000000000010
#define XIF_INT_MASK_MSKTSFULLUPDINT_FIELD_WIDTH 1
#define XIF_INT_MASK_MSKTSFULLUPDINT_FIELD_SHIFT 4

extern const ru_field_rec XIF_INT_MASK_MSKTXHANGINT_FIELD;
#define XIF_INT_MASK_MSKTXHANGINT_FIELD_MASK  0x0000000000000008
#define XIF_INT_MASK_MSKTXHANGINT_FIELD_WIDTH 1
#define XIF_INT_MASK_MSKTXHANGINT_FIELD_SHIFT 3

extern const ru_field_rec XIF_INT_MASK_MSKNEGTIMEINT_FIELD;
#define XIF_INT_MASK_MSKNEGTIMEINT_FIELD_MASK  0x0000000000000004
#define XIF_INT_MASK_MSKNEGTIMEINT_FIELD_WIDTH 1
#define XIF_INT_MASK_MSKNEGTIMEINT_FIELD_SHIFT 2

extern const ru_field_rec XIF_INT_MASK_MSKPMCTSJTTRINT_FIELD;
#define XIF_INT_MASK_MSKPMCTSJTTRINT_FIELD_MASK  0x0000000000000002
#define XIF_INT_MASK_MSKPMCTSJTTRINT_FIELD_WIDTH 1
#define XIF_INT_MASK_MSKPMCTSJTTRINT_FIELD_SHIFT 1

extern const ru_field_rec XIF_INT_MASK_MSKSECRXOUTFFINT_FIELD;
#define XIF_INT_MASK_MSKSECRXOUTFFINT_FIELD_MASK  0x0000000000000001
#define XIF_INT_MASK_MSKSECRXOUTFFINT_FIELD_WIDTH 1
#define XIF_INT_MASK_MSKSECRXOUTFFINT_FIELD_SHIFT 0

extern const ru_field_rec XIF_PORT_COMMAND_DATAPORTBUSY_FIELD;
#define XIF_PORT_COMMAND_DATAPORTBUSY_FIELD_MASK  0x0000000080000000
#define XIF_PORT_COMMAND_DATAPORTBUSY_FIELD_WIDTH 1
#define XIF_PORT_COMMAND_DATAPORTBUSY_FIELD_SHIFT 31

extern const ru_field_rec XIF_PORT_COMMAND_RESERVED0_FIELD;
#define XIF_PORT_COMMAND_RESERVED0_FIELD_MASK  0x0000000040000000
#define XIF_PORT_COMMAND_RESERVED0_FIELD_WIDTH 1
#define XIF_PORT_COMMAND_RESERVED0_FIELD_SHIFT 30

extern const ru_field_rec XIF_PORT_COMMAND_PORTSELECT_FIELD;
#define XIF_PORT_COMMAND_PORTSELECT_FIELD_MASK  0x000000003f000000
#define XIF_PORT_COMMAND_PORTSELECT_FIELD_WIDTH 6
#define XIF_PORT_COMMAND_PORTSELECT_FIELD_SHIFT 24

extern const ru_field_rec XIF_PORT_COMMAND_PORTOPCODE_FIELD;
#define XIF_PORT_COMMAND_PORTOPCODE_FIELD_MASK  0x0000000000ff0000
#define XIF_PORT_COMMAND_PORTOPCODE_FIELD_WIDTH 8
#define XIF_PORT_COMMAND_PORTOPCODE_FIELD_SHIFT 16

extern const ru_field_rec XIF_PORT_COMMAND_PORTADDRESS_FIELD;
#define XIF_PORT_COMMAND_PORTADDRESS_FIELD_MASK  0x000000000000ffff
#define XIF_PORT_COMMAND_PORTADDRESS_FIELD_WIDTH 16
#define XIF_PORT_COMMAND_PORTADDRESS_FIELD_SHIFT 0

extern const ru_field_rec XIF_PORT_DATA__PORTDATA_FIELD;
#define XIF_PORT_DATA__PORTDATA_FIELD_MASK  0x00000000ffffffff
#define XIF_PORT_DATA__PORTDATA_FIELD_WIDTH 32
#define XIF_PORT_DATA__PORTDATA_FIELD_SHIFT 0

extern const ru_field_rec XIF_MACSEC_RESERVED0_FIELD;
#define XIF_MACSEC_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XIF_MACSEC_RESERVED0_FIELD_WIDTH 16
#define XIF_MACSEC_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XIF_MACSEC_CFGMACSECETHERTYPE_FIELD;
#define XIF_MACSEC_CFGMACSECETHERTYPE_FIELD_MASK  0x000000000000ffff
#define XIF_MACSEC_CFGMACSECETHERTYPE_FIELD_WIDTH 16
#define XIF_MACSEC_CFGMACSECETHERTYPE_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_XMT_OFFSET_RESERVED0_FIELD;
#define XIF_XPN_XMT_OFFSET_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XIF_XPN_XMT_OFFSET_RESERVED0_FIELD_WIDTH 16
#define XIF_XPN_XMT_OFFSET_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XIF_XPN_XMT_OFFSET_CFGXPNXMTOFFSET_FIELD;
#define XIF_XPN_XMT_OFFSET_CFGXPNXMTOFFSET_FIELD_MASK  0x000000000000ffff
#define XIF_XPN_XMT_OFFSET_CFGXPNXMTOFFSET_FIELD_WIDTH 16
#define XIF_XPN_XMT_OFFSET_CFGXPNXMTOFFSET_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_TIMESTAMP_OFFSET_CFGXPNMPCPTSOFFSET_FIELD;
#define XIF_XPN_TIMESTAMP_OFFSET_CFGXPNMPCPTSOFFSET_FIELD_MASK  0x00000000ffffffff
#define XIF_XPN_TIMESTAMP_OFFSET_CFGXPNMPCPTSOFFSET_FIELD_WIDTH 32
#define XIF_XPN_TIMESTAMP_OFFSET_CFGXPNMPCPTSOFFSET_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_PKTGEN_CTL_CFGONUBURSTSIZE_FIELD;
#define XIF_XPN_PKTGEN_CTL_CFGONUBURSTSIZE_FIELD_MASK  0x00000000ffff0000
#define XIF_XPN_PKTGEN_CTL_CFGONUBURSTSIZE_FIELD_WIDTH 16
#define XIF_XPN_PKTGEN_CTL_CFGONUBURSTSIZE_FIELD_SHIFT 16

extern const ru_field_rec XIF_XPN_PKTGEN_CTL_RESERVED0_FIELD;
#define XIF_XPN_PKTGEN_CTL_RESERVED0_FIELD_MASK  0x000000000000ffc0
#define XIF_XPN_PKTGEN_CTL_RESERVED0_FIELD_WIDTH 10
#define XIF_XPN_PKTGEN_CTL_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec XIF_XPN_PKTGEN_CTL_CFGENBCK2BCKPKTGEN_FIELD;
#define XIF_XPN_PKTGEN_CTL_CFGENBCK2BCKPKTGEN_FIELD_MASK  0x0000000000000020
#define XIF_XPN_PKTGEN_CTL_CFGENBCK2BCKPKTGEN_FIELD_WIDTH 1
#define XIF_XPN_PKTGEN_CTL_CFGENBCK2BCKPKTGEN_FIELD_SHIFT 5

extern const ru_field_rec XIF_XPN_PKTGEN_CTL_CFGENALLMPCPPKTGEN_FIELD;
#define XIF_XPN_PKTGEN_CTL_CFGENALLMPCPPKTGEN_FIELD_MASK  0x0000000000000010
#define XIF_XPN_PKTGEN_CTL_CFGENALLMPCPPKTGEN_FIELD_WIDTH 1
#define XIF_XPN_PKTGEN_CTL_CFGENALLMPCPPKTGEN_FIELD_SHIFT 4

extern const ru_field_rec XIF_XPN_PKTGEN_CTL_RESERVED1_FIELD;
#define XIF_XPN_PKTGEN_CTL_RESERVED1_FIELD_MASK  0x000000000000000c
#define XIF_XPN_PKTGEN_CTL_RESERVED1_FIELD_WIDTH 2
#define XIF_XPN_PKTGEN_CTL_RESERVED1_FIELD_SHIFT 2

extern const ru_field_rec XIF_XPN_PKTGEN_CTL_CFGXPNSTARTPKTGEN_FIELD;
#define XIF_XPN_PKTGEN_CTL_CFGXPNSTARTPKTGEN_FIELD_MASK  0x0000000000000002
#define XIF_XPN_PKTGEN_CTL_CFGXPNSTARTPKTGEN_FIELD_WIDTH 1
#define XIF_XPN_PKTGEN_CTL_CFGXPNSTARTPKTGEN_FIELD_SHIFT 1

extern const ru_field_rec XIF_XPN_PKTGEN_CTL_CFGXPNENPKTGEN_FIELD;
#define XIF_XPN_PKTGEN_CTL_CFGXPNENPKTGEN_FIELD_MASK  0x0000000000000001
#define XIF_XPN_PKTGEN_CTL_CFGXPNENPKTGEN_FIELD_WIDTH 1
#define XIF_XPN_PKTGEN_CTL_CFGXPNENPKTGEN_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_PKTGEN_LLID_CFGXPNPKTGENLLID1_FIELD;
#define XIF_XPN_PKTGEN_LLID_CFGXPNPKTGENLLID1_FIELD_MASK  0x00000000ffff0000
#define XIF_XPN_PKTGEN_LLID_CFGXPNPKTGENLLID1_FIELD_WIDTH 16
#define XIF_XPN_PKTGEN_LLID_CFGXPNPKTGENLLID1_FIELD_SHIFT 16

extern const ru_field_rec XIF_XPN_PKTGEN_LLID_CFGXPNPKTGENLLID0_FIELD;
#define XIF_XPN_PKTGEN_LLID_CFGXPNPKTGENLLID0_FIELD_MASK  0x000000000000ffff
#define XIF_XPN_PKTGEN_LLID_CFGXPNPKTGENLLID0_FIELD_WIDTH 16
#define XIF_XPN_PKTGEN_LLID_CFGXPNPKTGENLLID0_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_PKTGEN_PKT_CNT_CFGXPNPKTGENBURSTMODE_FIELD;
#define XIF_XPN_PKTGEN_PKT_CNT_CFGXPNPKTGENBURSTMODE_FIELD_MASK  0x0000000080000000
#define XIF_XPN_PKTGEN_PKT_CNT_CFGXPNPKTGENBURSTMODE_FIELD_WIDTH 1
#define XIF_XPN_PKTGEN_PKT_CNT_CFGXPNPKTGENBURSTMODE_FIELD_SHIFT 31

extern const ru_field_rec XIF_XPN_PKTGEN_PKT_CNT_RESERVED0_FIELD;
#define XIF_XPN_PKTGEN_PKT_CNT_RESERVED0_FIELD_MASK  0x000000007f000000
#define XIF_XPN_PKTGEN_PKT_CNT_RESERVED0_FIELD_WIDTH 7
#define XIF_XPN_PKTGEN_PKT_CNT_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec XIF_XPN_PKTGEN_PKT_CNT_CFGXPNPKTGENBURSTSIZE_FIELD;
#define XIF_XPN_PKTGEN_PKT_CNT_CFGXPNPKTGENBURSTSIZE_FIELD_MASK  0x0000000000ffffff
#define XIF_XPN_PKTGEN_PKT_CNT_CFGXPNPKTGENBURSTSIZE_FIELD_WIDTH 24
#define XIF_XPN_PKTGEN_PKT_CNT_CFGXPNPKTGENBURSTSIZE_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZEINCR_FIELD;
#define XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZEINCR_FIELD_MASK  0x0000000080000000
#define XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZEINCR_FIELD_WIDTH 1
#define XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZEINCR_FIELD_SHIFT 31

extern const ru_field_rec XIF_XPN_PKTGEN_PKT_SIZE_RESERVED0_FIELD;
#define XIF_XPN_PKTGEN_PKT_SIZE_RESERVED0_FIELD_MASK  0x0000000070000000
#define XIF_XPN_PKTGEN_PKT_SIZE_RESERVED0_FIELD_WIDTH 3
#define XIF_XPN_PKTGEN_PKT_SIZE_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZEEND_FIELD;
#define XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZEEND_FIELD_MASK  0x000000000fff0000
#define XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZEEND_FIELD_WIDTH 12
#define XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZEEND_FIELD_SHIFT 16

extern const ru_field_rec XIF_XPN_PKTGEN_PKT_SIZE_RESERVED1_FIELD;
#define XIF_XPN_PKTGEN_PKT_SIZE_RESERVED1_FIELD_MASK  0x000000000000f000
#define XIF_XPN_PKTGEN_PKT_SIZE_RESERVED1_FIELD_WIDTH 4
#define XIF_XPN_PKTGEN_PKT_SIZE_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZESTART_FIELD;
#define XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZESTART_FIELD_MASK  0x0000000000000fff
#define XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZESTART_FIELD_WIDTH 12
#define XIF_XPN_PKTGEN_PKT_SIZE_CFGXPNPKTGENSIZESTART_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_PKTGEN_IPG_CFGXPNPKTGENBCK2BCKIPG_FIELD;
#define XIF_XPN_PKTGEN_IPG_CFGXPNPKTGENBCK2BCKIPG_FIELD_MASK  0x00000000ffff0000
#define XIF_XPN_PKTGEN_IPG_CFGXPNPKTGENBCK2BCKIPG_FIELD_WIDTH 16
#define XIF_XPN_PKTGEN_IPG_CFGXPNPKTGENBCK2BCKIPG_FIELD_SHIFT 16

extern const ru_field_rec XIF_XPN_PKTGEN_IPG_CFGXPNPKTGENIPG_FIELD;
#define XIF_XPN_PKTGEN_IPG_CFGXPNPKTGENIPG_FIELD_MASK  0x000000000000ffff
#define XIF_XPN_PKTGEN_IPG_CFGXPNPKTGENIPG_FIELD_WIDTH 16
#define XIF_XPN_PKTGEN_IPG_CFGXPNPKTGENIPG_FIELD_SHIFT 0

extern const ru_field_rec XIF_TS_JITTER_THRESH_RESERVED0_FIELD;
#define XIF_TS_JITTER_THRESH_RESERVED0_FIELD_MASK  0x0000000080000000
#define XIF_TS_JITTER_THRESH_RESERVED0_FIELD_WIDTH 1
#define XIF_TS_JITTER_THRESH_RESERVED0_FIELD_SHIFT 31

extern const ru_field_rec XIF_TS_JITTER_THRESH_CFGTSJTTRTHRESH_FIELD;
#define XIF_TS_JITTER_THRESH_CFGTSJTTRTHRESH_FIELD_MASK  0x000000007fffffff
#define XIF_TS_JITTER_THRESH_CFGTSJTTRTHRESH_FIELD_WIDTH 31
#define XIF_TS_JITTER_THRESH_CFGTSJTTRTHRESH_FIELD_SHIFT 0

extern const ru_field_rec XIF_TS_UPDATE_CFGTSFULLUPDTHR_FIELD;
#define XIF_TS_UPDATE_CFGTSFULLUPDTHR_FIELD_MASK  0x00000000ffff0000
#define XIF_TS_UPDATE_CFGTSFULLUPDTHR_FIELD_WIDTH 16
#define XIF_TS_UPDATE_CFGTSFULLUPDTHR_FIELD_SHIFT 16

extern const ru_field_rec XIF_TS_UPDATE_CFGENAUTOTSUPD_FIELD;
#define XIF_TS_UPDATE_CFGENAUTOTSUPD_FIELD_MASK  0x0000000000008000
#define XIF_TS_UPDATE_CFGENAUTOTSUPD_FIELD_WIDTH 1
#define XIF_TS_UPDATE_CFGENAUTOTSUPD_FIELD_SHIFT 15

extern const ru_field_rec XIF_TS_UPDATE_RESERVED0_FIELD;
#define XIF_TS_UPDATE_RESERVED0_FIELD_MASK  0x0000000000007f00
#define XIF_TS_UPDATE_RESERVED0_FIELD_WIDTH 7
#define XIF_TS_UPDATE_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XIF_TS_UPDATE_CFGTSUPDPER_FIELD;
#define XIF_TS_UPDATE_CFGTSUPDPER_FIELD_MASK  0x00000000000000ff
#define XIF_TS_UPDATE_CFGTSUPDPER_FIELD_WIDTH 8
#define XIF_TS_UPDATE_CFGTSUPDPER_FIELD_SHIFT 0

extern const ru_field_rec XIF_GNT_OVERHEAD_RESERVED0_FIELD;
#define XIF_GNT_OVERHEAD_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XIF_GNT_OVERHEAD_RESERVED0_FIELD_WIDTH 16
#define XIF_GNT_OVERHEAD_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XIF_GNT_OVERHEAD_CFGGNTOH_FIELD;
#define XIF_GNT_OVERHEAD_CFGGNTOH_FIELD_MASK  0x000000000000ffff
#define XIF_GNT_OVERHEAD_CFGGNTOH_FIELD_WIDTH 16
#define XIF_GNT_OVERHEAD_CFGGNTOH_FIELD_SHIFT 0

extern const ru_field_rec XIF_DISCOVER_OVERHEAD_RESERVED0_FIELD;
#define XIF_DISCOVER_OVERHEAD_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XIF_DISCOVER_OVERHEAD_RESERVED0_FIELD_WIDTH 16
#define XIF_DISCOVER_OVERHEAD_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XIF_DISCOVER_OVERHEAD_CFGDISCOH_FIELD;
#define XIF_DISCOVER_OVERHEAD_CFGDISCOH_FIELD_MASK  0x000000000000ffff
#define XIF_DISCOVER_OVERHEAD_CFGDISCOH_FIELD_WIDTH 16
#define XIF_DISCOVER_OVERHEAD_CFGDISCOH_FIELD_SHIFT 0

extern const ru_field_rec XIF_DISCOVER_INFO_RESERVED0_FIELD;
#define XIF_DISCOVER_INFO_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XIF_DISCOVER_INFO_RESERVED0_FIELD_WIDTH 16
#define XIF_DISCOVER_INFO_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XIF_DISCOVER_INFO_CFGDISCINFOFLD_FIELD;
#define XIF_DISCOVER_INFO_CFGDISCINFOFLD_FIELD_MASK  0x000000000000ffff
#define XIF_DISCOVER_INFO_CFGDISCINFOFLD_FIELD_WIDTH 16
#define XIF_DISCOVER_INFO_CFGDISCINFOFLD_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_OVERSIZE_THRESH_RESERVED0_FIELD;
#define XIF_XPN_OVERSIZE_THRESH_RESERVED0_FIELD_MASK  0x00000000ffffc000
#define XIF_XPN_OVERSIZE_THRESH_RESERVED0_FIELD_WIDTH 18
#define XIF_XPN_OVERSIZE_THRESH_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec XIF_XPN_OVERSIZE_THRESH_CFGXPNOVRSZTHRESH_FIELD;
#define XIF_XPN_OVERSIZE_THRESH_CFGXPNOVRSZTHRESH_FIELD_MASK  0x0000000000003fff
#define XIF_XPN_OVERSIZE_THRESH_CFGXPNOVRSZTHRESH_FIELD_WIDTH 14
#define XIF_XPN_OVERSIZE_THRESH_CFGXPNOVRSZTHRESH_FIELD_SHIFT 0

extern const ru_field_rec XIF_SECRX_KEYNUM_KEYSTATRX_FIELD;
#define XIF_SECRX_KEYNUM_KEYSTATRX_FIELD_MASK  0x00000000ffffffff
#define XIF_SECRX_KEYNUM_KEYSTATRX_FIELD_WIDTH 32
#define XIF_SECRX_KEYNUM_KEYSTATRX_FIELD_SHIFT 0

extern const ru_field_rec XIF_SECRX_ENCRYPT_ENCRSTATRX_FIELD;
#define XIF_SECRX_ENCRYPT_ENCRSTATRX_FIELD_MASK  0x00000000ffffffff
#define XIF_SECRX_ENCRYPT_ENCRSTATRX_FIELD_WIDTH 32
#define XIF_SECRX_ENCRYPT_ENCRSTATRX_FIELD_SHIFT 0

extern const ru_field_rec XIF_PMC_FRAME_RX_CNT_PMCRXFRAMECNT_FIELD;
#define XIF_PMC_FRAME_RX_CNT_PMCRXFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define XIF_PMC_FRAME_RX_CNT_PMCRXFRAMECNT_FIELD_WIDTH 32
#define XIF_PMC_FRAME_RX_CNT_PMCRXFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_PMC_BYTE_RX_CNT_PMCRXBYTECNT_FIELD;
#define XIF_PMC_BYTE_RX_CNT_PMCRXBYTECNT_FIELD_MASK  0x00000000ffffffff
#define XIF_PMC_BYTE_RX_CNT_PMCRXBYTECNT_FIELD_WIDTH 32
#define XIF_PMC_BYTE_RX_CNT_PMCRXBYTECNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_PMC_RUNT_RX_CNT_PMCRXRUNTCNT_FIELD;
#define XIF_PMC_RUNT_RX_CNT_PMCRXRUNTCNT_FIELD_MASK  0x00000000ffffffff
#define XIF_PMC_RUNT_RX_CNT_PMCRXRUNTCNT_FIELD_WIDTH 32
#define XIF_PMC_RUNT_RX_CNT_PMCRXRUNTCNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_PMC_CW_ERR_RX_CNT_PMCRXCWERRCNT_FIELD;
#define XIF_PMC_CW_ERR_RX_CNT_PMCRXCWERRCNT_FIELD_MASK  0x00000000ffffffff
#define XIF_PMC_CW_ERR_RX_CNT_PMCRXCWERRCNT_FIELD_WIDTH 32
#define XIF_PMC_CW_ERR_RX_CNT_PMCRXCWERRCNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_PMC_CRC8_ERR_RX_CNT_PMCRXCRC8ERRCNT_FIELD;
#define XIF_PMC_CRC8_ERR_RX_CNT_PMCRXCRC8ERRCNT_FIELD_MASK  0x00000000ffffffff
#define XIF_PMC_CRC8_ERR_RX_CNT_PMCRXCRC8ERRCNT_FIELD_WIDTH 32
#define XIF_PMC_CRC8_ERR_RX_CNT_PMCRXCRC8ERRCNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_DATA_FRM_CNT_XPNDTFRAMECNT_FIELD;
#define XIF_XPN_DATA_FRM_CNT_XPNDTFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define XIF_XPN_DATA_FRM_CNT_XPNDTFRAMECNT_FIELD_WIDTH 32
#define XIF_XPN_DATA_FRM_CNT_XPNDTFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_DATA_BYTE_CNT_XPNDTBYTECNT_FIELD;
#define XIF_XPN_DATA_BYTE_CNT_XPNDTBYTECNT_FIELD_MASK  0x00000000ffffffff
#define XIF_XPN_DATA_BYTE_CNT_XPNDTBYTECNT_FIELD_WIDTH 32
#define XIF_XPN_DATA_BYTE_CNT_XPNDTBYTECNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_MPCP_FRM_CNT_XPNMPCPFRAMECNT_FIELD;
#define XIF_XPN_MPCP_FRM_CNT_XPNMPCPFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define XIF_XPN_MPCP_FRM_CNT_XPNMPCPFRAMECNT_FIELD_WIDTH 32
#define XIF_XPN_MPCP_FRM_CNT_XPNMPCPFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_OAM_FRM_CNT_XPNOAMFRAMECNT_FIELD;
#define XIF_XPN_OAM_FRM_CNT_XPNOAMFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define XIF_XPN_OAM_FRM_CNT_XPNOAMFRAMECNT_FIELD_WIDTH 32
#define XIF_XPN_OAM_FRM_CNT_XPNOAMFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_OAM_BYTE_CNT_XPNOAMBYTECNT_FIELD;
#define XIF_XPN_OAM_BYTE_CNT_XPNOAMBYTECNT_FIELD_MASK  0x00000000ffffffff
#define XIF_XPN_OAM_BYTE_CNT_XPNOAMBYTECNT_FIELD_WIDTH 32
#define XIF_XPN_OAM_BYTE_CNT_XPNOAMBYTECNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_OVERSIZE_FRM_CNT_XPNDTOVERSIZECNT_FIELD;
#define XIF_XPN_OVERSIZE_FRM_CNT_XPNDTOVERSIZECNT_FIELD_MASK  0x00000000ffffffff
#define XIF_XPN_OVERSIZE_FRM_CNT_XPNDTOVERSIZECNT_FIELD_WIDTH 32
#define XIF_XPN_OVERSIZE_FRM_CNT_XPNDTOVERSIZECNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_SEC_ABORT_FRM_CNT_SECRXABORTFRMCNT_FIELD;
#define XIF_SEC_ABORT_FRM_CNT_SECRXABORTFRMCNT_FIELD_MASK  0x00000000ffffffff
#define XIF_SEC_ABORT_FRM_CNT_SECRXABORTFRMCNT_FIELD_WIDTH 32
#define XIF_SEC_ABORT_FRM_CNT_SECRXABORTFRMCNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_PMC_TX_NEG_EVENT_CNT_RESERVED0_FIELD;
#define XIF_PMC_TX_NEG_EVENT_CNT_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XIF_PMC_TX_NEG_EVENT_CNT_RESERVED0_FIELD_WIDTH 24
#define XIF_PMC_TX_NEG_EVENT_CNT_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XIF_PMC_TX_NEG_EVENT_CNT_PMCTXNEGEVENTCNT_FIELD;
#define XIF_PMC_TX_NEG_EVENT_CNT_PMCTXNEGEVENTCNT_FIELD_MASK  0x00000000000000ff
#define XIF_PMC_TX_NEG_EVENT_CNT_PMCTXNEGEVENTCNT_FIELD_WIDTH 8
#define XIF_PMC_TX_NEG_EVENT_CNT_PMCTXNEGEVENTCNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_XPN_IDLE_PKT_CNT_RESERVED0_FIELD;
#define XIF_XPN_IDLE_PKT_CNT_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XIF_XPN_IDLE_PKT_CNT_RESERVED0_FIELD_WIDTH 16
#define XIF_XPN_IDLE_PKT_CNT_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XIF_XPN_IDLE_PKT_CNT_XPNIDLEFRAMECNT_FIELD;
#define XIF_XPN_IDLE_PKT_CNT_XPNIDLEFRAMECNT_FIELD_MASK  0x000000000000ffff
#define XIF_XPN_IDLE_PKT_CNT_XPNIDLEFRAMECNT_FIELD_WIDTH 16
#define XIF_XPN_IDLE_PKT_CNT_XPNIDLEFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_0_RESERVED0_FIELD;
#define XIF_LLID_0_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_0_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_0_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_0_CFGONULLID0_FIELD;
#define XIF_LLID_0_CFGONULLID0_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_0_CFGONULLID0_FIELD_WIDTH 17
#define XIF_LLID_0_CFGONULLID0_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_1_RESERVED0_FIELD;
#define XIF_LLID_1_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_1_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_1_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_1_CFGONULLID1_FIELD;
#define XIF_LLID_1_CFGONULLID1_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_1_CFGONULLID1_FIELD_WIDTH 17
#define XIF_LLID_1_CFGONULLID1_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_2_RESERVED0_FIELD;
#define XIF_LLID_2_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_2_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_2_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_2_CFGONULLID2_FIELD;
#define XIF_LLID_2_CFGONULLID2_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_2_CFGONULLID2_FIELD_WIDTH 17
#define XIF_LLID_2_CFGONULLID2_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_3_RESERVED0_FIELD;
#define XIF_LLID_3_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_3_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_3_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_3_CFGONULLID3_FIELD;
#define XIF_LLID_3_CFGONULLID3_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_3_CFGONULLID3_FIELD_WIDTH 17
#define XIF_LLID_3_CFGONULLID3_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_4_RESERVED0_FIELD;
#define XIF_LLID_4_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_4_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_4_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_4_CFGONULLID4_FIELD;
#define XIF_LLID_4_CFGONULLID4_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_4_CFGONULLID4_FIELD_WIDTH 17
#define XIF_LLID_4_CFGONULLID4_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_5_RESERVED0_FIELD;
#define XIF_LLID_5_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_5_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_5_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_5_CFGONULLID5_FIELD;
#define XIF_LLID_5_CFGONULLID5_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_5_CFGONULLID5_FIELD_WIDTH 17
#define XIF_LLID_5_CFGONULLID5_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_6_RESERVED0_FIELD;
#define XIF_LLID_6_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_6_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_6_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_6_CFGONULLID6_FIELD;
#define XIF_LLID_6_CFGONULLID6_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_6_CFGONULLID6_FIELD_WIDTH 17
#define XIF_LLID_6_CFGONULLID6_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_7_RESERVED0_FIELD;
#define XIF_LLID_7_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_7_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_7_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_7_CFGONULLID7_FIELD;
#define XIF_LLID_7_CFGONULLID7_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_7_CFGONULLID7_FIELD_WIDTH 17
#define XIF_LLID_7_CFGONULLID7_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_8_RESERVED0_FIELD;
#define XIF_LLID_8_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_8_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_8_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_8_CFGONULLID8_FIELD;
#define XIF_LLID_8_CFGONULLID8_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_8_CFGONULLID8_FIELD_WIDTH 17
#define XIF_LLID_8_CFGONULLID8_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_9_RESERVED0_FIELD;
#define XIF_LLID_9_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_9_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_9_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_9_CFGONULLID9_FIELD;
#define XIF_LLID_9_CFGONULLID9_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_9_CFGONULLID9_FIELD_WIDTH 17
#define XIF_LLID_9_CFGONULLID9_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_10_RESERVED0_FIELD;
#define XIF_LLID_10_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_10_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_10_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_10_CFGONULLID10_FIELD;
#define XIF_LLID_10_CFGONULLID10_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_10_CFGONULLID10_FIELD_WIDTH 17
#define XIF_LLID_10_CFGONULLID10_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_11_RESERVED0_FIELD;
#define XIF_LLID_11_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_11_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_11_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_11_CFGONULLID11_FIELD;
#define XIF_LLID_11_CFGONULLID11_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_11_CFGONULLID11_FIELD_WIDTH 17
#define XIF_LLID_11_CFGONULLID11_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_12_RESERVED0_FIELD;
#define XIF_LLID_12_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_12_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_12_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_12_CFGONULLID12_FIELD;
#define XIF_LLID_12_CFGONULLID12_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_12_CFGONULLID12_FIELD_WIDTH 17
#define XIF_LLID_12_CFGONULLID12_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_13_RESERVED0_FIELD;
#define XIF_LLID_13_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_13_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_13_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_13_CFGONULLID13_FIELD;
#define XIF_LLID_13_CFGONULLID13_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_13_CFGONULLID13_FIELD_WIDTH 17
#define XIF_LLID_13_CFGONULLID13_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_14_RESERVED0_FIELD;
#define XIF_LLID_14_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_14_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_14_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_14_CFGONULLID14_FIELD;
#define XIF_LLID_14_CFGONULLID14_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_14_CFGONULLID14_FIELD_WIDTH 17
#define XIF_LLID_14_CFGONULLID14_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_15_RESERVED0_FIELD;
#define XIF_LLID_15_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_15_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_15_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_15_CFGONULLID15_FIELD;
#define XIF_LLID_15_CFGONULLID15_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_15_CFGONULLID15_FIELD_WIDTH 17
#define XIF_LLID_15_CFGONULLID15_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_16_RESERVED0_FIELD;
#define XIF_LLID_16_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_16_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_16_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_16_CFGONULLID16_FIELD;
#define XIF_LLID_16_CFGONULLID16_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_16_CFGONULLID16_FIELD_WIDTH 17
#define XIF_LLID_16_CFGONULLID16_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_17_RESERVED0_FIELD;
#define XIF_LLID_17_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_17_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_17_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_17_CFGONULLID17_FIELD;
#define XIF_LLID_17_CFGONULLID17_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_17_CFGONULLID17_FIELD_WIDTH 17
#define XIF_LLID_17_CFGONULLID17_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_18_RESERVED0_FIELD;
#define XIF_LLID_18_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_18_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_18_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_18_CFGONULLID18_FIELD;
#define XIF_LLID_18_CFGONULLID18_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_18_CFGONULLID18_FIELD_WIDTH 17
#define XIF_LLID_18_CFGONULLID18_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_19_RESERVED0_FIELD;
#define XIF_LLID_19_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_19_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_19_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_19_CFGONULLID19_FIELD;
#define XIF_LLID_19_CFGONULLID19_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_19_CFGONULLID19_FIELD_WIDTH 17
#define XIF_LLID_19_CFGONULLID19_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_20_RESERVED0_FIELD;
#define XIF_LLID_20_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_20_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_20_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_20_CFGONULLID20_FIELD;
#define XIF_LLID_20_CFGONULLID20_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_20_CFGONULLID20_FIELD_WIDTH 17
#define XIF_LLID_20_CFGONULLID20_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_21_RESERVED0_FIELD;
#define XIF_LLID_21_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_21_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_21_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_21_CFGONULLID21_FIELD;
#define XIF_LLID_21_CFGONULLID21_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_21_CFGONULLID21_FIELD_WIDTH 17
#define XIF_LLID_21_CFGONULLID21_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_22_RESERVED0_FIELD;
#define XIF_LLID_22_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_22_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_22_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_22_CFGONULLID22_FIELD;
#define XIF_LLID_22_CFGONULLID22_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_22_CFGONULLID22_FIELD_WIDTH 17
#define XIF_LLID_22_CFGONULLID22_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_23_RESERVED0_FIELD;
#define XIF_LLID_23_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_23_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_23_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_23_CFGONULLID23_FIELD;
#define XIF_LLID_23_CFGONULLID23_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_23_CFGONULLID23_FIELD_WIDTH 17
#define XIF_LLID_23_CFGONULLID23_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_24_RESERVED0_FIELD;
#define XIF_LLID_24_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_24_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_24_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_24_CFGONULLID24_FIELD;
#define XIF_LLID_24_CFGONULLID24_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_24_CFGONULLID24_FIELD_WIDTH 17
#define XIF_LLID_24_CFGONULLID24_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_25_RESERVED0_FIELD;
#define XIF_LLID_25_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_25_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_25_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_25_CFGONULLID25_FIELD;
#define XIF_LLID_25_CFGONULLID25_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_25_CFGONULLID25_FIELD_WIDTH 17
#define XIF_LLID_25_CFGONULLID25_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_26_RESERVED0_FIELD;
#define XIF_LLID_26_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_26_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_26_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_26_CFGONULLID26_FIELD;
#define XIF_LLID_26_CFGONULLID26_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_26_CFGONULLID26_FIELD_WIDTH 17
#define XIF_LLID_26_CFGONULLID26_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_27_RESERVED0_FIELD;
#define XIF_LLID_27_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_27_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_27_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_27_CFGONULLID27_FIELD;
#define XIF_LLID_27_CFGONULLID27_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_27_CFGONULLID27_FIELD_WIDTH 17
#define XIF_LLID_27_CFGONULLID27_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_28_RESERVED0_FIELD;
#define XIF_LLID_28_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_28_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_28_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_28_CFGONULLID28_FIELD;
#define XIF_LLID_28_CFGONULLID28_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_28_CFGONULLID28_FIELD_WIDTH 17
#define XIF_LLID_28_CFGONULLID28_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_29_RESERVED0_FIELD;
#define XIF_LLID_29_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_29_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_29_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_29_CFGONULLID29_FIELD;
#define XIF_LLID_29_CFGONULLID29_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_29_CFGONULLID29_FIELD_WIDTH 17
#define XIF_LLID_29_CFGONULLID29_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_30_RESERVED0_FIELD;
#define XIF_LLID_30_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_30_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_30_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_30_CFGONULLID30_FIELD;
#define XIF_LLID_30_CFGONULLID30_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_30_CFGONULLID30_FIELD_WIDTH 17
#define XIF_LLID_30_CFGONULLID30_FIELD_SHIFT 0

extern const ru_field_rec XIF_LLID_31_RESERVED0_FIELD;
#define XIF_LLID_31_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define XIF_LLID_31_RESERVED0_FIELD_WIDTH 15
#define XIF_LLID_31_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec XIF_LLID_31_CFGONULLID31_FIELD;
#define XIF_LLID_31_CFGONULLID31_FIELD_MASK  0x000000000001ffff
#define XIF_LLID_31_CFGONULLID31_FIELD_WIDTH 17
#define XIF_LLID_31_CFGONULLID31_FIELD_SHIFT 0

extern const ru_field_rec XIF_MAX_MPCP_UPDATE_CFGMAXPOSMPCPUPD_FIELD;
#define XIF_MAX_MPCP_UPDATE_CFGMAXPOSMPCPUPD_FIELD_MASK  0x00000000ffffffff
#define XIF_MAX_MPCP_UPDATE_CFGMAXPOSMPCPUPD_FIELD_WIDTH 32
#define XIF_MAX_MPCP_UPDATE_CFGMAXPOSMPCPUPD_FIELD_SHIFT 0

extern const ru_field_rec XIF_IPG_INSERTION_RESERVED0_FIELD;
#define XIF_IPG_INSERTION_RESERVED0_FIELD_MASK  0x00000000fffffc00
#define XIF_IPG_INSERTION_RESERVED0_FIELD_WIDTH 22
#define XIF_IPG_INSERTION_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec XIF_IPG_INSERTION_CFGSHORTIPG_FIELD;
#define XIF_IPG_INSERTION_CFGSHORTIPG_FIELD_MASK  0x0000000000000200
#define XIF_IPG_INSERTION_CFGSHORTIPG_FIELD_WIDTH 1
#define XIF_IPG_INSERTION_CFGSHORTIPG_FIELD_SHIFT 9

extern const ru_field_rec XIF_IPG_INSERTION_CFGINSERTIPG_FIELD;
#define XIF_IPG_INSERTION_CFGINSERTIPG_FIELD_MASK  0x0000000000000100
#define XIF_IPG_INSERTION_CFGINSERTIPG_FIELD_WIDTH 1
#define XIF_IPG_INSERTION_CFGINSERTIPG_FIELD_SHIFT 8

extern const ru_field_rec XIF_IPG_INSERTION_RESERVED1_FIELD;
#define XIF_IPG_INSERTION_RESERVED1_FIELD_MASK  0x0000000000000080
#define XIF_IPG_INSERTION_RESERVED1_FIELD_WIDTH 1
#define XIF_IPG_INSERTION_RESERVED1_FIELD_SHIFT 7

extern const ru_field_rec XIF_IPG_INSERTION_CFGIPGWORD_FIELD;
#define XIF_IPG_INSERTION_CFGIPGWORD_FIELD_MASK  0x000000000000007f
#define XIF_IPG_INSERTION_CFGIPGWORD_FIELD_WIDTH 7
#define XIF_IPG_INSERTION_CFGIPGWORD_FIELD_SHIFT 0

extern const ru_field_rec XIF_TRANSPORT_TIME_CFTRANSPORTTIME_FIELD;
#define XIF_TRANSPORT_TIME_CFTRANSPORTTIME_FIELD_MASK  0x00000000ffffffff
#define XIF_TRANSPORT_TIME_CFTRANSPORTTIME_FIELD_WIDTH 32
#define XIF_TRANSPORT_TIME_CFTRANSPORTTIME_FIELD_SHIFT 0

extern const ru_field_rec XIF_MPCP_TIME_CURMPCPTS_FIELD;
#define XIF_MPCP_TIME_CURMPCPTS_FIELD_MASK  0x00000000ffffffff
#define XIF_MPCP_TIME_CURMPCPTS_FIELD_WIDTH 32
#define XIF_MPCP_TIME_CURMPCPTS_FIELD_SHIFT 0

extern const ru_field_rec XIF_OVERLAP_GNT_OH_CFGOVRLPOH_FIELD;
#define XIF_OVERLAP_GNT_OH_CFGOVRLPOH_FIELD_MASK  0x00000000ffffffff
#define XIF_OVERLAP_GNT_OH_CFGOVRLPOH_FIELD_WIDTH 32
#define XIF_OVERLAP_GNT_OH_CFGOVRLPOH_FIELD_SHIFT 0

extern const ru_field_rec XIF_MAC_MODE_RESERVED0_FIELD;
#define XIF_MAC_MODE_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define XIF_MAC_MODE_RESERVED0_FIELD_WIDTH 30
#define XIF_MAC_MODE_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec XIF_MAC_MODE_CFGENNOGNTXMT_FIELD;
#define XIF_MAC_MODE_CFGENNOGNTXMT_FIELD_MASK  0x0000000000000002
#define XIF_MAC_MODE_CFGENNOGNTXMT_FIELD_WIDTH 1
#define XIF_MAC_MODE_CFGENNOGNTXMT_FIELD_SHIFT 1

extern const ru_field_rec XIF_PMCTX_CTL_RESERVED0_FIELD;
#define XIF_PMCTX_CTL_RESERVED0_FIELD_MASK  0x00000000ff000000
#define XIF_PMCTX_CTL_RESERVED0_FIELD_WIDTH 8
#define XIF_PMCTX_CTL_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec XIF_PMCTX_CTL_CFGMPCPUPDPERIOD_FIELD;
#define XIF_PMCTX_CTL_CFGMPCPUPDPERIOD_FIELD_MASK  0x0000000000ff0000
#define XIF_PMCTX_CTL_CFGMPCPUPDPERIOD_FIELD_WIDTH 8
#define XIF_PMCTX_CTL_CFGMPCPUPDPERIOD_FIELD_SHIFT 16

extern const ru_field_rec XIF_PMCTX_CTL_RESERVED1_FIELD;
#define XIF_PMCTX_CTL_RESERVED1_FIELD_MASK  0x000000000000ffc0
#define XIF_PMCTX_CTL_RESERVED1_FIELD_WIDTH 10
#define XIF_PMCTX_CTL_RESERVED1_FIELD_SHIFT 6

extern const ru_field_rec XIF_PMCTX_CTL_CFGDIS4IDLEB4STARTCHAR_FIELD;
#define XIF_PMCTX_CTL_CFGDIS4IDLEB4STARTCHAR_FIELD_MASK  0x0000000000000020
#define XIF_PMCTX_CTL_CFGDIS4IDLEB4STARTCHAR_FIELD_WIDTH 1
#define XIF_PMCTX_CTL_CFGDIS4IDLEB4STARTCHAR_FIELD_SHIFT 5

extern const ru_field_rec XIF_PMCTX_CTL_CFGENIDLEDSCRD_FIELD;
#define XIF_PMCTX_CTL_CFGENIDLEDSCRD_FIELD_MASK  0x0000000000000010
#define XIF_PMCTX_CTL_CFGENIDLEDSCRD_FIELD_WIDTH 1
#define XIF_PMCTX_CTL_CFGENIDLEDSCRD_FIELD_SHIFT 4

extern const ru_field_rec XIF_PMCTX_CTL_CFGSELTXPONTIME_FIELD;
#define XIF_PMCTX_CTL_CFGSELTXPONTIME_FIELD_MASK  0x0000000000000008
#define XIF_PMCTX_CTL_CFGSELTXPONTIME_FIELD_WIDTH 1
#define XIF_PMCTX_CTL_CFGSELTXPONTIME_FIELD_SHIFT 3

extern const ru_field_rec XIF_PMCTX_CTL_CFGMPCPCONTUPD_FIELD;
#define XIF_PMCTX_CTL_CFGMPCPCONTUPD_FIELD_MASK  0x0000000000000004
#define XIF_PMCTX_CTL_CFGMPCPCONTUPD_FIELD_WIDTH 1
#define XIF_PMCTX_CTL_CFGMPCPCONTUPD_FIELD_SHIFT 2

extern const ru_field_rec XIF_PMCTX_CTL_CFGENMAXMPCPUPD_FIELD;
#define XIF_PMCTX_CTL_CFGENMAXMPCPUPD_FIELD_MASK  0x0000000000000002
#define XIF_PMCTX_CTL_CFGENMAXMPCPUPD_FIELD_WIDTH 1
#define XIF_PMCTX_CTL_CFGENMAXMPCPUPD_FIELD_SHIFT 1

extern const ru_field_rec XIF_PMCTX_CTL_CFGENNEGTIMEABORT_FIELD;
#define XIF_PMCTX_CTL_CFGENNEGTIMEABORT_FIELD_MASK  0x0000000000000001
#define XIF_PMCTX_CTL_CFGENNEGTIMEABORT_FIELD_WIDTH 1
#define XIF_PMCTX_CTL_CFGENNEGTIMEABORT_FIELD_SHIFT 0

extern const ru_field_rec XIF_SEC_CTL_RESERVED0_FIELD;
#define XIF_SEC_CTL_RESERVED0_FIELD_MASK  0x00000000ffffff80
#define XIF_SEC_CTL_RESERVED0_FIELD_WIDTH 25
#define XIF_SEC_CTL_RESERVED0_FIELD_SHIFT 7

extern const ru_field_rec XIF_SEC_CTL_CFGSECRXENSHORTLEN_FIELD;
#define XIF_SEC_CTL_CFGSECRXENSHORTLEN_FIELD_MASK  0x0000000000000040
#define XIF_SEC_CTL_CFGSECRXENSHORTLEN_FIELD_WIDTH 1
#define XIF_SEC_CTL_CFGSECRXENSHORTLEN_FIELD_SHIFT 6

extern const ru_field_rec XIF_SEC_CTL_CFGENSECTXFAKEAES_FIELD;
#define XIF_SEC_CTL_CFGENSECTXFAKEAES_FIELD_MASK  0x0000000000000020
#define XIF_SEC_CTL_CFGENSECTXFAKEAES_FIELD_WIDTH 1
#define XIF_SEC_CTL_CFGENSECTXFAKEAES_FIELD_SHIFT 5

extern const ru_field_rec XIF_SEC_CTL_CFGENSECRXFAKEAES_FIELD;
#define XIF_SEC_CTL_CFGENSECRXFAKEAES_FIELD_MASK  0x0000000000000010
#define XIF_SEC_CTL_CFGENSECRXFAKEAES_FIELD_WIDTH 1
#define XIF_SEC_CTL_CFGENSECRXFAKEAES_FIELD_SHIFT 4

extern const ru_field_rec XIF_SEC_CTL_RESERVED1_FIELD;
#define XIF_SEC_CTL_RESERVED1_FIELD_MASK  0x000000000000000e
#define XIF_SEC_CTL_RESERVED1_FIELD_WIDTH 3
#define XIF_SEC_CTL_RESERVED1_FIELD_SHIFT 1

extern const ru_field_rec XIF_SEC_CTL_CFGENAEREPLAYPRCT_FIELD;
#define XIF_SEC_CTL_CFGENAEREPLAYPRCT_FIELD_MASK  0x0000000000000001
#define XIF_SEC_CTL_CFGENAEREPLAYPRCT_FIELD_WIDTH 1
#define XIF_SEC_CTL_CFGENAEREPLAYPRCT_FIELD_SHIFT 0

extern const ru_field_rec XIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD;
#define XIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD_MASK  0x00000000ffffffff
#define XIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD_WIDTH 32
#define XIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD_SHIFT 0

extern const ru_field_rec XIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD;
#define XIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD_MASK  0x00000000ffffffff
#define XIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD_WIDTH 32
#define XIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD_SHIFT 0

extern const ru_field_rec XIF_SECTX_KEYNUM_KEYSTATTX_FIELD;
#define XIF_SECTX_KEYNUM_KEYSTATTX_FIELD_MASK  0x00000000ffffffff
#define XIF_SECTX_KEYNUM_KEYSTATTX_FIELD_WIDTH 32
#define XIF_SECTX_KEYNUM_KEYSTATTX_FIELD_SHIFT 0

extern const ru_field_rec XIF_SECTX_ENCRYPT_ENCRSTATTX_FIELD;
#define XIF_SECTX_ENCRYPT_ENCRSTATTX_FIELD_MASK  0x00000000ffffffff
#define XIF_SECTX_ENCRYPT_ENCRSTATTX_FIELD_WIDTH 32
#define XIF_SECTX_ENCRYPT_ENCRSTATTX_FIELD_SHIFT 0

extern const ru_field_rec XIF_AE_PKTNUM_STAT_RESERVED0_FIELD;
#define XIF_AE_PKTNUM_STAT_RESERVED0_FIELD_MASK  0x00000000ffe00000
#define XIF_AE_PKTNUM_STAT_RESERVED0_FIELD_WIDTH 11
#define XIF_AE_PKTNUM_STAT_RESERVED0_FIELD_SHIFT 21

extern const ru_field_rec XIF_AE_PKTNUM_STAT_SECTXINDXWTPKTNUMMAX_FIELD;
#define XIF_AE_PKTNUM_STAT_SECTXINDXWTPKTNUMMAX_FIELD_MASK  0x00000000001f0000
#define XIF_AE_PKTNUM_STAT_SECTXINDXWTPKTNUMMAX_FIELD_WIDTH 5
#define XIF_AE_PKTNUM_STAT_SECTXINDXWTPKTNUMMAX_FIELD_SHIFT 16

extern const ru_field_rec XIF_AE_PKTNUM_STAT_RESERVED1_FIELD;
#define XIF_AE_PKTNUM_STAT_RESERVED1_FIELD_MASK  0x000000000000ffe0
#define XIF_AE_PKTNUM_STAT_RESERVED1_FIELD_WIDTH 11
#define XIF_AE_PKTNUM_STAT_RESERVED1_FIELD_SHIFT 5

extern const ru_field_rec XIF_AE_PKTNUM_STAT_SECRXINDXWTPKTNUMABORT_FIELD;
#define XIF_AE_PKTNUM_STAT_SECRXINDXWTPKTNUMABORT_FIELD_MASK  0x000000000000001f
#define XIF_AE_PKTNUM_STAT_SECRXINDXWTPKTNUMABORT_FIELD_WIDTH 5
#define XIF_AE_PKTNUM_STAT_SECRXINDXWTPKTNUMABORT_FIELD_SHIFT 0

extern const ru_field_rec XIF_MPCP_UPDATE_MPCPUPDPERIOD_FIELD;
#define XIF_MPCP_UPDATE_MPCPUPDPERIOD_FIELD_MASK  0x00000000ffffffff
#define XIF_MPCP_UPDATE_MPCPUPDPERIOD_FIELD_WIDTH 32
#define XIF_MPCP_UPDATE_MPCPUPDPERIOD_FIELD_SHIFT 0

extern const ru_field_rec XIF_BURST_PRELAUNCH_OFFSET_CFGBURSTPRELAUNCHOFFSET_FIELD;
#define XIF_BURST_PRELAUNCH_OFFSET_CFGBURSTPRELAUNCHOFFSET_FIELD_MASK  0x00000000ffffffff
#define XIF_BURST_PRELAUNCH_OFFSET_CFGBURSTPRELAUNCHOFFSET_FIELD_WIDTH 32
#define XIF_BURST_PRELAUNCH_OFFSET_CFGBURSTPRELAUNCHOFFSET_FIELD_SHIFT 0

extern const ru_field_rec XIF_VLAN_TYPE_RESERVED0_FIELD;
#define XIF_VLAN_TYPE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XIF_VLAN_TYPE_RESERVED0_FIELD_WIDTH 16
#define XIF_VLAN_TYPE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XIF_VLAN_TYPE_CFGVLANTYPE_FIELD;
#define XIF_VLAN_TYPE_CFGVLANTYPE_FIELD_MASK  0x000000000000ffff
#define XIF_VLAN_TYPE_CFGVLANTYPE_FIELD_WIDTH 16
#define XIF_VLAN_TYPE_CFGVLANTYPE_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_EN_RESERVED0_FIELD;
#define XIF_P2P_AE_SCI_EN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XIF_P2P_AE_SCI_EN_RESERVED0_FIELD_WIDTH 16
#define XIF_P2P_AE_SCI_EN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XIF_P2P_AE_SCI_EN_CFGP2PSCIEN_FIELD;
#define XIF_P2P_AE_SCI_EN_CFGP2PSCIEN_FIELD_MASK  0x000000000000ffff
#define XIF_P2P_AE_SCI_EN_CFGP2PSCIEN_FIELD_WIDTH 16
#define XIF_P2P_AE_SCI_EN_CFGP2PSCIEN_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_0_CFGP2PSCI_LO_0_FIELD;
#define XIF_P2P_AE_SCI_LO_0_CFGP2PSCI_LO_0_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_0_CFGP2PSCI_LO_0_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_0_CFGP2PSCI_LO_0_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_0_CFGP2PSCI_HI_0_FIELD;
#define XIF_P2P_AE_SCI_HI_0_CFGP2PSCI_HI_0_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_0_CFGP2PSCI_HI_0_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_0_CFGP2PSCI_HI_0_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_1_CFGP2PSCI_LO_1_FIELD;
#define XIF_P2P_AE_SCI_LO_1_CFGP2PSCI_LO_1_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_1_CFGP2PSCI_LO_1_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_1_CFGP2PSCI_LO_1_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_1_CFGP2PSCI_HI_1_FIELD;
#define XIF_P2P_AE_SCI_HI_1_CFGP2PSCI_HI_1_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_1_CFGP2PSCI_HI_1_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_1_CFGP2PSCI_HI_1_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_2_CFGP2PSCI_LO_2_FIELD;
#define XIF_P2P_AE_SCI_LO_2_CFGP2PSCI_LO_2_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_2_CFGP2PSCI_LO_2_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_2_CFGP2PSCI_LO_2_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_2_CFGP2PSCI_HI_2_FIELD;
#define XIF_P2P_AE_SCI_HI_2_CFGP2PSCI_HI_2_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_2_CFGP2PSCI_HI_2_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_2_CFGP2PSCI_HI_2_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_3_CFGP2PSCI_LO_3_FIELD;
#define XIF_P2P_AE_SCI_LO_3_CFGP2PSCI_LO_3_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_3_CFGP2PSCI_LO_3_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_3_CFGP2PSCI_LO_3_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_3_CFGP2PSCI_HI_3_FIELD;
#define XIF_P2P_AE_SCI_HI_3_CFGP2PSCI_HI_3_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_3_CFGP2PSCI_HI_3_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_3_CFGP2PSCI_HI_3_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_4_CFGP2PSCI_LO_4_FIELD;
#define XIF_P2P_AE_SCI_LO_4_CFGP2PSCI_LO_4_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_4_CFGP2PSCI_LO_4_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_4_CFGP2PSCI_LO_4_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_4_CFGP2PSCI_HI_4_FIELD;
#define XIF_P2P_AE_SCI_HI_4_CFGP2PSCI_HI_4_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_4_CFGP2PSCI_HI_4_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_4_CFGP2PSCI_HI_4_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_5_CFGP2PSCI_LO_5_FIELD;
#define XIF_P2P_AE_SCI_LO_5_CFGP2PSCI_LO_5_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_5_CFGP2PSCI_LO_5_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_5_CFGP2PSCI_LO_5_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_5_CFGP2PSCI_HI_5_FIELD;
#define XIF_P2P_AE_SCI_HI_5_CFGP2PSCI_HI_5_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_5_CFGP2PSCI_HI_5_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_5_CFGP2PSCI_HI_5_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_6_CFGP2PSCI_LO_6_FIELD;
#define XIF_P2P_AE_SCI_LO_6_CFGP2PSCI_LO_6_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_6_CFGP2PSCI_LO_6_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_6_CFGP2PSCI_LO_6_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_6_CFGP2PSCI_HI_6_FIELD;
#define XIF_P2P_AE_SCI_HI_6_CFGP2PSCI_HI_6_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_6_CFGP2PSCI_HI_6_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_6_CFGP2PSCI_HI_6_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_7_CFGP2PSCI_LO_7_FIELD;
#define XIF_P2P_AE_SCI_LO_7_CFGP2PSCI_LO_7_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_7_CFGP2PSCI_LO_7_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_7_CFGP2PSCI_LO_7_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_7_CFGP2PSCI_HI_7_FIELD;
#define XIF_P2P_AE_SCI_HI_7_CFGP2PSCI_HI_7_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_7_CFGP2PSCI_HI_7_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_7_CFGP2PSCI_HI_7_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_8_CFGP2PSCI_LO_8_FIELD;
#define XIF_P2P_AE_SCI_LO_8_CFGP2PSCI_LO_8_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_8_CFGP2PSCI_LO_8_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_8_CFGP2PSCI_LO_8_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_8_CFGP2PSCI_HI_8_FIELD;
#define XIF_P2P_AE_SCI_HI_8_CFGP2PSCI_HI_8_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_8_CFGP2PSCI_HI_8_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_8_CFGP2PSCI_HI_8_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_9_CFGP2PSCI_LO_9_FIELD;
#define XIF_P2P_AE_SCI_LO_9_CFGP2PSCI_LO_9_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_9_CFGP2PSCI_LO_9_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_9_CFGP2PSCI_LO_9_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_9_CFGP2PSCI_HI_9_FIELD;
#define XIF_P2P_AE_SCI_HI_9_CFGP2PSCI_HI_9_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_9_CFGP2PSCI_HI_9_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_9_CFGP2PSCI_HI_9_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_10_CFGP2PSCI_LO_10_FIELD;
#define XIF_P2P_AE_SCI_LO_10_CFGP2PSCI_LO_10_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_10_CFGP2PSCI_LO_10_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_10_CFGP2PSCI_LO_10_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_10_CFGP2PSCI_HI_10_FIELD;
#define XIF_P2P_AE_SCI_HI_10_CFGP2PSCI_HI_10_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_10_CFGP2PSCI_HI_10_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_10_CFGP2PSCI_HI_10_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_11_CFGP2PSCI_LO_11_FIELD;
#define XIF_P2P_AE_SCI_LO_11_CFGP2PSCI_LO_11_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_11_CFGP2PSCI_LO_11_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_11_CFGP2PSCI_LO_11_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_11_CFGP2PSCI_HI_11_FIELD;
#define XIF_P2P_AE_SCI_HI_11_CFGP2PSCI_HI_11_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_11_CFGP2PSCI_HI_11_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_11_CFGP2PSCI_HI_11_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_12_CFGP2PSCI_LO_12_FIELD;
#define XIF_P2P_AE_SCI_LO_12_CFGP2PSCI_LO_12_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_12_CFGP2PSCI_LO_12_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_12_CFGP2PSCI_LO_12_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_12_CFGP2PSCI_HI_12_FIELD;
#define XIF_P2P_AE_SCI_HI_12_CFGP2PSCI_HI_12_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_12_CFGP2PSCI_HI_12_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_12_CFGP2PSCI_HI_12_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_13_CFGP2PSCI_LO_13_FIELD;
#define XIF_P2P_AE_SCI_LO_13_CFGP2PSCI_LO_13_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_13_CFGP2PSCI_LO_13_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_13_CFGP2PSCI_LO_13_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_13_CFGP2PSCI_HI_13_FIELD;
#define XIF_P2P_AE_SCI_HI_13_CFGP2PSCI_HI_13_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_13_CFGP2PSCI_HI_13_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_13_CFGP2PSCI_HI_13_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_14_CFGP2PSCI_LO_14_FIELD;
#define XIF_P2P_AE_SCI_LO_14_CFGP2PSCI_LO_14_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_14_CFGP2PSCI_LO_14_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_14_CFGP2PSCI_LO_14_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_14_CFGP2PSCI_HI_14_FIELD;
#define XIF_P2P_AE_SCI_HI_14_CFGP2PSCI_HI_14_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_14_CFGP2PSCI_HI_14_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_14_CFGP2PSCI_HI_14_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_LO_15_CFGP2PSCI_LO_15_FIELD;
#define XIF_P2P_AE_SCI_LO_15_CFGP2PSCI_LO_15_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_LO_15_CFGP2PSCI_LO_15_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_LO_15_CFGP2PSCI_LO_15_FIELD_SHIFT 0

extern const ru_field_rec XIF_P2P_AE_SCI_HI_15_CFGP2PSCI_HI_15_FIELD;
#define XIF_P2P_AE_SCI_HI_15_CFGP2PSCI_HI_15_FIELD_MASK  0x00000000ffffffff
#define XIF_P2P_AE_SCI_HI_15_CFGP2PSCI_HI_15_FIELD_WIDTH 32
#define XIF_P2P_AE_SCI_HI_15_CFGP2PSCI_HI_15_FIELD_SHIFT 0

extern const ru_field_rec XIF_SECTX_KEYNUM_1_KEYSTATTX_HI_FIELD;
#define XIF_SECTX_KEYNUM_1_KEYSTATTX_HI_FIELD_MASK  0x00000000ffffffff
#define XIF_SECTX_KEYNUM_1_KEYSTATTX_HI_FIELD_WIDTH 32
#define XIF_SECTX_KEYNUM_1_KEYSTATTX_HI_FIELD_SHIFT 0

extern const ru_field_rec XIF_SECRX_KEYNUM_1_KEYSTATRX_HI_FIELD;
#define XIF_SECRX_KEYNUM_1_KEYSTATRX_HI_FIELD_MASK  0x00000000ffffffff
#define XIF_SECRX_KEYNUM_1_KEYSTATRX_HI_FIELD_WIDTH 32
#define XIF_SECRX_KEYNUM_1_KEYSTATRX_HI_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_RST_RESERVED0_FIELD;
#define XPCSRX_RX_RST_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define XPCSRX_RX_RST_RESERVED0_FIELD_WIDTH 31
#define XPCSRX_RX_RST_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_RST_CFGXPCSRXCLK161RSTN_FIELD;
#define XPCSRX_RX_RST_CFGXPCSRXCLK161RSTN_FIELD_MASK  0x0000000000000001
#define XPCSRX_RX_RST_CFGXPCSRXCLK161RSTN_FIELD_WIDTH 1
#define XPCSRX_RX_RST_CFGXPCSRXCLK161RSTN_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_INT_STAT_RESERVED0_FIELD;
#define XPCSRX_RX_INT_STAT_RESERVED0_FIELD_MASK  0x0000000080000000
#define XPCSRX_RX_INT_STAT_RESERVED0_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_RESERVED0_FIELD_SHIFT 31

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXIDLEDAJIT_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXIDLEDAJIT_FIELD_MASK  0x0000000040000000
#define XPCSRX_RX_INT_STAT_INTRXIDLEDAJIT_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXIDLEDAJIT_FIELD_SHIFT 30

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFRMRMISBRST_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFRMRMISBRST_FIELD_MASK  0x0000000020000000
#define XPCSRX_RX_INT_STAT_INTRXFRMRMISBRST_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFRMRMISBRST_FIELD_SHIFT 29

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXIDLESOPEOPGAPBIG_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXIDLESOPEOPGAPBIG_FIELD_MASK  0x0000000010000000
#define XPCSRX_RX_INT_STAT_INTRXIDLESOPEOPGAPBIG_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXIDLESOPEOPGAPBIG_FIELD_SHIFT 28

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXIDLEFRCINS_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXIDLEFRCINS_FIELD_MASK  0x0000000008000000
#define XPCSRX_RX_INT_STAT_INTRXIDLEFRCINS_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXIDLEFRCINS_FIELD_SHIFT 27

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRX64B66BMINIPGERR_FIELD;
#define XPCSRX_RX_INT_STAT_INTRX64B66BMINIPGERR_FIELD_MASK  0x0000000004000000
#define XPCSRX_RX_INT_STAT_INTRX64B66BMINIPGERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRX64B66BMINIPGERR_FIELD_SHIFT 26

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFECNQUECNTNEQ_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFECNQUECNTNEQ_FIELD_MASK  0x0000000002000000
#define XPCSRX_RX_INT_STAT_INTRXFECNQUECNTNEQ_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFECNQUECNTNEQ_FIELD_SHIFT 25

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXIDLEFIFOUNDRUN_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXIDLEFIFOUNDRUN_FIELD_MASK  0x0000000001000000
#define XPCSRX_RX_INT_STAT_INTRXIDLEFIFOUNDRUN_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXIDLEFIFOUNDRUN_FIELD_SHIFT 24

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXIDLEFIFOOVRRUN_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXIDLEFIFOOVRRUN_FIELD_MASK  0x0000000000800000
#define XPCSRX_RX_INT_STAT_INTRXIDLEFIFOOVRRUN_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXIDLEFIFOOVRRUN_FIELD_SHIFT 23

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFECHIGHCOR_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFECHIGHCOR_FIELD_MASK  0x0000000000400000
#define XPCSRX_RX_INT_STAT_INTRXFECHIGHCOR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFECHIGHCOR_FIELD_SHIFT 22

extern const ru_field_rec XPCSRX_RX_INT_STAT_RESERVED1_FIELD;
#define XPCSRX_RX_INT_STAT_RESERVED1_FIELD_MASK  0x0000000000300000
#define XPCSRX_RX_INT_STAT_RESERVED1_FIELD_WIDTH 2
#define XPCSRX_RX_INT_STAT_RESERVED1_FIELD_SHIFT 20

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFECDECSTOPONERR_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFECDECSTOPONERR_FIELD_MASK  0x0000000000080000
#define XPCSRX_RX_INT_STAT_INTRXFECDECSTOPONERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFECDECSTOPONERR_FIELD_SHIFT 19

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFECDECPASS_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFECDECPASS_FIELD_MASK  0x0000000000040000
#define XPCSRX_RX_INT_STAT_INTRXFECDECPASS_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFECDECPASS_FIELD_SHIFT 18

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXSTATFRMRHIGHBER_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXSTATFRMRHIGHBER_FIELD_MASK  0x0000000000020000
#define XPCSRX_RX_INT_STAT_INTRXSTATFRMRHIGHBER_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXSTATFRMRHIGHBER_FIELD_SHIFT 17

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFRMREXITBYSP_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFRMREXITBYSP_FIELD_MASK  0x0000000000010000
#define XPCSRX_RX_INT_STAT_INTRXFRMREXITBYSP_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFRMREXITBYSP_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFRMRBADSHMAX_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFRMRBADSHMAX_FIELD_MASK  0x0000000000008000
#define XPCSRX_RX_INT_STAT_INTRXFRMRBADSHMAX_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFRMRBADSHMAX_FIELD_SHIFT 15

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXDSCRAMBURSTSEQOUT_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXDSCRAMBURSTSEQOUT_FIELD_MASK  0x0000000000004000
#define XPCSRX_RX_INT_STAT_INTRXDSCRAMBURSTSEQOUT_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXDSCRAMBURSTSEQOUT_FIELD_SHIFT 14

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXTESTPSUDOLOCK_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXTESTPSUDOLOCK_FIELD_MASK  0x0000000000002000
#define XPCSRX_RX_INT_STAT_INTRXTESTPSUDOLOCK_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXTESTPSUDOLOCK_FIELD_SHIFT 13

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXTESTPSUDOTYPE_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXTESTPSUDOTYPE_FIELD_MASK  0x0000000000001000
#define XPCSRX_RX_INT_STAT_INTRXTESTPSUDOTYPE_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXTESTPSUDOTYPE_FIELD_SHIFT 12

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXTESTPSUDOERR_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXTESTPSUDOERR_FIELD_MASK  0x0000000000000800
#define XPCSRX_RX_INT_STAT_INTRXTESTPSUDOERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXTESTPSUDOERR_FIELD_SHIFT 11

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXTESTPRBSLOCK_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXTESTPRBSLOCK_FIELD_MASK  0x0000000000000400
#define XPCSRX_RX_INT_STAT_INTRXTESTPRBSLOCK_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXTESTPRBSLOCK_FIELD_SHIFT 10

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXTESTPRBSERR_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXTESTPRBSERR_FIELD_MASK  0x0000000000000200
#define XPCSRX_RX_INT_STAT_INTRXTESTPRBSERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXTESTPRBSERR_FIELD_SHIFT 9

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFECPSISTDECFAIL_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFECPSISTDECFAIL_FIELD_MASK  0x0000000000000100
#define XPCSRX_RX_INT_STAT_INTRXFECPSISTDECFAIL_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFECPSISTDECFAIL_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFRAMERBADSH_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFRAMERBADSH_FIELD_MASK  0x0000000000000080
#define XPCSRX_RX_INT_STAT_INTRXFRAMERBADSH_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFRAMERBADSH_FIELD_SHIFT 7

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFRAMERCWLOSS_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFRAMERCWLOSS_FIELD_MASK  0x0000000000000040
#define XPCSRX_RX_INT_STAT_INTRXFRAMERCWLOSS_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFRAMERCWLOSS_FIELD_SHIFT 6

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFRAMERCWLOCK_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFRAMERCWLOCK_FIELD_MASK  0x0000000000000020
#define XPCSRX_RX_INT_STAT_INTRXFRAMERCWLOCK_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFRAMERCWLOCK_FIELD_SHIFT 5

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFECDECFAIL_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFECDECFAIL_FIELD_MASK  0x0000000000000010
#define XPCSRX_RX_INT_STAT_INTRXFECDECFAIL_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFECDECFAIL_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRX64B66BDECERR_FIELD;
#define XPCSRX_RX_INT_STAT_INTRX64B66BDECERR_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_INT_STAT_INTRX64B66BDECERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRX64B66BDECERR_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFRMRNOLOCKLOS_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFRMRNOLOCKLOS_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_INT_STAT_INTRXFRMRNOLOCKLOS_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFRMRNOLOCKLOS_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_INT_STAT_INTRXFRMRROGUE_FIELD;
#define XPCSRX_RX_INT_STAT_INTRXFRMRROGUE_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_INT_STAT_INTRXFRMRROGUE_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INTRXFRMRROGUE_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_INT_STAT_INT_REGS_ERR_FIELD;
#define XPCSRX_RX_INT_STAT_INT_REGS_ERR_FIELD_MASK  0x0000000000000001
#define XPCSRX_RX_INT_STAT_INT_REGS_ERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT_INT_REGS_ERR_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_INT_MSK_RESERVED0_FIELD;
#define XPCSRX_RX_INT_MSK_RESERVED0_FIELD_MASK  0x0000000080000000
#define XPCSRX_RX_INT_MSK_RESERVED0_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_RESERVED0_FIELD_SHIFT 31

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXIDLEDAJIT_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXIDLEDAJIT_FIELD_MASK  0x0000000040000000
#define XPCSRX_RX_INT_MSK_MSKRXIDLEDAJIT_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXIDLEDAJIT_FIELD_SHIFT 30

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFRMRMISBRST_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFRMRMISBRST_FIELD_MASK  0x0000000020000000
#define XPCSRX_RX_INT_MSK_MSKRXFRMRMISBRST_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFRMRMISBRST_FIELD_SHIFT 29

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXIDLESOPEOPGAPBIG_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXIDLESOPEOPGAPBIG_FIELD_MASK  0x0000000010000000
#define XPCSRX_RX_INT_MSK_MSKRXIDLESOPEOPGAPBIG_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXIDLESOPEOPGAPBIG_FIELD_SHIFT 28

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXIDLEFRCINS_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXIDLEFRCINS_FIELD_MASK  0x0000000008000000
#define XPCSRX_RX_INT_MSK_MSKRXIDLEFRCINS_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXIDLEFRCINS_FIELD_SHIFT 27

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRX64B66BMINIPGERR_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRX64B66BMINIPGERR_FIELD_MASK  0x0000000004000000
#define XPCSRX_RX_INT_MSK_MSKRX64B66BMINIPGERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRX64B66BMINIPGERR_FIELD_SHIFT 26

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFECNQUECNTNEQ_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFECNQUECNTNEQ_FIELD_MASK  0x0000000002000000
#define XPCSRX_RX_INT_MSK_MSKRXFECNQUECNTNEQ_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFECNQUECNTNEQ_FIELD_SHIFT 25

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXIDLEFIFOUNDRUN_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXIDLEFIFOUNDRUN_FIELD_MASK  0x0000000001000000
#define XPCSRX_RX_INT_MSK_MSKRXIDLEFIFOUNDRUN_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXIDLEFIFOUNDRUN_FIELD_SHIFT 24

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXIDLEFIFOOVRRUN_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXIDLEFIFOOVRRUN_FIELD_MASK  0x0000000000800000
#define XPCSRX_RX_INT_MSK_MSKRXIDLEFIFOOVRRUN_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXIDLEFIFOOVRRUN_FIELD_SHIFT 23

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFECHIGHCOR_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFECHIGHCOR_FIELD_MASK  0x0000000000400000
#define XPCSRX_RX_INT_MSK_MSKRXFECHIGHCOR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFECHIGHCOR_FIELD_SHIFT 22

extern const ru_field_rec XPCSRX_RX_INT_MSK_RESERVED1_FIELD;
#define XPCSRX_RX_INT_MSK_RESERVED1_FIELD_MASK  0x0000000000300000
#define XPCSRX_RX_INT_MSK_RESERVED1_FIELD_WIDTH 2
#define XPCSRX_RX_INT_MSK_RESERVED1_FIELD_SHIFT 20

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFECDECSTOPONERR_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFECDECSTOPONERR_FIELD_MASK  0x0000000000080000
#define XPCSRX_RX_INT_MSK_MSKRXFECDECSTOPONERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFECDECSTOPONERR_FIELD_SHIFT 19

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFECDECPASS_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFECDECPASS_FIELD_MASK  0x0000000000040000
#define XPCSRX_RX_INT_MSK_MSKRXFECDECPASS_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFECDECPASS_FIELD_SHIFT 18

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXSTATFRMRHIGHBER_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXSTATFRMRHIGHBER_FIELD_MASK  0x0000000000020000
#define XPCSRX_RX_INT_MSK_MSKRXSTATFRMRHIGHBER_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXSTATFRMRHIGHBER_FIELD_SHIFT 17

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFRMREXITBYSP_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFRMREXITBYSP_FIELD_MASK  0x0000000000010000
#define XPCSRX_RX_INT_MSK_MSKRXFRMREXITBYSP_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFRMREXITBYSP_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFRMRBADSHMAX_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFRMRBADSHMAX_FIELD_MASK  0x0000000000008000
#define XPCSRX_RX_INT_MSK_MSKRXFRMRBADSHMAX_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFRMRBADSHMAX_FIELD_SHIFT 15

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXDSCRAMBURSTSEQOUT_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXDSCRAMBURSTSEQOUT_FIELD_MASK  0x0000000000004000
#define XPCSRX_RX_INT_MSK_MSKRXDSCRAMBURSTSEQOUT_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXDSCRAMBURSTSEQOUT_FIELD_SHIFT 14

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOLOCK_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOLOCK_FIELD_MASK  0x0000000000002000
#define XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOLOCK_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOLOCK_FIELD_SHIFT 13

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOTYPE_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOTYPE_FIELD_MASK  0x0000000000001000
#define XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOTYPE_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOTYPE_FIELD_SHIFT 12

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOERR_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOERR_FIELD_MASK  0x0000000000000800
#define XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXTESTPSUDOERR_FIELD_SHIFT 11

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXTESTPRBSLOCK_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXTESTPRBSLOCK_FIELD_MASK  0x0000000000000400
#define XPCSRX_RX_INT_MSK_MSKRXTESTPRBSLOCK_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXTESTPRBSLOCK_FIELD_SHIFT 10

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXTESTPRBSERR_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXTESTPRBSERR_FIELD_MASK  0x0000000000000200
#define XPCSRX_RX_INT_MSK_MSKRXTESTPRBSERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXTESTPRBSERR_FIELD_SHIFT 9

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFECPSISTDECFAIL_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFECPSISTDECFAIL_FIELD_MASK  0x0000000000000100
#define XPCSRX_RX_INT_MSK_MSKRXFECPSISTDECFAIL_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFECPSISTDECFAIL_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFRAMERBADSH_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFRAMERBADSH_FIELD_MASK  0x0000000000000080
#define XPCSRX_RX_INT_MSK_MSKRXFRAMERBADSH_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFRAMERBADSH_FIELD_SHIFT 7

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFRAMERCWLOSS_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFRAMERCWLOSS_FIELD_MASK  0x0000000000000040
#define XPCSRX_RX_INT_MSK_MSKRXFRAMERCWLOSS_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFRAMERCWLOSS_FIELD_SHIFT 6

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFRAMERCWLOCK_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFRAMERCWLOCK_FIELD_MASK  0x0000000000000020
#define XPCSRX_RX_INT_MSK_MSKRXFRAMERCWLOCK_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFRAMERCWLOCK_FIELD_SHIFT 5

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFECDECFAIL_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFECDECFAIL_FIELD_MASK  0x0000000000000010
#define XPCSRX_RX_INT_MSK_MSKRXFECDECFAIL_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFECDECFAIL_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRX64B66BDECERR_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRX64B66BDECERR_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_INT_MSK_MSKRX64B66BDECERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRX64B66BDECERR_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFRMRNOLOCKLOS_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFRMRNOLOCKLOS_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_INT_MSK_MSKRXFRMRNOLOCKLOS_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFRMRNOLOCKLOS_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSKRXFRMRROGUE_FIELD;
#define XPCSRX_RX_INT_MSK_MSKRXFRMRROGUE_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_INT_MSK_MSKRXFRMRROGUE_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSKRXFRMRROGUE_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_INT_MSK_MSK_INT_REGS_ERR_FIELD;
#define XPCSRX_RX_INT_MSK_MSK_INT_REGS_ERR_FIELD_MASK  0x0000000000000001
#define XPCSRX_RX_INT_MSK_MSK_INT_REGS_ERR_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK_MSK_INT_REGS_ERR_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_CTL_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XPCSRX_RX_FRAMER_CTL_RESERVED0_FIELD_WIDTH 16
#define XPCSRX_RX_FRAMER_CTL_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRFRCEARLYALIGN_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRFRCEARLYALIGN_FIELD_MASK  0x0000000000008000
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRFRCEARLYALIGN_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRFRCEARLYALIGN_FIELD_SHIFT 15

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRMODEA_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRMODEA_FIELD_MASK  0x0000000000004000
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRMODEA_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRMODEA_FIELD_SHIFT 14

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMROVERLAPBDEBDZERO_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMROVERLAPBDEBDZERO_FIELD_MASK  0x0000000000002000
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMROVERLAPBDEBDZERO_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMROVERLAPBDEBDZERO_FIELD_SHIFT 13

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMROVERLAPGNTEN_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMROVERLAPGNTEN_FIELD_MASK  0x0000000000001000
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMROVERLAPGNTEN_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMROVERLAPGNTEN_FIELD_SHIFT 12

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_RESERVED1_FIELD;
#define XPCSRX_RX_FRAMER_CTL_RESERVED1_FIELD_MASK  0x0000000000000c00
#define XPCSRX_RX_FRAMER_CTL_RESERVED1_FIELD_WIDTH 2
#define XPCSRX_RX_FRAMER_CTL_RESERVED1_FIELD_SHIFT 10

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEBURSTOLDALIGN_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEBURSTOLDALIGN_FIELD_MASK  0x0000000000000200
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEBURSTOLDALIGN_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEBURSTOLDALIGN_FIELD_SHIFT 9

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRMISBRSTTYPE_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRMISBRSTTYPE_FIELD_MASK  0x0000000000000100
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRMISBRSTTYPE_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRMISBRSTTYPE_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMREBDVLDEN_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMREBDVLDEN_FIELD_MASK  0x0000000000000080
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMREBDVLDEN_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMREBDVLDEN_FIELD_SHIFT 7

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBDCNTEN_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBDCNTEN_FIELD_MASK  0x0000000000000040
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBDCNTEN_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBDCNTEN_FIELD_SHIFT 6

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBURSTBADSHEN_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBURSTBADSHEN_FIELD_MASK  0x0000000000000020
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBURSTBADSHEN_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBURSTBADSHEN_FIELD_SHIFT 5

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRSPULKEN_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRSPULKEN_FIELD_MASK  0x0000000000000010
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRSPULKEN_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRSPULKEN_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEBURST_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEBURST_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEBURST_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEBURST_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMREN_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMREN_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMREN_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMREN_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBLKFECFAIL_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBLKFECFAIL_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBLKFECFAIL_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRMRBLKFECFAIL_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEFEC_FIELD;
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEFEC_FIELD_MASK  0x0000000000000001
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEFEC_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_CTL_CFGXPCSRXFRAMEFEC_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_CTL_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_CTL_RESERVED0_FIELD_MASK  0x00000000fffff800
#define XPCSRX_RX_FEC_CTL_RESERVED0_FIELD_WIDTH 21
#define XPCSRX_RX_FEC_CTL_RESERVED0_FIELD_SHIFT 11

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECSTOPONERR_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECSTOPONERR_FIELD_MASK  0x0000000000000400
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECSTOPONERR_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECSTOPONERR_FIELD_SHIFT 10

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECCNTNQUECW_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECCNTNQUECW_FIELD_MASK  0x0000000000000200
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECCNTNQUECW_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECCNTNQUECW_FIELD_SHIFT 9

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECNQUERST_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECNQUERST_FIELD_MASK  0x0000000000000100
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECNQUERST_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECNQUERST_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECONEZEROMODE_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECONEZEROMODE_FIELD_MASK  0x0000000000000080
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECONEZEROMODE_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECONEZEROMODE_FIELD_SHIFT 7

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECBLKCORRECT_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECBLKCORRECT_FIELD_MASK  0x0000000000000040
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECBLKCORRECT_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECBLKCORRECT_FIELD_SHIFT 6

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECNQUETESTPAT_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECNQUETESTPAT_FIELD_MASK  0x0000000000000020
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECNQUETESTPAT_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECNQUETESTPAT_FIELD_SHIFT 5

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECFAILBLKSH0_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECFAILBLKSH0_FIELD_MASK  0x0000000000000010
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECFAILBLKSH0_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECFAILBLKSH0_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECSTRIP_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECSTRIP_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECSTRIP_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECSTRIP_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECBYPAS_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECBYPAS_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECBYPAS_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECBYPAS_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECIDLEINS_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECIDLEINS_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECIDLEINS_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECIDLEINS_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_FEC_CTL_CFGXPCSRXFECEN_FIELD;
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECEN_FIELD_MASK  0x0000000000000001
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECEN_FIELD_WIDTH 1
#define XPCSRX_RX_FEC_CTL_CFGXPCSRXFECEN_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_DSCRAM_CTL_RESERVED0_FIELD;
#define XPCSRX_RX_DSCRAM_CTL_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define XPCSRX_RX_DSCRAM_CTL_RESERVED0_FIELD_WIDTH 31
#define XPCSRX_RX_DSCRAM_CTL_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_DSCRAM_CTL_CFGXPCSRXDSCRAMBYPAS_FIELD;
#define XPCSRX_RX_DSCRAM_CTL_CFGXPCSRXDSCRAMBYPAS_FIELD_MASK  0x0000000000000001
#define XPCSRX_RX_DSCRAM_CTL_CFGXPCSRXDSCRAMBYPAS_FIELD_WIDTH 1
#define XPCSRX_RX_DSCRAM_CTL_CFGXPCSRXDSCRAMBYPAS_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTMASK1_FIELD;
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTMASK1_FIELD_MASK  0x00000000ff000000
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTMASK1_FIELD_WIDTH 8
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTMASK1_FIELD_SHIFT 24

extern const ru_field_rec XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTMASK0_FIELD;
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTMASK0_FIELD_MASK  0x0000000000ff0000
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTMASK0_FIELD_WIDTH 8
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTMASK0_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_64B66B_CTL_RESERVED0_FIELD;
#define XPCSRX_RX_64B66B_CTL_RESERVED0_FIELD_MASK  0x000000000000c000
#define XPCSRX_RX_64B66B_CTL_RESERVED0_FIELD_WIDTH 2
#define XPCSRX_RX_64B66B_CTL_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BSMASK1_FIELD;
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BSMASK1_FIELD_MASK  0x0000000000003000
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BSMASK1_FIELD_WIDTH 2
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BSMASK1_FIELD_SHIFT 12

extern const ru_field_rec XPCSRX_RX_64B66B_CTL_RESERVED1_FIELD;
#define XPCSRX_RX_64B66B_CTL_RESERVED1_FIELD_MASK  0x0000000000000c00
#define XPCSRX_RX_64B66B_CTL_RESERVED1_FIELD_WIDTH 2
#define XPCSRX_RX_64B66B_CTL_RESERVED1_FIELD_SHIFT 10

extern const ru_field_rec XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BSMASK0_FIELD;
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BSMASK0_FIELD_MASK  0x0000000000000300
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BSMASK0_FIELD_WIDTH 2
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BSMASK0_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_64B66B_CTL_RESERVED2_FIELD;
#define XPCSRX_RX_64B66B_CTL_RESERVED2_FIELD_MASK  0x00000000000000c0
#define XPCSRX_RX_64B66B_CTL_RESERVED2_FIELD_WIDTH 2
#define XPCSRX_RX_64B66B_CTL_RESERVED2_FIELD_SHIFT 6

extern const ru_field_rec XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTDLAY_FIELD;
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTDLAY_FIELD_MASK  0x0000000000000030
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTDLAY_FIELD_WIDTH 2
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BTDLAY_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_64B66B_CTL_RESERVED3_FIELD;
#define XPCSRX_RX_64B66B_CTL_RESERVED3_FIELD_MASK  0x000000000000000e
#define XPCSRX_RX_64B66B_CTL_RESERVED3_FIELD_WIDTH 3
#define XPCSRX_RX_64B66B_CTL_RESERVED3_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BDECBYPAS_FIELD;
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BDECBYPAS_FIELD_MASK  0x0000000000000001
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BDECBYPAS_FIELD_WIDTH 1
#define XPCSRX_RX_64B66B_CTL_CFGXPCSRX64B66BDECBYPAS_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_TEST_CTL_RESERVED0_FIELD;
#define XPCSRX_RX_TEST_CTL_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define XPCSRX_RX_TEST_CTL_RESERVED0_FIELD_WIDTH 30
#define XPCSRX_RX_TEST_CTL_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_TEST_CTL_CFGXPCSRXTESTPRBSDETEN_FIELD;
#define XPCSRX_RX_TEST_CTL_CFGXPCSRXTESTPRBSDETEN_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_TEST_CTL_CFGXPCSRXTESTPRBSDETEN_FIELD_WIDTH 1
#define XPCSRX_RX_TEST_CTL_CFGXPCSRXTESTPRBSDETEN_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_TEST_CTL_CFGXPCSRXTESTPSUDODETEN_FIELD;
#define XPCSRX_RX_TEST_CTL_CFGXPCSRXTESTPSUDODETEN_FIELD_MASK  0x0000000000000001
#define XPCSRX_RX_TEST_CTL_CFGXPCSRXTESTPSUDODETEN_FIELD_WIDTH 1
#define XPCSRX_RX_TEST_CTL_CFGXPCSRXTESTPSUDODETEN_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_IDLE_RD_TIMER_DLY_RESERVED0_FIELD;
#define XPCSRX_RX_IDLE_RD_TIMER_DLY_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XPCSRX_RX_IDLE_RD_TIMER_DLY_RESERVED0_FIELD_WIDTH 24
#define XPCSRX_RX_IDLE_RD_TIMER_DLY_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_IDLE_RD_TIMER_DLY_CFGXPCSRXIDLERDDELAYTIMERMAX_FIELD;
#define XPCSRX_RX_IDLE_RD_TIMER_DLY_CFGXPCSRXIDLERDDELAYTIMERMAX_FIELD_MASK  0x00000000000000ff
#define XPCSRX_RX_IDLE_RD_TIMER_DLY_CFGXPCSRXIDLERDDELAYTIMERMAX_FIELD_WIDTH 8
#define XPCSRX_RX_IDLE_RD_TIMER_DLY_CFGXPCSRXIDLERDDELAYTIMERMAX_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_IDLE_GAP_SIZ_MAX_RESERVED0_FIELD;
#define XPCSRX_RX_IDLE_GAP_SIZ_MAX_RESERVED0_FIELD_MASK  0x00000000f8000000
#define XPCSRX_RX_IDLE_GAP_SIZ_MAX_RESERVED0_FIELD_WIDTH 5
#define XPCSRX_RX_IDLE_GAP_SIZ_MAX_RESERVED0_FIELD_SHIFT 27

extern const ru_field_rec XPCSRX_RX_IDLE_GAP_SIZ_MAX_CFGXPCSRXIDLEOVRSIZMAX_FIELD;
#define XPCSRX_RX_IDLE_GAP_SIZ_MAX_CFGXPCSRXIDLEOVRSIZMAX_FIELD_MASK  0x0000000007ff0000
#define XPCSRX_RX_IDLE_GAP_SIZ_MAX_CFGXPCSRXIDLEOVRSIZMAX_FIELD_WIDTH 11
#define XPCSRX_RX_IDLE_GAP_SIZ_MAX_CFGXPCSRXIDLEOVRSIZMAX_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_IDLE_GAP_SIZ_MAX_CFGXPCSRXIDLESOPEOPGAP_FIELD;
#define XPCSRX_RX_IDLE_GAP_SIZ_MAX_CFGXPCSRXIDLESOPEOPGAP_FIELD_MASK  0x000000000000ffff
#define XPCSRX_RX_IDLE_GAP_SIZ_MAX_CFGXPCSRXIDLESOPEOPGAP_FIELD_WIDTH 16
#define XPCSRX_RX_IDLE_GAP_SIZ_MAX_CFGXPCSRXIDLESOPEOPGAP_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_LK_MAX_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_LK_MAX_RESERVED0_FIELD_MASK  0x00000000fffffe00
#define XPCSRX_RX_FRAMER_LK_MAX_RESERVED0_FIELD_WIDTH 23
#define XPCSRX_RX_FRAMER_LK_MAX_RESERVED0_FIELD_SHIFT 9

extern const ru_field_rec XPCSRX_RX_FRAMER_LK_MAX_CFGXPCSRXFRMRCWLKTIMERMAX_FIELD;
#define XPCSRX_RX_FRAMER_LK_MAX_CFGXPCSRXFRMRCWLKTIMERMAX_FIELD_MASK  0x00000000000001ff
#define XPCSRX_RX_FRAMER_LK_MAX_CFGXPCSRXFRMRCWLKTIMERMAX_FIELD_WIDTH 9
#define XPCSRX_RX_FRAMER_LK_MAX_CFGXPCSRXFRMRCWLKTIMERMAX_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_UNLK_MAX_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_UNLK_MAX_RESERVED0_FIELD_MASK  0x00000000fffffe00
#define XPCSRX_RX_FRAMER_UNLK_MAX_RESERVED0_FIELD_WIDTH 23
#define XPCSRX_RX_FRAMER_UNLK_MAX_RESERVED0_FIELD_SHIFT 9

extern const ru_field_rec XPCSRX_RX_FRAMER_UNLK_MAX_CFGXPCSRXFRMRCWUNLKTIMERMAX_FIELD;
#define XPCSRX_RX_FRAMER_UNLK_MAX_CFGXPCSRXFRMRCWUNLKTIMERMAX_FIELD_MASK  0x00000000000001ff
#define XPCSRX_RX_FRAMER_UNLK_MAX_CFGXPCSRXFRMRCWUNLKTIMERMAX_FIELD_WIDTH 9
#define XPCSRX_RX_FRAMER_UNLK_MAX_CFGXPCSRXFRMRCWUNLKTIMERMAX_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_BD_SH_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_BD_SH_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define XPCSRX_RX_FRAMER_BD_SH_RESERVED0_FIELD_WIDTH 30
#define XPCSRX_RX_FRAMER_BD_SH_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_FRAMER_BD_SH_CFGXPCSRXOLTBDSH_FIELD;
#define XPCSRX_RX_FRAMER_BD_SH_CFGXPCSRXOLTBDSH_FIELD_MASK  0x0000000000000003
#define XPCSRX_RX_FRAMER_BD_SH_CFGXPCSRXOLTBDSH_FIELD_WIDTH 2
#define XPCSRX_RX_FRAMER_BD_SH_CFGXPCSRXOLTBDSH_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_BD_LO_CFGXPCSRXOLTBDLO_FIELD;
#define XPCSRX_RX_FRAMER_BD_LO_CFGXPCSRXOLTBDLO_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FRAMER_BD_LO_CFGXPCSRXOLTBDLO_FIELD_WIDTH 32
#define XPCSRX_RX_FRAMER_BD_LO_CFGXPCSRXOLTBDLO_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_BD_HI_CFGXPCSRXOLTBDHI_FIELD;
#define XPCSRX_RX_FRAMER_BD_HI_CFGXPCSRXOLTBDHI_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FRAMER_BD_HI_CFGXPCSRXOLTBDHI_FIELD_WIDTH 32
#define XPCSRX_RX_FRAMER_BD_HI_CFGXPCSRXOLTBDHI_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_EBD_SH_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_EBD_SH_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define XPCSRX_RX_FRAMER_EBD_SH_RESERVED0_FIELD_WIDTH 30
#define XPCSRX_RX_FRAMER_EBD_SH_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_FRAMER_EBD_SH_CFGXPCSRXOLTEBDSH_FIELD;
#define XPCSRX_RX_FRAMER_EBD_SH_CFGXPCSRXOLTEBDSH_FIELD_MASK  0x0000000000000003
#define XPCSRX_RX_FRAMER_EBD_SH_CFGXPCSRXOLTEBDSH_FIELD_WIDTH 2
#define XPCSRX_RX_FRAMER_EBD_SH_CFGXPCSRXOLTEBDSH_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_EBD_LO_CFGXPCSRXOLTEBDLO_FIELD;
#define XPCSRX_RX_FRAMER_EBD_LO_CFGXPCSRXOLTEBDLO_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FRAMER_EBD_LO_CFGXPCSRXOLTEBDLO_FIELD_WIDTH 32
#define XPCSRX_RX_FRAMER_EBD_LO_CFGXPCSRXOLTEBDLO_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_EBD_HI_CFGXPCSRXOLTEBDHI_FIELD;
#define XPCSRX_RX_FRAMER_EBD_HI_CFGXPCSRXOLTEBDHI_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FRAMER_EBD_HI_CFGXPCSRXOLTEBDHI_FIELD_WIDTH 32
#define XPCSRX_RX_FRAMER_EBD_HI_CFGXPCSRXOLTEBDHI_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_STATUS_RESERVED0_FIELD;
#define XPCSRX_RX_STATUS_RESERVED0_FIELD_MASK  0x0000000080000000
#define XPCSRX_RX_STATUS_RESERVED0_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_RESERVED0_FIELD_SHIFT 31

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXIDLEDAJIT_FIELD;
#define XPCSRX_RX_STATUS_STATRXIDLEDAJIT_FIELD_MASK  0x0000000040000000
#define XPCSRX_RX_STATUS_STATRXIDLEDAJIT_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXIDLEDAJIT_FIELD_SHIFT 30

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFRMRMISBRST_FIELD;
#define XPCSRX_RX_STATUS_STATRXFRMRMISBRST_FIELD_MASK  0x0000000020000000
#define XPCSRX_RX_STATUS_STATRXFRMRMISBRST_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFRMRMISBRST_FIELD_SHIFT 29

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXIDLESOPEOPGAPBIG_FIELD;
#define XPCSRX_RX_STATUS_STATRXIDLESOPEOPGAPBIG_FIELD_MASK  0x0000000010000000
#define XPCSRX_RX_STATUS_STATRXIDLESOPEOPGAPBIG_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXIDLESOPEOPGAPBIG_FIELD_SHIFT 28

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXIDLEFRCINS_FIELD;
#define XPCSRX_RX_STATUS_STATRXIDLEFRCINS_FIELD_MASK  0x0000000008000000
#define XPCSRX_RX_STATUS_STATRXIDLEFRCINS_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXIDLEFRCINS_FIELD_SHIFT 27

extern const ru_field_rec XPCSRX_RX_STATUS_STATRX64B66BMINIPGERR_FIELD;
#define XPCSRX_RX_STATUS_STATRX64B66BMINIPGERR_FIELD_MASK  0x0000000004000000
#define XPCSRX_RX_STATUS_STATRX64B66BMINIPGERR_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRX64B66BMINIPGERR_FIELD_SHIFT 26

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFECNQUECNTNEQ_FIELD;
#define XPCSRX_RX_STATUS_STATRXFECNQUECNTNEQ_FIELD_MASK  0x0000000002000000
#define XPCSRX_RX_STATUS_STATRXFECNQUECNTNEQ_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFECNQUECNTNEQ_FIELD_SHIFT 25

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXIDLEFIFOUNDRUN_FIELD;
#define XPCSRX_RX_STATUS_STATRXIDLEFIFOUNDRUN_FIELD_MASK  0x0000000001000000
#define XPCSRX_RX_STATUS_STATRXIDLEFIFOUNDRUN_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXIDLEFIFOUNDRUN_FIELD_SHIFT 24

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXIDLEFIFOOVRRUN_FIELD;
#define XPCSRX_RX_STATUS_STATRXIDLEFIFOOVRRUN_FIELD_MASK  0x0000000000800000
#define XPCSRX_RX_STATUS_STATRXIDLEFIFOOVRRUN_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXIDLEFIFOOVRRUN_FIELD_SHIFT 23

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFECHIGHCOR_FIELD;
#define XPCSRX_RX_STATUS_STATRXFECHIGHCOR_FIELD_MASK  0x0000000000400000
#define XPCSRX_RX_STATUS_STATRXFECHIGHCOR_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFECHIGHCOR_FIELD_SHIFT 22

extern const ru_field_rec XPCSRX_RX_STATUS_RESERVED1_FIELD;
#define XPCSRX_RX_STATUS_RESERVED1_FIELD_MASK  0x0000000000380000
#define XPCSRX_RX_STATUS_RESERVED1_FIELD_WIDTH 3
#define XPCSRX_RX_STATUS_RESERVED1_FIELD_SHIFT 19

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFECDECPASS_FIELD;
#define XPCSRX_RX_STATUS_STATRXFECDECPASS_FIELD_MASK  0x0000000000040000
#define XPCSRX_RX_STATUS_STATRXFECDECPASS_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFECDECPASS_FIELD_SHIFT 18

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXSTATFRMRHIGHBER_FIELD;
#define XPCSRX_RX_STATUS_STATRXSTATFRMRHIGHBER_FIELD_MASK  0x0000000000020000
#define XPCSRX_RX_STATUS_STATRXSTATFRMRHIGHBER_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXSTATFRMRHIGHBER_FIELD_SHIFT 17

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFRMREXITBYSP_FIELD;
#define XPCSRX_RX_STATUS_STATRXFRMREXITBYSP_FIELD_MASK  0x0000000000010000
#define XPCSRX_RX_STATUS_STATRXFRMREXITBYSP_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFRMREXITBYSP_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFRMRBADSHMAX_FIELD;
#define XPCSRX_RX_STATUS_STATRXFRMRBADSHMAX_FIELD_MASK  0x0000000000008000
#define XPCSRX_RX_STATUS_STATRXFRMRBADSHMAX_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFRMRBADSHMAX_FIELD_SHIFT 15

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXDSCRAMBURSTSEQOUT_FIELD;
#define XPCSRX_RX_STATUS_STATRXDSCRAMBURSTSEQOUT_FIELD_MASK  0x0000000000004000
#define XPCSRX_RX_STATUS_STATRXDSCRAMBURSTSEQOUT_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXDSCRAMBURSTSEQOUT_FIELD_SHIFT 14

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXTESTPSUDOLOCK_FIELD;
#define XPCSRX_RX_STATUS_STATRXTESTPSUDOLOCK_FIELD_MASK  0x0000000000002000
#define XPCSRX_RX_STATUS_STATRXTESTPSUDOLOCK_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXTESTPSUDOLOCK_FIELD_SHIFT 13

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXTESTPSUDOTYPE_FIELD;
#define XPCSRX_RX_STATUS_STATRXTESTPSUDOTYPE_FIELD_MASK  0x0000000000001000
#define XPCSRX_RX_STATUS_STATRXTESTPSUDOTYPE_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXTESTPSUDOTYPE_FIELD_SHIFT 12

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXTESTPSUDOERR_FIELD;
#define XPCSRX_RX_STATUS_STATRXTESTPSUDOERR_FIELD_MASK  0x0000000000000800
#define XPCSRX_RX_STATUS_STATRXTESTPSUDOERR_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXTESTPSUDOERR_FIELD_SHIFT 11

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXTESTPRBSLOCK_FIELD;
#define XPCSRX_RX_STATUS_STATRXTESTPRBSLOCK_FIELD_MASK  0x0000000000000400
#define XPCSRX_RX_STATUS_STATRXTESTPRBSLOCK_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXTESTPRBSLOCK_FIELD_SHIFT 10

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXTESTPRBSERR_FIELD;
#define XPCSRX_RX_STATUS_STATRXTESTPRBSERR_FIELD_MASK  0x0000000000000200
#define XPCSRX_RX_STATUS_STATRXTESTPRBSERR_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXTESTPRBSERR_FIELD_SHIFT 9

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFECPSISTDECFAIL_FIELD;
#define XPCSRX_RX_STATUS_STATRXFECPSISTDECFAIL_FIELD_MASK  0x0000000000000100
#define XPCSRX_RX_STATUS_STATRXFECPSISTDECFAIL_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFECPSISTDECFAIL_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFRAMERBADSH_FIELD;
#define XPCSRX_RX_STATUS_STATRXFRAMERBADSH_FIELD_MASK  0x0000000000000080
#define XPCSRX_RX_STATUS_STATRXFRAMERBADSH_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFRAMERBADSH_FIELD_SHIFT 7

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFRAMERCWLOSS_FIELD;
#define XPCSRX_RX_STATUS_STATRXFRAMERCWLOSS_FIELD_MASK  0x0000000000000040
#define XPCSRX_RX_STATUS_STATRXFRAMERCWLOSS_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFRAMERCWLOSS_FIELD_SHIFT 6

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFRAMERCWLOCK_FIELD;
#define XPCSRX_RX_STATUS_STATRXFRAMERCWLOCK_FIELD_MASK  0x0000000000000020
#define XPCSRX_RX_STATUS_STATRXFRAMERCWLOCK_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFRAMERCWLOCK_FIELD_SHIFT 5

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFECDECFAIL_FIELD;
#define XPCSRX_RX_STATUS_STATRXFECDECFAIL_FIELD_MASK  0x0000000000000010
#define XPCSRX_RX_STATUS_STATRXFECDECFAIL_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFECDECFAIL_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_STATUS_STATRX64B66BDECERR_FIELD;
#define XPCSRX_RX_STATUS_STATRX64B66BDECERR_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_STATUS_STATRX64B66BDECERR_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRX64B66BDECERR_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFRMRNOLOCKLOS_FIELD;
#define XPCSRX_RX_STATUS_STATRXFRMRNOLOCKLOS_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_STATUS_STATRXFRMRNOLOCKLOS_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFRMRNOLOCKLOS_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_STATUS_STATRXFRMRROGUE_FIELD;
#define XPCSRX_RX_STATUS_STATRXFRMRROGUE_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_STATUS_STATRXFRMRROGUE_FIELD_WIDTH 1
#define XPCSRX_RX_STATUS_STATRXFRMRROGUE_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_FRAMER_LK_ULK_MAX_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_RESERVED0_FIELD_MASK  0x00000000e0000000
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_RESERVED0_FIELD_WIDTH 3
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_RESERVED0_FIELD_SHIFT 29

extern const ru_field_rec XPCSRX_RX_FRAMER_LK_ULK_MAX_CFGXPCSRXFRMRSPLKMAX_FIELD;
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_CFGXPCSRXFRMRSPLKMAX_FIELD_MASK  0x000000001fff0000
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_CFGXPCSRXFRMRSPLKMAX_FIELD_WIDTH 13
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_CFGXPCSRXFRMRSPLKMAX_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_FRAMER_LK_ULK_MAX_RESERVED1_FIELD;
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_RESERVED1_FIELD_MASK  0x000000000000e000
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_RESERVED1_FIELD_WIDTH 3
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_RESERVED1_FIELD_SHIFT 13

extern const ru_field_rec XPCSRX_RX_FRAMER_LK_ULK_MAX_CFGXPCSRXFRMRSPULKMAX_FIELD;
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_CFGXPCSRXFRMRSPULKMAX_FIELD_MASK  0x0000000000001fff
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_CFGXPCSRXFRMRSPULKMAX_FIELD_WIDTH 13
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_CFGXPCSRXFRMRSPULKMAX_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_SP_SH_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_SP_SH_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define XPCSRX_RX_FRAMER_SP_SH_RESERVED0_FIELD_WIDTH 30
#define XPCSRX_RX_FRAMER_SP_SH_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_FRAMER_SP_SH_CFGXPCSRXOLTSPSH_FIELD;
#define XPCSRX_RX_FRAMER_SP_SH_CFGXPCSRXOLTSPSH_FIELD_MASK  0x0000000000000003
#define XPCSRX_RX_FRAMER_SP_SH_CFGXPCSRXOLTSPSH_FIELD_WIDTH 2
#define XPCSRX_RX_FRAMER_SP_SH_CFGXPCSRXOLTSPSH_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_SP_LO_CFGXPCSRXOLTSPLO_FIELD;
#define XPCSRX_RX_FRAMER_SP_LO_CFGXPCSRXOLTSPLO_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FRAMER_SP_LO_CFGXPCSRXOLTSPLO_FIELD_WIDTH 32
#define XPCSRX_RX_FRAMER_SP_LO_CFGXPCSRXOLTSPLO_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_SP_HI_CFGXPCSRXOLTSPHI_FIELD;
#define XPCSRX_RX_FRAMER_SP_HI_CFGXPCSRXOLTSPHI_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FRAMER_SP_HI_CFGXPCSRXOLTSPHI_FIELD_WIDTH 32
#define XPCSRX_RX_FRAMER_SP_HI_CFGXPCSRXOLTSPHI_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_STATE_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_STATE_RESERVED0_FIELD_MASK  0x00000000fffffff0
#define XPCSRX_RX_FRAMER_STATE_RESERVED0_FIELD_WIDTH 28
#define XPCSRX_RX_FRAMER_STATE_RESERVED0_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_FRAMER_STATE_XPCSRXFRMRSTATE_FIELD;
#define XPCSRX_RX_FRAMER_STATE_XPCSRXFRMRSTATE_FIELD_MASK  0x000000000000000f
#define XPCSRX_RX_FRAMER_STATE_XPCSRXFRMRSTATE_FIELD_WIDTH 4
#define XPCSRX_RX_FRAMER_STATE_XPCSRXFRMRSTATE_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_BD_EBD_HAM_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_RESERVED0_FIELD_MASK  0x00000000fffff000
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_RESERVED0_FIELD_WIDTH 20
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_RESERVED0_FIELD_SHIFT 12

extern const ru_field_rec XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMRSPHAM_FIELD;
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMRSPHAM_FIELD_MASK  0x0000000000000f00
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMRSPHAM_FIELD_WIDTH 4
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMRSPHAM_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMREBDHAM_FIELD;
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMREBDHAM_FIELD_MASK  0x00000000000000f0
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMREBDHAM_FIELD_WIDTH 4
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMREBDHAM_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMRBDHAM_FIELD;
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMRBDHAM_FIELD_MASK  0x000000000000000f
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMRBDHAM_FIELD_WIDTH 4
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_CFGXPCSRXFRMRBDHAM_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_MISBRST_CNT_RXFRMRMISBRSTCNT_FIELD;
#define XPCSRX_RX_FRAMER_MISBRST_CNT_RXFRMRMISBRSTCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FRAMER_MISBRST_CNT_RXFRMRMISBRSTCNT_FIELD_WIDTH 32
#define XPCSRX_RX_FRAMER_MISBRST_CNT_RXFRMRMISBRSTCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_BD_ERR_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_BD_ERR_RESERVED0_FIELD_MASK  0x00000000fffffff0
#define XPCSRX_RX_FRAMER_BD_ERR_RESERVED0_FIELD_WIDTH 28
#define XPCSRX_RX_FRAMER_BD_ERR_RESERVED0_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_FRAMER_BD_ERR_XPCSRXSTATFRMRBDERR_FIELD;
#define XPCSRX_RX_FRAMER_BD_ERR_XPCSRXSTATFRMRBDERR_FIELD_MASK  0x000000000000000f
#define XPCSRX_RX_FRAMER_BD_ERR_XPCSRXSTATFRMRBDERR_FIELD_WIDTH 4
#define XPCSRX_RX_FRAMER_BD_ERR_XPCSRXSTATFRMRBDERR_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_ROGUE_CTL_CFGXPCSRXFRMRROGUEEN_FIELD;
#define XPCSRX_RX_FRAMER_ROGUE_CTL_CFGXPCSRXFRMRROGUEEN_FIELD_MASK  0x0000000080000000
#define XPCSRX_RX_FRAMER_ROGUE_CTL_CFGXPCSRXFRMRROGUEEN_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_ROGUE_CTL_CFGXPCSRXFRMRROGUEEN_FIELD_SHIFT 31

extern const ru_field_rec XPCSRX_RX_FRAMER_ROGUE_CTL_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_ROGUE_CTL_RESERVED0_FIELD_MASK  0x000000007fff0000
#define XPCSRX_RX_FRAMER_ROGUE_CTL_RESERVED0_FIELD_WIDTH 15
#define XPCSRX_RX_FRAMER_ROGUE_CTL_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_FRAMER_ROGUE_CTL_CFGXPCSRXFRMRROGUESPTRESH_FIELD;
#define XPCSRX_RX_FRAMER_ROGUE_CTL_CFGXPCSRXFRMRROGUESPTRESH_FIELD_MASK  0x000000000000ffff
#define XPCSRX_RX_FRAMER_ROGUE_CTL_CFGXPCSRXFRMRROGUESPTRESH_FIELD_WIDTH 16
#define XPCSRX_RX_FRAMER_ROGUE_CTL_CFGXPCSRXFRMRROGUESPTRESH_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRAMER_NOLOCK_CTL_CFGXPCSRXFRMRNOLOCKLOSEN_FIELD;
#define XPCSRX_RX_FRAMER_NOLOCK_CTL_CFGXPCSRXFRMRNOLOCKLOSEN_FIELD_MASK  0x0000000080000000
#define XPCSRX_RX_FRAMER_NOLOCK_CTL_CFGXPCSRXFRMRNOLOCKLOSEN_FIELD_WIDTH 1
#define XPCSRX_RX_FRAMER_NOLOCK_CTL_CFGXPCSRXFRMRNOLOCKLOSEN_FIELD_SHIFT 31

extern const ru_field_rec XPCSRX_RX_FRAMER_NOLOCK_CTL_RESERVED0_FIELD;
#define XPCSRX_RX_FRAMER_NOLOCK_CTL_RESERVED0_FIELD_MASK  0x000000007f000000
#define XPCSRX_RX_FRAMER_NOLOCK_CTL_RESERVED0_FIELD_WIDTH 7
#define XPCSRX_RX_FRAMER_NOLOCK_CTL_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec XPCSRX_RX_FRAMER_NOLOCK_CTL_CFGXPCSRXFRMRNOLOCKLOSINTVAL_FIELD;
#define XPCSRX_RX_FRAMER_NOLOCK_CTL_CFGXPCSRXFRMRNOLOCKLOSINTVAL_FIELD_MASK  0x0000000000ffffff
#define XPCSRX_RX_FRAMER_NOLOCK_CTL_CFGXPCSRXFRMRNOLOCKLOSINTVAL_FIELD_WIDTH 24
#define XPCSRX_RX_FRAMER_NOLOCK_CTL_CFGXPCSRXFRMRNOLOCKLOSINTVAL_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_64B66B_IPG_DET_CNT_RX64B66BIPGDETCNT_FIELD;
#define XPCSRX_RX_64B66B_IPG_DET_CNT_RX64B66BIPGDETCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_64B66B_IPG_DET_CNT_RX64B66BIPGDETCNT_FIELD_WIDTH 32
#define XPCSRX_RX_64B66B_IPG_DET_CNT_RX64B66BIPGDETCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_NQUE_IN_CNT_RXFECNQUEINCNT_FIELD;
#define XPCSRX_RX_FEC_NQUE_IN_CNT_RXFECNQUEINCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FEC_NQUE_IN_CNT_RXFECNQUEINCNT_FIELD_WIDTH 32
#define XPCSRX_RX_FEC_NQUE_IN_CNT_RXFECNQUEINCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_NQUE_OUT_CNT_RXFECNQUEOUTCNT_FIELD;
#define XPCSRX_RX_FEC_NQUE_OUT_CNT_RXFECNQUEOUTCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FEC_NQUE_OUT_CNT_RXFECNQUEOUTCNT_FIELD_WIDTH 32
#define XPCSRX_RX_FEC_NQUE_OUT_CNT_RXFECNQUEOUTCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_IDLE_START_CNT_RXIDLESTARTCNT_FIELD;
#define XPCSRX_RX_IDLE_START_CNT_RXIDLESTARTCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_IDLE_START_CNT_RXIDLESTARTCNT_FIELD_WIDTH 32
#define XPCSRX_RX_IDLE_START_CNT_RXIDLESTARTCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_IDLE_STOP_CNT_RXIDLESTOPCNT_FIELD;
#define XPCSRX_RX_IDLE_STOP_CNT_RXIDLESTOPCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_IDLE_STOP_CNT_RXIDLESTOPCNT_FIELD_WIDTH 32
#define XPCSRX_RX_IDLE_STOP_CNT_RXIDLESTOPCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_COR_INTVAL_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_COR_INTVAL_RESERVED0_FIELD_MASK  0x00000000ff000000
#define XPCSRX_RX_FEC_COR_INTVAL_RESERVED0_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_COR_INTVAL_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec XPCSRX_RX_FEC_COR_INTVAL_CFGXPCSRXFECCORINTVAL_FIELD;
#define XPCSRX_RX_FEC_COR_INTVAL_CFGXPCSRXFECCORINTVAL_FIELD_MASK  0x0000000000ffffff
#define XPCSRX_RX_FEC_COR_INTVAL_CFGXPCSRXFECCORINTVAL_FIELD_WIDTH 24
#define XPCSRX_RX_FEC_COR_INTVAL_CFGXPCSRXFECCORINTVAL_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_COR_TRESH_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_COR_TRESH_RESERVED0_FIELD_MASK  0x00000000ff000000
#define XPCSRX_RX_FEC_COR_TRESH_RESERVED0_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_COR_TRESH_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec XPCSRX_RX_FEC_COR_TRESH_CFGXPCSRXFECCORTRESH_FIELD;
#define XPCSRX_RX_FEC_COR_TRESH_CFGXPCSRXFECCORTRESH_FIELD_MASK  0x0000000000ffffff
#define XPCSRX_RX_FEC_COR_TRESH_CFGXPCSRXFECCORTRESH_FIELD_WIDTH 24
#define XPCSRX_RX_FEC_COR_TRESH_CFGXPCSRXFECCORTRESH_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_CW_FAIL_CNT_RXFECDECCWFAILCNT_FIELD;
#define XPCSRX_RX_FEC_CW_FAIL_CNT_RXFECDECCWFAILCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FEC_CW_FAIL_CNT_RXFECDECCWFAILCNT_FIELD_WIDTH 32
#define XPCSRX_RX_FEC_CW_FAIL_CNT_RXFECDECCWFAILCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_CW_TOT_CNT_RXFECDECCWTOTCNT_FIELD;
#define XPCSRX_RX_FEC_CW_TOT_CNT_RXFECDECCWTOTCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FEC_CW_TOT_CNT_RXFECDECCWTOTCNT_FIELD_WIDTH 32
#define XPCSRX_RX_FEC_CW_TOT_CNT_RXFECDECCWTOTCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_CORRECT_CNT_LOWER_RXFECDECERRCORCNTLOWER_FIELD;
#define XPCSRX_RX_FEC_CORRECT_CNT_LOWER_RXFECDECERRCORCNTLOWER_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FEC_CORRECT_CNT_LOWER_RXFECDECERRCORCNTLOWER_FIELD_WIDTH 32
#define XPCSRX_RX_FEC_CORRECT_CNT_LOWER_RXFECDECERRCORCNTLOWER_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_CORRECT_CNT_UPPER_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_CORRECT_CNT_UPPER_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XPCSRX_RX_FEC_CORRECT_CNT_UPPER_RESERVED0_FIELD_WIDTH 24
#define XPCSRX_RX_FEC_CORRECT_CNT_UPPER_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_FEC_CORRECT_CNT_UPPER_RXFECDECERRCORCNTUPPER_FIELD;
#define XPCSRX_RX_FEC_CORRECT_CNT_UPPER_RXFECDECERRCORCNTUPPER_FIELD_MASK  0x00000000000000ff
#define XPCSRX_RX_FEC_CORRECT_CNT_UPPER_RXFECDECERRCORCNTUPPER_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_CORRECT_CNT_UPPER_RXFECDECERRCORCNTUPPER_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_CORRECT_CNT_SHADOW_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_CORRECT_CNT_SHADOW_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XPCSRX_RX_FEC_CORRECT_CNT_SHADOW_RESERVED0_FIELD_WIDTH 24
#define XPCSRX_RX_FEC_CORRECT_CNT_SHADOW_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_FEC_CORRECT_CNT_SHADOW_RXFECDECERRCORCNTSHADOW_FIELD;
#define XPCSRX_RX_FEC_CORRECT_CNT_SHADOW_RXFECDECERRCORCNTSHADOW_FIELD_MASK  0x00000000000000ff
#define XPCSRX_RX_FEC_CORRECT_CNT_SHADOW_RXFECDECERRCORCNTSHADOW_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_CORRECT_CNT_SHADOW_RXFECDECERRCORCNTSHADOW_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_ONES_COR_CNT_LOWER_RXFECDECONESCORCNTLOWER_FIELD;
#define XPCSRX_RX_FEC_ONES_COR_CNT_LOWER_RXFECDECONESCORCNTLOWER_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FEC_ONES_COR_CNT_LOWER_RXFECDECONESCORCNTLOWER_FIELD_WIDTH 32
#define XPCSRX_RX_FEC_ONES_COR_CNT_LOWER_RXFECDECONESCORCNTLOWER_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_ONES_COR_CNT_UPPER_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_ONES_COR_CNT_UPPER_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XPCSRX_RX_FEC_ONES_COR_CNT_UPPER_RESERVED0_FIELD_WIDTH 24
#define XPCSRX_RX_FEC_ONES_COR_CNT_UPPER_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_FEC_ONES_COR_CNT_UPPER_RXFECDECONESCORCNTUPPER_FIELD;
#define XPCSRX_RX_FEC_ONES_COR_CNT_UPPER_RXFECDECONESCORCNTUPPER_FIELD_MASK  0x00000000000000ff
#define XPCSRX_RX_FEC_ONES_COR_CNT_UPPER_RXFECDECONESCORCNTUPPER_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_ONES_COR_CNT_UPPER_RXFECDECONESCORCNTUPPER_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_ONES_COR_CNT_SHADOW_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_ONES_COR_CNT_SHADOW_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XPCSRX_RX_FEC_ONES_COR_CNT_SHADOW_RESERVED0_FIELD_WIDTH 24
#define XPCSRX_RX_FEC_ONES_COR_CNT_SHADOW_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_FEC_ONES_COR_CNT_SHADOW_RXFECDECONESCORCNTSHADOW_FIELD;
#define XPCSRX_RX_FEC_ONES_COR_CNT_SHADOW_RXFECDECONESCORCNTSHADOW_FIELD_MASK  0x00000000000000ff
#define XPCSRX_RX_FEC_ONES_COR_CNT_SHADOW_RXFECDECONESCORCNTSHADOW_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_ONES_COR_CNT_SHADOW_RXFECDECONESCORCNTSHADOW_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_ZEROS_COR_CNT_LOWER_RXFECDECZEROSCORCNTLOWER_FIELD;
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_LOWER_RXFECDECZEROSCORCNTLOWER_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_LOWER_RXFECDECZEROSCORCNTLOWER_FIELD_WIDTH 32
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_LOWER_RXFECDECZEROSCORCNTLOWER_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_ZEROS_COR_CNT_UPPER_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_UPPER_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_UPPER_RESERVED0_FIELD_WIDTH 24
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_UPPER_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_FEC_ZEROS_COR_CNT_UPPER_RXFECDECZEROSCORCNTUPPER_FIELD;
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_UPPER_RXFECDECZEROSCORCNTUPPER_FIELD_MASK  0x00000000000000ff
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_UPPER_RXFECDECZEROSCORCNTUPPER_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_UPPER_RXFECDECZEROSCORCNTUPPER_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_ZEROS_COR_CNT_SHADOW_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_SHADOW_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_SHADOW_RESERVED0_FIELD_WIDTH 24
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_SHADOW_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_FEC_ZEROS_COR_CNT_SHADOW_RXFECDECZEROSCORCNTSHADOW_FIELD;
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_SHADOW_RXFECDECZEROSCORCNTSHADOW_FIELD_MASK  0x00000000000000ff
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_SHADOW_RXFECDECZEROSCORCNTSHADOW_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_SHADOW_RXFECDECZEROSCORCNTSHADOW_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RESERVED0_FIELD_WIDTH 16
#define XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RXFECSTOPONERRRDPTR_FIELD;
#define XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RXFECSTOPONERRRDPTR_FIELD_MASK  0x000000000000ff00
#define XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RXFECSTOPONERRRDPTR_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RXFECSTOPONERRRDPTR_FIELD_SHIFT 8

extern const ru_field_rec XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RXFECSTOPONERRWRPTR_FIELD;
#define XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RXFECSTOPONERRWRPTR_FIELD_MASK  0x00000000000000ff
#define XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RXFECSTOPONERRWRPTR_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_RXFECSTOPONERRWRPTR_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FEC_STOP_ON_ERR_BURST_LOCATION_RESERVED0_FIELD;
#define XPCSRX_RX_FEC_STOP_ON_ERR_BURST_LOCATION_RESERVED0_FIELD_MASK  0x00000000ff000000
#define XPCSRX_RX_FEC_STOP_ON_ERR_BURST_LOCATION_RESERVED0_FIELD_WIDTH 8
#define XPCSRX_RX_FEC_STOP_ON_ERR_BURST_LOCATION_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec XPCSRX_RX_FEC_STOP_ON_ERR_BURST_LOCATION_RXFECSTOPONERRBRSTLOC_FIELD;
#define XPCSRX_RX_FEC_STOP_ON_ERR_BURST_LOCATION_RXFECSTOPONERRBRSTLOC_FIELD_MASK  0x0000000000ffffff
#define XPCSRX_RX_FEC_STOP_ON_ERR_BURST_LOCATION_RXFECSTOPONERRBRSTLOC_FIELD_WIDTH 24
#define XPCSRX_RX_FEC_STOP_ON_ERR_BURST_LOCATION_RXFECSTOPONERRBRSTLOC_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_64B66B_FAIL_CNT_RX64B66BDECERRCNT_FIELD;
#define XPCSRX_RX_64B66B_FAIL_CNT_RX64B66BDECERRCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_64B66B_FAIL_CNT_RX64B66BDECERRCNT_FIELD_WIDTH 32
#define XPCSRX_RX_64B66B_FAIL_CNT_RX64B66BDECERRCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_FRMR_BAD_SH_CNT_RXFRMRBADSHCNT_FIELD;
#define XPCSRX_RX_FRMR_BAD_SH_CNT_RXFRMRBADSHCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_FRMR_BAD_SH_CNT_RXFRMRBADSHCNT_FIELD_WIDTH 32
#define XPCSRX_RX_FRMR_BAD_SH_CNT_RXFRMRBADSHCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_PSUDO_CNT_RXTESTPSUDOERRCNT_FIELD;
#define XPCSRX_RX_PSUDO_CNT_RXTESTPSUDOERRCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_PSUDO_CNT_RXTESTPSUDOERRCNT_FIELD_WIDTH 32
#define XPCSRX_RX_PSUDO_CNT_RXTESTPSUDOERRCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_PRBS_CNT_RXTESTPRBSERRCNT_FIELD;
#define XPCSRX_RX_PRBS_CNT_RXTESTPRBSERRCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_PRBS_CNT_RXTESTPRBSERRCNT_FIELD_WIDTH 32
#define XPCSRX_RX_PRBS_CNT_RXTESTPRBSERRCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_BER_INTVAL_RESERVED0_FIELD;
#define XPCSRX_RX_BER_INTVAL_RESERVED0_FIELD_MASK  0x00000000ff000000
#define XPCSRX_RX_BER_INTVAL_RESERVED0_FIELD_WIDTH 8
#define XPCSRX_RX_BER_INTVAL_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec XPCSRX_RX_BER_INTVAL_CFGXPCSRXFRMRBERINTVAL_FIELD;
#define XPCSRX_RX_BER_INTVAL_CFGXPCSRXFRMRBERINTVAL_FIELD_MASK  0x0000000000ffffff
#define XPCSRX_RX_BER_INTVAL_CFGXPCSRXFRMRBERINTVAL_FIELD_WIDTH 24
#define XPCSRX_RX_BER_INTVAL_CFGXPCSRXFRMRBERINTVAL_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_BER_TRESH_RESERVED0_FIELD;
#define XPCSRX_RX_BER_TRESH_RESERVED0_FIELD_MASK  0x00000000fffffe00
#define XPCSRX_RX_BER_TRESH_RESERVED0_FIELD_WIDTH 23
#define XPCSRX_RX_BER_TRESH_RESERVED0_FIELD_SHIFT 9

extern const ru_field_rec XPCSRX_RX_BER_TRESH_CFGXPCSRXFRMRBERTRESH_FIELD;
#define XPCSRX_RX_BER_TRESH_CFGXPCSRXFRMRBERTRESH_FIELD_MASK  0x00000000000001ff
#define XPCSRX_RX_BER_TRESH_CFGXPCSRXFRMRBERTRESH_FIELD_WIDTH 9
#define XPCSRX_RX_BER_TRESH_CFGXPCSRXFRMRBERTRESH_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_64B66B_START_CNT_RX64B66BDECSTARTCNT_FIELD;
#define XPCSRX_RX_64B66B_START_CNT_RX64B66BDECSTARTCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_64B66B_START_CNT_RX64B66BDECSTARTCNT_FIELD_WIDTH 32
#define XPCSRX_RX_64B66B_START_CNT_RX64B66BDECSTARTCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_IDLE_GOOD_PKT_CNT_RXIDLEGOODPKTCNT_FIELD;
#define XPCSRX_RX_IDLE_GOOD_PKT_CNT_RXIDLEGOODPKTCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_IDLE_GOOD_PKT_CNT_RXIDLEGOODPKTCNT_FIELD_WIDTH 32
#define XPCSRX_RX_IDLE_GOOD_PKT_CNT_RXIDLEGOODPKTCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_IDLE_ERR_PKT_CNT_RXIDLEERRPKTCNT_FIELD;
#define XPCSRX_RX_IDLE_ERR_PKT_CNT_RXIDLEERRPKTCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_IDLE_ERR_PKT_CNT_RXIDLEERRPKTCNT_FIELD_WIDTH 32
#define XPCSRX_RX_IDLE_ERR_PKT_CNT_RXIDLEERRPKTCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_64B66B_STOP_CNT_RX64B66BDECSTOPCNT_FIELD;
#define XPCSRX_RX_64B66B_STOP_CNT_RX64B66BDECSTOPCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_64B66B_STOP_CNT_RX64B66BDECSTOPCNT_FIELD_WIDTH 32
#define XPCSRX_RX_64B66B_STOP_CNT_RX64B66BDECSTOPCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_BURST_OUT_ODR_CNT_RXBURSTSEQOUTOFORDERCNT_FIELD;
#define XPCSRX_RX_BURST_OUT_ODR_CNT_RXBURSTSEQOUTOFORDERCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_BURST_OUT_ODR_CNT_RXBURSTSEQOUTOFORDERCNT_FIELD_WIDTH 32
#define XPCSRX_RX_BURST_OUT_ODR_CNT_RXBURSTSEQOUTOFORDERCNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_IDLE_DA_JIT_DLY_RESERVED0_FIELD;
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RESERVED0_FIELD_MASK  0x00000000fe000000
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RESERVED0_FIELD_WIDTH 7
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RESERVED0_FIELD_SHIFT 25

extern const ru_field_rec XPCSRX_RX_IDLE_DA_JIT_DLY_RXIDLELASTDACNT_FIELD;
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RXIDLELASTDACNT_FIELD_MASK  0x0000000001ff0000
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RXIDLELASTDACNT_FIELD_WIDTH 9
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RXIDLELASTDACNT_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_IDLE_DA_JIT_DLY_RESERVED1_FIELD;
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RESERVED1_FIELD_MASK  0x000000000000fe00
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RESERVED1_FIELD_WIDTH 7
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RESERVED1_FIELD_SHIFT 9

extern const ru_field_rec XPCSRX_RX_IDLE_DA_JIT_DLY_RXIDLEDACNT_FIELD;
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RXIDLEDACNT_FIELD_MASK  0x00000000000001ff
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RXIDLEDACNT_FIELD_WIDTH 9
#define XPCSRX_RX_IDLE_DA_JIT_DLY_RXIDLEDACNT_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_DPORT_CTL_XPCSRXDPBUSY_FIELD;
#define XPCSRX_RX_DPORT_CTL_XPCSRXDPBUSY_FIELD_MASK  0x0000000080000000
#define XPCSRX_RX_DPORT_CTL_XPCSRXDPBUSY_FIELD_WIDTH 1
#define XPCSRX_RX_DPORT_CTL_XPCSRXDPBUSY_FIELD_SHIFT 31

extern const ru_field_rec XPCSRX_RX_DPORT_CTL_XPCSRXDPERR_FIELD;
#define XPCSRX_RX_DPORT_CTL_XPCSRXDPERR_FIELD_MASK  0x0000000040000000
#define XPCSRX_RX_DPORT_CTL_XPCSRXDPERR_FIELD_WIDTH 1
#define XPCSRX_RX_DPORT_CTL_XPCSRXDPERR_FIELD_SHIFT 30

extern const ru_field_rec XPCSRX_RX_DPORT_CTL_RESERVED0_FIELD;
#define XPCSRX_RX_DPORT_CTL_RESERVED0_FIELD_MASK  0x0000000030000000
#define XPCSRX_RX_DPORT_CTL_RESERVED0_FIELD_WIDTH 2
#define XPCSRX_RX_DPORT_CTL_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPCTL_FIELD;
#define XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPCTL_FIELD_MASK  0x000000000ff00000
#define XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPCTL_FIELD_WIDTH 8
#define XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPCTL_FIELD_SHIFT 20

extern const ru_field_rec XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPRAMSEL_FIELD;
#define XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPRAMSEL_FIELD_MASK  0x00000000000f0000
#define XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPRAMSEL_FIELD_WIDTH 4
#define XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPRAMSEL_FIELD_SHIFT 16

extern const ru_field_rec XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPADDR_FIELD;
#define XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPADDR_FIELD_MASK  0x000000000000ffff
#define XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPADDR_FIELD_WIDTH 16
#define XPCSRX_RX_DPORT_CTL_CFGXPCSRXDPADDR_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_DPORT_DATA0_XPCSRXDPDATA0_FIELD;
#define XPCSRX_RX_DPORT_DATA0_XPCSRXDPDATA0_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_DPORT_DATA0_XPCSRXDPDATA0_FIELD_WIDTH 32
#define XPCSRX_RX_DPORT_DATA0_XPCSRXDPDATA0_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_DPORT_DATA1_XPCSRXDPDATA1_FIELD;
#define XPCSRX_RX_DPORT_DATA1_XPCSRXDPDATA1_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_DPORT_DATA1_XPCSRXDPDATA1_FIELD_WIDTH 32
#define XPCSRX_RX_DPORT_DATA1_XPCSRXDPDATA1_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_DPORT_DATA2_XPCSRXDPDATA2_FIELD;
#define XPCSRX_RX_DPORT_DATA2_XPCSRXDPDATA2_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_DPORT_DATA2_XPCSRXDPDATA2_FIELD_WIDTH 32
#define XPCSRX_RX_DPORT_DATA2_XPCSRXDPDATA2_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_DPORT_ACC_RESERVED0_FIELD;
#define XPCSRX_RX_DPORT_ACC_RESERVED0_FIELD_MASK  0x00000000fffffff0
#define XPCSRX_RX_DPORT_ACC_RESERVED0_FIELD_WIDTH 28
#define XPCSRX_RX_DPORT_ACC_RESERVED0_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_DPORT_ACC_CFGXPCSRXIDLERAMDPSEL_FIELD;
#define XPCSRX_RX_DPORT_ACC_CFGXPCSRXIDLERAMDPSEL_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_DPORT_ACC_CFGXPCSRXIDLERAMDPSEL_FIELD_WIDTH 1
#define XPCSRX_RX_DPORT_ACC_CFGXPCSRXIDLERAMDPSEL_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_DPORT_ACC_CFGXPCSRXFECDECRAMDPSEL_FIELD;
#define XPCSRX_RX_DPORT_ACC_CFGXPCSRXFECDECRAMDPSEL_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_DPORT_ACC_CFGXPCSRXFECDECRAMDPSEL_FIELD_WIDTH 1
#define XPCSRX_RX_DPORT_ACC_CFGXPCSRXFECDECRAMDPSEL_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_DPORT_ACC_CFGXPCSRXFECNQUERAMDPSEL_FIELD;
#define XPCSRX_RX_DPORT_ACC_CFGXPCSRXFECNQUERAMDPSEL_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_DPORT_ACC_CFGXPCSRXFECNQUERAMDPSEL_FIELD_WIDTH 1
#define XPCSRX_RX_DPORT_ACC_CFGXPCSRXFECNQUERAMDPSEL_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_RAM_ECC_INT_STAT_RESERVED0_FIELD;
#define XPCSRX_RX_RAM_ECC_INT_STAT_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define XPCSRX_RX_RAM_ECC_INT_STAT_RESERVED0_FIELD_WIDTH 27
#define XPCSRX_RX_RAM_ECC_INT_STAT_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec XPCSRX_RX_RAM_ECC_INT_STAT_INTRXIDLERAMINITDONE_FIELD;
#define XPCSRX_RX_RAM_ECC_INT_STAT_INTRXIDLERAMINITDONE_FIELD_MASK  0x0000000000000010
#define XPCSRX_RX_RAM_ECC_INT_STAT_INTRXIDLERAMINITDONE_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_ECC_INT_STAT_INTRXIDLERAMINITDONE_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_RAM_ECC_INT_STAT_INTRXFECNQUERAMINITDONE_FIELD;
#define XPCSRX_RX_RAM_ECC_INT_STAT_INTRXFECNQUERAMINITDONE_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_RAM_ECC_INT_STAT_INTRXFECNQUERAMINITDONE_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_ECC_INT_STAT_INTRXFECNQUERAMINITDONE_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_RAM_ECC_INT_STAT_RESERVED1_FIELD;
#define XPCSRX_RX_RAM_ECC_INT_STAT_RESERVED1_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_RAM_ECC_INT_STAT_RESERVED1_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_ECC_INT_STAT_RESERVED1_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_RAM_ECC_INT_STAT_INTRXFECDECRAMINITDONE_FIELD;
#define XPCSRX_RX_RAM_ECC_INT_STAT_INTRXFECDECRAMINITDONE_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_RAM_ECC_INT_STAT_INTRXFECDECRAMINITDONE_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_ECC_INT_STAT_INTRXFECDECRAMINITDONE_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_RAM_ECC_INT_MSK_RESERVED0_FIELD;
#define XPCSRX_RX_RAM_ECC_INT_MSK_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define XPCSRX_RX_RAM_ECC_INT_MSK_RESERVED0_FIELD_WIDTH 27
#define XPCSRX_RX_RAM_ECC_INT_MSK_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXIDLERAMINITDONE_FIELD;
#define XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXIDLERAMINITDONE_FIELD_MASK  0x0000000000000010
#define XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXIDLERAMINITDONE_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXIDLERAMINITDONE_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXFECNQUERAMINITDONE_FIELD;
#define XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXFECNQUERAMINITDONE_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXFECNQUERAMINITDONE_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXFECNQUERAMINITDONE_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_RAM_ECC_INT_MSK_RESERVED1_FIELD;
#define XPCSRX_RX_RAM_ECC_INT_MSK_RESERVED1_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_RAM_ECC_INT_MSK_RESERVED1_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_ECC_INT_MSK_RESERVED1_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXFECDECRAMINITDONE_FIELD;
#define XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXFECDECRAMINITDONE_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXFECDECRAMINITDONE_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_ECC_INT_MSK_MSKRXFECDECRAMINITDONE_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_DFT_TESTMODE_RESERVED0_FIELD;
#define XPCSRX_RX_DFT_TESTMODE_RESERVED0_FIELD_MASK  0x00000000fffffc00
#define XPCSRX_RX_DFT_TESTMODE_RESERVED0_FIELD_WIDTH 22
#define XPCSRX_RX_DFT_TESTMODE_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec XPCSRX_RX_DFT_TESTMODE_TM_PD_FIELD;
#define XPCSRX_RX_DFT_TESTMODE_TM_PD_FIELD_MASK  0x00000000000003ff
#define XPCSRX_RX_DFT_TESTMODE_TM_PD_FIELD_WIDTH 10
#define XPCSRX_RX_DFT_TESTMODE_TM_PD_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_RAM_POWER_PDA_CTL0_RESERVED0_FIELD;
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_RESERVED0_FIELD_MASK  0x00000000fffffff0
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_RESERVED0_FIELD_WIDTH 28
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_RESERVED0_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_RAM_POWER_PDA_CTL0_CFGXPCSRXIDLERAMPDA_FIELD;
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_CFGXPCSRXIDLERAMPDA_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_CFGXPCSRXIDLERAMPDA_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_CFGXPCSRXIDLERAMPDA_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_RAM_POWER_PDA_CTL0_RESERVED1_FIELD;
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_RESERVED1_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_RESERVED1_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_RESERVED1_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_RAM_POWER_PDA_CTL0_CFGXPCSRXFECDECRAMPDA_FIELD;
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_CFGXPCSRXFECDECRAMPDA_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_CFGXPCSRXFECDECRAMPDA_FIELD_WIDTH 1
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_CFGXPCSRXFECDECRAMPDA_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_INT_STAT1_RESERVED0_FIELD;
#define XPCSRX_RX_INT_STAT1_RESERVED0_FIELD_MASK  0x00000000fffffff0
#define XPCSRX_RX_INT_STAT1_RESERVED0_FIELD_WIDTH 28
#define XPCSRX_RX_INT_STAT1_RESERVED0_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_INT_STAT1_INTRX64B66BTRAILSTART_FIELD;
#define XPCSRX_RX_INT_STAT1_INTRX64B66BTRAILSTART_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_INT_STAT1_INTRX64B66BTRAILSTART_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT1_INTRX64B66BTRAILSTART_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_INT_STAT1_INTRX64B66BTWOSTOP_FIELD;
#define XPCSRX_RX_INT_STAT1_INTRX64B66BTWOSTOP_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_INT_STAT1_INTRX64B66BTWOSTOP_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT1_INTRX64B66BTWOSTOP_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_INT_STAT1_INTRX64B66BTWOSTART_FIELD;
#define XPCSRX_RX_INT_STAT1_INTRX64B66BTWOSTART_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_INT_STAT1_INTRX64B66BTWOSTART_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT1_INTRX64B66BTWOSTART_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_INT_STAT1_INTRX64B66BLEADSTOP_FIELD;
#define XPCSRX_RX_INT_STAT1_INTRX64B66BLEADSTOP_FIELD_MASK  0x0000000000000001
#define XPCSRX_RX_INT_STAT1_INTRX64B66BLEADSTOP_FIELD_WIDTH 1
#define XPCSRX_RX_INT_STAT1_INTRX64B66BLEADSTOP_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_INT_MSK1_RESERVED0_FIELD;
#define XPCSRX_RX_INT_MSK1_RESERVED0_FIELD_MASK  0x00000000fffffff0
#define XPCSRX_RX_INT_MSK1_RESERVED0_FIELD_WIDTH 28
#define XPCSRX_RX_INT_MSK1_RESERVED0_FIELD_SHIFT 4

extern const ru_field_rec XPCSRX_RX_INT_MSK1_MSKRX64B66BTRAILSTART_FIELD;
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BTRAILSTART_FIELD_MASK  0x0000000000000008
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BTRAILSTART_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BTRAILSTART_FIELD_SHIFT 3

extern const ru_field_rec XPCSRX_RX_INT_MSK1_MSKRX64B66BTWOSTOP_FIELD;
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BTWOSTOP_FIELD_MASK  0x0000000000000004
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BTWOSTOP_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BTWOSTOP_FIELD_SHIFT 2

extern const ru_field_rec XPCSRX_RX_INT_MSK1_MSKRX64B66BTWOSTART_FIELD;
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BTWOSTART_FIELD_MASK  0x0000000000000002
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BTWOSTART_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BTWOSTART_FIELD_SHIFT 1

extern const ru_field_rec XPCSRX_RX_INT_MSK1_MSKRX64B66BLEADSTOP_FIELD;
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BLEADSTOP_FIELD_MASK  0x0000000000000001
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BLEADSTOP_FIELD_WIDTH 1
#define XPCSRX_RX_INT_MSK1_MSKRX64B66BLEADSTOP_FIELD_SHIFT 0

extern const ru_field_rec XPCSRX_RX_SPARE_CTL_CFGXPCSRXSPARE_FIELD;
#define XPCSRX_RX_SPARE_CTL_CFGXPCSRXSPARE_FIELD_MASK  0x00000000ffffffff
#define XPCSRX_RX_SPARE_CTL_CFGXPCSRXSPARE_FIELD_WIDTH 32
#define XPCSRX_RX_SPARE_CTL_CFGXPCSRXSPARE_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_CONTROL_RESERVED0_FIELD;
#define XPCSTX_TX_CONTROL_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define XPCSTX_TX_CONTROL_RESERVED0_FIELD_WIDTH 16
#define XPCSTX_TX_CONTROL_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGENRMTFAULTDET125_FIELD;
#define XPCSTX_TX_CONTROL_CFGENRMTFAULTDET125_FIELD_MASK  0x0000000000008000
#define XPCSTX_TX_CONTROL_CFGENRMTFAULTDET125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGENRMTFAULTDET125_FIELD_SHIFT 15

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGLSRTRISTATEEN125_FIELD;
#define XPCSTX_TX_CONTROL_CFGLSRTRISTATEEN125_FIELD_MASK  0x0000000000004000
#define XPCSTX_TX_CONTROL_CFGLSRTRISTATEEN125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGLSRTRISTATEEN125_FIELD_SHIFT 14

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGENSEQNUM125_FIELD;
#define XPCSTX_TX_CONTROL_CFGENSEQNUM125_FIELD_MASK  0x0000000000002000
#define XPCSTX_TX_CONTROL_CFGENSEQNUM125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGENSEQNUM125_FIELD_SHIFT 13

extern const ru_field_rec XPCSTX_TX_CONTROL_RESERVED1_FIELD;
#define XPCSTX_TX_CONTROL_RESERVED1_FIELD_MASK  0x0000000000001000
#define XPCSTX_TX_CONTROL_RESERVED1_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGENSCRMBCONT125_FIELD;
#define XPCSTX_TX_CONTROL_CFGENSCRMBCONT125_FIELD_MASK  0x0000000000000800
#define XPCSTX_TX_CONTROL_CFGENSCRMBCONT125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGENSCRMBCONT125_FIELD_SHIFT 11

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGLSRENACTHI125_FIELD;
#define XPCSTX_TX_CONTROL_CFGLSRENACTHI125_FIELD_MASK  0x0000000000000400
#define XPCSTX_TX_CONTROL_CFGLSRENACTHI125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGLSRENACTHI125_FIELD_SHIFT 10

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGENLSRALWAYS125_FIELD;
#define XPCSTX_TX_CONTROL_CFGENLSRALWAYS125_FIELD_MASK  0x0000000000000200
#define XPCSTX_TX_CONTROL_CFGENLSRALWAYS125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGENLSRALWAYS125_FIELD_SHIFT 9

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGENLSRTILENDSLOT125_FIELD;
#define XPCSTX_TX_CONTROL_CFGENLSRTILENDSLOT125_FIELD_MASK  0x0000000000000100
#define XPCSTX_TX_CONTROL_CFGENLSRTILENDSLOT125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGENLSRTILENDSLOT125_FIELD_SHIFT 8

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGTXOUTBYTEFLIP125_FIELD;
#define XPCSTX_TX_CONTROL_CFGTXOUTBYTEFLIP125_FIELD_MASK  0x0000000000000080
#define XPCSTX_TX_CONTROL_CFGTXOUTBYTEFLIP125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGTXOUTBYTEFLIP125_FIELD_SHIFT 7

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGENTXOUT125_FIELD;
#define XPCSTX_TX_CONTROL_CFGENTXOUT125_FIELD_MASK  0x0000000000000040
#define XPCSTX_TX_CONTROL_CFGENTXOUT125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGENTXOUT125_FIELD_SHIFT 6

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGENTXSCRB125_FIELD;
#define XPCSTX_TX_CONTROL_CFGENTXSCRB125_FIELD_MASK  0x0000000000000020
#define XPCSTX_TX_CONTROL_CFGENTXSCRB125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGENTXSCRB125_FIELD_SHIFT 5

extern const ru_field_rec XPCSTX_TX_CONTROL_CFGENTXFEC125_FIELD;
#define XPCSTX_TX_CONTROL_CFGENTXFEC125_FIELD_MASK  0x0000000000000010
#define XPCSTX_TX_CONTROL_CFGENTXFEC125_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_CFGENTXFEC125_FIELD_SHIFT 4

extern const ru_field_rec XPCSTX_TX_CONTROL_PCSTXNOTRDY_FIELD;
#define XPCSTX_TX_CONTROL_PCSTXNOTRDY_FIELD_MASK  0x0000000000000008
#define XPCSTX_TX_CONTROL_PCSTXNOTRDY_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_PCSTXNOTRDY_FIELD_SHIFT 3

extern const ru_field_rec XPCSTX_TX_CONTROL_RESERVED2_FIELD;
#define XPCSTX_TX_CONTROL_RESERVED2_FIELD_MASK  0x0000000000000004
#define XPCSTX_TX_CONTROL_RESERVED2_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_RESERVED2_FIELD_SHIFT 2

extern const ru_field_rec XPCSTX_TX_CONTROL_PCSTXDTPORTRSTN_FIELD;
#define XPCSTX_TX_CONTROL_PCSTXDTPORTRSTN_FIELD_MASK  0x0000000000000002
#define XPCSTX_TX_CONTROL_PCSTXDTPORTRSTN_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_PCSTXDTPORTRSTN_FIELD_SHIFT 1

extern const ru_field_rec XPCSTX_TX_CONTROL_PCSTXRSTN_FIELD;
#define XPCSTX_TX_CONTROL_PCSTXRSTN_FIELD_MASK  0x0000000000000001
#define XPCSTX_TX_CONTROL_PCSTXRSTN_FIELD_WIDTH 1
#define XPCSTX_TX_CONTROL_PCSTXRSTN_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_INT_STAT_RESERVED0_FIELD;
#define XPCSTX_TX_INT_STAT_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XPCSTX_TX_INT_STAT_RESERVED0_FIELD_WIDTH 24
#define XPCSTX_TX_INT_STAT_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XPCSTX_TX_INT_STAT_LASERONMAX_FIELD;
#define XPCSTX_TX_INT_STAT_LASERONMAX_FIELD_MASK  0x0000000000000080
#define XPCSTX_TX_INT_STAT_LASERONMAX_FIELD_WIDTH 1
#define XPCSTX_TX_INT_STAT_LASERONMAX_FIELD_SHIFT 7

extern const ru_field_rec XPCSTX_TX_INT_STAT_LASEROFF_FIELD;
#define XPCSTX_TX_INT_STAT_LASEROFF_FIELD_MASK  0x0000000000000040
#define XPCSTX_TX_INT_STAT_LASEROFF_FIELD_WIDTH 1
#define XPCSTX_TX_INT_STAT_LASEROFF_FIELD_SHIFT 6

extern const ru_field_rec XPCSTX_TX_INT_STAT_GRANTLAGERR_FIELD;
#define XPCSTX_TX_INT_STAT_GRANTLAGERR_FIELD_MASK  0x0000000000000020
#define XPCSTX_TX_INT_STAT_GRANTLAGERR_FIELD_WIDTH 1
#define XPCSTX_TX_INT_STAT_GRANTLAGERR_FIELD_SHIFT 5

extern const ru_field_rec XPCSTX_TX_INT_STAT_RESERVED1_FIELD;
#define XPCSTX_TX_INT_STAT_RESERVED1_FIELD_MASK  0x0000000000000010
#define XPCSTX_TX_INT_STAT_RESERVED1_FIELD_WIDTH 1
#define XPCSTX_TX_INT_STAT_RESERVED1_FIELD_SHIFT 4

extern const ru_field_rec XPCSTX_TX_INT_STAT_BACK2BACKGNT_FIELD;
#define XPCSTX_TX_INT_STAT_BACK2BACKGNT_FIELD_MASK  0x0000000000000008
#define XPCSTX_TX_INT_STAT_BACK2BACKGNT_FIELD_WIDTH 1
#define XPCSTX_TX_INT_STAT_BACK2BACKGNT_FIELD_SHIFT 3

extern const ru_field_rec XPCSTX_TX_INT_STAT_FECUNDERRUN_FIELD;
#define XPCSTX_TX_INT_STAT_FECUNDERRUN_FIELD_MASK  0x0000000000000004
#define XPCSTX_TX_INT_STAT_FECUNDERRUN_FIELD_WIDTH 1
#define XPCSTX_TX_INT_STAT_FECUNDERRUN_FIELD_SHIFT 2

extern const ru_field_rec XPCSTX_TX_INT_STAT_GEARBOXUNDERRUN_FIELD;
#define XPCSTX_TX_INT_STAT_GEARBOXUNDERRUN_FIELD_MASK  0x0000000000000002
#define XPCSTX_TX_INT_STAT_GEARBOXUNDERRUN_FIELD_WIDTH 1
#define XPCSTX_TX_INT_STAT_GEARBOXUNDERRUN_FIELD_SHIFT 1

extern const ru_field_rec XPCSTX_TX_INT_STAT_GNTTOOSHORT_FIELD;
#define XPCSTX_TX_INT_STAT_GNTTOOSHORT_FIELD_MASK  0x0000000000000001
#define XPCSTX_TX_INT_STAT_GNTTOOSHORT_FIELD_WIDTH 1
#define XPCSTX_TX_INT_STAT_GNTTOOSHORT_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_INT_MASK_RESERVED0_FIELD;
#define XPCSTX_TX_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define XPCSTX_TX_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define XPCSTX_TX_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec XPCSTX_TX_INT_MASK_LASERONMAXMASK_FIELD;
#define XPCSTX_TX_INT_MASK_LASERONMAXMASK_FIELD_MASK  0x0000000000000080
#define XPCSTX_TX_INT_MASK_LASERONMAXMASK_FIELD_WIDTH 1
#define XPCSTX_TX_INT_MASK_LASERONMAXMASK_FIELD_SHIFT 7

extern const ru_field_rec XPCSTX_TX_INT_MASK_LASEROFFMASK_FIELD;
#define XPCSTX_TX_INT_MASK_LASEROFFMASK_FIELD_MASK  0x0000000000000040
#define XPCSTX_TX_INT_MASK_LASEROFFMASK_FIELD_WIDTH 1
#define XPCSTX_TX_INT_MASK_LASEROFFMASK_FIELD_SHIFT 6

extern const ru_field_rec XPCSTX_TX_INT_MASK_GRANTLAGERRMSK_FIELD;
#define XPCSTX_TX_INT_MASK_GRANTLAGERRMSK_FIELD_MASK  0x0000000000000020
#define XPCSTX_TX_INT_MASK_GRANTLAGERRMSK_FIELD_WIDTH 1
#define XPCSTX_TX_INT_MASK_GRANTLAGERRMSK_FIELD_SHIFT 5

extern const ru_field_rec XPCSTX_TX_INT_MASK_RESERVED1_FIELD;
#define XPCSTX_TX_INT_MASK_RESERVED1_FIELD_MASK  0x0000000000000010
#define XPCSTX_TX_INT_MASK_RESERVED1_FIELD_WIDTH 1
#define XPCSTX_TX_INT_MASK_RESERVED1_FIELD_SHIFT 4

extern const ru_field_rec XPCSTX_TX_INT_MASK_BACK2BCKGNTMSK_FIELD;
#define XPCSTX_TX_INT_MASK_BACK2BCKGNTMSK_FIELD_MASK  0x0000000000000008
#define XPCSTX_TX_INT_MASK_BACK2BCKGNTMSK_FIELD_WIDTH 1
#define XPCSTX_TX_INT_MASK_BACK2BCKGNTMSK_FIELD_SHIFT 3

extern const ru_field_rec XPCSTX_TX_INT_MASK_FECUNDERRUNMSK_FIELD;
#define XPCSTX_TX_INT_MASK_FECUNDERRUNMSK_FIELD_MASK  0x0000000000000004
#define XPCSTX_TX_INT_MASK_FECUNDERRUNMSK_FIELD_WIDTH 1
#define XPCSTX_TX_INT_MASK_FECUNDERRUNMSK_FIELD_SHIFT 2

extern const ru_field_rec XPCSTX_TX_INT_MASK_GEARBOXUNDERRUNMSK_FIELD;
#define XPCSTX_TX_INT_MASK_GEARBOXUNDERRUNMSK_FIELD_MASK  0x0000000000000002
#define XPCSTX_TX_INT_MASK_GEARBOXUNDERRUNMSK_FIELD_WIDTH 1
#define XPCSTX_TX_INT_MASK_GEARBOXUNDERRUNMSK_FIELD_SHIFT 1

extern const ru_field_rec XPCSTX_TX_INT_MASK_GNTTOOSHORTMSK_FIELD;
#define XPCSTX_TX_INT_MASK_GNTTOOSHORTMSK_FIELD_MASK  0x0000000000000001
#define XPCSTX_TX_INT_MASK_GNTTOOSHORTMSK_FIELD_WIDTH 1
#define XPCSTX_TX_INT_MASK_GNTTOOSHORTMSK_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_PORT_COMMAND_DATAPORTBUSY_FIELD;
#define XPCSTX_TX_PORT_COMMAND_DATAPORTBUSY_FIELD_MASK  0x0000000080000000
#define XPCSTX_TX_PORT_COMMAND_DATAPORTBUSY_FIELD_WIDTH 1
#define XPCSTX_TX_PORT_COMMAND_DATAPORTBUSY_FIELD_SHIFT 31

extern const ru_field_rec XPCSTX_TX_PORT_COMMAND_RESERVED0_FIELD;
#define XPCSTX_TX_PORT_COMMAND_RESERVED0_FIELD_MASK  0x0000000040000000
#define XPCSTX_TX_PORT_COMMAND_RESERVED0_FIELD_WIDTH 1
#define XPCSTX_TX_PORT_COMMAND_RESERVED0_FIELD_SHIFT 30

extern const ru_field_rec XPCSTX_TX_PORT_COMMAND_PORTSELECT_FIELD;
#define XPCSTX_TX_PORT_COMMAND_PORTSELECT_FIELD_MASK  0x000000003f000000
#define XPCSTX_TX_PORT_COMMAND_PORTSELECT_FIELD_WIDTH 6
#define XPCSTX_TX_PORT_COMMAND_PORTSELECT_FIELD_SHIFT 24

extern const ru_field_rec XPCSTX_TX_PORT_COMMAND_PORTOPCODE_FIELD;
#define XPCSTX_TX_PORT_COMMAND_PORTOPCODE_FIELD_MASK  0x0000000000ff0000
#define XPCSTX_TX_PORT_COMMAND_PORTOPCODE_FIELD_WIDTH 8
#define XPCSTX_TX_PORT_COMMAND_PORTOPCODE_FIELD_SHIFT 16

extern const ru_field_rec XPCSTX_TX_PORT_COMMAND_PORTADDRESS_FIELD;
#define XPCSTX_TX_PORT_COMMAND_PORTADDRESS_FIELD_MASK  0x000000000000ffff
#define XPCSTX_TX_PORT_COMMAND_PORTADDRESS_FIELD_WIDTH 16
#define XPCSTX_TX_PORT_COMMAND_PORTADDRESS_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_DATA_PORT_0_PORTDATA0_FIELD;
#define XPCSTX_TX_DATA_PORT_0_PORTDATA0_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_DATA_PORT_0_PORTDATA0_FIELD_WIDTH 32
#define XPCSTX_TX_DATA_PORT_0_PORTDATA0_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_DATA_PORT_1_PORTDATA1_FIELD;
#define XPCSTX_TX_DATA_PORT_1_PORTDATA1_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_DATA_PORT_1_PORTDATA1_FIELD_WIDTH 32
#define XPCSTX_TX_DATA_PORT_1_PORTDATA1_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_DATA_PORT_2_PORTDATA2_FIELD;
#define XPCSTX_TX_DATA_PORT_2_PORTDATA2_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_DATA_PORT_2_PORTDATA2_FIELD_WIDTH 32
#define XPCSTX_TX_DATA_PORT_2_PORTDATA2_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_SYNC_PATT_CWORD_LO_CFGSYNCPATCWL_FIELD;
#define XPCSTX_TX_SYNC_PATT_CWORD_LO_CFGSYNCPATCWL_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_SYNC_PATT_CWORD_LO_CFGSYNCPATCWL_FIELD_WIDTH 32
#define XPCSTX_TX_SYNC_PATT_CWORD_LO_CFGSYNCPATCWL_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_SYNC_PATT_CWORD_HI_CFGSYNCPATCWH_FIELD;
#define XPCSTX_TX_SYNC_PATT_CWORD_HI_CFGSYNCPATCWH_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_SYNC_PATT_CWORD_HI_CFGSYNCPATCWH_FIELD_WIDTH 32
#define XPCSTX_TX_SYNC_PATT_CWORD_HI_CFGSYNCPATCWH_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_START_BURST_DEL_CWORD_LO_CFGSTRTBRSTDLMTRCWL_FIELD;
#define XPCSTX_TX_START_BURST_DEL_CWORD_LO_CFGSTRTBRSTDLMTRCWL_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_START_BURST_DEL_CWORD_LO_CFGSTRTBRSTDLMTRCWL_FIELD_WIDTH 32
#define XPCSTX_TX_START_BURST_DEL_CWORD_LO_CFGSTRTBRSTDLMTRCWL_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_START_BURST_DEL_CWORD_HI_CFGSTRTBRSTDLMTRCWH_FIELD;
#define XPCSTX_TX_START_BURST_DEL_CWORD_HI_CFGSTRTBRSTDLMTRCWH_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_START_BURST_DEL_CWORD_HI_CFGSTRTBRSTDLMTRCWH_FIELD_WIDTH 32
#define XPCSTX_TX_START_BURST_DEL_CWORD_HI_CFGSTRTBRSTDLMTRCWH_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_END_BURST_DEL_CWORD_LO_CFGENDBRSTDLMTRCWL_FIELD;
#define XPCSTX_TX_END_BURST_DEL_CWORD_LO_CFGENDBRSTDLMTRCWL_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_END_BURST_DEL_CWORD_LO_CFGENDBRSTDLMTRCWL_FIELD_WIDTH 32
#define XPCSTX_TX_END_BURST_DEL_CWORD_LO_CFGENDBRSTDLMTRCWL_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_END_BURST_DEL_CWORD_HI_CFGENDBRSTDLMTRCWH_FIELD;
#define XPCSTX_TX_END_BURST_DEL_CWORD_HI_CFGENDBRSTDLMTRCWH_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_END_BURST_DEL_CWORD_HI_CFGENDBRSTDLMTRCWH_FIELD_WIDTH 32
#define XPCSTX_TX_END_BURST_DEL_CWORD_HI_CFGENDBRSTDLMTRCWH_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_IDLE_CWORD_LO_CFGIDLECWL_FIELD;
#define XPCSTX_TX_IDLE_CWORD_LO_CFGIDLECWL_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_IDLE_CWORD_LO_CFGIDLECWL_FIELD_WIDTH 32
#define XPCSTX_TX_IDLE_CWORD_LO_CFGIDLECWL_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_IDLE_CWORD_HI_CFGIDLECWH_FIELD;
#define XPCSTX_TX_IDLE_CWORD_HI_CFGIDLECWH_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_IDLE_CWORD_HI_CFGIDLECWH_FIELD_WIDTH 32
#define XPCSTX_TX_IDLE_CWORD_HI_CFGIDLECWH_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_BURST_PATT_CWORD_LO_CFGBURSTPATCWL_FIELD;
#define XPCSTX_TX_BURST_PATT_CWORD_LO_CFGBURSTPATCWL_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_BURST_PATT_CWORD_LO_CFGBURSTPATCWL_FIELD_WIDTH 32
#define XPCSTX_TX_BURST_PATT_CWORD_LO_CFGBURSTPATCWL_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_BURST_PATT_CWORD_HI_CFGBURSTPATCWH_FIELD;
#define XPCSTX_TX_BURST_PATT_CWORD_HI_CFGBURSTPATCWH_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_BURST_PATT_CWORD_HI_CFGBURSTPATCWH_FIELD_WIDTH 32
#define XPCSTX_TX_BURST_PATT_CWORD_HI_CFGBURSTPATCWH_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_LASER_TIME_RESERVED0_FIELD;
#define XPCSTX_TX_LASER_TIME_RESERVED0_FIELD_MASK  0x00000000ffc00000
#define XPCSTX_TX_LASER_TIME_RESERVED0_FIELD_WIDTH 10
#define XPCSTX_TX_LASER_TIME_RESERVED0_FIELD_SHIFT 22

extern const ru_field_rec XPCSTX_TX_LASER_TIME_CFGLASERPIPE125_FIELD;
#define XPCSTX_TX_LASER_TIME_CFGLASERPIPE125_FIELD_MASK  0x00000000003f0000
#define XPCSTX_TX_LASER_TIME_CFGLASERPIPE125_FIELD_WIDTH 6
#define XPCSTX_TX_LASER_TIME_CFGLASERPIPE125_FIELD_SHIFT 16

extern const ru_field_rec XPCSTX_TX_LASER_TIME_RESERVED1_FIELD;
#define XPCSTX_TX_LASER_TIME_RESERVED1_FIELD_MASK  0x000000000000f000
#define XPCSTX_TX_LASER_TIME_RESERVED1_FIELD_WIDTH 4
#define XPCSTX_TX_LASER_TIME_RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec XPCSTX_TX_LASER_TIME_CFGLASEROFFDLYTQ125_FIELD;
#define XPCSTX_TX_LASER_TIME_CFGLASEROFFDLYTQ125_FIELD_MASK  0x0000000000000f00
#define XPCSTX_TX_LASER_TIME_CFGLASEROFFDLYTQ125_FIELD_WIDTH 4
#define XPCSTX_TX_LASER_TIME_CFGLASEROFFDLYTQ125_FIELD_SHIFT 8

extern const ru_field_rec XPCSTX_TX_LASER_TIME_RESERVED2_FIELD;
#define XPCSTX_TX_LASER_TIME_RESERVED2_FIELD_MASK  0x00000000000000f0
#define XPCSTX_TX_LASER_TIME_RESERVED2_FIELD_WIDTH 4
#define XPCSTX_TX_LASER_TIME_RESERVED2_FIELD_SHIFT 4

extern const ru_field_rec XPCSTX_TX_LASER_TIME_CFGLASERONDLYTQ125_FIELD;
#define XPCSTX_TX_LASER_TIME_CFGLASERONDLYTQ125_FIELD_MASK  0x000000000000000f
#define XPCSTX_TX_LASER_TIME_CFGLASERONDLYTQ125_FIELD_WIDTH 4
#define XPCSTX_TX_LASER_TIME_CFGLASERONDLYTQ125_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_MAC_MODE_RESERVED0_FIELD;
#define XPCSTX_TX_MAC_MODE_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define XPCSTX_TX_MAC_MODE_RESERVED0_FIELD_WIDTH 30
#define XPCSTX_TX_MAC_MODE_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec XPCSTX_TX_MAC_MODE_CFGENNOGNTXMT125_FIELD;
#define XPCSTX_TX_MAC_MODE_CFGENNOGNTXMT125_FIELD_MASK  0x0000000000000002
#define XPCSTX_TX_MAC_MODE_CFGENNOGNTXMT125_FIELD_WIDTH 1
#define XPCSTX_TX_MAC_MODE_CFGENNOGNTXMT125_FIELD_SHIFT 1

extern const ru_field_rec XPCSTX_TX_LASER_MONITOR_CTL_RESERVED0_FIELD;
#define XPCSTX_TX_LASER_MONITOR_CTL_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define XPCSTX_TX_LASER_MONITOR_CTL_RESERVED0_FIELD_WIDTH 26
#define XPCSTX_TX_LASER_MONITOR_CTL_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec XPCSTX_TX_LASER_MONITOR_CTL_LASERENSTATUS_FIELD;
#define XPCSTX_TX_LASER_MONITOR_CTL_LASERENSTATUS_FIELD_MASK  0x0000000000000020
#define XPCSTX_TX_LASER_MONITOR_CTL_LASERENSTATUS_FIELD_WIDTH 1
#define XPCSTX_TX_LASER_MONITOR_CTL_LASERENSTATUS_FIELD_SHIFT 5

extern const ru_field_rec XPCSTX_TX_LASER_MONITOR_CTL_CFGLSRMONACTHI_FIELD;
#define XPCSTX_TX_LASER_MONITOR_CTL_CFGLSRMONACTHI_FIELD_MASK  0x0000000000000010
#define XPCSTX_TX_LASER_MONITOR_CTL_CFGLSRMONACTHI_FIELD_WIDTH 1
#define XPCSTX_TX_LASER_MONITOR_CTL_CFGLSRMONACTHI_FIELD_SHIFT 4

extern const ru_field_rec XPCSTX_TX_LASER_MONITOR_CTL_RESERVED1_FIELD;
#define XPCSTX_TX_LASER_MONITOR_CTL_RESERVED1_FIELD_MASK  0x000000000000000e
#define XPCSTX_TX_LASER_MONITOR_CTL_RESERVED1_FIELD_WIDTH 3
#define XPCSTX_TX_LASER_MONITOR_CTL_RESERVED1_FIELD_SHIFT 1

extern const ru_field_rec XPCSTX_TX_LASER_MONITOR_CTL_LASERMONRSTN_FIELD;
#define XPCSTX_TX_LASER_MONITOR_CTL_LASERMONRSTN_FIELD_MASK  0x0000000000000001
#define XPCSTX_TX_LASER_MONITOR_CTL_LASERMONRSTN_FIELD_WIDTH 1
#define XPCSTX_TX_LASER_MONITOR_CTL_LASERMONRSTN_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_LASER_MONITOR_MAX_THRESH_CFGLSRMONMAXTQ_FIELD;
#define XPCSTX_TX_LASER_MONITOR_MAX_THRESH_CFGLSRMONMAXTQ_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_LASER_MONITOR_MAX_THRESH_CFGLSRMONMAXTQ_FIELD_WIDTH 32
#define XPCSTX_TX_LASER_MONITOR_MAX_THRESH_CFGLSRMONMAXTQ_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_LASER_MONITOR_BURST_LEN_LASERONLENGTH_FIELD;
#define XPCSTX_TX_LASER_MONITOR_BURST_LEN_LASERONLENGTH_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_LASER_MONITOR_BURST_LEN_LASERONLENGTH_FIELD_WIDTH 32
#define XPCSTX_TX_LASER_MONITOR_BURST_LEN_LASERONLENGTH_FIELD_SHIFT 0

extern const ru_field_rec XPCSTX_TX_LASER_MONITOR_BURST_COUNT_BURSTCNT_FIELD;
#define XPCSTX_TX_LASER_MONITOR_BURST_COUNT_BURSTCNT_FIELD_MASK  0x00000000ffffffff
#define XPCSTX_TX_LASER_MONITOR_BURST_COUNT_BURSTCNT_FIELD_WIDTH 32
#define XPCSTX_TX_LASER_MONITOR_BURST_COUNT_BURSTCNT_FIELD_SHIFT 0



/******************************************************************************
 * EPON Registers
 ******************************************************************************/
extern const ru_reg_rec EPON_TOP_SCRATCH_REG;
#define EPON_TOP_SCRATCH_REG_OFFSET 0x00000000

extern const ru_reg_rec EPON_TOP_RESET_REG;
#define EPON_TOP_RESET_REG_OFFSET 0x00000004

extern const ru_reg_rec EPON_TOP_INTERRUPT_REG;
#define EPON_TOP_INTERRUPT_REG_OFFSET 0x00000008

extern const ru_reg_rec EPON_TOP_INTERRUPT_MASK_REG;
#define EPON_TOP_INTERRUPT_MASK_REG_OFFSET 0x0000000c

extern const ru_reg_rec EPON_TOP_CONTROL_REG;
#define EPON_TOP_CONTROL_REG_OFFSET 0x00000010

extern const ru_reg_rec EPON_TOP_ONE_PPS_MPCP_OFFSET_REG;
#define EPON_TOP_ONE_PPS_MPCP_OFFSET_REG_OFFSET 0x00000014

extern const ru_reg_rec EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_REG;
#define EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_REG_OFFSET 0x00000018

extern const ru_reg_rec EPON_TOP_TOD_CONFIG_REG;
#define EPON_TOP_TOD_CONFIG_REG_OFFSET 0x0000001c

extern const ru_reg_rec EPON_TOP_TOD_NS_REG;
#define EPON_TOP_TOD_NS_REG_OFFSET 0x00000020

extern const ru_reg_rec EPON_TOP_TOD_MPCP_REG;
#define EPON_TOP_TOD_MPCP_REG_OFFSET 0x00000024

extern const ru_reg_rec EPON_TOP_TS48_MSB_REG;
#define EPON_TOP_TS48_MSB_REG_OFFSET 0x00000028

extern const ru_reg_rec EPON_TOP_TS48_LSB_REG;
#define EPON_TOP_TS48_LSB_REG_OFFSET 0x0000002c

extern const ru_reg_rec EPON_TOP_TSEC_REG;
#define EPON_TOP_TSEC_REG_OFFSET 0x00000030

extern const ru_reg_rec EPON_TOP_TNS_EPON_REG;
#define EPON_TOP_TNS_EPON_REG_OFFSET 0x00000034

extern const ru_reg_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_REG;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_REG_OFFSET 0x00000000

extern const ru_reg_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_REG;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_REG_OFFSET 0x00000004

extern const ru_reg_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_REG;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_REG_OFFSET 0x00000008

extern const ru_reg_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_REG;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_REG_OFFSET 0x0000000c

extern const ru_reg_rec EPN_ONU_MAC_ADDR_LO_REG;
#define EPN_ONU_MAC_ADDR_LO_REG_OFFSET 0x00000000

extern const ru_reg_rec EPN_ONU_MAC_ADDR_HI_REG;
#define EPN_ONU_MAC_ADDR_HI_REG_OFFSET 0x00000004

extern const ru_reg_rec EPN_TX_L1S_SHP_CONFIG_REG;
#define EPN_TX_L1S_SHP_CONFIG_REG_OFFSET 0x00000000

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_EN_REG;
#define EPN_TX_L1S_SHP_QUE_EN_REG_OFFSET 0x00000004

extern const ru_reg_rec EPN_CONTROL_0_REG;
#define EPN_CONTROL_0_REG_OFFSET 0x00000000

extern const ru_reg_rec EPN_CONTROL_1_REG;
#define EPN_CONTROL_1_REG_OFFSET 0x00000004

extern const ru_reg_rec EPN_ENABLE_GRANTS_REG;
#define EPN_ENABLE_GRANTS_REG_OFFSET 0x00000008

extern const ru_reg_rec EPN_DROP_DISC_GATES_REG;
#define EPN_DROP_DISC_GATES_REG_OFFSET 0x0000000c

extern const ru_reg_rec EPN_DIS_FCS_CHK_REG;
#define EPN_DIS_FCS_CHK_REG_OFFSET 0x00000010

extern const ru_reg_rec EPN_PASS_GATES_REG;
#define EPN_PASS_GATES_REG_OFFSET 0x00000014

extern const ru_reg_rec EPN_CFG_MISALGN_FB_REG;
#define EPN_CFG_MISALGN_FB_REG_OFFSET 0x00000018

extern const ru_reg_rec EPN_DISCOVERY_FILTER_REG;
#define EPN_DISCOVERY_FILTER_REG_OFFSET 0x0000001c

extern const ru_reg_rec EPN_MINIMUM_GRANT_SETUP_REG;
#define EPN_MINIMUM_GRANT_SETUP_REG_OFFSET 0x00000020

extern const ru_reg_rec EPN_RESET_GNT_FIFO_REG;
#define EPN_RESET_GNT_FIFO_REG_OFFSET 0x00000024

extern const ru_reg_rec EPN_RESET_L1_ACCUMULATOR_REG;
#define EPN_RESET_L1_ACCUMULATOR_REG_OFFSET 0x00000028

extern const ru_reg_rec EPN_L1_ACCUMULATOR_SEL_REG;
#define EPN_L1_ACCUMULATOR_SEL_REG_OFFSET 0x0000002c

extern const ru_reg_rec EPN_L1_SVA_BYTES_REG;
#define EPN_L1_SVA_BYTES_REG_OFFSET 0x00000030

extern const ru_reg_rec EPN_L1_UVA_BYTES_REG;
#define EPN_L1_UVA_BYTES_REG_OFFSET 0x00000034

extern const ru_reg_rec EPN_L1_SVA_OVERFLOW_REG;
#define EPN_L1_SVA_OVERFLOW_REG_OFFSET 0x00000038

extern const ru_reg_rec EPN_L1_UVA_OVERFLOW_REG;
#define EPN_L1_UVA_OVERFLOW_REG_OFFSET 0x0000003c

extern const ru_reg_rec EPN_RESET_RPT_PRI_REG;
#define EPN_RESET_RPT_PRI_REG_OFFSET 0x00000040

extern const ru_reg_rec EPN_RESET_L2_RPT_FIFO_REG;
#define EPN_RESET_L2_RPT_FIFO_REG_OFFSET 0x00000044

extern const ru_reg_rec EPN_ENABLE_UPSTREAM_REG;
#define EPN_ENABLE_UPSTREAM_REG_OFFSET 0x00000048

extern const ru_reg_rec EPN_ENABLE_UPSTREAM_FB_REG;
#define EPN_ENABLE_UPSTREAM_FB_REG_OFFSET 0x0000004c

extern const ru_reg_rec EPN_ENABLE_UPSTREAM_FEC_REG;
#define EPN_ENABLE_UPSTREAM_FEC_REG_OFFSET 0x00000050

extern const ru_reg_rec EPN_REPORT_BYTE_LENGTH_REG;
#define EPN_REPORT_BYTE_LENGTH_REG_OFFSET 0x00000054

extern const ru_reg_rec EPN_MAIN_INT_STATUS_REG;
#define EPN_MAIN_INT_STATUS_REG_OFFSET 0x00000058

extern const ru_reg_rec EPN_GNT_FULL_INT_STATUS_REG;
#define EPN_GNT_FULL_INT_STATUS_REG_OFFSET 0x0000005c

extern const ru_reg_rec EPN_GNT_FULL_INT_MASK_REG;
#define EPN_GNT_FULL_INT_MASK_REG_OFFSET 0x00000060

extern const ru_reg_rec EPN_GNT_MISS_INT_STATUS_REG;
#define EPN_GNT_MISS_INT_STATUS_REG_OFFSET 0x00000064

extern const ru_reg_rec EPN_GNT_MISS_INT_MASK_REG;
#define EPN_GNT_MISS_INT_MASK_REG_OFFSET 0x00000068

extern const ru_reg_rec EPN_DISC_RX_INT_STATUS_REG;
#define EPN_DISC_RX_INT_STATUS_REG_OFFSET 0x0000006c

extern const ru_reg_rec EPN_DISC_RX_INT_MASK_REG;
#define EPN_DISC_RX_INT_MASK_REG_OFFSET 0x00000070

extern const ru_reg_rec EPN_GNT_INTV_INT_STATUS_REG;
#define EPN_GNT_INTV_INT_STATUS_REG_OFFSET 0x00000074

extern const ru_reg_rec EPN_GNT_INTV_INT_MASK_REG;
#define EPN_GNT_INTV_INT_MASK_REG_OFFSET 0x00000078

extern const ru_reg_rec EPN_GNT_FAR_INT_STATUS_REG;
#define EPN_GNT_FAR_INT_STATUS_REG_OFFSET 0x0000007c

extern const ru_reg_rec EPN_GNT_FAR_INT_MASK_REG;
#define EPN_GNT_FAR_INT_MASK_REG_OFFSET 0x00000080

extern const ru_reg_rec EPN_GNT_MISALGN_INT_STATUS_REG;
#define EPN_GNT_MISALGN_INT_STATUS_REG_OFFSET 0x00000084

extern const ru_reg_rec EPN_GNT_MISALGN_INT_MASK_REG;
#define EPN_GNT_MISALGN_INT_MASK_REG_OFFSET 0x00000088

extern const ru_reg_rec EPN_NP_GNT_INT_STATUS_REG;
#define EPN_NP_GNT_INT_STATUS_REG_OFFSET 0x0000008c

extern const ru_reg_rec EPN_NP_GNT_INT_MASK_REG;
#define EPN_NP_GNT_INT_MASK_REG_OFFSET 0x00000090

extern const ru_reg_rec EPN_DEL_STALE_INT_STATUS_REG;
#define EPN_DEL_STALE_INT_STATUS_REG_OFFSET 0x00000094

extern const ru_reg_rec EPN_DEL_STALE_INT_MASK_REG;
#define EPN_DEL_STALE_INT_MASK_REG_OFFSET 0x00000098

extern const ru_reg_rec EPN_GNT_PRES_INT_STATUS_REG;
#define EPN_GNT_PRES_INT_STATUS_REG_OFFSET 0x0000009c

extern const ru_reg_rec EPN_GNT_PRES_INT_MASK_REG;
#define EPN_GNT_PRES_INT_MASK_REG_OFFSET 0x000000a0

extern const ru_reg_rec EPN_RPT_PRES_INT_STATUS_REG;
#define EPN_RPT_PRES_INT_STATUS_REG_OFFSET 0x000000a4

extern const ru_reg_rec EPN_RPT_PRES_INT_MASK_REG;
#define EPN_RPT_PRES_INT_MASK_REG_OFFSET 0x000000a8

extern const ru_reg_rec EPN_DRX_ABORT_INT_STATUS_REG;
#define EPN_DRX_ABORT_INT_STATUS_REG_OFFSET 0x000000ac

extern const ru_reg_rec EPN_DRX_ABORT_INT_MASK_REG;
#define EPN_DRX_ABORT_INT_MASK_REG_OFFSET 0x000000b0

extern const ru_reg_rec EPN_EMPTY_RPT_INT_STATUS_REG;
#define EPN_EMPTY_RPT_INT_STATUS_REG_OFFSET 0x000000b4

extern const ru_reg_rec EPN_EMPTY_RPT_INT_MASK_REG;
#define EPN_EMPTY_RPT_INT_MASK_REG_OFFSET 0x000000b8

extern const ru_reg_rec EPN_BCAP_OVERFLOW_INT_STATUS_REG;
#define EPN_BCAP_OVERFLOW_INT_STATUS_REG_OFFSET 0x000000bc

extern const ru_reg_rec EPN_BCAP_OVERFLOW_INT_MASK_REG;
#define EPN_BCAP_OVERFLOW_INT_MASK_REG_OFFSET 0x000000c0

extern const ru_reg_rec EPN_BBH_DNS_FAULT_INT_STATUS_REG;
#define EPN_BBH_DNS_FAULT_INT_STATUS_REG_OFFSET 0x000000c4

extern const ru_reg_rec EPN_BBH_DNS_FAULT_INT_MASK_REG;
#define EPN_BBH_DNS_FAULT_INT_MASK_REG_OFFSET 0x000000c8

extern const ru_reg_rec EPN_BBH_UPS_FAULT_INT_STATUS_REG;
#define EPN_BBH_UPS_FAULT_INT_STATUS_REG_OFFSET 0x000000cc

extern const ru_reg_rec EPN_BBH_UPS_FAULT_INT_MASK_REG;
#define EPN_BBH_UPS_FAULT_INT_MASK_REG_OFFSET 0x000000d0

extern const ru_reg_rec EPN_BBH_UPS_ABORT_INT_STATUS_REG;
#define EPN_BBH_UPS_ABORT_INT_STATUS_REG_OFFSET 0x000000d4

extern const ru_reg_rec EPN_BBH_UPS_ABORT_INT_MASK_REG;
#define EPN_BBH_UPS_ABORT_INT_MASK_REG_OFFSET 0x000000d8

extern const ru_reg_rec EPN_MAIN_INT_MASK_REG;
#define EPN_MAIN_INT_MASK_REG_OFFSET 0x000000dc

extern const ru_reg_rec EPN_MAX_GNT_SIZE_REG;
#define EPN_MAX_GNT_SIZE_REG_OFFSET 0x000000e0

extern const ru_reg_rec EPN_MAX_FRAME_SIZE_REG;
#define EPN_MAX_FRAME_SIZE_REG_OFFSET 0x000000e4

extern const ru_reg_rec EPN_GRANT_OVR_HD_REG;
#define EPN_GRANT_OVR_HD_REG_OFFSET 0x000000e8

extern const ru_reg_rec EPN_POLL_SIZE_REG;
#define EPN_POLL_SIZE_REG_OFFSET 0x000000ec

extern const ru_reg_rec EPN_DN_RD_GNT_MARGIN_REG;
#define EPN_DN_RD_GNT_MARGIN_REG_OFFSET 0x000000f0

extern const ru_reg_rec EPN_GNT_TIME_START_DELTA_REG;
#define EPN_GNT_TIME_START_DELTA_REG_OFFSET 0x000000f4

extern const ru_reg_rec EPN_TIME_STAMP_DIFF_REG;
#define EPN_TIME_STAMP_DIFF_REG_OFFSET 0x000000f8

extern const ru_reg_rec EPN_UP_TIME_STAMP_OFF_REG;
#define EPN_UP_TIME_STAMP_OFF_REG_OFFSET 0x000000fc

extern const ru_reg_rec EPN_GNT_INTERVAL_REG;
#define EPN_GNT_INTERVAL_REG_OFFSET 0x00000100

extern const ru_reg_rec EPN_DN_GNT_MISALIGN_THR_REG;
#define EPN_DN_GNT_MISALIGN_THR_REG_OFFSET 0x00000104

extern const ru_reg_rec EPN_DN_GNT_MISALIGN_PAUSE_REG;
#define EPN_DN_GNT_MISALIGN_PAUSE_REG_OFFSET 0x00000108

extern const ru_reg_rec EPN_NON_POLL_INTV_REG;
#define EPN_NON_POLL_INTV_REG_OFFSET 0x0000010c

extern const ru_reg_rec EPN_FORCE_FCS_ERR_REG;
#define EPN_FORCE_FCS_ERR_REG_OFFSET 0x00000110

extern const ru_reg_rec EPN_GRANT_OVERLAP_LIMIT_REG;
#define EPN_GRANT_OVERLAP_LIMIT_REG_OFFSET 0x00000114

extern const ru_reg_rec EPN_AES_CONFIGURATION_0_REG;
#define EPN_AES_CONFIGURATION_0_REG_OFFSET 0x00000118

extern const ru_reg_rec EPN_DISC_GRANT_OVR_HD_REG;
#define EPN_DISC_GRANT_OVR_HD_REG_OFFSET 0x0000011c

extern const ru_reg_rec EPN_DN_DISCOVERY_SEED_REG;
#define EPN_DN_DISCOVERY_SEED_REG_OFFSET 0x00000120

extern const ru_reg_rec EPN_DN_DISCOVERY_INC_REG;
#define EPN_DN_DISCOVERY_INC_REG_OFFSET 0x00000124

extern const ru_reg_rec EPN_DN_DISCOVERY_SIZE_REG;
#define EPN_DN_DISCOVERY_SIZE_REG_OFFSET 0x00000128

extern const ru_reg_rec EPN_FEC_IPG_LENGTH_REG;
#define EPN_FEC_IPG_LENGTH_REG_OFFSET 0x0000012c

extern const ru_reg_rec EPN_FAKE_REPORT_VALUE_EN_REG;
#define EPN_FAKE_REPORT_VALUE_EN_REG_OFFSET 0x00000130

extern const ru_reg_rec EPN_FAKE_REPORT_VALUE_REG;
#define EPN_FAKE_REPORT_VALUE_REG_OFFSET 0x00000134

extern const ru_reg_rec EPN_VALID_OPCODE_MAP_REG;
#define EPN_VALID_OPCODE_MAP_REG_OFFSET 0x00000178

extern const ru_reg_rec EPN_UP_PACKET_TX_MARGIN_REG;
#define EPN_UP_PACKET_TX_MARGIN_REG_OFFSET 0x0000017c

extern const ru_reg_rec EPN_MULTI_PRI_CFG_0_REG;
#define EPN_MULTI_PRI_CFG_0_REG_OFFSET 0x00000180

extern const ru_reg_rec EPN_SHARED_BCAP_OVRFLOW_REG;
#define EPN_SHARED_BCAP_OVRFLOW_REG_OFFSET 0x00000184

extern const ru_reg_rec EPN_FORCED_REPORT_EN_REG;
#define EPN_FORCED_REPORT_EN_REG_OFFSET 0x00000188

extern const ru_reg_rec EPN_FORCED_REPORT_MAX_INTERVAL_REG;
#define EPN_FORCED_REPORT_MAX_INTERVAL_REG_OFFSET 0x0000018c

extern const ru_reg_rec EPN_L2S_FLUSH_CONFIG_REG;
#define EPN_L2S_FLUSH_CONFIG_REG_OFFSET 0x00000190

extern const ru_reg_rec EPN_DATA_PORT_COMMAND_REG;
#define EPN_DATA_PORT_COMMAND_REG_OFFSET 0x00000194

extern const ru_reg_rec EPN_DATA_PORT_ADDRESS_REG;
#define EPN_DATA_PORT_ADDRESS_REG_OFFSET 0x00000198

extern const ru_reg_rec EPN_DATA_PORT_DATA_0_REG;
#define EPN_DATA_PORT_DATA_0_REG_OFFSET 0x0000019c

extern const ru_reg_rec EPN_UNMAP_BIG_CNT_REG;
#define EPN_UNMAP_BIG_CNT_REG_OFFSET 0x000001a0

extern const ru_reg_rec EPN_UNMAP_FRAME_CNT_REG;
#define EPN_UNMAP_FRAME_CNT_REG_OFFSET 0x000001a4

extern const ru_reg_rec EPN_UNMAP_FCS_CNT_REG;
#define EPN_UNMAP_FCS_CNT_REG_OFFSET 0x000001a8

extern const ru_reg_rec EPN_UNMAP_GATE_CNT_REG;
#define EPN_UNMAP_GATE_CNT_REG_OFFSET 0x000001ac

extern const ru_reg_rec EPN_UNMAP_OAM_CNT_REG;
#define EPN_UNMAP_OAM_CNT_REG_OFFSET 0x000001b0

extern const ru_reg_rec EPN_UNMAP_SMALL_CNT_REG;
#define EPN_UNMAP_SMALL_CNT_REG_OFFSET 0x000001b4

extern const ru_reg_rec EPN_FIF_DEQUEUE_EVENT_CNT_REG;
#define EPN_FIF_DEQUEUE_EVENT_CNT_REG_OFFSET 0x000001b8

extern const ru_reg_rec EPN_BBH_UP_FAULT_HALT_EN_REG;
#define EPN_BBH_UP_FAULT_HALT_EN_REG_OFFSET 0x000001dc

extern const ru_reg_rec EPN_BBH_UP_TARDY_HALT_EN_REG;
#define EPN_BBH_UP_TARDY_HALT_EN_REG_OFFSET 0x000001e0

extern const ru_reg_rec EPN_DEBUG_STATUS_0_REG;
#define EPN_DEBUG_STATUS_0_REG_OFFSET 0x000001e4

extern const ru_reg_rec EPN_DEBUG_STATUS_1_REG;
#define EPN_DEBUG_STATUS_1_REG_OFFSET 0x000001e8

extern const ru_reg_rec EPN_DEBUG_L2S_PTR_SEL_REG;
#define EPN_DEBUG_L2S_PTR_SEL_REG_OFFSET 0x000001ec

extern const ru_reg_rec EPN_OLT_MAC_ADDR_LO_REG;
#define EPN_OLT_MAC_ADDR_LO_REG_OFFSET 0x00000230

extern const ru_reg_rec EPN_OLT_MAC_ADDR_HI_REG;
#define EPN_OLT_MAC_ADDR_HI_REG_OFFSET 0x00000234

extern const ru_reg_rec EPN_TX_L1S_SHP_DQU_EMPTY_REG;
#define EPN_TX_L1S_SHP_DQU_EMPTY_REG_OFFSET 0x00000278

extern const ru_reg_rec EPN_TX_L1S_UNSHAPED_EMPTY_REG;
#define EPN_TX_L1S_UNSHAPED_EMPTY_REG_OFFSET 0x0000027c

extern const ru_reg_rec EPN_TX_L2S_QUE_EMPTY_REG;
#define EPN_TX_L2S_QUE_EMPTY_REG_OFFSET 0x000002c0

extern const ru_reg_rec EPN_TX_L2S_QUE_FULL_REG;
#define EPN_TX_L2S_QUE_FULL_REG_OFFSET 0x000002c4

extern const ru_reg_rec EPN_TX_L2S_QUE_STOPPED_REG;
#define EPN_TX_L2S_QUE_STOPPED_REG_OFFSET 0x000002c8

extern const ru_reg_rec EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_REG;
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_REG_OFFSET 0x000002ec

extern const ru_reg_rec EPN_MIN_REPORT_VALUE_DIFFERENCE_REG;
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_REG_OFFSET 0x000002f0

extern const ru_reg_rec EPN_BBH_STATUS_FIFO_OVERFLOW_REG;
#define EPN_BBH_STATUS_FIFO_OVERFLOW_REG_OFFSET 0x000002f4

extern const ru_reg_rec EPN_SPARE_CTL_REG;
#define EPN_SPARE_CTL_REG_OFFSET 0x000002f8

extern const ru_reg_rec EPN_TS_SYNC_OFFSET_REG;
#define EPN_TS_SYNC_OFFSET_REG_OFFSET 0x000002fc

extern const ru_reg_rec EPN_DN_TS_OFFSET_REG;
#define EPN_DN_TS_OFFSET_REG_OFFSET 0x00000300

extern const ru_reg_rec EPN_UP_TS_OFFSET_LO_REG;
#define EPN_UP_TS_OFFSET_LO_REG_OFFSET 0x00000304

extern const ru_reg_rec EPN_UP_TS_OFFSET_HI_REG;
#define EPN_UP_TS_OFFSET_HI_REG_OFFSET 0x00000308

extern const ru_reg_rec EPN_TWO_STEP_TS_CTL_REG;
#define EPN_TWO_STEP_TS_CTL_REG_OFFSET 0x0000030c

extern const ru_reg_rec EPN_TWO_STEP_TS_VALUE_LO_REG;
#define EPN_TWO_STEP_TS_VALUE_LO_REG_OFFSET 0x00000310

extern const ru_reg_rec EPN_TWO_STEP_TS_VALUE_HI_REG;
#define EPN_TWO_STEP_TS_VALUE_HI_REG_OFFSET 0x00000314

extern const ru_reg_rec EPN_1588_TIMESTAMP_INT_STATUS_REG;
#define EPN_1588_TIMESTAMP_INT_STATUS_REG_OFFSET 0x00000318

extern const ru_reg_rec EPN_1588_TIMESTAMP_INT_MASK_REG;
#define EPN_1588_TIMESTAMP_INT_MASK_REG_OFFSET 0x0000031c

extern const ru_reg_rec EPN_UP_PACKET_FETCH_MARGIN_REG;
#define EPN_UP_PACKET_FETCH_MARGIN_REG_OFFSET 0x00000320

extern const ru_reg_rec EPN_DN_1588_TIMESTAMP_REG;
#define EPN_DN_1588_TIMESTAMP_REG_OFFSET 0x00000324

extern const ru_reg_rec EPN_PERSISTENT_REPORT_CFG_REG;
#define EPN_PERSISTENT_REPORT_CFG_REG_OFFSET 0x00000328

extern const ru_reg_rec EPN_PERSISTENT_REPORT_ENABLES_REG;
#define EPN_PERSISTENT_REPORT_ENABLES_REG_OFFSET 0x0000032c

extern const ru_reg_rec EPN_PERSISTENT_REPORT_REQUEST_SIZE_REG;
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_REG_OFFSET 0x00000330

extern const ru_reg_rec EPN_AES_CONFIGURATION_1_REG;
#define EPN_AES_CONFIGURATION_1_REG_OFFSET 0x00000334

extern const ru_reg_rec EPN_BURST_CAP_0_REG;
#define EPN_BURST_CAP_0_REG_OFFSET 0x00000138

extern const ru_reg_rec EPN_BURST_CAP_1_REG;
#define EPN_BURST_CAP_1_REG_OFFSET 0x0000013c

extern const ru_reg_rec EPN_BURST_CAP_2_REG;
#define EPN_BURST_CAP_2_REG_OFFSET 0x00000140

extern const ru_reg_rec EPN_BURST_CAP_3_REG;
#define EPN_BURST_CAP_3_REG_OFFSET 0x00000144

extern const ru_reg_rec EPN_BURST_CAP_4_REG;
#define EPN_BURST_CAP_4_REG_OFFSET 0x00000148

extern const ru_reg_rec EPN_BURST_CAP_5_REG;
#define EPN_BURST_CAP_5_REG_OFFSET 0x0000014c

extern const ru_reg_rec EPN_BURST_CAP_6_REG;
#define EPN_BURST_CAP_6_REG_OFFSET 0x00000150

extern const ru_reg_rec EPN_BURST_CAP_7_REG;
#define EPN_BURST_CAP_7_REG_OFFSET 0x00000154

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_0_REG;
#define EPN_QUEUE_LLID_MAP_0_REG_OFFSET 0x00000158

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_1_REG;
#define EPN_QUEUE_LLID_MAP_1_REG_OFFSET 0x0000015c

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_2_REG;
#define EPN_QUEUE_LLID_MAP_2_REG_OFFSET 0x00000160

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_3_REG;
#define EPN_QUEUE_LLID_MAP_3_REG_OFFSET 0x00000164

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_4_REG;
#define EPN_QUEUE_LLID_MAP_4_REG_OFFSET 0x00000168

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_5_REG;
#define EPN_QUEUE_LLID_MAP_5_REG_OFFSET 0x0000016c

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_6_REG;
#define EPN_QUEUE_LLID_MAP_6_REG_OFFSET 0x00000170

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_7_REG;
#define EPN_QUEUE_LLID_MAP_7_REG_OFFSET 0x00000174

extern const ru_reg_rec EPN_UNUSED_TQ_CNT0_REG;
#define EPN_UNUSED_TQ_CNT0_REG_OFFSET 0x000001bc

extern const ru_reg_rec EPN_UNUSED_TQ_CNT1_REG;
#define EPN_UNUSED_TQ_CNT1_REG_OFFSET 0x000001c0

extern const ru_reg_rec EPN_UNUSED_TQ_CNT2_REG;
#define EPN_UNUSED_TQ_CNT2_REG_OFFSET 0x000001c4

extern const ru_reg_rec EPN_UNUSED_TQ_CNT3_REG;
#define EPN_UNUSED_TQ_CNT3_REG_OFFSET 0x000001c8

extern const ru_reg_rec EPN_UNUSED_TQ_CNT4_REG;
#define EPN_UNUSED_TQ_CNT4_REG_OFFSET 0x000001cc

extern const ru_reg_rec EPN_UNUSED_TQ_CNT5_REG;
#define EPN_UNUSED_TQ_CNT5_REG_OFFSET 0x000001d0

extern const ru_reg_rec EPN_UNUSED_TQ_CNT6_REG;
#define EPN_UNUSED_TQ_CNT6_REG_OFFSET 0x000001d4

extern const ru_reg_rec EPN_UNUSED_TQ_CNT7_REG;
#define EPN_UNUSED_TQ_CNT7_REG_OFFSET 0x000001d8

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_0_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_0_REG_OFFSET 0x00000280

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_1_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_1_REG_OFFSET 0x00000284

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_2_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_2_REG_OFFSET 0x00000288

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_3_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_3_REG_OFFSET 0x0000028c

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_4_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_4_REG_OFFSET 0x00000290

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_5_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_5_REG_OFFSET 0x00000294

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_6_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_6_REG_OFFSET 0x00000298

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_7_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_7_REG_OFFSET 0x0000029c

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_0_REG;
#define EPN_TX_L2S_QUE_CONFIG_0_REG_OFFSET 0x000002a0

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_1_REG;
#define EPN_TX_L2S_QUE_CONFIG_1_REG_OFFSET 0x000002a4

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_2_REG;
#define EPN_TX_L2S_QUE_CONFIG_2_REG_OFFSET 0x000002a8

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_3_REG;
#define EPN_TX_L2S_QUE_CONFIG_3_REG_OFFSET 0x000002ac

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_4_REG;
#define EPN_TX_L2S_QUE_CONFIG_4_REG_OFFSET 0x000002b0

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_5_REG;
#define EPN_TX_L2S_QUE_CONFIG_5_REG_OFFSET 0x000002b4

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_6_REG;
#define EPN_TX_L2S_QUE_CONFIG_6_REG_OFFSET 0x000002b8

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_7_REG;
#define EPN_TX_L2S_QUE_CONFIG_7_REG_OFFSET 0x000002bc

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_0_REG;
#define EPN_TX_CTC_BURST_LIMIT_0_REG_OFFSET 0x000002cc

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_1_REG;
#define EPN_TX_CTC_BURST_LIMIT_1_REG_OFFSET 0x000002d0

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_2_REG;
#define EPN_TX_CTC_BURST_LIMIT_2_REG_OFFSET 0x000002d4

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_3_REG;
#define EPN_TX_CTC_BURST_LIMIT_3_REG_OFFSET 0x000002d8

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_4_REG;
#define EPN_TX_CTC_BURST_LIMIT_4_REG_OFFSET 0x000002dc

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_5_REG;
#define EPN_TX_CTC_BURST_LIMIT_5_REG_OFFSET 0x000002e0

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_6_REG;
#define EPN_TX_CTC_BURST_LIMIT_6_REG_OFFSET 0x000002e4

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_7_REG;
#define EPN_TX_CTC_BURST_LIMIT_7_REG_OFFSET 0x000002e8

extern const ru_reg_rec EPN_BURST_CAP_8_REG;
#define EPN_BURST_CAP_8_REG_OFFSET 0x00000338

extern const ru_reg_rec EPN_BURST_CAP_9_REG;
#define EPN_BURST_CAP_9_REG_OFFSET 0x0000033c

extern const ru_reg_rec EPN_BURST_CAP_10_REG;
#define EPN_BURST_CAP_10_REG_OFFSET 0x00000340

extern const ru_reg_rec EPN_BURST_CAP_11_REG;
#define EPN_BURST_CAP_11_REG_OFFSET 0x00000344

extern const ru_reg_rec EPN_BURST_CAP_12_REG;
#define EPN_BURST_CAP_12_REG_OFFSET 0x00000348

extern const ru_reg_rec EPN_BURST_CAP_13_REG;
#define EPN_BURST_CAP_13_REG_OFFSET 0x0000034c

extern const ru_reg_rec EPN_BURST_CAP_14_REG;
#define EPN_BURST_CAP_14_REG_OFFSET 0x00000350

extern const ru_reg_rec EPN_BURST_CAP_15_REG;
#define EPN_BURST_CAP_15_REG_OFFSET 0x00000354

extern const ru_reg_rec EPN_BURST_CAP_16_REG;
#define EPN_BURST_CAP_16_REG_OFFSET 0x00000358

extern const ru_reg_rec EPN_BURST_CAP_17_REG;
#define EPN_BURST_CAP_17_REG_OFFSET 0x0000035c

extern const ru_reg_rec EPN_BURST_CAP_18_REG;
#define EPN_BURST_CAP_18_REG_OFFSET 0x00000360

extern const ru_reg_rec EPN_BURST_CAP_19_REG;
#define EPN_BURST_CAP_19_REG_OFFSET 0x00000364

extern const ru_reg_rec EPN_BURST_CAP_20_REG;
#define EPN_BURST_CAP_20_REG_OFFSET 0x00000368

extern const ru_reg_rec EPN_BURST_CAP_21_REG;
#define EPN_BURST_CAP_21_REG_OFFSET 0x0000036c

extern const ru_reg_rec EPN_BURST_CAP_22_REG;
#define EPN_BURST_CAP_22_REG_OFFSET 0x00000370

extern const ru_reg_rec EPN_BURST_CAP_23_REG;
#define EPN_BURST_CAP_23_REG_OFFSET 0x00000374

extern const ru_reg_rec EPN_BURST_CAP_24_REG;
#define EPN_BURST_CAP_24_REG_OFFSET 0x00000378

extern const ru_reg_rec EPN_BURST_CAP_25_REG;
#define EPN_BURST_CAP_25_REG_OFFSET 0x0000037c

extern const ru_reg_rec EPN_BURST_CAP_26_REG;
#define EPN_BURST_CAP_26_REG_OFFSET 0x00000380

extern const ru_reg_rec EPN_BURST_CAP_27_REG;
#define EPN_BURST_CAP_27_REG_OFFSET 0x00000384

extern const ru_reg_rec EPN_BURST_CAP_28_REG;
#define EPN_BURST_CAP_28_REG_OFFSET 0x00000388

extern const ru_reg_rec EPN_BURST_CAP_29_REG;
#define EPN_BURST_CAP_29_REG_OFFSET 0x0000038c

extern const ru_reg_rec EPN_BURST_CAP_30_REG;
#define EPN_BURST_CAP_30_REG_OFFSET 0x00000390

extern const ru_reg_rec EPN_BURST_CAP_31_REG;
#define EPN_BURST_CAP_31_REG_OFFSET 0x00000394

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_8_REG;
#define EPN_QUEUE_LLID_MAP_8_REG_OFFSET 0x00000398

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_9_REG;
#define EPN_QUEUE_LLID_MAP_9_REG_OFFSET 0x0000039c

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_10_REG;
#define EPN_QUEUE_LLID_MAP_10_REG_OFFSET 0x000003a0

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_11_REG;
#define EPN_QUEUE_LLID_MAP_11_REG_OFFSET 0x000003a4

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_12_REG;
#define EPN_QUEUE_LLID_MAP_12_REG_OFFSET 0x000003a8

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_13_REG;
#define EPN_QUEUE_LLID_MAP_13_REG_OFFSET 0x000003ac

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_14_REG;
#define EPN_QUEUE_LLID_MAP_14_REG_OFFSET 0x000003b0

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_15_REG;
#define EPN_QUEUE_LLID_MAP_15_REG_OFFSET 0x000003b4

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_16_REG;
#define EPN_QUEUE_LLID_MAP_16_REG_OFFSET 0x000003b8

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_17_REG;
#define EPN_QUEUE_LLID_MAP_17_REG_OFFSET 0x000003bc

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_18_REG;
#define EPN_QUEUE_LLID_MAP_18_REG_OFFSET 0x000003c0

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_19_REG;
#define EPN_QUEUE_LLID_MAP_19_REG_OFFSET 0x000003c4

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_20_REG;
#define EPN_QUEUE_LLID_MAP_20_REG_OFFSET 0x000003c8

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_21_REG;
#define EPN_QUEUE_LLID_MAP_21_REG_OFFSET 0x000003cc

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_22_REG;
#define EPN_QUEUE_LLID_MAP_22_REG_OFFSET 0x000003d0

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_23_REG;
#define EPN_QUEUE_LLID_MAP_23_REG_OFFSET 0x000003d4

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_24_REG;
#define EPN_QUEUE_LLID_MAP_24_REG_OFFSET 0x000003d8

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_25_REG;
#define EPN_QUEUE_LLID_MAP_25_REG_OFFSET 0x000003dc

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_26_REG;
#define EPN_QUEUE_LLID_MAP_26_REG_OFFSET 0x000003e0

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_27_REG;
#define EPN_QUEUE_LLID_MAP_27_REG_OFFSET 0x000003e4

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_28_REG;
#define EPN_QUEUE_LLID_MAP_28_REG_OFFSET 0x000003e8

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_29_REG;
#define EPN_QUEUE_LLID_MAP_29_REG_OFFSET 0x000003ec

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_30_REG;
#define EPN_QUEUE_LLID_MAP_30_REG_OFFSET 0x000003f0

extern const ru_reg_rec EPN_QUEUE_LLID_MAP_31_REG;
#define EPN_QUEUE_LLID_MAP_31_REG_OFFSET 0x000003f4

extern const ru_reg_rec EPN_UNUSED_TQ_CNT8_REG;
#define EPN_UNUSED_TQ_CNT8_REG_OFFSET 0x000003f8

extern const ru_reg_rec EPN_UNUSED_TQ_CNT9_REG;
#define EPN_UNUSED_TQ_CNT9_REG_OFFSET 0x000003fc

extern const ru_reg_rec EPN_UNUSED_TQ_CNT10_REG;
#define EPN_UNUSED_TQ_CNT10_REG_OFFSET 0x00000400

extern const ru_reg_rec EPN_UNUSED_TQ_CNT11_REG;
#define EPN_UNUSED_TQ_CNT11_REG_OFFSET 0x00000404

extern const ru_reg_rec EPN_UNUSED_TQ_CNT12_REG;
#define EPN_UNUSED_TQ_CNT12_REG_OFFSET 0x00000408

extern const ru_reg_rec EPN_UNUSED_TQ_CNT13_REG;
#define EPN_UNUSED_TQ_CNT13_REG_OFFSET 0x0000040c

extern const ru_reg_rec EPN_UNUSED_TQ_CNT14_REG;
#define EPN_UNUSED_TQ_CNT14_REG_OFFSET 0x00000410

extern const ru_reg_rec EPN_UNUSED_TQ_CNT15_REG;
#define EPN_UNUSED_TQ_CNT15_REG_OFFSET 0x00000414

extern const ru_reg_rec EPN_UNUSED_TQ_CNT16_REG;
#define EPN_UNUSED_TQ_CNT16_REG_OFFSET 0x00000418

extern const ru_reg_rec EPN_UNUSED_TQ_CNT17_REG;
#define EPN_UNUSED_TQ_CNT17_REG_OFFSET 0x0000041c

extern const ru_reg_rec EPN_UNUSED_TQ_CNT18_REG;
#define EPN_UNUSED_TQ_CNT18_REG_OFFSET 0x00000420

extern const ru_reg_rec EPN_UNUSED_TQ_CNT19_REG;
#define EPN_UNUSED_TQ_CNT19_REG_OFFSET 0x00000424

extern const ru_reg_rec EPN_UNUSED_TQ_CNT20_REG;
#define EPN_UNUSED_TQ_CNT20_REG_OFFSET 0x00000428

extern const ru_reg_rec EPN_UNUSED_TQ_CNT21_REG;
#define EPN_UNUSED_TQ_CNT21_REG_OFFSET 0x0000042c

extern const ru_reg_rec EPN_UNUSED_TQ_CNT22_REG;
#define EPN_UNUSED_TQ_CNT22_REG_OFFSET 0x00000430

extern const ru_reg_rec EPN_UNUSED_TQ_CNT23_REG;
#define EPN_UNUSED_TQ_CNT23_REG_OFFSET 0x00000434

extern const ru_reg_rec EPN_UNUSED_TQ_CNT24_REG;
#define EPN_UNUSED_TQ_CNT24_REG_OFFSET 0x00000438

extern const ru_reg_rec EPN_UNUSED_TQ_CNT25_REG;
#define EPN_UNUSED_TQ_CNT25_REG_OFFSET 0x0000043c

extern const ru_reg_rec EPN_UNUSED_TQ_CNT26_REG;
#define EPN_UNUSED_TQ_CNT26_REG_OFFSET 0x00000440

extern const ru_reg_rec EPN_UNUSED_TQ_CNT27_REG;
#define EPN_UNUSED_TQ_CNT27_REG_OFFSET 0x00000444

extern const ru_reg_rec EPN_UNUSED_TQ_CNT28_REG;
#define EPN_UNUSED_TQ_CNT28_REG_OFFSET 0x00000448

extern const ru_reg_rec EPN_UNUSED_TQ_CNT29_REG;
#define EPN_UNUSED_TQ_CNT29_REG_OFFSET 0x0000044c

extern const ru_reg_rec EPN_UNUSED_TQ_CNT30_REG;
#define EPN_UNUSED_TQ_CNT30_REG_OFFSET 0x00000450

extern const ru_reg_rec EPN_UNUSED_TQ_CNT31_REG;
#define EPN_UNUSED_TQ_CNT31_REG_OFFSET 0x00000454

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_8_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_8_REG_OFFSET 0x000005d8

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_9_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_9_REG_OFFSET 0x000005dc

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_10_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_10_REG_OFFSET 0x000005e0

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_11_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_11_REG_OFFSET 0x000005e4

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_12_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_12_REG_OFFSET 0x000005e8

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_13_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_13_REG_OFFSET 0x000005ec

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_14_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_14_REG_OFFSET 0x000005f0

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_15_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_15_REG_OFFSET 0x000005f4

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_16_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_16_REG_OFFSET 0x000005f8

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_17_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_17_REG_OFFSET 0x000005fc

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_18_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_18_REG_OFFSET 0x00000600

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_19_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_19_REG_OFFSET 0x00000604

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_20_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_20_REG_OFFSET 0x00000608

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_21_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_21_REG_OFFSET 0x0000060c

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_22_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_22_REG_OFFSET 0x00000610

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_23_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_23_REG_OFFSET 0x00000614

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_24_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_24_REG_OFFSET 0x00000618

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_25_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_25_REG_OFFSET 0x0000061c

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_26_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_26_REG_OFFSET 0x00000620

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_27_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_27_REG_OFFSET 0x00000624

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_28_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_28_REG_OFFSET 0x00000628

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_29_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_29_REG_OFFSET 0x0000062c

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_30_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_30_REG_OFFSET 0x00000630

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK_31_REG;
#define EPN_TX_L1S_SHP_QUE_MASK_31_REG_OFFSET 0x00000634

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_8_REG;
#define EPN_TX_L2S_QUE_CONFIG_8_REG_OFFSET 0x00000638

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_9_REG;
#define EPN_TX_L2S_QUE_CONFIG_9_REG_OFFSET 0x0000063c

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_10_REG;
#define EPN_TX_L2S_QUE_CONFIG_10_REG_OFFSET 0x00000640

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_11_REG;
#define EPN_TX_L2S_QUE_CONFIG_11_REG_OFFSET 0x00000644

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_12_REG;
#define EPN_TX_L2S_QUE_CONFIG_12_REG_OFFSET 0x00000648

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_13_REG;
#define EPN_TX_L2S_QUE_CONFIG_13_REG_OFFSET 0x0000064c

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_14_REG;
#define EPN_TX_L2S_QUE_CONFIG_14_REG_OFFSET 0x00000650

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_15_REG;
#define EPN_TX_L2S_QUE_CONFIG_15_REG_OFFSET 0x00000654

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_16_REG;
#define EPN_TX_L2S_QUE_CONFIG_16_REG_OFFSET 0x00000658

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_17_REG;
#define EPN_TX_L2S_QUE_CONFIG_17_REG_OFFSET 0x0000065c

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_18_REG;
#define EPN_TX_L2S_QUE_CONFIG_18_REG_OFFSET 0x00000660

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_19_REG;
#define EPN_TX_L2S_QUE_CONFIG_19_REG_OFFSET 0x00000664

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_20_REG;
#define EPN_TX_L2S_QUE_CONFIG_20_REG_OFFSET 0x00000668

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_21_REG;
#define EPN_TX_L2S_QUE_CONFIG_21_REG_OFFSET 0x0000066c

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_22_REG;
#define EPN_TX_L2S_QUE_CONFIG_22_REG_OFFSET 0x00000670

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_23_REG;
#define EPN_TX_L2S_QUE_CONFIG_23_REG_OFFSET 0x00000674

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_24_REG;
#define EPN_TX_L2S_QUE_CONFIG_24_REG_OFFSET 0x00000678

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_25_REG;
#define EPN_TX_L2S_QUE_CONFIG_25_REG_OFFSET 0x0000067c

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_26_REG;
#define EPN_TX_L2S_QUE_CONFIG_26_REG_OFFSET 0x00000680

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_27_REG;
#define EPN_TX_L2S_QUE_CONFIG_27_REG_OFFSET 0x00000684

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_28_REG;
#define EPN_TX_L2S_QUE_CONFIG_28_REG_OFFSET 0x00000688

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_29_REG;
#define EPN_TX_L2S_QUE_CONFIG_29_REG_OFFSET 0x0000068c

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_30_REG;
#define EPN_TX_L2S_QUE_CONFIG_30_REG_OFFSET 0x00000690

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG_31_REG;
#define EPN_TX_L2S_QUE_CONFIG_31_REG_OFFSET 0x00000694

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_8_REG;
#define EPN_TX_CTC_BURST_LIMIT_8_REG_OFFSET 0x00000698

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_9_REG;
#define EPN_TX_CTC_BURST_LIMIT_9_REG_OFFSET 0x0000069c

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_10_REG;
#define EPN_TX_CTC_BURST_LIMIT_10_REG_OFFSET 0x000006a0

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_11_REG;
#define EPN_TX_CTC_BURST_LIMIT_11_REG_OFFSET 0x000006a4

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_12_REG;
#define EPN_TX_CTC_BURST_LIMIT_12_REG_OFFSET 0x000006a8

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_13_REG;
#define EPN_TX_CTC_BURST_LIMIT_13_REG_OFFSET 0x000006ac

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_14_REG;
#define EPN_TX_CTC_BURST_LIMIT_14_REG_OFFSET 0x000006b0

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_15_REG;
#define EPN_TX_CTC_BURST_LIMIT_15_REG_OFFSET 0x000006b4

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_16_REG;
#define EPN_TX_CTC_BURST_LIMIT_16_REG_OFFSET 0x000006b8

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_17_REG;
#define EPN_TX_CTC_BURST_LIMIT_17_REG_OFFSET 0x000006bc

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_18_REG;
#define EPN_TX_CTC_BURST_LIMIT_18_REG_OFFSET 0x000006c0

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_19_REG;
#define EPN_TX_CTC_BURST_LIMIT_19_REG_OFFSET 0x000006c4

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_20_REG;
#define EPN_TX_CTC_BURST_LIMIT_20_REG_OFFSET 0x000006c8

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_21_REG;
#define EPN_TX_CTC_BURST_LIMIT_21_REG_OFFSET 0x000006cc

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_22_REG;
#define EPN_TX_CTC_BURST_LIMIT_22_REG_OFFSET 0x000006d0

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_23_REG;
#define EPN_TX_CTC_BURST_LIMIT_23_REG_OFFSET 0x000006d4

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_24_REG;
#define EPN_TX_CTC_BURST_LIMIT_24_REG_OFFSET 0x000006d8

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_25_REG;
#define EPN_TX_CTC_BURST_LIMIT_25_REG_OFFSET 0x000006dc

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_26_REG;
#define EPN_TX_CTC_BURST_LIMIT_26_REG_OFFSET 0x000006e0

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_27_REG;
#define EPN_TX_CTC_BURST_LIMIT_27_REG_OFFSET 0x000006e4

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_28_REG;
#define EPN_TX_CTC_BURST_LIMIT_28_REG_OFFSET 0x000006e8

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_29_REG;
#define EPN_TX_CTC_BURST_LIMIT_29_REG_OFFSET 0x000006ec

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_30_REG;
#define EPN_TX_CTC_BURST_LIMIT_30_REG_OFFSET 0x000006f0

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT_31_REG;
#define EPN_TX_CTC_BURST_LIMIT_31_REG_OFFSET 0x000006f4

extern const ru_reg_rec EPN_10G_ABC_SIZE0_REG;
#define EPN_10G_ABC_SIZE0_REG_OFFSET 0x000006f8

extern const ru_reg_rec EPN_10G_ABC_SIZE1_REG;
#define EPN_10G_ABC_SIZE1_REG_OFFSET 0x000006fc

extern const ru_reg_rec EPN_10G_ABC_SIZE2_REG;
#define EPN_10G_ABC_SIZE2_REG_OFFSET 0x00000700

extern const ru_reg_rec EPN_10G_ABC_SIZE3_REG;
#define EPN_10G_ABC_SIZE3_REG_OFFSET 0x00000704

extern const ru_reg_rec EPN_10G_ABC_SIZE4_REG;
#define EPN_10G_ABC_SIZE4_REG_OFFSET 0x00000708

extern const ru_reg_rec EPN_10G_ABC_SIZE5_REG;
#define EPN_10G_ABC_SIZE5_REG_OFFSET 0x0000070c

extern const ru_reg_rec EPN_10G_ABC_SIZE6_REG;
#define EPN_10G_ABC_SIZE6_REG_OFFSET 0x00000710

extern const ru_reg_rec EPN_10G_ABC_SIZE7_REG;
#define EPN_10G_ABC_SIZE7_REG_OFFSET 0x00000714

extern const ru_reg_rec EPN_10G_ABC_SIZE8_REG;
#define EPN_10G_ABC_SIZE8_REG_OFFSET 0x00000718

extern const ru_reg_rec EPN_10G_ABC_SIZE9_REG;
#define EPN_10G_ABC_SIZE9_REG_OFFSET 0x0000071c

extern const ru_reg_rec EPN_10G_ABC_SIZE10_REG;
#define EPN_10G_ABC_SIZE10_REG_OFFSET 0x00000720

extern const ru_reg_rec EPN_10G_ABC_SIZE11_REG;
#define EPN_10G_ABC_SIZE11_REG_OFFSET 0x00000724

extern const ru_reg_rec EPN_10G_ABC_SIZE12_REG;
#define EPN_10G_ABC_SIZE12_REG_OFFSET 0x00000728

extern const ru_reg_rec EPN_10G_ABC_SIZE13_REG;
#define EPN_10G_ABC_SIZE13_REG_OFFSET 0x0000072c

extern const ru_reg_rec EPN_10G_ABC_SIZE14_REG;
#define EPN_10G_ABC_SIZE14_REG_OFFSET 0x00000730

extern const ru_reg_rec EPN_10G_ABC_SIZE15_REG;
#define EPN_10G_ABC_SIZE15_REG_OFFSET 0x00000734

extern const ru_reg_rec EPN_10G_ABC_SIZE16_REG;
#define EPN_10G_ABC_SIZE16_REG_OFFSET 0x00000738

extern const ru_reg_rec EPN_10G_ABC_SIZE17_REG;
#define EPN_10G_ABC_SIZE17_REG_OFFSET 0x0000073c

extern const ru_reg_rec EPN_10G_ABC_SIZE18_REG;
#define EPN_10G_ABC_SIZE18_REG_OFFSET 0x00000740

extern const ru_reg_rec EPN_10G_ABC_SIZE19_REG;
#define EPN_10G_ABC_SIZE19_REG_OFFSET 0x00000744

extern const ru_reg_rec EPN_10G_ABC_SIZE20_REG;
#define EPN_10G_ABC_SIZE20_REG_OFFSET 0x00000748

extern const ru_reg_rec EPN_10G_ABC_SIZE21_REG;
#define EPN_10G_ABC_SIZE21_REG_OFFSET 0x0000074c

extern const ru_reg_rec EPN_10G_ABC_SIZE22_REG;
#define EPN_10G_ABC_SIZE22_REG_OFFSET 0x00000750

extern const ru_reg_rec EPN_10G_ABC_SIZE23_REG;
#define EPN_10G_ABC_SIZE23_REG_OFFSET 0x00000754

extern const ru_reg_rec EPN_10G_ABC_SIZE24_REG;
#define EPN_10G_ABC_SIZE24_REG_OFFSET 0x00000758

extern const ru_reg_rec EPN_10G_ABC_SIZE25_REG;
#define EPN_10G_ABC_SIZE25_REG_OFFSET 0x0000075c

extern const ru_reg_rec EPN_10G_ABC_SIZE26_REG;
#define EPN_10G_ABC_SIZE26_REG_OFFSET 0x00000760

extern const ru_reg_rec EPN_10G_ABC_SIZE27_REG;
#define EPN_10G_ABC_SIZE27_REG_OFFSET 0x00000764

extern const ru_reg_rec EPN_10G_ABC_SIZE28_REG;
#define EPN_10G_ABC_SIZE28_REG_OFFSET 0x00000768

extern const ru_reg_rec EPN_10G_ABC_SIZE29_REG;
#define EPN_10G_ABC_SIZE29_REG_OFFSET 0x0000076c

extern const ru_reg_rec EPN_10G_ABC_SIZE30_REG;
#define EPN_10G_ABC_SIZE30_REG_OFFSET 0x00000770

extern const ru_reg_rec EPN_10G_ABC_SIZE31_REG;
#define EPN_10G_ABC_SIZE31_REG_OFFSET 0x00000774

extern const ru_reg_rec EPN_10G_ABC_SIZE32_REG;
#define EPN_10G_ABC_SIZE32_REG_OFFSET 0x00000778

extern const ru_reg_rec EPN_10G_ABC_SIZE33_REG;
#define EPN_10G_ABC_SIZE33_REG_OFFSET 0x0000077c

extern const ru_reg_rec EPN_10G_ABC_SIZE34_REG;
#define EPN_10G_ABC_SIZE34_REG_OFFSET 0x00000780

extern const ru_reg_rec EPN_10G_ABC_SIZE35_REG;
#define EPN_10G_ABC_SIZE35_REG_OFFSET 0x00000784

extern const ru_reg_rec EPN_10G_ABC_SIZE36_REG;
#define EPN_10G_ABC_SIZE36_REG_OFFSET 0x00000788

extern const ru_reg_rec EPN_10G_ABC_SIZE37_REG;
#define EPN_10G_ABC_SIZE37_REG_OFFSET 0x0000078c

extern const ru_reg_rec EPN_10G_ABC_SIZE38_REG;
#define EPN_10G_ABC_SIZE38_REG_OFFSET 0x00000790

extern const ru_reg_rec EPN_10G_ABC_SIZE39_REG;
#define EPN_10G_ABC_SIZE39_REG_OFFSET 0x00000794

extern const ru_reg_rec EPN_10G_ABC_SIZE40_REG;
#define EPN_10G_ABC_SIZE40_REG_OFFSET 0x00000798

extern const ru_reg_rec EPN_10G_ABC_SIZE41_REG;
#define EPN_10G_ABC_SIZE41_REG_OFFSET 0x0000079c

extern const ru_reg_rec EPN_10G_ABC_SIZE42_REG;
#define EPN_10G_ABC_SIZE42_REG_OFFSET 0x000007a0

extern const ru_reg_rec EPN_10G_ABC_SIZE43_REG;
#define EPN_10G_ABC_SIZE43_REG_OFFSET 0x000007a4

extern const ru_reg_rec EPN_10G_ABC_SIZE44_REG;
#define EPN_10G_ABC_SIZE44_REG_OFFSET 0x000007a8

extern const ru_reg_rec EPN_10G_ABC_SIZE45_REG;
#define EPN_10G_ABC_SIZE45_REG_OFFSET 0x000007ac

extern const ru_reg_rec EPN_10G_ABC_SIZE46_REG;
#define EPN_10G_ABC_SIZE46_REG_OFFSET 0x000007b0

extern const ru_reg_rec EPN_10G_ABC_SIZE47_REG;
#define EPN_10G_ABC_SIZE47_REG_OFFSET 0x000007b4

extern const ru_reg_rec LIF_PON_CONTROL_REG;
#define LIF_PON_CONTROL_REG_OFFSET 0x00000000

extern const ru_reg_rec LIF_PON_INTER_OP_CONTROL_REG;
#define LIF_PON_INTER_OP_CONTROL_REG_OFFSET 0x00000004

extern const ru_reg_rec LIF_FEC_CONTROL_REG;
#define LIF_FEC_CONTROL_REG_OFFSET 0x00000008

extern const ru_reg_rec LIF_SEC_CONTROL_REG;
#define LIF_SEC_CONTROL_REG_OFFSET 0x0000000c

extern const ru_reg_rec LIF_MACSEC_REG;
#define LIF_MACSEC_REG_OFFSET 0x00000010

extern const ru_reg_rec LIF_INT_STATUS_REG;
#define LIF_INT_STATUS_REG_OFFSET 0x00000014

extern const ru_reg_rec LIF_INT_MASK_REG;
#define LIF_INT_MASK_REG_OFFSET 0x00000018

extern const ru_reg_rec LIF_DATA_PORT_COMMAND_REG;
#define LIF_DATA_PORT_COMMAND_REG_OFFSET 0x0000001c

extern const ru_reg_rec LIF_DATA_PORT_DATA_REG;
#define LIF_DATA_PORT_DATA_REG_OFFSET 0x00000020

#define LIF_DATA_PORT_DATA_REG_RAM_CNT 0x00000007

extern const ru_reg_rec LIF_LLID_0_REG;
#define LIF_LLID_0_REG_OFFSET 0x00000040

extern const ru_reg_rec LIF_LLID_1_REG;
#define LIF_LLID_1_REG_OFFSET 0x00000044

extern const ru_reg_rec LIF_LLID_2_REG;
#define LIF_LLID_2_REG_OFFSET 0x00000048

extern const ru_reg_rec LIF_LLID_3_REG;
#define LIF_LLID_3_REG_OFFSET 0x0000004c

extern const ru_reg_rec LIF_LLID_4_REG;
#define LIF_LLID_4_REG_OFFSET 0x00000050

extern const ru_reg_rec LIF_LLID_5_REG;
#define LIF_LLID_5_REG_OFFSET 0x00000054

extern const ru_reg_rec LIF_LLID_6_REG;
#define LIF_LLID_6_REG_OFFSET 0x00000058

extern const ru_reg_rec LIF_LLID_7_REG;
#define LIF_LLID_7_REG_OFFSET 0x0000005c

extern const ru_reg_rec LIF_LLID_16_REG;
#define LIF_LLID_16_REG_OFFSET 0x00000060

extern const ru_reg_rec LIF_LLID_17_REG;
#define LIF_LLID_17_REG_OFFSET 0x00000064

extern const ru_reg_rec LIF_LLID_18_REG;
#define LIF_LLID_18_REG_OFFSET 0x00000068

extern const ru_reg_rec LIF_LLID_19_REG;
#define LIF_LLID_19_REG_OFFSET 0x0000006c

extern const ru_reg_rec LIF_LLID_20_REG;
#define LIF_LLID_20_REG_OFFSET 0x00000070

extern const ru_reg_rec LIF_LLID_21_REG;
#define LIF_LLID_21_REG_OFFSET 0x00000074

extern const ru_reg_rec LIF_LLID_22_REG;
#define LIF_LLID_22_REG_OFFSET 0x00000078

extern const ru_reg_rec LIF_LLID_23_REG;
#define LIF_LLID_23_REG_OFFSET 0x0000007c

extern const ru_reg_rec LIF_TIME_REF_CNT_REG;
#define LIF_TIME_REF_CNT_REG_OFFSET 0x00000080

extern const ru_reg_rec LIF_TIMESTAMP_UPD_PER_REG;
#define LIF_TIMESTAMP_UPD_PER_REG_OFFSET 0x00000084

extern const ru_reg_rec LIF_TP_TIME_REG;
#define LIF_TP_TIME_REG_OFFSET 0x00000088

extern const ru_reg_rec LIF_MPCP_TIME_REG;
#define LIF_MPCP_TIME_REG_OFFSET 0x0000008c

extern const ru_reg_rec LIF_MAXLEN_CTR_REG;
#define LIF_MAXLEN_CTR_REG_OFFSET 0x00000090

extern const ru_reg_rec LIF_LASER_ON_DELTA_REG;
#define LIF_LASER_ON_DELTA_REG_OFFSET 0x00000094

extern const ru_reg_rec LIF_LASER_OFF_IDLE_REG;
#define LIF_LASER_OFF_IDLE_REG_OFFSET 0x00000098

extern const ru_reg_rec LIF_FEC_INIT_IDLE_REG;
#define LIF_FEC_INIT_IDLE_REG_OFFSET 0x0000009c

extern const ru_reg_rec LIF_FEC_ERR_ALLOW_REG;
#define LIF_FEC_ERR_ALLOW_REG_OFFSET 0x000000a0

extern const ru_reg_rec LIF_SEC_KEY_SEL_REG;
#define LIF_SEC_KEY_SEL_REG_OFFSET 0x000000a4

extern const ru_reg_rec LIF_DN_ENCRYPT_STAT_REG;
#define LIF_DN_ENCRYPT_STAT_REG_OFFSET 0x000000a8

extern const ru_reg_rec LIF_SEC_UP_KEY_STAT_REG;
#define LIF_SEC_UP_KEY_STAT_REG_OFFSET 0x000000ac

extern const ru_reg_rec LIF_SEC_UP_ENCRYPT_STAT_REG;
#define LIF_SEC_UP_ENCRYPT_STAT_REG_OFFSET 0x000000b0

extern const ru_reg_rec LIF_SEC_UP_MPCP_OFFSET_REG;
#define LIF_SEC_UP_MPCP_OFFSET_REG_OFFSET 0x000000b4

extern const ru_reg_rec LIF_FEC_PER_LLID_REG;
#define LIF_FEC_PER_LLID_REG_OFFSET 0x000000b8

extern const ru_reg_rec LIF_RX_LINE_CODE_ERR_CNT_REG;
#define LIF_RX_LINE_CODE_ERR_CNT_REG_OFFSET 0x000000bc

extern const ru_reg_rec LIF_RX_AGG_MPCP_FRM_REG;
#define LIF_RX_AGG_MPCP_FRM_REG_OFFSET 0x000000c0

extern const ru_reg_rec LIF_RX_AGG_GOOD_FRM_REG;
#define LIF_RX_AGG_GOOD_FRM_REG_OFFSET 0x000000c4

extern const ru_reg_rec LIF_RX_AGG_GOOD_BYTE_REG;
#define LIF_RX_AGG_GOOD_BYTE_REG_OFFSET 0x000000c8

extern const ru_reg_rec LIF_RX_AGG_UNDERSZ_FRM_REG;
#define LIF_RX_AGG_UNDERSZ_FRM_REG_OFFSET 0x000000cc

extern const ru_reg_rec LIF_RX_AGG_OVERSZ_FRM_REG;
#define LIF_RX_AGG_OVERSZ_FRM_REG_OFFSET 0x000000d0

extern const ru_reg_rec LIF_RX_AGG_CRC8_FRM_REG;
#define LIF_RX_AGG_CRC8_FRM_REG_OFFSET 0x000000d4

extern const ru_reg_rec LIF_RX_AGG_FEC_FRM_REG;
#define LIF_RX_AGG_FEC_FRM_REG_OFFSET 0x000000d8

extern const ru_reg_rec LIF_RX_AGG_FEC_BYTE_REG;
#define LIF_RX_AGG_FEC_BYTE_REG_OFFSET 0x000000dc

extern const ru_reg_rec LIF_RX_AGG_FEC_EXC_ERR_FRM_REG;
#define LIF_RX_AGG_FEC_EXC_ERR_FRM_REG_OFFSET 0x000000e0

extern const ru_reg_rec LIF_RX_AGG_NONFEC_GOOD_FRM_REG;
#define LIF_RX_AGG_NONFEC_GOOD_FRM_REG_OFFSET 0x000000e4

extern const ru_reg_rec LIF_RX_AGG_NONFEC_GOOD_BYTE_REG;
#define LIF_RX_AGG_NONFEC_GOOD_BYTE_REG_OFFSET 0x000000e8

extern const ru_reg_rec LIF_RX_AGG_ERR_BYTES_REG;
#define LIF_RX_AGG_ERR_BYTES_REG_OFFSET 0x000000ec

extern const ru_reg_rec LIF_RX_AGG_ERR_ZEROES_REG;
#define LIF_RX_AGG_ERR_ZEROES_REG_OFFSET 0x000000f0

extern const ru_reg_rec LIF_RX_AGG_NO_ERR_BLKS_REG;
#define LIF_RX_AGG_NO_ERR_BLKS_REG_OFFSET 0x000000f4

extern const ru_reg_rec LIF_RX_AGG_COR_BLKS_REG;
#define LIF_RX_AGG_COR_BLKS_REG_OFFSET 0x000000f8

extern const ru_reg_rec LIF_RX_AGG_UNCOR_BLKS_REG;
#define LIF_RX_AGG_UNCOR_BLKS_REG_OFFSET 0x000000fc

extern const ru_reg_rec LIF_RX_AGG_ERR_ONES_REG;
#define LIF_RX_AGG_ERR_ONES_REG_OFFSET 0x00000100

extern const ru_reg_rec LIF_RX_AGG_ERR_FRM_REG;
#define LIF_RX_AGG_ERR_FRM_REG_OFFSET 0x00000104

extern const ru_reg_rec LIF_TX_PKT_CNT_REG;
#define LIF_TX_PKT_CNT_REG_OFFSET 0x00000108

extern const ru_reg_rec LIF_TX_BYTE_CNT_REG;
#define LIF_TX_BYTE_CNT_REG_OFFSET 0x0000010c

extern const ru_reg_rec LIF_TX_NON_FEC_PKT_CNT_REG;
#define LIF_TX_NON_FEC_PKT_CNT_REG_OFFSET 0x00000110

extern const ru_reg_rec LIF_TX_NON_FEC_BYTE_CNT_REG;
#define LIF_TX_NON_FEC_BYTE_CNT_REG_OFFSET 0x00000114

extern const ru_reg_rec LIF_TX_FEC_PKT_CNT_REG;
#define LIF_TX_FEC_PKT_CNT_REG_OFFSET 0x00000118

extern const ru_reg_rec LIF_TX_FEC_BYTE_CNT_REG;
#define LIF_TX_FEC_BYTE_CNT_REG_OFFSET 0x0000011c

extern const ru_reg_rec LIF_TX_FEC_BLK_CNT_REG;
#define LIF_TX_FEC_BLK_CNT_REG_OFFSET 0x00000120

extern const ru_reg_rec LIF_TX_MPCP_PKT_CNT_REG;
#define LIF_TX_MPCP_PKT_CNT_REG_OFFSET 0x00000124

extern const ru_reg_rec LIF_DEBUG_TX_DATA_PKT_CNT_REG;
#define LIF_DEBUG_TX_DATA_PKT_CNT_REG_OFFSET 0x00000128

extern const ru_reg_rec LIF_FEC_LLID_STATUS_REG;
#define LIF_FEC_LLID_STATUS_REG_OFFSET 0x0000012c

extern const ru_reg_rec LIF_SEC_RX_TEK_IG_IV_LLID_REG;
#define LIF_SEC_RX_TEK_IG_IV_LLID_REG_OFFSET 0x00000130

extern const ru_reg_rec LIF_PON_BER_INTERV_THRESH_REG;
#define LIF_PON_BER_INTERV_THRESH_REG_OFFSET 0x00000134

extern const ru_reg_rec LIF_LSR_MON_A_CTRL_REG;
#define LIF_LSR_MON_A_CTRL_REG_OFFSET 0x00000138

extern const ru_reg_rec LIF_LSR_MON_A_MAX_THR_REG;
#define LIF_LSR_MON_A_MAX_THR_REG_OFFSET 0x0000013c

extern const ru_reg_rec LIF_LSR_MON_A_BST_LEN_REG;
#define LIF_LSR_MON_A_BST_LEN_REG_OFFSET 0x00000140

extern const ru_reg_rec LIF_LSR_MON_A_BST_CNT_REG;
#define LIF_LSR_MON_A_BST_CNT_REG_OFFSET 0x00000144

extern const ru_reg_rec LIF_DEBUG_PON_SM_REG;
#define LIF_DEBUG_PON_SM_REG_OFFSET 0x00000148

extern const ru_reg_rec LIF_DEBUG_FEC_SM_REG;
#define LIF_DEBUG_FEC_SM_REG_OFFSET 0x0000014c

extern const ru_reg_rec LIF_AE_PKTNUM_WINDOW_REG;
#define LIF_AE_PKTNUM_WINDOW_REG_OFFSET 0x00000150

extern const ru_reg_rec LIF_AE_PKTNUM_THRESH_REG;
#define LIF_AE_PKTNUM_THRESH_REG_OFFSET 0x00000154

extern const ru_reg_rec LIF_AE_PKTNUM_STAT_REG;
#define LIF_AE_PKTNUM_STAT_REG_OFFSET 0x00000158

extern const ru_reg_rec LIF_LLID_8_REG;
#define LIF_LLID_8_REG_OFFSET 0x0000015c

extern const ru_reg_rec LIF_LLID_9_REG;
#define LIF_LLID_9_REG_OFFSET 0x00000160

extern const ru_reg_rec LIF_LLID_10_REG;
#define LIF_LLID_10_REG_OFFSET 0x00000164

extern const ru_reg_rec LIF_LLID_11_REG;
#define LIF_LLID_11_REG_OFFSET 0x00000168

extern const ru_reg_rec LIF_LLID_12_REG;
#define LIF_LLID_12_REG_OFFSET 0x0000016c

extern const ru_reg_rec LIF_LLID_13_REG;
#define LIF_LLID_13_REG_OFFSET 0x00000170

extern const ru_reg_rec LIF_LLID_14_REG;
#define LIF_LLID_14_REG_OFFSET 0x00000174

extern const ru_reg_rec LIF_LLID_15_REG;
#define LIF_LLID_15_REG_OFFSET 0x00000178

extern const ru_reg_rec LIF_LLID_24_REG;
#define LIF_LLID_24_REG_OFFSET 0x0000017c

extern const ru_reg_rec LIF_LLID_25_REG;
#define LIF_LLID_25_REG_OFFSET 0x00000180

extern const ru_reg_rec LIF_LLID_26_REG;
#define LIF_LLID_26_REG_OFFSET 0x00000184

extern const ru_reg_rec LIF_LLID_27_REG;
#define LIF_LLID_27_REG_OFFSET 0x00000188

extern const ru_reg_rec LIF_LLID_28_REG;
#define LIF_LLID_28_REG_OFFSET 0x0000018c

extern const ru_reg_rec LIF_LLID_29_REG;
#define LIF_LLID_29_REG_OFFSET 0x00000190

extern const ru_reg_rec LIF_LLID_30_REG;
#define LIF_LLID_30_REG_OFFSET 0x00000194

extern const ru_reg_rec LIF_LLID_31_REG;
#define LIF_LLID_31_REG_OFFSET 0x00000198

extern const ru_reg_rec LIF_VLAN_TYPE_REG;
#define LIF_VLAN_TYPE_REG_OFFSET 0x0000019c

extern const ru_reg_rec LIF_P2P_AE_SCI_EN_REG;
#define LIF_P2P_AE_SCI_EN_REG_OFFSET 0x000001a0

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_0_REG;
#define LIF_P2P_AE_SCI_LO_0_REG_OFFSET 0x000001a4

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_0_REG;
#define LIF_P2P_AE_SCI_HI_0_REG_OFFSET 0x000001a8

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_1_REG;
#define LIF_P2P_AE_SCI_LO_1_REG_OFFSET 0x000001ac

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_1_REG;
#define LIF_P2P_AE_SCI_HI_1_REG_OFFSET 0x000001b0

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_2_REG;
#define LIF_P2P_AE_SCI_LO_2_REG_OFFSET 0x000001b4

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_2_REG;
#define LIF_P2P_AE_SCI_HI_2_REG_OFFSET 0x000001b8

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_3_REG;
#define LIF_P2P_AE_SCI_LO_3_REG_OFFSET 0x000001bc

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_3_REG;
#define LIF_P2P_AE_SCI_HI_3_REG_OFFSET 0x000001c0

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_4_REG;
#define LIF_P2P_AE_SCI_LO_4_REG_OFFSET 0x000001c4

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_4_REG;
#define LIF_P2P_AE_SCI_HI_4_REG_OFFSET 0x000001c8

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_5_REG;
#define LIF_P2P_AE_SCI_LO_5_REG_OFFSET 0x000001cc

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_5_REG;
#define LIF_P2P_AE_SCI_HI_5_REG_OFFSET 0x000001d0

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_6_REG;
#define LIF_P2P_AE_SCI_LO_6_REG_OFFSET 0x000001d4

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_6_REG;
#define LIF_P2P_AE_SCI_HI_6_REG_OFFSET 0x000001d8

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_7_REG;
#define LIF_P2P_AE_SCI_LO_7_REG_OFFSET 0x000001dc

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_7_REG;
#define LIF_P2P_AE_SCI_HI_7_REG_OFFSET 0x000001e0

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_8_REG;
#define LIF_P2P_AE_SCI_LO_8_REG_OFFSET 0x000001e4

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_8_REG;
#define LIF_P2P_AE_SCI_HI_8_REG_OFFSET 0x000001e8

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_9_REG;
#define LIF_P2P_AE_SCI_LO_9_REG_OFFSET 0x000001ec

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_9_REG;
#define LIF_P2P_AE_SCI_HI_9_REG_OFFSET 0x000001f0

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_10_REG;
#define LIF_P2P_AE_SCI_LO_10_REG_OFFSET 0x000001f4

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_10_REG;
#define LIF_P2P_AE_SCI_HI_10_REG_OFFSET 0x000001f8

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_11_REG;
#define LIF_P2P_AE_SCI_LO_11_REG_OFFSET 0x000001fc

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_11_REG;
#define LIF_P2P_AE_SCI_HI_11_REG_OFFSET 0x00000200

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_12_REG;
#define LIF_P2P_AE_SCI_LO_12_REG_OFFSET 0x00000204

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_12_REG;
#define LIF_P2P_AE_SCI_HI_12_REG_OFFSET 0x00000208

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_13_REG;
#define LIF_P2P_AE_SCI_LO_13_REG_OFFSET 0x0000020c

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_13_REG;
#define LIF_P2P_AE_SCI_HI_13_REG_OFFSET 0x00000210

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_14_REG;
#define LIF_P2P_AE_SCI_LO_14_REG_OFFSET 0x00000214

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_14_REG;
#define LIF_P2P_AE_SCI_HI_14_REG_OFFSET 0x00000218

extern const ru_reg_rec LIF_P2P_AE_SCI_LO_15_REG;
#define LIF_P2P_AE_SCI_LO_15_REG_OFFSET 0x0000021c

extern const ru_reg_rec LIF_P2P_AE_SCI_HI_15_REG;
#define LIF_P2P_AE_SCI_HI_15_REG_OFFSET 0x00000220

extern const ru_reg_rec LIF_SEC_UP_KEY_STAT_1_REG;
#define LIF_SEC_UP_KEY_STAT_1_REG_OFFSET 0x00000224

extern const ru_reg_rec LIF_SEC_KEY_SEL_1_REG;
#define LIF_SEC_KEY_SEL_1_REG_OFFSET 0x00000228

extern const ru_reg_rec LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_REG;
#define LIF_PON_SEC_TX_PLAINTXT_AE_PAD_CONTROL_REG_OFFSET 0x0000022c

extern const ru_reg_rec LIF_P2P_AUTONEG_CONTROL_REG;
#define LIF_P2P_AUTONEG_CONTROL_REG_OFFSET 0x00000230

extern const ru_reg_rec LIF_P2P_AUTONEG_STATUS_REG;
#define LIF_P2P_AUTONEG_STATUS_REG_OFFSET 0x00000234

extern const ru_reg_rec LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_REG;
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_REG_OFFSET 0x00000238

extern const ru_reg_rec LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_REG;
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_REG_OFFSET 0x0000023c

extern const ru_reg_rec NCO_ADDR_NCO_CFG_REG;
#define NCO_ADDR_NCO_CFG_REG_OFFSET 0x00000000

extern const ru_reg_rec NCO_ADDR_NCO_INT_REG;
#define NCO_ADDR_NCO_INT_REG_OFFSET 0x00000004

extern const ru_reg_rec NCO_ADDR_NCO_MSK_REG;
#define NCO_ADDR_NCO_MSK_REG_OFFSET 0x00000008

extern const ru_reg_rec NCO_ADDR_NCO_1PPS_PERIOD_REG;
#define NCO_ADDR_NCO_1PPS_PERIOD_REG_OFFSET 0x0000000c

extern const ru_reg_rec NCO_ADDR_NCO_8KHZ_PERIOD_REG;
#define NCO_ADDR_NCO_8KHZ_PERIOD_REG_OFFSET 0x00000010

extern const ru_reg_rec NCO_ADDR_NCO_CENTER_FREQUENCY_REG;
#define NCO_ADDR_NCO_CENTER_FREQUENCY_REG_OFFSET 0x00000014

extern const ru_reg_rec NCO_ADDR_NCO_INT_GAIN_REG;
#define NCO_ADDR_NCO_INT_GAIN_REG_OFFSET 0x00000018

extern const ru_reg_rec NCO_ADDR_NCO_PRO_GAIN_REG;
#define NCO_ADDR_NCO_PRO_GAIN_REG_OFFSET 0x0000001c

extern const ru_reg_rec NCO_ADDR_NCO_CNT_REG;
#define NCO_ADDR_NCO_CNT_REG_OFFSET 0x00000020

extern const ru_reg_rec NCO_ADDR_NCO_1PPS_HALF_REG;
#define NCO_ADDR_NCO_1PPS_HALF_REG_OFFSET 0x00000024

extern const ru_reg_rec NCO_ADDR_NCO_8KHZ_HALF_REG;
#define NCO_ADDR_NCO_8KHZ_HALF_REG_OFFSET 0x00000028

extern const ru_reg_rec NCO_ADDR_NCO_PERIOD_CNT_REG;
#define NCO_ADDR_NCO_PERIOD_CNT_REG_OFFSET 0x0000002c

extern const ru_reg_rec NCO_ADDR_NCO_PHS_ERR_CNT_REG;
#define NCO_ADDR_NCO_PHS_ERR_CNT_REG_OFFSET 0x00000030

extern const ru_reg_rec XIF_CTL_REG;
#define XIF_CTL_REG_OFFSET 0x00000000

extern const ru_reg_rec XIF_INT_STATUS_REG;
#define XIF_INT_STATUS_REG_OFFSET 0x00000004

extern const ru_reg_rec XIF_INT_MASK_REG;
#define XIF_INT_MASK_REG_OFFSET 0x00000008

extern const ru_reg_rec XIF_PORT_COMMAND_REG;
#define XIF_PORT_COMMAND_REG_OFFSET 0x0000000c

extern const ru_reg_rec XIF_PORT_DATA__REG;
#define XIF_PORT_DATA__REG_OFFSET 0x00000014

#define XIF_PORT_DATA__REG_RAM_CNT 0x00000007

extern const ru_reg_rec XIF_MACSEC_REG;
#define XIF_MACSEC_REG_OFFSET 0x00000034

extern const ru_reg_rec XIF_XPN_XMT_OFFSET_REG;
#define XIF_XPN_XMT_OFFSET_REG_OFFSET 0x00000038

extern const ru_reg_rec XIF_XPN_TIMESTAMP_OFFSET_REG;
#define XIF_XPN_TIMESTAMP_OFFSET_REG_OFFSET 0x0000003c

extern const ru_reg_rec XIF_XPN_PKTGEN_CTL_REG;
#define XIF_XPN_PKTGEN_CTL_REG_OFFSET 0x00000040

extern const ru_reg_rec XIF_XPN_PKTGEN_LLID_REG;
#define XIF_XPN_PKTGEN_LLID_REG_OFFSET 0x00000044

extern const ru_reg_rec XIF_XPN_PKTGEN_PKT_CNT_REG;
#define XIF_XPN_PKTGEN_PKT_CNT_REG_OFFSET 0x00000048

extern const ru_reg_rec XIF_XPN_PKTGEN_PKT_SIZE_REG;
#define XIF_XPN_PKTGEN_PKT_SIZE_REG_OFFSET 0x0000004c

extern const ru_reg_rec XIF_XPN_PKTGEN_IPG_REG;
#define XIF_XPN_PKTGEN_IPG_REG_OFFSET 0x00000050

extern const ru_reg_rec XIF_TS_JITTER_THRESH_REG;
#define XIF_TS_JITTER_THRESH_REG_OFFSET 0x00000054

extern const ru_reg_rec XIF_TS_UPDATE_REG;
#define XIF_TS_UPDATE_REG_OFFSET 0x00000058

extern const ru_reg_rec XIF_GNT_OVERHEAD_REG;
#define XIF_GNT_OVERHEAD_REG_OFFSET 0x0000005c

extern const ru_reg_rec XIF_DISCOVER_OVERHEAD_REG;
#define XIF_DISCOVER_OVERHEAD_REG_OFFSET 0x00000060

extern const ru_reg_rec XIF_DISCOVER_INFO_REG;
#define XIF_DISCOVER_INFO_REG_OFFSET 0x00000064

extern const ru_reg_rec XIF_XPN_OVERSIZE_THRESH_REG;
#define XIF_XPN_OVERSIZE_THRESH_REG_OFFSET 0x00000068

extern const ru_reg_rec XIF_SECRX_KEYNUM_REG;
#define XIF_SECRX_KEYNUM_REG_OFFSET 0x0000006c

extern const ru_reg_rec XIF_SECRX_ENCRYPT_REG;
#define XIF_SECRX_ENCRYPT_REG_OFFSET 0x00000070

extern const ru_reg_rec XIF_PMC_FRAME_RX_CNT_REG;
#define XIF_PMC_FRAME_RX_CNT_REG_OFFSET 0x00000078

extern const ru_reg_rec XIF_PMC_BYTE_RX_CNT_REG;
#define XIF_PMC_BYTE_RX_CNT_REG_OFFSET 0x0000007c

extern const ru_reg_rec XIF_PMC_RUNT_RX_CNT_REG;
#define XIF_PMC_RUNT_RX_CNT_REG_OFFSET 0x00000080

extern const ru_reg_rec XIF_PMC_CW_ERR_RX_CNT_REG;
#define XIF_PMC_CW_ERR_RX_CNT_REG_OFFSET 0x00000084

extern const ru_reg_rec XIF_PMC_CRC8_ERR_RX_CNT_REG;
#define XIF_PMC_CRC8_ERR_RX_CNT_REG_OFFSET 0x00000088

extern const ru_reg_rec XIF_XPN_DATA_FRM_CNT_REG;
#define XIF_XPN_DATA_FRM_CNT_REG_OFFSET 0x0000008c

extern const ru_reg_rec XIF_XPN_DATA_BYTE_CNT_REG;
#define XIF_XPN_DATA_BYTE_CNT_REG_OFFSET 0x00000090

extern const ru_reg_rec XIF_XPN_MPCP_FRM_CNT_REG;
#define XIF_XPN_MPCP_FRM_CNT_REG_OFFSET 0x00000094

extern const ru_reg_rec XIF_XPN_OAM_FRM_CNT_REG;
#define XIF_XPN_OAM_FRM_CNT_REG_OFFSET 0x00000098

extern const ru_reg_rec XIF_XPN_OAM_BYTE_CNT_REG;
#define XIF_XPN_OAM_BYTE_CNT_REG_OFFSET 0x0000009c

extern const ru_reg_rec XIF_XPN_OVERSIZE_FRM_CNT_REG;
#define XIF_XPN_OVERSIZE_FRM_CNT_REG_OFFSET 0x000000a0

extern const ru_reg_rec XIF_SEC_ABORT_FRM_CNT_REG;
#define XIF_SEC_ABORT_FRM_CNT_REG_OFFSET 0x000000a4

extern const ru_reg_rec XIF_PMC_TX_NEG_EVENT_CNT_REG;
#define XIF_PMC_TX_NEG_EVENT_CNT_REG_OFFSET 0x000000a8

extern const ru_reg_rec XIF_XPN_IDLE_PKT_CNT_REG;
#define XIF_XPN_IDLE_PKT_CNT_REG_OFFSET 0x000000ac

extern const ru_reg_rec XIF_LLID_0_REG;
#define XIF_LLID_0_REG_OFFSET 0x000000c0

extern const ru_reg_rec XIF_LLID_1_REG;
#define XIF_LLID_1_REG_OFFSET 0x000000c4

extern const ru_reg_rec XIF_LLID_2_REG;
#define XIF_LLID_2_REG_OFFSET 0x000000c8

extern const ru_reg_rec XIF_LLID_3_REG;
#define XIF_LLID_3_REG_OFFSET 0x000000cc

extern const ru_reg_rec XIF_LLID_4_REG;
#define XIF_LLID_4_REG_OFFSET 0x000000d0

extern const ru_reg_rec XIF_LLID_5_REG;
#define XIF_LLID_5_REG_OFFSET 0x000000d4

extern const ru_reg_rec XIF_LLID_6_REG;
#define XIF_LLID_6_REG_OFFSET 0x000000d8

extern const ru_reg_rec XIF_LLID_7_REG;
#define XIF_LLID_7_REG_OFFSET 0x000000dc

extern const ru_reg_rec XIF_LLID_8_REG;
#define XIF_LLID_8_REG_OFFSET 0x000000e0

extern const ru_reg_rec XIF_LLID_9_REG;
#define XIF_LLID_9_REG_OFFSET 0x000000e4

extern const ru_reg_rec XIF_LLID_10_REG;
#define XIF_LLID_10_REG_OFFSET 0x000000e8

extern const ru_reg_rec XIF_LLID_11_REG;
#define XIF_LLID_11_REG_OFFSET 0x000000ec

extern const ru_reg_rec XIF_LLID_12_REG;
#define XIF_LLID_12_REG_OFFSET 0x000000f0

extern const ru_reg_rec XIF_LLID_13_REG;
#define XIF_LLID_13_REG_OFFSET 0x000000f4

extern const ru_reg_rec XIF_LLID_14_REG;
#define XIF_LLID_14_REG_OFFSET 0x000000f8

extern const ru_reg_rec XIF_LLID_15_REG;
#define XIF_LLID_15_REG_OFFSET 0x000000fc

extern const ru_reg_rec XIF_LLID_16_REG;
#define XIF_LLID_16_REG_OFFSET 0x00000100

extern const ru_reg_rec XIF_LLID_17_REG;
#define XIF_LLID_17_REG_OFFSET 0x00000104

extern const ru_reg_rec XIF_LLID_18_REG;
#define XIF_LLID_18_REG_OFFSET 0x00000108

extern const ru_reg_rec XIF_LLID_19_REG;
#define XIF_LLID_19_REG_OFFSET 0x0000010c

extern const ru_reg_rec XIF_LLID_20_REG;
#define XIF_LLID_20_REG_OFFSET 0x00000110

extern const ru_reg_rec XIF_LLID_21_REG;
#define XIF_LLID_21_REG_OFFSET 0x00000114

extern const ru_reg_rec XIF_LLID_22_REG;
#define XIF_LLID_22_REG_OFFSET 0x00000118

extern const ru_reg_rec XIF_LLID_23_REG;
#define XIF_LLID_23_REG_OFFSET 0x0000011c

extern const ru_reg_rec XIF_LLID_24_REG;
#define XIF_LLID_24_REG_OFFSET 0x00000120

extern const ru_reg_rec XIF_LLID_25_REG;
#define XIF_LLID_25_REG_OFFSET 0x00000124

extern const ru_reg_rec XIF_LLID_26_REG;
#define XIF_LLID_26_REG_OFFSET 0x00000128

extern const ru_reg_rec XIF_LLID_27_REG;
#define XIF_LLID_27_REG_OFFSET 0x0000012c

extern const ru_reg_rec XIF_LLID_28_REG;
#define XIF_LLID_28_REG_OFFSET 0x00000130

extern const ru_reg_rec XIF_LLID_29_REG;
#define XIF_LLID_29_REG_OFFSET 0x00000134

extern const ru_reg_rec XIF_LLID_30_REG;
#define XIF_LLID_30_REG_OFFSET 0x00000138

extern const ru_reg_rec XIF_LLID_31_REG;
#define XIF_LLID_31_REG_OFFSET 0x0000013c

extern const ru_reg_rec XIF_MAX_MPCP_UPDATE_REG;
#define XIF_MAX_MPCP_UPDATE_REG_OFFSET 0x00000140

extern const ru_reg_rec XIF_IPG_INSERTION_REG;
#define XIF_IPG_INSERTION_REG_OFFSET 0x00000144

extern const ru_reg_rec XIF_TRANSPORT_TIME_REG;
#define XIF_TRANSPORT_TIME_REG_OFFSET 0x00000148

extern const ru_reg_rec XIF_MPCP_TIME_REG;
#define XIF_MPCP_TIME_REG_OFFSET 0x0000014c

extern const ru_reg_rec XIF_OVERLAP_GNT_OH_REG;
#define XIF_OVERLAP_GNT_OH_REG_OFFSET 0x00000150

extern const ru_reg_rec XIF_MAC_MODE_REG;
#define XIF_MAC_MODE_REG_OFFSET 0x00000154

extern const ru_reg_rec XIF_PMCTX_CTL_REG;
#define XIF_PMCTX_CTL_REG_OFFSET 0x00000158

extern const ru_reg_rec XIF_SEC_CTL_REG;
#define XIF_SEC_CTL_REG_OFFSET 0x0000015c

extern const ru_reg_rec XIF_AE_PKTNUM_WINDOW_REG;
#define XIF_AE_PKTNUM_WINDOW_REG_OFFSET 0x00000160

extern const ru_reg_rec XIF_AE_PKTNUM_THRESH_REG;
#define XIF_AE_PKTNUM_THRESH_REG_OFFSET 0x00000164

extern const ru_reg_rec XIF_SECTX_KEYNUM_REG;
#define XIF_SECTX_KEYNUM_REG_OFFSET 0x00000168

extern const ru_reg_rec XIF_SECTX_ENCRYPT_REG;
#define XIF_SECTX_ENCRYPT_REG_OFFSET 0x0000016c

extern const ru_reg_rec XIF_AE_PKTNUM_STAT_REG;
#define XIF_AE_PKTNUM_STAT_REG_OFFSET 0x00000170

extern const ru_reg_rec XIF_MPCP_UPDATE_REG;
#define XIF_MPCP_UPDATE_REG_OFFSET 0x00000174

extern const ru_reg_rec XIF_BURST_PRELAUNCH_OFFSET_REG;
#define XIF_BURST_PRELAUNCH_OFFSET_REG_OFFSET 0x00000178

extern const ru_reg_rec XIF_VLAN_TYPE_REG;
#define XIF_VLAN_TYPE_REG_OFFSET 0x0000017c

extern const ru_reg_rec XIF_P2P_AE_SCI_EN_REG;
#define XIF_P2P_AE_SCI_EN_REG_OFFSET 0x00000180

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_0_REG;
#define XIF_P2P_AE_SCI_LO_0_REG_OFFSET 0x00000184

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_0_REG;
#define XIF_P2P_AE_SCI_HI_0_REG_OFFSET 0x00000188

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_1_REG;
#define XIF_P2P_AE_SCI_LO_1_REG_OFFSET 0x0000018c

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_1_REG;
#define XIF_P2P_AE_SCI_HI_1_REG_OFFSET 0x00000190

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_2_REG;
#define XIF_P2P_AE_SCI_LO_2_REG_OFFSET 0x00000194

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_2_REG;
#define XIF_P2P_AE_SCI_HI_2_REG_OFFSET 0x00000198

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_3_REG;
#define XIF_P2P_AE_SCI_LO_3_REG_OFFSET 0x0000019c

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_3_REG;
#define XIF_P2P_AE_SCI_HI_3_REG_OFFSET 0x000001a0

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_4_REG;
#define XIF_P2P_AE_SCI_LO_4_REG_OFFSET 0x000001a4

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_4_REG;
#define XIF_P2P_AE_SCI_HI_4_REG_OFFSET 0x000001a8

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_5_REG;
#define XIF_P2P_AE_SCI_LO_5_REG_OFFSET 0x000001ac

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_5_REG;
#define XIF_P2P_AE_SCI_HI_5_REG_OFFSET 0x000001b0

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_6_REG;
#define XIF_P2P_AE_SCI_LO_6_REG_OFFSET 0x000001b4

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_6_REG;
#define XIF_P2P_AE_SCI_HI_6_REG_OFFSET 0x000001b8

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_7_REG;
#define XIF_P2P_AE_SCI_LO_7_REG_OFFSET 0x000001bc

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_7_REG;
#define XIF_P2P_AE_SCI_HI_7_REG_OFFSET 0x000001c0

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_8_REG;
#define XIF_P2P_AE_SCI_LO_8_REG_OFFSET 0x000001c4

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_8_REG;
#define XIF_P2P_AE_SCI_HI_8_REG_OFFSET 0x000001c8

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_9_REG;
#define XIF_P2P_AE_SCI_LO_9_REG_OFFSET 0x000001cc

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_9_REG;
#define XIF_P2P_AE_SCI_HI_9_REG_OFFSET 0x000001d0

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_10_REG;
#define XIF_P2P_AE_SCI_LO_10_REG_OFFSET 0x000001d4

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_10_REG;
#define XIF_P2P_AE_SCI_HI_10_REG_OFFSET 0x000001d8

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_11_REG;
#define XIF_P2P_AE_SCI_LO_11_REG_OFFSET 0x000001dc

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_11_REG;
#define XIF_P2P_AE_SCI_HI_11_REG_OFFSET 0x000001e0

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_12_REG;
#define XIF_P2P_AE_SCI_LO_12_REG_OFFSET 0x000001e4

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_12_REG;
#define XIF_P2P_AE_SCI_HI_12_REG_OFFSET 0x000001e8

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_13_REG;
#define XIF_P2P_AE_SCI_LO_13_REG_OFFSET 0x000001ec

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_13_REG;
#define XIF_P2P_AE_SCI_HI_13_REG_OFFSET 0x000001f0

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_14_REG;
#define XIF_P2P_AE_SCI_LO_14_REG_OFFSET 0x000001f4

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_14_REG;
#define XIF_P2P_AE_SCI_HI_14_REG_OFFSET 0x000001f8

extern const ru_reg_rec XIF_P2P_AE_SCI_LO_15_REG;
#define XIF_P2P_AE_SCI_LO_15_REG_OFFSET 0x000001fc

extern const ru_reg_rec XIF_P2P_AE_SCI_HI_15_REG;
#define XIF_P2P_AE_SCI_HI_15_REG_OFFSET 0x00000200

extern const ru_reg_rec XIF_SECTX_KEYNUM_1_REG;
#define XIF_SECTX_KEYNUM_1_REG_OFFSET 0x00000204

extern const ru_reg_rec XIF_SECRX_KEYNUM_1_REG;
#define XIF_SECRX_KEYNUM_1_REG_OFFSET 0x00000208

extern const ru_reg_rec XPCSRX_RX_RST_REG;
#define XPCSRX_RX_RST_REG_OFFSET 0x00000000

extern const ru_reg_rec XPCSRX_RX_INT_STAT_REG;
#define XPCSRX_RX_INT_STAT_REG_OFFSET 0x00000004

extern const ru_reg_rec XPCSRX_RX_INT_MSK_REG;
#define XPCSRX_RX_INT_MSK_REG_OFFSET 0x00000008

extern const ru_reg_rec XPCSRX_RX_FRAMER_CTL_REG;
#define XPCSRX_RX_FRAMER_CTL_REG_OFFSET 0x0000000c

extern const ru_reg_rec XPCSRX_RX_FEC_CTL_REG;
#define XPCSRX_RX_FEC_CTL_REG_OFFSET 0x00000010

extern const ru_reg_rec XPCSRX_RX_DSCRAM_CTL_REG;
#define XPCSRX_RX_DSCRAM_CTL_REG_OFFSET 0x00000014

extern const ru_reg_rec XPCSRX_RX_64B66B_CTL_REG;
#define XPCSRX_RX_64B66B_CTL_REG_OFFSET 0x00000018

extern const ru_reg_rec XPCSRX_RX_TEST_CTL_REG;
#define XPCSRX_RX_TEST_CTL_REG_OFFSET 0x0000001c

extern const ru_reg_rec XPCSRX_RX_IDLE_RD_TIMER_DLY_REG;
#define XPCSRX_RX_IDLE_RD_TIMER_DLY_REG_OFFSET 0x00000020

extern const ru_reg_rec XPCSRX_RX_IDLE_GAP_SIZ_MAX_REG;
#define XPCSRX_RX_IDLE_GAP_SIZ_MAX_REG_OFFSET 0x00000024

extern const ru_reg_rec XPCSRX_RX_FRAMER_LK_MAX_REG;
#define XPCSRX_RX_FRAMER_LK_MAX_REG_OFFSET 0x00000028

extern const ru_reg_rec XPCSRX_RX_FRAMER_UNLK_MAX_REG;
#define XPCSRX_RX_FRAMER_UNLK_MAX_REG_OFFSET 0x0000002c

extern const ru_reg_rec XPCSRX_RX_FRAMER_BD_SH_REG;
#define XPCSRX_RX_FRAMER_BD_SH_REG_OFFSET 0x00000030

extern const ru_reg_rec XPCSRX_RX_FRAMER_BD_LO_REG;
#define XPCSRX_RX_FRAMER_BD_LO_REG_OFFSET 0x00000034

extern const ru_reg_rec XPCSRX_RX_FRAMER_BD_HI_REG;
#define XPCSRX_RX_FRAMER_BD_HI_REG_OFFSET 0x00000038

extern const ru_reg_rec XPCSRX_RX_FRAMER_EBD_SH_REG;
#define XPCSRX_RX_FRAMER_EBD_SH_REG_OFFSET 0x0000003c

extern const ru_reg_rec XPCSRX_RX_FRAMER_EBD_LO_REG;
#define XPCSRX_RX_FRAMER_EBD_LO_REG_OFFSET 0x00000040

extern const ru_reg_rec XPCSRX_RX_FRAMER_EBD_HI_REG;
#define XPCSRX_RX_FRAMER_EBD_HI_REG_OFFSET 0x00000044

extern const ru_reg_rec XPCSRX_RX_STATUS_REG;
#define XPCSRX_RX_STATUS_REG_OFFSET 0x00000048

extern const ru_reg_rec XPCSRX_RX_FRAMER_LK_ULK_MAX_REG;
#define XPCSRX_RX_FRAMER_LK_ULK_MAX_REG_OFFSET 0x0000004c

extern const ru_reg_rec XPCSRX_RX_FRAMER_SP_SH_REG;
#define XPCSRX_RX_FRAMER_SP_SH_REG_OFFSET 0x00000050

extern const ru_reg_rec XPCSRX_RX_FRAMER_SP_LO_REG;
#define XPCSRX_RX_FRAMER_SP_LO_REG_OFFSET 0x00000054

extern const ru_reg_rec XPCSRX_RX_FRAMER_SP_HI_REG;
#define XPCSRX_RX_FRAMER_SP_HI_REG_OFFSET 0x00000058

extern const ru_reg_rec XPCSRX_RX_FRAMER_STATE_REG;
#define XPCSRX_RX_FRAMER_STATE_REG_OFFSET 0x0000005c

extern const ru_reg_rec XPCSRX_RX_FRAMER_BD_EBD_HAM_REG;
#define XPCSRX_RX_FRAMER_BD_EBD_HAM_REG_OFFSET 0x00000060

extern const ru_reg_rec XPCSRX_RX_FRAMER_MISBRST_CNT_REG;
#define XPCSRX_RX_FRAMER_MISBRST_CNT_REG_OFFSET 0x00000064

extern const ru_reg_rec XPCSRX_RX_FRAMER_BD_ERR_REG;
#define XPCSRX_RX_FRAMER_BD_ERR_REG_OFFSET 0x00000068

extern const ru_reg_rec XPCSRX_RX_FRAMER_ROGUE_CTL_REG;
#define XPCSRX_RX_FRAMER_ROGUE_CTL_REG_OFFSET 0x0000006c

extern const ru_reg_rec XPCSRX_RX_FRAMER_NOLOCK_CTL_REG;
#define XPCSRX_RX_FRAMER_NOLOCK_CTL_REG_OFFSET 0x00000070

extern const ru_reg_rec XPCSRX_RX_64B66B_IPG_DET_CNT_REG;
#define XPCSRX_RX_64B66B_IPG_DET_CNT_REG_OFFSET 0x00000074

extern const ru_reg_rec XPCSRX_RX_FEC_NQUE_IN_CNT_REG;
#define XPCSRX_RX_FEC_NQUE_IN_CNT_REG_OFFSET 0x00000078

extern const ru_reg_rec XPCSRX_RX_FEC_NQUE_OUT_CNT_REG;
#define XPCSRX_RX_FEC_NQUE_OUT_CNT_REG_OFFSET 0x0000007c

extern const ru_reg_rec XPCSRX_RX_IDLE_START_CNT_REG;
#define XPCSRX_RX_IDLE_START_CNT_REG_OFFSET 0x00000080

extern const ru_reg_rec XPCSRX_RX_IDLE_STOP_CNT_REG;
#define XPCSRX_RX_IDLE_STOP_CNT_REG_OFFSET 0x00000084

extern const ru_reg_rec XPCSRX_RX_FEC_COR_INTVAL_REG;
#define XPCSRX_RX_FEC_COR_INTVAL_REG_OFFSET 0x00000088

extern const ru_reg_rec XPCSRX_RX_FEC_COR_TRESH_REG;
#define XPCSRX_RX_FEC_COR_TRESH_REG_OFFSET 0x0000008c

extern const ru_reg_rec XPCSRX_RX_FEC_CW_FAIL_CNT_REG;
#define XPCSRX_RX_FEC_CW_FAIL_CNT_REG_OFFSET 0x00000090

extern const ru_reg_rec XPCSRX_RX_FEC_CW_TOT_CNT_REG;
#define XPCSRX_RX_FEC_CW_TOT_CNT_REG_OFFSET 0x00000094

extern const ru_reg_rec XPCSRX_RX_FEC_CORRECT_CNT_LOWER_REG;
#define XPCSRX_RX_FEC_CORRECT_CNT_LOWER_REG_OFFSET 0x00000098

extern const ru_reg_rec XPCSRX_RX_FEC_CORRECT_CNT_UPPER_REG;
#define XPCSRX_RX_FEC_CORRECT_CNT_UPPER_REG_OFFSET 0x0000009c

extern const ru_reg_rec XPCSRX_RX_FEC_CORRECT_CNT_SHADOW_REG;
#define XPCSRX_RX_FEC_CORRECT_CNT_SHADOW_REG_OFFSET 0x000000a0

extern const ru_reg_rec XPCSRX_RX_FEC_ONES_COR_CNT_LOWER_REG;
#define XPCSRX_RX_FEC_ONES_COR_CNT_LOWER_REG_OFFSET 0x000000a4

extern const ru_reg_rec XPCSRX_RX_FEC_ONES_COR_CNT_UPPER_REG;
#define XPCSRX_RX_FEC_ONES_COR_CNT_UPPER_REG_OFFSET 0x000000a8

extern const ru_reg_rec XPCSRX_RX_FEC_ONES_COR_CNT_SHADOW_REG;
#define XPCSRX_RX_FEC_ONES_COR_CNT_SHADOW_REG_OFFSET 0x000000ac

extern const ru_reg_rec XPCSRX_RX_FEC_ZEROS_COR_CNT_LOWER_REG;
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_LOWER_REG_OFFSET 0x000000b0

extern const ru_reg_rec XPCSRX_RX_FEC_ZEROS_COR_CNT_UPPER_REG;
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_UPPER_REG_OFFSET 0x000000b4

extern const ru_reg_rec XPCSRX_RX_FEC_ZEROS_COR_CNT_SHADOW_REG;
#define XPCSRX_RX_FEC_ZEROS_COR_CNT_SHADOW_REG_OFFSET 0x000000b8

extern const ru_reg_rec XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_REG;
#define XPCSRX_RX_FEC_STOP_ON_ERR_READ_POINTER_REG_OFFSET 0x000000bc

extern const ru_reg_rec XPCSRX_RX_FEC_STOP_ON_ERR_BURST_LOCATION_REG;
#define XPCSRX_RX_FEC_STOP_ON_ERR_BURST_LOCATION_REG_OFFSET 0x000000c0

extern const ru_reg_rec XPCSRX_RX_64B66B_FAIL_CNT_REG;
#define XPCSRX_RX_64B66B_FAIL_CNT_REG_OFFSET 0x000000c4

extern const ru_reg_rec XPCSRX_RX_FRMR_BAD_SH_CNT_REG;
#define XPCSRX_RX_FRMR_BAD_SH_CNT_REG_OFFSET 0x000000c8

extern const ru_reg_rec XPCSRX_RX_PSUDO_CNT_REG;
#define XPCSRX_RX_PSUDO_CNT_REG_OFFSET 0x000000cc

extern const ru_reg_rec XPCSRX_RX_PRBS_CNT_REG;
#define XPCSRX_RX_PRBS_CNT_REG_OFFSET 0x000000d0

extern const ru_reg_rec XPCSRX_RX_BER_INTVAL_REG;
#define XPCSRX_RX_BER_INTVAL_REG_OFFSET 0x000000d4

extern const ru_reg_rec XPCSRX_RX_BER_TRESH_REG;
#define XPCSRX_RX_BER_TRESH_REG_OFFSET 0x000000d8

extern const ru_reg_rec XPCSRX_RX_64B66B_START_CNT_REG;
#define XPCSRX_RX_64B66B_START_CNT_REG_OFFSET 0x000000dc

extern const ru_reg_rec XPCSRX_RX_IDLE_GOOD_PKT_CNT_REG;
#define XPCSRX_RX_IDLE_GOOD_PKT_CNT_REG_OFFSET 0x000000e0

extern const ru_reg_rec XPCSRX_RX_IDLE_ERR_PKT_CNT_REG;
#define XPCSRX_RX_IDLE_ERR_PKT_CNT_REG_OFFSET 0x000000e4

extern const ru_reg_rec XPCSRX_RX_64B66B_STOP_CNT_REG;
#define XPCSRX_RX_64B66B_STOP_CNT_REG_OFFSET 0x000000e8

extern const ru_reg_rec XPCSRX_RX_BURST_OUT_ODR_CNT_REG;
#define XPCSRX_RX_BURST_OUT_ODR_CNT_REG_OFFSET 0x000000ec

extern const ru_reg_rec XPCSRX_RX_IDLE_DA_JIT_DLY_REG;
#define XPCSRX_RX_IDLE_DA_JIT_DLY_REG_OFFSET 0x000000f0

extern const ru_reg_rec XPCSRX_RX_DPORT_CTL_REG;
#define XPCSRX_RX_DPORT_CTL_REG_OFFSET 0x000000f4

extern const ru_reg_rec XPCSRX_RX_DPORT_DATA0_REG;
#define XPCSRX_RX_DPORT_DATA0_REG_OFFSET 0x000000f8

extern const ru_reg_rec XPCSRX_RX_DPORT_DATA1_REG;
#define XPCSRX_RX_DPORT_DATA1_REG_OFFSET 0x000000fc

extern const ru_reg_rec XPCSRX_RX_DPORT_DATA2_REG;
#define XPCSRX_RX_DPORT_DATA2_REG_OFFSET 0x00000100

extern const ru_reg_rec XPCSRX_RX_DPORT_ACC_REG;
#define XPCSRX_RX_DPORT_ACC_REG_OFFSET 0x00000104

extern const ru_reg_rec XPCSRX_RX_RAM_ECC_INT_STAT_REG;
#define XPCSRX_RX_RAM_ECC_INT_STAT_REG_OFFSET 0x00000108

extern const ru_reg_rec XPCSRX_RX_RAM_ECC_INT_MSK_REG;
#define XPCSRX_RX_RAM_ECC_INT_MSK_REG_OFFSET 0x0000010c

extern const ru_reg_rec XPCSRX_RX_DFT_TESTMODE_REG;
#define XPCSRX_RX_DFT_TESTMODE_REG_OFFSET 0x00000110

extern const ru_reg_rec XPCSRX_RX_RAM_POWER_PDA_CTL0_REG;
#define XPCSRX_RX_RAM_POWER_PDA_CTL0_REG_OFFSET 0x00000114

extern const ru_reg_rec XPCSRX_RX_INT_STAT1_REG;
#define XPCSRX_RX_INT_STAT1_REG_OFFSET 0x00000118

extern const ru_reg_rec XPCSRX_RX_INT_MSK1_REG;
#define XPCSRX_RX_INT_MSK1_REG_OFFSET 0x0000011c

extern const ru_reg_rec XPCSRX_RX_SPARE_CTL_REG;
#define XPCSRX_RX_SPARE_CTL_REG_OFFSET 0x00000120

extern const ru_reg_rec XPCSTX_TX_CONTROL_REG;
#define XPCSTX_TX_CONTROL_REG_OFFSET 0x00000000

extern const ru_reg_rec XPCSTX_TX_INT_STAT_REG;
#define XPCSTX_TX_INT_STAT_REG_OFFSET 0x00000004

extern const ru_reg_rec XPCSTX_TX_INT_MASK_REG;
#define XPCSTX_TX_INT_MASK_REG_OFFSET 0x00000008

extern const ru_reg_rec XPCSTX_TX_PORT_COMMAND_REG;
#define XPCSTX_TX_PORT_COMMAND_REG_OFFSET 0x0000000c

extern const ru_reg_rec XPCSTX_TX_DATA_PORT_0_REG;
#define XPCSTX_TX_DATA_PORT_0_REG_OFFSET 0x00000010

extern const ru_reg_rec XPCSTX_TX_DATA_PORT_1_REG;
#define XPCSTX_TX_DATA_PORT_1_REG_OFFSET 0x00000014

extern const ru_reg_rec XPCSTX_TX_DATA_PORT_2_REG;
#define XPCSTX_TX_DATA_PORT_2_REG_OFFSET 0x00000018

extern const ru_reg_rec XPCSTX_TX_SYNC_PATT_CWORD_LO_REG;
#define XPCSTX_TX_SYNC_PATT_CWORD_LO_REG_OFFSET 0x0000001c

extern const ru_reg_rec XPCSTX_TX_SYNC_PATT_CWORD_HI_REG;
#define XPCSTX_TX_SYNC_PATT_CWORD_HI_REG_OFFSET 0x00000020

extern const ru_reg_rec XPCSTX_TX_START_BURST_DEL_CWORD_LO_REG;
#define XPCSTX_TX_START_BURST_DEL_CWORD_LO_REG_OFFSET 0x00000024

extern const ru_reg_rec XPCSTX_TX_START_BURST_DEL_CWORD_HI_REG;
#define XPCSTX_TX_START_BURST_DEL_CWORD_HI_REG_OFFSET 0x00000028

extern const ru_reg_rec XPCSTX_TX_END_BURST_DEL_CWORD_LO_REG;
#define XPCSTX_TX_END_BURST_DEL_CWORD_LO_REG_OFFSET 0x0000002c

extern const ru_reg_rec XPCSTX_TX_END_BURST_DEL_CWORD_HI_REG;
#define XPCSTX_TX_END_BURST_DEL_CWORD_HI_REG_OFFSET 0x00000030

extern const ru_reg_rec XPCSTX_TX_IDLE_CWORD_LO_REG;
#define XPCSTX_TX_IDLE_CWORD_LO_REG_OFFSET 0x00000034

extern const ru_reg_rec XPCSTX_TX_IDLE_CWORD_HI_REG;
#define XPCSTX_TX_IDLE_CWORD_HI_REG_OFFSET 0x00000038

extern const ru_reg_rec XPCSTX_TX_BURST_PATT_CWORD_LO_REG;
#define XPCSTX_TX_BURST_PATT_CWORD_LO_REG_OFFSET 0x0000003c

extern const ru_reg_rec XPCSTX_TX_BURST_PATT_CWORD_HI_REG;
#define XPCSTX_TX_BURST_PATT_CWORD_HI_REG_OFFSET 0x00000040

extern const ru_reg_rec XPCSTX_TX_LASER_TIME_REG;
#define XPCSTX_TX_LASER_TIME_REG_OFFSET 0x00000044

extern const ru_reg_rec XPCSTX_TX_MAC_MODE_REG;
#define XPCSTX_TX_MAC_MODE_REG_OFFSET 0x00000048

extern const ru_reg_rec XPCSTX_TX_LASER_MONITOR_CTL_REG;
#define XPCSTX_TX_LASER_MONITOR_CTL_REG_OFFSET 0x0000004c

extern const ru_reg_rec XPCSTX_TX_LASER_MONITOR_MAX_THRESH_REG;
#define XPCSTX_TX_LASER_MONITOR_MAX_THRESH_REG_OFFSET 0x00000050

extern const ru_reg_rec XPCSTX_TX_LASER_MONITOR_BURST_LEN_REG;
#define XPCSTX_TX_LASER_MONITOR_BURST_LEN_REG_OFFSET 0x00000054

extern const ru_reg_rec XPCSTX_TX_LASER_MONITOR_BURST_COUNT_REG;
#define XPCSTX_TX_LASER_MONITOR_BURST_COUNT_REG_OFFSET 0x00000058



/******************************************************************************
 * EPON Blocks
 ******************************************************************************/
extern const ru_block_rec EPON_TOP_BLOCK;
extern const ru_block_rec CLK_PRG_SWCH_ADDR_BLOCK;
extern const ru_block_rec EPN_ONU_MAC_ADDR_BLOCK;
extern const ru_block_rec EPN_TX_L1S_SHP_BLOCK;
extern const ru_block_rec EPN_BLOCK;
extern const ru_block_rec LIF_BLOCK;
extern const ru_block_rec NCO_ADDR_BLOCK;
extern const ru_block_rec XIF_BLOCK;
extern const ru_block_rec XPCSRX_BLOCK;
extern const ru_block_rec XPCSTX_BLOCK;
extern const ru_block_rec *RU_EPON_BLOCKS[];


#define RU_BLK_COUNT 10
#define RU_REG_COUNT 752
#define RU_FLD_COUNT 2810


#endif /* End of file EPON.h */
