/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#ifndef _EPON_AG_H_
#define _EPON_AG_H_

#include "ru.h"

/******************************************************************************
 * EPON Fields
 ******************************************************************************/
extern const ru_field_rec EPON_TOP_SCRATCH_SCRATCH_FIELD;
#define EPON_TOP_SCRATCH_SCRATCH_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_SCRATCH_SCRATCH_FIELD_WIDTH 32
#define EPON_TOP_SCRATCH_SCRATCH_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_RESET_RESERVED0_FIELD;
#define EPON_TOP_RESET_RESERVED0_FIELD_MASK  0x00000000ffffffe0
#define EPON_TOP_RESET_RESERVED0_FIELD_WIDTH 27
#define EPON_TOP_RESET_RESERVED0_FIELD_SHIFT 5

extern const ru_field_rec EPON_TOP_RESET_TODRST_N_FIELD;
#define EPON_TOP_RESET_TODRST_N_FIELD_MASK  0x0000000000000010
#define EPON_TOP_RESET_TODRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_TODRST_N_FIELD_SHIFT 4

extern const ru_field_rec EPON_TOP_RESET_CLKPRGRST_N_FIELD;
#define EPON_TOP_RESET_CLKPRGRST_N_FIELD_MASK  0x0000000000000008
#define EPON_TOP_RESET_CLKPRGRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_CLKPRGRST_N_FIELD_SHIFT 3

extern const ru_field_rec EPON_TOP_RESET_NCORST_N_FIELD;
#define EPON_TOP_RESET_NCORST_N_FIELD_MASK  0x0000000000000004
#define EPON_TOP_RESET_NCORST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_NCORST_N_FIELD_SHIFT 2

extern const ru_field_rec EPON_TOP_RESET_LIFRST_N_FIELD;
#define EPON_TOP_RESET_LIFRST_N_FIELD_MASK  0x0000000000000002
#define EPON_TOP_RESET_LIFRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_LIFRST_N_FIELD_SHIFT 1

extern const ru_field_rec EPON_TOP_RESET_EPNRST_N_FIELD;
#define EPON_TOP_RESET_EPNRST_N_FIELD_MASK  0x0000000000000001
#define EPON_TOP_RESET_EPNRST_N_FIELD_WIDTH 1
#define EPON_TOP_RESET_EPNRST_N_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_INTERRUPT_RESERVED0_FIELD;
#define EPON_TOP_INTERRUPT_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPON_TOP_INTERRUPT_RESERVED0_FIELD_WIDTH 24
#define EPON_TOP_INTERRUPT_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_1PPS_FIELD;
#define EPON_TOP_INTERRUPT_INT_1PPS_FIELD_MASK  0x0000000000000080
#define EPON_TOP_INTERRUPT_INT_1PPS_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_1PPS_FIELD_SHIFT 7

extern const ru_field_rec EPON_TOP_INTERRUPT_RESERVED1_FIELD;
#define EPON_TOP_INTERRUPT_RESERVED1_FIELD_MASK  0x0000000000000070
#define EPON_TOP_INTERRUPT_RESERVED1_FIELD_WIDTH 3
#define EPON_TOP_INTERRUPT_RESERVED1_FIELD_SHIFT 4

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_NCO_FIELD;
#define EPON_TOP_INTERRUPT_INT_NCO_FIELD_MASK  0x0000000000000008
#define EPON_TOP_INTERRUPT_INT_NCO_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_NCO_FIELD_SHIFT 3

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_LIF_FIELD;
#define EPON_TOP_INTERRUPT_INT_LIF_FIELD_MASK  0x0000000000000004
#define EPON_TOP_INTERRUPT_INT_LIF_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_LIF_FIELD_SHIFT 2

extern const ru_field_rec EPON_TOP_INTERRUPT_RESERVED2_FIELD;
#define EPON_TOP_INTERRUPT_RESERVED2_FIELD_MASK  0x0000000000000002
#define EPON_TOP_INTERRUPT_RESERVED2_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_RESERVED2_FIELD_SHIFT 1

extern const ru_field_rec EPON_TOP_INTERRUPT_INT_EPN_FIELD;
#define EPON_TOP_INTERRUPT_INT_EPN_FIELD_MASK  0x0000000000000001
#define EPON_TOP_INTERRUPT_INT_EPN_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_INT_EPN_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_RESERVED0_FIELD;
#define EPON_TOP_INTERRUPT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPON_TOP_INTERRUPT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPON_TOP_INTERRUPT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_1PPS_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_1PPS_MASK_FIELD_MASK  0x0000000000000080
#define EPON_TOP_INTERRUPT_MASK_INT_1PPS_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_1PPS_MASK_FIELD_SHIFT 7

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_RESERVED1_FIELD;
#define EPON_TOP_INTERRUPT_MASK_RESERVED1_FIELD_MASK  0x0000000000000070
#define EPON_TOP_INTERRUPT_MASK_RESERVED1_FIELD_WIDTH 3
#define EPON_TOP_INTERRUPT_MASK_RESERVED1_FIELD_SHIFT 4

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_NCO_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_NCO_MASK_FIELD_MASK  0x0000000000000008
#define EPON_TOP_INTERRUPT_MASK_INT_NCO_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_NCO_MASK_FIELD_SHIFT 3

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_LIF_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_LIF_MASK_FIELD_MASK  0x0000000000000004
#define EPON_TOP_INTERRUPT_MASK_INT_LIF_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_LIF_MASK_FIELD_SHIFT 2

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_RESERVED2_FIELD;
#define EPON_TOP_INTERRUPT_MASK_RESERVED2_FIELD_MASK  0x0000000000000002
#define EPON_TOP_INTERRUPT_MASK_RESERVED2_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_RESERVED2_FIELD_SHIFT 1

extern const ru_field_rec EPON_TOP_INTERRUPT_MASK_INT_EPN_MASK_FIELD;
#define EPON_TOP_INTERRUPT_MASK_INT_EPN_MASK_FIELD_MASK  0x0000000000000001
#define EPON_TOP_INTERRUPT_MASK_INT_EPN_MASK_FIELD_WIDTH 1
#define EPON_TOP_INTERRUPT_MASK_INT_EPN_MASK_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_CONTROL_RESERVED0_FIELD;
#define EPON_TOP_CONTROL_RESERVED0_FIELD_MASK  0x00000000fffffff8
#define EPON_TOP_CONTROL_RESERVED0_FIELD_WIDTH 29
#define EPON_TOP_CONTROL_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec EPON_TOP_CONTROL_CFGTWOGIGPONDNS_FIELD;
#define EPON_TOP_CONTROL_CFGTWOGIGPONDNS_FIELD_MASK  0x0000000000000004
#define EPON_TOP_CONTROL_CFGTWOGIGPONDNS_FIELD_WIDTH 1
#define EPON_TOP_CONTROL_CFGTWOGIGPONDNS_FIELD_SHIFT 2

extern const ru_field_rec EPON_TOP_ONE_PPS_MPCP_OFFSET_CFG_1PPS_MPCP_OFFSET_FIELD;
#define EPON_TOP_ONE_PPS_MPCP_OFFSET_CFG_1PPS_MPCP_OFFSET_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_ONE_PPS_MPCP_OFFSET_CFG_1PPS_MPCP_OFFSET_FIELD_WIDTH 32
#define EPON_TOP_ONE_PPS_MPCP_OFFSET_CFG_1PPS_MPCP_OFFSET_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_CAPTURE_1PPS_MPCP_TIME_FIELD;
#define EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_CAPTURE_1PPS_MPCP_TIME_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_CAPTURE_1PPS_MPCP_TIME_FIELD_WIDTH 32
#define EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_CAPTURE_1PPS_MPCP_TIME_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_NS_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_NS_FIELD_MASK  0x0000000080000000
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_NS_FIELD_WIDTH 1
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_NS_FIELD_SHIFT 31

extern const ru_field_rec EPON_TOP_TOD_CONFIG_RESERVED0_FIELD;
#define EPON_TOP_TOD_CONFIG_RESERVED0_FIELD_MASK  0x000000007f000000
#define EPON_TOP_TOD_CONFIG_RESERVED0_FIELD_WIDTH 7
#define EPON_TOP_TOD_CONFIG_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_READ_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_FIELD_MASK  0x0000000000800000
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_FIELD_WIDTH 1
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_FIELD_SHIFT 23

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_READ_SEL_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_SEL_FIELD_MASK  0x0000000000600000
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_SEL_FIELD_WIDTH 2
#define EPON_TOP_TOD_CONFIG_CFG_TOD_READ_SEL_FIELD_SHIFT 21

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_PPS_CLEAR_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_PPS_CLEAR_FIELD_MASK  0x0000000000100000
#define EPON_TOP_TOD_CONFIG_CFG_TOD_PPS_CLEAR_FIELD_WIDTH 1
#define EPON_TOP_TOD_CONFIG_CFG_TOD_PPS_CLEAR_FIELD_SHIFT 20

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_FIELD_MASK  0x0000000000080000
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_FIELD_WIDTH 1
#define EPON_TOP_TOD_CONFIG_CFG_TOD_LOAD_FIELD_SHIFT 19

extern const ru_field_rec EPON_TOP_TOD_CONFIG_CFG_TOD_SECONDS_FIELD;
#define EPON_TOP_TOD_CONFIG_CFG_TOD_SECONDS_FIELD_MASK  0x000000000007ffff
#define EPON_TOP_TOD_CONFIG_CFG_TOD_SECONDS_FIELD_WIDTH 19
#define EPON_TOP_TOD_CONFIG_CFG_TOD_SECONDS_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TOD_NS_CFG_TOD_NS_FIELD;
#define EPON_TOP_TOD_NS_CFG_TOD_NS_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_TOD_NS_CFG_TOD_NS_FIELD_WIDTH 32
#define EPON_TOP_TOD_NS_CFG_TOD_NS_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TOD_MPCP_CFG_TOD_MPCP_FIELD;
#define EPON_TOP_TOD_MPCP_CFG_TOD_MPCP_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_TOD_MPCP_CFG_TOD_MPCP_FIELD_WIDTH 32
#define EPON_TOP_TOD_MPCP_CFG_TOD_MPCP_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TS48_MSB_RESERVED0_FIELD;
#define EPON_TOP_TS48_MSB_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPON_TOP_TS48_MSB_RESERVED0_FIELD_WIDTH 16
#define EPON_TOP_TS48_MSB_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPON_TOP_TS48_MSB_TS48_EPON_READ_MSB_FIELD;
#define EPON_TOP_TS48_MSB_TS48_EPON_READ_MSB_FIELD_MASK  0x000000000000ffff
#define EPON_TOP_TS48_MSB_TS48_EPON_READ_MSB_FIELD_WIDTH 16
#define EPON_TOP_TS48_MSB_TS48_EPON_READ_MSB_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TS48_LSB_TS48_EPON_READ_LSB_FIELD;
#define EPON_TOP_TS48_LSB_TS48_EPON_READ_LSB_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_TS48_LSB_TS48_EPON_READ_LSB_FIELD_WIDTH 32
#define EPON_TOP_TS48_LSB_TS48_EPON_READ_LSB_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TSEC_RESERVED0_FIELD;
#define EPON_TOP_TSEC_RESERVED0_FIELD_MASK  0x00000000fff80000
#define EPON_TOP_TSEC_RESERVED0_FIELD_WIDTH 13
#define EPON_TOP_TSEC_RESERVED0_FIELD_SHIFT 19

extern const ru_field_rec EPON_TOP_TSEC_TSEC_EPON_READ_FIELD;
#define EPON_TOP_TSEC_TSEC_EPON_READ_FIELD_MASK  0x000000000007ffff
#define EPON_TOP_TSEC_TSEC_EPON_READ_FIELD_WIDTH 19
#define EPON_TOP_TSEC_TSEC_EPON_READ_FIELD_SHIFT 0

extern const ru_field_rec EPON_TOP_TNS_EPON_TNS_EPON_READ_FIELD;
#define EPON_TOP_TNS_EPON_TNS_EPON_READ_FIELD_MASK  0x00000000ffffffff
#define EPON_TOP_TNS_EPON_TNS_EPON_READ_FIELD_WIDTH 32
#define EPON_TOP_TNS_EPON_TNS_EPON_READ_FIELD_SHIFT 0

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKSEL_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKSEL_FIELD_MASK  0x00000000e0000000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKSEL_FIELD_WIDTH 3
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKSEL_FIELD_SHIFT 29

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_RESERVED0_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_RESERVED0_FIELD_MASK  0x0000000010000000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_RESERVED0_FIELD_WIDTH 1
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKDIVIDE_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKDIVIDE_FIELD_MASK  0x000000000fffffff
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKDIVIDE_FIELD_WIDTH 28
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_CFGPRGCLKDIVIDE_FIELD_SHIFT 0

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_RESERVED0_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_RESERVED0_FIELD_MASK  0x00000000ffffe000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_RESERVED0_FIELD_WIDTH 19
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_RESERVED0_FIELD_SHIFT 13

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_CFGPRGCLKDENOM_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_CFGPRGCLKDENOM_FIELD_MASK  0x0000000000001fff
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_CFGPRGCLKDENOM_FIELD_WIDTH 13
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_CFGPRGCLKDENOM_FIELD_SHIFT 0

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKSEL_1_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKSEL_1_FIELD_MASK  0x00000000e0000000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKSEL_1_FIELD_WIDTH 3
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKSEL_1_FIELD_SHIFT 29

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_RESERVED0_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_RESERVED0_FIELD_MASK  0x0000000010000000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_RESERVED0_FIELD_WIDTH 1
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKDIVIDE_1_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKDIVIDE_1_FIELD_MASK  0x000000000fffffff
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKDIVIDE_1_FIELD_WIDTH 28
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_CFGPRGCLKDIVIDE_1_FIELD_SHIFT 0

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_RESERVED0_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_RESERVED0_FIELD_MASK  0x00000000ffffe000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_RESERVED0_FIELD_WIDTH 19
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_RESERVED0_FIELD_SHIFT 13

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_CFGPRGCLKDENOM_1_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_CFGPRGCLKDENOM_1_FIELD_MASK  0x0000000000001fff
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_CFGPRGCLKDENOM_1_FIELD_WIDTH 13
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_CFGPRGCLKDENOM_1_FIELD_SHIFT 0

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSOFFSET_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSOFFSET_FIELD_MASK  0x00000000ffff0000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSOFFSET_FIELD_WIDTH 16
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSOFFSET_FIELD_SHIFT 16

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSTRACKGAIN_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSTRACKGAIN_FIELD_MASK  0x000000000000f000
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSTRACKGAIN_FIELD_WIDTH 4
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSTRACKGAIN_FIELD_SHIFT 12

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_RESERVED0_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_RESERVED0_FIELD_MASK  0x0000000000000ff0
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_RESERVED0_FIELD_WIDTH 8
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_RESERVED0_FIELD_SHIFT 4

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGOUTCLKINV_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGOUTCLKINV_FIELD_MASK  0x0000000000000008
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGOUTCLKINV_FIELD_WIDTH 1
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGOUTCLKINV_FIELD_SHIFT 3

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSTRACKEN_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSTRACKEN_FIELD_MASK  0x0000000000000004
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSTRACKEN_FIELD_WIDTH 1
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSTRACKEN_FIELD_SHIFT 2

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSALIGNEN_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSALIGNEN_FIELD_MASK  0x0000000000000002
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSALIGNEN_FIELD_WIDTH 1
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSALIGNEN_FIELD_SHIFT 1

extern const ru_field_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSSELECT_FIELD;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSSELECT_FIELD_MASK  0x0000000000000001
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSSELECT_FIELD_WIDTH 1
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_CFGPPSSELECT_FIELD_SHIFT 0

extern const ru_field_rec EPN_CONTROL_0_CFGEN1588TS_FIELD;
#define EPN_CONTROL_0_CFGEN1588TS_FIELD_MASK  0x0000000080000000
#define EPN_CONTROL_0_CFGEN1588TS_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGEN1588TS_FIELD_SHIFT 31

extern const ru_field_rec EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD;
#define EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD_MASK  0x0000000040000000
#define EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGREPLACEUPFCS_FIELD_SHIFT 30

extern const ru_field_rec EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD;
#define EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD_MASK  0x0000000020000000
#define EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGAPPENDUPFCS_FIELD_SHIFT 29

extern const ru_field_rec EPN_CONTROL_0_CFGDROPSCB_FIELD;
#define EPN_CONTROL_0_CFGDROPSCB_FIELD_MASK  0x0000000010000000
#define EPN_CONTROL_0_CFGDROPSCB_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGDROPSCB_FIELD_SHIFT 28

extern const ru_field_rec EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD;
#define EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD_MASK  0x0000000008000000
#define EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD_WIDTH 1
#define EPN_CONTROL_0_MODUNCAPPEDREPORTLIMIT_FIELD_SHIFT 27

extern const ru_field_rec EPN_CONTROL_0_MODMPQUESETFIRST_FIELD;
#define EPN_CONTROL_0_MODMPQUESETFIRST_FIELD_MASK  0x0000000004000000
#define EPN_CONTROL_0_MODMPQUESETFIRST_FIELD_WIDTH 1
#define EPN_CONTROL_0_MODMPQUESETFIRST_FIELD_SHIFT 26

extern const ru_field_rec EPN_CONTROL_0_RESERVED0_FIELD;
#define EPN_CONTROL_0_RESERVED0_FIELD_MASK  0x0000000002000000
#define EPN_CONTROL_0_RESERVED0_FIELD_WIDTH 1
#define EPN_CONTROL_0_RESERVED0_FIELD_SHIFT 25

extern const ru_field_rec EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD;
#define EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD_MASK  0x0000000001000000
#define EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVLOCALMPCPPROPAGATION_FIELD_SHIFT 24

extern const ru_field_rec EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD;
#define EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD_MASK  0x0000000000800000
#define EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVTEKMODEPREFETCH_FIELD_SHIFT 23

extern const ru_field_rec EPN_CONTROL_0_RESERVED1_FIELD;
#define EPN_CONTROL_0_RESERVED1_FIELD_MASK  0x0000000000600000
#define EPN_CONTROL_0_RESERVED1_FIELD_WIDTH 2
#define EPN_CONTROL_0_RESERVED1_FIELD_SHIFT 21

extern const ru_field_rec EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD;
#define EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD_MASK  0x0000000000100000
#define EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVNOUNMAPPPEDFCS_FIELD_SHIFT 20

extern const ru_field_rec EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD;
#define EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD_MASK  0x0000000000080000
#define EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVSUPRESSDISCEN_FIELD_SHIFT 19

extern const ru_field_rec EPN_CONTROL_0_CFGVLANMAX_FIELD;
#define EPN_CONTROL_0_CFGVLANMAX_FIELD_MASK  0x0000000000040000
#define EPN_CONTROL_0_CFGVLANMAX_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGVLANMAX_FIELD_SHIFT 18

extern const ru_field_rec EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD;
#define EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD_MASK  0x0000000000020000
#define EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD_WIDTH 1
#define EPN_CONTROL_0_FCSERRONLYDATAFR_FIELD_SHIFT 17

extern const ru_field_rec EPN_CONTROL_0_RESERVED2_FIELD;
#define EPN_CONTROL_0_RESERVED2_FIELD_MASK  0x000000000001e000
#define EPN_CONTROL_0_RESERVED2_FIELD_WIDTH 4
#define EPN_CONTROL_0_RESERVED2_FIELD_SHIFT 13

extern const ru_field_rec EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD;
#define EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD_MASK  0x0000000000001000
#define EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVDROPUNMAPPPEDLLID_FIELD_SHIFT 12

extern const ru_field_rec EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD;
#define EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD_MASK  0x0000000000000800
#define EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVSUPPRESSLLIDMODEBIT_FIELD_SHIFT 11

extern const ru_field_rec EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD;
#define EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD_MASK  0x0000000000000400
#define EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD_WIDTH 1
#define EPN_CONTROL_0_MODDISCOVERYDAFILTEREN_FIELD_SHIFT 10

extern const ru_field_rec EPN_CONTROL_0_RPTSELECT_FIELD;
#define EPN_CONTROL_0_RPTSELECT_FIELD_MASK  0x0000000000000300
#define EPN_CONTROL_0_RPTSELECT_FIELD_WIDTH 2
#define EPN_CONTROL_0_RPTSELECT_FIELD_SHIFT 8

extern const ru_field_rec EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD;
#define EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD_MASK  0x0000000000000080
#define EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD_WIDTH 1
#define EPN_CONTROL_0_PRVDISABLESVAQUESTATUSBP_FIELD_SHIFT 7

extern const ru_field_rec EPN_CONTROL_0_UTXLOOPBACK_FIELD;
#define EPN_CONTROL_0_UTXLOOPBACK_FIELD_MASK  0x0000000000000040
#define EPN_CONTROL_0_UTXLOOPBACK_FIELD_WIDTH 1
#define EPN_CONTROL_0_UTXLOOPBACK_FIELD_SHIFT 6

extern const ru_field_rec EPN_CONTROL_0_UTXEN_FIELD;
#define EPN_CONTROL_0_UTXEN_FIELD_MASK  0x0000000000000020
#define EPN_CONTROL_0_UTXEN_FIELD_WIDTH 1
#define EPN_CONTROL_0_UTXEN_FIELD_SHIFT 5

extern const ru_field_rec EPN_CONTROL_0_UTXRST_PRE_N_FIELD;
#define EPN_CONTROL_0_UTXRST_PRE_N_FIELD_MASK  0x0000000000000010
#define EPN_CONTROL_0_UTXRST_PRE_N_FIELD_WIDTH 1
#define EPN_CONTROL_0_UTXRST_PRE_N_FIELD_SHIFT 4

extern const ru_field_rec EPN_CONTROL_0_CFGDISABLEDNS_FIELD;
#define EPN_CONTROL_0_CFGDISABLEDNS_FIELD_MASK  0x0000000000000008
#define EPN_CONTROL_0_CFGDISABLEDNS_FIELD_WIDTH 1
#define EPN_CONTROL_0_CFGDISABLEDNS_FIELD_SHIFT 3

extern const ru_field_rec EPN_CONTROL_0_DRXLOOPBACK_FIELD;
#define EPN_CONTROL_0_DRXLOOPBACK_FIELD_MASK  0x0000000000000004
#define EPN_CONTROL_0_DRXLOOPBACK_FIELD_WIDTH 1
#define EPN_CONTROL_0_DRXLOOPBACK_FIELD_SHIFT 2

extern const ru_field_rec EPN_CONTROL_0_DRXEN_FIELD;
#define EPN_CONTROL_0_DRXEN_FIELD_MASK  0x0000000000000002
#define EPN_CONTROL_0_DRXEN_FIELD_WIDTH 1
#define EPN_CONTROL_0_DRXEN_FIELD_SHIFT 1

extern const ru_field_rec EPN_CONTROL_0_DRXRST_PRE_N_FIELD;
#define EPN_CONTROL_0_DRXRST_PRE_N_FIELD_MASK  0x0000000000000001
#define EPN_CONTROL_0_DRXRST_PRE_N_FIELD_WIDTH 1
#define EPN_CONTROL_0_DRXRST_PRE_N_FIELD_SHIFT 0

extern const ru_field_rec EPN_CONTROL_1_RESERVED0_FIELD;
#define EPN_CONTROL_1_RESERVED0_FIELD_MASK  0x00000000ff800000
#define EPN_CONTROL_1_RESERVED0_FIELD_WIDTH 9
#define EPN_CONTROL_1_RESERVED0_FIELD_SHIFT 23

extern const ru_field_rec EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD;
#define EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD_MASK  0x0000000000400000
#define EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGDISABLEMPCPCORRECTIONDITHERING_FIELD_SHIFT 22

extern const ru_field_rec EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD;
#define EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD_MASK  0x0000000000200000
#define EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD_WIDTH 1
#define EPN_CONTROL_1_PRVOVERLAPPEDGNTENABLE_FIELD_SHIFT 21

extern const ru_field_rec EPN_CONTROL_1_RSTMISALIGNTHR_FIELD;
#define EPN_CONTROL_1_RSTMISALIGNTHR_FIELD_MASK  0x0000000000100000
#define EPN_CONTROL_1_RSTMISALIGNTHR_FIELD_WIDTH 1
#define EPN_CONTROL_1_RSTMISALIGNTHR_FIELD_SHIFT 20

extern const ru_field_rec EPN_CONTROL_1_RESERVED1_FIELD;
#define EPN_CONTROL_1_RESERVED1_FIELD_MASK  0x0000000000080000
#define EPN_CONTROL_1_RESERVED1_FIELD_WIDTH 1
#define EPN_CONTROL_1_RESERVED1_FIELD_SHIFT 19

extern const ru_field_rec EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD;
#define EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD_MASK  0x0000000000040000
#define EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGSTALEGNTCHK_FIELD_SHIFT 18

extern const ru_field_rec EPN_CONTROL_1_FECRPTEN_FIELD;
#define EPN_CONTROL_1_FECRPTEN_FIELD_MASK  0x0000000000020000
#define EPN_CONTROL_1_FECRPTEN_FIELD_WIDTH 1
#define EPN_CONTROL_1_FECRPTEN_FIELD_SHIFT 17

extern const ru_field_rec EPN_CONTROL_1_RESERVED2_FIELD;
#define EPN_CONTROL_1_RESERVED2_FIELD_MASK  0x000000000001ff00
#define EPN_CONTROL_1_RESERVED2_FIELD_WIDTH 9
#define EPN_CONTROL_1_RESERVED2_FIELD_SHIFT 8

extern const ru_field_rec EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD;
#define EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD_MASK  0x0000000000000080
#define EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGL1L2TRUESTRICT_FIELD_SHIFT 7

extern const ru_field_rec EPN_CONTROL_1_CFGCTCRPT_FIELD;
#define EPN_CONTROL_1_CFGCTCRPT_FIELD_MASK  0x0000000000000060
#define EPN_CONTROL_1_CFGCTCRPT_FIELD_WIDTH 2
#define EPN_CONTROL_1_CFGCTCRPT_FIELD_SHIFT 5

extern const ru_field_rec EPN_CONTROL_1_CFGTSCORRDIS_FIELD;
#define EPN_CONTROL_1_CFGTSCORRDIS_FIELD_MASK  0x0000000000000010
#define EPN_CONTROL_1_CFGTSCORRDIS_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGTSCORRDIS_FIELD_SHIFT 4

extern const ru_field_rec EPN_CONTROL_1_CFGNODISCRPT_FIELD;
#define EPN_CONTROL_1_CFGNODISCRPT_FIELD_MASK  0x0000000000000008
#define EPN_CONTROL_1_CFGNODISCRPT_FIELD_WIDTH 1
#define EPN_CONTROL_1_CFGNODISCRPT_FIELD_SHIFT 3

extern const ru_field_rec EPN_CONTROL_1_DISABLEDISCSCALE_FIELD;
#define EPN_CONTROL_1_DISABLEDISCSCALE_FIELD_MASK  0x0000000000000004
#define EPN_CONTROL_1_DISABLEDISCSCALE_FIELD_WIDTH 1
#define EPN_CONTROL_1_DISABLEDISCSCALE_FIELD_SHIFT 2

extern const ru_field_rec EPN_CONTROL_1_CLRONRD_FIELD;
#define EPN_CONTROL_1_CLRONRD_FIELD_MASK  0x0000000000000002
#define EPN_CONTROL_1_CLRONRD_FIELD_WIDTH 1
#define EPN_CONTROL_1_CLRONRD_FIELD_SHIFT 1

extern const ru_field_rec EPN_ENABLE_GRANTS_RESERVED0_FIELD;
#define EPN_ENABLE_GRANTS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_ENABLE_GRANTS_RESERVED0_FIELD_WIDTH 24
#define EPN_ENABLE_GRANTS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT7_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT7_FIELD_MASK  0x0000000000000080
#define EPN_ENABLE_GRANTS_ENGNT7_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT6_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT6_FIELD_MASK  0x0000000000000040
#define EPN_ENABLE_GRANTS_ENGNT6_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT5_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT5_FIELD_MASK  0x0000000000000020
#define EPN_ENABLE_GRANTS_ENGNT5_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT4_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT4_FIELD_MASK  0x0000000000000010
#define EPN_ENABLE_GRANTS_ENGNT4_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT3_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT3_FIELD_MASK  0x0000000000000008
#define EPN_ENABLE_GRANTS_ENGNT3_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT2_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT2_FIELD_MASK  0x0000000000000004
#define EPN_ENABLE_GRANTS_ENGNT2_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT1_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT1_FIELD_MASK  0x0000000000000002
#define EPN_ENABLE_GRANTS_ENGNT1_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_ENABLE_GRANTS_ENGNT0_FIELD;
#define EPN_ENABLE_GRANTS_ENGNT0_FIELD_MASK  0x0000000000000001
#define EPN_ENABLE_GRANTS_ENGNT0_FIELD_WIDTH 1
#define EPN_ENABLE_GRANTS_ENGNT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DROP_DISC_GATES_RESERVED0_FIELD;
#define EPN_DROP_DISC_GATES_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_DROP_DISC_GATES_RESERVED0_FIELD_WIDTH 24
#define EPN_DROP_DISC_GATES_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD_MASK  0x0000000000000080
#define EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD_MASK  0x0000000000000040
#define EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD_MASK  0x0000000000000020
#define EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD_MASK  0x0000000000000010
#define EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD_MASK  0x0000000000000008
#define EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD_MASK  0x0000000000000004
#define EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD_MASK  0x0000000000000002
#define EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD;
#define EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD_MASK  0x0000000000000001
#define EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD_WIDTH 1
#define EPN_DROP_DISC_GATES_SINKDISCGATES0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DIS_FCS_CHK_RESERVED0_FIELD;
#define EPN_DIS_FCS_CHK_RESERVED0_FIELD_MASK  0x00000000ff000000
#define EPN_DIS_FCS_CHK_RESERVED0_FIELD_WIDTH 8
#define EPN_DIS_FCS_CHK_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHKDN23_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN23_FIELD_MASK  0x0000000000800000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN23_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN23_FIELD_SHIFT 23

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHKDN22_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN22_FIELD_MASK  0x0000000000400000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN22_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN22_FIELD_SHIFT 22

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHKDN21_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN21_FIELD_MASK  0x0000000000200000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN21_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN21_FIELD_SHIFT 21

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHKDN20_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN20_FIELD_MASK  0x0000000000100000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN20_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN20_FIELD_SHIFT 20

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHKDN19_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN19_FIELD_MASK  0x0000000000080000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN19_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN19_FIELD_SHIFT 19

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHKDN18_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN18_FIELD_MASK  0x0000000000040000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN18_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN18_FIELD_SHIFT 18

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHKDN17_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN17_FIELD_MASK  0x0000000000020000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN17_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN17_FIELD_SHIFT 17

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHKDN16_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN16_FIELD_MASK  0x0000000000010000
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN16_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHKDN16_FIELD_SHIFT 16

extern const ru_field_rec EPN_DIS_FCS_CHK_RESERVED1_FIELD;
#define EPN_DIS_FCS_CHK_RESERVED1_FIELD_MASK  0x000000000000ff00
#define EPN_DIS_FCS_CHK_RESERVED1_FIELD_WIDTH 8
#define EPN_DIS_FCS_CHK_RESERVED1_FIELD_SHIFT 8

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD_MASK  0x0000000000000080
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD_MASK  0x0000000000000040
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD_MASK  0x0000000000000020
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD_MASK  0x0000000000000010
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD_MASK  0x0000000000000008
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD_MASK  0x0000000000000004
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD_MASK  0x0000000000000002
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD;
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD_MASK  0x0000000000000001
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD_WIDTH 1
#define EPN_DIS_FCS_CHK_DISABLEFCSCHK0_FIELD_SHIFT 0

extern const ru_field_rec EPN_PASS_GATES_RESERVED0_FIELD;
#define EPN_PASS_GATES_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_PASS_GATES_RESERVED0_FIELD_WIDTH 24
#define EPN_PASS_GATES_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID7_FIELD;
#define EPN_PASS_GATES_PASSGATELLID7_FIELD_MASK  0x0000000000000080
#define EPN_PASS_GATES_PASSGATELLID7_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID7_FIELD_SHIFT 7

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID6_FIELD;
#define EPN_PASS_GATES_PASSGATELLID6_FIELD_MASK  0x0000000000000040
#define EPN_PASS_GATES_PASSGATELLID6_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID6_FIELD_SHIFT 6

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID5_FIELD;
#define EPN_PASS_GATES_PASSGATELLID5_FIELD_MASK  0x0000000000000020
#define EPN_PASS_GATES_PASSGATELLID5_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID5_FIELD_SHIFT 5

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID4_FIELD;
#define EPN_PASS_GATES_PASSGATELLID4_FIELD_MASK  0x0000000000000010
#define EPN_PASS_GATES_PASSGATELLID4_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID4_FIELD_SHIFT 4

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID3_FIELD;
#define EPN_PASS_GATES_PASSGATELLID3_FIELD_MASK  0x0000000000000008
#define EPN_PASS_GATES_PASSGATELLID3_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID3_FIELD_SHIFT 3

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID2_FIELD;
#define EPN_PASS_GATES_PASSGATELLID2_FIELD_MASK  0x0000000000000004
#define EPN_PASS_GATES_PASSGATELLID2_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID2_FIELD_SHIFT 2

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID1_FIELD;
#define EPN_PASS_GATES_PASSGATELLID1_FIELD_MASK  0x0000000000000002
#define EPN_PASS_GATES_PASSGATELLID1_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID1_FIELD_SHIFT 1

extern const ru_field_rec EPN_PASS_GATES_PASSGATELLID0_FIELD;
#define EPN_PASS_GATES_PASSGATELLID0_FIELD_MASK  0x0000000000000001
#define EPN_PASS_GATES_PASSGATELLID0_FIELD_WIDTH 1
#define EPN_PASS_GATES_PASSGATELLID0_FIELD_SHIFT 0

extern const ru_field_rec EPN_CFG_MISALGN_FB_RESERVED0_FIELD;
#define EPN_CFG_MISALGN_FB_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_CFG_MISALGN_FB_RESERVED0_FIELD_WIDTH 24
#define EPN_CFG_MISALGN_FB_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD_MASK  0x0000000000000080
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK7_FIELD_SHIFT 7

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD_MASK  0x0000000000000040
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK6_FIELD_SHIFT 6

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD_MASK  0x0000000000000020
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK5_FIELD_SHIFT 5

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD_MASK  0x0000000000000010
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK4_FIELD_SHIFT 4

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD_MASK  0x0000000000000008
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK3_FIELD_SHIFT 3

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD_MASK  0x0000000000000004
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK2_FIELD_SHIFT 2

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD_MASK  0x0000000000000002
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK1_FIELD_SHIFT 1

extern const ru_field_rec EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD;
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD_MASK  0x0000000000000001
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD_WIDTH 1
#define EPN_CFG_MISALGN_FB_CFGMISALIGNFEEDBACK0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD;
#define EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD_MASK  0x00000000ffff0000
#define EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD_WIDTH 16
#define EPN_DISCOVERY_FILTER_PRVDISCINFOMASK_FIELD_SHIFT 16

extern const ru_field_rec EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD;
#define EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD_MASK  0x000000000000ffff
#define EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD_WIDTH 16
#define EPN_DISCOVERY_FILTER_PRVDISCINFOVALUE_FIELD_SHIFT 0

extern const ru_field_rec EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD;
#define EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD_WIDTH 16
#define EPN_MINIMUM_GRANT_SETUP_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD;
#define EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD_MASK  0x000000000000ffff
#define EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD_WIDTH 16
#define EPN_MINIMUM_GRANT_SETUP_CFGMINGRANTSETUP_FIELD_SHIFT 0

extern const ru_field_rec EPN_RESET_GNT_FIFO_RESERVED0_FIELD;
#define EPN_RESET_GNT_FIFO_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_RESET_GNT_FIFO_RESERVED0_FIELD_WIDTH 24
#define EPN_RESET_GNT_FIFO_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD_MASK  0x0000000000000080
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO7_FIELD_SHIFT 7

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD_MASK  0x0000000000000040
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO6_FIELD_SHIFT 6

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD_MASK  0x0000000000000020
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO5_FIELD_SHIFT 5

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD_MASK  0x0000000000000010
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO4_FIELD_SHIFT 4

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD_MASK  0x0000000000000008
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO3_FIELD_SHIFT 3

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD_MASK  0x0000000000000004
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO2_FIELD_SHIFT 2

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD_MASK  0x0000000000000002
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO1_FIELD_SHIFT 1

extern const ru_field_rec EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD;
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD_MASK  0x0000000000000001
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD_WIDTH 1
#define EPN_RESET_GNT_FIFO_RSTGNTFIFO0_FIELD_SHIFT 0

extern const ru_field_rec EPN_RESET_L1_ACCUMULATOR_RESERVED0_FIELD;
#define EPN_RESET_L1_ACCUMULATOR_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_RESET_L1_ACCUMULATOR_RESERVED0_FIELD_WIDTH 24
#define EPN_RESET_L1_ACCUMULATOR_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD;
#define EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD_MASK  0x00000000000000ff
#define EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD_WIDTH 8
#define EPN_RESET_L1_ACCUMULATOR_CFGL1SCLRACUM_FIELD_SHIFT 0

extern const ru_field_rec EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD;
#define EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD_WIDTH 26
#define EPN_L1_ACCUMULATOR_SEL_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD;
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD_MASK  0x0000000000000038
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD_WIDTH 3
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SUVASIZESEL_FIELD_SHIFT 3

extern const ru_field_rec EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD;
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD_MASK  0x0000000000000007
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD_WIDTH 3
#define EPN_L1_ACCUMULATOR_SEL_CFGL1SSVASIZESEL_FIELD_SHIFT 0

extern const ru_field_rec EPN_L1_SVA_BYTES_RESERVED0_FIELD;
#define EPN_L1_SVA_BYTES_RESERVED0_FIELD_MASK  0x00000000c0000000
#define EPN_L1_SVA_BYTES_RESERVED0_FIELD_WIDTH 2
#define EPN_L1_SVA_BYTES_RESERVED0_FIELD_SHIFT 30

extern const ru_field_rec EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD;
#define EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD_MASK  0x000000003fffffff
#define EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD_WIDTH 30
#define EPN_L1_SVA_BYTES_L1SSVASIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_L1_UVA_BYTES_RESERVED0_FIELD;
#define EPN_L1_UVA_BYTES_RESERVED0_FIELD_MASK  0x00000000c0000000
#define EPN_L1_UVA_BYTES_RESERVED0_FIELD_WIDTH 2
#define EPN_L1_UVA_BYTES_RESERVED0_FIELD_SHIFT 30

extern const ru_field_rec EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD;
#define EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD_MASK  0x000000003fffffff
#define EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD_WIDTH 30
#define EPN_L1_UVA_BYTES_L1SUVASIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_L1_SVA_OVERFLOW_RESERVED0_FIELD;
#define EPN_L1_SVA_OVERFLOW_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_L1_SVA_OVERFLOW_RESERVED0_FIELD_WIDTH 24
#define EPN_L1_SVA_OVERFLOW_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD;
#define EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD_MASK  0x00000000000000ff
#define EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD_WIDTH 8
#define EPN_L1_SVA_OVERFLOW_L1SSVAOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_L1_UVA_OVERFLOW_RESERVED0_FIELD;
#define EPN_L1_UVA_OVERFLOW_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_L1_UVA_OVERFLOW_RESERVED0_FIELD_WIDTH 24
#define EPN_L1_UVA_OVERFLOW_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD;
#define EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD_MASK  0x00000000000000ff
#define EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD_WIDTH 8
#define EPN_L1_UVA_OVERFLOW_L1SUVAOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_RESET_RPT_PRI_RESERVED0_FIELD;
#define EPN_RESET_RPT_PRI_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_RESET_RPT_PRI_RESERVED0_FIELD_WIDTH 16
#define EPN_RESET_RPT_PRI_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD_MASK  0x0000000000008000
#define EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI15_FIELD_SHIFT 15

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD_MASK  0x0000000000004000
#define EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI14_FIELD_SHIFT 14

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD_MASK  0x0000000000002000
#define EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI13_FIELD_SHIFT 13

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD_MASK  0x0000000000001000
#define EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI12_FIELD_SHIFT 12

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD_MASK  0x0000000000000800
#define EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI11_FIELD_SHIFT 11

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD_MASK  0x0000000000000400
#define EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI10_FIELD_SHIFT 10

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD_MASK  0x0000000000000200
#define EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI9_FIELD_SHIFT 9

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD_MASK  0x0000000000000100
#define EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI8_FIELD_SHIFT 8

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD_MASK  0x0000000000000080
#define EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI7_FIELD_SHIFT 7

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD_MASK  0x0000000000000040
#define EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI6_FIELD_SHIFT 6

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD_MASK  0x0000000000000020
#define EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI5_FIELD_SHIFT 5

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD_MASK  0x0000000000000010
#define EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI4_FIELD_SHIFT 4

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD_MASK  0x0000000000000008
#define EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI3_FIELD_SHIFT 3

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD_MASK  0x0000000000000004
#define EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI2_FIELD_SHIFT 2

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD_MASK  0x0000000000000002
#define EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI1_FIELD_SHIFT 1

extern const ru_field_rec EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD;
#define EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD_MASK  0x0000000000000001
#define EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD_WIDTH 1
#define EPN_RESET_RPT_PRI_NULLRPTPRI0_FIELD_SHIFT 0

extern const ru_field_rec EPN_RESET_L2_RPT_FIFO_RESERVED0_FIELD;
#define EPN_RESET_L2_RPT_FIFO_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_RESET_L2_RPT_FIFO_RESERVED0_FIELD_WIDTH 24
#define EPN_RESET_L2_RPT_FIFO_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD;
#define EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD_MASK  0x00000000000000ff
#define EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD_WIDTH 8
#define EPN_RESET_L2_RPT_FIFO_CFGL2SCLRQUE_FIELD_SHIFT 0

extern const ru_field_rec EPN_ENABLE_UPSTREAM_RESERVED0_FIELD;
#define EPN_ENABLE_UPSTREAM_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_ENABLE_UPSTREAM_RESERVED0_FIELD_WIDTH 24
#define EPN_ENABLE_UPSTREAM_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD;
#define EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD_MASK  0x00000000000000ff
#define EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD_WIDTH 8
#define EPN_ENABLE_UPSTREAM_CFGENABLEUPSTREAMREG_FIELD_SHIFT 0

extern const ru_field_rec EPN_ENABLE_UPSTREAM_FB_RESERVED0_FIELD;
#define EPN_ENABLE_UPSTREAM_FB_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_ENABLE_UPSTREAM_FB_RESERVED0_FIELD_WIDTH 24
#define EPN_ENABLE_UPSTREAM_FB_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD;
#define EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD_MASK  0x00000000000000ff
#define EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD_WIDTH 8
#define EPN_ENABLE_UPSTREAM_FB_CFGENABLEUPSTREAMFEEDBACK_FIELD_SHIFT 0

extern const ru_field_rec EPN_ENABLE_UPSTREAM_FEC_RESERVED0_FIELD;
#define EPN_ENABLE_UPSTREAM_FEC_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_ENABLE_UPSTREAM_FEC_RESERVED0_FIELD_WIDTH 24
#define EPN_ENABLE_UPSTREAM_FEC_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD;
#define EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD_MASK  0x00000000000000ff
#define EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD_WIDTH 8
#define EPN_ENABLE_UPSTREAM_FEC_CFGENABLEUPSTREAMFEC_FIELD_SHIFT 0

extern const ru_field_rec EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD;
#define EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD_WIDTH 24
#define EPN_REPORT_BYTE_LENGTH_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD;
#define EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD_MASK  0x00000000000000ff
#define EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD_WIDTH 8
#define EPN_REPORT_BYTE_LENGTH_PRVRPTBYTELEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD;
#define EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD_MASK  0x0000000080000000
#define EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTBBHUPFRABORT_FIELD_SHIFT 31

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD_MASK  0x0000000040000000
#define EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOL2SBURSTCAPOVERFLOWPRES_FIELD_SHIFT 30

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD_MASK  0x0000000020000000
#define EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOEMPTYRPT_FIELD_SHIFT 29

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD;
#define EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD_MASK  0x0000000010000000
#define EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCODRXERRABORTPRES_FIELD_SHIFT 28

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD;
#define EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD_MASK  0x0000000008000000
#define EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTL2SFIFOOVERRUN_FIELD_SHIFT 27

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD_MASK  0x0000000004000000
#define EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCO1588TSINT_FIELD_SHIFT 26

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD;
#define EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD_MASK  0x0000000002000000
#define EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCORPTPRES_FIELD_SHIFT 25

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD_MASK  0x0000000001000000
#define EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTPRES_FIELD_SHIFT 24

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD_MASK  0x0000000000800000
#define EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCODELSTALEGNT_FIELD_SHIFT 23

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD_MASK  0x0000000000400000
#define EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTNONPOLL_FIELD_SHIFT 22

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD_MASK  0x0000000000200000
#define EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTMISALIGN_FIELD_SHIFT 21

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD_MASK  0x0000000000100000
#define EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTTOOFAR_FIELD_SHIFT 20

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD_MASK  0x0000000000080000
#define EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTINTERVAL_FIELD_SHIFT 19

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD_MASK  0x0000000000040000
#define EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTDISCOVERY_FIELD_SHIFT 18

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD_MASK  0x0000000000020000
#define EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTMISSABORT_FIELD_SHIFT 17

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD_MASK  0x0000000000010000
#define EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOGNTFULLABORT_FIELD_SHIFT 16

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD;
#define EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD_MASK  0x0000000000008000
#define EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTBADUPFRLEN_FIELD_SHIFT 15

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD;
#define EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD_MASK  0x0000000000004000
#define EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTUPTARDYPACKET_FIELD_SHIFT 14

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD;
#define EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD_MASK  0x0000000000002000
#define EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTUPRPTFRXMT_FIELD_SHIFT 13

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD;
#define EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD_MASK  0x0000000000001000
#define EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTBIFIFOOVERRUN_FIELD_SHIFT 12

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD;
#define EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD_MASK  0x0000000000000800
#define EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTBURSTGNTTOOBIG_FIELD_SHIFT 11

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD;
#define EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD_MASK  0x0000000000000400
#define EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTWRGNTTOOBIG_FIELD_SHIFT 10

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD;
#define EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD_MASK  0x0000000000000200
#define EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTRCVGNTTOOBIG_FIELD_SHIFT 9

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD;
#define EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD_MASK  0x0000000000000100
#define EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTDNSTATSOVERRUN_FIELD_SHIFT 8

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD;
#define EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD_MASK  0x0000000000000080
#define EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTUPSTATSOVERRUN_FIELD_SHIFT 7

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD;
#define EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD_MASK  0x0000000000000040
#define EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTDNOUTOFORDER_FIELD_SHIFT 6

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD;
#define EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD_MASK  0x0000000000000020
#define EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTTRUANTBBHHALT_FIELD_SHIFT 5

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD;
#define EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD_MASK  0x0000000000000010
#define EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTUPINVLDGNTLEN_FIELD_SHIFT 4

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD;
#define EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD_MASK  0x0000000000000008
#define EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTCOBBHUPSFAULT_FIELD_SHIFT 3

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD;
#define EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD_MASK  0x0000000000000004
#define EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTDNTIMEINSYNC_FIELD_SHIFT 2

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD;
#define EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD_MASK  0x0000000000000002
#define EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTDNTIMENOTINSYNC_FIELD_SHIFT 1

extern const ru_field_rec EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD;
#define EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD_MASK  0x0000000000000001
#define EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD_WIDTH 1
#define EPN_MAIN_INT_STATUS_INTDPORTRDY_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_RESERVED0_FIELD;
#define EPN_GNT_FULL_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_FULL_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_FULL_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD;
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_STATUS_INTDNGNTFULLABORT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_RESERVED0_FIELD;
#define EPN_GNT_FULL_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_FULL_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_FULL_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD;
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD_WIDTH 1
#define EPN_GNT_FULL_INT_MASK_MASKINTDNGNTFULLABORT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_RESERVED0_FIELD;
#define EPN_GNT_MISS_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_MISS_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_MISS_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD;
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_STATUS_INTDNGNTMISSABORT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_RESERVED0_FIELD;
#define EPN_GNT_MISS_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_MISS_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_MISS_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD;
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD_WIDTH 1
#define EPN_GNT_MISS_INT_MASK_MASKINTDNGNTMISSABORT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_RESERVED0_FIELD;
#define EPN_DISC_RX_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_DISC_RX_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_DISC_RX_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD_MASK  0x0000000000000080
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD_MASK  0x0000000000000040
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD_MASK  0x0000000000000020
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD_MASK  0x0000000000000010
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD_MASK  0x0000000000000008
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD_MASK  0x0000000000000004
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD_MASK  0x0000000000000002
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD;
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD_MASK  0x0000000000000001
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_STATUS_INTDNGNTDISCOVERY0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DISC_RX_INT_MASK_RESERVED0_FIELD;
#define EPN_DISC_RX_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_DISC_RX_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_DISC_RX_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD_MASK  0x0000000000000080
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD_MASK  0x0000000000000040
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD_MASK  0x0000000000000020
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD_MASK  0x0000000000000010
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD_MASK  0x0000000000000008
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD_MASK  0x0000000000000004
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD_MASK  0x0000000000000002
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD;
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD_MASK  0x0000000000000001
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD_WIDTH 1
#define EPN_DISC_RX_INT_MASK_MASKINTDNGNTDISCOVERY0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_RESERVED0_FIELD;
#define EPN_GNT_INTV_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_INTV_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_INTV_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD;
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_STATUS_INTDNGNTINTERVAL0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_RESERVED0_FIELD;
#define EPN_GNT_INTV_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_INTV_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_INTV_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD;
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD_WIDTH 1
#define EPN_GNT_INTV_INT_MASK_MASKINTDNGNTINTERVAL0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_RESERVED0_FIELD;
#define EPN_GNT_FAR_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_FAR_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_FAR_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD;
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_STATUS_INTDNGNTTOOFAR0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_RESERVED0_FIELD;
#define EPN_GNT_FAR_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_FAR_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_FAR_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD;
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD_WIDTH 1
#define EPN_GNT_FAR_INT_MASK_MASKDNGNTTOOFAR0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_RESERVED0_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_MISALGN_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_MISALGN_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD;
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_STATUS_INTDNGNTMISALIGN0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_RESERVED0_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_MISALGN_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_MISALGN_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD;
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD_WIDTH 1
#define EPN_GNT_MISALGN_INT_MASK_MASKINTDNGNTMISALIGN0_FIELD_SHIFT 0

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_RESERVED0_FIELD;
#define EPN_NP_GNT_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_NP_GNT_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_NP_GNT_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD_MASK  0x0000000000000080
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL7_FIELD_SHIFT 7

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD_MASK  0x0000000000000040
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL6_FIELD_SHIFT 6

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD_MASK  0x0000000000000020
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL5_FIELD_SHIFT 5

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD_MASK  0x0000000000000010
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL4_FIELD_SHIFT 4

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD_MASK  0x0000000000000008
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL3_FIELD_SHIFT 3

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD_MASK  0x0000000000000004
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL2_FIELD_SHIFT 2

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD_MASK  0x0000000000000002
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL1_FIELD_SHIFT 1

extern const ru_field_rec EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD;
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD_MASK  0x0000000000000001
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_STATUS_INTDNGNTNONPOLL0_FIELD_SHIFT 0

extern const ru_field_rec EPN_NP_GNT_INT_MASK_RESERVED0_FIELD;
#define EPN_NP_GNT_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_NP_GNT_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_NP_GNT_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD_MASK  0x0000000000000080
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL7_FIELD_SHIFT 7

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD_MASK  0x0000000000000040
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL6_FIELD_SHIFT 6

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD_MASK  0x0000000000000020
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL5_FIELD_SHIFT 5

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD_MASK  0x0000000000000010
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL4_FIELD_SHIFT 4

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD_MASK  0x0000000000000008
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL3_FIELD_SHIFT 3

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD_MASK  0x0000000000000004
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL2_FIELD_SHIFT 2

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD_MASK  0x0000000000000002
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL1_FIELD_SHIFT 1

extern const ru_field_rec EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD;
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD_MASK  0x0000000000000001
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD_WIDTH 1
#define EPN_NP_GNT_INT_MASK_MASKDNGNTNONPOLL0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_RESERVED0_FIELD;
#define EPN_DEL_STALE_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_DEL_STALE_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_DEL_STALE_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD_MASK  0x0000000000000080
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD_MASK  0x0000000000000040
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD_MASK  0x0000000000000020
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD_MASK  0x0000000000000010
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD_MASK  0x0000000000000008
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD_MASK  0x0000000000000004
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD_MASK  0x0000000000000002
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD;
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD_MASK  0x0000000000000001
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_STATUS_INTDELSTALEGNT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_RESERVED0_FIELD;
#define EPN_DEL_STALE_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_DEL_STALE_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_DEL_STALE_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD_MASK  0x0000000000000080
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD_MASK  0x0000000000000040
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD_MASK  0x0000000000000020
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD_MASK  0x0000000000000010
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD_MASK  0x0000000000000008
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD_MASK  0x0000000000000004
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD_MASK  0x0000000000000002
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD;
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD_MASK  0x0000000000000001
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD_WIDTH 1
#define EPN_DEL_STALE_INT_MASK_MASKINTDELSTALEGNT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_RESERVED0_FIELD;
#define EPN_GNT_PRES_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_PRES_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_PRES_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD;
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_STATUS_INTDNGNTRDY0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_RESERVED0_FIELD;
#define EPN_GNT_PRES_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_GNT_PRES_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_GNT_PRES_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD_MASK  0x0000000000000080
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY7_FIELD_SHIFT 7

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD_MASK  0x0000000000000040
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY6_FIELD_SHIFT 6

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD_MASK  0x0000000000000020
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY5_FIELD_SHIFT 5

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD_MASK  0x0000000000000010
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY4_FIELD_SHIFT 4

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD_MASK  0x0000000000000008
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY3_FIELD_SHIFT 3

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD_MASK  0x0000000000000004
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY2_FIELD_SHIFT 2

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD_MASK  0x0000000000000002
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY1_FIELD_SHIFT 1

extern const ru_field_rec EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD;
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD_MASK  0x0000000000000001
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD_WIDTH 1
#define EPN_GNT_PRES_INT_MASK_MASKDNGNTRDY0_FIELD_SHIFT 0

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_RESERVED0_FIELD;
#define EPN_RPT_PRES_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_RPT_PRES_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_RPT_PRES_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD_MASK  0x0000000000000080
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO7_FIELD_SHIFT 7

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD_MASK  0x0000000000000040
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO6_FIELD_SHIFT 6

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD_MASK  0x0000000000000020
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO5_FIELD_SHIFT 5

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD_MASK  0x0000000000000010
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO4_FIELD_SHIFT 4

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD_MASK  0x0000000000000008
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO3_FIELD_SHIFT 3

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD_MASK  0x0000000000000004
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO2_FIELD_SHIFT 2

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD_MASK  0x0000000000000002
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO1_FIELD_SHIFT 1

extern const ru_field_rec EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD;
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD_MASK  0x0000000000000001
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_STATUS_INTUPRPTFIFO0_FIELD_SHIFT 0

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_RESERVED0_FIELD;
#define EPN_RPT_PRES_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_RPT_PRES_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_RPT_PRES_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD_MASK  0x0000000000000080
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO7_FIELD_SHIFT 7

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD_MASK  0x0000000000000040
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO6_FIELD_SHIFT 6

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD_MASK  0x0000000000000020
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO5_FIELD_SHIFT 5

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD_MASK  0x0000000000000010
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO4_FIELD_SHIFT 4

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD_MASK  0x0000000000000008
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO3_FIELD_SHIFT 3

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD_MASK  0x0000000000000004
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO2_FIELD_SHIFT 2

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD_MASK  0x0000000000000002
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO1_FIELD_SHIFT 1

extern const ru_field_rec EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD;
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD_MASK  0x0000000000000001
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD_WIDTH 1
#define EPN_RPT_PRES_INT_MASK_MASKINTUPRPTFIFO0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD;
#define EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD_MASK  0x00000000ffffffff
#define EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD_WIDTH 32
#define EPN_DRX_ABORT_INT_STATUS_INTDRXERRABORT_FIELD_SHIFT 0

extern const ru_field_rec EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD;
#define EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD_MASK  0x00000000ffffffff
#define EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD_WIDTH 32
#define EPN_DRX_ABORT_INT_MASK_MASKINTDRXERRABORT_FIELD_SHIFT 0

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_RESERVED0_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_EMPTY_RPT_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_EMPTY_RPT_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD_MASK  0x0000000000000080
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD_MASK  0x0000000000000040
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD_MASK  0x0000000000000020
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD_MASK  0x0000000000000010
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD_MASK  0x0000000000000008
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD_MASK  0x0000000000000004
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD_MASK  0x0000000000000002
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD;
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD_MASK  0x0000000000000001
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_STATUS_INTEMPTYRPT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_RESERVED0_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_EMPTY_RPT_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_EMPTY_RPT_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD_MASK  0x0000000000000080
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD_MASK  0x0000000000000040
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD_MASK  0x0000000000000020
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD_MASK  0x0000000000000010
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD_MASK  0x0000000000000008
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD_MASK  0x0000000000000004
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD_MASK  0x0000000000000002
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD;
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD_MASK  0x0000000000000001
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD_WIDTH 1
#define EPN_EMPTY_RPT_INT_MASK_MASKINTEMPTYRPT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_BCAP_OVERFLOW_INT_STATUS_RESERVED0_FIELD;
#define EPN_BCAP_OVERFLOW_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_BCAP_OVERFLOW_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_BCAP_OVERFLOW_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD;
#define EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD_MASK  0x00000000000000ff
#define EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD_WIDTH 8
#define EPN_BCAP_OVERFLOW_INT_STATUS_INTL2SBURSTCAPOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_BCAP_OVERFLOW_INT_MASK_RESERVED0_FIELD;
#define EPN_BCAP_OVERFLOW_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_BCAP_OVERFLOW_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_BCAP_OVERFLOW_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD;
#define EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD_MASK  0x00000000000000ff
#define EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD_WIDTH 8
#define EPN_BCAP_OVERFLOW_INT_MASK_MASKINTL2SBURSTCAPOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD;
#define EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD_WIDTH 31
#define EPN_BBH_DNS_FAULT_INT_STATUS_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD;
#define EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD_MASK  0x0000000000000001
#define EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD_WIDTH 1
#define EPN_BBH_DNS_FAULT_INT_STATUS_INTBBHDNSOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD;
#define EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD_WIDTH 31
#define EPN_BBH_DNS_FAULT_INT_MASK_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD;
#define EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD_MASK  0x0000000000000001
#define EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD_WIDTH 1
#define EPN_BBH_DNS_FAULT_INT_MASK_MASKINTBBHDNSOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_RESERVED0_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_BBH_UPS_FAULT_INT_STATUS_RESERVED0_FIELD_WIDTH 24
#define EPN_BBH_UPS_FAULT_INT_STATUS_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD_MASK  0x0000000000000080
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD_MASK  0x0000000000000040
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD_MASK  0x0000000000000020
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD_MASK  0x0000000000000010
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD_MASK  0x0000000000000008
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD_MASK  0x0000000000000004
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD_MASK  0x0000000000000002
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD;
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD_MASK  0x0000000000000001
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_STATUS_INTBBHUPSFAULT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_RESERVED0_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_BBH_UPS_FAULT_INT_MASK_RESERVED0_FIELD_WIDTH 24
#define EPN_BBH_UPS_FAULT_INT_MASK_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD_MASK  0x0000000000000080
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT7_FIELD_SHIFT 7

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD_MASK  0x0000000000000040
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT6_FIELD_SHIFT 6

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD_MASK  0x0000000000000020
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT5_FIELD_SHIFT 5

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD_MASK  0x0000000000000010
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT4_FIELD_SHIFT 4

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD_MASK  0x0000000000000008
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT3_FIELD_SHIFT 3

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD_MASK  0x0000000000000004
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT2_FIELD_SHIFT 2

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD_MASK  0x0000000000000002
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT1_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD;
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD_MASK  0x0000000000000001
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD_WIDTH 1
#define EPN_BBH_UPS_FAULT_INT_MASK_MASKINTBBHUPSFAULT0_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD;
#define EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD_WIDTH 31
#define EPN_BBH_UPS_ABORT_INT_STATUS_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD;
#define EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD_MASK  0x0000000000000001
#define EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD_WIDTH 1
#define EPN_BBH_UPS_ABORT_INT_STATUS_TARDYBBHABORT_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD;
#define EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD_WIDTH 31
#define EPN_BBH_UPS_ABORT_INT_MASK_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD;
#define EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD_MASK  0x0000000000000001
#define EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD_WIDTH 1
#define EPN_BBH_UPS_ABORT_INT_MASK_MASKTARDYBBHABORT_FIELD_SHIFT 0

extern const ru_field_rec EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD;
#define EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD_MASK  0x0000000080000000
#define EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_BBHUPFRABORTMASK_FIELD_SHIFT 31

extern const ru_field_rec EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD_MASK  0x0000000040000000
#define EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTL2SBURSTCAPOVERFLOWMASK_FIELD_SHIFT 30

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD_MASK  0x0000000020000000
#define EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOEMPTYRPTMASK_FIELD_SHIFT 29

extern const ru_field_rec EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD_MASK  0x0000000010000000
#define EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTDRXERRABORTMASK_FIELD_SHIFT 28

extern const ru_field_rec EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD_MASK  0x0000000008000000
#define EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTL2SFIFOOVERRUNMASK_FIELD_SHIFT 27

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD_MASK  0x0000000004000000
#define EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCO1588TSMASK_FIELD_SHIFT 26

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD_MASK  0x0000000002000000
#define EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCORPTPRESMASK_FIELD_SHIFT 25

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD_MASK  0x0000000001000000
#define EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTPRESMASK_FIELD_SHIFT 24

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD_MASK  0x0000000000800000
#define EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCODELSTALEGNTMASK_FIELD_SHIFT 23

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD_MASK  0x0000000000400000
#define EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTNONPOLLMASK_FIELD_SHIFT 22

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD_MASK  0x0000000000200000
#define EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTMISALIGNMASK_FIELD_SHIFT 21

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD_MASK  0x0000000000100000
#define EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTTOOFARMASK_FIELD_SHIFT 20

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD_MASK  0x0000000000080000
#define EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTINTERVALMASK_FIELD_SHIFT 19

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD_MASK  0x0000000000040000
#define EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTDISCOVERYMASK_FIELD_SHIFT 18

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD_MASK  0x0000000000020000
#define EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTMISSABORTMASK_FIELD_SHIFT 17

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD_MASK  0x0000000000010000
#define EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOGNTFULLABORTMASK_FIELD_SHIFT 16

extern const ru_field_rec EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD;
#define EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD_MASK  0x0000000000008000
#define EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_BADUPFRLENMASK_FIELD_SHIFT 15

extern const ru_field_rec EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD;
#define EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD_MASK  0x0000000000004000
#define EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_UPTARDYPACKETMASK_FIELD_SHIFT 14

extern const ru_field_rec EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD;
#define EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD_MASK  0x0000000000002000
#define EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_UPRPTFRXMTMASK_FIELD_SHIFT 13

extern const ru_field_rec EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD_MASK  0x0000000000001000
#define EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTBIFIFOOVERRUNMASK_FIELD_SHIFT 12

extern const ru_field_rec EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD;
#define EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD_MASK  0x0000000000000800
#define EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_BURSTGNTTOOBIGMASK_FIELD_SHIFT 11

extern const ru_field_rec EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD;
#define EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD_MASK  0x0000000000000400
#define EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_WRGNTTOOBIGMASK_FIELD_SHIFT 10

extern const ru_field_rec EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD;
#define EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD_MASK  0x0000000000000200
#define EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_RCVGNTTOOBIGMASK_FIELD_SHIFT 9

extern const ru_field_rec EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD;
#define EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD_MASK  0x0000000000000100
#define EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_DNSTATSOVERRUNMASK_FIELD_SHIFT 8

extern const ru_field_rec EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD_MASK  0x0000000000000080
#define EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTUPSTATSOVERRUNMASK_FIELD_SHIFT 7

extern const ru_field_rec EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD;
#define EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD_MASK  0x0000000000000040
#define EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_DNOUTOFORDERMASK_FIELD_SHIFT 6

extern const ru_field_rec EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD;
#define EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD_MASK  0x0000000000000020
#define EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_TRUANTBBHHALTMASK_FIELD_SHIFT 5

extern const ru_field_rec EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD;
#define EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD_MASK  0x0000000000000010
#define EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_UPINVLDGNTLENMASK_FIELD_SHIFT 4

extern const ru_field_rec EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD;
#define EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD_MASK  0x0000000000000008
#define EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_INTCOBBHUPSFAULTMASK_FIELD_SHIFT 3

extern const ru_field_rec EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD;
#define EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD_MASK  0x0000000000000004
#define EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_DNTIMEINSYNCMASK_FIELD_SHIFT 2

extern const ru_field_rec EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD;
#define EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD_MASK  0x0000000000000002
#define EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_DNTIMENOTINSYNCMASK_FIELD_SHIFT 1

extern const ru_field_rec EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD;
#define EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD_MASK  0x0000000000000001
#define EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD_WIDTH 1
#define EPN_MAIN_INT_MASK_DPORTRDYMASK_FIELD_SHIFT 0

extern const ru_field_rec EPN_MAX_GNT_SIZE_RESERVED0_FIELD;
#define EPN_MAX_GNT_SIZE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_MAX_GNT_SIZE_RESERVED0_FIELD_WIDTH 16
#define EPN_MAX_GNT_SIZE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD;
#define EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD_MASK  0x000000000000ffff
#define EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD_WIDTH 16
#define EPN_MAX_GNT_SIZE_MAXGNTSIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_MAX_FRAME_SIZE_RESERVED0_FIELD;
#define EPN_MAX_FRAME_SIZE_RESERVED0_FIELD_MASK  0x00000000fffff800
#define EPN_MAX_FRAME_SIZE_RESERVED0_FIELD_WIDTH 21
#define EPN_MAX_FRAME_SIZE_RESERVED0_FIELD_SHIFT 11

extern const ru_field_rec EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD;
#define EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD_MASK  0x00000000000007ff
#define EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD_WIDTH 11
#define EPN_MAX_FRAME_SIZE_CFGMAXFRAMESIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD;
#define EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD_MASK  0x00000000ffff0000
#define EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD_WIDTH 16
#define EPN_GRANT_OVR_HD_GNTOVRHDFEC_FIELD_SHIFT 16

extern const ru_field_rec EPN_GRANT_OVR_HD_GNTOVRHD_FIELD;
#define EPN_GRANT_OVR_HD_GNTOVRHD_FIELD_MASK  0x000000000000ffff
#define EPN_GRANT_OVR_HD_GNTOVRHD_FIELD_WIDTH 16
#define EPN_GRANT_OVR_HD_GNTOVRHD_FIELD_SHIFT 0

extern const ru_field_rec EPN_POLL_SIZE_POLLSIZEFEC_FIELD;
#define EPN_POLL_SIZE_POLLSIZEFEC_FIELD_MASK  0x00000000ffff0000
#define EPN_POLL_SIZE_POLLSIZEFEC_FIELD_WIDTH 16
#define EPN_POLL_SIZE_POLLSIZEFEC_FIELD_SHIFT 16

extern const ru_field_rec EPN_POLL_SIZE_POLLSIZE_FIELD;
#define EPN_POLL_SIZE_POLLSIZE_FIELD_MASK  0x000000000000ffff
#define EPN_POLL_SIZE_POLLSIZE_FIELD_WIDTH 16
#define EPN_POLL_SIZE_POLLSIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD;
#define EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD_WIDTH 16
#define EPN_DN_RD_GNT_MARGIN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD;
#define EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD_MASK  0x000000000000ffff
#define EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD_WIDTH 16
#define EPN_DN_RD_GNT_MARGIN_RDGNTSTARTMARGIN_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD;
#define EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD_WIDTH 16
#define EPN_GNT_TIME_START_DELTA_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD;
#define EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD_MASK  0x000000000000ffff
#define EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD_WIDTH 16
#define EPN_GNT_TIME_START_DELTA_GNTSTARTTIMEDELTA_FIELD_SHIFT 0

extern const ru_field_rec EPN_TIME_STAMP_DIFF_RESERVED0_FIELD;
#define EPN_TIME_STAMP_DIFF_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_TIME_STAMP_DIFF_RESERVED0_FIELD_WIDTH 16
#define EPN_TIME_STAMP_DIFF_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD;
#define EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD_MASK  0x000000000000ffff
#define EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD_WIDTH 16
#define EPN_TIME_STAMP_DIFF_TIMESTAMPDIFFDELTA_FIELD_SHIFT 0

extern const ru_field_rec EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD;
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD_MASK  0x00000000ffff0000
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD_WIDTH 16
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSETFEC_FIELD_SHIFT 16

extern const ru_field_rec EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD;
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD_MASK  0x000000000000ffff
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD_WIDTH 16
#define EPN_UP_TIME_STAMP_OFF_TIMESTAMPOFFSET_FIELD_SHIFT 0

extern const ru_field_rec EPN_GNT_INTERVAL_RESERVED0_FIELD;
#define EPN_GNT_INTERVAL_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_GNT_INTERVAL_RESERVED0_FIELD_WIDTH 16
#define EPN_GNT_INTERVAL_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_GNT_INTERVAL_GNTINTERVAL_FIELD;
#define EPN_GNT_INTERVAL_GNTINTERVAL_FIELD_MASK  0x000000000000ffff
#define EPN_GNT_INTERVAL_GNTINTERVAL_FIELD_WIDTH 16
#define EPN_GNT_INTERVAL_GNTINTERVAL_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD;
#define EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD_MASK  0x00000000ffff0000
#define EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD_WIDTH 16
#define EPN_DN_GNT_MISALIGN_THR_PRVUNUSEDGNTTHRESHOLD_FIELD_SHIFT 16

extern const ru_field_rec EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD;
#define EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD_MASK  0x000000000000fc00
#define EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD_WIDTH 6
#define EPN_DN_GNT_MISALIGN_THR_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD;
#define EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD_MASK  0x00000000000003ff
#define EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD_WIDTH 10
#define EPN_DN_GNT_MISALIGN_THR_GNTMISALIGNTHRESH_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD;
#define EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD_WIDTH 16
#define EPN_DN_GNT_MISALIGN_PAUSE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD;
#define EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD_MASK  0x000000000000ffff
#define EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD_WIDTH 16
#define EPN_DN_GNT_MISALIGN_PAUSE_GNTMISALIGNPAUSE_FIELD_SHIFT 0

extern const ru_field_rec EPN_NON_POLL_INTV_RESERVED0_FIELD;
#define EPN_NON_POLL_INTV_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_NON_POLL_INTV_RESERVED0_FIELD_WIDTH 16
#define EPN_NON_POLL_INTV_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD;
#define EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD_MASK  0x000000000000ffff
#define EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD_WIDTH 16
#define EPN_NON_POLL_INTV_NONPOLLGNTINTV_FIELD_SHIFT 0

extern const ru_field_rec EPN_FORCE_FCS_ERR_RESERVED0_FIELD;
#define EPN_FORCE_FCS_ERR_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_FORCE_FCS_ERR_RESERVED0_FIELD_WIDTH 24
#define EPN_FORCE_FCS_ERR_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD_MASK  0x0000000000000080
#define EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR7_FIELD_SHIFT 7

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD_MASK  0x0000000000000040
#define EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR6_FIELD_SHIFT 6

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD_MASK  0x0000000000000020
#define EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR5_FIELD_SHIFT 5

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD_MASK  0x0000000000000010
#define EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR4_FIELD_SHIFT 4

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD_MASK  0x0000000000000008
#define EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR3_FIELD_SHIFT 3

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD_MASK  0x0000000000000004
#define EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR2_FIELD_SHIFT 2

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD_MASK  0x0000000000000002
#define EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR1_FIELD_SHIFT 1

extern const ru_field_rec EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD;
#define EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD_MASK  0x0000000000000001
#define EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD_WIDTH 1
#define EPN_FORCE_FCS_ERR_FORCEFCSERR0_FIELD_SHIFT 0

extern const ru_field_rec EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD;
#define EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD_WIDTH 16
#define EPN_GRANT_OVERLAP_LIMIT_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD;
#define EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD_MASK  0x000000000000ffff
#define EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD_WIDTH 16
#define EPN_GRANT_OVERLAP_LIMIT_PRVGRANTOVERLAPLIMIT_FIELD_SHIFT 0

extern const ru_field_rec EPN_AES_CONFIGURATION_0_RESERVED0_FIELD;
#define EPN_AES_CONFIGURATION_0_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_AES_CONFIGURATION_0_RESERVED0_FIELD_WIDTH 16
#define EPN_AES_CONFIGURATION_0_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD;
#define EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD_MASK  0x000000000000ffff
#define EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD_WIDTH 16
#define EPN_AES_CONFIGURATION_0_PRVUPSTREAMAESMODE_0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD;
#define EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD_WIDTH 16
#define EPN_DISC_GRANT_OVR_HD_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD;
#define EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD_MASK  0x000000000000ffff
#define EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD_WIDTH 16
#define EPN_DISC_GRANT_OVR_HD_DISCGNTOVRHD_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD;
#define EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD_MASK  0x00000000fffff000
#define EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD_WIDTH 20
#define EPN_DN_DISCOVERY_SEED_RESERVED0_FIELD_SHIFT 12

extern const ru_field_rec EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD;
#define EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD_MASK  0x0000000000000fff
#define EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD_WIDTH 12
#define EPN_DN_DISCOVERY_SEED_CFGDISCSEED_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_DISCOVERY_INC_RESERVED0_FIELD;
#define EPN_DN_DISCOVERY_INC_RESERVED0_FIELD_MASK  0x00000000fffffc00
#define EPN_DN_DISCOVERY_INC_RESERVED0_FIELD_WIDTH 22
#define EPN_DN_DISCOVERY_INC_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD;
#define EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD_MASK  0x00000000000003ff
#define EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD_WIDTH 10
#define EPN_DN_DISCOVERY_INC_CFGDISCINC_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD;
#define EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD_WIDTH 16
#define EPN_DN_DISCOVERY_SIZE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD;
#define EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD_MASK  0x000000000000ffff
#define EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD_WIDTH 16
#define EPN_DN_DISCOVERY_SIZE_CFGDISCSIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_FEC_IPG_LENGTH_RESERVED0_FIELD;
#define EPN_FEC_IPG_LENGTH_RESERVED0_FIELD_MASK  0x00000000e0000000
#define EPN_FEC_IPG_LENGTH_RESERVED0_FIELD_WIDTH 3
#define EPN_FEC_IPG_LENGTH_RESERVED0_FIELD_SHIFT 29

extern const ru_field_rec EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD;
#define EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD_MASK  0x000000001f000000
#define EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD_WIDTH 5
#define EPN_FEC_IPG_LENGTH_MODIPGPREAMBLEBYTES_FIELD_SHIFT 24

extern const ru_field_rec EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD;
#define EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD_MASK  0x0000000000ff0000
#define EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD_WIDTH 8
#define EPN_FEC_IPG_LENGTH_CFGRPTLEN_FIELD_SHIFT 16

extern const ru_field_rec EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD;
#define EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD_MASK  0x000000000000ff00
#define EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD_WIDTH 8
#define EPN_FEC_IPG_LENGTH_CFGFECRPTLENGTH_FIELD_SHIFT 8

extern const ru_field_rec EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD;
#define EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD_MASK  0x00000000000000ff
#define EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD_WIDTH 8
#define EPN_FEC_IPG_LENGTH_CFGFECIPGLENGTH_FIELD_SHIFT 0

extern const ru_field_rec EPN_FAKE_REPORT_VALUE_EN_RESERVED0_FIELD;
#define EPN_FAKE_REPORT_VALUE_EN_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_FAKE_REPORT_VALUE_EN_RESERVED0_FIELD_WIDTH 24
#define EPN_FAKE_REPORT_VALUE_EN_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD;
#define EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD_MASK  0x00000000000000ff
#define EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD_WIDTH 8
#define EPN_FAKE_REPORT_VALUE_EN_FAKEREPORTVALUEEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD;
#define EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD_MASK  0x00000000ffe00000
#define EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD_WIDTH 11
#define EPN_FAKE_REPORT_VALUE_RESERVED0_FIELD_SHIFT 21

extern const ru_field_rec EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD;
#define EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD_MASK  0x00000000001fffff
#define EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD_WIDTH 21
#define EPN_FAKE_REPORT_VALUE_FAKEREPORTVALUE_FIELD_SHIFT 0

extern const ru_field_rec EPN_BURST_CAP__RESERVED0_FIELD;
#define EPN_BURST_CAP__RESERVED0_FIELD_MASK  0x00000000fff00000
#define EPN_BURST_CAP__RESERVED0_FIELD_WIDTH 12
#define EPN_BURST_CAP__RESERVED0_FIELD_SHIFT 20

extern const ru_field_rec EPN_BURST_CAP__BURSTCAP_FIELD;
#define EPN_BURST_CAP__BURSTCAP_FIELD_MASK  0x00000000000fffff
#define EPN_BURST_CAP__BURSTCAP_FIELD_WIDTH 20
#define EPN_BURST_CAP__BURSTCAP_FIELD_SHIFT 0

extern const ru_field_rec EPN_QUEUE_LLID_MAP__RESERVED0_FIELD;
#define EPN_QUEUE_LLID_MAP__RESERVED0_FIELD_MASK  0x00000000fffffff8
#define EPN_QUEUE_LLID_MAP__RESERVED0_FIELD_WIDTH 29
#define EPN_QUEUE_LLID_MAP__RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec EPN_QUEUE_LLID_MAP__QUELLIDMAP_FIELD;
#define EPN_QUEUE_LLID_MAP__QUELLIDMAP_FIELD_MASK  0x0000000000000007
#define EPN_QUEUE_LLID_MAP__QUELLIDMAP_FIELD_WIDTH 3
#define EPN_QUEUE_LLID_MAP__QUELLIDMAP_FIELD_SHIFT 0

extern const ru_field_rec EPN_VALID_OPCODE_MAP_RESERVED0_FIELD;
#define EPN_VALID_OPCODE_MAP_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_VALID_OPCODE_MAP_RESERVED0_FIELD_WIDTH 16
#define EPN_VALID_OPCODE_MAP_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD;
#define EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD_MASK  0x000000000000ffff
#define EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD_WIDTH 16
#define EPN_VALID_OPCODE_MAP_PRVVALIDMPCPOPCODES_FIELD_SHIFT 0

extern const ru_field_rec EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD;
#define EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD_WIDTH 16
#define EPN_UP_PACKET_TX_MARGIN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD;
#define EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD_MASK  0x000000000000ffff
#define EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD_WIDTH 16
#define EPN_UP_PACKET_TX_MARGIN_UPPACKETTXMARGIN_FIELD_SHIFT 0

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD;
#define EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD_MASK  0x00000000ffffe000
#define EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD_WIDTH 19
#define EPN_MULTI_PRI_CFG_0_RESERVED0_FIELD_SHIFT 13

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD_MASK  0x0000000000001000
#define EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGCTCSCHDEFICITEN_FIELD_SHIFT 12

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD;
#define EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD_MASK  0x0000000000000c00
#define EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD_WIDTH 2
#define EPN_MULTI_PRI_CFG_0_RESERVED1_FIELD_SHIFT 10

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD;
#define EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD_MASK  0x0000000000000300
#define EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD_WIDTH 2
#define EPN_MULTI_PRI_CFG_0_PRVZEROBURSTCAPOVERRIDEMODE_FIELD_SHIFT 8

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD;
#define EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD_MASK  0x0000000000000080
#define EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_RESERVED2_FIELD_SHIFT 7

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD_MASK  0x0000000000000040
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDL2_FIELD_SHIFT 6

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD_MASK  0x0000000000000020
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGSHAREDBURSTCAP_FIELD_SHIFT 5

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD_MASK  0x0000000000000010
#define EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGRPTGNTSOUTST0_FIELD_SHIFT 4

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD_MASK  0x0000000000000008
#define EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGRPTHIPRIFIRST0_FIELD_SHIFT 3

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD_MASK  0x0000000000000004
#define EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGRPTSWAPQS0_FIELD_SHIFT 2

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD;
#define EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD_MASK  0x0000000000000002
#define EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_RESERVED3_FIELD_SHIFT 1

extern const ru_field_rec EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD;
#define EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD_MASK  0x0000000000000001
#define EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD_WIDTH 1
#define EPN_MULTI_PRI_CFG_0_CFGRPTMULTIPRI0_FIELD_SHIFT 0

extern const ru_field_rec EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD;
#define EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD_WIDTH 30
#define EPN_SHARED_BCAP_OVRFLOW_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD;
#define EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD_MASK  0x0000000000000003
#define EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD_WIDTH 2
#define EPN_SHARED_BCAP_OVRFLOW_SHAREDBURSTCAPOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_FORCED_REPORT_EN_RESERVED0_FIELD;
#define EPN_FORCED_REPORT_EN_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_FORCED_REPORT_EN_RESERVED0_FIELD_WIDTH 24
#define EPN_FORCED_REPORT_EN_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD;
#define EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD_MASK  0x00000000000000ff
#define EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD_WIDTH 8
#define EPN_FORCED_REPORT_EN_CFGFORCEREPORTEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD;
#define EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD_WIDTH 26
#define EPN_FORCED_REPORT_MAX_INTERVAL_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD;
#define EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD_MASK  0x000000000000003f
#define EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD_WIDTH 6
#define EPN_FORCED_REPORT_MAX_INTERVAL_CFGMAXREPORTINTERVAL_FIELD_SHIFT 0

extern const ru_field_rec EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD;
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD_MASK  0x0000000080000000
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD_WIDTH 1
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SEN_FIELD_SHIFT 31

extern const ru_field_rec EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD;
#define EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD_MASK  0x0000000040000000
#define EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD_WIDTH 1
#define EPN_L2S_FLUSH_CONFIG_FLUSHL2SDONE_FIELD_SHIFT 30

extern const ru_field_rec EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD;
#define EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD_MASK  0x000000003ffffff8
#define EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD_WIDTH 27
#define EPN_L2S_FLUSH_CONFIG_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD;
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD_MASK  0x0000000000000007
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD_WIDTH 3
#define EPN_L2S_FLUSH_CONFIG_CFGFLUSHL2SSEL_FIELD_SHIFT 0

extern const ru_field_rec EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD;
#define EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD_MASK  0x0000000080000000
#define EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD_WIDTH 1
#define EPN_DATA_PORT_COMMAND_DPORTBUSY_FIELD_SHIFT 31

extern const ru_field_rec EPN_DATA_PORT_COMMAND_RESERVED0_FIELD;
#define EPN_DATA_PORT_COMMAND_RESERVED0_FIELD_MASK  0x000000007ffffe00
#define EPN_DATA_PORT_COMMAND_RESERVED0_FIELD_WIDTH 22
#define EPN_DATA_PORT_COMMAND_RESERVED0_FIELD_SHIFT 9

extern const ru_field_rec EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD;
#define EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD_MASK  0x00000000000001f0
#define EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD_WIDTH 5
#define EPN_DATA_PORT_COMMAND_DPORTSELECT_FIELD_SHIFT 4

extern const ru_field_rec EPN_DATA_PORT_COMMAND_RESERVED1_FIELD;
#define EPN_DATA_PORT_COMMAND_RESERVED1_FIELD_MASK  0x000000000000000e
#define EPN_DATA_PORT_COMMAND_RESERVED1_FIELD_WIDTH 3
#define EPN_DATA_PORT_COMMAND_RESERVED1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD;
#define EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD_MASK  0x0000000000000001
#define EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD_WIDTH 1
#define EPN_DATA_PORT_COMMAND_DPORTCONTROL_FIELD_SHIFT 0

extern const ru_field_rec EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD;
#define EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD_MASK  0x00000000ffffc000
#define EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD_WIDTH 18
#define EPN_DATA_PORT_ADDRESS_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD;
#define EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD_MASK  0x0000000000003fff
#define EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD_WIDTH 14
#define EPN_DATA_PORT_ADDRESS_DPORTADDR_FIELD_SHIFT 0

extern const ru_field_rec EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD;
#define EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD_MASK  0x00000000ffffffff
#define EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD_WIDTH 32
#define EPN_DATA_PORT_DATA_0_DPORTDATA0_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD;
#define EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD_WIDTH 32
#define EPN_UNMAP_BIG_CNT_UNMAPBIGERRCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD;
#define EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD_WIDTH 32
#define EPN_UNMAP_FRAME_CNT_UNMAPFRCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD;
#define EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD_WIDTH 32
#define EPN_UNMAP_FCS_CNT_UNMAPFCSERRCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD;
#define EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD_WIDTH 32
#define EPN_UNMAP_GATE_CNT_UNMAPGATECNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD;
#define EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD_WIDTH 32
#define EPN_UNMAP_OAM_CNT_UNMAPOAMCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD;
#define EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD_WIDTH 32
#define EPN_UNMAP_SMALL_CNT_UNMAPSMALLERRCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD;
#define EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD_WIDTH 32
#define EPN_FIF_DEQUEUE_EVENT_CNT_FIFDEQUEUEEVENTCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_UNUSED_TQ_CNT_UNUSEDTQCNT_FIELD;
#define EPN_UNUSED_TQ_CNT_UNUSEDTQCNT_FIELD_MASK  0x00000000ffffffff
#define EPN_UNUSED_TQ_CNT_UNUSEDTQCNT_FIELD_WIDTH 32
#define EPN_UNUSED_TQ_CNT_UNUSEDTQCNT_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UP_FAULT_HALT_EN_RESERVED0_FIELD;
#define EPN_BBH_UP_FAULT_HALT_EN_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_BBH_UP_FAULT_HALT_EN_RESERVED0_FIELD_WIDTH 24
#define EPN_BBH_UP_FAULT_HALT_EN_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD;
#define EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD_MASK  0x00000000000000ff
#define EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD_WIDTH 8
#define EPN_BBH_UP_FAULT_HALT_EN_BBHUPSFAULTHALTEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD;
#define EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD_MASK  0x00000000fffffffe
#define EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD_WIDTH 31
#define EPN_BBH_UP_TARDY_HALT_EN_RESERVED0_FIELD_SHIFT 1

extern const ru_field_rec EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD;
#define EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD_MASK  0x0000000000000001
#define EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD_WIDTH 1
#define EPN_BBH_UP_TARDY_HALT_EN_FATALTARDYBBHABORTEN_FIELD_SHIFT 0

extern const ru_field_rec EPN_DEBUG_STATUS_0_RESERVED0_FIELD;
#define EPN_DEBUG_STATUS_0_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_DEBUG_STATUS_0_RESERVED0_FIELD_WIDTH 16
#define EPN_DEBUG_STATUS_0_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD;
#define EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD_MASK  0x000000000000ff00
#define EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD_WIDTH 8
#define EPN_DEBUG_STATUS_0_L2SQUEFULLDEBUG_FIELD_SHIFT 8

extern const ru_field_rec EPN_DEBUG_STATUS_0_RESERVED1_FIELD;
#define EPN_DEBUG_STATUS_0_RESERVED1_FIELD_MASK  0x00000000000000e0
#define EPN_DEBUG_STATUS_0_RESERVED1_FIELD_WIDTH 3
#define EPN_DEBUG_STATUS_0_RESERVED1_FIELD_SHIFT 5

extern const ru_field_rec EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD;
#define EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD_MASK  0x0000000000000010
#define EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_0_DNDLUFULL_FIELD_SHIFT 4

extern const ru_field_rec EPN_DEBUG_STATUS_0_DNSECFULL_FIELD;
#define EPN_DEBUG_STATUS_0_DNSECFULL_FIELD_MASK  0x0000000000000008
#define EPN_DEBUG_STATUS_0_DNSECFULL_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_0_DNSECFULL_FIELD_SHIFT 3

extern const ru_field_rec EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD;
#define EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD_MASK  0x0000000000000004
#define EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_0_EPNLIFFIFOFULL_FIELD_SHIFT 2

extern const ru_field_rec EPN_DEBUG_STATUS_1_RESERVED0_FIELD;
#define EPN_DEBUG_STATUS_1_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_DEBUG_STATUS_1_RESERVED0_FIELD_WIDTH 24
#define EPN_DEBUG_STATUS_1_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY7_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY7_FIELD_MASK  0x0000000000000080
#define EPN_DEBUG_STATUS_1_GNTRDY7_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY7_FIELD_SHIFT 7

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY6_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY6_FIELD_MASK  0x0000000000000040
#define EPN_DEBUG_STATUS_1_GNTRDY6_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY6_FIELD_SHIFT 6

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY5_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY5_FIELD_MASK  0x0000000000000020
#define EPN_DEBUG_STATUS_1_GNTRDY5_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY5_FIELD_SHIFT 5

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY4_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY4_FIELD_MASK  0x0000000000000010
#define EPN_DEBUG_STATUS_1_GNTRDY4_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY4_FIELD_SHIFT 4

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY3_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY3_FIELD_MASK  0x0000000000000008
#define EPN_DEBUG_STATUS_1_GNTRDY3_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY3_FIELD_SHIFT 3

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY2_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY2_FIELD_MASK  0x0000000000000004
#define EPN_DEBUG_STATUS_1_GNTRDY2_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY2_FIELD_SHIFT 2

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY1_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY1_FIELD_MASK  0x0000000000000002
#define EPN_DEBUG_STATUS_1_GNTRDY1_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY1_FIELD_SHIFT 1

extern const ru_field_rec EPN_DEBUG_STATUS_1_GNTRDY0_FIELD;
#define EPN_DEBUG_STATUS_1_GNTRDY0_FIELD_MASK  0x0000000000000001
#define EPN_DEBUG_STATUS_1_GNTRDY0_FIELD_WIDTH 1
#define EPN_DEBUG_STATUS_1_GNTRDY0_FIELD_SHIFT 0

extern const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD;
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD_MASK  0x00000000fff80000
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD_WIDTH 13
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED0_FIELD_SHIFT 19

extern const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD;
#define EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD_MASK  0x0000000000070000
#define EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD_WIDTH 3
#define EPN_DEBUG_L2S_PTR_SEL_CFGL2SDEBUGPTRSEL_FIELD_SHIFT 16

extern const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD;
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD_MASK  0x0000000000008000
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD_WIDTH 1
#define EPN_DEBUG_L2S_PTR_SEL_RESERVED1_FIELD_SHIFT 15

extern const ru_field_rec EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD;
#define EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD_MASK  0x0000000000007fff
#define EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD_WIDTH 15
#define EPN_DEBUG_L2S_PTR_SEL_L2SDEBUGPTRSTATE_FIELD_SHIFT 0

extern const ru_field_rec EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD;
#define EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD_MASK  0x00000000ffffffff
#define EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD_WIDTH 32
#define EPN_OLT_MAC_ADDR_LO_OLTADDRLO_FIELD_SHIFT 0

extern const ru_field_rec EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD;
#define EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD_WIDTH 16
#define EPN_OLT_MAC_ADDR_HI_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD;
#define EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD_MASK  0x000000000000ffff
#define EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD_WIDTH 16
#define EPN_OLT_MAC_ADDR_HI_OLTADDRHI_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_DQU_EMPTY_RESERVED0_FIELD;
#define EPN_TX_L1S_SHP_DQU_EMPTY_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_TX_L1S_SHP_DQU_EMPTY_RESERVED0_FIELD_WIDTH 24
#define EPN_TX_L1S_SHP_DQU_EMPTY_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD;
#define EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD_MASK  0x00000000000000ff
#define EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD_WIDTH 8
#define EPN_TX_L1S_SHP_DQU_EMPTY_L1SDQUQUEEMPTY_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_UNSHAPED_EMPTY_RESERVED0_FIELD;
#define EPN_TX_L1S_UNSHAPED_EMPTY_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_TX_L1S_UNSHAPED_EMPTY_RESERVED0_FIELD_WIDTH 24
#define EPN_TX_L1S_UNSHAPED_EMPTY_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD;
#define EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD_MASK  0x00000000000000ff
#define EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD_WIDTH 8
#define EPN_TX_L1S_UNSHAPED_EMPTY_L1SUNSHAPEDQUEEMPTY_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK__RESERVED0_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK__RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_TX_L1S_SHP_QUE_MASK__RESERVED0_FIELD_WIDTH 24
#define EPN_TX_L1S_SHP_QUE_MASK__RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_MASK__CFGSHPMASK_FIELD;
#define EPN_TX_L1S_SHP_QUE_MASK__CFGSHPMASK_FIELD_MASK  0x00000000000000ff
#define EPN_TX_L1S_SHP_QUE_MASK__CFGSHPMASK_FIELD_WIDTH 8
#define EPN_TX_L1S_SHP_QUE_MASK__CFGSHPMASK_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG__RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_CONFIG__RESERVED0_FIELD_MASK  0x00000000f0000000
#define EPN_TX_L2S_QUE_CONFIG__RESERVED0_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG__RESERVED0_FIELD_SHIFT 28

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG__CFGL2SQUEEND_FIELD;
#define EPN_TX_L2S_QUE_CONFIG__CFGL2SQUEEND_FIELD_MASK  0x000000000fff0000
#define EPN_TX_L2S_QUE_CONFIG__CFGL2SQUEEND_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG__CFGL2SQUEEND_FIELD_SHIFT 16

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG__RESERVED1_FIELD;
#define EPN_TX_L2S_QUE_CONFIG__RESERVED1_FIELD_MASK  0x000000000000f000
#define EPN_TX_L2S_QUE_CONFIG__RESERVED1_FIELD_WIDTH 4
#define EPN_TX_L2S_QUE_CONFIG__RESERVED1_FIELD_SHIFT 12

extern const ru_field_rec EPN_TX_L2S_QUE_CONFIG__CFGL2SQUESTART_FIELD;
#define EPN_TX_L2S_QUE_CONFIG__CFGL2SQUESTART_FIELD_MASK  0x0000000000000fff
#define EPN_TX_L2S_QUE_CONFIG__CFGL2SQUESTART_FIELD_WIDTH 12
#define EPN_TX_L2S_QUE_CONFIG__CFGL2SQUESTART_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_EMPTY_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_EMPTY_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_TX_L2S_QUE_EMPTY_RESERVED0_FIELD_WIDTH 24
#define EPN_TX_L2S_QUE_EMPTY_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD;
#define EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD_MASK  0x00000000000000ff
#define EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD_WIDTH 8
#define EPN_TX_L2S_QUE_EMPTY_L2SQUEEMPTY_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_FULL_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_FULL_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_TX_L2S_QUE_FULL_RESERVED0_FIELD_WIDTH 24
#define EPN_TX_L2S_QUE_FULL_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD;
#define EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD_MASK  0x00000000000000ff
#define EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD_WIDTH 8
#define EPN_TX_L2S_QUE_FULL_L2SQUEFULL_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L2S_QUE_STOPPED_RESERVED0_FIELD;
#define EPN_TX_L2S_QUE_STOPPED_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_TX_L2S_QUE_STOPPED_RESERVED0_FIELD_WIDTH 24
#define EPN_TX_L2S_QUE_STOPPED_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD;
#define EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD_MASK  0x00000000000000ff
#define EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD_WIDTH 8
#define EPN_TX_L2S_QUE_STOPPED_L2SSTOPPEDQUEUES_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT__RESERVED0_FIELD;
#define EPN_TX_CTC_BURST_LIMIT__RESERVED0_FIELD_MASK  0x00000000fffc0000
#define EPN_TX_CTC_BURST_LIMIT__RESERVED0_FIELD_WIDTH 14
#define EPN_TX_CTC_BURST_LIMIT__RESERVED0_FIELD_SHIFT 18

extern const ru_field_rec EPN_TX_CTC_BURST_LIMIT__PRVBURSTLIMIT_FIELD;
#define EPN_TX_CTC_BURST_LIMIT__PRVBURSTLIMIT_FIELD_MASK  0x000000000003ffff
#define EPN_TX_CTC_BURST_LIMIT__PRVBURSTLIMIT_FIELD_WIDTH 18
#define EPN_TX_CTC_BURST_LIMIT__PRVBURSTLIMIT_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD;
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD_MASK  0x00000000fffffc00
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD_WIDTH 22
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_RESERVED0_FIELD_SHIFT 10

extern const ru_field_rec EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD;
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD_MASK  0x00000000000003ff
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD_WIDTH 10
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_CFGMAXOUTSTANDINGTARDYPACKETS_FIELD_SHIFT 0

extern const ru_field_rec EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD;
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD_MASK  0x00000000ffffc000
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD_WIDTH 18
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD;
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD_MASK  0x0000000000003fff
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD_WIDTH 14
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_PRVMINREPORTDIFF_FIELD_SHIFT 0

extern const ru_field_rec EPN_BBH_STATUS_FIFO_OVERFLOW_RESERVED0_FIELD;
#define EPN_BBH_STATUS_FIFO_OVERFLOW_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_BBH_STATUS_FIFO_OVERFLOW_RESERVED0_FIELD_WIDTH 24
#define EPN_BBH_STATUS_FIFO_OVERFLOW_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD;
#define EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD_MASK  0x00000000000000ff
#define EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD_WIDTH 8
#define EPN_BBH_STATUS_FIFO_OVERFLOW_UTXBBHSTATUSFIFOOVERFLOW_FIELD_SHIFT 0

extern const ru_field_rec EPN_SPARE_CTL_CFGEPNSPARE_FIELD;
#define EPN_SPARE_CTL_CFGEPNSPARE_FIELD_MASK  0x00000000fffffffc
#define EPN_SPARE_CTL_CFGEPNSPARE_FIELD_WIDTH 30
#define EPN_SPARE_CTL_CFGEPNSPARE_FIELD_SHIFT 2

extern const ru_field_rec EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD;
#define EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD_MASK  0x0000000000000002
#define EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD_WIDTH 1
#define EPN_SPARE_CTL_ECOUTXSNFENABLE_FIELD_SHIFT 1

extern const ru_field_rec EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD;
#define EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD_MASK  0x0000000000000001
#define EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD_WIDTH 1
#define EPN_SPARE_CTL_ECOJIRA758ENABLE_FIELD_SHIFT 0

extern const ru_field_rec EPN_TS_SYNC_OFFSET_RESERVED0_FIELD;
#define EPN_TS_SYNC_OFFSET_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define EPN_TS_SYNC_OFFSET_RESERVED0_FIELD_WIDTH 26
#define EPN_TS_SYNC_OFFSET_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD;
#define EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD_MASK  0x000000000000003f
#define EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD_WIDTH 6
#define EPN_TS_SYNC_OFFSET_CFGTSSYNCOFFSET_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD;
#define EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD_MASK  0x00000000ffffffff
#define EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD_WIDTH 32
#define EPN_DN_TS_OFFSET_CFGDNTSOFFSET_FIELD_SHIFT 0

extern const ru_field_rec EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD;
#define EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD_MASK  0x00000000ffffffff
#define EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD_WIDTH 32
#define EPN_UP_TS_OFFSET_LO_CFGUPTSOFFSET_LO_FIELD_SHIFT 0

extern const ru_field_rec EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD;
#define EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD_MASK  0x00000000ff000000
#define EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD_WIDTH 8
#define EPN_UP_TS_OFFSET_HI_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec EPN_UP_TS_OFFSET_HI_CFGCMHOFFSET_FIELD;
#define EPN_UP_TS_OFFSET_HI_CFGCMHOFFSET_FIELD_MASK  0x0000000000ff0000
#define EPN_UP_TS_OFFSET_HI_CFGCMHOFFSET_FIELD_WIDTH 8
#define EPN_UP_TS_OFFSET_HI_CFGCMHOFFSET_FIELD_SHIFT 16

extern const ru_field_rec EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD;
#define EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD_MASK  0x000000000000ffff
#define EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD_WIDTH 16
#define EPN_UP_TS_OFFSET_HI_CFGUPTSOFFSET_HI_FIELD_SHIFT 0

extern const ru_field_rec EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD;
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD_MASK  0x0000000080000000
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD_WIDTH 1
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFRD_FIELD_SHIFT 31

extern const ru_field_rec EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD;
#define EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD_MASK  0x000000007ffffff8
#define EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD_WIDTH 28
#define EPN_TWO_STEP_TS_CTL_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD;
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD_MASK  0x0000000000000007
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD_WIDTH 3
#define EPN_TWO_STEP_TS_CTL_TWOSTEPFFENTRIES_FIELD_SHIFT 0

extern const ru_field_rec EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD;
#define EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD_MASK  0x00000000ffffffff
#define EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD_WIDTH 32
#define EPN_TWO_STEP_TS_VALUE_LO_TWOSTEPTIMESTAMP_LO_FIELD_SHIFT 0

extern const ru_field_rec EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD;
#define EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD_WIDTH 16
#define EPN_TWO_STEP_TS_VALUE_HI_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD;
#define EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD_MASK  0x000000000000ffff
#define EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD_WIDTH 16
#define EPN_TWO_STEP_TS_VALUE_HI_TWOSTEPTIMESTAMP_HI_FIELD_SHIFT 0

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD;
#define EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD_WIDTH 30
#define EPN_1588_TIMESTAMP_INT_STATUS_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD;
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD_MASK  0x0000000000000002
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD_WIDTH 1
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588PKTABORT_FIELD_SHIFT 1

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD;
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD_MASK  0x0000000000000001
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD_WIDTH 1
#define EPN_1588_TIMESTAMP_INT_STATUS_INT1588TWOSTEPFFINT_FIELD_SHIFT 0

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD;
#define EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD_MASK  0x00000000fffffffc
#define EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD_WIDTH 30
#define EPN_1588_TIMESTAMP_INT_MASK_RESERVED0_FIELD_SHIFT 2

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD;
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD_MASK  0x0000000000000002
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD_WIDTH 1
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588PKTABORT_MASK_FIELD_SHIFT 1

extern const ru_field_rec EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD;
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD_MASK  0x0000000000000001
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD_WIDTH 1
#define EPN_1588_TIMESTAMP_INT_MASK_TS1588TWOSTEPFF_MASK_FIELD_SHIFT 0

extern const ru_field_rec EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD;
#define EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD_WIDTH 16
#define EPN_UP_PACKET_FETCH_MARGIN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD;
#define EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD_MASK  0x000000000000ffff
#define EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD_WIDTH 16
#define EPN_UP_PACKET_FETCH_MARGIN_UPPACKETFETCHMARGIN_FIELD_SHIFT 0

extern const ru_field_rec EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD;
#define EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD_MASK  0x00000000ffffffff
#define EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD_WIDTH 32
#define EPN_DN_1588_TIMESTAMP_DN_1588_TS_FIELD_SHIFT 0

extern const ru_field_rec EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD;
#define EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD_MASK  0x00000000fc000000
#define EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD_WIDTH 6
#define EPN_PERSISTENT_REPORT_CFG_RESERVED0_FIELD_SHIFT 26

extern const ru_field_rec EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD;
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD_MASK  0x0000000003ff0000
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD_WIDTH 10
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTDURATION_FIELD_SHIFT 16

extern const ru_field_rec EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD;
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD_MASK  0x000000000000ffff
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD_WIDTH 16
#define EPN_PERSISTENT_REPORT_CFG_CFGPERSRPTTICKSIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_PERSISTENT_REPORT_ENABLES_RESERVED0_FIELD;
#define EPN_PERSISTENT_REPORT_ENABLES_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_PERSISTENT_REPORT_ENABLES_RESERVED0_FIELD_WIDTH 24
#define EPN_PERSISTENT_REPORT_ENABLES_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD;
#define EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD_MASK  0x00000000000000ff
#define EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD_WIDTH 8
#define EPN_PERSISTENT_REPORT_ENABLES_CFGPERSRPTENABLE_FIELD_SHIFT 0

extern const ru_field_rec EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD;
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD_WIDTH 16
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD;
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD_MASK  0x000000000000ffff
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD_WIDTH 16
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_CFGPERSRPTREQTQ_FIELD_SHIFT 0

extern const ru_field_rec EPN_ONU_MAC_ADDR_LO_MFGADDRREGLO_FIELD;
#define EPN_ONU_MAC_ADDR_LO_MFGADDRREGLO_FIELD_MASK  0x00000000ff000000
#define EPN_ONU_MAC_ADDR_LO_MFGADDRREGLO_FIELD_WIDTH 8
#define EPN_ONU_MAC_ADDR_LO_MFGADDRREGLO_FIELD_SHIFT 24

extern const ru_field_rec EPN_ONU_MAC_ADDR_LO_ONUADDRREG_FIELD;
#define EPN_ONU_MAC_ADDR_LO_ONUADDRREG_FIELD_MASK  0x0000000000ffffff
#define EPN_ONU_MAC_ADDR_LO_ONUADDRREG_FIELD_WIDTH 24
#define EPN_ONU_MAC_ADDR_LO_ONUADDRREG_FIELD_SHIFT 0

extern const ru_field_rec EPN_ONU_MAC_ADDR_HI_RESERVED0_FIELD;
#define EPN_ONU_MAC_ADDR_HI_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define EPN_ONU_MAC_ADDR_HI_RESERVED0_FIELD_WIDTH 16
#define EPN_ONU_MAC_ADDR_HI_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec EPN_ONU_MAC_ADDR_HI_MFGADDRREGHI_FIELD;
#define EPN_ONU_MAC_ADDR_HI_MFGADDRREGHI_FIELD_MASK  0x000000000000ffff
#define EPN_ONU_MAC_ADDR_HI_MFGADDRREGHI_FIELD_WIDTH 16
#define EPN_ONU_MAC_ADDR_HI_MFGADDRREGHI_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_CONFIG_RESERVED0_FIELD;
#define EPN_TX_L1S_SHP_CONFIG_RESERVED0_FIELD_MASK  0x0000000080000000
#define EPN_TX_L1S_SHP_CONFIG_RESERVED0_FIELD_WIDTH 1
#define EPN_TX_L1S_SHP_CONFIG_RESERVED0_FIELD_SHIFT 31

extern const ru_field_rec EPN_TX_L1S_SHP_CONFIG_CFGSHPRATE_FIELD;
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPRATE_FIELD_MASK  0x000000007fffff00
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPRATE_FIELD_WIDTH 23
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPRATE_FIELD_SHIFT 8

extern const ru_field_rec EPN_TX_L1S_SHP_CONFIG_CFGSHPBSTSIZE_FIELD;
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPBSTSIZE_FIELD_MASK  0x00000000000000ff
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPBSTSIZE_FIELD_WIDTH 8
#define EPN_TX_L1S_SHP_CONFIG_CFGSHPBSTSIZE_FIELD_SHIFT 0

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_EN_RESERVED0_FIELD;
#define EPN_TX_L1S_SHP_QUE_EN_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define EPN_TX_L1S_SHP_QUE_EN_RESERVED0_FIELD_WIDTH 24
#define EPN_TX_L1S_SHP_QUE_EN_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec EPN_TX_L1S_SHP_QUE_EN_CFGSHPEN_FIELD;
#define EPN_TX_L1S_SHP_QUE_EN_CFGSHPEN_FIELD_MASK  0x00000000000000ff
#define EPN_TX_L1S_SHP_QUE_EN_CFGSHPEN_FIELD_WIDTH 8
#define EPN_TX_L1S_SHP_QUE_EN_CFGSHPEN_FIELD_SHIFT 0

extern const ru_field_rec LIF_PON_CONTROL_RESERVED0_FIELD;
#define LIF_PON_CONTROL_RESERVED0_FIELD_MASK  0x00000000c0000000
#define LIF_PON_CONTROL_RESERVED0_FIELD_WIDTH 2
#define LIF_PON_CONTROL_RESERVED0_FIELD_SHIFT 30

extern const ru_field_rec LIF_PON_CONTROL_CFGDISRUNTFILTER_FIELD;
#define LIF_PON_CONTROL_CFGDISRUNTFILTER_FIELD_MASK  0x0000000020000000
#define LIF_PON_CONTROL_CFGDISRUNTFILTER_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFGDISRUNTFILTER_FIELD_SHIFT 29

extern const ru_field_rec LIF_PON_CONTROL_CFMAXCOMMAERRCNT_FIELD;
#define LIF_PON_CONTROL_CFMAXCOMMAERRCNT_FIELD_MASK  0x000000001e000000
#define LIF_PON_CONTROL_CFMAXCOMMAERRCNT_FIELD_WIDTH 4
#define LIF_PON_CONTROL_CFMAXCOMMAERRCNT_FIELD_SHIFT 25

extern const ru_field_rec LIF_PON_CONTROL_CFSYNCSMSELECT_FIELD;
#define LIF_PON_CONTROL_CFSYNCSMSELECT_FIELD_MASK  0x0000000001800000
#define LIF_PON_CONTROL_CFSYNCSMSELECT_FIELD_WIDTH 2
#define LIF_PON_CONTROL_CFSYNCSMSELECT_FIELD_SHIFT 23

extern const ru_field_rec LIF_PON_CONTROL_CFPONRXFORCENONFECABORT_FIELD;
#define LIF_PON_CONTROL_CFPONRXFORCENONFECABORT_FIELD_MASK  0x0000000000400000
#define LIF_PON_CONTROL_CFPONRXFORCENONFECABORT_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFPONRXFORCENONFECABORT_FIELD_SHIFT 22

extern const ru_field_rec LIF_PON_CONTROL_CFPONRXFORCEFECABORT_FIELD;
#define LIF_PON_CONTROL_CFPONRXFORCEFECABORT_FIELD_MASK  0x0000000000200000
#define LIF_PON_CONTROL_CFPONRXFORCEFECABORT_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFPONRXFORCEFECABORT_FIELD_SHIFT 21

extern const ru_field_rec LIF_PON_CONTROL_CFGRXDATABITFLIP_FIELD;
#define LIF_PON_CONTROL_CFGRXDATABITFLIP_FIELD_MASK  0x0000000000100000
#define LIF_PON_CONTROL_CFGRXDATABITFLIP_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFGRXDATABITFLIP_FIELD_SHIFT 20

extern const ru_field_rec LIF_PON_CONTROL_RESERVED1_FIELD;
#define LIF_PON_CONTROL_RESERVED1_FIELD_MASK  0x00000000000e0000
#define LIF_PON_CONTROL_RESERVED1_FIELD_WIDTH 3
#define LIF_PON_CONTROL_RESERVED1_FIELD_SHIFT 17

extern const ru_field_rec LIF_PON_CONTROL_CFENABLESOFTWARESYNCHOLD_FIELD;
#define LIF_PON_CONTROL_CFENABLESOFTWARESYNCHOLD_FIELD_MASK  0x0000000000010000
#define LIF_PON_CONTROL_CFENABLESOFTWARESYNCHOLD_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFENABLESOFTWARESYNCHOLD_FIELD_SHIFT 16

extern const ru_field_rec LIF_PON_CONTROL_CFENABLEEXTENDSYNC_FIELD;
#define LIF_PON_CONTROL_CFENABLEEXTENDSYNC_FIELD_MASK  0x0000000000008000
#define LIF_PON_CONTROL_CFENABLEEXTENDSYNC_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFENABLEEXTENDSYNC_FIELD_SHIFT 15

extern const ru_field_rec LIF_PON_CONTROL_CFENABLEQUICKSYNC_FIELD;
#define LIF_PON_CONTROL_CFENABLEQUICKSYNC_FIELD_MASK  0x0000000000004000
#define LIF_PON_CONTROL_CFENABLEQUICKSYNC_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFENABLEQUICKSYNC_FIELD_SHIFT 14

extern const ru_field_rec LIF_PON_CONTROL_CFPPSEN_FIELD;
#define LIF_PON_CONTROL_CFPPSEN_FIELD_MASK  0x0000000000002000
#define LIF_PON_CONTROL_CFPPSEN_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFPPSEN_FIELD_SHIFT 13

extern const ru_field_rec LIF_PON_CONTROL_CFPPSCLKRBC_FIELD;
#define LIF_PON_CONTROL_CFPPSCLKRBC_FIELD_MASK  0x0000000000001000
#define LIF_PON_CONTROL_CFPPSCLKRBC_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFPPSCLKRBC_FIELD_SHIFT 12

extern const ru_field_rec LIF_PON_CONTROL_CFRX2TXLPBACK_FIELD;
#define LIF_PON_CONTROL_CFRX2TXLPBACK_FIELD_MASK  0x0000000000000800
#define LIF_PON_CONTROL_CFRX2TXLPBACK_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFRX2TXLPBACK_FIELD_SHIFT 11

extern const ru_field_rec LIF_PON_CONTROL_CFTX2RXLPBACK_FIELD;
#define LIF_PON_CONTROL_CFTX2RXLPBACK_FIELD_MASK  0x0000000000000400
#define LIF_PON_CONTROL_CFTX2RXLPBACK_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFTX2RXLPBACK_FIELD_SHIFT 10

extern const ru_field_rec LIF_PON_CONTROL_CFTXDATAENDURLON_FIELD;
#define LIF_PON_CONTROL_CFTXDATAENDURLON_FIELD_MASK  0x0000000000000200
#define LIF_PON_CONTROL_CFTXDATAENDURLON_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFTXDATAENDURLON_FIELD_SHIFT 9

extern const ru_field_rec LIF_PON_CONTROL_CFP2PMODE_FIELD;
#define LIF_PON_CONTROL_CFP2PMODE_FIELD_MASK  0x0000000000000100
#define LIF_PON_CONTROL_CFP2PMODE_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFP2PMODE_FIELD_SHIFT 8

extern const ru_field_rec LIF_PON_CONTROL_CFP2PSHORTPRE_FIELD;
#define LIF_PON_CONTROL_CFP2PSHORTPRE_FIELD_MASK  0x0000000000000080
#define LIF_PON_CONTROL_CFP2PSHORTPRE_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFP2PSHORTPRE_FIELD_SHIFT 7

extern const ru_field_rec LIF_PON_CONTROL_CFLASEREN_FIELD;
#define LIF_PON_CONTROL_CFLASEREN_FIELD_MASK  0x0000000000000040
#define LIF_PON_CONTROL_CFLASEREN_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFLASEREN_FIELD_SHIFT 6

extern const ru_field_rec LIF_PON_CONTROL_CFTXLASERON_FIELD;
#define LIF_PON_CONTROL_CFTXLASERON_FIELD_MASK  0x0000000000000020
#define LIF_PON_CONTROL_CFTXLASERON_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFTXLASERON_FIELD_SHIFT 5

extern const ru_field_rec LIF_PON_CONTROL_CFTXLASERONACTHI_FIELD;
#define LIF_PON_CONTROL_CFTXLASERONACTHI_FIELD_MASK  0x0000000000000010
#define LIF_PON_CONTROL_CFTXLASERONACTHI_FIELD_WIDTH 1
#define LIF_PON_CONTROL_CFTXLASERONACTHI_FIELD_SHIFT 4

extern const ru_field_rec LIF_PON_CONTROL_LIFTXRSTN_PRE_FIELD;
#define LIF_PON_CONTROL_LIFTXRSTN_PRE_FIELD_MASK  0x0000000000000008
#define LIF_PON_CONTROL_LIFTXRSTN_PRE_FIELD_WIDTH 1
#define LIF_PON_CONTROL_LIFTXRSTN_PRE_FIELD_SHIFT 3

extern const ru_field_rec LIF_PON_CONTROL_LIFRXRSTN_PRE_FIELD;
#define LIF_PON_CONTROL_LIFRXRSTN_PRE_FIELD_MASK  0x0000000000000004
#define LIF_PON_CONTROL_LIFRXRSTN_PRE_FIELD_WIDTH 1
#define LIF_PON_CONTROL_LIFRXRSTN_PRE_FIELD_SHIFT 2

extern const ru_field_rec LIF_PON_CONTROL_LIFTXEN_FIELD;
#define LIF_PON_CONTROL_LIFTXEN_FIELD_MASK  0x0000000000000002
#define LIF_PON_CONTROL_LIFTXEN_FIELD_WIDTH 1
#define LIF_PON_CONTROL_LIFTXEN_FIELD_SHIFT 1

extern const ru_field_rec LIF_PON_CONTROL_LIFRXEN_FIELD;
#define LIF_PON_CONTROL_LIFRXEN_FIELD_MASK  0x0000000000000001
#define LIF_PON_CONTROL_LIFRXEN_FIELD_WIDTH 1
#define LIF_PON_CONTROL_LIFRXEN_FIELD_SHIFT 0

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_RESERVED0_FIELD;
#define LIF_PON_INTER_OP_CONTROL_RESERVED0_FIELD_MASK  0x0000000080000000
#define LIF_PON_INTER_OP_CONTROL_RESERVED0_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_RESERVED0_FIELD_SHIFT 31

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFIPGFILTER_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFIPGFILTER_FIELD_MASK  0x0000000078000000
#define LIF_PON_INTER_OP_CONTROL_CFIPGFILTER_FIELD_WIDTH 4
#define LIF_PON_INTER_OP_CONTROL_CFIPGFILTER_FIELD_SHIFT 27

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFDISABLELOSLASERBLOCK_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFDISABLELOSLASERBLOCK_FIELD_MASK  0x0000000004000000
#define LIF_PON_INTER_OP_CONTROL_CFDISABLELOSLASERBLOCK_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFDISABLELOSLASERBLOCK_FIELD_SHIFT 26

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFGLLIDPROMISCUOUSMODE_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDPROMISCUOUSMODE_FIELD_MASK  0x0000000002000000
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDPROMISCUOUSMODE_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDPROMISCUOUSMODE_FIELD_SHIFT 25

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFGLLIDMODMSK_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDMODMSK_FIELD_MASK  0x0000000001000000
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDMODMSK_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFGLLIDMODMSK_FIELD_SHIFT 24

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFUSEFECIPG_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFUSEFECIPG_FIELD_MASK  0x0000000000800000
#define LIF_PON_INTER_OP_CONTROL_CFUSEFECIPG_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFUSEFECIPG_FIELD_SHIFT 23

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFRXCRC8INVCHK_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8INVCHK_FIELD_MASK  0x0000000000400000
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8INVCHK_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8INVCHK_FIELD_SHIFT 22

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFRXCRC8BITSWAP_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8BITSWAP_FIELD_MASK  0x0000000000200000
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8BITSWAP_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8BITSWAP_FIELD_SHIFT 21

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFRXCRC8MSB2LSB_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8MSB2LSB_FIELD_MASK  0x0000000000100000
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8MSB2LSB_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8MSB2LSB_FIELD_SHIFT 20

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFRXCRC8DISABLE_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8DISABLE_FIELD_MASK  0x0000000000080000
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8DISABLE_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFRXCRC8DISABLE_FIELD_SHIFT 19

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_RESERVED1_FIELD;
#define LIF_PON_INTER_OP_CONTROL_RESERVED1_FIELD_MASK  0x0000000000040000
#define LIF_PON_INTER_OP_CONTROL_RESERVED1_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_RESERVED1_FIELD_SHIFT 18

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXLLIDBIT15SET_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXLLIDBIT15SET_FIELD_MASK  0x0000000000020000
#define LIF_PON_INTER_OP_CONTROL_CFTXLLIDBIT15SET_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXLLIDBIT15SET_FIELD_SHIFT 17

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXCRC8INV_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8INV_FIELD_MASK  0x0000000000010000
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8INV_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8INV_FIELD_SHIFT 16

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXCRC8BAD_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BAD_FIELD_MASK  0x0000000000008000
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BAD_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BAD_FIELD_SHIFT 15

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXCRC8BITSWAP_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BITSWAP_FIELD_MASK  0x0000000000004000
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BITSWAP_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8BITSWAP_FIELD_SHIFT 14

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXCRC8MSB2LSB_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8MSB2LSB_FIELD_MASK  0x0000000000002000
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8MSB2LSB_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXCRC8MSB2LSB_FIELD_SHIFT 13

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXSHORTPRE_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXSHORTPRE_FIELD_MASK  0x0000000000001000
#define LIF_PON_INTER_OP_CONTROL_CFTXSHORTPRE_FIELD_WIDTH 1
#define LIF_PON_INTER_OP_CONTROL_CFTXSHORTPRE_FIELD_SHIFT 12

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXIPGCNT_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXIPGCNT_FIELD_MASK  0x0000000000000f00
#define LIF_PON_INTER_OP_CONTROL_CFTXIPGCNT_FIELD_WIDTH 4
#define LIF_PON_INTER_OP_CONTROL_CFTXIPGCNT_FIELD_SHIFT 8

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXAASYNCLEN_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXAASYNCLEN_FIELD_MASK  0x00000000000000f0
#define LIF_PON_INTER_OP_CONTROL_CFTXAASYNCLEN_FIELD_WIDTH 4
#define LIF_PON_INTER_OP_CONTROL_CFTXAASYNCLEN_FIELD_SHIFT 4

extern const ru_field_rec LIF_PON_INTER_OP_CONTROL_CFTXPIPEDELAY_FIELD;
#define LIF_PON_INTER_OP_CONTROL_CFTXPIPEDELAY_FIELD_MASK  0x000000000000000f
#define LIF_PON_INTER_OP_CONTROL_CFTXPIPEDELAY_FIELD_WIDTH 4
#define LIF_PON_INTER_OP_CONTROL_CFTXPIPEDELAY_FIELD_SHIFT 0

extern const ru_field_rec LIF_FEC_CONTROL_RESERVED0_FIELD;
#define LIF_FEC_CONTROL_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define LIF_FEC_CONTROL_RESERVED0_FIELD_WIDTH 26
#define LIF_FEC_CONTROL_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec LIF_FEC_CONTROL_CFFECRXERRORPROP_FIELD;
#define LIF_FEC_CONTROL_CFFECRXERRORPROP_FIELD_MASK  0x0000000000000020
#define LIF_FEC_CONTROL_CFFECRXERRORPROP_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECRXERRORPROP_FIELD_SHIFT 5

extern const ru_field_rec LIF_FEC_CONTROL_CFFECRXFORCENONFECABORT_FIELD;
#define LIF_FEC_CONTROL_CFFECRXFORCENONFECABORT_FIELD_MASK  0x0000000000000010
#define LIF_FEC_CONTROL_CFFECRXFORCENONFECABORT_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECRXFORCENONFECABORT_FIELD_SHIFT 4

extern const ru_field_rec LIF_FEC_CONTROL_CFFECRXFORCEFECABORT_FIELD;
#define LIF_FEC_CONTROL_CFFECRXFORCEFECABORT_FIELD_MASK  0x0000000000000008
#define LIF_FEC_CONTROL_CFFECRXFORCEFECABORT_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECRXFORCEFECABORT_FIELD_SHIFT 3

extern const ru_field_rec LIF_FEC_CONTROL_CFFECRXENABLE_FIELD;
#define LIF_FEC_CONTROL_CFFECRXENABLE_FIELD_MASK  0x0000000000000004
#define LIF_FEC_CONTROL_CFFECRXENABLE_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECRXENABLE_FIELD_SHIFT 2

extern const ru_field_rec LIF_FEC_CONTROL_CFFECTXFECPERLLID_FIELD;
#define LIF_FEC_CONTROL_CFFECTXFECPERLLID_FIELD_MASK  0x0000000000000002
#define LIF_FEC_CONTROL_CFFECTXFECPERLLID_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECTXFECPERLLID_FIELD_SHIFT 1

extern const ru_field_rec LIF_FEC_CONTROL_CFFECTXENABLE_FIELD;
#define LIF_FEC_CONTROL_CFFECTXENABLE_FIELD_MASK  0x0000000000000001
#define LIF_FEC_CONTROL_CFFECTXENABLE_FIELD_WIDTH 1
#define LIF_FEC_CONTROL_CFFECTXENABLE_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_CONTROL_CFGDISMPCPENCRYPT_FIELD;
#define LIF_SEC_CONTROL_CFGDISMPCPENCRYPT_FIELD_MASK  0x0000000080000000
#define LIF_SEC_CONTROL_CFGDISMPCPENCRYPT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGDISMPCPENCRYPT_FIELD_SHIFT 31

extern const ru_field_rec LIF_SEC_CONTROL_CFGDISOAMENCRYPT_FIELD;
#define LIF_SEC_CONTROL_CFGDISOAMENCRYPT_FIELD_MASK  0x0000000040000000
#define LIF_SEC_CONTROL_CFGDISOAMENCRYPT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGDISOAMENCRYPT_FIELD_SHIFT 30

extern const ru_field_rec LIF_SEC_CONTROL_CFGSECENSHORTLEN_FIELD;
#define LIF_SEC_CONTROL_CFGSECENSHORTLEN_FIELD_MASK  0x0000000020000000
#define LIF_SEC_CONTROL_CFGSECENSHORTLEN_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGSECENSHORTLEN_FIELD_SHIFT 29

extern const ru_field_rec LIF_SEC_CONTROL_CFGSECDNENPKTNUMRLOVR_FIELD;
#define LIF_SEC_CONTROL_CFGSECDNENPKTNUMRLOVR_FIELD_MASK  0x0000000010000000
#define LIF_SEC_CONTROL_CFGSECDNENPKTNUMRLOVR_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGSECDNENPKTNUMRLOVR_FIELD_SHIFT 28

extern const ru_field_rec LIF_SEC_CONTROL_CFGSECUPENPKTNUMRLOVR_FIELD;
#define LIF_SEC_CONTROL_CFGSECUPENPKTNUMRLOVR_FIELD_MASK  0x0000000008000000
#define LIF_SEC_CONTROL_CFGSECUPENPKTNUMRLOVR_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGSECUPENPKTNUMRLOVR_FIELD_SHIFT 27

extern const ru_field_rec LIF_SEC_CONTROL_CFGENAEREPLAYPRCT_FIELD;
#define LIF_SEC_CONTROL_CFGENAEREPLAYPRCT_FIELD_MASK  0x0000000004000000
#define LIF_SEC_CONTROL_CFGENAEREPLAYPRCT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGENAEREPLAYPRCT_FIELD_SHIFT 26

extern const ru_field_rec LIF_SEC_CONTROL_CFGENLEGACYRCC_FIELD;
#define LIF_SEC_CONTROL_CFGENLEGACYRCC_FIELD_MASK  0x0000000002000000
#define LIF_SEC_CONTROL_CFGENLEGACYRCC_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_CFGENLEGACYRCC_FIELD_SHIFT 25

extern const ru_field_rec LIF_SEC_CONTROL_ENFAKEUPAES_FIELD;
#define LIF_SEC_CONTROL_ENFAKEUPAES_FIELD_MASK  0x0000000001000000
#define LIF_SEC_CONTROL_ENFAKEUPAES_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_ENFAKEUPAES_FIELD_SHIFT 24

extern const ru_field_rec LIF_SEC_CONTROL_ENFAKEDNAES_FIELD;
#define LIF_SEC_CONTROL_ENFAKEDNAES_FIELD_MASK  0x0000000000800000
#define LIF_SEC_CONTROL_ENFAKEDNAES_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_ENFAKEDNAES_FIELD_SHIFT 23

extern const ru_field_rec LIF_SEC_CONTROL_RESERVED0_FIELD;
#define LIF_SEC_CONTROL_RESERVED0_FIELD_MASK  0x0000000000600000
#define LIF_SEC_CONTROL_RESERVED0_FIELD_WIDTH 2
#define LIF_SEC_CONTROL_RESERVED0_FIELD_SHIFT 21

extern const ru_field_rec LIF_SEC_CONTROL_CFGFECIPGLEN_FIELD;
#define LIF_SEC_CONTROL_CFGFECIPGLEN_FIELD_MASK  0x00000000001fe000
#define LIF_SEC_CONTROL_CFGFECIPGLEN_FIELD_WIDTH 8
#define LIF_SEC_CONTROL_CFGFECIPGLEN_FIELD_SHIFT 13

extern const ru_field_rec LIF_SEC_CONTROL_DISDNDASAENCRPT_FIELD;
#define LIF_SEC_CONTROL_DISDNDASAENCRPT_FIELD_MASK  0x0000000000001000
#define LIF_SEC_CONTROL_DISDNDASAENCRPT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_DISDNDASAENCRPT_FIELD_SHIFT 12

extern const ru_field_rec LIF_SEC_CONTROL_ENTRIPLECHURN_FIELD;
#define LIF_SEC_CONTROL_ENTRIPLECHURN_FIELD_MASK  0x0000000000000800
#define LIF_SEC_CONTROL_ENTRIPLECHURN_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_ENTRIPLECHURN_FIELD_SHIFT 11

extern const ru_field_rec LIF_SEC_CONTROL_ENEPNMIXENCRYPT_FIELD;
#define LIF_SEC_CONTROL_ENEPNMIXENCRYPT_FIELD_MASK  0x0000000000000400
#define LIF_SEC_CONTROL_ENEPNMIXENCRYPT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_ENEPNMIXENCRYPT_FIELD_SHIFT 10

extern const ru_field_rec LIF_SEC_CONTROL_DISUPDASAENCRPT_FIELD;
#define LIF_SEC_CONTROL_DISUPDASAENCRPT_FIELD_MASK  0x0000000000000200
#define LIF_SEC_CONTROL_DISUPDASAENCRPT_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_DISUPDASAENCRPT_FIELD_SHIFT 9

extern const ru_field_rec LIF_SEC_CONTROL_SECUPENCRYPTSCHEME_FIELD;
#define LIF_SEC_CONTROL_SECUPENCRYPTSCHEME_FIELD_MASK  0x0000000000000180
#define LIF_SEC_CONTROL_SECUPENCRYPTSCHEME_FIELD_WIDTH 2
#define LIF_SEC_CONTROL_SECUPENCRYPTSCHEME_FIELD_SHIFT 7

extern const ru_field_rec LIF_SEC_CONTROL_SECDNENCRYPTSCHEME_FIELD;
#define LIF_SEC_CONTROL_SECDNENCRYPTSCHEME_FIELD_MASK  0x0000000000000070
#define LIF_SEC_CONTROL_SECDNENCRYPTSCHEME_FIELD_WIDTH 3
#define LIF_SEC_CONTROL_SECDNENCRYPTSCHEME_FIELD_SHIFT 4

extern const ru_field_rec LIF_SEC_CONTROL_SECUPRSTN_PRE_FIELD;
#define LIF_SEC_CONTROL_SECUPRSTN_PRE_FIELD_MASK  0x0000000000000008
#define LIF_SEC_CONTROL_SECUPRSTN_PRE_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_SECUPRSTN_PRE_FIELD_SHIFT 3

extern const ru_field_rec LIF_SEC_CONTROL_SECDNRSTN_PRE_FIELD;
#define LIF_SEC_CONTROL_SECDNRSTN_PRE_FIELD_MASK  0x0000000000000004
#define LIF_SEC_CONTROL_SECDNRSTN_PRE_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_SECDNRSTN_PRE_FIELD_SHIFT 2

extern const ru_field_rec LIF_SEC_CONTROL_SECENUP_FIELD;
#define LIF_SEC_CONTROL_SECENUP_FIELD_MASK  0x0000000000000002
#define LIF_SEC_CONTROL_SECENUP_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_SECENUP_FIELD_SHIFT 1

extern const ru_field_rec LIF_SEC_CONTROL_SECENDN_FIELD;
#define LIF_SEC_CONTROL_SECENDN_FIELD_MASK  0x0000000000000001
#define LIF_SEC_CONTROL_SECENDN_FIELD_WIDTH 1
#define LIF_SEC_CONTROL_SECENDN_FIELD_SHIFT 0

extern const ru_field_rec LIF_MACSEC_RESERVED0_FIELD;
#define LIF_MACSEC_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_MACSEC_RESERVED0_FIELD_WIDTH 16
#define LIF_MACSEC_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_MACSEC_CFGMACSECETHERTYPE_FIELD;
#define LIF_MACSEC_CFGMACSECETHERTYPE_FIELD_MASK  0x000000000000ffff
#define LIF_MACSEC_CFGMACSECETHERTYPE_FIELD_WIDTH 16
#define LIF_MACSEC_CFGMACSECETHERTYPE_FIELD_SHIFT 0

extern const ru_field_rec LIF_INT_STATUS_RESERVED0_FIELD;
#define LIF_INT_STATUS_RESERVED0_FIELD_MASK  0x00000000ffc00000
#define LIF_INT_STATUS_RESERVED0_FIELD_WIDTH 10
#define LIF_INT_STATUS_RESERVED0_FIELD_SHIFT 22

extern const ru_field_rec LIF_INT_STATUS_INT_SOP_SFEC_IPG_VIOLATION_FIELD;
#define LIF_INT_STATUS_INT_SOP_SFEC_IPG_VIOLATION_FIELD_MASK  0x0000000000200000
#define LIF_INT_STATUS_INT_SOP_SFEC_IPG_VIOLATION_FIELD_WIDTH 1
#define LIF_INT_STATUS_INT_SOP_SFEC_IPG_VIOLATION_FIELD_SHIFT 21

extern const ru_field_rec LIF_INT_STATUS_LASERONMAX_FIELD;
#define LIF_INT_STATUS_LASERONMAX_FIELD_MASK  0x0000000000100000
#define LIF_INT_STATUS_LASERONMAX_FIELD_WIDTH 1
#define LIF_INT_STATUS_LASERONMAX_FIELD_SHIFT 20

extern const ru_field_rec LIF_INT_STATUS_LASEROFF_FIELD;
#define LIF_INT_STATUS_LASEROFF_FIELD_MASK  0x0000000000080000
#define LIF_INT_STATUS_LASEROFF_FIELD_WIDTH 1
#define LIF_INT_STATUS_LASEROFF_FIELD_SHIFT 19

extern const ru_field_rec LIF_INT_STATUS_SECDNREPLAYPROTCTABORT_FIELD;
#define LIF_INT_STATUS_SECDNREPLAYPROTCTABORT_FIELD_MASK  0x0000000000040000
#define LIF_INT_STATUS_SECDNREPLAYPROTCTABORT_FIELD_WIDTH 1
#define LIF_INT_STATUS_SECDNREPLAYPROTCTABORT_FIELD_SHIFT 18

extern const ru_field_rec LIF_INT_STATUS_SECUPPKTNUMOVERFLOW_FIELD;
#define LIF_INT_STATUS_SECUPPKTNUMOVERFLOW_FIELD_MASK  0x0000000000020000
#define LIF_INT_STATUS_SECUPPKTNUMOVERFLOW_FIELD_WIDTH 1
#define LIF_INT_STATUS_SECUPPKTNUMOVERFLOW_FIELD_SHIFT 17

extern const ru_field_rec LIF_INT_STATUS_INTLASEROFFDURBURST_FIELD;
#define LIF_INT_STATUS_INTLASEROFFDURBURST_FIELD_MASK  0x0000000000010000
#define LIF_INT_STATUS_INTLASEROFFDURBURST_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTLASEROFFDURBURST_FIELD_SHIFT 16

extern const ru_field_rec LIF_INT_STATUS_INTRXBERTHRESHEXC_FIELD;
#define LIF_INT_STATUS_INTRXBERTHRESHEXC_FIELD_MASK  0x0000000000008000
#define LIF_INT_STATUS_INTRXBERTHRESHEXC_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTRXBERTHRESHEXC_FIELD_SHIFT 15

extern const ru_field_rec LIF_INT_STATUS_INTFECRXFECRECVSTATUS_FIELD;
#define LIF_INT_STATUS_INTFECRXFECRECVSTATUS_FIELD_MASK  0x0000000000004000
#define LIF_INT_STATUS_INTFECRXFECRECVSTATUS_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECRXFECRECVSTATUS_FIELD_SHIFT 14

extern const ru_field_rec LIF_INT_STATUS_INTFECRXCORERRFIFOFULLSTATUS_FIELD;
#define LIF_INT_STATUS_INTFECRXCORERRFIFOFULLSTATUS_FIELD_MASK  0x0000000000002000
#define LIF_INT_STATUS_INTFECRXCORERRFIFOFULLSTATUS_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECRXCORERRFIFOFULLSTATUS_FIELD_SHIFT 13

extern const ru_field_rec LIF_INT_STATUS_INTFECRXCORERRFIFOUNEXPEMPTY_FIELD;
#define LIF_INT_STATUS_INTFECRXCORERRFIFOUNEXPEMPTY_FIELD_MASK  0x0000000000001000
#define LIF_INT_STATUS_INTFECRXCORERRFIFOUNEXPEMPTY_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECRXCORERRFIFOUNEXPEMPTY_FIELD_SHIFT 12

extern const ru_field_rec LIF_INT_STATUS_INTFECBUFPOPEMPTYPUSH_FIELD;
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYPUSH_FIELD_MASK  0x0000000000000800
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYPUSH_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYPUSH_FIELD_SHIFT 11

extern const ru_field_rec LIF_INT_STATUS_INTFECBUFPOPEMPTYNOPUSH_FIELD;
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYNOPUSH_FIELD_MASK  0x0000000000000400
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYNOPUSH_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECBUFPOPEMPTYNOPUSH_FIELD_SHIFT 10

extern const ru_field_rec LIF_INT_STATUS_INTFECBUFPUSHFULL_FIELD;
#define LIF_INT_STATUS_INTFECBUFPUSHFULL_FIELD_MASK  0x0000000000000200
#define LIF_INT_STATUS_INTFECBUFPUSHFULL_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFECBUFPUSHFULL_FIELD_SHIFT 9

extern const ru_field_rec LIF_INT_STATUS_INTUPTIMEFULLUPDSTAT_FIELD;
#define LIF_INT_STATUS_INTUPTIMEFULLUPDSTAT_FIELD_MASK  0x0000000000000100
#define LIF_INT_STATUS_INTUPTIMEFULLUPDSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTUPTIMEFULLUPDSTAT_FIELD_SHIFT 8

extern const ru_field_rec LIF_INT_STATUS_INTFROUTOFALIGNSTAT_FIELD;
#define LIF_INT_STATUS_INTFROUTOFALIGNSTAT_FIELD_MASK  0x0000000000000080
#define LIF_INT_STATUS_INTFROUTOFALIGNSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTFROUTOFALIGNSTAT_FIELD_SHIFT 7

extern const ru_field_rec LIF_INT_STATUS_INTGRNTSTARTTIMELAGSTAT_FIELD;
#define LIF_INT_STATUS_INTGRNTSTARTTIMELAGSTAT_FIELD_MASK  0x0000000000000040
#define LIF_INT_STATUS_INTGRNTSTARTTIMELAGSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTGRNTSTARTTIMELAGSTAT_FIELD_SHIFT 6

extern const ru_field_rec LIF_INT_STATUS_INTABORTRXFRMSTAT_FIELD;
#define LIF_INT_STATUS_INTABORTRXFRMSTAT_FIELD_MASK  0x0000000000000020
#define LIF_INT_STATUS_INTABORTRXFRMSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTABORTRXFRMSTAT_FIELD_SHIFT 5

extern const ru_field_rec LIF_INT_STATUS_INTNORXCLKSTAT_FIELD;
#define LIF_INT_STATUS_INTNORXCLKSTAT_FIELD_MASK  0x0000000000000010
#define LIF_INT_STATUS_INTNORXCLKSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTNORXCLKSTAT_FIELD_SHIFT 4

extern const ru_field_rec LIF_INT_STATUS_INTRXMAXLENERRSTAT_FIELD;
#define LIF_INT_STATUS_INTRXMAXLENERRSTAT_FIELD_MASK  0x0000000000000008
#define LIF_INT_STATUS_INTRXMAXLENERRSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTRXMAXLENERRSTAT_FIELD_SHIFT 3

extern const ru_field_rec LIF_INT_STATUS_INTRXERRAFTALIGNSTAT_FIELD;
#define LIF_INT_STATUS_INTRXERRAFTALIGNSTAT_FIELD_MASK  0x0000000000000004
#define LIF_INT_STATUS_INTRXERRAFTALIGNSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTRXERRAFTALIGNSTAT_FIELD_SHIFT 2

extern const ru_field_rec LIF_INT_STATUS_INTRXSYNCHACQSTAT_FIELD;
#define LIF_INT_STATUS_INTRXSYNCHACQSTAT_FIELD_MASK  0x0000000000000002
#define LIF_INT_STATUS_INTRXSYNCHACQSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTRXSYNCHACQSTAT_FIELD_SHIFT 1

extern const ru_field_rec LIF_INT_STATUS_INTRXOUTOFSYNCHSTAT_FIELD;
#define LIF_INT_STATUS_INTRXOUTOFSYNCHSTAT_FIELD_MASK  0x0000000000000001
#define LIF_INT_STATUS_INTRXOUTOFSYNCHSTAT_FIELD_WIDTH 1
#define LIF_INT_STATUS_INTRXOUTOFSYNCHSTAT_FIELD_SHIFT 0

extern const ru_field_rec LIF_INT_MASK_RESERVED0_FIELD;
#define LIF_INT_MASK_RESERVED0_FIELD_MASK  0x00000000ffc00000
#define LIF_INT_MASK_RESERVED0_FIELD_WIDTH 10
#define LIF_INT_MASK_RESERVED0_FIELD_SHIFT 22

extern const ru_field_rec LIF_INT_MASK_INT_SOP_SFEC_IPG_VIOLATION_MASK_FIELD;
#define LIF_INT_MASK_INT_SOP_SFEC_IPG_VIOLATION_MASK_FIELD_MASK  0x0000000000200000
#define LIF_INT_MASK_INT_SOP_SFEC_IPG_VIOLATION_MASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INT_SOP_SFEC_IPG_VIOLATION_MASK_FIELD_SHIFT 21

extern const ru_field_rec LIF_INT_MASK_LASERONMAXMASK_FIELD;
#define LIF_INT_MASK_LASERONMAXMASK_FIELD_MASK  0x0000000000100000
#define LIF_INT_MASK_LASERONMAXMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_LASERONMAXMASK_FIELD_SHIFT 20

extern const ru_field_rec LIF_INT_MASK_LASEROFFMASK_FIELD;
#define LIF_INT_MASK_LASEROFFMASK_FIELD_MASK  0x0000000000080000
#define LIF_INT_MASK_LASEROFFMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_LASEROFFMASK_FIELD_SHIFT 19

extern const ru_field_rec LIF_INT_MASK_SECDNREPLAYPROTCTABORTMSK_FIELD;
#define LIF_INT_MASK_SECDNREPLAYPROTCTABORTMSK_FIELD_MASK  0x0000000000040000
#define LIF_INT_MASK_SECDNREPLAYPROTCTABORTMSK_FIELD_WIDTH 1
#define LIF_INT_MASK_SECDNREPLAYPROTCTABORTMSK_FIELD_SHIFT 18

extern const ru_field_rec LIF_INT_MASK_SECUPPKTNUMOVERFLOWMSK_FIELD;
#define LIF_INT_MASK_SECUPPKTNUMOVERFLOWMSK_FIELD_MASK  0x0000000000020000
#define LIF_INT_MASK_SECUPPKTNUMOVERFLOWMSK_FIELD_WIDTH 1
#define LIF_INT_MASK_SECUPPKTNUMOVERFLOWMSK_FIELD_SHIFT 17

extern const ru_field_rec LIF_INT_MASK_INTLASEROFFDURBURSTMASK_FIELD;
#define LIF_INT_MASK_INTLASEROFFDURBURSTMASK_FIELD_MASK  0x0000000000010000
#define LIF_INT_MASK_INTLASEROFFDURBURSTMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTLASEROFFDURBURSTMASK_FIELD_SHIFT 16

extern const ru_field_rec LIF_INT_MASK_INTRXBERTHRESHEXCMASK_FIELD;
#define LIF_INT_MASK_INTRXBERTHRESHEXCMASK_FIELD_MASK  0x0000000000008000
#define LIF_INT_MASK_INTRXBERTHRESHEXCMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTRXBERTHRESHEXCMASK_FIELD_SHIFT 15

extern const ru_field_rec LIF_INT_MASK_INTFECRXFECRECVMASK_FIELD;
#define LIF_INT_MASK_INTFECRXFECRECVMASK_FIELD_MASK  0x0000000000004000
#define LIF_INT_MASK_INTFECRXFECRECVMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECRXFECRECVMASK_FIELD_SHIFT 14

extern const ru_field_rec LIF_INT_MASK_INTFECRXCORERRFIFOFULLMASK_FIELD;
#define LIF_INT_MASK_INTFECRXCORERRFIFOFULLMASK_FIELD_MASK  0x0000000000002000
#define LIF_INT_MASK_INTFECRXCORERRFIFOFULLMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECRXCORERRFIFOFULLMASK_FIELD_SHIFT 13

extern const ru_field_rec LIF_INT_MASK_INTFECRXCORERRFIFOUNEXPEMPTYMASK_FIELD;
#define LIF_INT_MASK_INTFECRXCORERRFIFOUNEXPEMPTYMASK_FIELD_MASK  0x0000000000001000
#define LIF_INT_MASK_INTFECRXCORERRFIFOUNEXPEMPTYMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECRXCORERRFIFOUNEXPEMPTYMASK_FIELD_SHIFT 12

extern const ru_field_rec LIF_INT_MASK_INTFECBUFPOPEMPTYPUSHMASK_FIELD;
#define LIF_INT_MASK_INTFECBUFPOPEMPTYPUSHMASK_FIELD_MASK  0x0000000000000800
#define LIF_INT_MASK_INTFECBUFPOPEMPTYPUSHMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECBUFPOPEMPTYPUSHMASK_FIELD_SHIFT 11

extern const ru_field_rec LIF_INT_MASK_INTFECBUFPOPEMPTYNOPUSHMASK_FIELD;
#define LIF_INT_MASK_INTFECBUFPOPEMPTYNOPUSHMASK_FIELD_MASK  0x0000000000000400
#define LIF_INT_MASK_INTFECBUFPOPEMPTYNOPUSHMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECBUFPOPEMPTYNOPUSHMASK_FIELD_SHIFT 10

extern const ru_field_rec LIF_INT_MASK_INTFECBUFPUSHFULLMASK_FIELD;
#define LIF_INT_MASK_INTFECBUFPUSHFULLMASK_FIELD_MASK  0x0000000000000200
#define LIF_INT_MASK_INTFECBUFPUSHFULLMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFECBUFPUSHFULLMASK_FIELD_SHIFT 9

extern const ru_field_rec LIF_INT_MASK_INTUPTIMEFULLUPDMASK_FIELD;
#define LIF_INT_MASK_INTUPTIMEFULLUPDMASK_FIELD_MASK  0x0000000000000100
#define LIF_INT_MASK_INTUPTIMEFULLUPDMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTUPTIMEFULLUPDMASK_FIELD_SHIFT 8

extern const ru_field_rec LIF_INT_MASK_INTFROUTOFALIGNMASK_FIELD;
#define LIF_INT_MASK_INTFROUTOFALIGNMASK_FIELD_MASK  0x0000000000000080
#define LIF_INT_MASK_INTFROUTOFALIGNMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTFROUTOFALIGNMASK_FIELD_SHIFT 7

extern const ru_field_rec LIF_INT_MASK_INTGRNTSTARTTIMELAGMASK_FIELD;
#define LIF_INT_MASK_INTGRNTSTARTTIMELAGMASK_FIELD_MASK  0x0000000000000040
#define LIF_INT_MASK_INTGRNTSTARTTIMELAGMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTGRNTSTARTTIMELAGMASK_FIELD_SHIFT 6

extern const ru_field_rec LIF_INT_MASK_INTABORTRXFRMMASK_FIELD;
#define LIF_INT_MASK_INTABORTRXFRMMASK_FIELD_MASK  0x0000000000000020
#define LIF_INT_MASK_INTABORTRXFRMMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTABORTRXFRMMASK_FIELD_SHIFT 5

extern const ru_field_rec LIF_INT_MASK_INTNORXCLKMASK_FIELD;
#define LIF_INT_MASK_INTNORXCLKMASK_FIELD_MASK  0x0000000000000010
#define LIF_INT_MASK_INTNORXCLKMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTNORXCLKMASK_FIELD_SHIFT 4

extern const ru_field_rec LIF_INT_MASK_INTRXMAXLENERRMASK_FIELD;
#define LIF_INT_MASK_INTRXMAXLENERRMASK_FIELD_MASK  0x0000000000000008
#define LIF_INT_MASK_INTRXMAXLENERRMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTRXMAXLENERRMASK_FIELD_SHIFT 3

extern const ru_field_rec LIF_INT_MASK_INTRXERRAFTALIGNMASK_FIELD;
#define LIF_INT_MASK_INTRXERRAFTALIGNMASK_FIELD_MASK  0x0000000000000004
#define LIF_INT_MASK_INTRXERRAFTALIGNMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTRXERRAFTALIGNMASK_FIELD_SHIFT 2

extern const ru_field_rec LIF_INT_MASK_INTRXSYNCHACQMASK_FIELD;
#define LIF_INT_MASK_INTRXSYNCHACQMASK_FIELD_MASK  0x0000000000000002
#define LIF_INT_MASK_INTRXSYNCHACQMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTRXSYNCHACQMASK_FIELD_SHIFT 1

extern const ru_field_rec LIF_INT_MASK_INTRXOUTOFSYNCHMASK_FIELD;
#define LIF_INT_MASK_INTRXOUTOFSYNCHMASK_FIELD_MASK  0x0000000000000001
#define LIF_INT_MASK_INTRXOUTOFSYNCHMASK_FIELD_WIDTH 1
#define LIF_INT_MASK_INTRXOUTOFSYNCHMASK_FIELD_SHIFT 0

extern const ru_field_rec LIF_DATA_PORT_COMMAND_DATA_PORT_BUSY_FIELD;
#define LIF_DATA_PORT_COMMAND_DATA_PORT_BUSY_FIELD_MASK  0x0000000080000000
#define LIF_DATA_PORT_COMMAND_DATA_PORT_BUSY_FIELD_WIDTH 1
#define LIF_DATA_PORT_COMMAND_DATA_PORT_BUSY_FIELD_SHIFT 31

extern const ru_field_rec LIF_DATA_PORT_COMMAND_DATA_PORT_ERROR_FIELD;
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ERROR_FIELD_MASK  0x0000000040000000
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ERROR_FIELD_WIDTH 1
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ERROR_FIELD_SHIFT 30

extern const ru_field_rec LIF_DATA_PORT_COMMAND_RAM_SELECT_FIELD;
#define LIF_DATA_PORT_COMMAND_RAM_SELECT_FIELD_MASK  0x000000003f000000
#define LIF_DATA_PORT_COMMAND_RAM_SELECT_FIELD_WIDTH 6
#define LIF_DATA_PORT_COMMAND_RAM_SELECT_FIELD_SHIFT 24

extern const ru_field_rec LIF_DATA_PORT_COMMAND_DATA_PORT_OP_CODE_FIELD;
#define LIF_DATA_PORT_COMMAND_DATA_PORT_OP_CODE_FIELD_MASK  0x0000000000ff0000
#define LIF_DATA_PORT_COMMAND_DATA_PORT_OP_CODE_FIELD_WIDTH 8
#define LIF_DATA_PORT_COMMAND_DATA_PORT_OP_CODE_FIELD_SHIFT 16

extern const ru_field_rec LIF_DATA_PORT_COMMAND_DATA_PORT_ADDR_FIELD;
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ADDR_FIELD_MASK  0x000000000000ffff
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ADDR_FIELD_WIDTH 16
#define LIF_DATA_PORT_COMMAND_DATA_PORT_ADDR_FIELD_SHIFT 0

extern const ru_field_rec LIF_DATA_PORT_DATA_PBIPORTDATA_FIELD;
#define LIF_DATA_PORT_DATA_PBIPORTDATA_FIELD_MASK  0x00000000ffffffff
#define LIF_DATA_PORT_DATA_PBIPORTDATA_FIELD_WIDTH 32
#define LIF_DATA_PORT_DATA_PBIPORTDATA_FIELD_SHIFT 0

extern const ru_field_rec LIF_LLID_RESERVED0_FIELD;
#define LIF_LLID_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_LLID_RESERVED0_FIELD_WIDTH 15
#define LIF_LLID_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_LLID_CFGLLID0_FIELD;
#define LIF_LLID_CFGLLID0_FIELD_MASK  0x000000000001ffff
#define LIF_LLID_CFGLLID0_FIELD_WIDTH 17
#define LIF_LLID_CFGLLID0_FIELD_SHIFT 0

extern const ru_field_rec LIF_TIME_REF_CNT_RESERVED0_FIELD;
#define LIF_TIME_REF_CNT_RESERVED0_FIELD_MASK  0x00000000ff000000
#define LIF_TIME_REF_CNT_RESERVED0_FIELD_WIDTH 8
#define LIF_TIME_REF_CNT_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec LIF_TIME_REF_CNT_CFFULLUPDATEVALUE_FIELD;
#define LIF_TIME_REF_CNT_CFFULLUPDATEVALUE_FIELD_MASK  0x0000000000ff0000
#define LIF_TIME_REF_CNT_CFFULLUPDATEVALUE_FIELD_WIDTH 8
#define LIF_TIME_REF_CNT_CFFULLUPDATEVALUE_FIELD_SHIFT 16

extern const ru_field_rec LIF_TIME_REF_CNT_CFMAXNEGVALUE_FIELD;
#define LIF_TIME_REF_CNT_CFMAXNEGVALUE_FIELD_MASK  0x000000000000ff00
#define LIF_TIME_REF_CNT_CFMAXNEGVALUE_FIELD_WIDTH 8
#define LIF_TIME_REF_CNT_CFMAXNEGVALUE_FIELD_SHIFT 8

extern const ru_field_rec LIF_TIME_REF_CNT_CFMAXPOSVALUE_FIELD;
#define LIF_TIME_REF_CNT_CFMAXPOSVALUE_FIELD_MASK  0x00000000000000ff
#define LIF_TIME_REF_CNT_CFMAXPOSVALUE_FIELD_WIDTH 8
#define LIF_TIME_REF_CNT_CFMAXPOSVALUE_FIELD_SHIFT 0

extern const ru_field_rec LIF_TIMESTAMP_UPD_PER_RESERVED0_FIELD;
#define LIF_TIMESTAMP_UPD_PER_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_TIMESTAMP_UPD_PER_RESERVED0_FIELD_WIDTH 16
#define LIF_TIMESTAMP_UPD_PER_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_TIMESTAMP_UPD_PER_CFTIMESTAMPUPDPER_FIELD;
#define LIF_TIMESTAMP_UPD_PER_CFTIMESTAMPUPDPER_FIELD_MASK  0x000000000000ffff
#define LIF_TIMESTAMP_UPD_PER_CFTIMESTAMPUPDPER_FIELD_WIDTH 16
#define LIF_TIMESTAMP_UPD_PER_CFTIMESTAMPUPDPER_FIELD_SHIFT 0

extern const ru_field_rec LIF_TP_TIME_CFTRANSPORTTIME_FIELD;
#define LIF_TP_TIME_CFTRANSPORTTIME_FIELD_MASK  0x00000000ffffffff
#define LIF_TP_TIME_CFTRANSPORTTIME_FIELD_WIDTH 32
#define LIF_TP_TIME_CFTRANSPORTTIME_FIELD_SHIFT 0

extern const ru_field_rec LIF_MPCP_TIME_LTMPCPTIME_FIELD;
#define LIF_MPCP_TIME_LTMPCPTIME_FIELD_MASK  0x00000000ffffffff
#define LIF_MPCP_TIME_LTMPCPTIME_FIELD_WIDTH 32
#define LIF_MPCP_TIME_LTMPCPTIME_FIELD_SHIFT 0

extern const ru_field_rec LIF_MAXLEN_CTR_RESERVED0_FIELD;
#define LIF_MAXLEN_CTR_RESERVED0_FIELD_MASK  0x00000000ffffc000
#define LIF_MAXLEN_CTR_RESERVED0_FIELD_WIDTH 18
#define LIF_MAXLEN_CTR_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec LIF_MAXLEN_CTR_CFRXMAXFRAMELENGTH_FIELD;
#define LIF_MAXLEN_CTR_CFRXMAXFRAMELENGTH_FIELD_MASK  0x0000000000003fff
#define LIF_MAXLEN_CTR_CFRXMAXFRAMELENGTH_FIELD_WIDTH 14
#define LIF_MAXLEN_CTR_CFRXMAXFRAMELENGTH_FIELD_SHIFT 0

extern const ru_field_rec LIF_LASER_ON_DELTA_RESERVED0_FIELD;
#define LIF_LASER_ON_DELTA_RESERVED0_FIELD_MASK  0x00000000ffffe000
#define LIF_LASER_ON_DELTA_RESERVED0_FIELD_WIDTH 19
#define LIF_LASER_ON_DELTA_RESERVED0_FIELD_SHIFT 13

extern const ru_field_rec LIF_LASER_ON_DELTA_CFTXLASERONDELTA_FIELD;
#define LIF_LASER_ON_DELTA_CFTXLASERONDELTA_FIELD_MASK  0x0000000000001fff
#define LIF_LASER_ON_DELTA_CFTXLASERONDELTA_FIELD_WIDTH 13
#define LIF_LASER_ON_DELTA_CFTXLASERONDELTA_FIELD_SHIFT 0

extern const ru_field_rec LIF_LASER_OFF_IDLE_CFTXINITIDLE_FIELD;
#define LIF_LASER_OFF_IDLE_CFTXINITIDLE_FIELD_MASK  0x00000000ffff0000
#define LIF_LASER_OFF_IDLE_CFTXINITIDLE_FIELD_WIDTH 16
#define LIF_LASER_OFF_IDLE_CFTXINITIDLE_FIELD_SHIFT 16

extern const ru_field_rec LIF_LASER_OFF_IDLE_RESERVED0_FIELD;
#define LIF_LASER_OFF_IDLE_RESERVED0_FIELD_MASK  0x000000000000ff00
#define LIF_LASER_OFF_IDLE_RESERVED0_FIELD_WIDTH 8
#define LIF_LASER_OFF_IDLE_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec LIF_LASER_OFF_IDLE_CFTXLASEROFFDELTA_FIELD;
#define LIF_LASER_OFF_IDLE_CFTXLASEROFFDELTA_FIELD_MASK  0x00000000000000ff
#define LIF_LASER_OFF_IDLE_CFTXLASEROFFDELTA_FIELD_WIDTH 8
#define LIF_LASER_OFF_IDLE_CFTXLASEROFFDELTA_FIELD_SHIFT 0

extern const ru_field_rec LIF_FEC_INIT_IDLE_RESERVED0_FIELD;
#define LIF_FEC_INIT_IDLE_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_FEC_INIT_IDLE_RESERVED0_FIELD_WIDTH 16
#define LIF_FEC_INIT_IDLE_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_FEC_INIT_IDLE_CFTXFECINITIDLE_FIELD;
#define LIF_FEC_INIT_IDLE_CFTXFECINITIDLE_FIELD_MASK  0x000000000000ffff
#define LIF_FEC_INIT_IDLE_CFTXFECINITIDLE_FIELD_WIDTH 16
#define LIF_FEC_INIT_IDLE_CFTXFECINITIDLE_FIELD_SHIFT 0

extern const ru_field_rec LIF_FEC_ERR_ALLOW_RESERVED0_FIELD;
#define LIF_FEC_ERR_ALLOW_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define LIF_FEC_ERR_ALLOW_RESERVED0_FIELD_WIDTH 24
#define LIF_FEC_ERR_ALLOW_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec LIF_FEC_ERR_ALLOW_CFRXTFECBITERRALLOW_FIELD;
#define LIF_FEC_ERR_ALLOW_CFRXTFECBITERRALLOW_FIELD_MASK  0x00000000000000f0
#define LIF_FEC_ERR_ALLOW_CFRXTFECBITERRALLOW_FIELD_WIDTH 4
#define LIF_FEC_ERR_ALLOW_CFRXTFECBITERRALLOW_FIELD_SHIFT 4

extern const ru_field_rec LIF_FEC_ERR_ALLOW_CFRXSFECBITERRALLOW_FIELD;
#define LIF_FEC_ERR_ALLOW_CFRXSFECBITERRALLOW_FIELD_MASK  0x000000000000000f
#define LIF_FEC_ERR_ALLOW_CFRXSFECBITERRALLOW_FIELD_WIDTH 4
#define LIF_FEC_ERR_ALLOW_CFRXSFECBITERRALLOW_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_KEY_SEL_RESERVED0_FIELD;
#define LIF_SEC_KEY_SEL_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_SEC_KEY_SEL_RESERVED0_FIELD_WIDTH 16
#define LIF_SEC_KEY_SEL_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_SEC_KEY_SEL_KEYSEL_FIELD;
#define LIF_SEC_KEY_SEL_KEYSEL_FIELD_MASK  0x000000000000ffff
#define LIF_SEC_KEY_SEL_KEYSEL_FIELD_WIDTH 16
#define LIF_SEC_KEY_SEL_KEYSEL_FIELD_SHIFT 0

extern const ru_field_rec LIF_DN_ENCRYPT_STAT_RESERVED0_FIELD;
#define LIF_DN_ENCRYPT_STAT_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_DN_ENCRYPT_STAT_RESERVED0_FIELD_WIDTH 16
#define LIF_DN_ENCRYPT_STAT_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_DN_ENCRYPT_STAT_ENENCRYPT_FIELD;
#define LIF_DN_ENCRYPT_STAT_ENENCRYPT_FIELD_MASK  0x000000000000ffff
#define LIF_DN_ENCRYPT_STAT_ENENCRYPT_FIELD_WIDTH 16
#define LIF_DN_ENCRYPT_STAT_ENENCRYPT_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_UP_KEY_STAT_RESERVED0_FIELD;
#define LIF_SEC_UP_KEY_STAT_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define LIF_SEC_UP_KEY_STAT_RESERVED0_FIELD_WIDTH 24
#define LIF_SEC_UP_KEY_STAT_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec LIF_SEC_UP_KEY_STAT_KEYUPSEL_FIELD;
#define LIF_SEC_UP_KEY_STAT_KEYUPSEL_FIELD_MASK  0x00000000000000ff
#define LIF_SEC_UP_KEY_STAT_KEYUPSEL_FIELD_WIDTH 8
#define LIF_SEC_UP_KEY_STAT_KEYUPSEL_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_UP_ENCRYPT_STAT_RESERVED0_FIELD;
#define LIF_SEC_UP_ENCRYPT_STAT_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define LIF_SEC_UP_ENCRYPT_STAT_RESERVED0_FIELD_WIDTH 24
#define LIF_SEC_UP_ENCRYPT_STAT_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec LIF_SEC_UP_ENCRYPT_STAT_ENUPENCRYPT_FIELD;
#define LIF_SEC_UP_ENCRYPT_STAT_ENUPENCRYPT_FIELD_MASK  0x00000000000000ff
#define LIF_SEC_UP_ENCRYPT_STAT_ENUPENCRYPT_FIELD_WIDTH 8
#define LIF_SEC_UP_ENCRYPT_STAT_ENUPENCRYPT_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_UP_MPCP_OFFSET_SECUPMPCPOFFSET_FIELD;
#define LIF_SEC_UP_MPCP_OFFSET_SECUPMPCPOFFSET_FIELD_MASK  0x00000000ffffffff
#define LIF_SEC_UP_MPCP_OFFSET_SECUPMPCPOFFSET_FIELD_WIDTH 32
#define LIF_SEC_UP_MPCP_OFFSET_SECUPMPCPOFFSET_FIELD_SHIFT 0

extern const ru_field_rec LIF_FEC_PER_LLID_RESERVED0_FIELD;
#define LIF_FEC_PER_LLID_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define LIF_FEC_PER_LLID_RESERVED0_FIELD_WIDTH 24
#define LIF_FEC_PER_LLID_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec LIF_FEC_PER_LLID_CFFECTXFECENLLID_FIELD;
#define LIF_FEC_PER_LLID_CFFECTXFECENLLID_FIELD_MASK  0x00000000000000ff
#define LIF_FEC_PER_LLID_CFFECTXFECENLLID_FIELD_WIDTH 8
#define LIF_FEC_PER_LLID_CFFECTXFECENLLID_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_LINE_CODE_ERR_CNT_RXLINECODEERRCNT_FIELD;
#define LIF_RX_LINE_CODE_ERR_CNT_RXLINECODEERRCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_LINE_CODE_ERR_CNT_RXLINECODEERRCNT_FIELD_WIDTH 32
#define LIF_RX_LINE_CODE_ERR_CNT_RXLINECODEERRCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_MPCP_FRM_RXAGGMPCPCNT_FIELD;
#define LIF_RX_AGG_MPCP_FRM_RXAGGMPCPCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_MPCP_FRM_RXAGGMPCPCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_MPCP_FRM_RXAGGMPCPCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_GOOD_FRM_RXAGGGOODCNT_FIELD;
#define LIF_RX_AGG_GOOD_FRM_RXAGGGOODCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_GOOD_FRM_RXAGGGOODCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_GOOD_FRM_RXAGGGOODCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_GOOD_BYTE_RXAGGGOODBYTESCNT_FIELD;
#define LIF_RX_AGG_GOOD_BYTE_RXAGGGOODBYTESCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_GOOD_BYTE_RXAGGGOODBYTESCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_GOOD_BYTE_RXAGGGOODBYTESCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_UNDERSZ_FRM_RXAGGUNDERSZCNT_FIELD;
#define LIF_RX_AGG_UNDERSZ_FRM_RXAGGUNDERSZCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_UNDERSZ_FRM_RXAGGUNDERSZCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_UNDERSZ_FRM_RXAGGUNDERSZCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_OVERSZ_FRM_RXAGGOVERSZCNT_FIELD;
#define LIF_RX_AGG_OVERSZ_FRM_RXAGGOVERSZCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_OVERSZ_FRM_RXAGGOVERSZCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_OVERSZ_FRM_RXAGGOVERSZCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_CRC8_FRM_RXAGGCRC8ERRCNT_FIELD;
#define LIF_RX_AGG_CRC8_FRM_RXAGGCRC8ERRCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_CRC8_FRM_RXAGGCRC8ERRCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_CRC8_FRM_RXAGGCRC8ERRCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_FEC_FRM_RXAGGFEC_FIELD;
#define LIF_RX_AGG_FEC_FRM_RXAGGFEC_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_FEC_FRM_RXAGGFEC_FIELD_WIDTH 32
#define LIF_RX_AGG_FEC_FRM_RXAGGFEC_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_FEC_BYTE_RXAGGFECBYTES_FIELD;
#define LIF_RX_AGG_FEC_BYTE_RXAGGFECBYTES_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_FEC_BYTE_RXAGGFECBYTES_FIELD_WIDTH 32
#define LIF_RX_AGG_FEC_BYTE_RXAGGFECBYTES_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_FEC_EXC_ERR_FRM_RXAGGFECEXCEEDERRS_FIELD;
#define LIF_RX_AGG_FEC_EXC_ERR_FRM_RXAGGFECEXCEEDERRS_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_FEC_EXC_ERR_FRM_RXAGGFECEXCEEDERRS_FIELD_WIDTH 32
#define LIF_RX_AGG_FEC_EXC_ERR_FRM_RXAGGFECEXCEEDERRS_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_NONFEC_GOOD_FRM_RXAGGNONFECGOOD_FIELD;
#define LIF_RX_AGG_NONFEC_GOOD_FRM_RXAGGNONFECGOOD_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_NONFEC_GOOD_FRM_RXAGGNONFECGOOD_FIELD_WIDTH 32
#define LIF_RX_AGG_NONFEC_GOOD_FRM_RXAGGNONFECGOOD_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_NONFEC_GOOD_BYTE_RXAGGNONFECGOODBYTES_FIELD;
#define LIF_RX_AGG_NONFEC_GOOD_BYTE_RXAGGNONFECGOODBYTES_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_NONFEC_GOOD_BYTE_RXAGGNONFECGOODBYTES_FIELD_WIDTH 32
#define LIF_RX_AGG_NONFEC_GOOD_BYTE_RXAGGNONFECGOODBYTES_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_ERR_BYTES_RXAGGERRBYTES_FIELD;
#define LIF_RX_AGG_ERR_BYTES_RXAGGERRBYTES_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_ERR_BYTES_RXAGGERRBYTES_FIELD_WIDTH 32
#define LIF_RX_AGG_ERR_BYTES_RXAGGERRBYTES_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_ERR_ZEROES_RXAGGERRZEROES_FIELD;
#define LIF_RX_AGG_ERR_ZEROES_RXAGGERRZEROES_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_ERR_ZEROES_RXAGGERRZEROES_FIELD_WIDTH 32
#define LIF_RX_AGG_ERR_ZEROES_RXAGGERRZEROES_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_NO_ERR_BLKS_RXAGGNOERRBLKS_FIELD;
#define LIF_RX_AGG_NO_ERR_BLKS_RXAGGNOERRBLKS_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_NO_ERR_BLKS_RXAGGNOERRBLKS_FIELD_WIDTH 32
#define LIF_RX_AGG_NO_ERR_BLKS_RXAGGNOERRBLKS_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_COR_BLKS_RXAGGCORRBLKS_FIELD;
#define LIF_RX_AGG_COR_BLKS_RXAGGCORRBLKS_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_COR_BLKS_RXAGGCORRBLKS_FIELD_WIDTH 32
#define LIF_RX_AGG_COR_BLKS_RXAGGCORRBLKS_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_UNCOR_BLKS_RXAGGUNCORRBLKS_FIELD;
#define LIF_RX_AGG_UNCOR_BLKS_RXAGGUNCORRBLKS_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_UNCOR_BLKS_RXAGGUNCORRBLKS_FIELD_WIDTH 32
#define LIF_RX_AGG_UNCOR_BLKS_RXAGGUNCORRBLKS_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_ERR_ONES_RXAGGERRONES_FIELD;
#define LIF_RX_AGG_ERR_ONES_RXAGGERRONES_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_ERR_ONES_RXAGGERRONES_FIELD_WIDTH 32
#define LIF_RX_AGG_ERR_ONES_RXAGGERRONES_FIELD_SHIFT 0

extern const ru_field_rec LIF_RX_AGG_ERR_FRM_RXAGGERROREDCNT_FIELD;
#define LIF_RX_AGG_ERR_FRM_RXAGGERROREDCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_RX_AGG_ERR_FRM_RXAGGERROREDCNT_FIELD_WIDTH 32
#define LIF_RX_AGG_ERR_FRM_RXAGGERROREDCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_PKT_CNT_TXFRAMECNT_FIELD;
#define LIF_TX_PKT_CNT_TXFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_PKT_CNT_TXFRAMECNT_FIELD_WIDTH 32
#define LIF_TX_PKT_CNT_TXFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_BYTE_CNT_TXBYTECNT_FIELD;
#define LIF_TX_BYTE_CNT_TXBYTECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_BYTE_CNT_TXBYTECNT_FIELD_WIDTH 32
#define LIF_TX_BYTE_CNT_TXBYTECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_NON_FEC_PKT_CNT_TXNONFECFRAMECNT_FIELD;
#define LIF_TX_NON_FEC_PKT_CNT_TXNONFECFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_NON_FEC_PKT_CNT_TXNONFECFRAMECNT_FIELD_WIDTH 32
#define LIF_TX_NON_FEC_PKT_CNT_TXNONFECFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_NON_FEC_BYTE_CNT_TXNONFECBYTECNT_FIELD;
#define LIF_TX_NON_FEC_BYTE_CNT_TXNONFECBYTECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_NON_FEC_BYTE_CNT_TXNONFECBYTECNT_FIELD_WIDTH 32
#define LIF_TX_NON_FEC_BYTE_CNT_TXNONFECBYTECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_FEC_PKT_CNT_TXFECFRAMECNT_FIELD;
#define LIF_TX_FEC_PKT_CNT_TXFECFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_FEC_PKT_CNT_TXFECFRAMECNT_FIELD_WIDTH 32
#define LIF_TX_FEC_PKT_CNT_TXFECFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_FEC_BYTE_CNT_TXFECBYTECNT_FIELD;
#define LIF_TX_FEC_BYTE_CNT_TXFECBYTECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_FEC_BYTE_CNT_TXFECBYTECNT_FIELD_WIDTH 32
#define LIF_TX_FEC_BYTE_CNT_TXFECBYTECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_FEC_BLK_CNT_TXFECBLKSCNT_FIELD;
#define LIF_TX_FEC_BLK_CNT_TXFECBLKSCNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_FEC_BLK_CNT_TXFECBLKSCNT_FIELD_WIDTH 32
#define LIF_TX_FEC_BLK_CNT_TXFECBLKSCNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_TX_MPCP_PKT_CNT_TXMPCPFRAMECNT_FIELD;
#define LIF_TX_MPCP_PKT_CNT_TXMPCPFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_TX_MPCP_PKT_CNT_TXMPCPFRAMECNT_FIELD_WIDTH 32
#define LIF_TX_MPCP_PKT_CNT_TXMPCPFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_DEBUG_TX_DATA_PKT_CNT_TXDATAFRAMECNT_FIELD;
#define LIF_DEBUG_TX_DATA_PKT_CNT_TXDATAFRAMECNT_FIELD_MASK  0x00000000ffffffff
#define LIF_DEBUG_TX_DATA_PKT_CNT_TXDATAFRAMECNT_FIELD_WIDTH 32
#define LIF_DEBUG_TX_DATA_PKT_CNT_TXDATAFRAMECNT_FIELD_SHIFT 0

extern const ru_field_rec LIF_FEC_LLID_STATUS_RESERVED0_FIELD;
#define LIF_FEC_LLID_STATUS_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_FEC_LLID_STATUS_RESERVED0_FIELD_WIDTH 16
#define LIF_FEC_LLID_STATUS_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_FEC_LLID_STATUS_STKYFECREVCLLIDBMSK_FIELD;
#define LIF_FEC_LLID_STATUS_STKYFECREVCLLIDBMSK_FIELD_MASK  0x000000000000ffff
#define LIF_FEC_LLID_STATUS_STKYFECREVCLLIDBMSK_FIELD_WIDTH 16
#define LIF_FEC_LLID_STATUS_STKYFECREVCLLIDBMSK_FIELD_SHIFT 0

extern const ru_field_rec LIF_SEC_RX_TEK_IG_IV_LLID_RESERVED0_FIELD;
#define LIF_SEC_RX_TEK_IG_IV_LLID_RESERVED0_FIELD_MASK  0x00000000fffe0000
#define LIF_SEC_RX_TEK_IG_IV_LLID_RESERVED0_FIELD_WIDTH 15
#define LIF_SEC_RX_TEK_IG_IV_LLID_RESERVED0_FIELD_SHIFT 17

extern const ru_field_rec LIF_SEC_RX_TEK_IG_IV_LLID_CFIGIVNULLLLID_FIELD;
#define LIF_SEC_RX_TEK_IG_IV_LLID_CFIGIVNULLLLID_FIELD_MASK  0x000000000001ffff
#define LIF_SEC_RX_TEK_IG_IV_LLID_CFIGIVNULLLLID_FIELD_WIDTH 17
#define LIF_SEC_RX_TEK_IG_IV_LLID_CFIGIVNULLLLID_FIELD_SHIFT 0

extern const ru_field_rec LIF_PON_BER_INTERV_THRESH_CFRXLIFBERINTERVAL_FIELD;
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERINTERVAL_FIELD_MASK  0x00000000ffff8000
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERINTERVAL_FIELD_WIDTH 17
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERINTERVAL_FIELD_SHIFT 15

extern const ru_field_rec LIF_PON_BER_INTERV_THRESH_CFRXLIFBERTHRESHLD_FIELD;
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERTHRESHLD_FIELD_MASK  0x0000000000007ffc
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERTHRESHLD_FIELD_WIDTH 13
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERTHRESHLD_FIELD_SHIFT 2

extern const ru_field_rec LIF_PON_BER_INTERV_THRESH_CFRXLIFBERCNTRL_FIELD;
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERCNTRL_FIELD_MASK  0x0000000000000003
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERCNTRL_FIELD_WIDTH 2
#define LIF_PON_BER_INTERV_THRESH_CFRXLIFBERCNTRL_FIELD_SHIFT 0

extern const ru_field_rec LIF_LSR_MON_A_CTRL_RESERVED0_FIELD;
#define LIF_LSR_MON_A_CTRL_RESERVED0_FIELD_MASK  0x00000000ffffffc0
#define LIF_LSR_MON_A_CTRL_RESERVED0_FIELD_WIDTH 26
#define LIF_LSR_MON_A_CTRL_RESERVED0_FIELD_SHIFT 6

extern const ru_field_rec LIF_LSR_MON_A_CTRL_IOPBILASERENS1A_FIELD;
#define LIF_LSR_MON_A_CTRL_IOPBILASERENS1A_FIELD_MASK  0x0000000000000020
#define LIF_LSR_MON_A_CTRL_IOPBILASERENS1A_FIELD_WIDTH 1
#define LIF_LSR_MON_A_CTRL_IOPBILASERENS1A_FIELD_SHIFT 5

extern const ru_field_rec LIF_LSR_MON_A_CTRL_CFGLSRMONACTHI_FIELD;
#define LIF_LSR_MON_A_CTRL_CFGLSRMONACTHI_FIELD_MASK  0x0000000000000010
#define LIF_LSR_MON_A_CTRL_CFGLSRMONACTHI_FIELD_WIDTH 1
#define LIF_LSR_MON_A_CTRL_CFGLSRMONACTHI_FIELD_SHIFT 4

extern const ru_field_rec LIF_LSR_MON_A_CTRL_RESERVED1_FIELD;
#define LIF_LSR_MON_A_CTRL_RESERVED1_FIELD_MASK  0x000000000000000e
#define LIF_LSR_MON_A_CTRL_RESERVED1_FIELD_WIDTH 3
#define LIF_LSR_MON_A_CTRL_RESERVED1_FIELD_SHIFT 1

extern const ru_field_rec LIF_LSR_MON_A_CTRL_PBILASERMONRSTA_N_PRE_FIELD;
#define LIF_LSR_MON_A_CTRL_PBILASERMONRSTA_N_PRE_FIELD_MASK  0x0000000000000001
#define LIF_LSR_MON_A_CTRL_PBILASERMONRSTA_N_PRE_FIELD_WIDTH 1
#define LIF_LSR_MON_A_CTRL_PBILASERMONRSTA_N_PRE_FIELD_SHIFT 0

extern const ru_field_rec LIF_LSR_MON_A_MAX_THR_CFGLASERMONMAXA_FIELD;
#define LIF_LSR_MON_A_MAX_THR_CFGLASERMONMAXA_FIELD_MASK  0x00000000ffffffff
#define LIF_LSR_MON_A_MAX_THR_CFGLASERMONMAXA_FIELD_WIDTH 32
#define LIF_LSR_MON_A_MAX_THR_CFGLASERMONMAXA_FIELD_SHIFT 0

extern const ru_field_rec LIF_LSR_MON_A_BST_LEN_LASERONTIMEA_FIELD;
#define LIF_LSR_MON_A_BST_LEN_LASERONTIMEA_FIELD_MASK  0x00000000ffffffff
#define LIF_LSR_MON_A_BST_LEN_LASERONTIMEA_FIELD_WIDTH 32
#define LIF_LSR_MON_A_BST_LEN_LASERONTIMEA_FIELD_SHIFT 0

extern const ru_field_rec LIF_LSR_MON_A_BST_CNT_LASERMONBRSTCNTA_FIELD;
#define LIF_LSR_MON_A_BST_CNT_LASERMONBRSTCNTA_FIELD_MASK  0x00000000ffffffff
#define LIF_LSR_MON_A_BST_CNT_LASERMONBRSTCNTA_FIELD_WIDTH 32
#define LIF_LSR_MON_A_BST_CNT_LASERMONBRSTCNTA_FIELD_SHIFT 0

extern const ru_field_rec LIF_DEBUG_PON_SM_RESERVED0_FIELD;
#define LIF_DEBUG_PON_SM_RESERVED0_FIELD_MASK  0x00000000ffffc000
#define LIF_DEBUG_PON_SM_RESERVED0_FIELD_WIDTH 18
#define LIF_DEBUG_PON_SM_RESERVED0_FIELD_SHIFT 14

extern const ru_field_rec LIF_DEBUG_PON_SM_ALIGNCSQQ_FIELD;
#define LIF_DEBUG_PON_SM_ALIGNCSQQ_FIELD_MASK  0x0000000000003f00
#define LIF_DEBUG_PON_SM_ALIGNCSQQ_FIELD_WIDTH 6
#define LIF_DEBUG_PON_SM_ALIGNCSQQ_FIELD_SHIFT 8

extern const ru_field_rec LIF_DEBUG_PON_SM_RESERVED1_FIELD;
#define LIF_DEBUG_PON_SM_RESERVED1_FIELD_MASK  0x00000000000000e0
#define LIF_DEBUG_PON_SM_RESERVED1_FIELD_WIDTH 3
#define LIF_DEBUG_PON_SM_RESERVED1_FIELD_SHIFT 5

extern const ru_field_rec LIF_DEBUG_PON_SM_RXFECIFCSQQ_FIELD;
#define LIF_DEBUG_PON_SM_RXFECIFCSQQ_FIELD_MASK  0x000000000000001f
#define LIF_DEBUG_PON_SM_RXFECIFCSQQ_FIELD_WIDTH 5
#define LIF_DEBUG_PON_SM_RXFECIFCSQQ_FIELD_SHIFT 0

extern const ru_field_rec LIF_DEBUG_FEC_SM_RESERVED0_FIELD;
#define LIF_DEBUG_FEC_SM_RESERVED0_FIELD_MASK  0x00000000ffe00000
#define LIF_DEBUG_FEC_SM_RESERVED0_FIELD_WIDTH 11
#define LIF_DEBUG_FEC_SM_RESERVED0_FIELD_SHIFT 21

extern const ru_field_rec LIF_DEBUG_FEC_SM_RXSYNCSQQ_FIELD;
#define LIF_DEBUG_FEC_SM_RXSYNCSQQ_FIELD_MASK  0x00000000001f0000
#define LIF_DEBUG_FEC_SM_RXSYNCSQQ_FIELD_WIDTH 5
#define LIF_DEBUG_FEC_SM_RXSYNCSQQ_FIELD_SHIFT 16

extern const ru_field_rec LIF_DEBUG_FEC_SM_RESERVED1_FIELD;
#define LIF_DEBUG_FEC_SM_RESERVED1_FIELD_MASK  0x000000000000fc00
#define LIF_DEBUG_FEC_SM_RESERVED1_FIELD_WIDTH 6
#define LIF_DEBUG_FEC_SM_RESERVED1_FIELD_SHIFT 10

extern const ru_field_rec LIF_DEBUG_FEC_SM_RXCORCS_FIELD;
#define LIF_DEBUG_FEC_SM_RXCORCS_FIELD_MASK  0x0000000000000300
#define LIF_DEBUG_FEC_SM_RXCORCS_FIELD_WIDTH 2
#define LIF_DEBUG_FEC_SM_RXCORCS_FIELD_SHIFT 8

extern const ru_field_rec LIF_DEBUG_FEC_SM_RESERVED2_FIELD;
#define LIF_DEBUG_FEC_SM_RESERVED2_FIELD_MASK  0x00000000000000e0
#define LIF_DEBUG_FEC_SM_RESERVED2_FIELD_WIDTH 3
#define LIF_DEBUG_FEC_SM_RESERVED2_FIELD_SHIFT 5

extern const ru_field_rec LIF_DEBUG_FEC_SM_FECRXOUTCS_FIELD;
#define LIF_DEBUG_FEC_SM_FECRXOUTCS_FIELD_MASK  0x000000000000001f
#define LIF_DEBUG_FEC_SM_FECRXOUTCS_FIELD_WIDTH 5
#define LIF_DEBUG_FEC_SM_FECRXOUTCS_FIELD_SHIFT 0

extern const ru_field_rec LIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD;
#define LIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD_MASK  0x00000000ffffffff
#define LIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD_WIDTH 32
#define LIF_AE_PKTNUM_WINDOW_CFGAEPKTNUMWND_FIELD_SHIFT 0

extern const ru_field_rec LIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD;
#define LIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD_MASK  0x00000000ffffffff
#define LIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD_WIDTH 32
#define LIF_AE_PKTNUM_THRESH_CFGPKTNUMMAXTHRESH_FIELD_SHIFT 0

extern const ru_field_rec LIF_AE_PKTNUM_STAT_RESERVED0_FIELD;
#define LIF_AE_PKTNUM_STAT_RESERVED0_FIELD_MASK  0x00000000fff80000
#define LIF_AE_PKTNUM_STAT_RESERVED0_FIELD_WIDTH 13
#define LIF_AE_PKTNUM_STAT_RESERVED0_FIELD_SHIFT 19

extern const ru_field_rec LIF_AE_PKTNUM_STAT_SECUPINDXWTPKTNUMMAX_FIELD;
#define LIF_AE_PKTNUM_STAT_SECUPINDXWTPKTNUMMAX_FIELD_MASK  0x0000000000070000
#define LIF_AE_PKTNUM_STAT_SECUPINDXWTPKTNUMMAX_FIELD_WIDTH 3
#define LIF_AE_PKTNUM_STAT_SECUPINDXWTPKTNUMMAX_FIELD_SHIFT 16

extern const ru_field_rec LIF_AE_PKTNUM_STAT_RESERVED1_FIELD;
#define LIF_AE_PKTNUM_STAT_RESERVED1_FIELD_MASK  0x000000000000ffe0
#define LIF_AE_PKTNUM_STAT_RESERVED1_FIELD_WIDTH 11
#define LIF_AE_PKTNUM_STAT_RESERVED1_FIELD_SHIFT 5

extern const ru_field_rec LIF_AE_PKTNUM_STAT_SECDNINDXWTPKTNUMABORT_FIELD;
#define LIF_AE_PKTNUM_STAT_SECDNINDXWTPKTNUMABORT_FIELD_MASK  0x000000000000001f
#define LIF_AE_PKTNUM_STAT_SECDNINDXWTPKTNUMABORT_FIELD_WIDTH 5
#define LIF_AE_PKTNUM_STAT_SECDNINDXWTPKTNUMABORT_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_LINKTIMER_FIELD;
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_LINKTIMER_FIELD_MASK  0x00000000ffff0000
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_LINKTIMER_FIELD_WIDTH 16
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_LINKTIMER_FIELD_SHIFT 16

extern const ru_field_rec LIF_P2P_AUTONEG_CONTROL_RESERVED0_FIELD;
#define LIF_P2P_AUTONEG_CONTROL_RESERVED0_FIELD_MASK  0x000000000000fff8
#define LIF_P2P_AUTONEG_CONTROL_RESERVED0_FIELD_WIDTH 13
#define LIF_P2P_AUTONEG_CONTROL_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_MODE_SEL_FIELD;
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_MODE_SEL_FIELD_MASK  0x0000000000000004
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_MODE_SEL_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_MODE_SEL_FIELD_SHIFT 2

extern const ru_field_rec LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_RESTART_FIELD;
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_RESTART_FIELD_MASK  0x0000000000000002
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_RESTART_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_RESTART_FIELD_SHIFT 1

extern const ru_field_rec LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_EN_FIELD;
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_EN_FIELD_MASK  0x0000000000000001
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_EN_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_CONTROL_CF_AUTONEG_EN_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AUTONEG_STATUS_RESERVED0_FIELD;
#define LIF_P2P_AUTONEG_STATUS_RESERVED0_FIELD_MASK  0x00000000fffffff8
#define LIF_P2P_AUTONEG_STATUS_RESERVED0_FIELD_WIDTH 29
#define LIF_P2P_AUTONEG_STATUS_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec LIF_P2P_AUTONEG_STATUS_AN_LP_REMOTE_FAULT_FIELD;
#define LIF_P2P_AUTONEG_STATUS_AN_LP_REMOTE_FAULT_FIELD_MASK  0x0000000000000004
#define LIF_P2P_AUTONEG_STATUS_AN_LP_REMOTE_FAULT_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_STATUS_AN_LP_REMOTE_FAULT_FIELD_SHIFT 2

extern const ru_field_rec LIF_P2P_AUTONEG_STATUS_AN_SYNC_STATUS_FIELD;
#define LIF_P2P_AUTONEG_STATUS_AN_SYNC_STATUS_FIELD_MASK  0x0000000000000002
#define LIF_P2P_AUTONEG_STATUS_AN_SYNC_STATUS_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_STATUS_AN_SYNC_STATUS_FIELD_SHIFT 1

extern const ru_field_rec LIF_P2P_AUTONEG_STATUS_AN_COMPLETE_FIELD;
#define LIF_P2P_AUTONEG_STATUS_AN_COMPLETE_FIELD_MASK  0x0000000000000001
#define LIF_P2P_AUTONEG_STATUS_AN_COMPLETE_FIELD_WIDTH 1
#define LIF_P2P_AUTONEG_STATUS_AN_COMPLETE_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_RESERVED0_FIELD;
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_RESERVED0_FIELD_WIDTH 16
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_CF_LIF_P2P_AE_AUTONEG_CONFIG_ABILITY_FIELD;
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_CF_LIF_P2P_AE_AUTONEG_CONFIG_ABILITY_FIELD_MASK  0x000000000000ffff
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_CF_LIF_P2P_AE_AUTONEG_CONFIG_ABILITY_FIELD_WIDTH 16
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_CF_LIF_P2P_AE_AUTONEG_CONFIG_ABILITY_FIELD_SHIFT 0

extern const ru_field_rec LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_RESERVED0_FIELD;
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_RESERVED0_FIELD_WIDTH 16
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_CF_LIF_P2P_AE_AUTONEG_LP_ABILITY_READ_FIELD;
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_CF_LIF_P2P_AE_AUTONEG_LP_ABILITY_READ_FIELD_MASK  0x000000000000ffff
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_CF_LIF_P2P_AE_AUTONEG_LP_ABILITY_READ_FIELD_WIDTH 16
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_CF_LIF_P2P_AE_AUTONEG_LP_ABILITY_READ_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_CFG_RESERVED0_FIELD;
#define NCO_ADDR_NCO_CFG_RESERVED0_FIELD_MASK  0x00000000ffffff00
#define NCO_ADDR_NCO_CFG_RESERVED0_FIELD_WIDTH 24
#define NCO_ADDR_NCO_CFG_RESERVED0_FIELD_SHIFT 8

extern const ru_field_rec NCO_ADDR_NCO_CFG_CFGBYPASS_FIELD;
#define NCO_ADDR_NCO_CFG_CFGBYPASS_FIELD_MASK  0x0000000000000080
#define NCO_ADDR_NCO_CFG_CFGBYPASS_FIELD_WIDTH 1
#define NCO_ADDR_NCO_CFG_CFGBYPASS_FIELD_SHIFT 7

extern const ru_field_rec NCO_ADDR_NCO_CFG_CFGSRCOUT10MHZ_FIELD;
#define NCO_ADDR_NCO_CFG_CFGSRCOUT10MHZ_FIELD_MASK  0x0000000000000060
#define NCO_ADDR_NCO_CFG_CFGSRCOUT10MHZ_FIELD_WIDTH 2
#define NCO_ADDR_NCO_CFG_CFGSRCOUT10MHZ_FIELD_SHIFT 5

extern const ru_field_rec NCO_ADDR_NCO_CFG_CFGSRCOUT_FIELD;
#define NCO_ADDR_NCO_CFG_CFGSRCOUT_FIELD_MASK  0x0000000000000018
#define NCO_ADDR_NCO_CFG_CFGSRCOUT_FIELD_WIDTH 2
#define NCO_ADDR_NCO_CFG_CFGSRCOUT_FIELD_SHIFT 3

extern const ru_field_rec NCO_ADDR_NCO_CFG_CFGSRCIN_FIELD;
#define NCO_ADDR_NCO_CFG_CFGSRCIN_FIELD_MASK  0x0000000000000006
#define NCO_ADDR_NCO_CFG_CFGSRCIN_FIELD_WIDTH 2
#define NCO_ADDR_NCO_CFG_CFGSRCIN_FIELD_SHIFT 1

extern const ru_field_rec NCO_ADDR_NCO_CFG_CFGNCOCLR_FIELD;
#define NCO_ADDR_NCO_CFG_CFGNCOCLR_FIELD_MASK  0x0000000000000001
#define NCO_ADDR_NCO_CFG_CFGNCOCLR_FIELD_WIDTH 1
#define NCO_ADDR_NCO_CFG_CFGNCOCLR_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_INT_RESERVED0_FIELD;
#define NCO_ADDR_NCO_INT_RESERVED0_FIELD_MASK  0x00000000fffffff8
#define NCO_ADDR_NCO_INT_RESERVED0_FIELD_WIDTH 29
#define NCO_ADDR_NCO_INT_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec NCO_ADDR_NCO_INT_INTNONCOSYNC_FIELD;
#define NCO_ADDR_NCO_INT_INTNONCOSYNC_FIELD_MASK  0x0000000000000004
#define NCO_ADDR_NCO_INT_INTNONCOSYNC_FIELD_WIDTH 1
#define NCO_ADDR_NCO_INT_INTNONCOSYNC_FIELD_SHIFT 2

extern const ru_field_rec NCO_ADDR_NCO_INT_INTNOXIFPPS_FIELD;
#define NCO_ADDR_NCO_INT_INTNOXIFPPS_FIELD_MASK  0x0000000000000002
#define NCO_ADDR_NCO_INT_INTNOXIFPPS_FIELD_WIDTH 1
#define NCO_ADDR_NCO_INT_INTNOXIFPPS_FIELD_SHIFT 1

extern const ru_field_rec NCO_ADDR_NCO_INT_INTNOLIFPPS_FIELD;
#define NCO_ADDR_NCO_INT_INTNOLIFPPS_FIELD_MASK  0x0000000000000001
#define NCO_ADDR_NCO_INT_INTNOLIFPPS_FIELD_WIDTH 1
#define NCO_ADDR_NCO_INT_INTNOLIFPPS_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_MSK_RESERVED0_FIELD;
#define NCO_ADDR_NCO_MSK_RESERVED0_FIELD_MASK  0x00000000fffffff8
#define NCO_ADDR_NCO_MSK_RESERVED0_FIELD_WIDTH 29
#define NCO_ADDR_NCO_MSK_RESERVED0_FIELD_SHIFT 3

extern const ru_field_rec NCO_ADDR_NCO_MSK_INTNONCOSYNCMASK_FIELD;
#define NCO_ADDR_NCO_MSK_INTNONCOSYNCMASK_FIELD_MASK  0x0000000000000004
#define NCO_ADDR_NCO_MSK_INTNONCOSYNCMASK_FIELD_WIDTH 1
#define NCO_ADDR_NCO_MSK_INTNONCOSYNCMASK_FIELD_SHIFT 2

extern const ru_field_rec NCO_ADDR_NCO_MSK_INTNOXIFPPSMASK_FIELD;
#define NCO_ADDR_NCO_MSK_INTNOXIFPPSMASK_FIELD_MASK  0x0000000000000002
#define NCO_ADDR_NCO_MSK_INTNOXIFPPSMASK_FIELD_WIDTH 1
#define NCO_ADDR_NCO_MSK_INTNOXIFPPSMASK_FIELD_SHIFT 1

extern const ru_field_rec NCO_ADDR_NCO_MSK_INTNOLIFPPSMASK_FIELD;
#define NCO_ADDR_NCO_MSK_INTNOLIFPPSMASK_FIELD_MASK  0x0000000000000001
#define NCO_ADDR_NCO_MSK_INTNOLIFPPSMASK_FIELD_WIDTH 1
#define NCO_ADDR_NCO_MSK_INTNOLIFPPSMASK_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_1PPS_PERIOD_RESERVED0_FIELD;
#define NCO_ADDR_NCO_1PPS_PERIOD_RESERVED0_FIELD_MASK  0x00000000ff000000
#define NCO_ADDR_NCO_1PPS_PERIOD_RESERVED0_FIELD_WIDTH 8
#define NCO_ADDR_NCO_1PPS_PERIOD_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec NCO_ADDR_NCO_1PPS_PERIOD_CFG1PPSPERIOD_FIELD;
#define NCO_ADDR_NCO_1PPS_PERIOD_CFG1PPSPERIOD_FIELD_MASK  0x0000000000ffffff
#define NCO_ADDR_NCO_1PPS_PERIOD_CFG1PPSPERIOD_FIELD_WIDTH 24
#define NCO_ADDR_NCO_1PPS_PERIOD_CFG1PPSPERIOD_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_8KHZ_PERIOD_RESERVED0_FIELD;
#define NCO_ADDR_NCO_8KHZ_PERIOD_RESERVED0_FIELD_MASK  0x00000000ff000000
#define NCO_ADDR_NCO_8KHZ_PERIOD_RESERVED0_FIELD_WIDTH 8
#define NCO_ADDR_NCO_8KHZ_PERIOD_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec NCO_ADDR_NCO_8KHZ_PERIOD_CFG8KHZPERIOD_FIELD;
#define NCO_ADDR_NCO_8KHZ_PERIOD_CFG8KHZPERIOD_FIELD_MASK  0x0000000000ffffff
#define NCO_ADDR_NCO_8KHZ_PERIOD_CFG8KHZPERIOD_FIELD_WIDTH 24
#define NCO_ADDR_NCO_8KHZ_PERIOD_CFG8KHZPERIOD_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_CENTER_FREQUENCY_CFGNCODEFAULT_FIELD;
#define NCO_ADDR_NCO_CENTER_FREQUENCY_CFGNCODEFAULT_FIELD_MASK  0x00000000ffffffff
#define NCO_ADDR_NCO_CENTER_FREQUENCY_CFGNCODEFAULT_FIELD_WIDTH 32
#define NCO_ADDR_NCO_CENTER_FREQUENCY_CFGNCODEFAULT_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_INT_GAIN_RESERVED0_FIELD;
#define NCO_ADDR_NCO_INT_GAIN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define NCO_ADDR_NCO_INT_GAIN_RESERVED0_FIELD_WIDTH 16
#define NCO_ADDR_NCO_INT_GAIN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec NCO_ADDR_NCO_INT_GAIN_CFGNCOGAIN_FIELD;
#define NCO_ADDR_NCO_INT_GAIN_CFGNCOGAIN_FIELD_MASK  0x000000000000ffff
#define NCO_ADDR_NCO_INT_GAIN_CFGNCOGAIN_FIELD_WIDTH 16
#define NCO_ADDR_NCO_INT_GAIN_CFGNCOGAIN_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_PRO_GAIN_RESERVED0_FIELD;
#define NCO_ADDR_NCO_PRO_GAIN_RESERVED0_FIELD_MASK  0x00000000ffff0000
#define NCO_ADDR_NCO_PRO_GAIN_RESERVED0_FIELD_WIDTH 16
#define NCO_ADDR_NCO_PRO_GAIN_RESERVED0_FIELD_SHIFT 16

extern const ru_field_rec NCO_ADDR_NCO_PRO_GAIN_CFGNCOPROPGAIN_FIELD;
#define NCO_ADDR_NCO_PRO_GAIN_CFGNCOPROPGAIN_FIELD_MASK  0x000000000000ffff
#define NCO_ADDR_NCO_PRO_GAIN_CFGNCOPROPGAIN_FIELD_WIDTH 16
#define NCO_ADDR_NCO_PRO_GAIN_CFGNCOPROPGAIN_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_CNT_NCOCNT_FIELD;
#define NCO_ADDR_NCO_CNT_NCOCNT_FIELD_MASK  0x00000000ffffffff
#define NCO_ADDR_NCO_CNT_NCOCNT_FIELD_WIDTH 32
#define NCO_ADDR_NCO_CNT_NCOCNT_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_1PPS_HALF_RESERVED0_FIELD;
#define NCO_ADDR_NCO_1PPS_HALF_RESERVED0_FIELD_MASK  0x00000000ff000000
#define NCO_ADDR_NCO_1PPS_HALF_RESERVED0_FIELD_WIDTH 8
#define NCO_ADDR_NCO_1PPS_HALF_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec NCO_ADDR_NCO_1PPS_HALF_CFG1PPSHALFPERIOD_FIELD;
#define NCO_ADDR_NCO_1PPS_HALF_CFG1PPSHALFPERIOD_FIELD_MASK  0x0000000000ffffff
#define NCO_ADDR_NCO_1PPS_HALF_CFG1PPSHALFPERIOD_FIELD_WIDTH 24
#define NCO_ADDR_NCO_1PPS_HALF_CFG1PPSHALFPERIOD_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_8KHZ_HALF_RESERVED0_FIELD;
#define NCO_ADDR_NCO_8KHZ_HALF_RESERVED0_FIELD_MASK  0x00000000ff000000
#define NCO_ADDR_NCO_8KHZ_HALF_RESERVED0_FIELD_WIDTH 8
#define NCO_ADDR_NCO_8KHZ_HALF_RESERVED0_FIELD_SHIFT 24

extern const ru_field_rec NCO_ADDR_NCO_8KHZ_HALF_CFG8KHZHALFPERIOD_FIELD;
#define NCO_ADDR_NCO_8KHZ_HALF_CFG8KHZHALFPERIOD_FIELD_MASK  0x0000000000ffffff
#define NCO_ADDR_NCO_8KHZ_HALF_CFG8KHZHALFPERIOD_FIELD_WIDTH 24
#define NCO_ADDR_NCO_8KHZ_HALF_CFG8KHZHALFPERIOD_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_PERIOD_CNT_PERIODCNT_FIELD;
#define NCO_ADDR_NCO_PERIOD_CNT_PERIODCNT_FIELD_MASK  0x00000000ffffffff
#define NCO_ADDR_NCO_PERIOD_CNT_PERIODCNT_FIELD_WIDTH 32
#define NCO_ADDR_NCO_PERIOD_CNT_PERIODCNT_FIELD_SHIFT 0

extern const ru_field_rec NCO_ADDR_NCO_PHS_ERR_CNT_RESERVED0_FIELD;
#define NCO_ADDR_NCO_PHS_ERR_CNT_RESERVED0_FIELD_MASK  0x00000000fffff000
#define NCO_ADDR_NCO_PHS_ERR_CNT_RESERVED0_FIELD_WIDTH 20
#define NCO_ADDR_NCO_PHS_ERR_CNT_RESERVED0_FIELD_SHIFT 12

extern const ru_field_rec NCO_ADDR_NCO_PHS_ERR_CNT_NCOPHSERR_FIELD;
#define NCO_ADDR_NCO_PHS_ERR_CNT_NCOPHSERR_FIELD_MASK  0x0000000000000fff
#define NCO_ADDR_NCO_PHS_ERR_CNT_NCOPHSERR_FIELD_WIDTH 12
#define NCO_ADDR_NCO_PHS_ERR_CNT_NCOPHSERR_FIELD_SHIFT 0



/******************************************************************************
 * EPON Registers
 ******************************************************************************/
extern const ru_reg_rec EPON_TOP_SCRATCH_REG;
#define EPON_TOP_SCRATCH_REG_OFFSET 0x00000000

extern const ru_reg_rec EPON_TOP_RESET_REG;
#define EPON_TOP_RESET_REG_OFFSET 0x00000004

extern const ru_reg_rec EPON_TOP_INTERRUPT_REG;
#define EPON_TOP_INTERRUPT_REG_OFFSET 0x00000008

extern const ru_reg_rec EPON_TOP_INTERRUPT_MASK_REG;
#define EPON_TOP_INTERRUPT_MASK_REG_OFFSET 0x0000000c

extern const ru_reg_rec EPON_TOP_CONTROL_REG;
#define EPON_TOP_CONTROL_REG_OFFSET 0x00000010

extern const ru_reg_rec EPON_TOP_ONE_PPS_MPCP_OFFSET_REG;
#define EPON_TOP_ONE_PPS_MPCP_OFFSET_REG_OFFSET 0x00000014

extern const ru_reg_rec EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_REG;
#define EPON_TOP_ONE_PPS_CAPTURED_MPCP_TIME_REG_OFFSET 0x00000018

extern const ru_reg_rec EPON_TOP_TOD_CONFIG_REG;
#define EPON_TOP_TOD_CONFIG_REG_OFFSET 0x0000001c

extern const ru_reg_rec EPON_TOP_TOD_NS_REG;
#define EPON_TOP_TOD_NS_REG_OFFSET 0x00000020

extern const ru_reg_rec EPON_TOP_TOD_MPCP_REG;
#define EPON_TOP_TOD_MPCP_REG_OFFSET 0x00000024

extern const ru_reg_rec EPON_TOP_TS48_MSB_REG;
#define EPON_TOP_TS48_MSB_REG_OFFSET 0x00000028

extern const ru_reg_rec EPON_TOP_TS48_LSB_REG;
#define EPON_TOP_TS48_LSB_REG_OFFSET 0x0000002c

extern const ru_reg_rec EPON_TOP_TSEC_REG;
#define EPON_TOP_TSEC_REG_OFFSET 0x00000030

extern const ru_reg_rec EPON_TOP_TNS_EPON_REG;
#define EPON_TOP_TNS_EPON_REG_OFFSET 0x00000034

extern const ru_reg_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_REG;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_REG_OFFSET 0x00000000

extern const ru_reg_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_REG;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_REG_OFFSET 0x00000004

extern const ru_reg_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_REG;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG_1_REG_OFFSET 0x00000008

extern const ru_reg_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_REG;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG2_1_REG_OFFSET 0x0000000c

extern const ru_reg_rec CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_REG;
#define CLK_PRG_SWCH_ADDR_CLK_PRG_CONFIG3_REG_OFFSET 0x00000010

extern const ru_reg_rec EPN_CONTROL_0_REG;
#define EPN_CONTROL_0_REG_OFFSET 0x00000000

extern const ru_reg_rec EPN_CONTROL_1_REG;
#define EPN_CONTROL_1_REG_OFFSET 0x00000004

extern const ru_reg_rec EPN_ENABLE_GRANTS_REG;
#define EPN_ENABLE_GRANTS_REG_OFFSET 0x00000008

extern const ru_reg_rec EPN_DROP_DISC_GATES_REG;
#define EPN_DROP_DISC_GATES_REG_OFFSET 0x0000000c

extern const ru_reg_rec EPN_DIS_FCS_CHK_REG;
#define EPN_DIS_FCS_CHK_REG_OFFSET 0x00000010

extern const ru_reg_rec EPN_PASS_GATES_REG;
#define EPN_PASS_GATES_REG_OFFSET 0x00000014

extern const ru_reg_rec EPN_CFG_MISALGN_FB_REG;
#define EPN_CFG_MISALGN_FB_REG_OFFSET 0x00000018

extern const ru_reg_rec EPN_DISCOVERY_FILTER_REG;
#define EPN_DISCOVERY_FILTER_REG_OFFSET 0x0000001c

extern const ru_reg_rec EPN_MINIMUM_GRANT_SETUP_REG;
#define EPN_MINIMUM_GRANT_SETUP_REG_OFFSET 0x00000020

extern const ru_reg_rec EPN_RESET_GNT_FIFO_REG;
#define EPN_RESET_GNT_FIFO_REG_OFFSET 0x00000024

extern const ru_reg_rec EPN_RESET_L1_ACCUMULATOR_REG;
#define EPN_RESET_L1_ACCUMULATOR_REG_OFFSET 0x00000028

extern const ru_reg_rec EPN_L1_ACCUMULATOR_SEL_REG;
#define EPN_L1_ACCUMULATOR_SEL_REG_OFFSET 0x0000002c

extern const ru_reg_rec EPN_L1_SVA_BYTES_REG;
#define EPN_L1_SVA_BYTES_REG_OFFSET 0x00000030

extern const ru_reg_rec EPN_L1_UVA_BYTES_REG;
#define EPN_L1_UVA_BYTES_REG_OFFSET 0x00000034

extern const ru_reg_rec EPN_L1_SVA_OVERFLOW_REG;
#define EPN_L1_SVA_OVERFLOW_REG_OFFSET 0x00000038

extern const ru_reg_rec EPN_L1_UVA_OVERFLOW_REG;
#define EPN_L1_UVA_OVERFLOW_REG_OFFSET 0x0000003c

extern const ru_reg_rec EPN_RESET_RPT_PRI_REG;
#define EPN_RESET_RPT_PRI_REG_OFFSET 0x00000040

extern const ru_reg_rec EPN_RESET_L2_RPT_FIFO_REG;
#define EPN_RESET_L2_RPT_FIFO_REG_OFFSET 0x00000044

extern const ru_reg_rec EPN_ENABLE_UPSTREAM_REG;
#define EPN_ENABLE_UPSTREAM_REG_OFFSET 0x00000048

extern const ru_reg_rec EPN_ENABLE_UPSTREAM_FB_REG;
#define EPN_ENABLE_UPSTREAM_FB_REG_OFFSET 0x0000004c

extern const ru_reg_rec EPN_ENABLE_UPSTREAM_FEC_REG;
#define EPN_ENABLE_UPSTREAM_FEC_REG_OFFSET 0x00000050

extern const ru_reg_rec EPN_REPORT_BYTE_LENGTH_REG;
#define EPN_REPORT_BYTE_LENGTH_REG_OFFSET 0x00000054

extern const ru_reg_rec EPN_MAIN_INT_STATUS_REG;
#define EPN_MAIN_INT_STATUS_REG_OFFSET 0x00000058

extern const ru_reg_rec EPN_GNT_FULL_INT_STATUS_REG;
#define EPN_GNT_FULL_INT_STATUS_REG_OFFSET 0x0000005c

extern const ru_reg_rec EPN_GNT_FULL_INT_MASK_REG;
#define EPN_GNT_FULL_INT_MASK_REG_OFFSET 0x00000060

extern const ru_reg_rec EPN_GNT_MISS_INT_STATUS_REG;
#define EPN_GNT_MISS_INT_STATUS_REG_OFFSET 0x00000064

extern const ru_reg_rec EPN_GNT_MISS_INT_MASK_REG;
#define EPN_GNT_MISS_INT_MASK_REG_OFFSET 0x00000068

extern const ru_reg_rec EPN_DISC_RX_INT_STATUS_REG;
#define EPN_DISC_RX_INT_STATUS_REG_OFFSET 0x0000006c

extern const ru_reg_rec EPN_DISC_RX_INT_MASK_REG;
#define EPN_DISC_RX_INT_MASK_REG_OFFSET 0x00000070

extern const ru_reg_rec EPN_GNT_INTV_INT_STATUS_REG;
#define EPN_GNT_INTV_INT_STATUS_REG_OFFSET 0x00000074

extern const ru_reg_rec EPN_GNT_INTV_INT_MASK_REG;
#define EPN_GNT_INTV_INT_MASK_REG_OFFSET 0x00000078

extern const ru_reg_rec EPN_GNT_FAR_INT_STATUS_REG;
#define EPN_GNT_FAR_INT_STATUS_REG_OFFSET 0x0000007c

extern const ru_reg_rec EPN_GNT_FAR_INT_MASK_REG;
#define EPN_GNT_FAR_INT_MASK_REG_OFFSET 0x00000080

extern const ru_reg_rec EPN_GNT_MISALGN_INT_STATUS_REG;
#define EPN_GNT_MISALGN_INT_STATUS_REG_OFFSET 0x00000084

extern const ru_reg_rec EPN_GNT_MISALGN_INT_MASK_REG;
#define EPN_GNT_MISALGN_INT_MASK_REG_OFFSET 0x00000088

extern const ru_reg_rec EPN_NP_GNT_INT_STATUS_REG;
#define EPN_NP_GNT_INT_STATUS_REG_OFFSET 0x0000008c

extern const ru_reg_rec EPN_NP_GNT_INT_MASK_REG;
#define EPN_NP_GNT_INT_MASK_REG_OFFSET 0x00000090

extern const ru_reg_rec EPN_DEL_STALE_INT_STATUS_REG;
#define EPN_DEL_STALE_INT_STATUS_REG_OFFSET 0x00000094

extern const ru_reg_rec EPN_DEL_STALE_INT_MASK_REG;
#define EPN_DEL_STALE_INT_MASK_REG_OFFSET 0x00000098

extern const ru_reg_rec EPN_GNT_PRES_INT_STATUS_REG;
#define EPN_GNT_PRES_INT_STATUS_REG_OFFSET 0x0000009c

extern const ru_reg_rec EPN_GNT_PRES_INT_MASK_REG;
#define EPN_GNT_PRES_INT_MASK_REG_OFFSET 0x000000a0

extern const ru_reg_rec EPN_RPT_PRES_INT_STATUS_REG;
#define EPN_RPT_PRES_INT_STATUS_REG_OFFSET 0x000000a4

extern const ru_reg_rec EPN_RPT_PRES_INT_MASK_REG;
#define EPN_RPT_PRES_INT_MASK_REG_OFFSET 0x000000a8

extern const ru_reg_rec EPN_DRX_ABORT_INT_STATUS_REG;
#define EPN_DRX_ABORT_INT_STATUS_REG_OFFSET 0x000000ac

extern const ru_reg_rec EPN_DRX_ABORT_INT_MASK_REG;
#define EPN_DRX_ABORT_INT_MASK_REG_OFFSET 0x000000b0

extern const ru_reg_rec EPN_EMPTY_RPT_INT_STATUS_REG;
#define EPN_EMPTY_RPT_INT_STATUS_REG_OFFSET 0x000000b4

extern const ru_reg_rec EPN_EMPTY_RPT_INT_MASK_REG;
#define EPN_EMPTY_RPT_INT_MASK_REG_OFFSET 0x000000b8

extern const ru_reg_rec EPN_BCAP_OVERFLOW_INT_STATUS_REG;
#define EPN_BCAP_OVERFLOW_INT_STATUS_REG_OFFSET 0x000000bc

extern const ru_reg_rec EPN_BCAP_OVERFLOW_INT_MASK_REG;
#define EPN_BCAP_OVERFLOW_INT_MASK_REG_OFFSET 0x000000c0

extern const ru_reg_rec EPN_BBH_DNS_FAULT_INT_STATUS_REG;
#define EPN_BBH_DNS_FAULT_INT_STATUS_REG_OFFSET 0x000000c4

extern const ru_reg_rec EPN_BBH_DNS_FAULT_INT_MASK_REG;
#define EPN_BBH_DNS_FAULT_INT_MASK_REG_OFFSET 0x000000c8

extern const ru_reg_rec EPN_BBH_UPS_FAULT_INT_STATUS_REG;
#define EPN_BBH_UPS_FAULT_INT_STATUS_REG_OFFSET 0x000000cc

extern const ru_reg_rec EPN_BBH_UPS_FAULT_INT_MASK_REG;
#define EPN_BBH_UPS_FAULT_INT_MASK_REG_OFFSET 0x000000d0

extern const ru_reg_rec EPN_BBH_UPS_ABORT_INT_STATUS_REG;
#define EPN_BBH_UPS_ABORT_INT_STATUS_REG_OFFSET 0x000000d4

extern const ru_reg_rec EPN_BBH_UPS_ABORT_INT_MASK_REG;
#define EPN_BBH_UPS_ABORT_INT_MASK_REG_OFFSET 0x000000d8

extern const ru_reg_rec EPN_MAIN_INT_MASK_REG;
#define EPN_MAIN_INT_MASK_REG_OFFSET 0x000000dc

extern const ru_reg_rec EPN_MAX_GNT_SIZE_REG;
#define EPN_MAX_GNT_SIZE_REG_OFFSET 0x000000e0

extern const ru_reg_rec EPN_MAX_FRAME_SIZE_REG;
#define EPN_MAX_FRAME_SIZE_REG_OFFSET 0x000000e4

extern const ru_reg_rec EPN_GRANT_OVR_HD_REG;
#define EPN_GRANT_OVR_HD_REG_OFFSET 0x000000e8

extern const ru_reg_rec EPN_POLL_SIZE_REG;
#define EPN_POLL_SIZE_REG_OFFSET 0x000000ec

extern const ru_reg_rec EPN_DN_RD_GNT_MARGIN_REG;
#define EPN_DN_RD_GNT_MARGIN_REG_OFFSET 0x000000f0

extern const ru_reg_rec EPN_GNT_TIME_START_DELTA_REG;
#define EPN_GNT_TIME_START_DELTA_REG_OFFSET 0x000000f4

extern const ru_reg_rec EPN_TIME_STAMP_DIFF_REG;
#define EPN_TIME_STAMP_DIFF_REG_OFFSET 0x000000f8

extern const ru_reg_rec EPN_UP_TIME_STAMP_OFF_REG;
#define EPN_UP_TIME_STAMP_OFF_REG_OFFSET 0x000000fc

extern const ru_reg_rec EPN_GNT_INTERVAL_REG;
#define EPN_GNT_INTERVAL_REG_OFFSET 0x00000100

extern const ru_reg_rec EPN_DN_GNT_MISALIGN_THR_REG;
#define EPN_DN_GNT_MISALIGN_THR_REG_OFFSET 0x00000104

extern const ru_reg_rec EPN_DN_GNT_MISALIGN_PAUSE_REG;
#define EPN_DN_GNT_MISALIGN_PAUSE_REG_OFFSET 0x00000108

extern const ru_reg_rec EPN_NON_POLL_INTV_REG;
#define EPN_NON_POLL_INTV_REG_OFFSET 0x0000010c

extern const ru_reg_rec EPN_FORCE_FCS_ERR_REG;
#define EPN_FORCE_FCS_ERR_REG_OFFSET 0x00000110

extern const ru_reg_rec EPN_GRANT_OVERLAP_LIMIT_REG;
#define EPN_GRANT_OVERLAP_LIMIT_REG_OFFSET 0x00000114

extern const ru_reg_rec EPN_AES_CONFIGURATION_0_REG;
#define EPN_AES_CONFIGURATION_0_REG_OFFSET 0x00000118

extern const ru_reg_rec EPN_DISC_GRANT_OVR_HD_REG;
#define EPN_DISC_GRANT_OVR_HD_REG_OFFSET 0x0000011c

extern const ru_reg_rec EPN_DN_DISCOVERY_SEED_REG;
#define EPN_DN_DISCOVERY_SEED_REG_OFFSET 0x00000120

extern const ru_reg_rec EPN_DN_DISCOVERY_INC_REG;
#define EPN_DN_DISCOVERY_INC_REG_OFFSET 0x00000124

extern const ru_reg_rec EPN_DN_DISCOVERY_SIZE_REG;
#define EPN_DN_DISCOVERY_SIZE_REG_OFFSET 0x00000128

extern const ru_reg_rec EPN_FEC_IPG_LENGTH_REG;
#define EPN_FEC_IPG_LENGTH_REG_OFFSET 0x0000012c

extern const ru_reg_rec EPN_FAKE_REPORT_VALUE_EN_REG;
#define EPN_FAKE_REPORT_VALUE_EN_REG_OFFSET 0x00000130

extern const ru_reg_rec EPN_FAKE_REPORT_VALUE_REG;
#define EPN_FAKE_REPORT_VALUE_REG_OFFSET 0x00000134

extern const ru_reg_rec EPN_BURST_CAP__REG;
#define EPN_BURST_CAP__REG_OFFSET 0x00000138

#define EPN_BURST_CAP__REG_RAM_CNT 0x00000007

extern const ru_reg_rec EPN_QUEUE_LLID_MAP__REG;
#define EPN_QUEUE_LLID_MAP__REG_OFFSET 0x00000158

#define EPN_QUEUE_LLID_MAP__REG_RAM_CNT 0x00000007

extern const ru_reg_rec EPN_VALID_OPCODE_MAP_REG;
#define EPN_VALID_OPCODE_MAP_REG_OFFSET 0x00000178

extern const ru_reg_rec EPN_UP_PACKET_TX_MARGIN_REG;
#define EPN_UP_PACKET_TX_MARGIN_REG_OFFSET 0x0000017c

extern const ru_reg_rec EPN_MULTI_PRI_CFG_0_REG;
#define EPN_MULTI_PRI_CFG_0_REG_OFFSET 0x00000180

extern const ru_reg_rec EPN_SHARED_BCAP_OVRFLOW_REG;
#define EPN_SHARED_BCAP_OVRFLOW_REG_OFFSET 0x00000184

extern const ru_reg_rec EPN_FORCED_REPORT_EN_REG;
#define EPN_FORCED_REPORT_EN_REG_OFFSET 0x00000188

extern const ru_reg_rec EPN_FORCED_REPORT_MAX_INTERVAL_REG;
#define EPN_FORCED_REPORT_MAX_INTERVAL_REG_OFFSET 0x0000018c

extern const ru_reg_rec EPN_L2S_FLUSH_CONFIG_REG;
#define EPN_L2S_FLUSH_CONFIG_REG_OFFSET 0x00000190

extern const ru_reg_rec EPN_DATA_PORT_COMMAND_REG;
#define EPN_DATA_PORT_COMMAND_REG_OFFSET 0x00000194

extern const ru_reg_rec EPN_DATA_PORT_ADDRESS_REG;
#define EPN_DATA_PORT_ADDRESS_REG_OFFSET 0x00000198

extern const ru_reg_rec EPN_DATA_PORT_DATA_0_REG;
#define EPN_DATA_PORT_DATA_0_REG_OFFSET 0x0000019c

extern const ru_reg_rec EPN_UNMAP_BIG_CNT_REG;
#define EPN_UNMAP_BIG_CNT_REG_OFFSET 0x000001a0

extern const ru_reg_rec EPN_UNMAP_FRAME_CNT_REG;
#define EPN_UNMAP_FRAME_CNT_REG_OFFSET 0x000001a4

extern const ru_reg_rec EPN_UNMAP_FCS_CNT_REG;
#define EPN_UNMAP_FCS_CNT_REG_OFFSET 0x000001a8

extern const ru_reg_rec EPN_UNMAP_GATE_CNT_REG;
#define EPN_UNMAP_GATE_CNT_REG_OFFSET 0x000001ac

extern const ru_reg_rec EPN_UNMAP_OAM_CNT_REG;
#define EPN_UNMAP_OAM_CNT_REG_OFFSET 0x000001b0

extern const ru_reg_rec EPN_UNMAP_SMALL_CNT_REG;
#define EPN_UNMAP_SMALL_CNT_REG_OFFSET 0x000001b4

extern const ru_reg_rec EPN_FIF_DEQUEUE_EVENT_CNT_REG;
#define EPN_FIF_DEQUEUE_EVENT_CNT_REG_OFFSET 0x000001b8

extern const ru_reg_rec EPN_UNUSED_TQ_CNT_REG;
#define EPN_UNUSED_TQ_CNT_REG_OFFSET 0x000001bc

#define EPN_UNUSED_TQ_CNT_REG_RAM_CNT 0x00000007

extern const ru_reg_rec EPN_BBH_UP_FAULT_HALT_EN_REG;
#define EPN_BBH_UP_FAULT_HALT_EN_REG_OFFSET 0x000001dc

extern const ru_reg_rec EPN_BBH_UP_TARDY_HALT_EN_REG;
#define EPN_BBH_UP_TARDY_HALT_EN_REG_OFFSET 0x000001e0

extern const ru_reg_rec EPN_DEBUG_STATUS_0_REG;
#define EPN_DEBUG_STATUS_0_REG_OFFSET 0x000001e4

extern const ru_reg_rec EPN_DEBUG_STATUS_1_REG;
#define EPN_DEBUG_STATUS_1_REG_OFFSET 0x000001e8

extern const ru_reg_rec EPN_DEBUG_L2S_PTR_SEL_REG;
#define EPN_DEBUG_L2S_PTR_SEL_REG_OFFSET 0x000001ec

extern const ru_reg_rec EPN_OLT_MAC_ADDR_LO_REG;
#define EPN_OLT_MAC_ADDR_LO_REG_OFFSET 0x00000230

extern const ru_reg_rec EPN_OLT_MAC_ADDR_HI_REG;
#define EPN_OLT_MAC_ADDR_HI_REG_OFFSET 0x00000234

extern const ru_reg_rec EPN_TX_L1S_SHP_DQU_EMPTY_REG;
#define EPN_TX_L1S_SHP_DQU_EMPTY_REG_OFFSET 0x00000278

extern const ru_reg_rec EPN_TX_L1S_UNSHAPED_EMPTY_REG;
#define EPN_TX_L1S_UNSHAPED_EMPTY_REG_OFFSET 0x0000027c

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_MASK__REG;
#define EPN_TX_L1S_SHP_QUE_MASK__REG_OFFSET 0x00000280

#define EPN_TX_L1S_SHP_QUE_MASK__REG_RAM_CNT 0x00000007

extern const ru_reg_rec EPN_TX_L2S_QUE_CONFIG__REG;
#define EPN_TX_L2S_QUE_CONFIG__REG_OFFSET 0x000002a0

#define EPN_TX_L2S_QUE_CONFIG__REG_RAM_CNT 0x00000007

extern const ru_reg_rec EPN_TX_L2S_QUE_EMPTY_REG;
#define EPN_TX_L2S_QUE_EMPTY_REG_OFFSET 0x000002c0

extern const ru_reg_rec EPN_TX_L2S_QUE_FULL_REG;
#define EPN_TX_L2S_QUE_FULL_REG_OFFSET 0x000002c4

extern const ru_reg_rec EPN_TX_L2S_QUE_STOPPED_REG;
#define EPN_TX_L2S_QUE_STOPPED_REG_OFFSET 0x000002c8

extern const ru_reg_rec EPN_TX_CTC_BURST_LIMIT__REG;
#define EPN_TX_CTC_BURST_LIMIT__REG_OFFSET 0x000002cc

#define EPN_TX_CTC_BURST_LIMIT__REG_RAM_CNT 0x00000007

extern const ru_reg_rec EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_REG;
#define EPN_BBH_MAX_OUTSTANDING_TARDY_PACKETS_REG_OFFSET 0x000002ec

extern const ru_reg_rec EPN_MIN_REPORT_VALUE_DIFFERENCE_REG;
#define EPN_MIN_REPORT_VALUE_DIFFERENCE_REG_OFFSET 0x000002f0

extern const ru_reg_rec EPN_BBH_STATUS_FIFO_OVERFLOW_REG;
#define EPN_BBH_STATUS_FIFO_OVERFLOW_REG_OFFSET 0x000002f4

extern const ru_reg_rec EPN_SPARE_CTL_REG;
#define EPN_SPARE_CTL_REG_OFFSET 0x000002f8

extern const ru_reg_rec EPN_TS_SYNC_OFFSET_REG;
#define EPN_TS_SYNC_OFFSET_REG_OFFSET 0x000002fc

extern const ru_reg_rec EPN_DN_TS_OFFSET_REG;
#define EPN_DN_TS_OFFSET_REG_OFFSET 0x00000300

extern const ru_reg_rec EPN_UP_TS_OFFSET_LO_REG;
#define EPN_UP_TS_OFFSET_LO_REG_OFFSET 0x00000304

extern const ru_reg_rec EPN_UP_TS_OFFSET_HI_REG;
#define EPN_UP_TS_OFFSET_HI_REG_OFFSET 0x00000308

extern const ru_reg_rec EPN_TWO_STEP_TS_CTL_REG;
#define EPN_TWO_STEP_TS_CTL_REG_OFFSET 0x0000030c

extern const ru_reg_rec EPN_TWO_STEP_TS_VALUE_LO_REG;
#define EPN_TWO_STEP_TS_VALUE_LO_REG_OFFSET 0x00000310

extern const ru_reg_rec EPN_TWO_STEP_TS_VALUE_HI_REG;
#define EPN_TWO_STEP_TS_VALUE_HI_REG_OFFSET 0x00000314

extern const ru_reg_rec EPN_1588_TIMESTAMP_INT_STATUS_REG;
#define EPN_1588_TIMESTAMP_INT_STATUS_REG_OFFSET 0x00000318

extern const ru_reg_rec EPN_1588_TIMESTAMP_INT_MASK_REG;
#define EPN_1588_TIMESTAMP_INT_MASK_REG_OFFSET 0x0000031c

extern const ru_reg_rec EPN_UP_PACKET_FETCH_MARGIN_REG;
#define EPN_UP_PACKET_FETCH_MARGIN_REG_OFFSET 0x00000320

extern const ru_reg_rec EPN_DN_1588_TIMESTAMP_REG;
#define EPN_DN_1588_TIMESTAMP_REG_OFFSET 0x00000324

extern const ru_reg_rec EPN_PERSISTENT_REPORT_CFG_REG;
#define EPN_PERSISTENT_REPORT_CFG_REG_OFFSET 0x00000328

extern const ru_reg_rec EPN_PERSISTENT_REPORT_ENABLES_REG;
#define EPN_PERSISTENT_REPORT_ENABLES_REG_OFFSET 0x0000032c

extern const ru_reg_rec EPN_PERSISTENT_REPORT_REQUEST_SIZE_REG;
#define EPN_PERSISTENT_REPORT_REQUEST_SIZE_REG_OFFSET 0x00000330

extern const ru_reg_rec EPN_ONU_MAC_ADDR_LO_REG;
#define EPN_ONU_MAC_ADDR_LO_REG_OFFSET 0x00000000

extern const ru_reg_rec EPN_ONU_MAC_ADDR_HI_REG;
#define EPN_ONU_MAC_ADDR_HI_REG_OFFSET 0x00000004

extern const ru_reg_rec EPN_TX_L1S_SHP_CONFIG_REG;
#define EPN_TX_L1S_SHP_CONFIG_REG_OFFSET 0x00000000

extern const ru_reg_rec EPN_TX_L1S_SHP_QUE_EN_REG;
#define EPN_TX_L1S_SHP_QUE_EN_REG_OFFSET 0x00000004

extern const ru_reg_rec LIF_PON_CONTROL_REG;
#define LIF_PON_CONTROL_REG_OFFSET 0x00000000

extern const ru_reg_rec LIF_PON_INTER_OP_CONTROL_REG;
#define LIF_PON_INTER_OP_CONTROL_REG_OFFSET 0x00000004

extern const ru_reg_rec LIF_FEC_CONTROL_REG;
#define LIF_FEC_CONTROL_REG_OFFSET 0x00000008

extern const ru_reg_rec LIF_SEC_CONTROL_REG;
#define LIF_SEC_CONTROL_REG_OFFSET 0x0000000c

extern const ru_reg_rec LIF_MACSEC_REG;
#define LIF_MACSEC_REG_OFFSET 0x00000010

extern const ru_reg_rec LIF_INT_STATUS_REG;
#define LIF_INT_STATUS_REG_OFFSET 0x00000014

extern const ru_reg_rec LIF_INT_MASK_REG;
#define LIF_INT_MASK_REG_OFFSET 0x00000018

extern const ru_reg_rec LIF_DATA_PORT_COMMAND_REG;
#define LIF_DATA_PORT_COMMAND_REG_OFFSET 0x0000001c

extern const ru_reg_rec LIF_DATA_PORT_DATA_REG;
#define LIF_DATA_PORT_DATA_REG_OFFSET 0x00000020

#define LIF_DATA_PORT_DATA_REG_RAM_CNT 0x00000007

extern const ru_reg_rec LIF_LLID_REG;
#define LIF_LLID_REG_OFFSET 0x00000040

#define LIF_LLID_REG_RAM_CNT 0x00000017

extern const ru_reg_rec LIF_TIME_REF_CNT_REG;
#define LIF_TIME_REF_CNT_REG_OFFSET 0x00000080

extern const ru_reg_rec LIF_TIMESTAMP_UPD_PER_REG;
#define LIF_TIMESTAMP_UPD_PER_REG_OFFSET 0x00000084

extern const ru_reg_rec LIF_TP_TIME_REG;
#define LIF_TP_TIME_REG_OFFSET 0x00000088

extern const ru_reg_rec LIF_MPCP_TIME_REG;
#define LIF_MPCP_TIME_REG_OFFSET 0x0000008c

extern const ru_reg_rec LIF_MAXLEN_CTR_REG;
#define LIF_MAXLEN_CTR_REG_OFFSET 0x00000090

extern const ru_reg_rec LIF_LASER_ON_DELTA_REG;
#define LIF_LASER_ON_DELTA_REG_OFFSET 0x00000094

extern const ru_reg_rec LIF_LASER_OFF_IDLE_REG;
#define LIF_LASER_OFF_IDLE_REG_OFFSET 0x00000098

extern const ru_reg_rec LIF_FEC_INIT_IDLE_REG;
#define LIF_FEC_INIT_IDLE_REG_OFFSET 0x0000009c

extern const ru_reg_rec LIF_FEC_ERR_ALLOW_REG;
#define LIF_FEC_ERR_ALLOW_REG_OFFSET 0x000000a0

extern const ru_reg_rec LIF_SEC_KEY_SEL_REG;
#define LIF_SEC_KEY_SEL_REG_OFFSET 0x000000a4

extern const ru_reg_rec LIF_DN_ENCRYPT_STAT_REG;
#define LIF_DN_ENCRYPT_STAT_REG_OFFSET 0x000000a8

extern const ru_reg_rec LIF_SEC_UP_KEY_STAT_REG;
#define LIF_SEC_UP_KEY_STAT_REG_OFFSET 0x000000ac

extern const ru_reg_rec LIF_SEC_UP_ENCRYPT_STAT_REG;
#define LIF_SEC_UP_ENCRYPT_STAT_REG_OFFSET 0x000000b0

extern const ru_reg_rec LIF_SEC_UP_MPCP_OFFSET_REG;
#define LIF_SEC_UP_MPCP_OFFSET_REG_OFFSET 0x000000b4

extern const ru_reg_rec LIF_FEC_PER_LLID_REG;
#define LIF_FEC_PER_LLID_REG_OFFSET 0x000000b8

extern const ru_reg_rec LIF_RX_LINE_CODE_ERR_CNT_REG;
#define LIF_RX_LINE_CODE_ERR_CNT_REG_OFFSET 0x000000bc

extern const ru_reg_rec LIF_RX_AGG_MPCP_FRM_REG;
#define LIF_RX_AGG_MPCP_FRM_REG_OFFSET 0x000000c0

extern const ru_reg_rec LIF_RX_AGG_GOOD_FRM_REG;
#define LIF_RX_AGG_GOOD_FRM_REG_OFFSET 0x000000c4

extern const ru_reg_rec LIF_RX_AGG_GOOD_BYTE_REG;
#define LIF_RX_AGG_GOOD_BYTE_REG_OFFSET 0x000000c8

extern const ru_reg_rec LIF_RX_AGG_UNDERSZ_FRM_REG;
#define LIF_RX_AGG_UNDERSZ_FRM_REG_OFFSET 0x000000cc

extern const ru_reg_rec LIF_RX_AGG_OVERSZ_FRM_REG;
#define LIF_RX_AGG_OVERSZ_FRM_REG_OFFSET 0x000000d0

extern const ru_reg_rec LIF_RX_AGG_CRC8_FRM_REG;
#define LIF_RX_AGG_CRC8_FRM_REG_OFFSET 0x000000d4

extern const ru_reg_rec LIF_RX_AGG_FEC_FRM_REG;
#define LIF_RX_AGG_FEC_FRM_REG_OFFSET 0x000000d8

extern const ru_reg_rec LIF_RX_AGG_FEC_BYTE_REG;
#define LIF_RX_AGG_FEC_BYTE_REG_OFFSET 0x000000dc

extern const ru_reg_rec LIF_RX_AGG_FEC_EXC_ERR_FRM_REG;
#define LIF_RX_AGG_FEC_EXC_ERR_FRM_REG_OFFSET 0x000000e0

extern const ru_reg_rec LIF_RX_AGG_NONFEC_GOOD_FRM_REG;
#define LIF_RX_AGG_NONFEC_GOOD_FRM_REG_OFFSET 0x000000e4

extern const ru_reg_rec LIF_RX_AGG_NONFEC_GOOD_BYTE_REG;
#define LIF_RX_AGG_NONFEC_GOOD_BYTE_REG_OFFSET 0x000000e8

extern const ru_reg_rec LIF_RX_AGG_ERR_BYTES_REG;
#define LIF_RX_AGG_ERR_BYTES_REG_OFFSET 0x000000ec

extern const ru_reg_rec LIF_RX_AGG_ERR_ZEROES_REG;
#define LIF_RX_AGG_ERR_ZEROES_REG_OFFSET 0x000000f0

extern const ru_reg_rec LIF_RX_AGG_NO_ERR_BLKS_REG;
#define LIF_RX_AGG_NO_ERR_BLKS_REG_OFFSET 0x000000f4

extern const ru_reg_rec LIF_RX_AGG_COR_BLKS_REG;
#define LIF_RX_AGG_COR_BLKS_REG_OFFSET 0x000000f8

extern const ru_reg_rec LIF_RX_AGG_UNCOR_BLKS_REG;
#define LIF_RX_AGG_UNCOR_BLKS_REG_OFFSET 0x000000fc

extern const ru_reg_rec LIF_RX_AGG_ERR_ONES_REG;
#define LIF_RX_AGG_ERR_ONES_REG_OFFSET 0x00000100

extern const ru_reg_rec LIF_RX_AGG_ERR_FRM_REG;
#define LIF_RX_AGG_ERR_FRM_REG_OFFSET 0x00000104

extern const ru_reg_rec LIF_TX_PKT_CNT_REG;
#define LIF_TX_PKT_CNT_REG_OFFSET 0x00000108

extern const ru_reg_rec LIF_TX_BYTE_CNT_REG;
#define LIF_TX_BYTE_CNT_REG_OFFSET 0x0000010c

extern const ru_reg_rec LIF_TX_NON_FEC_PKT_CNT_REG;
#define LIF_TX_NON_FEC_PKT_CNT_REG_OFFSET 0x00000110

extern const ru_reg_rec LIF_TX_NON_FEC_BYTE_CNT_REG;
#define LIF_TX_NON_FEC_BYTE_CNT_REG_OFFSET 0x00000114

extern const ru_reg_rec LIF_TX_FEC_PKT_CNT_REG;
#define LIF_TX_FEC_PKT_CNT_REG_OFFSET 0x00000118

extern const ru_reg_rec LIF_TX_FEC_BYTE_CNT_REG;
#define LIF_TX_FEC_BYTE_CNT_REG_OFFSET 0x0000011c

extern const ru_reg_rec LIF_TX_FEC_BLK_CNT_REG;
#define LIF_TX_FEC_BLK_CNT_REG_OFFSET 0x00000120

extern const ru_reg_rec LIF_TX_MPCP_PKT_CNT_REG;
#define LIF_TX_MPCP_PKT_CNT_REG_OFFSET 0x00000124

extern const ru_reg_rec LIF_DEBUG_TX_DATA_PKT_CNT_REG;
#define LIF_DEBUG_TX_DATA_PKT_CNT_REG_OFFSET 0x00000128

extern const ru_reg_rec LIF_FEC_LLID_STATUS_REG;
#define LIF_FEC_LLID_STATUS_REG_OFFSET 0x0000012c

extern const ru_reg_rec LIF_SEC_RX_TEK_IG_IV_LLID_REG;
#define LIF_SEC_RX_TEK_IG_IV_LLID_REG_OFFSET 0x00000130

extern const ru_reg_rec LIF_PON_BER_INTERV_THRESH_REG;
#define LIF_PON_BER_INTERV_THRESH_REG_OFFSET 0x00000134

extern const ru_reg_rec LIF_LSR_MON_A_CTRL_REG;
#define LIF_LSR_MON_A_CTRL_REG_OFFSET 0x00000138

extern const ru_reg_rec LIF_LSR_MON_A_MAX_THR_REG;
#define LIF_LSR_MON_A_MAX_THR_REG_OFFSET 0x0000013c

extern const ru_reg_rec LIF_LSR_MON_A_BST_LEN_REG;
#define LIF_LSR_MON_A_BST_LEN_REG_OFFSET 0x00000140

extern const ru_reg_rec LIF_LSR_MON_A_BST_CNT_REG;
#define LIF_LSR_MON_A_BST_CNT_REG_OFFSET 0x00000144

extern const ru_reg_rec LIF_DEBUG_PON_SM_REG;
#define LIF_DEBUG_PON_SM_REG_OFFSET 0x00000148

extern const ru_reg_rec LIF_DEBUG_FEC_SM_REG;
#define LIF_DEBUG_FEC_SM_REG_OFFSET 0x0000014c

extern const ru_reg_rec LIF_AE_PKTNUM_WINDOW_REG;
#define LIF_AE_PKTNUM_WINDOW_REG_OFFSET 0x00000150

extern const ru_reg_rec LIF_AE_PKTNUM_THRESH_REG;
#define LIF_AE_PKTNUM_THRESH_REG_OFFSET 0x00000154

extern const ru_reg_rec LIF_AE_PKTNUM_STAT_REG;
#define LIF_AE_PKTNUM_STAT_REG_OFFSET 0x00000158

extern const ru_reg_rec LIF_P2P_AUTONEG_CONTROL_REG;
#define LIF_P2P_AUTONEG_CONTROL_REG_OFFSET 0x0000015c

extern const ru_reg_rec LIF_P2P_AUTONEG_STATUS_REG;
#define LIF_P2P_AUTONEG_STATUS_REG_OFFSET 0x00000160

extern const ru_reg_rec LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_REG;
#define LIF_P2P_AUTONEG_ABILITY_CONFIG_REG_REG_OFFSET 0x00000164

extern const ru_reg_rec LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_REG;
#define LIF_P2P_AUTONEG_LINK_PARTNER_ABILITY_CONFIG_READ_REG_OFFSET 0x00000168

extern const ru_reg_rec NCO_ADDR_NCO_CFG_REG;
#define NCO_ADDR_NCO_CFG_REG_OFFSET 0x00000000

extern const ru_reg_rec NCO_ADDR_NCO_INT_REG;
#define NCO_ADDR_NCO_INT_REG_OFFSET 0x00000004

extern const ru_reg_rec NCO_ADDR_NCO_MSK_REG;
#define NCO_ADDR_NCO_MSK_REG_OFFSET 0x00000008

extern const ru_reg_rec NCO_ADDR_NCO_1PPS_PERIOD_REG;
#define NCO_ADDR_NCO_1PPS_PERIOD_REG_OFFSET 0x0000000c

extern const ru_reg_rec NCO_ADDR_NCO_8KHZ_PERIOD_REG;
#define NCO_ADDR_NCO_8KHZ_PERIOD_REG_OFFSET 0x00000010

extern const ru_reg_rec NCO_ADDR_NCO_CENTER_FREQUENCY_REG;
#define NCO_ADDR_NCO_CENTER_FREQUENCY_REG_OFFSET 0x00000014

extern const ru_reg_rec NCO_ADDR_NCO_INT_GAIN_REG;
#define NCO_ADDR_NCO_INT_GAIN_REG_OFFSET 0x00000018

extern const ru_reg_rec NCO_ADDR_NCO_PRO_GAIN_REG;
#define NCO_ADDR_NCO_PRO_GAIN_REG_OFFSET 0x0000001c

extern const ru_reg_rec NCO_ADDR_NCO_CNT_REG;
#define NCO_ADDR_NCO_CNT_REG_OFFSET 0x00000020

extern const ru_reg_rec NCO_ADDR_NCO_1PPS_HALF_REG;
#define NCO_ADDR_NCO_1PPS_HALF_REG_OFFSET 0x00000024

extern const ru_reg_rec NCO_ADDR_NCO_8KHZ_HALF_REG;
#define NCO_ADDR_NCO_8KHZ_HALF_REG_OFFSET 0x00000028

extern const ru_reg_rec NCO_ADDR_NCO_PERIOD_CNT_REG;
#define NCO_ADDR_NCO_PERIOD_CNT_REG_OFFSET 0x0000002c

extern const ru_reg_rec NCO_ADDR_NCO_PHS_ERR_CNT_REG;
#define NCO_ADDR_NCO_PHS_ERR_CNT_REG_OFFSET 0x00000030



/******************************************************************************
 * EPON Blocks
 ******************************************************************************/
extern const ru_block_rec EPON_TOP_BLOCK;
extern const ru_block_rec CLK_PRG_SWCH_ADDR_BLOCK;
extern const ru_block_rec EPN_BLOCK;
extern const ru_block_rec EPN_ONU_MAC_ADDR_BLOCK;
extern const ru_block_rec EPN_TX_L1S_SHP_BLOCK;
extern const ru_block_rec LIF_BLOCK;
extern const ru_block_rec NCO_ADDR_BLOCK;
extern const ru_block_rec *RU_EPON_BLOCKS[];


#define RU_BLK_COUNT 7
#define RU_REG_COUNT 236
#define RU_FLD_COUNT 954


#endif /* End of file EPON.h */
