/*
   Copyright (c) 2015 Broadcom Corporation
   All Rights Reserved

    <:label-BRCM:2015:DUAL/GPL:standard
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as published by
    the Free Software Foundation (the "GPL").
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    
    A copy of the GPL is available at http://www.broadcom.com/licenses/GPLv2.php, or by
    writing to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
:>
*/

#include "ru.h"

#if RU_INCLUDE_FIELD_DB
/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX64_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX64_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX64_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX64_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX64_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX127_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX127_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX127_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX127_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX127_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX255_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX255_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX255_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX255_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX255_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX511_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX511_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX511_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX511_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX511_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX1023_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX1023_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX1023_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX1023_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX1023_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX1518_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX1518_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX1518_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX1518_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX1518_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX1522_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX1522_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX1522_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX1522_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX1522_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX2047_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX2047_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX2047_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX2047_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX2047_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX4095_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX4095_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX4095_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX4095_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX4095_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX9216_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX9216_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX9216_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX9216_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX9216_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRX16383_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRX16383_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRX16383_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRX16383_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRX16383_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPKT_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPKT_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPKT_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPKT_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPKT_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXUCA_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXUCA_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXUCA_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXUCA_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXUCA_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXMCA_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXMCA_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXMCA_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXMCA_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXMCA_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXBCA_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXBCA_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXBCA_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXBCA_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXBCA_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXFCS_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXFCS_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXFCS_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXFCS_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXFCS_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXCF_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXCF_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXCF_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXCF_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXCF_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPF_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPF_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPF_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPF_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPF_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPP_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPP_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPP_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPP_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPP_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXUO_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXUO_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXUO_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXUO_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXUO_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXUDA_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXUDA_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXUDA_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXUDA_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXUDA_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXWSA_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXWSA_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXWSA_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXWSA_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXWSA_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXALN_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXALN_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXALN_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXALN_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXALN_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXFLR_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXFLR_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXFLR_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXFLR_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXFLR_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXFRERR_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXFRERR_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXFRERR_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXFRERR_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXFRERR_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXFCR_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXFCR_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXFCR_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXFCR_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXFCR_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXOVR_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXOVR_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXOVR_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXOVR_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXOVR_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXJBR_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXJBR_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXJBR_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXJBR_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXJBR_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXMTUE_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXMTUE_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXMTUE_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXMTUE_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXMTUE_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXMCRC_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXMCRC_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXMCRC_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXMCRC_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXMCRC_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPRM_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPRM_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPRM_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPRM_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPRM_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXVLN_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXVLN_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXVLN_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXVLN_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXVLN_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXDVLN_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXDVLN_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXDVLN_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXDVLN_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXDVLN_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXTRFU_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXTRFU_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXTRFU_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXTRFU_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXTRFU_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPOK_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPOK_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPOK_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPOK_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPOK_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCOFF0_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCOFF0_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF0_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCOFF0_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCOFF0_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCOFF1_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCOFF1_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF1_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCOFF1_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCOFF1_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCOFF2_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCOFF2_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF2_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCOFF2_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCOFF2_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCOFF3_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCOFF3_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF3_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCOFF3_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCOFF3_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCOFF4_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCOFF4_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF4_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCOFF4_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCOFF4_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCOFF5_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCOFF5_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF5_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCOFF5_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCOFF5_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCOFF6_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCOFF6_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF6_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCOFF6_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCOFF6_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCOFF7_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCOFF7_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF7_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCOFF7_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCOFF7_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCP0_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCP0_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCP0_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCP0_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCP0_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCP1_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCP1_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCP1_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCP1_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCP1_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCP2_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCP2_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCP2_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCP2_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCP2_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCP3_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCP3_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCP3_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCP3_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCP3_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCP4_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCP4_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCP4_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCP4_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCP4_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCP5_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCP5_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCP5_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCP5_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCP5_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCP6_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCP6_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCP6_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCP6_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCP6_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPFCP7_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPFCP7_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPFCP7_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPFCP7_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPFCP7_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXSCHCRC_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXSCHCRC_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXSCHCRC_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXSCHCRC_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXSCHCRC_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXBYT_COUNT48
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXBYT_COUNT48_FIELD =
{
    "COUNT48",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 48 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXBYT_COUNT48_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXBYT_COUNT48_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXBYT_COUNT48_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXRPKT_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXRPKT_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXRPKT_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXRPKT_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXRPKT_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXUND_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXUND_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXUND_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXUND_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXUND_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXFRG_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXFRG_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXFRG_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXFRG_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXFRG_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXRBYT_COUNT48
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXRBYT_COUNT48_FIELD =
{
    "COUNT48",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 48 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXRBYT_COUNT48_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXRBYT_COUNT48_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXRBYT_COUNT48_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX64_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX64_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX64_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX64_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX64_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX127_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX127_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX127_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX127_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX127_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX255_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX255_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX255_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX255_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX255_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX511_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX511_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX511_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX511_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX511_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX1023_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX1023_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX1023_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX1023_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX1023_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX1518_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX1518_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX1518_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX1518_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX1518_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX1522_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX1522_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX1522_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX1522_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX1522_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX2047_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX2047_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX2047_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX2047_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX2047_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX4095_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX4095_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX4095_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX4095_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX4095_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX9216_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX9216_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX9216_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX9216_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX9216_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTX16383_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTX16383_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTX16383_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTX16383_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTX16383_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPOK_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPOK_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPOK_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPOK_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPOK_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPKT_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPKT_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPKT_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPKT_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPKT_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXUCA_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXUCA_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXUCA_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXUCA_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXUCA_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXMCA_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXMCA_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXMCA_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXMCA_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXMCA_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXBCA_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXBCA_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXBCA_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXBCA_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXBCA_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPF_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPF_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPF_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPF_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPF_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPFC_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPFC_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPFC_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPFC_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPFC_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXJBR_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXJBR_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXJBR_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXJBR_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXJBR_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXFCS_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXFCS_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXFCS_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXFCS_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXFCS_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXCF_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXCF_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXCF_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXCF_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXCF_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXOVR_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXOVR_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXOVR_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXOVR_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXOVR_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXDFR_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXDFR_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXDFR_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXDFR_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXDFR_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXEDF_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXEDF_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXEDF_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXEDF_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXEDF_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXSCL_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXSCL_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXSCL_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXSCL_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXSCL_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXMCL_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXMCL_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXMCL_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXMCL_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXMCL_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXLCL_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXLCL_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXLCL_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXLCL_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXLCL_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXXCL_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXXCL_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXXCL_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXXCL_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXXCL_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXFRG_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXFRG_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXFRG_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXFRG_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXFRG_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXERR_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXERR_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXERR_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXERR_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXERR_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXVLN_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXVLN_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXVLN_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXVLN_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXVLN_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXDVLN_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXDVLN_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXDVLN_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXDVLN_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXDVLN_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXRPKT_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXRPKT_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXRPKT_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXRPKT_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXRPKT_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXUFL_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXUFL_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXUFL_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXUFL_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXUFL_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPFCP0_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPFCP0_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPFCP0_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPFCP0_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPFCP0_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPFCP1_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPFCP1_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPFCP1_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPFCP1_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPFCP1_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPFCP2_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPFCP2_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPFCP2_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPFCP2_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPFCP2_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPFCP3_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPFCP3_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPFCP3_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPFCP3_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPFCP3_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPFCP4_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPFCP4_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPFCP4_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPFCP4_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPFCP4_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPFCP5_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPFCP5_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPFCP5_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPFCP5_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPFCP5_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPFCP6_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPFCP6_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPFCP6_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPFCP6_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPFCP6_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXPFCP7_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXPFCP7_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXPFCP7_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXPFCP7_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXPFCP7_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXNCL_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXNCL_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXNCL_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXNCL_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXNCL_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXBYT_COUNT48
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXBYT_COUNT48_FIELD =
{
    "COUNT48",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 48 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXBYT_COUNT48_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXBYT_COUNT48_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXBYT_COUNT48_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXLPI_COUNT32
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXLPI_COUNT32_FIELD =
{
    "COUNT32",
#if RU_INCLUDE_DESC
    "",
    "The 32-bit MIB counter value.\n"
    "This MIB counter is 32 bits wide in hardware, unlike most of other MIB counters (which are more than 32 bits wide).",
#endif
    XPORT_MIB_CORE_GRXLPI_COUNT32_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXLPI_COUNT32_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXLPI_COUNT32_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXDLPI_COUNT32
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXDLPI_COUNT32_FIELD =
{
    "COUNT32",
#if RU_INCLUDE_DESC
    "",
    "The 32-bit MIB counter value.\n"
    "This MIB counter is 32 bits wide in hardware, unlike most of other MIB counters (which are more than 32 bits wide).",
#endif
    XPORT_MIB_CORE_GRXDLPI_COUNT32_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXDLPI_COUNT32_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXDLPI_COUNT32_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXLPI_COUNT32
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXLPI_COUNT32_FIELD =
{
    "COUNT32",
#if RU_INCLUDE_DESC
    "",
    "The 32-bit MIB counter value.\n"
    "This MIB counter is 32 bits wide in hardware, unlike most of other MIB counters (which are more than 32 bits wide).",
#endif
    XPORT_MIB_CORE_GTXLPI_COUNT32_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXLPI_COUNT32_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXLPI_COUNT32_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXDLPI_COUNT32
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXDLPI_COUNT32_FIELD =
{
    "COUNT32",
#if RU_INCLUDE_DESC
    "",
    "The 32-bit MIB counter value.\n"
    "This MIB counter is 32 bits wide in hardware, unlike most of other MIB counters (which are more than 32 bits wide).",
#endif
    XPORT_MIB_CORE_GTXDLPI_COUNT32_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXDLPI_COUNT32_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXDLPI_COUNT32_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXPTLLFC_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXPTLLFC_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXPTLLFC_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXPTLLFC_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXPTLLFC_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXLTLLFC_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXLTLLFC_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXLTLLFC_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXLTLLFC_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXLTLLFC_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GRXLLFCFCS_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GRXLLFCFCS_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GRXLLFCFCS_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GRXLLFCFCS_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GRXLLFCFCS_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

/******************************************************************************
 * Field: XPORT_MIB_CORE_GTXLTLLFC_COUNT40
 ******************************************************************************/
const ru_field_rec XPORT_MIB_CORE_GTXLTLLFC_COUNT40_FIELD =
{
    "COUNT40",
#if RU_INCLUDE_DESC
    "",
    "This MIB counter is 40 bits wide in hardware.\n"
    "LPORT register reads and writes are however 32 bits per transaction.\n"
    "When reading from this address, higher counter bits are copied to MIBx 32-bit Direct Access Data Read Register, and can subsequently be obtained by reading from that register.\n"
    "Similarly, when writing to this address, higher MIB counter bits are taken from MIBx 32-bit Direct Access Data Write Register, so it is important to ensure proper value for the higher bits is present in that register prior to writing to this register.\n"
    "Alternatively, Indirect Access mechanism can be used to access MIB counters (see MIBx Indirect Access registers).",
#endif
    XPORT_MIB_CORE_GTXLTLLFC_COUNT40_FIELD_MASK,
    0,
    XPORT_MIB_CORE_GTXLTLLFC_COUNT40_FIELD_WIDTH,
    XPORT_MIB_CORE_GTXLTLLFC_COUNT40_FIELD_SHIFT,
#if RU_INCLUDE_ACCESS
    ru_access_rw
#endif
};

#endif /* RU_INCLUDE_FIELD_DB */

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX64
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX64_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX64_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX64_REG = 
{
    "GRX64",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX64_REG_OFFSET,
    0,
    0,
    56,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX64_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX127
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX127_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX127_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX127_REG = 
{
    "GRX127",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX127_REG_OFFSET,
    0,
    0,
    57,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX127_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX255
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX255_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX255_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX255_REG = 
{
    "GRX255",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX255_REG_OFFSET,
    0,
    0,
    58,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX255_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX511
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX511_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX511_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX511_REG = 
{
    "GRX511",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX511_REG_OFFSET,
    0,
    0,
    59,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX511_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX1023
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX1023_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX1023_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX1023_REG = 
{
    "GRX1023",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX1023_REG_OFFSET,
    0,
    0,
    60,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX1023_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX1518
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX1518_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX1518_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX1518_REG = 
{
    "GRX1518",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX1518_REG_OFFSET,
    0,
    0,
    61,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX1518_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX1522
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX1522_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX1522_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX1522_REG = 
{
    "GRX1522",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX1522_REG_OFFSET,
    0,
    0,
    62,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX1522_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX2047
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX2047_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX2047_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX2047_REG = 
{
    "GRX2047",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX2047_REG_OFFSET,
    0,
    0,
    63,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX2047_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX4095
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX4095_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX4095_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX4095_REG = 
{
    "GRX4095",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX4095_REG_OFFSET,
    0,
    0,
    64,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX4095_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX9216
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX9216_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX9216_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX9216_REG = 
{
    "GRX9216",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX9216_REG_OFFSET,
    0,
    0,
    65,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX9216_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRX16383
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRX16383_FIELDS[] =
{
    &XPORT_MIB_CORE_GRX16383_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRX16383_REG = 
{
    "GRX16383",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRX16383_REG_OFFSET,
    0,
    0,
    66,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRX16383_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPKT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPKT_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPKT_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPKT_REG = 
{
    "GRXPKT",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPKT_REG_OFFSET,
    0,
    0,
    67,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPKT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXUCA
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXUCA_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXUCA_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXUCA_REG = 
{
    "GRXUCA",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXUCA_REG_OFFSET,
    0,
    0,
    68,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXUCA_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXMCA
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXMCA_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXMCA_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXMCA_REG = 
{
    "GRXMCA",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXMCA_REG_OFFSET,
    0,
    0,
    69,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXMCA_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXBCA
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXBCA_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXBCA_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXBCA_REG = 
{
    "GRXBCA",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXBCA_REG_OFFSET,
    0,
    0,
    70,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXBCA_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXFCS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXFCS_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXFCS_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXFCS_REG = 
{
    "GRXFCS",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXFCS_REG_OFFSET,
    0,
    0,
    71,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXFCS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXCF
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXCF_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXCF_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXCF_REG = 
{
    "GRXCF",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXCF_REG_OFFSET,
    0,
    0,
    72,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXCF_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPF
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPF_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPF_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPF_REG = 
{
    "GRXPF",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPF_REG_OFFSET,
    0,
    0,
    73,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPF_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPP
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPP_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPP_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPP_REG = 
{
    "GRXPP",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPP_REG_OFFSET,
    0,
    0,
    74,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPP_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXUO
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXUO_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXUO_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXUO_REG = 
{
    "GRXUO",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXUO_REG_OFFSET,
    0,
    0,
    75,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXUO_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXUDA
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXUDA_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXUDA_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXUDA_REG = 
{
    "GRXUDA",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXUDA_REG_OFFSET,
    0,
    0,
    76,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXUDA_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXWSA
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXWSA_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXWSA_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXWSA_REG = 
{
    "GRXWSA",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXWSA_REG_OFFSET,
    0,
    0,
    77,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXWSA_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXALN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXALN_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXALN_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXALN_REG = 
{
    "GRXALN",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXALN_REG_OFFSET,
    0,
    0,
    78,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXALN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXFLR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXFLR_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXFLR_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXFLR_REG = 
{
    "GRXFLR",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXFLR_REG_OFFSET,
    0,
    0,
    79,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXFLR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXFRERR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXFRERR_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXFRERR_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXFRERR_REG = 
{
    "GRXFRERR",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXFRERR_REG_OFFSET,
    0,
    0,
    80,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXFRERR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXFCR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXFCR_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXFCR_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXFCR_REG = 
{
    "GRXFCR",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXFCR_REG_OFFSET,
    0,
    0,
    81,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXFCR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXOVR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXOVR_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXOVR_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXOVR_REG = 
{
    "GRXOVR",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXOVR_REG_OFFSET,
    0,
    0,
    82,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXOVR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXJBR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXJBR_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXJBR_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXJBR_REG = 
{
    "GRXJBR",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXJBR_REG_OFFSET,
    0,
    0,
    83,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXJBR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXMTUE
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXMTUE_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXMTUE_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXMTUE_REG = 
{
    "GRXMTUE",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXMTUE_REG_OFFSET,
    0,
    0,
    84,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXMTUE_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXMCRC
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXMCRC_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXMCRC_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXMCRC_REG = 
{
    "GRXMCRC",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXMCRC_REG_OFFSET,
    0,
    0,
    85,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXMCRC_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPRM
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPRM_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPRM_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPRM_REG = 
{
    "GRXPRM",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPRM_REG_OFFSET,
    0,
    0,
    86,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPRM_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXVLN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXVLN_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXVLN_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXVLN_REG = 
{
    "GRXVLN",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXVLN_REG_OFFSET,
    0,
    0,
    87,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXVLN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXDVLN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXDVLN_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXDVLN_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXDVLN_REG = 
{
    "GRXDVLN",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXDVLN_REG_OFFSET,
    0,
    0,
    88,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXDVLN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXTRFU
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXTRFU_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXTRFU_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXTRFU_REG = 
{
    "GRXTRFU",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXTRFU_REG_OFFSET,
    0,
    0,
    89,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXTRFU_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPOK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPOK_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPOK_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPOK_REG = 
{
    "GRXPOK",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPOK_REG_OFFSET,
    0,
    0,
    90,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPOK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCOFF0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCOFF0_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCOFF0_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCOFF0_REG = 
{
    "GRXPFCOFF0",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF0_REG_OFFSET,
    0,
    0,
    91,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCOFF0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCOFF1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCOFF1_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCOFF1_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCOFF1_REG = 
{
    "GRXPFCOFF1",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF1_REG_OFFSET,
    0,
    0,
    92,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCOFF1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCOFF2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCOFF2_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCOFF2_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCOFF2_REG = 
{
    "GRXPFCOFF2",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF2_REG_OFFSET,
    0,
    0,
    93,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCOFF2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCOFF3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCOFF3_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCOFF3_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCOFF3_REG = 
{
    "GRXPFCOFF3",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF3_REG_OFFSET,
    0,
    0,
    94,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCOFF3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCOFF4
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCOFF4_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCOFF4_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCOFF4_REG = 
{
    "GRXPFCOFF4",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF4_REG_OFFSET,
    0,
    0,
    95,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCOFF4_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCOFF5
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCOFF5_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCOFF5_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCOFF5_REG = 
{
    "GRXPFCOFF5",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF5_REG_OFFSET,
    0,
    0,
    96,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCOFF5_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCOFF6
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCOFF6_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCOFF6_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCOFF6_REG = 
{
    "GRXPFCOFF6",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF6_REG_OFFSET,
    0,
    0,
    97,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCOFF6_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCOFF7
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCOFF7_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCOFF7_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCOFF7_REG = 
{
    "GRXPFCOFF7",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCOFF7_REG_OFFSET,
    0,
    0,
    98,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCOFF7_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCP0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCP0_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCP0_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCP0_REG = 
{
    "GRXPFCP0",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCP0_REG_OFFSET,
    0,
    0,
    99,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCP0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCP1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCP1_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCP1_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCP1_REG = 
{
    "GRXPFCP1",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCP1_REG_OFFSET,
    0,
    0,
    100,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCP1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCP2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCP2_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCP2_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCP2_REG = 
{
    "GRXPFCP2",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCP2_REG_OFFSET,
    0,
    0,
    101,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCP2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCP3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCP3_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCP3_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCP3_REG = 
{
    "GRXPFCP3",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCP3_REG_OFFSET,
    0,
    0,
    102,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCP3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCP4
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCP4_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCP4_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCP4_REG = 
{
    "GRXPFCP4",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCP4_REG_OFFSET,
    0,
    0,
    103,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCP4_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCP5
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCP5_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCP5_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCP5_REG = 
{
    "GRXPFCP5",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCP5_REG_OFFSET,
    0,
    0,
    104,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCP5_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCP6
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCP6_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCP6_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCP6_REG = 
{
    "GRXPFCP6",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCP6_REG_OFFSET,
    0,
    0,
    105,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCP6_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPFCP7
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPFCP7_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPFCP7_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPFCP7_REG = 
{
    "GRXPFCP7",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPFCP7_REG_OFFSET,
    0,
    0,
    106,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPFCP7_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXSCHCRC
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXSCHCRC_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXSCHCRC_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXSCHCRC_REG = 
{
    "GRXSCHCRC",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXSCHCRC_REG_OFFSET,
    0,
    0,
    107,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXSCHCRC_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXBYT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXBYT_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXBYT_COUNT48_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXBYT_REG = 
{
    "GRXBYT",
#if RU_INCLUDE_DESC
    "Transmit Byte Counter for XLMAC/port0 (LPORT port0)",
    "Receive Byte Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 48 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (47:32)."
    "Receive Runt Byte Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 48 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (47:32)."
    "Transmit Byte Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 48 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (47:32).",
#endif
    XPORT_MIB_CORE_GRXBYT_REG_OFFSET,
    0,
    0,
    108,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXBYT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXRPKT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXRPKT_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXRPKT_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXRPKT_REG = 
{
    "GRXRPKT",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXRPKT_REG_OFFSET,
    0,
    0,
    109,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXRPKT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXUND
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXUND_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXUND_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXUND_REG = 
{
    "GRXUND",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXUND_REG_OFFSET,
    0,
    0,
    110,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXUND_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXFRG
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXFRG_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXFRG_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXFRG_REG = 
{
    "GRXFRG",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXFRG_REG_OFFSET,
    0,
    0,
    111,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXFRG_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXRBYT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXRBYT_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXRBYT_COUNT48_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXRBYT_REG = 
{
    "GRXRBYT",
#if RU_INCLUDE_DESC
    "Transmit Byte Counter for XLMAC/port0 (LPORT port0)",
    "Receive Byte Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 48 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (47:32)."
    "Receive Runt Byte Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 48 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (47:32)."
    "Transmit Byte Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 48 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (47:32).",
#endif
    XPORT_MIB_CORE_GRXRBYT_REG_OFFSET,
    0,
    0,
    112,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXRBYT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX64
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX64_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX64_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX64_REG = 
{
    "GTX64",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX64_REG_OFFSET,
    0,
    0,
    113,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX64_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX127
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX127_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX127_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX127_REG = 
{
    "GTX127",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX127_REG_OFFSET,
    0,
    0,
    114,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX127_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX255
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX255_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX255_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX255_REG = 
{
    "GTX255",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX255_REG_OFFSET,
    0,
    0,
    115,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX255_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX511
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX511_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX511_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX511_REG = 
{
    "GTX511",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX511_REG_OFFSET,
    0,
    0,
    116,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX511_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX1023
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX1023_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX1023_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX1023_REG = 
{
    "GTX1023",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX1023_REG_OFFSET,
    0,
    0,
    117,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX1023_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX1518
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX1518_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX1518_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX1518_REG = 
{
    "GTX1518",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX1518_REG_OFFSET,
    0,
    0,
    118,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX1518_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX1522
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX1522_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX1522_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX1522_REG = 
{
    "GTX1522",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX1522_REG_OFFSET,
    0,
    0,
    119,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX1522_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX2047
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX2047_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX2047_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX2047_REG = 
{
    "GTX2047",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX2047_REG_OFFSET,
    0,
    0,
    120,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX2047_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX4095
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX4095_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX4095_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX4095_REG = 
{
    "GTX4095",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX4095_REG_OFFSET,
    0,
    0,
    121,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX4095_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX9216
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX9216_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX9216_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX9216_REG = 
{
    "GTX9216",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX9216_REG_OFFSET,
    0,
    0,
    122,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX9216_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTX16383
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTX16383_FIELDS[] =
{
    &XPORT_MIB_CORE_GTX16383_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTX16383_REG = 
{
    "GTX16383",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTX16383_REG_OFFSET,
    0,
    0,
    123,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTX16383_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPOK
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPOK_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPOK_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPOK_REG = 
{
    "GTXPOK",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPOK_REG_OFFSET,
    0,
    0,
    124,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPOK_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPKT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPKT_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPKT_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPKT_REG = 
{
    "GTXPKT",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPKT_REG_OFFSET,
    0,
    0,
    125,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPKT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXUCA
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXUCA_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXUCA_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXUCA_REG = 
{
    "GTXUCA",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXUCA_REG_OFFSET,
    0,
    0,
    126,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXUCA_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXMCA
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXMCA_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXMCA_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXMCA_REG = 
{
    "GTXMCA",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXMCA_REG_OFFSET,
    0,
    0,
    127,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXMCA_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXBCA
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXBCA_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXBCA_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXBCA_REG = 
{
    "GTXBCA",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXBCA_REG_OFFSET,
    0,
    0,
    128,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXBCA_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPF
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPF_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPF_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPF_REG = 
{
    "GTXPF",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPF_REG_OFFSET,
    0,
    0,
    129,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPF_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPFC
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPFC_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPFC_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPFC_REG = 
{
    "GTXPFC",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPFC_REG_OFFSET,
    0,
    0,
    130,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPFC_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXJBR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXJBR_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXJBR_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXJBR_REG = 
{
    "GTXJBR",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXJBR_REG_OFFSET,
    0,
    0,
    131,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXJBR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXFCS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXFCS_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXFCS_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXFCS_REG = 
{
    "GTXFCS",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXFCS_REG_OFFSET,
    0,
    0,
    132,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXFCS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXCF
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXCF_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXCF_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXCF_REG = 
{
    "GTXCF",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXCF_REG_OFFSET,
    0,
    0,
    133,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXCF_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXOVR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXOVR_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXOVR_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXOVR_REG = 
{
    "GTXOVR",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXOVR_REG_OFFSET,
    0,
    0,
    134,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXOVR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXDFR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXDFR_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXDFR_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXDFR_REG = 
{
    "GTXDFR",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXDFR_REG_OFFSET,
    0,
    0,
    135,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXDFR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXEDF
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXEDF_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXEDF_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXEDF_REG = 
{
    "GTXEDF",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXEDF_REG_OFFSET,
    0,
    0,
    136,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXEDF_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXSCL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXSCL_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXSCL_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXSCL_REG = 
{
    "GTXSCL",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXSCL_REG_OFFSET,
    0,
    0,
    137,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXSCL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXMCL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXMCL_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXMCL_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXMCL_REG = 
{
    "GTXMCL",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXMCL_REG_OFFSET,
    0,
    0,
    138,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXMCL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXLCL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXLCL_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXLCL_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXLCL_REG = 
{
    "GTXLCL",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXLCL_REG_OFFSET,
    0,
    0,
    139,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXLCL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXXCL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXXCL_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXXCL_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXXCL_REG = 
{
    "GTXXCL",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXXCL_REG_OFFSET,
    0,
    0,
    140,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXXCL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXFRG
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXFRG_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXFRG_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXFRG_REG = 
{
    "GTXFRG",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXFRG_REG_OFFSET,
    0,
    0,
    141,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXFRG_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXERR
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXERR_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXERR_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXERR_REG = 
{
    "GTXERR",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXERR_REG_OFFSET,
    0,
    0,
    142,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXERR_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXVLN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXVLN_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXVLN_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXVLN_REG = 
{
    "GTXVLN",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXVLN_REG_OFFSET,
    0,
    0,
    143,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXVLN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXDVLN
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXDVLN_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXDVLN_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXDVLN_REG = 
{
    "GTXDVLN",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXDVLN_REG_OFFSET,
    0,
    0,
    144,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXDVLN_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXRPKT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXRPKT_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXRPKT_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXRPKT_REG = 
{
    "GTXRPKT",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXRPKT_REG_OFFSET,
    0,
    0,
    145,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXRPKT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXUFL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXUFL_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXUFL_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXUFL_REG = 
{
    "GTXUFL",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXUFL_REG_OFFSET,
    0,
    0,
    146,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXUFL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPFCP0
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPFCP0_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPFCP0_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPFCP0_REG = 
{
    "GTXPFCP0",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPFCP0_REG_OFFSET,
    0,
    0,
    147,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPFCP0_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPFCP1
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPFCP1_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPFCP1_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPFCP1_REG = 
{
    "GTXPFCP1",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPFCP1_REG_OFFSET,
    0,
    0,
    148,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPFCP1_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPFCP2
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPFCP2_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPFCP2_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPFCP2_REG = 
{
    "GTXPFCP2",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPFCP2_REG_OFFSET,
    0,
    0,
    149,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPFCP2_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPFCP3
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPFCP3_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPFCP3_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPFCP3_REG = 
{
    "GTXPFCP3",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPFCP3_REG_OFFSET,
    0,
    0,
    150,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPFCP3_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPFCP4
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPFCP4_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPFCP4_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPFCP4_REG = 
{
    "GTXPFCP4",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPFCP4_REG_OFFSET,
    0,
    0,
    151,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPFCP4_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPFCP5
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPFCP5_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPFCP5_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPFCP5_REG = 
{
    "GTXPFCP5",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPFCP5_REG_OFFSET,
    0,
    0,
    152,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPFCP5_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPFCP6
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPFCP6_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPFCP6_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPFCP6_REG = 
{
    "GTXPFCP6",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPFCP6_REG_OFFSET,
    0,
    0,
    153,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPFCP6_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXPFCP7
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXPFCP7_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXPFCP7_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXPFCP7_REG = 
{
    "GTXPFCP7",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXPFCP7_REG_OFFSET,
    0,
    0,
    154,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXPFCP7_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXNCL
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXNCL_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXNCL_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXNCL_REG = 
{
    "GTXNCL",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXNCL_REG_OFFSET,
    0,
    0,
    155,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXNCL_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXBYT
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXBYT_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXBYT_COUNT48_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXBYT_REG = 
{
    "GTXBYT",
#if RU_INCLUDE_DESC
    "Transmit Byte Counter for XLMAC/port0 (LPORT port0)",
    "Receive Byte Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 48 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (47:32)."
    "Receive Runt Byte Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 48 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (47:32)."
    "Transmit Byte Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 48 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (47:32).",
#endif
    XPORT_MIB_CORE_GTXBYT_REG_OFFSET,
    0,
    0,
    156,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXBYT_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXLPI
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXLPI_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXLPI_COUNT32_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXLPI_REG = 
{
    "GRXLPI",
#if RU_INCLUDE_DESC
    "TX EEE LPI Duration Counter for XLMAC/port0 (LPORT port0)",
    "RX EEE LPI Event Counter"
    "RX EEE LPI Duration Counter"
    "TX EEE LPI Event Counter"
    "TX EEE LPI Duration Counter",
#endif
    XPORT_MIB_CORE_GRXLPI_REG_OFFSET,
    0,
    0,
    157,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXLPI_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXDLPI
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXDLPI_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXDLPI_COUNT32_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXDLPI_REG = 
{
    "GRXDLPI",
#if RU_INCLUDE_DESC
    "TX EEE LPI Duration Counter for XLMAC/port0 (LPORT port0)",
    "RX EEE LPI Event Counter"
    "RX EEE LPI Duration Counter"
    "TX EEE LPI Event Counter"
    "TX EEE LPI Duration Counter",
#endif
    XPORT_MIB_CORE_GRXDLPI_REG_OFFSET,
    0,
    0,
    158,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXDLPI_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXLPI
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXLPI_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXLPI_COUNT32_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXLPI_REG = 
{
    "GTXLPI",
#if RU_INCLUDE_DESC
    "TX EEE LPI Duration Counter for XLMAC/port0 (LPORT port0)",
    "RX EEE LPI Event Counter"
    "RX EEE LPI Duration Counter"
    "TX EEE LPI Event Counter"
    "TX EEE LPI Duration Counter",
#endif
    XPORT_MIB_CORE_GTXLPI_REG_OFFSET,
    0,
    0,
    159,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXLPI_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXDLPI
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXDLPI_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXDLPI_COUNT32_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXDLPI_REG = 
{
    "GTXDLPI",
#if RU_INCLUDE_DESC
    "TX EEE LPI Duration Counter for XLMAC/port0 (LPORT port0)",
    "RX EEE LPI Event Counter"
    "RX EEE LPI Duration Counter"
    "TX EEE LPI Event Counter"
    "TX EEE LPI Duration Counter",
#endif
    XPORT_MIB_CORE_GTXDLPI_REG_OFFSET,
    0,
    0,
    160,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXDLPI_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXPTLLFC
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXPTLLFC_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXPTLLFC_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXPTLLFC_REG = 
{
    "GRXPTLLFC",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXPTLLFC_REG_OFFSET,
    0,
    0,
    161,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXPTLLFC_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXLTLLFC
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXLTLLFC_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXLTLLFC_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXLTLLFC_REG = 
{
    "GRXLTLLFC",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXLTLLFC_REG_OFFSET,
    0,
    0,
    162,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXLTLLFC_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GRXLLFCFCS
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GRXLLFCFCS_FIELDS[] =
{
    &XPORT_MIB_CORE_GRXLLFCFCS_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GRXLLFCFCS_REG = 
{
    "GRXLLFCFCS",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GRXLLFCFCS_REG_OFFSET,
    0,
    0,
    163,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GRXLLFCFCS_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Register: XPORT_MIB_CORE_GTXLTLLFC
 ******************************************************************************/
#if RU_INCLUDE_FIELD_DB
static const ru_field_rec *XPORT_MIB_CORE_GTXLTLLFC_FIELDS[] =
{
    &XPORT_MIB_CORE_GTXLTLLFC_COUNT40_FIELD,
};

#endif /* RU_INCLUDE_FIELD_DB */

const ru_reg_rec XPORT_MIB_CORE_GTXLTLLFC_REG = 
{
    "GTXLTLLFC",
#if RU_INCLUDE_DESC
    "Transmit Logical Type LLFC message counter for XLMAC/port0 (LPORT port0)",
    "Receive 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive 9217 to 16838 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive frame/packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive FCS Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PAUSE Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC (Per-Priority Pause) Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported Opcode Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Unsupported DA for PAUSE/PFC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Wrong SA Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Alignment Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Length Out of Range Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Code Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive False Carrier Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Oversized Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Jabber Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive MTU Check Error Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Matched CRC Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Promiscuous Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Truncated Frame Counter (due to RX FIFO full)\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0 XON to XOFF\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive SCH CRC Error\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Undersize Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 64 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 65 to 127 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 128 to 255 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 256 to 511 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 512 to 1023 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1024 to 1518 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 1522 Byte Good VLAN Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 1519 to 2047 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 2048 to 4095 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 4096 to 9216 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit 9217 to 16383 Byte Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Good Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Packet/Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Unicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multicast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Broadcast Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC/Per-Priority Pause Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Jabber Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FCS Error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Control Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Oversize Packet Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Deferral Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Single Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Multiple Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Late Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Excessive Collision Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Fragment Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Error (set by system) Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Double VLAN Tag Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit RUNT Frame Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit FIFO Underrun Counter.\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 0\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 1\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 2\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 3\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 4\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 5\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 6\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit PFC Frame Priority 7\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Total Collision Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Physical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Logical Type LLFC message Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Receive Type LLFC message with CRC error Counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32)."
    "Transmit Logical Type LLFC message counter\n"
    "\n"
    "IMPORTANT: This MIB counter is 40 bits wide (which is more than 32 bits).\n"
    "See Description on how to access the higher counter bits (39:32).",
#endif
    XPORT_MIB_CORE_GTXLTLLFC_REG_OFFSET,
    0,
    0,
    164,
#if RU_INCLUDE_ACCESS
    ru_access_rw,
#endif
#if RU_INCLUDE_FIELD_DB
    1,
    XPORT_MIB_CORE_GTXLTLLFC_FIELDS,
#endif /* RU_INCLUDE_FIELD_DB */
    ru_reg_size_64
};

/******************************************************************************
 * Block: XPORT_MIB_CORE
 ******************************************************************************/
static const ru_reg_rec *XPORT_MIB_CORE_REGS[] =
{
    &XPORT_MIB_CORE_GRX64_REG,
    &XPORT_MIB_CORE_GRX127_REG,
    &XPORT_MIB_CORE_GRX255_REG,
    &XPORT_MIB_CORE_GRX511_REG,
    &XPORT_MIB_CORE_GRX1023_REG,
    &XPORT_MIB_CORE_GRX1518_REG,
    &XPORT_MIB_CORE_GRX1522_REG,
    &XPORT_MIB_CORE_GRX2047_REG,
    &XPORT_MIB_CORE_GRX4095_REG,
    &XPORT_MIB_CORE_GRX9216_REG,
    &XPORT_MIB_CORE_GRX16383_REG,
    &XPORT_MIB_CORE_GRXPKT_REG,
    &XPORT_MIB_CORE_GRXUCA_REG,
    &XPORT_MIB_CORE_GRXMCA_REG,
    &XPORT_MIB_CORE_GRXBCA_REG,
    &XPORT_MIB_CORE_GRXFCS_REG,
    &XPORT_MIB_CORE_GRXCF_REG,
    &XPORT_MIB_CORE_GRXPF_REG,
    &XPORT_MIB_CORE_GRXPP_REG,
    &XPORT_MIB_CORE_GRXUO_REG,
    &XPORT_MIB_CORE_GRXUDA_REG,
    &XPORT_MIB_CORE_GRXWSA_REG,
    &XPORT_MIB_CORE_GRXALN_REG,
    &XPORT_MIB_CORE_GRXFLR_REG,
    &XPORT_MIB_CORE_GRXFRERR_REG,
    &XPORT_MIB_CORE_GRXFCR_REG,
    &XPORT_MIB_CORE_GRXOVR_REG,
    &XPORT_MIB_CORE_GRXJBR_REG,
    &XPORT_MIB_CORE_GRXMTUE_REG,
    &XPORT_MIB_CORE_GRXMCRC_REG,
    &XPORT_MIB_CORE_GRXPRM_REG,
    &XPORT_MIB_CORE_GRXVLN_REG,
    &XPORT_MIB_CORE_GRXDVLN_REG,
    &XPORT_MIB_CORE_GRXTRFU_REG,
    &XPORT_MIB_CORE_GRXPOK_REG,
    &XPORT_MIB_CORE_GRXPFCOFF0_REG,
    &XPORT_MIB_CORE_GRXPFCOFF1_REG,
    &XPORT_MIB_CORE_GRXPFCOFF2_REG,
    &XPORT_MIB_CORE_GRXPFCOFF3_REG,
    &XPORT_MIB_CORE_GRXPFCOFF4_REG,
    &XPORT_MIB_CORE_GRXPFCOFF5_REG,
    &XPORT_MIB_CORE_GRXPFCOFF6_REG,
    &XPORT_MIB_CORE_GRXPFCOFF7_REG,
    &XPORT_MIB_CORE_GRXPFCP0_REG,
    &XPORT_MIB_CORE_GRXPFCP1_REG,
    &XPORT_MIB_CORE_GRXPFCP2_REG,
    &XPORT_MIB_CORE_GRXPFCP3_REG,
    &XPORT_MIB_CORE_GRXPFCP4_REG,
    &XPORT_MIB_CORE_GRXPFCP5_REG,
    &XPORT_MIB_CORE_GRXPFCP6_REG,
    &XPORT_MIB_CORE_GRXPFCP7_REG,
    &XPORT_MIB_CORE_GRXSCHCRC_REG,
    &XPORT_MIB_CORE_GRXBYT_REG,
    &XPORT_MIB_CORE_GRXRPKT_REG,
    &XPORT_MIB_CORE_GRXUND_REG,
    &XPORT_MIB_CORE_GRXFRG_REG,
    &XPORT_MIB_CORE_GRXRBYT_REG,
    &XPORT_MIB_CORE_GTX64_REG,
    &XPORT_MIB_CORE_GTX127_REG,
    &XPORT_MIB_CORE_GTX255_REG,
    &XPORT_MIB_CORE_GTX511_REG,
    &XPORT_MIB_CORE_GTX1023_REG,
    &XPORT_MIB_CORE_GTX1518_REG,
    &XPORT_MIB_CORE_GTX1522_REG,
    &XPORT_MIB_CORE_GTX2047_REG,
    &XPORT_MIB_CORE_GTX4095_REG,
    &XPORT_MIB_CORE_GTX9216_REG,
    &XPORT_MIB_CORE_GTX16383_REG,
    &XPORT_MIB_CORE_GTXPOK_REG,
    &XPORT_MIB_CORE_GTXPKT_REG,
    &XPORT_MIB_CORE_GTXUCA_REG,
    &XPORT_MIB_CORE_GTXMCA_REG,
    &XPORT_MIB_CORE_GTXBCA_REG,
    &XPORT_MIB_CORE_GTXPF_REG,
    &XPORT_MIB_CORE_GTXPFC_REG,
    &XPORT_MIB_CORE_GTXJBR_REG,
    &XPORT_MIB_CORE_GTXFCS_REG,
    &XPORT_MIB_CORE_GTXCF_REG,
    &XPORT_MIB_CORE_GTXOVR_REG,
    &XPORT_MIB_CORE_GTXDFR_REG,
    &XPORT_MIB_CORE_GTXEDF_REG,
    &XPORT_MIB_CORE_GTXSCL_REG,
    &XPORT_MIB_CORE_GTXMCL_REG,
    &XPORT_MIB_CORE_GTXLCL_REG,
    &XPORT_MIB_CORE_GTXXCL_REG,
    &XPORT_MIB_CORE_GTXFRG_REG,
    &XPORT_MIB_CORE_GTXERR_REG,
    &XPORT_MIB_CORE_GTXVLN_REG,
    &XPORT_MIB_CORE_GTXDVLN_REG,
    &XPORT_MIB_CORE_GTXRPKT_REG,
    &XPORT_MIB_CORE_GTXUFL_REG,
    &XPORT_MIB_CORE_GTXPFCP0_REG,
    &XPORT_MIB_CORE_GTXPFCP1_REG,
    &XPORT_MIB_CORE_GTXPFCP2_REG,
    &XPORT_MIB_CORE_GTXPFCP3_REG,
    &XPORT_MIB_CORE_GTXPFCP4_REG,
    &XPORT_MIB_CORE_GTXPFCP5_REG,
    &XPORT_MIB_CORE_GTXPFCP6_REG,
    &XPORT_MIB_CORE_GTXPFCP7_REG,
    &XPORT_MIB_CORE_GTXNCL_REG,
    &XPORT_MIB_CORE_GTXBYT_REG,
    &XPORT_MIB_CORE_GRXLPI_REG,
    &XPORT_MIB_CORE_GRXDLPI_REG,
    &XPORT_MIB_CORE_GTXLPI_REG,
    &XPORT_MIB_CORE_GTXDLPI_REG,
    &XPORT_MIB_CORE_GRXPTLLFC_REG,
    &XPORT_MIB_CORE_GRXLTLLFC_REG,
    &XPORT_MIB_CORE_GRXLLFCFCS_REG,
    &XPORT_MIB_CORE_GTXLTLLFC_REG,
};

unsigned long XPORT_MIB_CORE_ADDRS[] =
{
    0x80139000,
    0x80139400,
    0x80139800,
    0x80139c00,
};

const ru_block_rec XPORT_MIB_CORE_BLOCK = 
{
    "XPORT_MIB_CORE",
    XPORT_MIB_CORE_ADDRS,
    4,
    109,
    XPORT_MIB_CORE_REGS
};

/* End of file XPORT_MIB_CORE.c */
